class
	S_X11_XLIB_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	XCreateGC (a_arg1: CE_POINTER [ANY]; a_arg2, a_arg3: NATURAL_32; a_arg4: CE_POINTER [SD_XGCVALUES]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_XCreateGC (a_arg1.c_pointer, a_arg2, a_arg3, a_arg4.c_pointer))
		end

	c_XCreateGC (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: NATURAL_32; a_arg4: POINTER): POINTER
		external
			"C inline use <xeyes.h>"
		alias
			"return (EIF_POINTER)XCreateGC($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	XCreatePixmap (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3, a_arg4, a_arg5: NATURAL_32): NATURAL_32
		do
			Result := c_XCreatePixmap (a_arg1.c_pointer, a_arg2, a_arg3, a_arg4, a_arg5)
		end

	c_XCreatePixmap (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: NATURAL_32; a_arg4: NATURAL_32; a_arg5: NATURAL_32): NATURAL_32
		external
			"C inline use <xeyes.h>"
		alias
			"return XCreatePixmap($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	XClearWindow (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32): INTEGER_32
		do
			Result := c_XClearWindow (a_arg1.c_pointer, a_arg2)
		end

	c_XClearWindow (a_arg1: POINTER; a_arg2: NATURAL_32): INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return XClearWindow($a_arg1, $a_arg2);"
		end

	XFillRectangle (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [ANY]; a_arg4, a_arg5: INTEGER_32; a_arg6, a_arg7: NATURAL_32): INTEGER_32
		do
			Result := c_XFillRectangle (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4, a_arg5, a_arg6, a_arg7)
		end

	c_XFillRectangle (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: INTEGER_32; a_arg5: INTEGER_32; a_arg6: NATURAL_32; a_arg7: NATURAL_32): INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return XFillRectangle($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7);"
		end

	XFreePixmap (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32): INTEGER_32
		do
			Result := c_XFreePixmap (a_arg1.c_pointer, a_arg2)
		end

	c_XFreePixmap (a_arg1: POINTER; a_arg2: NATURAL_32): INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return XFreePixmap($a_arg1, $a_arg2);"
		end

	XQueryPointer (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3, a_arg4: CE_POINTER [NATURAL_32]; a_arg5, a_arg6, a_arg7, a_arg8: CE_POINTER [INTEGER_32]; a_arg9: CE_POINTER [NATURAL_32]): INTEGER_32
		do
			Result := c_XQueryPointer (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4.c_pointer, a_arg5.c_pointer, a_arg6.c_pointer, a_arg7.c_pointer, a_arg8.c_pointer, a_arg9.c_pointer)
		end

	c_XQueryPointer (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: POINTER; a_arg5: POINTER; a_arg6: POINTER; a_arg7: POINTER; a_arg8: POINTER; a_arg9: POINTER): INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return XQueryPointer($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8, $a_arg9);"
		end

	XSetForeground (a_arg1, a_arg2: CE_POINTER [ANY]; a_arg3: NATURAL_32): INTEGER_32
		do
			Result := c_XSetForeground (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_XSetForeground (a_arg1: POINTER; a_arg2: POINTER; a_arg3: NATURAL_32): INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return XSetForeground($a_arg1, $a_arg2, $a_arg3);"
		end

	XFillArc (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [ANY]; a_arg4, a_arg5: INTEGER_32; a_arg6, a_arg7: NATURAL_32; a_arg8, a_arg9: INTEGER_32): INTEGER_32
		do
			Result := c_XFillArc (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4, a_arg5, a_arg6, a_arg7, a_arg8, a_arg9)
		end

	c_XFillArc (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: INTEGER_32; a_arg5: INTEGER_32; a_arg6: NATURAL_32; a_arg7: NATURAL_32; a_arg8: INTEGER_32; a_arg9: INTEGER_32): INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return XFillArc($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8, $a_arg9);"
		end

	XInternAtom (a_arg1: CE_POINTER [ANY]; a_arg2: CE_POINTER [INTEGER_8]; a_arg3: INTEGER_32): NATURAL_32
		do
			Result := c_XInternAtom (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3)
		end

	c_XInternAtom (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32): NATURAL_32
		external
			"C inline use <xeyes.h>"
		alias
			"return XInternAtom($a_arg1, $a_arg2, $a_arg3);"
		end

	XCreateBitmapFromData (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [INTEGER_8]; a_arg4, a_arg5: NATURAL_32): NATURAL_32
		do
			Result := c_XCreateBitmapFromData (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4, a_arg5)
		end

	c_XCreateBitmapFromData (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: NATURAL_32; a_arg5: NATURAL_32): NATURAL_32
		external
			"C inline use <xeyes.h>"
		alias
			"return XCreateBitmapFromData($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5);"
		end

	XSetWMProtocols (a_arg1: CE_POINTER [ANY]; a_arg2: NATURAL_32; a_arg3: CE_POINTER [NATURAL_32]; a_arg4: INTEGER_32): INTEGER_32
		do
			Result := c_XSetWMProtocols (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4)
		end

	c_XSetWMProtocols (a_arg1: POINTER; a_arg2: NATURAL_32; a_arg3: POINTER; a_arg4: INTEGER_32): INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return XSetWMProtocols($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	XBell (a_arg1: CE_POINTER [ANY]; a_arg2: INTEGER_32): INTEGER_32
		do
			Result := c_XBell (a_arg1.c_pointer, a_arg2)
		end

	c_XBell (a_arg1: POINTER; a_arg2: INTEGER_32): INTEGER_32
		external
			"C inline use <xeyes.h>"
		alias
			"return XBell($a_arg1, $a_arg2);"
		end

end
