class
	P_BRAC_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	match_brac (a_obrac, a_cbrac, a_forwdir, a_n: INTEGER_32)
		local
			l_n: INTEGER_32
			l_c: INTEGER_32
			l_nest: INTEGER_32
			l_pos2: INTEGER_32
			l_chget: CE_ROUTINE
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n := a_n
					if a_forwdir.to_boolean then
						l_tmp := 0
					else
						l_tmp := -1
					end
					l_pos2 := (create {P_POSITION_STATIC}).position (l_tmp)
					if l_pos2 /= -1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (((create {P_CH_STATIC}).ch_seek (l_pos2)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if a_forwdir.to_boolean then
							(create {P_OUTPUT_STATIC}).error (ce_string ("Nothing in top line"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						else
							(create {P_OUTPUT_STATIC}).error (ce_string ("Nothing in bottom line"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						end
						l_return := True
				when 5 then -- if done
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 6 then -- if: | loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 13 -- skip loop
						end
				when 7 then -- loop body:
						l_break := False
						l_c := (create {P_CH_STATIC}).ch_forw_get
						if l_c /= 10 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L___0
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if l_c /= -1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L___0:
						if a_forwdir.to_boolean then
							(create {P_OUTPUT_STATIC}).error (ce_string ("No bracket in top line"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						else
							(create {P_OUTPUT_STATIC}).error (ce_string ("No bracket in bottom line"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
						end
						l_return := True
				when 12 then -- if done
						if not l_return and then (l_c = a_obrac) then
							l_n := l_n - 1
							if not (l_n > 0) then
								l_break := True
							end
						end
						l_pos := -1 + 6 -- back to loop condition
				when 13 then -- loop done | if done
					if not l_return then
						l_break := False
						if not a_forwdir.to_boolean then
							(create {P_CH_STATIC}).ch_back_get.do_nothing
						end
						if a_forwdir.to_boolean then
							l_chget := (create {P_CH_STATIC}).ch_forw_get_address
						else
							l_chget := (create {P_CH_STATIC}).ch_back_get_address
						end
						l_nest := 0
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l_c := l_chget.integer_32_item ([])
							if l_c = -1 then
								l_break := True
							end
							if not (l_return or l_break) then
								if l_c = a_obrac then
									l_nest := l_nest + 1
								elseif l_c = a_cbrac then
									l_nest := l_nest - 1
									if l_nest < 0 then
										if a_forwdir.to_boolean then
											l_tmp___1 := -1
										else
											l_tmp___1 := 1
										end
										(create {P_JUMP_STATIC}).jump_line_loc (((create {P_CH_STATIC}).ch_tell), l_tmp___1)
										l_return := True
									end
								end
							end
						end
					end
					if not l_return then
						l_break := False;
						(create {P_OUTPUT_STATIC}).error (ce_string ("No matching bracket"), create {CE_CLASS_POINTER [PD_PARG]}.make_shared (default_pointer))
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
