class
	SD_REGMATCH_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	rm_so: INTEGER_32 assign set_rm_so

	rm_eo: INTEGER_32 assign set_rm_eo

feature {ANY} -- field setters

	set_rm_so (a_rm_so: INTEGER_32)
		do
			rm_so := a_rm_so
			update_memory_field ("rm_so")
		end

	set_rm_eo (a_rm_eo: INTEGER_32)
		do
			rm_eo := a_rm_eo
			update_memory_field ("rm_eo")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			rm_so := a_other.rm_so
			rm_eo := a_other.rm_eo
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				rm_so = a_other.rm_so and
				rm_eo = a_other.rm_eo
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("rm_so"),
					create {CE_STRUCTURE_FIELD}.make ("rm_eo")
				>>)
			init_structure_info
		end

end
