class
	P_CSS_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public attributes

	yyleng: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	yy_buffer_stack_top: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (0).to_natural_32
		end

	yy_buffer_stack_max: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (0).to_natural_32
		end

	yy_buffer_stack: CE_STATIC [CE_POINTER [CE_POINTER [PD_YY_BUFFER_STATE]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
		end

	yy_hold_char: CE_STATIC [INTEGER_8]
		once ("PROCESS")
		end

	yy_n_chars: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	yy_c_buf_p: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
		end

	yy_init: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	yy_start: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	yy_did_buffer_switch_on_eof: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	yyin: CE_STATIC [CE_POINTER [SD_IO_FILE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
		end

	yyout: CE_STATIC [CE_POINTER [SD_IO_FILE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
		end

	yylineno: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

	yytext: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

	yy_flex_debug: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	yy_switch_to_buffer (a_new_buffer: CE_POINTER [PD_YY_BUFFER_STATE])
		local
			l_tmp: CE_POINTER [PD_YY_BUFFER_STATE]
			l_tmp___0: CE_POINTER [PD_YY_BUFFER_STATE]
			l_return: BOOLEAN
		do
			yyensure_buffer_stack
			if (not yy_buffer_stack.item.is_void) then
				l_tmp := yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]
			else
				l_tmp := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
			end
			if l_tmp.is_equal (a_new_buffer) then
				l_return := True
			end
			if not l_return then
				if (not yy_buffer_stack.item.is_void) then
					l_tmp___0 := yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]
				else
					l_tmp___0 := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
				end
				if (not l_tmp___0.is_void) then
					yy_c_buf_p.item[0] := yy_hold_char.item;
					(yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]).item.yy_buf_pos := yy_c_buf_p.item;
					(yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]).item.yy_n_chars := yy_n_chars.item
				end
				yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32] := a_new_buffer
				yy_load_buffer_state
				yy_did_buffer_switch_on_eof.item := 1
			end
		end

	yy_load_buffer_state
		do
			yy_n_chars.item := (yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]).item.yy_n_chars
			yy_c_buf_p.item := (yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]).item.yy_buf_pos
			yytext.item := yy_c_buf_p.item
			yyin.item := (yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]).item.yy_input_file
			yy_hold_char.item := yy_c_buf_p.item[0]
		end

	yy_delete_buffer (a_b: CE_POINTER [PD_YY_BUFFER_STATE])
		local
			l_tmp: CE_POINTER [PD_YY_BUFFER_STATE]
			l_return: BOOLEAN
		do
			if a_b.is_void then
				l_return := True
			end
			if not l_return then
				if (not yy_buffer_stack.item.is_void) then
					l_tmp := yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]
				else
					l_tmp := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
				end
				if a_b.is_equal (l_tmp) then
					yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32] := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
				end
				if (a_b.item.yy_is_our_buffer).to_boolean then
					yyfree (create {CE_VOID_POINTER}.make_cast (a_b.item.yy_ch_buf))
				end
				yyfree (create {CE_VOID_POINTER}.make_cast (a_b))
			end
		end

	yypush_buffer_state (a_new_buffer: CE_POINTER [PD_YY_BUFFER_STATE])
		local
			l_tmp: CE_POINTER [PD_YY_BUFFER_STATE]
			l_tmp___0: CE_POINTER [PD_YY_BUFFER_STATE]
			l_return: BOOLEAN
		do
			if a_new_buffer.is_void then
				l_return := True
			end
			if not l_return then
				yyensure_buffer_stack
				if (not yy_buffer_stack.item.is_void) then
					l_tmp := yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]
				else
					l_tmp := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
				end
				if (not l_tmp.is_void) then
					yy_c_buf_p.item[0] := yy_hold_char.item;
					(yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]).item.yy_buf_pos := yy_c_buf_p.item;
					(yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]).item.yy_n_chars := yy_n_chars.item
				end
				if (not yy_buffer_stack.item.is_void) then
					l_tmp___0 := yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]
				else
					l_tmp___0 := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
				end
				if (not l_tmp___0.is_void) then
					yy_buffer_stack_top.item := yy_buffer_stack_top.item + 1
				end
				yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32] := a_new_buffer
				yy_load_buffer_state
				yy_did_buffer_switch_on_eof.item := 1
			end
		end

	yypop_buffer_state
		local
			l_tmp: CE_POINTER [PD_YY_BUFFER_STATE]
			l_tmp___0: CE_POINTER [PD_YY_BUFFER_STATE]
			l_tmp___1: CE_POINTER [PD_YY_BUFFER_STATE]
			l_return: BOOLEAN
		do
			if (not yy_buffer_stack.item.is_void) then
				l_tmp := yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]
			else
				l_tmp := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
			end
			if l_tmp.is_void then
				l_return := True
			end
			if not l_return then
				if (not yy_buffer_stack.item.is_void) then
					l_tmp___0 := yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]
				else
					l_tmp___0 := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
				end
				yy_delete_buffer (l_tmp___0)
				yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32] := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
				if yy_buffer_stack_top.item > {NATURAL_32} 0 then
					yy_buffer_stack_top.item := yy_buffer_stack_top.item - 1
				end
				if (not yy_buffer_stack.item.is_void) then
					l_tmp___1 := yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]
				else
					l_tmp___1 := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
				end
				if (not l_tmp___1.is_void) then
					yy_load_buffer_state
					yy_did_buffer_switch_on_eof.item := 1
				end
			end
		end

	yyensure_buffer_stack
		local
			l_num_to_alloc: INTEGER_32
			l_grow_size: INTEGER_32
			l_return: BOOLEAN
		do
			if yy_buffer_stack.item.is_void then
				l_num_to_alloc := 1
				yy_buffer_stack.item := create {CE_POINTER_POINTER [PD_YY_BUFFER_STATE]}.make_cast ((yyalloc (l_num_to_alloc.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
				if yy_buffer_stack.item.is_void then
					yy_fatal_error (ce_string ("out of dynamic memory in yyensure_buffer_stack()"))
				end
				memset (create {CE_VOID_POINTER}.make_cast (yy_buffer_stack.item), 0, l_num_to_alloc.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32).do_nothing
				yy_buffer_stack_max.item := l_num_to_alloc.to_natural_32
				yy_buffer_stack_top.item := (0).to_natural_32
				l_return := True
			end
			if not l_return and then (yy_buffer_stack_top.item >= yy_buffer_stack_max.item - {NATURAL_32} 1) then
				l_grow_size := 8
				l_num_to_alloc := (yy_buffer_stack_max.item + l_grow_size.to_natural_32).to_integer_32
				yy_buffer_stack.item := create {CE_POINTER_POINTER [PD_YY_BUFFER_STATE]}.make_cast ((yyrealloc (create {CE_VOID_POINTER}.make_cast (yy_buffer_stack.item), l_num_to_alloc.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
				if yy_buffer_stack.item.is_void then
					yy_fatal_error (ce_string ("out of dynamic memory in yyensure_buffer_stack()"))
				end
				memset (create {CE_VOID_POINTER}.make_cast ((yy_buffer_stack.item + yy_buffer_stack_max.item.to_integer_32)), 0, l_grow_size.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32).do_nothing
				yy_buffer_stack_max.item := l_num_to_alloc.to_natural_32
			end
		end

	yy_scan_buffer (a_base: CE_POINTER [INTEGER_8]; a_size: NATURAL_32): CE_POINTER [PD_YY_BUFFER_STATE]
		local
			l_b: CE_POINTER [PD_YY_BUFFER_STATE]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			if a_size < {NATURAL_32} 2 then
				Result := (create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer))
				l_return := True
			elseif (a_base[(a_size - {NATURAL_32} 2).to_integer_32]).to_integer_32 /= 0 then
				Result := (create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer))
				l_return := True
			elseif (a_base[(a_size - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 0 then
				Result := (create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_b := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_cast ((yyalloc ((create {PD_YY_BUFFER_STATE}.make).structure_size.to_natural_32)))
				if l_b.is_void then
					yy_fatal_error (ce_string ("out of dynamic memory in yy_scan_buffer()"))
				end
				l_b.item.yy_buf_size := a_size - {NATURAL_32} 2
				l_tmp___0 := a_base
				l_b.item.yy_ch_buf := l_tmp___0
				l_b.item.yy_buf_pos := l_tmp___0
				l_b.item.yy_is_our_buffer := 0
				l_b.item.yy_input_file := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
				l_b.item.yy_n_chars := (l_b.item.yy_buf_size).to_integer_32
				l_b.item.yy_is_interactive := 0
				l_b.item.yy_at_bol := 1
				l_b.item.yy_fill_buffer := 0
				l_b.item.yy_buffer_status := 0
				yy_switch_to_buffer (l_b)
				Result := l_b
			end
		end

	yy_scan_string (a_yystr: CE_POINTER [INTEGER_8]): CE_POINTER [PD_YY_BUFFER_STATE]
		require
			not a_yystr.is_void
		do
			Result := (yy_scan_bytes (a_yystr, (strlen (a_yystr)).to_integer_32))
		end

	yy_scan_bytes (a_yybytes: CE_POINTER [INTEGER_8]; a__yybytes_len: INTEGER_32): CE_POINTER [PD_YY_BUFFER_STATE]
		local
			l_b: CE_POINTER [PD_YY_BUFFER_STATE]
			l_buf___6: CE_POINTER [INTEGER_8]
			l_n: NATURAL_32
			l_i: INTEGER_32
			l_tmp___0: INTEGER_8
		do
			l_n := (a__yybytes_len + 2).to_natural_32
			l_buf___6 := create {CE_INTEGER_8_POINTER}.make_cast ((yyalloc (l_n)))
			if l_buf___6.is_void then
				yy_fatal_error (ce_string ("out of dynamic memory in yy_scan_bytes()"))
			end
			l_i := 0
			from
			until
				not (l_i < a__yybytes_len)
			loop
				l_buf___6[l_i] := a_yybytes[l_i]
				l_i := l_i + 1
			end
			l_tmp___0 := (0).to_integer_8
			l_buf___6[(a__yybytes_len + 1)] := l_tmp___0
			l_buf___6[a__yybytes_len] := l_tmp___0
			l_b := yy_scan_buffer (l_buf___6, l_n)
			if l_b.is_void then
				yy_fatal_error (ce_string ("bad buffer in yy_scan_bytes()"))
			end
			l_b.item.yy_is_our_buffer := 1
			Result := l_b
		end

	yy_fatal_error (a_msg: CE_POINTER [INTEGER_8])
		require
			not a_msg.is_void
		do
			Io.error.put_string (eif_string (a_msg) + "%N")
			exit (2)
		end

	yyget_lineno: INTEGER_32
		do
			Result := yylineno.item
		end

	yyget_in: CE_POINTER [SD_IO_FILE]
		do
			Result := yyin.item
		end

	yyget_out: CE_POINTER [SD_IO_FILE]
		do
			Result := yyout.item
		end

	yyget_leng: INTEGER_32
		do
			Result := yyleng.item
		end

	yyget_text: CE_POINTER [INTEGER_8]
		do
			Result := yytext.item
		end

	yyset_lineno (a_line_number: INTEGER_32)
		do
			yylineno.item := a_line_number
		end

	yyset_in (a_in_str: CE_POINTER [SD_IO_FILE])
		do
			yyin.item := a_in_str
		end

	yyset_out (a_out_str: CE_POINTER [SD_IO_FILE])
		do
			yyout.item := a_out_str
		end

	yyget_debug: INTEGER_32
		do
			Result := yy_flex_debug.item
		end

	yyset_debug (a_bdebug: INTEGER_32)
		do
			yy_flex_debug.item := a_bdebug
		end

	yy_init_globals: INTEGER_32
		do
			yy_buffer_stack.item := create {CE_POINTER_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
			yy_buffer_stack_top.item := (0).to_natural_32
			yy_buffer_stack_max.item := (0).to_natural_32
			yy_c_buf_p.item := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
			yy_init.item := 0
			yy_start.item := 0
			yyin.item := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
			yyout.item := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
			Result := 0
		end

	yylex_destroy: INTEGER_32
		local
			l_tmp: CE_POINTER [PD_YY_BUFFER_STATE]
			l_tmp___0: CE_POINTER [PD_YY_BUFFER_STATE]
			l_break: BOOLEAN
		do
			from
			until
				(l_break)
			loop
				l_break := False
				if (not yy_buffer_stack.item.is_void) then
					l_tmp___0 := yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]
				else
					l_tmp___0 := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
				end
				if l_tmp___0.is_void then
					l_break := True
				end
				if not (l_break) then
					if (not yy_buffer_stack.item.is_void) then
						l_tmp := yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32]
					else
						l_tmp := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
					end
					yy_delete_buffer (l_tmp)
					yy_buffer_stack.item[yy_buffer_stack_top.item.to_integer_32] := create {CE_CLASS_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
					yypop_buffer_state
				end
			end
			l_break := False
			yyfree (create {CE_VOID_POINTER}.make_cast (yy_buffer_stack.item))
			yy_buffer_stack.item := create {CE_POINTER_POINTER [PD_YY_BUFFER_STATE]}.make_shared (default_pointer)
			yy_init_globals.do_nothing
			Result := 0
		end

	yyalloc (a_size: NATURAL_32): CE_POINTER [ANY]
		do
			Result := (malloc (a_size))
		end

	yyrealloc (a_ptr: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			Result := (realloc (a_ptr, a_size))
		end

	yyfree (a_ptr: CE_POINTER [ANY])
		do
			free (a_ptr)
		end

end
