class
	P_HTML_TBL_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public routines

	get_align (a_attr: CE_POINTER [INTEGER_8]; a_a: CE_POINTER [INTEGER_32])
		local
			l_al: CE_POINTER [INTEGER_8]
		do
			l_al := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HTML_STATIC}).get_attr_val (create {CE_NATURAL_8_POINTER}.make_cast (a_attr), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("align")))))
			if (not l_al.is_void) then
				if not (strcasecmp (l_al, ce_string ("left"))).to_boolean then
					a_a.item := 0
				end
				if not (strcasecmp (l_al, ce_string ("right"))).to_boolean then
					a_a.item := 2
				end
				if not (strcasecmp (l_al, ce_string ("center"))).to_boolean then
					a_a.item := 1
				end
				if not (strcasecmp (l_al, ce_string ("justify"))).to_boolean then
					a_a.item := 3
				end
				if not (strcasecmp (l_al, ce_string ("char"))).to_boolean then
					a_a.item := 2
				end
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 37, create {CE_VOID_POINTER}.make_cast (l_al))
			end
		end

	get_valign (a_attr: CE_POINTER [INTEGER_8]; a_a: CE_POINTER [INTEGER_32])
		local
			l_al: CE_POINTER [INTEGER_8]
		do
			l_al := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HTML_STATIC}).get_attr_val (create {CE_NATURAL_8_POINTER}.make_cast (a_attr), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("valign")))))
			if (not l_al.is_void) then
				if not (strcasecmp (l_al, ce_string ("top"))).to_boolean then
					a_a.item := 0
				end
				if not (strcasecmp (l_al, ce_string ("middle"))).to_boolean then
					a_a.item := 1
				end
				if not (strcasecmp (l_al, ce_string ("bottom"))).to_boolean then
					a_a.item := 2
				end
				if not (strcasecmp (l_al, ce_string ("baseline"))).to_boolean then
					a_a.item := 0
				end
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 49, create {CE_VOID_POINTER}.make_cast (l_al))
			end
		end

	get_c_width (a_attr: CE_POINTER [INTEGER_8]; a_w: CE_POINTER [INTEGER_32]; a_sh: INTEGER_32)
		local
			l_al: CE_POINTER [INTEGER_8]
			l_en: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_n: NATURAL_32
			l_p: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_en.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_al := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HTML_STATIC}).get_attr_val (create {CE_NATURAL_8_POINTER}.make_cast (a_attr), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("width")))))
					if l_al.is_void then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if not ((l_al[0]).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (l_al[((strlen (l_al)) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 42 then
							l_al[((strlen (l_al)) - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
							l_n := strtoul (l_al, l_en, 10)
							if l_n < {NATURAL_32} 10_000 then
								if not (l_en.item[0]).to_boolean then
									a_w.item := ({NATURAL_32} 4_294_967_294 - l_n).to_integer_32
								end
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						l_p := ((create {P_HTML_STATIC}).get_width (create {CE_NATURAL_8_POINTER}.make_cast (a_attr), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("width")), a_sh))
						if l_p >= 0 then
							a_w.item := l_p
						end
				when 5 then;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 67, create {CE_VOID_POINTER}.make_cast (l_al))
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	new_table: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]
		local
			l_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]
			l_tmp___0: INTEGER_32
		do
			l_t := create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 144, (create {PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS}.make).structure_size.to_natural_32)))
			memset (create {CE_VOID_POINTER}.make_cast (l_t), 0, (create {PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS}.make).structure_size.to_natural_32).do_nothing
			l_t.item.p := create {CE_CLASS_POINTER [PD_PART]}.make_shared (default_pointer)
			l_tmp___0 := 0
			l_t.item.y := l_tmp___0
			l_t.item.x := l_tmp___0
			l_t.item.rx := 8
			l_t.item.ry := 8
			l_t.item.cells := create {CE_CLASS_POINTER [PD_TABLE_CELL]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 150, {NATURAL_32} 64 * (create {PD_TABLE_CELL}.make).structure_size.to_natural_32)))
			memset (create {CE_VOID_POINTER}.make_cast (l_t.item.cells), 0, {NATURAL_32} 64 * (create {PD_TABLE_CELL}.make).structure_size.to_natural_32).do_nothing
			l_t.item.c := 0
			l_t.item.rc := 8
			l_t.item.cols := create {CE_CLASS_POINTER [PD_TABLE_COLUMN]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 154, {NATURAL_32} 8 * (create {PD_TABLE_COLUMN}.make).structure_size.to_natural_32)))
			memset (create {CE_VOID_POINTER}.make_cast (l_t.item.cols), 0, {NATURAL_32} 8 * (create {PD_TABLE_COLUMN}.make).structure_size.to_natural_32).do_nothing
			l_t.item.xcols := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer + -1)
			l_t.item.xc := 0
			l_t.item.r_heights := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer + -1)
			Result := l_t
		end

	skip_table (a_html, a_eof: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_html: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_level: INTEGER_32
			l_name: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_namelen: CE_ARRAY [INTEGER_32]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_html.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_name.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_namelen.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_html.item := a_html
					l_level := 1
				when 1 then -- r:
					from
					until
						(l_break)
					loop
						l_break := False
						if ((l_html.item).c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_html.item.item).to_integer_32 = 60 then
								if not ((create {P_HTML_STATIC}).parse_element (l_html.item, a_eof, l_name, l_namelen, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), l_html)).to_boolean then
									l_break := True
								end
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_html.item := l_html.item + 1
						end
					end
					l_break := False
					if ((l_html.item).c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
						Result := a_eof
						l_return := True
					end
					if not l_return then
						if l_namelen.item = 5 then
							if not ((create {P_LINKS_STATIC}).casecmp (l_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("TABLE")), (5).to_natural_32)).to_boolean then
								l_level := l_level + 1
							end
						end
						if l_namelen.item = 6 then
							if not ((create {P_LINKS_STATIC}).casecmp (l_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/TABLE")), (6).to_natural_32)).to_boolean then
								l_level := l_level - 1
								if not l_level.to_boolean then
									Result := (l_html.item)
									l_return := True
								end
							end
						end
					end
					if not l_return then
						l_pos := -1 + 1 -- goto r
					end
				when 2 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	parse_table (a_html, a_eof: CE_POINTER [NATURAL_8]; a_end: CE_POINTER [CE_POINTER [NATURAL_8]]; a_bgcolor: CE_POINTER [PD_RGB]; a_sh: INTEGER_32; a_bad_html: CE_POINTER [CE_POINTER [PD_S_E]]; a_bhp: CE_POINTER [INTEGER_32]): CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]
		require
			not a_end.is_void
		local
			l_html: CE_POINTER [NATURAL_8]
			l_qqq: INTEGER_32
			l_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]
			l_cell: CE_POINTER [PD_TABLE_CELL]
			l_t_name: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_t_attr: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_en: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_t_namelen: CE_ARRAY [INTEGER_32]
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_p: INTEGER_32
			l_lbhp: CE_POINTER [NATURAL_8]
			l_l_al: CE_ARRAY [INTEGER_32]
			l_l_val: CE_ARRAY [INTEGER_32]
			l_csp: INTEGER_32
			l_rsp: INTEGER_32
			l_group: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_k: INTEGER_32
			l_l_col: CE_ARRAY [PD_RGB]
			l_c_al: CE_ARRAY [INTEGER_32]
			l_c_val: CE_ARRAY [INTEGER_32]
			l_c_width: CE_ARRAY [INTEGER_32]
			l_c_span: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_sp: INTEGER_32
			l_wi: CE_ARRAY [INTEGER_32]
			l_al: CE_ARRAY [INTEGER_32]
			l_val: CE_ARRAY [INTEGER_32]
			l_tmp___17: INTEGER_32
			l_w: CE_ARRAY [INTEGER_32]
			l_sc: CE_POINTER [PD_TABLE_CELL]
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_sc___0: CE_POINTER [PD_TABLE_CELL]
			l_l: INTEGER_32
			l_m: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_c: CE_POINTER [PD_TABLE_CELL]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_t_name.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_t_attr.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_en.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_t_namelen.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l_al.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l_val.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_RGB]} l_l_col.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_c_al.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_c_val.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_c_width.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_wi.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_al.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_val.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_w.make (<<1>>)
			create {CE_CLASS_POINTER [PD_TABLE_CELL]} l_sc.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_html := a_html
					l_x := 0
					l_y := -1
					l_p := 0
					l_lbhp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_l_al.item := 0
					l_l_val.item := 1
					l_group := 0
					l_c_al.item := -1
					l_c_val.item := -1
					l_c_width.item := -1
					l_c_span := 0
					memcpy (create {CE_VOID_POINTER}.make_cast (l_l_col), create {CE_VOID_POINTER}.make_cast (a_bgcolor), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
					a_end.item := l_html
					if (not a_bad_html.is_void) then
						a_bad_html.item := create {CE_CLASS_POINTER [PD_S_E]}.make_shared (default_pointer + -1)
						a_bhp.item := 0
					end
					l_t := new_table
					if l_t.is_void then
						Result := (create {CE_CLASS_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 46 -- skip if block
					end
				when 1 then -- if: | se:
						l_en.item := l_html
				when 2 then -- see:
						l_html := l_en.item
						if (not a_bad_html.is_void) then
							if not l_p.to_boolean then
								if l_lbhp.is_void then
									if not ((a_bhp.item).bit_and (63)).to_boolean then
										if (a_bhp.item).to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_S_E}.make).structure_size.to_natural_32 - {NATURAL_32} 64 then
											from
											until
												False
											loop
												(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 344]);
												(create {P_KBD_STATIC}).fatal_tty_exit
												exit (4)
											end
										end
										a_bad_html.item := create {CE_CLASS_POINTER [PD_S_E]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 345, create {CE_VOID_POINTER}.make_cast (a_bad_html.item), (a_bhp.item + 64).to_natural_32 * (create {PD_S_E}.make).structure_size.to_natural_32)))
									end
									l_tmp___0 := a_bhp.item
									a_bhp.item := (a_bhp.item) + 1
									l_tmp___1 := l_html;
									(a_bad_html.item + l_tmp___0).item.s := l_tmp___1
									l_lbhp := l_tmp___1
								end
							end
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_html.c_pointer.to_integer_32).to_natural_32 < (a_eof.c_pointer.to_integer_32).to_natural_32 then
								if (l_html.item).to_integer_32 = 60 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_html := l_html + 1
							end
						end
						l_break := False
						if (l_html.c_pointer.to_integer_32).to_natural_32 >= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if l_p.to_boolean then
								(l_t.item.cells + (l_y * l_t.item.rx + l_x)).item.end2 := l_html
							end
							if (not l_lbhp.is_void) then
								(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
							end
							l_pos := -1 + 45 -- goto scan_done
						end
				when 3 then
						if ((l_html + 2).c_pointer.to_integer_32).to_natural_32 <= (a_eof.c_pointer.to_integer_32).to_natural_32 then
							if (l_html[1]).to_integer_32 = 33 then
								l_html := (create {P_HTML_STATIC}).skip_comment (l_html, a_eof)
								l_pos := -1 + 1 -- goto se
							elseif (l_html[1]).to_integer_32 = 63 then
								l_html := (create {P_HTML_STATIC}).skip_comment (l_html, a_eof)
								l_pos := -1 + 1 -- goto se
							end
						end
				when 4 then
						if ((create {P_HTML_STATIC}).parse_element (l_html, a_eof, l_t_name, l_t_namelen, l_t_attr, l_en)).to_boolean then
							l_html := l_html + 1
							l_pos := -1 + 1 -- goto se
						end
				when 5 then
						if l_t_namelen.item = 5 then
							if not ((create {P_LINKS_STATIC}).casecmp (l_t_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("TABLE")), (5).to_natural_32)).to_boolean then
								l_en.item := skip_table (l_en.item, a_eof)
								l_pos := -1 + 2 -- goto see
							end
						end
				when 6 then
						if l_t_namelen.item = 6 then
							if not ((create {P_LINKS_STATIC}).casecmp (l_t_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/TABLE")), (6).to_natural_32)).to_boolean then
								if l_c_span.to_boolean then
									l_t.item.new_columns (l_c_span, l_c_width.item, l_c_al.item, l_c_val.item, 1)
								end
								if l_p.to_boolean then
									(l_t.item.cells + (l_y * l_t.item.rx + l_x)).item.end2 := l_html
								end
								if (not l_lbhp.is_void) then
									(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
								end
								l_pos := -1 + 45 -- goto scan_done
							end
						end
				when 7 then
						if l_t_namelen.item = 8 then
							if not ((create {P_LINKS_STATIC}).casecmp (l_t_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("COLGROUP")), (8).to_natural_32)).to_boolean then
								if l_c_span.to_boolean then
									l_t.item.new_columns (l_c_span, l_c_width.item, l_c_al.item, l_c_val.item, 1)
								end
								if (not l_lbhp.is_void) then
									(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
									l_lbhp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								end
								l_c_al.item := -1
								l_c_val.item := -1
								l_c_width.item := -1
								get_align (create {CE_INTEGER_8_POINTER}.make_cast (l_t_attr.item), l_c_al)
								get_valign (create {CE_INTEGER_8_POINTER}.make_cast (l_t_attr.item), l_c_val)
								get_c_width (create {CE_INTEGER_8_POINTER}.make_cast (l_t_attr.item), l_c_width, a_sh)
								l_c_span := (create {P_HTML_STATIC}).get_num (l_t_attr.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("span")))
								if l_c_span = -1 then
									l_c_span := 1
								end
								l_pos := -1 + 2 -- goto see
							end
						end
				when 8 then
						if l_t_namelen.item = 9 then
							if not ((create {P_LINKS_STATIC}).casecmp (l_t_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/COLGROUP")), (9).to_natural_32)).to_boolean then
								if l_c_span.to_boolean then
									l_t.item.new_columns (l_c_span, l_c_width.item, l_c_al.item, l_c_val.item, 1)
								end
								if (not l_lbhp.is_void) then
									(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
									l_lbhp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								end
								l_c_span := 0
								l_c_al.item := -1
								l_c_val.item := -1
								l_c_width.item := -1
								l_pos := -1 + 2 -- goto see
							end
						end
				when 9 then
						if l_t_namelen.item = 3 then
							if not ((create {P_LINKS_STATIC}).casecmp (l_t_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("COL")), (3).to_natural_32)).to_boolean then
								if (not l_lbhp.is_void) then
									(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
									l_lbhp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								end
								l_sp := (create {P_HTML_STATIC}).get_num (l_t_attr.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("span")))
								if l_sp = -1 then
									l_sp := 1
								end
								l_wi.item := l_c_width.item
								l_al.item := l_c_al.item
								l_val.item := l_c_val.item
								get_align (create {CE_INTEGER_8_POINTER}.make_cast (l_t_attr.item), l_al)
								get_valign (create {CE_INTEGER_8_POINTER}.make_cast (l_t_attr.item), l_val)
								get_c_width (create {CE_INTEGER_8_POINTER}.make_cast (l_t_attr.item), l_wi, a_sh)
								l_t.item.new_columns (l_sp, l_wi.item, l_al.item, l_val.item, (l_c_span.to_boolean).to_integer)
								l_c_span := 0
								l_pos := -1 + 2 -- goto see
							end
						end
				when 10 then
						if l_t_namelen.item /= 3 then
							l_pos := -1 + 19 -- skip if block
						end
				when 11 then -- if:
						if not (((create {P_LINKS_STATIC}).casecmp (l_t_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/TR")), (3).to_natural_32)).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 12 then -- if:
						if not (((create {P_LINKS_STATIC}).casecmp (l_t_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/TD")), (3).to_natural_32)).to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 13 then -- if:
						if ((create {P_LINKS_STATIC}).casecmp (l_t_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/TH")), (3).to_natural_32)).to_boolean then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if l_c_span.to_boolean then
							l_t.item.new_columns (l_c_span, l_c_width.item, l_c_al.item, l_c_val.item, 1)
						end
						if l_p.to_boolean then
							(l_t.item.cells + (l_y * l_t.item.rx + l_x)).item.end2 := l_html
							l_p := 0
						end
						if (not l_lbhp.is_void) then
							(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
							l_lbhp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 14 -- goto _L
				when 17 then -- if done | if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_pos := -1 + 14 -- goto _L
				when 19 then -- if done
						if l_t_namelen.item = 2 then
							if not ((create {P_LINKS_STATIC}).casecmp (l_t_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("TR")), (2).to_natural_32)).to_boolean then
								if l_c_span.to_boolean then
									l_t.item.new_columns (l_c_span, l_c_width.item, l_c_al.item, l_c_val.item, 1)
								end
								if l_p.to_boolean then
									(l_t.item.cells + (l_y * l_t.item.rx + l_x)).item.end2 := l_html
									l_p := 0
								end
								if (not l_lbhp.is_void) then
									(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
									l_lbhp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								end
								if l_group.to_boolean then
									l_group := l_group - 1
								end
								l_l_al.item := 0
								l_l_val.item := 1
								memcpy (create {CE_VOID_POINTER}.make_cast (l_l_col), create {CE_VOID_POINTER}.make_cast (a_bgcolor), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
								get_align (create {CE_INTEGER_8_POINTER}.make_cast (l_t_attr.item), l_l_al)
								get_valign (create {CE_INTEGER_8_POINTER}.make_cast (l_t_attr.item), l_l_val);
								(create {P_HTML_STATIC}).get_bgcolor (l_t_attr.item, l_l_col).do_nothing
								l_y := l_y + 1
								l_x := 0
								l_pos := -1 + 2 -- goto see
							end
						end
				when 20 then
						if l_t_namelen.item /= 5 then
							l_pos := -1 + 29 -- skip if block
						end
				when 21 then -- if:
						if not (((create {P_LINKS_STATIC}).casecmp (l_t_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("THEAD")), (5).to_natural_32)).to_boolean) then
							l_pos := -1 + 28 -- skip if block
						end
				when 22 then -- if:
						if not (((create {P_LINKS_STATIC}).casecmp (l_t_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("TBODY")), (5).to_natural_32)).to_boolean) then
							l_pos := -1 + 26 -- skip if block
						end
				when 23 then -- if:
						if ((create {P_LINKS_STATIC}).casecmp (l_t_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("TFOOT")), (5).to_natural_32)).to_boolean then
							l_pos := -1 + 25 -- skip if block
						end
				when 24 then -- if: | _L___0:
						if l_c_span.to_boolean then
							l_t.item.new_columns (l_c_span, l_c_width.item, l_c_al.item, l_c_val.item, 1)
						end
						if (not l_lbhp.is_void) then
							(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
							l_lbhp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
						l_group := 2
				when 25 then -- if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						l_pos := -1 + 24 -- goto _L___0
				when 27 then -- if done | if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_pos := -1 + 24 -- goto _L___0
				when 29 then -- if done
						if l_t_namelen.item /= 2 then
							l_pos := -1 + 2 -- goto see
						elseif ((create {P_LINKS_STATIC}).casecmp (l_t_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("TD")), (2).to_natural_32)).to_boolean then
							if ((create {P_LINKS_STATIC}).casecmp (l_t_name.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("TH")), (2).to_natural_32)).to_boolean then
								l_pos := -1 + 2 -- goto see
							end
						end
				when 30 then
						if l_c_span.to_boolean then
							l_t.item.new_columns (l_c_span, l_c_width.item, l_c_al.item, l_c_val.item, 1)
						end
						if (not l_lbhp.is_void) then
							(a_bad_html.item + (a_bhp.item - 1)).item.e := l_html
							l_lbhp := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						end
						if l_p.to_boolean then
							(l_t.item.cells + (l_y * l_t.item.rx + l_x)).item.end2 := l_html
							l_p := 0
						end
						if l_y = -1 then
							l_y := 0
							l_x := 0
						end
				when 31 then -- nc:
						l_cell := l_t.item.new_cell (l_x, l_y)
						if not ((l_cell.item.used).to_boolean) then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						if l_cell.item.colspan = -1 then
							l_pos := -1 + 2 -- goto see
						end
				when 33 then
						l_x := l_x + 1
						l_pos := -1 + 31 -- goto nc
				when 34 then
						l_cell.item.mx := l_x
						l_cell.item.my := l_y
						l_cell.item.used := 1
						l_cell.item.start := l_en.item
						l_p := 1
						l_cell.item.align := l_l_al.item
						l_cell.item.valign := l_l_val.item
						l_tmp___17 := (((create {P_LINKS_STATIC}).upcase (l_t_name.item[1])).to_integer_32 = 72).to_integer
						l_cell.item.b := l_tmp___17
						if l_tmp___17.to_boolean then
							l_cell.item.align := 1
						end
						if l_group = 1 then
							l_cell.item.group := 1
						end
						if l_x < l_t.item.c then
							if (l_t.item.cols + l_x).item.align /= -1 then
								l_cell.item.align := (l_t.item.cols + l_x).item.align
							end
							if (l_t.item.cols + l_x).item.valign /= -1 then
								l_cell.item.valign := (l_t.item.cols + l_x).item.valign
							end
						end
						memcpy (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared (l_cell.c_pointer + (create {PD_TABLE_CELL}.make).offset_of ("bgcolor")))), create {CE_VOID_POINTER}.make_cast (l_l_col), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing
						get_align (create {CE_INTEGER_8_POINTER}.make_cast (l_t_attr.item), create {CE_INTEGER_32_POINTER}.make_shared (l_cell.c_pointer + (create {PD_TABLE_CELL}.make).offset_of ("align")))
						get_valign (create {CE_INTEGER_8_POINTER}.make_cast (l_t_attr.item), create {CE_INTEGER_32_POINTER}.make_shared (l_cell.c_pointer + (create {PD_TABLE_CELL}.make).offset_of ("valign")));
						(create {P_HTML_STATIC}).get_bgcolor (l_t_attr.item, create {CE_CLASS_POINTER [PD_RGB]}.make_shared (l_cell.c_pointer + (create {PD_TABLE_CELL}.make).offset_of ("bgcolor"))).do_nothing
						l_csp := (create {P_HTML_STATIC}).get_num (l_t_attr.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("colspan")))
						if l_csp = -1 then
							l_csp := 1
						end
						if not l_csp.to_boolean then
							l_csp := -1
						end
						l_rsp := (create {P_HTML_STATIC}).get_num (l_t_attr.item, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("rowspan")))
						if l_rsp = -1 then
							l_rsp := 1
						end
						if not l_rsp.to_boolean then
							l_rsp := -1
						end
						if l_csp >= 0 then
							if l_rsp >= 0 then
								if l_csp * l_rsp > 100_000 then
									if l_csp > 10 then
										l_csp := -1
									end
									if l_rsp > 10 then
										l_rsp := -1
									end
								end
							end
						end
						l_cell.item.colspan := l_csp
						l_cell.item.rowspan := l_rsp
						if l_csp = 1 then
							l_w.item := -1
							get_c_width (create {CE_INTEGER_8_POINTER}.make_cast (l_t_attr.item), l_w, a_sh)
							if l_w.item /= -1 then
								l_t.item.set_td_width (l_x, l_w.item, 0)
							end
						end
						l_qqq := l_t.item.x
						l_i := 1
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_csp /= -1 then
								l_tmp___21 := (l_i < l_csp).to_integer
							else
								l_tmp___21 := (l_x + l_i < l_qqq).to_integer
							end
							if not l_tmp___21.to_boolean then
								l_break := True
							end
							if not (l_return or l_break) then
								l_sc := (l_t.item.new_cell (l_x + l_i, l_y))
								if (l_sc.item.used).to_boolean then
									l_csp := l_i
									l_k := 0
									from
									until
										not (l_k < l_i)
									loop
										(l_t.item.cells + (l_y * l_t.item.rx + (l_x + l_k))).item.colspan := l_csp
										l_k := l_k + 1
									end
									l_break := True
								end
							end
							if not (l_return or l_break) then
								l_tmp___20 := 1
								l_sc.item.spanned := l_tmp___20
								l_sc.item.used := l_tmp___20
								l_sc.item.rowspan := l_rsp
								l_sc.item.colspan := l_csp
								l_sc.item.mx := l_x
								l_sc.item.my := l_y
								l_i := l_i + 1
							end
						end
						l_break := False
						l_qqq := l_t.item.y
						l_j := 1
				when 35 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 43 -- skip loop
						end
				when 36 then -- loop body:
						l_break := False
						if l_rsp /= -1 then
							l_tmp___24 := (l_j < l_rsp).to_integer
						else
							l_tmp___24 := (l_y + l_j < l_qqq).to_integer
						end
						if not l_tmp___24.to_boolean then
							l_break := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 42 -- skip if block
						end
				when 37 then -- if:
						l_k := 0
				when 38 then -- loop condition:
						if not (not (l_return) and then (l_k < l_i)) then
							l_pos := -1 + 41 -- skip loop
						end
				when 39 then -- loop body:
						l_continue := False
						l_sc___0 := (l_t.item.new_cell (l_x + l_k, l_y + l_j))
						if (l_sc___0.item.used).to_boolean then
							if l_sc___0.item.mx = l_x then
								if l_sc___0.item.my = l_y then
									l_continue := True
								end
							end
							if not (l_return or l_break or l_continue) then
								l_l := 0
								from
								until
									not (l_l < l_k)
								loop
									memset (create {CE_VOID_POINTER}.make_cast ((l_t.item.cells + ((l_y + l_j) * l_t.item.rx + (l_x + l_l)))), 0, (create {PD_TABLE_CELL}.make).structure_size.to_natural_32).do_nothing
									l_l := l_l + 1
								end
								l_rsp := l_j
								l_l := 0
								from
								until
									not (not (l_return) and then (l_l < l_i))
								loop
									l_m := 0
									from
									until
										not (l_m < l_j)
									loop
										(l_t.item.cells + ((l_y + l_m) * l_t.item.rx + (l_x + l_l))).item.rowspan := l_j
										l_m := l_m + 1
									end
									l_l := l_l + 1
								end
								l_pos := -1 + 44 -- goto brk
							end
						end
				when 40 then
						if not (l_return or l_break or l_continue) then
							l_tmp___23 := 1
							l_sc___0.item.spanned := l_tmp___23
							l_sc___0.item.used := l_tmp___23
							l_sc___0.item.rowspan := l_rsp
							l_sc___0.item.colspan := l_csp
							l_sc___0.item.mx := l_x
							l_sc___0.item.my := l_y
						end
						if (not l_return) then
							l_k := l_k + 1
						end
						l_pos := -1 + 38 -- back to loop condition
				when 41 then -- loop done
						l_continue := False
						l_j := l_j + 1
				when 42 then -- if done
						l_pos := -1 + 35 -- back to loop condition
				when 43 then -- loop done
						l_break := False
				when 44 then -- brk:
						l_pos := -1 + 2 -- goto see
				when 45 then -- scan_done:
						a_end.item := l_html
						l_x := 0
						from
						until
							not (not (l_return) and then (l_x < l_t.item.x))
						loop
							l_y := 0
							from
							until
								not (l_y < l_t.item.y)
							loop
								l_c := l_t.item.cells + (l_y * l_t.item.rx + l_x)
								if not (l_c.item.spanned).to_boolean then
									if l_c.item.colspan = -1 then
										l_c.item.colspan := l_t.item.x - l_x
									end
									if l_c.item.rowspan = -1 then
										l_c.item.rowspan := l_t.item.y - l_y
									end
								end
								l_y := l_y + 1
							end
							l_x := l_x + 1
						end
						if (l_t.item.y).to_natural_32 > {NATURAL_32} 2_147_483_647 // {PLATFORM}.Integer_32_bytes.to_natural_32 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("html_tbl.c"), 524]);
								(create {P_KBD_STATIC}).fatal_tty_exit
								exit (4)
							end
						end
						l_t.item.r_heights := create {CE_INTEGER_32_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 525, (l_t.item.y).to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)))
						memset (create {CE_VOID_POINTER}.make_cast (l_t.item.r_heights), 0, (l_t.item.y).to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32).do_nothing
						l_x := 0
						from
						until
							not (l_x < l_t.item.c)
						loop
							if (l_t.item.cols + l_x).item.width /= -1 then
								l_t.item.set_td_width (l_x, (l_t.item.cols + l_x).item.width, 1)
							end
							l_x := l_x + 1
						end
						l_t.item.set_td_width (l_t.item.x, -1, 0)
						Result := l_t
				when 46 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	format_table (a_attr, a_html, a_eof: CE_POINTER [NATURAL_8]; a_end: CE_POINTER [CE_POINTER [NATURAL_8]]; a_f: CE_POINTER [ANY])
		require
			not a_attr.is_void
			not a_end.is_void
		local
			l_p: CE_POINTER [PD_PART]
			l_border: INTEGER_32
			l_cellsp: INTEGER_32
			l_vcellpd: INTEGER_32
			l_cellpd: INTEGER_32
			l_align: INTEGER_32
			l_frame: INTEGER_32
			l_rules: INTEGER_32
			l_width: INTEGER_32
			l_wf: INTEGER_32
			l_bgcolor: CE_ARRAY [PD_RGB]
			l_t: CE_POINTER [PD_TABLE_DIRTY_WORKAROUND_FOR_NAME_CLASH_WITH_LIBRARIES_ON_MACOS]
			l_al: CE_POINTER [INTEGER_8]
			l_cye: CE_ARRAY [INTEGER_32]
			l_x: INTEGER_32
			l_i: INTEGER_32
			l_bad_html: CE_ARRAY [CE_POINTER [PD_S_E]]
			l_bad_html_n: CE_ARRAY [INTEGER_32]
			l_n: CE_POINTER [PD_NODE]
			l_nn: CE_POINTER [PD_NODE]
			l_cpd_pass: INTEGER_32
			l_cpd_width: INTEGER_32
			l_cpd_last: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_ww: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_RGB]} l_bgcolor.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_cye.make (<<1>>)
			create {CE_POINTER_ARRAY [PD_S_E]} l_bad_html.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_bad_html_n.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p := create {CE_CLASS_POINTER [PD_PART]}.make_cast (a_f);
					(create {P_LINKS_STATIC}).table_level.item := (create {P_LINKS_STATIC}).table_level.item + 1
					memcpy (create {CE_VOID_POINTER}.make_cast (l_bgcolor), create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_RGB]}.make_shared ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).c_pointer + (create {PD_HTML_ELEMENT}.make).offset_of ("parattr") + (create {PD_PAR_ATTRIB}.make).offset_of ("bgcolor")))), (create {PD_RGB}.make).structure_size.to_natural_32).do_nothing;
					(create {P_HTML_STATIC}).get_bgcolor (a_attr, l_bgcolor).do_nothing
					l_border := (create {P_HTML_STATIC}).get_num (a_attr, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("border")))
					if l_border = -1 then
						if ((create {P_HTML_STATIC}).has_attr (a_attr, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("border")))).to_boolean then
							l_tmp___2 := 1
						elseif ((create {P_HTML_STATIC}).has_attr (a_attr, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("rules")))).to_boolean then
							l_tmp___2 := 1
						elseif ((create {P_HTML_STATIC}).has_attr (a_attr, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("frame")))).to_boolean then
							l_tmp___2 := 1
						else
							l_tmp___2 := 0
						end
						l_border := l_tmp___2
					end
					l_cellsp := (create {P_HTML_STATIC}).get_num (a_attr, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cellspacing")))
					if l_cellsp = -1 then
						l_cellsp := 1
					end
					l_cellpd := (create {P_HTML_STATIC}).get_num (a_attr, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("cellpadding")))
					if l_cellpd = -1 then
						l_vcellpd := 0
						l_cellpd := (l_border.to_boolean).to_integer
					else
						l_vcellpd := (l_cellpd >= 7).to_integer
						l_cellpd := (l_cellpd >= 4).to_integer
					end
					if not l_border.to_boolean then
						l_cellsp := 0
					elseif not l_cellsp.to_boolean then
						l_cellsp := 1
					end
					if l_border > 2 then
						l_border := 2
					end
					if l_cellsp > 2 then
						l_cellsp := 2
					end
					l_align := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align
					if l_align = 4 then
						l_align := 0
					elseif l_align = 3 then
						l_align := 0
					end
					l_al := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HTML_STATIC}).get_attr_val (a_attr, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("align")))))
					if (not l_al.is_void) then
						if not (strcasecmp (l_al, ce_string ("left"))).to_boolean then
							l_align := 0
						end
						if not (strcasecmp (l_al, ce_string ("center"))).to_boolean then
							l_align := 1
						end
						if not (strcasecmp (l_al, ce_string ("right"))).to_boolean then
							l_align := 2
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 1_129, create {CE_VOID_POINTER}.make_cast (l_al))
					end
					l_frame := 15
					l_al := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HTML_STATIC}).get_attr_val (a_attr, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("frame")))))
					if (not l_al.is_void) then
						if not (strcasecmp (l_al, ce_string ("void"))).to_boolean then
							l_frame := 0
						end
						if not (strcasecmp (l_al, ce_string ("above"))).to_boolean then
							l_frame := 1
						end
						if not (strcasecmp (l_al, ce_string ("below"))).to_boolean then
							l_frame := 2
						end
						if not (strcasecmp (l_al, ce_string ("hsides"))).to_boolean then
							l_frame := 3
						end
						if not (strcasecmp (l_al, ce_string ("vsides"))).to_boolean then
							l_frame := 12
						end
						if not (strcasecmp (l_al, ce_string ("lhs"))).to_boolean then
							l_frame := 4
						end
						if not (strcasecmp (l_al, ce_string ("rhs"))).to_boolean then
							l_frame := 8
						end
						if not (strcasecmp (l_al, ce_string ("box"))).to_boolean then
							l_frame := 15
						end
						if not (strcasecmp (l_al, ce_string ("border"))).to_boolean then
							l_frame := 15
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 1_142, create {CE_VOID_POINTER}.make_cast (l_al))
					end
					if l_border.to_boolean then
						l_rules := 3
					else
						l_rules := 0
					end
					l_al := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_HTML_STATIC}).get_attr_val (a_attr, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("rules")))))
					if (not l_al.is_void) then
						if not (strcasecmp (l_al, ce_string ("none"))).to_boolean then
							l_rules := 0
						end
						if not (strcasecmp (l_al, ce_string ("groups"))).to_boolean then
							l_rules := 4
						end
						if not (strcasecmp (l_al, ce_string ("rows"))).to_boolean then
							l_rules := 1
						end
						if not (strcasecmp (l_al, ce_string ("cols"))).to_boolean then
							l_rules := 2
						end
						if not (strcasecmp (l_al, ce_string ("all"))).to_boolean then
							l_rules := 3
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 1_151, create {CE_VOID_POINTER}.make_cast (l_al))
					end
					if not l_border.to_boolean then
						l_frame := 0
					end
					l_wf := 0
					if (not (l_p.item.data).is_void) then
						l_tmp___23 := 1
					elseif (l_p.item.xp).to_boolean then
						l_tmp___23 := 1
					else
						l_tmp___23 := 0
					end
					l_width := (create {P_HTML_STATIC}).get_width (a_attr, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("width")), l_tmp___23)
					if l_width = -1 then
						l_width := ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width - (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin) - (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin
						if l_width < 0 then
							l_width := 0
						end
						l_wf := 1
					end
					if (not (l_p.item.data).is_void) then
						l_tmp___24 := 1
					elseif (l_p.item.xp).to_boolean then
						l_tmp___24 := 1
					else
						l_tmp___24 := 0
					end
					l_t := parse_table (a_html, a_eof, a_end, l_bgcolor, l_tmp___24, l_bad_html, l_bad_html_n)
					if l_t.is_void then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 1_161, create {CE_VOID_POINTER}.make_cast (l_bad_html.item))
						l_pos := -1 + 10 -- goto ret0
					end
				when 1 then
					l_i := 0
					from
					until
						not (not (l_return) and then (l_i < l_bad_html_n.item))
					loop
						from
						until
							(l_break)
						loop
							l_break := False
							if (((l_bad_html.item + l_i).item.s).c_pointer.to_integer_32).to_natural_32 < (((l_bad_html.item + l_i).item.e).c_pointer.to_integer_32).to_natural_32 then
								if (((l_bad_html.item + l_i).item.s).item).to_integer_32 /= 9 then
									if (((l_bad_html.item + l_i).item.s).item).to_integer_32 /= 10 then
										if (((l_bad_html.item + l_i).item.s).item).to_integer_32 /= 12 then
											if (((l_bad_html.item + l_i).item.s).item).to_integer_32 /= 13 then
												if (((l_bad_html.item + l_i).item.s).item).to_integer_32 /= 32 then
													l_break := True
												end
											end
										end
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								(l_bad_html.item + l_i).item.s := ((l_bad_html.item + l_i).item.s) + 1
							end
						end
						l_break := False
						from
						until
							(l_break)
						loop
							l_break := False
							if (((l_bad_html.item + l_i).item.s).c_pointer.to_integer_32).to_natural_32 < (((l_bad_html.item + l_i).item.e).c_pointer.to_integer_32).to_natural_32 then
								if ((l_bad_html.item + l_i).item.e[-1]).to_integer_32 /= 9 then
									if ((l_bad_html.item + l_i).item.e[-1]).to_integer_32 /= 10 then
										if ((l_bad_html.item + l_i).item.e[-1]).to_integer_32 /= 12 then
											if ((l_bad_html.item + l_i).item.e[-1]).to_integer_32 /= 13 then
												if ((l_bad_html.item + l_i).item.e[-1]).to_integer_32 /= 32 then
													l_break := True
												end
											end
										end
									end
								end
							else
								l_break := True
							end
							if not (l_break) then
								(l_bad_html.item + l_i).item.e := ((l_bad_html.item + l_i).item.e) - 1
							end
						end
						l_break := False
						if (((l_bad_html.item + l_i).item.s).c_pointer.to_integer_32).to_natural_32 < (((l_bad_html.item + l_i).item.e).c_pointer.to_integer_32).to_natural_32 then
							(create {P_HTML_STATIC}).parse_html ((l_bad_html.item + l_i).item.s, (l_bad_html.item + l_i).item.e, (create {P_LINKS_STATIC}).put_chars_f.item, (create {P_LINKS_STATIC}).line_break_f.item, (create {P_LINKS_STATIC}).special_f.item, create {CE_VOID_POINTER}.make_cast (l_p), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						end
						l_i := l_i + 1
					end
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 1_169, create {CE_VOID_POINTER}.make_cast (l_bad_html.item));
					(create {P_HTML_STATIC}).html_stack_dup;
					(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.dontkill := 1;
					(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.align := 0
					l_t.item.p := l_p
					l_t.item.border := l_border
					l_t.item.cellpd := l_cellpd
					l_t.item.vcellpd := l_vcellpd
					l_t.item.cellsp := l_cellsp
					l_t.item.frame := l_frame
					l_t.item.rules := l_rules
					l_t.item.width := l_width
					l_t.item.wf := l_wf
					l_cpd_pass := 0
					l_cpd_last := l_t.item.cellpd
					l_cpd_width := 0
				when 2 then -- again:
					l_t.item.get_cell_widths
					if (l_t.item.get_column_widths).to_boolean then
						l_pos := -1 + 9 -- goto ret2
					end
				when 3 then
					l_t.item.get_table_width
					if (l_p.item.data).is_void then
						if not (l_p.item.xp).to_boolean then
							if not l_wf.to_boolean then
								if l_t.item.max_t > l_width then
									l_t.item.max_t := l_width
								end
							end
							if l_t.item.max_t < l_t.item.min_t then
								l_t.item.max_t := l_t.item.min_t
							end
							if (l_t.item.max_t + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin) + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin > l_p.item.xmax then
								l_p.item.xmax := (l_t.item.max_t + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin) + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin
							end
							if (l_t.item.min_t + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin) + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin > l_p.item.x then
								l_p.item.x := (l_t.item.min_t + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin) + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin
							end
							l_pos := -1 + 9 -- goto ret2
						end
					end
				when 4 then
					if not l_cpd_pass.to_boolean then
						if l_t.item.min_t > l_width then
							if (l_t.item.cellpd).to_boolean then
								l_t.item.cellpd := 0
								l_cpd_pass := 1
								l_cpd_width := l_t.item.min_t
								l_pos := -1 + 2 -- goto again
							end
						end
					end
				when 5 then
					if l_cpd_pass = 1 then
						if l_t.item.min_t > l_cpd_width then
							l_t.item.cellpd := l_cpd_last
							l_cpd_pass := 2
							l_pos := -1 + 2 -- goto again
						end
					end
				when 6 then
					if l_t.item.min_t >= l_width then
						l_t.item.distribute_widths (l_t.item.min_t)
					elseif l_t.item.max_t < l_width then
						if l_wf.to_boolean then
							l_t.item.distribute_widths (l_t.item.max_t)
						else
							l_t.item.distribute_widths (l_width)
						end
					else
						l_t.item.distribute_widths (l_width)
					end
					if (l_p.item.data).is_void then
						if l_p.item.xp = 1 then
							l_ww := (l_t.item.rw + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin) + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin
							if l_ww > (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width then
								l_ww := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width
							end
							if l_ww < l_t.item.rw then
								l_ww := l_t.item.rw
							end
							if l_ww > l_p.item.x then
								l_p.item.x := l_ww
							end
							l_p.item.cy := l_p.item.cy + (l_t.item.rh)
							l_pos := -1 + 9 -- goto ret2
						end
					end
				when 7 then
					l_t.item.check_table_widths
					l_x := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin
					if l_align = 1 then
						l_x := ((((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin) - (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin) - l_t.item.rw) // 2
					end
					if l_align = 2 then
						l_x := ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width - (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin) - l_t.item.rw
					end
					if l_x + l_t.item.rw > (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width then
						l_x := (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.width - l_t.item.rw
					end
					if l_x < 0 then
						l_x := 0
					end
					l_t.item.get_table_heights
					if (l_p.item.data).is_void then
						if (l_t.item.rw + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin) + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin > l_p.item.x then
							l_p.item.x := (l_t.item.rw + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.leftmargin) + (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.parattr.rightmargin
						end
						l_p.item.cy := l_p.item.cy + (l_t.item.rh)
						l_pos := -1 + 9 -- goto ret2
					end
				when 8 then
					l_n := create {CE_CLASS_POINTER [PD_NODE]}.make_cast ((l_p.item.data).item.nodes.next)
					l_n.item.yw := (l_p.item.yp - l_n.item.y) + l_p.item.cy
					l_t.item.display_complicated_table (l_x, l_p.item.cy, l_cye)
					l_t.item.display_table_frames (l_x, l_p.item.cy)
					l_nn := create {CE_CLASS_POINTER [PD_NODE]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html_tbl.c")), 1_238, (create {PD_NODE}.make).structure_size.to_natural_32)))
					l_nn.item.x := l_n.item.x
					l_nn.item.y := l_p.item.yp + l_cye.item
					l_nn.item.xw := l_n.item.xw
					from
					until
						(l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((l_p.item.data).c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes")))))
						l_nn.item.next := (create {CE_CLASS_POINTER [PD_NODE]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((l_p.item.data).c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes"))))).item.next
						l_nn.item.prev := create {CE_CLASS_POINTER [PD_NODE]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((l_p.item.data).c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes"))));
						(create {CE_CLASS_POINTER [PD_NODE]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((l_p.item.data).c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes"))))).item.next := l_nn;
						(l_nn.item.next).item.prev := l_nn;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared ((l_p.item.data).c_pointer + (create {PD_F_DATA}.make).offset_of ("nodes")))))
						l_break := True
					end
					l_break := False
					l_p.item.cy := l_cye.item
					l_p.item.cx := -1
				when 9 then -- ret2:
					l_p.item.link_num := l_t.item.link_num
					if l_p.item.cy > l_p.item.y then
						l_p.item.y := l_p.item.cy
					end
					l_t.item.free_table;
					(create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.kill_html_stack_item
				when 10 then -- ret0:;
					(create {P_LINKS_STATIC}).table_level.item := (create {P_LINKS_STATIC}).table_level.item - 1
					if not ((create {P_LINKS_STATIC}).table_level.item).to_boolean then
						(create {P_HTML_R_STATIC}).free_table_cache
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
