class
	P_SCHED_STATIC

inherit
	CE_UTILITIES
	S_UNISTD_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	connection_count: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (0).to_natural_32
		end

	active_connections: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	queue: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (queue.item), create {CE_VOID_POINTER}.make_cast (queue.item)])
		end

	keepalive_connections: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (keepalive_connections.item), create {CE_VOID_POINTER}.make_cast (keepalive_connections.item)])
		end

	keepalive_timeout: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	blacklist: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (blacklist.item), create {CE_VOID_POINTER}.make_cast (blacklist.item)])
		end

	msg_dsc: CE_STATIC [CE_ARRAY [PD_S_MSG_DSC]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_S_MSG_DSC]}.make_initialized (<<
					create {PD_S_MSG_DSC}.make_initialized ([0, (create {P_LINKS_STATIC}).dummyarray.item + 120]),
					create {PD_S_MSG_DSC}.make_initialized ([1, (create {P_LINKS_STATIC}).dummyarray.item + 121]),
					create {PD_S_MSG_DSC}.make_initialized ([2, (create {P_LINKS_STATIC}).dummyarray.item + 122]),
					create {PD_S_MSG_DSC}.make_initialized ([3, (create {P_LINKS_STATIC}).dummyarray.item + 123]),
					create {PD_S_MSG_DSC}.make_initialized ([4, (create {P_LINKS_STATIC}).dummyarray.item + 124]),
					create {PD_S_MSG_DSC}.make_initialized ([5, (create {P_LINKS_STATIC}).dummyarray.item + 125]),
					create {PD_S_MSG_DSC}.make_initialized ([6, (create {P_LINKS_STATIC}).dummyarray.item + 126]),
					create {PD_S_MSG_DSC}.make_initialized ([7, (create {P_LINKS_STATIC}).dummyarray.item + 127]),
					create {PD_S_MSG_DSC}.make_initialized ([8, (create {P_LINKS_STATIC}).dummyarray.item + 128]),
					create {PD_S_MSG_DSC}.make_initialized ([-999, (create {P_LINKS_STATIC}).dummyarray.item + 129]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_000, (create {P_LINKS_STATIC}).dummyarray.item + 14]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_001, (create {P_LINKS_STATIC}).dummyarray.item + 130]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_002, (create {P_LINKS_STATIC}).dummyarray.item + 131]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_003, (create {P_LINKS_STATIC}).dummyarray.item + 132]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_004, (create {P_LINKS_STATIC}).dummyarray.item + 133]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_005, (create {P_LINKS_STATIC}).dummyarray.item + 134]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_006, (create {P_LINKS_STATIC}).dummyarray.item + 135]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_007, (create {P_LINKS_STATIC}).dummyarray.item + 136]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_008, (create {P_LINKS_STATIC}).dummyarray.item + 137]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_009, (create {P_LINKS_STATIC}).dummyarray.item + 138]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_010, (create {P_LINKS_STATIC}).dummyarray.item + 139]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_011, (create {P_LINKS_STATIC}).dummyarray.item + 140]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_012, (create {P_LINKS_STATIC}).dummyarray.item + 141]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_014, (create {P_LINKS_STATIC}).dummyarray.item + 142]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_100, (create {P_LINKS_STATIC}).dummyarray.item + 143]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_101, (create {P_LINKS_STATIC}).dummyarray.item + 144]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_102, (create {P_LINKS_STATIC}).dummyarray.item + 145]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_200, (create {P_LINKS_STATIC}).dummyarray.item + 146]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_201, (create {P_LINKS_STATIC}).dummyarray.item + 147]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_300, (create {P_LINKS_STATIC}).dummyarray.item + 148]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_301, (create {P_LINKS_STATIC}).dummyarray.item + 149]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_302, (create {P_LINKS_STATIC}).dummyarray.item + 150]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_303, (create {P_LINKS_STATIC}).dummyarray.item + 151]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_304, (create {P_LINKS_STATIC}).dummyarray.item + 152]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_305, (create {P_LINKS_STATIC}).dummyarray.item + 153]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_400, (create {P_LINKS_STATIC}).dummyarray.item + 309]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_401, (create {P_LINKS_STATIC}).dummyarray.item + 310]),
					create {PD_S_MSG_DSC}.make_initialized ([-1_500, (create {P_LINKS_STATIC}).dummyarray.item + 311]),
					create {PD_S_MSG_DSC}.make_initialized ([0, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)])
				>>)
		end

feature {ANY} -- public routines

	abort_all_keepalive_connections
		local
			l_k: CE_POINTER [PD_K_CONN]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			l_k := create {CE_CLASS_POINTER [PD_K_CONN]}.make_cast (keepalive_connections.item.item.next)
			from
			until
				l_k.is_equal (keepalive_connections.item)
			loop
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 158, create {CE_VOID_POINTER}.make_cast (l_k.item.host))
				close (l_k.item.conn).do_nothing
				l_k := l_k.item.next
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (keepalive_connections.item))
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (keepalive_connections.item.item.next)
			from
			until
				l_a__.is_equal (keepalive_connections.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (keepalive_connections.item.item.prev)
			from
			until
				l_a__.is_equal (keepalive_connections.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.prev
			end
			from
			until
				(keepalive_connections.item.item.next).is_equal (keepalive_connections.item)
			loop
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (keepalive_connections.item.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 159, create {CE_VOID_POINTER}.make_cast (l_a__))
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (keepalive_connections.item))
			check_keepalive_connections
		end

	keepalive_timer (a_x: CE_POINTER [ANY])
		do
			keepalive_timeout.item := -1
			check_keepalive_connections
		end

	check_keepalive_connections
		local
			l_kc: CE_POINTER [PD_K_CONN]
			l_ct: INTEGER_32
			l_p: INTEGER_32
			l_return: BOOLEAN
		do
			l_ct := ((create {P_SELECT_STATIC}).get_time)
			l_p := 0
			if keepalive_timeout.item /= -1 then
				(create {P_SELECT_STATIC}).kill_timer (keepalive_timeout.item)
				keepalive_timeout.item := -1
			end
			l_kc := create {CE_CLASS_POINTER [PD_K_CONN]}.make_cast (keepalive_connections.item.item.next)
			from
			until
				l_kc.is_equal (keepalive_connections.item)
			loop
				if ((create {P_LINKS_STATIC}).can_read (l_kc.item.conn)).to_boolean then
					l_kc := l_kc.item.prev;
					(l_kc.item.next).item.del_keepalive_socket
				elseif l_ct - l_kc.item.add_time > l_kc.item.timeout then
					l_kc := l_kc.item.prev;
					(l_kc.item.next).item.del_keepalive_socket
				else
					l_p := l_p + 1
				end
				l_kc := l_kc.item.next
			end
			from
			until
				not (not (l_return) and then (l_p > 30))
			loop
				if not ((keepalive_connections.item.item.next).is_equal (keepalive_connections.item)) then
					(create {CE_CLASS_POINTER [PD_K_CONN]}.make_cast (keepalive_connections.item.item.prev)).item.del_keepalive_socket
				else
					from
					until
						False
					loop
						(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"));
						(create {P_LINKS_STATIC}).errline.item := 293;
						(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("keepalive list empty"))])
					end
				end
				l_p := l_p - 1
			end
			if not ((keepalive_connections.item.item.next).is_equal (keepalive_connections.item)) then
				keepalive_timeout.item := (create {P_SELECT_STATIC}).install_timer ((20_000).to_integer_32, keepalive_timer_address, create {CE_VOID_POINTER}.make_shared (default_pointer))
			end
		end

	sort_queue
		local
			l_c: CE_POINTER [PD_CONNECTION]
			l_n: CE_POINTER [PD_CONNECTION]
			l_swp: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_swp := 0
				l_c := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast (queue.item.item.next)
				from
				until
					not (not (l_return) and then (not l_c.is_equal (queue.item)))
				loop
					if not (l_c.item.next).is_equal (queue.item) then
						l_tmp := (create {P_LINKS_STATIC}).getpri (l_c.item.next)
						if l_tmp < ((create {P_LINKS_STATIC}).getpri (l_c)) then
							l_n := l_c.item.next;
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_c));
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_c.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_c.item.prev);
							(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_c.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_c.item.next);
							(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_c))
							from
							until
								(l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_n))
								l_c.item.next := l_n.item.next
								l_c.item.prev := l_n
								l_n.item.next := l_c;
								(l_c.item.next).item.prev := l_c;
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_n))
								l_break := True
							end
							l_break := False
							l_swp := 1
						end
					end
					l_c := l_c.item.next
				end
				if not l_swp.to_boolean then
					l_break := True
				end
			end
			l_break := False
		end

	check_queue_bugs
		local
			l_d: CE_POINTER [PD_CONNECTION]
			l_p: INTEGER_32
			l_ps: INTEGER_32
			l_cc: INTEGER_32
			l_q: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p := 0
					l_ps := 0
				when 1 then -- again:
					l_cc := 0
					l_d := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast (queue.item.item.next)
				when 2 then -- loop condition:
					if not (not (l_return or l_break) and then (not l_d.is_equal (queue.item))) then
						l_pos := -1 + 5 -- skip loop
					end
				when 3 then -- loop body:
						l_break := False
						l_q := ((create {P_LINKS_STATIC}).getpri (l_d))
						l_cc := l_cc + (l_d.item.running)
						if l_q < l_p then
							if not l_ps.to_boolean then
								from
								until
									False
								loop
									(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"));
									(create {P_LINKS_STATIC}).errline.item := 460;
									(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("queue is not sorted"))])
								end
								sort_queue
								l_ps := 1
								l_pos := -1 + 1 -- goto again
							else
								from
								until
									False
								loop
									(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"));
									(create {P_LINKS_STATIC}).errline.item := 465;
									(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("queue is not sorted even after sort_queue!"))])
								end
								l_break := True
							end
						else
							l_p := l_q
						end
				when 4 then
						if not (l_return or l_break) then
							if l_d.item.state < 0 then
								from
								until
									False
								loop
									(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"));
									(create {P_LINKS_STATIC}).errline.item := 469;
									(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("interrupted connection on queue (conn %%s, state %%d)")), l_d.item.url, l_d.item.state])
								end
								l_d := l_d.item.prev;
								(l_d.item.next).item.abort_connection
							end
							l_d := l_d.item.next
						end
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
					l_break := False
					if l_cc /= active_connections.item then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"));
							(create {P_LINKS_STATIC}).errline.item := 475;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bad number of active connections (counted %%d, stored %%d)")), l_cc, active_connections.item])
						end
						active_connections.item := l_cc
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_queue (a_dummy: CE_POINTER [ANY])
		local
			l_c: CE_POINTER [PD_CONNECTION]
			l_d: CE_POINTER [PD_CONNECTION]
			l_cp: INTEGER_32
			l_dd: CE_POINTER [PD_CONNECTION]
			l_dd___0: CE_POINTER [PD_CONNECTION]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start: | again:
					l_c := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast (queue.item.item.next)
					check_queue_bugs
					check_keepalive_connections
				when 1 then -- loop condition:
					if not (not (l_return) and then (not l_c.is_equal (queue.item))) then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						l_cp := ((create {P_LINKS_STATIC}).getpri (l_c))
						l_d := l_c
				when 3 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						l_break := False
						if not l_d.is_equal (queue.item) then
							if ((create {P_LINKS_STATIC}).getpri (l_d)) /= l_cp then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_dd := l_d
							l_d := l_d.item.next
							if not (l_dd.item.state).to_boolean then
								if (not (l_dd.item.is_host_on_keepalive_list).is_void) then
									if (l_dd.item.try_connection).to_boolean then
										l_pos := -1 + 0 -- goto again
									end
								end
							end
						end
				when 5 then
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						l_break := False
						l_d := l_c
				when 7 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 10 -- skip loop
						end
				when 8 then -- loop body:
						l_break := False
						if not l_d.is_equal (queue.item) then
							if ((create {P_LINKS_STATIC}).getpri (l_d)) /= l_cp then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							l_dd___0 := l_d
							l_d := l_d.item.next
							if not (l_dd___0.item.state).to_boolean then
								if (l_dd___0.item.try_connection).to_boolean then
									l_pos := -1 + 0 -- goto again
								end
							end
						end
				when 9 then
						l_pos := -1 + 7 -- back to loop condition
				when 10 then -- loop done
						l_break := False
						l_c := l_d
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- again2:
					l_c := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast (queue.item.item.prev)
				when 12 then -- loop condition:
					if not (not (l_break) and then (not l_c.is_equal (queue.item))) then
						l_pos := -1 + 17 -- skip loop
					end
				when 13 then -- loop body:
						l_break := False
						if ((create {P_LINKS_STATIC}).getpri (l_c)) < 5 then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						if l_c.item.state = 0 then
							l_c.item.setcstate (-1_001)
							l_c.item.del_connection
							l_pos := -1 + 11 -- goto again2
						elseif l_c.item.est_length > (create {P_DEFAULT_STATIC}).memory_cache_size.item.item // 4 then
							l_c.item.setcstate (-1_001)
							l_c.item.abort_connection
							l_pos := -1 + 11 -- goto again2
						elseif l_c.item.from2 > (create {P_DEFAULT_STATIC}).memory_cache_size.item.item // 4 then
							l_c.item.setcstate (-1_001)
							l_c.item.abort_connection
							l_pos := -1 + 11 -- goto again2
						end
				when 15 then
						l_c := l_c.item.prev
				when 16 then -- if done
						l_pos := -1 + 12 -- back to loop condition
				when 17 then -- loop done
					l_break := False
					check_queue_bugs
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_proxy (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_l: NATURAL_32
			l_proxy: CE_POINTER [NATURAL_8]
			l_u: CE_POINTER [NATURAL_8]
			l_tmp___3: NATURAL_32
		do
			l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_url)))
			l_proxy := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if ((create {P_DEFAULT_STATIC}).http_proxy.item[0]).to_boolean then
				if l_l >= {NATURAL_32} 7 then
					if not ((create {P_LINKS_STATIC}).casecmp (a_url, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("http://")), (7).to_natural_32)).to_boolean then
						l_proxy := (create {P_DEFAULT_STATIC}).http_proxy.item
					end
				end
			end
			if ((create {P_DEFAULT_STATIC}).ftp_proxy.item[0]).to_boolean then
				if l_l >= {NATURAL_32} 6 then
					if not ((create {P_LINKS_STATIC}).casecmp (a_url, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ftp://")), (6).to_natural_32)).to_boolean then
						l_proxy := (create {P_DEFAULT_STATIC}).ftp_proxy.item
					end
				end
			end
			if (not l_proxy.is_void) then
				l_tmp___3 := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_proxy))) + {NATURAL_32} 9
			else
				l_tmp___3 := (0).to_natural_32
			end
			l_u := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 532, (l_l + {NATURAL_32} 1) + l_tmp___3)))
			if (not l_proxy.is_void) then
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_u), ce_string ("proxy://")).do_nothing
				strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_u), create {CE_INTEGER_8_POINTER}.make_cast (l_proxy)).do_nothing
				strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_u), ce_string ("/")).do_nothing
			else
				l_u.item := (0).to_natural_8
			end
			strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_u), create {CE_INTEGER_8_POINTER}.make_cast (a_url)).do_nothing
			Result := l_u
		end

	load_url (a_url: CE_POINTER [NATURAL_8]; a_stat___0: CE_POINTER [PD_STATUS]; a_pri, a_no_cache: INTEGER_32): INTEGER_32
		local
			l_e: CE_ARRAY [CE_POINTER [PD_CACHE_ENTRY]]
			l_c: CE_POINTER [PD_CONNECTION]
			l_u: CE_POINTER [NATURAL_8]
			l_st: CE_POINTER [PD_STATUS]
			l_tmp___4: NATURAL_32
			l_tmp___5: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_CACHE_ENTRY]} l_e.make (<<1>>)

			l_e.item := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
			if (not a_stat___0.is_void) then
				a_stat___0.item.c := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_shared (default_pointer)
				a_stat___0.item.ce := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
				a_stat___0.item.pri := a_pri
			end
			l_c := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast (queue.item.item.next)
			from
			until
				not (not (l_return) and then (not l_c.is_equal (queue.item)))
			loop
				l_st := create {CE_CLASS_POINTER [PD_STATUS]}.make_cast (l_c.item.statuss.next)
				from
				until
					not (not (l_return) and then (not l_st.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
				loop
					if l_st.is_equal (a_stat___0) then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"));
							(create {P_LINKS_STATIC}).errline.item := 550;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("status already assigned to %'%%s%'")), l_c.item.url])
						end
						a_stat___0.item.state := -1_003
						if (not (a_stat___0.item.end2).is_void) then
							(a_stat___0.item.end2).call ([a_stat___0, a_stat___0.item.data])
						end
						Result := 0
						l_return := True
					end
					if not l_return then
						l_st := l_st.item.next
					end
				end
				if not l_return then
					l_c := l_c.item.next
				end
			end
			if not l_return then
				if (not a_stat___0.is_void) then
					a_stat___0.item.state := -1_004
					a_stat___0.item.prev_error := 0
				end
				if a_no_cache <= 1 then
					if not ((create {P_CACHE_STATIC}).find_in_cache (a_url, l_e)).to_boolean then
						if not (l_e.item.item.incomplete).to_boolean then
							if (not a_stat___0.is_void) then
								a_stat___0.item.ce := l_e.item
								a_stat___0.item.state := -1_000
								if (not (a_stat___0.item.end2).is_void) then
									(a_stat___0.item.end2).call ([a_stat___0, a_stat___0.item.data])
								end
							end
							Result := 0
							l_return := True
						end
					end
				end
			end
			if not l_return then
				if not ((create {P_LINKS_STATIC}).casecmp (a_url, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("proxy://")), (8).to_natural_32)).to_boolean then
					if (not a_stat___0.is_void) then
						a_stat___0.item.state := -1_009
						if (not (a_stat___0.item.end2).is_void) then
							(a_stat___0.item.end2).call ([a_stat___0, a_stat___0.item.data])
						end
					end
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_u := get_proxy (a_url)
				if l_u.is_void then
					if (not a_stat___0.is_void) then
						(a_stat___0.item.end2).call ([a_stat___0, a_stat___0.item.data])
					end
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				l_c := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast (queue.item.item.next)
				from
				until
					not (not (l_return) and then (not l_c.is_equal (queue.item)))
				loop
					if not (l_c.item.detached).to_boolean then
						if not (strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_c.item.url), create {CE_INTEGER_8_POINTER}.make_cast (l_u))).to_boolean then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 579, create {CE_VOID_POINTER}.make_cast (l_u))
							if ((create {P_LINKS_STATIC}).getpri (l_c)) > a_pri then
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_c));
								(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_c.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_c.item.prev);
								(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_c.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_c.item.next);
								(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_c))
								l_c.item.pri[a_pri] := (l_c.item.pri[a_pri]) + 1
								l_c.item.add_to_queue;
								(create {P_SELECT_STATIC}).register_bottom_half (check_queue_address, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
							else
								l_c.item.pri[a_pri] := (l_c.item.pri[a_pri]) + 1
							end
							if (not a_stat___0.is_void) then
								a_stat___0.item.prg := create {CE_CLASS_POINTER [PD_REMAINING_INFO]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("prg"))
								a_stat___0.item.c := l_c
								a_stat___0.item.ce := l_c.item.cache
								from
								until
									(l_break)
								loop
									l_break := False;
									(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
									a_stat___0.item.next := (create {CE_CLASS_POINTER [PD_STATUS]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))).item.next
									a_stat___0.item.prev := create {CE_CLASS_POINTER [PD_STATUS]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))));
									(create {CE_CLASS_POINTER [PD_STATUS]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))).item.next := a_stat___0;
									(a_stat___0.item.next).item.prev := a_stat___0;
									(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
									l_break := True
								end
								l_break := False
								l_c.item.setcstate (l_c.item.state)
							end
							check_queue_bugs
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						l_c := l_c.item.next
					end
				end
			end
			if not l_return then
				l_c := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 598, (create {PD_CONNECTION}.make).structure_size.to_natural_32)))
				memset (create {CE_VOID_POINTER}.make_cast (l_c), 0, (create {PD_CONNECTION}.make).structure_size.to_natural_32).do_nothing
				l_tmp___4 := connection_count.item
				connection_count.item := connection_count.item + 1
				l_c.item.count := l_tmp___4
				l_c.item.url := l_u
				l_c.item.running := 0
				l_c.item.prev_error := 0
				if a_no_cache >= 2 then
					l_c.item.from2 := (0).to_integer_32
				elseif (l_e.item).is_void then
					l_c.item.from2 := (0).to_integer_32
				elseif (l_e.item.item.frag.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_e.item.c_pointer + (create {PD_CACHE_ENTRY}.make).offset_of ("frag"))) then
					l_c.item.from2 := (0).to_integer_32
				elseif ((create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast (l_e.item.item.frag.next)).item.offset).to_boolean then
					l_c.item.from2 := (0).to_integer_32
				else
					l_c.item.from2 := (create {CE_CLASS_POINTER [PD_FRAGMENT]}.make_cast (l_e.item.item.frag.next)).item.length
				end
				memset (create {CE_VOID_POINTER}.make_cast ((l_c.item.pri)), 0, ({PLATFORM}.Integer_32_bytes.to_natural_32 * (6).to_natural_32)).do_nothing
				l_c.item.pri[a_pri] := 1
				l_c.item.no_cache := a_no_cache
				l_tmp___5 := -1
				l_c.item.sock2 := l_tmp___5
				l_c.item.sock1 := l_tmp___5
				l_c.item.dnsquery := create {CE_VOID_POINTER}.make_shared (default_pointer)
				l_c.item.info := create {CE_VOID_POINTER}.make_shared (default_pointer)
				l_c.item.buffer := create {CE_VOID_POINTER}.make_shared (default_pointer)
				l_c.item.cache := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
				l_c.item.tries := 0;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
				l_c.item.statuss.next := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))
				l_c.item.statuss.prev := create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))));
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
				l_c.item.est_length := (-1).to_integer_32
				l_c.item.unrestartable := 0
				l_c.item.prg.timer := -1
				l_c.item.timer := -1
				if (not a_stat___0.is_void) then
					a_stat___0.item.prg := create {CE_CLASS_POINTER [PD_REMAINING_INFO]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("prg"))
					a_stat___0.item.c := l_c
					a_stat___0.item.ce := create {CE_CLASS_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer)
					from
					until
						(l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
						a_stat___0.item.next := (create {CE_CLASS_POINTER [PD_STATUS]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))).item.next
						a_stat___0.item.prev := create {CE_CLASS_POINTER [PD_STATUS]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))));
						(create {CE_CLASS_POINTER [PD_STATUS]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))).item.next := a_stat___0;
						(a_stat___0.item.next).item.prev := a_stat___0;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
						l_break := True
					end
					l_break := False
				end
				l_c.item.add_to_queue
				l_c.item.setcstate (0)
				check_queue_bugs;
				(create {P_SELECT_STATIC}).register_bottom_half (check_queue_address, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
				Result := 0
			end
		end

	change_connection (a_oldstat, a_newstat: CE_POINTER [PD_STATUS]; a_newpri: INTEGER_32)
		local
			l_c: CE_POINTER [PD_CONNECTION]
			l_oldpri: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			if a_oldstat.is_void then
				from
				until
					False
				loop
					(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"));
					(create {P_LINKS_STATIC}).errline.item := 639;
					(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("change_connection: oldstat == NULL"))])
				end
				l_return := True
			end
			if not l_return then
				l_oldpri := a_oldstat.item.pri
				if a_oldstat.item.state < 0 then
					if (not a_newstat.is_void) then
						a_newstat.item.ce := a_oldstat.item.ce
						a_newstat.item.state := a_oldstat.item.state
						a_newstat.item.prev_error := a_oldstat.item.prev_error
						if (not (a_newstat.item.end2).is_void) then
							(a_newstat.item.end2).call ([a_newstat, a_newstat.item.data])
						end
					end
					l_return := True
				end
			end
			if not l_return then
				check_queue_bugs
				l_c := a_oldstat.item.c
				l_c.item.pri[l_oldpri] := (l_c.item.pri[l_oldpri]) - 1
				if l_c.item.pri[l_oldpri] < 0 then
					from
					until
						False
					loop
						(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c"));
						(create {P_LINKS_STATIC}).errline.item := 657;
						(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("priority counter underflow"))])
					end
					l_c.item.pri[l_oldpri] := 0
				end
				l_c.item.pri[a_newpri] := (l_c.item.pri[a_newpri]) + 1;
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (a_oldstat));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (a_oldstat.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (a_oldstat.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (a_oldstat.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (a_oldstat.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (a_oldstat))
				a_oldstat.item.state := -1_001
				if (not a_newstat.is_void) then
					a_newstat.item.prg := create {CE_CLASS_POINTER [PD_REMAINING_INFO]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("prg"))
					from
					until
						(l_break)
					loop
						l_break := False;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
						a_newstat.item.next := (create {CE_CLASS_POINTER [PD_STATUS]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))).item.next
						a_newstat.item.prev := create {CE_CLASS_POINTER [PD_STATUS]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))));
						(create {CE_CLASS_POINTER [PD_STATUS]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss"))))).item.next := a_newstat;
						(a_newstat.item.next).item.prev := a_newstat;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (l_c.c_pointer + (create {PD_CONNECTION}.make).offset_of ("statuss")))))
						l_break := True
					end
					l_break := False
					a_newstat.item.state := l_c.item.state
					a_newstat.item.prev_error := l_c.item.prev_error
					a_newstat.item.pri := a_newpri
					a_newstat.item.c := l_c
					a_newstat.item.ce := l_c.item.cache
				end
				if (l_c.item.detached).to_boolean then
					if a_newstat.is_void then
						l_c.item.setcstate (-1_001)
						l_c.item.abort_connection
					end
				end
				sort_queue
				check_queue_bugs;
				(create {P_SELECT_STATIC}).register_bottom_half (check_queue_address, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
			end
		end

	abort_all_connections
		do
			from
			until
				(queue.item.item.next).is_equal (queue.item)
			loop
				(create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast (queue.item.item.next)).item.setcstate (-1_001);
				(create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast (queue.item.item.next)).item.abort_connection
			end
			abort_all_keepalive_connections
		end

	abort_background_connections
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_c: CE_POINTER [PD_CONNECTION]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_i := 0
				when 1 then -- loop condition:
					if (l_return) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						l_c := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast (queue.item)
						l_j := 0
				when 3 then -- loop condition:
						if not (l_j <= l_i) then
							l_pos := -1 + 6 -- skip loop
						end
				when 4 then -- loop body:
						l_c := l_c.item.next
						if l_c.is_equal (queue.item) then
							l_pos := -1 + 7 -- goto brk
						end
				when 5 then
						l_j := l_j + 1
						l_pos := -1 + 3 -- back to loop condition
				when 6 then -- loop done
						if ((create {P_LINKS_STATIC}).getpri (l_c)) >= 5 then
							l_c.item.setcstate (-1_001)
							l_c.item.abort_connection
						else
							l_i := l_i + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- brk:
					abort_all_keepalive_connections
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	is_entry_used (a_e: CE_POINTER [PD_CACHE_ENTRY]): INTEGER_32
		local
			l_c: CE_POINTER [PD_CONNECTION]
			l_return: BOOLEAN
		do
			l_c := create {CE_CLASS_POINTER [PD_CONNECTION]}.make_cast (queue.item.item.next)
			from
			until
				not (not (l_return) and then (not l_c.is_equal (queue.item)))
			loop
				if (l_c.item.cache).is_equal (a_e) then
					Result := 1
					l_return := True
				end
				if not l_return then
					l_c := l_c.item.next
				end
			end
			if not l_return then
				Result := 0
			end
		end

	free_blacklist
		local
			l_a__: CE_POINTER [PD_XLIST_HEAD]
		do
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (blacklist.item))
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (blacklist.item.item.next)
			from
			until
				l_a__.is_equal (blacklist.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (blacklist.item.item.prev)
			from
			until
				l_a__.is_equal (blacklist.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.prev
			end
			from
			until
				(blacklist.item.item.next).is_equal (blacklist.item)
			loop
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (blacklist.item.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("sched.c")), 806, create {CE_VOID_POINTER}.make_cast (l_a__))
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (blacklist.item))
		end

feature {ANY} -- routine addresses

	keepalive_timer_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent keepalive_timer)
		end

	check_queue_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent check_queue)
		end

end
