class
	PD_CODEPAGE_DESC

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} name.make
			create {CE_POINTER_POINTER [NATURAL_8]} aliases.make
			create {CE_CLASS_POINTER [PD_TABLE_ENTRY]} table_dirty_workaround_for_name_clash_with_libraries_on_macos.make
		end

feature {ANY} -- fields

	name: CE_POINTER [NATURAL_8] assign set_name

	aliases: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_aliases

	table_dirty_workaround_for_name_clash_with_libraries_on_macos: CE_POINTER [PD_TABLE_ENTRY] assign set_table_dirty_workaround_for_name_clash_with_libraries_on_macos

feature {ANY} -- field setters

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_aliases (a_aliases: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			aliases := a_aliases
			update_memory_field ("aliases")
		end

	set_table_dirty_workaround_for_name_clash_with_libraries_on_macos (a_table_dirty_workaround_for_name_clash_with_libraries_on_macos: CE_POINTER [PD_TABLE_ENTRY])
		do
			table_dirty_workaround_for_name_clash_with_libraries_on_macos := a_table_dirty_workaround_for_name_clash_with_libraries_on_macos
			update_memory_field ("table_dirty_workaround_for_name_clash_with_libraries_on_macos")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			aliases := a_other.aliases
			table_dirty_workaround_for_name_clash_with_libraries_on_macos := a_other.table_dirty_workaround_for_name_clash_with_libraries_on_macos
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				aliases.is_equal (a_other.aliases) and
				table_dirty_workaround_for_name_clash_with_libraries_on_macos.is_equal (a_other.table_dirty_workaround_for_name_clash_with_libraries_on_macos)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("aliases"),
					create {CE_STRUCTURE_FIELD}.make ("table_dirty_workaround_for_name_clash_with_libraries_on_macos")
				>>)
			init_structure_info
		end

end
