class
	PD_ENTITIES

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} s.make
		end

feature {ANY} -- fields

	s: CE_POINTER [INTEGER_8] assign set_s

	c: INTEGER_32 assign set_c

feature {ANY} -- field setters

	set_s (a_s: CE_POINTER [INTEGER_8])
		do
			s := a_s
			update_memory_field ("s")
		end

	set_c (a_c: INTEGER_32)
		do
			c := a_c
			update_memory_field ("c")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			s := a_other.s
			c := a_other.c
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				s.is_equal (a_other.s) and
				c = a_other.c
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("s"),
					create {CE_STRUCTURE_FIELD}.make ("c")
				>>)
			init_structure_info
		end

end
