class
	PD_FORM

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} action.make
			create {CE_NATURAL_8_POINTER} target.make
			Precursor
		end

feature {ANY} -- fields

	action: CE_POINTER [NATURAL_8] assign set_action

	target: CE_POINTER [NATURAL_8] assign set_target

	method: INTEGER_32 assign set_method

	num: INTEGER_32 assign set_num

feature {ANY} -- field setters

	set_action (a_action: CE_POINTER [NATURAL_8])
		do
			action := a_action
			update_memory_field ("action")
		end

	set_target (a_target: CE_POINTER [NATURAL_8])
		do
			target := a_target
			update_memory_field ("target")
		end

	set_method (a_method: INTEGER_32)
		do
			method := a_method
			update_memory_field ("method")
		end

	set_num (a_num: INTEGER_32)
		do
			num := a_num
			update_memory_field ("num")
		end

feature {ANY} -- public routines

	get_html_form (a_a: CE_POINTER [NATURAL_8])
		require
			not a_a.is_void
		local
			l_al: CE_POINTER [NATURAL_8]
			l_ch: CE_POINTER [NATURAL_8]
			l_ax: CE_POINTER [INTEGER_8]
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_all: CE_POINTER [INTEGER_8]
			l_tmp___2: NATURAL_32
			l_tmp___3: NATURAL_32
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_break: BOOLEAN
		do
			Current.method := 0
			update_class_fields -- Current might have been changed; synchronize
			l_al := (create {P_HTML_STATIC}).get_attr_val (a_a, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("method")))
			update_class_fields -- Current might have been changed; synchronize
			if (not l_al.is_void) then
				l_tmp___1 := strcasecmp (create {CE_INTEGER_8_POINTER}.make_cast (l_al), ce_string ("post"))
				update_class_fields -- Current might have been changed; synchronize
				if not l_tmp___1.to_boolean then
					Current.method := 1
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := (create {P_HTML_STATIC}).get_attr_val (a_a, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("enctype")))
					update_class_fields -- Current might have been changed; synchronize
					l_ax := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___0)
					if (not l_ax.is_void) then
						l_tmp := strcasecmp (l_ax, ce_string ("multipart/form-data"))
						update_class_fields -- Current might have been changed; synchronize
						if not l_tmp.to_boolean then
							Current.method := 2
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 1_113, create {CE_VOID_POINTER}.make_cast (l_ax))
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 1_116, create {CE_VOID_POINTER}.make_cast (l_al))
				update_class_fields -- Current might have been changed; synchronize
			end
			l_al := (create {P_HTML_STATIC}).get_url_val (a_a, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("action")))
			update_class_fields -- Current might have been changed; synchronize
			if (not l_al.is_void) then
				l_all := create {CE_INTEGER_8_POINTER}.make_cast (l_al)
				from
				until
					(l_all[0]).to_integer_32 /= 32
				loop
					l_all := l_all + 1
				end
				from
				until
					(l_break)
				loop
					l_break := False
					if (l_all[0]).to_boolean then
						l_tmp___3 := strlen (l_all)
						update_class_fields -- Current might have been changed; synchronize
						if (l_all[(l_tmp___3 - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 32 then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						l_tmp___2 := strlen (l_all)
						update_class_fields -- Current might have been changed; synchronize
						l_all[(l_tmp___2 - {NATURAL_32} 1).to_integer_32] := (0).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
					end
				end
				l_break := False
				Current.action := (create {P_URL_STATIC}).join_urls ((create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.href_base, create {CE_NATURAL_8_POINTER}.make_cast (l_all))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 1_123, create {CE_VOID_POINTER}.make_cast (l_al))
				update_class_fields -- Current might have been changed; synchronize
			else
				l_tmp___4 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 1_125, (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.href_base)
				update_class_fields -- Current might have been changed; synchronize
				Current.action := l_tmp___4
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___5 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___4), 1)
				update_class_fields -- Current might have been changed; synchronize
				l_ch := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___5)
				if (not l_ch.is_void) then
					l_ch.item := (0).to_natural_8
					update_class_fields -- Current might have been changed; synchronize
				end
				if method = 0 then
					l_tmp___6 := strchr (create {CE_INTEGER_8_POINTER}.make_cast (action), ('?').code)
					update_class_fields -- Current might have been changed; synchronize
					l_ch := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___6)
					if (not l_ch.is_void) then
						l_ch.item := (0).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
					end
				end
			end
			l_al := (create {P_HTML_STATIC}).get_target (a_a)
			update_class_fields -- Current might have been changed; synchronize
			if (not l_al.is_void) then
				Current.target := l_al
				update_class_fields -- Current might have been changed; synchronize
			else
				Current.target := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html.c")), 1_131, (create {CE_CLASS_POINTER [PD_HTML_ELEMENT]}.make_cast ((create {P_HTML_STATIC}).html_stack.item.item.next)).item.attr.target_base)
				update_class_fields -- Current might have been changed; synchronize
			end
			Current.num := a_a.distance (((create {P_LINKS_STATIC}).startf.item))
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			action := a_other.action
			target := a_other.target
			method := a_other.method
			num := a_other.num
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				action.is_equal (a_other.action) and
				target.is_equal (a_other.target) and
				method = a_other.method and
				num = a_other.num
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("action"),
					create {CE_STRUCTURE_FIELD}.make ("target"),
					create {CE_STRUCTURE_FIELD}.make ("method"),
					create {CE_STRUCTURE_FIELD}.make ("num")
				>>)
			init_structure_info
		end

end
