class
	PD_KBDPREFIX

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	rep: INTEGER_32 assign set_rep

	rep_num: INTEGER_32 assign set_rep_num

	prefix2: INTEGER_32 assign set_prefix2

feature {ANY} -- field setters

	set_rep (a_rep: INTEGER_32)
		do
			rep := a_rep
			update_memory_field ("rep")
		end

	set_rep_num (a_rep_num: INTEGER_32)
		do
			rep_num := a_rep_num
			update_memory_field ("rep_num")
		end

	set_prefix2 (a_prefix2: INTEGER_32)
		do
			prefix2 := a_prefix2
			update_memory_field ("prefix2")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			rep := a_other.rep
			rep_num := a_other.rep_num
			prefix2 := a_other.prefix2
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				rep = a_other.rep and
				rep_num = a_other.rep_num and
				prefix2 = a_other.prefix2
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("rep"),
					create {CE_STRUCTURE_FIELD}.make ("rep_num"),
					create {CE_STRUCTURE_FIELD}.make ("prefix2")
				>>)
			init_structure_info
		end

end
