class
	SD_SIGFAULT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} si_addr.make
		end

feature {ANY} -- fields

	si_addr: CE_POINTER [ANY] assign set_si_addr

feature {ANY} -- field setters

	set_si_addr (a_si_addr: CE_POINTER [ANY])
		do
			si_addr := a_si_addr
			update_memory_field ("si_addr")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			si_addr := a_other.si_addr
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				si_addr.is_equal (a_other.si_addr)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("si_addr")
				>>)
			init_structure_info
		end

end
