class
	P_CHARSET_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_CTYPE_STATIC
	S_WCTYPE_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public attributes

	chartab_initialized: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	transchar_buf: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<7>>)
		end

	latin1flags: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8,
					(('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8,
					(('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8,
					(('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8,
					(('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8,
					(('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8,
					(('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8,
					(('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8,
					(('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8,
					(('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8,
					(('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8,
					(('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8,
					(('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					(('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8,
					(('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8,
					(('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8,
					(('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8,
					(('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8,
					(('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, ((' ').code).to_natural_8,
					(('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8,
					(('U').code).to_natural_8, (('U').code).to_natural_8, (('U').code).to_natural_8, (('l').code).to_natural_8,
					(('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8,
					(('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8,
					(('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8,
					(('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8,
					(('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8,
					(('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, ((' ').code).to_natural_8,
					(('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8,
					(('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8, (('l').code).to_natural_8,
					(('%/0/').code).to_natural_8
				>>)
		end

	latin1upper: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, (('!').code).to_natural_8, (('%"').code).to_natural_8, (('#').code).to_natural_8,
					(('$').code).to_natural_8, (('%%').code).to_natural_8, (('&').code).to_natural_8, (('%'').code).to_natural_8,
					(('(').code).to_natural_8, ((')').code).to_natural_8, (('*').code).to_natural_8, (('+').code).to_natural_8,
					((',').code).to_natural_8, (('-').code).to_natural_8, (('.').code).to_natural_8, (('/').code).to_natural_8,
					(('0').code).to_natural_8, (('1').code).to_natural_8, (('2').code).to_natural_8, (('3').code).to_natural_8,
					(('4').code).to_natural_8, (('5').code).to_natural_8, (('6').code).to_natural_8, (('7').code).to_natural_8,
					(('8').code).to_natural_8, (('9').code).to_natural_8, ((':').code).to_natural_8, ((';').code).to_natural_8,
					(('<').code).to_natural_8, (('=').code).to_natural_8, (('>').code).to_natural_8, (('?').code).to_natural_8,
					(('@').code).to_natural_8, (('A').code).to_natural_8, (('B').code).to_natural_8, (('C').code).to_natural_8,
					(('D').code).to_natural_8, (('E').code).to_natural_8, (('F').code).to_natural_8, (('G').code).to_natural_8,
					(('H').code).to_natural_8, (('I').code).to_natural_8, (('J').code).to_natural_8, (('K').code).to_natural_8,
					(('L').code).to_natural_8, (('M').code).to_natural_8, (('N').code).to_natural_8, (('O').code).to_natural_8,
					(('P').code).to_natural_8, (('Q').code).to_natural_8, (('R').code).to_natural_8, (('S').code).to_natural_8,
					(('T').code).to_natural_8, (('U').code).to_natural_8, (('V').code).to_natural_8, (('W').code).to_natural_8,
					(('X').code).to_natural_8, (('Y').code).to_natural_8, (('Z').code).to_natural_8, (('[').code).to_natural_8,
					(('\').code).to_natural_8, ((']').code).to_natural_8, (('^').code).to_natural_8, (('_').code).to_natural_8,
					(('`').code).to_natural_8, (('A').code).to_natural_8, (('B').code).to_natural_8, (('C').code).to_natural_8,
					(('D').code).to_natural_8, (('E').code).to_natural_8, (('F').code).to_natural_8, (('G').code).to_natural_8,
					(('H').code).to_natural_8, (('I').code).to_natural_8, (('J').code).to_natural_8, (('K').code).to_natural_8,
					(('L').code).to_natural_8, (('M').code).to_natural_8, (('N').code).to_natural_8, (('O').code).to_natural_8,
					(('P').code).to_natural_8, (('Q').code).to_natural_8, (('R').code).to_natural_8, (('S').code).to_natural_8,
					(('T').code).to_natural_8, (('U').code).to_natural_8, (('V').code).to_natural_8, (('W').code).to_natural_8,
					(('X').code).to_natural_8, (('Y').code).to_natural_8, (('Z').code).to_natural_8, (('{').code).to_natural_8,
					(('|').code).to_natural_8, (('}').code).to_natural_8, (('~').code).to_natural_8, (('%/127/').code).to_natural_8,
					(('%/128/').code).to_natural_8, (('%/129/').code).to_natural_8, (('%/130/').code).to_natural_8, (('%/131/').code).to_natural_8,
					(('%/132/').code).to_natural_8, (('%/133/').code).to_natural_8, (('%/134/').code).to_natural_8, (('%/135/').code).to_natural_8,
					(('%/136/').code).to_natural_8, (('%/137/').code).to_natural_8, (('%/138/').code).to_natural_8, (('%/139/').code).to_natural_8,
					(('%/140/').code).to_natural_8, (('%/141/').code).to_natural_8, (('%/142/').code).to_natural_8, (('%/143/').code).to_natural_8,
					(('%/144/').code).to_natural_8, (('%/145/').code).to_natural_8, (('%/146/').code).to_natural_8, (('%/147/').code).to_natural_8,
					(('%/148/').code).to_natural_8, (('%/149/').code).to_natural_8, (('%/150/').code).to_natural_8, (('%/151/').code).to_natural_8,
					(('%/152/').code).to_natural_8, (('%/153/').code).to_natural_8, (('%/154/').code).to_natural_8, (('%/155/').code).to_natural_8,
					(('%/156/').code).to_natural_8, (('%/157/').code).to_natural_8, (('%/158/').code).to_natural_8, (('%/159/').code).to_natural_8,
					(('%/160/').code).to_natural_8, (('%/161/').code).to_natural_8, (('%/162/').code).to_natural_8, (('%/163/').code).to_natural_8,
					(('%/164/').code).to_natural_8, (('%/165/').code).to_natural_8, (('%/166/').code).to_natural_8, (('%/167/').code).to_natural_8,
					(('%/168/').code).to_natural_8, (('%/169/').code).to_natural_8, (('%/170/').code).to_natural_8, (('%/171/').code).to_natural_8,
					(('%/172/').code).to_natural_8, (('%/173/').code).to_natural_8, (('%/174/').code).to_natural_8, (('%/175/').code).to_natural_8,
					(('%/176/').code).to_natural_8, (('%/177/').code).to_natural_8, (('%/178/').code).to_natural_8, (('%/179/').code).to_natural_8,
					(('%/180/').code).to_natural_8, (('%/181/').code).to_natural_8, (('%/182/').code).to_natural_8, (('%/183/').code).to_natural_8,
					(('%/184/').code).to_natural_8, (('%/185/').code).to_natural_8, (('%/186/').code).to_natural_8, (('%/187/').code).to_natural_8,
					(('%/188/').code).to_natural_8, (('%/189/').code).to_natural_8, (('%/190/').code).to_natural_8, (('%/191/').code).to_natural_8,
					(('%/192/').code).to_natural_8, (('%/193/').code).to_natural_8, (('%/194/').code).to_natural_8, (('%/195/').code).to_natural_8,
					(('%/196/').code).to_natural_8, (('%/197/').code).to_natural_8, (('%/198/').code).to_natural_8, (('%/199/').code).to_natural_8,
					(('%/200/').code).to_natural_8, (('%/201/').code).to_natural_8, (('%/202/').code).to_natural_8, (('%/203/').code).to_natural_8,
					(('%/204/').code).to_natural_8, (('%/205/').code).to_natural_8, (('%/206/').code).to_natural_8, (('%/207/').code).to_natural_8,
					(('%/208/').code).to_natural_8, (('%/209/').code).to_natural_8, (('%/210/').code).to_natural_8, (('%/211/').code).to_natural_8,
					(('%/212/').code).to_natural_8, (('%/213/').code).to_natural_8, (('%/214/').code).to_natural_8, (('%/215/').code).to_natural_8,
					(('%/216/').code).to_natural_8, (('%/217/').code).to_natural_8, (('%/218/').code).to_natural_8, (('%/219/').code).to_natural_8,
					(('%/220/').code).to_natural_8, (('%/221/').code).to_natural_8, (('%/222/').code).to_natural_8, (('%/223/').code).to_natural_8,
					(('%/192/').code).to_natural_8, (('%/193/').code).to_natural_8, (('%/194/').code).to_natural_8, (('%/195/').code).to_natural_8,
					(('%/196/').code).to_natural_8, (('%/197/').code).to_natural_8, (('%/198/').code).to_natural_8, (('%/199/').code).to_natural_8,
					(('%/200/').code).to_natural_8, (('%/201/').code).to_natural_8, (('%/202/').code).to_natural_8, (('%/203/').code).to_natural_8,
					(('%/204/').code).to_natural_8, (('%/205/').code).to_natural_8, (('%/206/').code).to_natural_8, (('%/207/').code).to_natural_8,
					(('%/208/').code).to_natural_8, (('%/209/').code).to_natural_8, (('%/210/').code).to_natural_8, (('%/211/').code).to_natural_8,
					(('%/212/').code).to_natural_8, (('%/213/').code).to_natural_8, (('%/214/').code).to_natural_8, (('%/247/').code).to_natural_8,
					(('%/216/').code).to_natural_8, (('%/217/').code).to_natural_8, (('%/218/').code).to_natural_8, (('%/219/').code).to_natural_8,
					(('%/220/').code).to_natural_8, (('%/221/').code).to_natural_8, (('%/222/').code).to_natural_8, (('%/255/').code).to_natural_8,
					(('%/0/').code).to_natural_8
				>>)
		end

	latin1lower: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8, ((' ').code).to_natural_8,
					((' ').code).to_natural_8, (('!').code).to_natural_8, (('%"').code).to_natural_8, (('#').code).to_natural_8,
					(('$').code).to_natural_8, (('%%').code).to_natural_8, (('&').code).to_natural_8, (('%'').code).to_natural_8,
					(('(').code).to_natural_8, ((')').code).to_natural_8, (('*').code).to_natural_8, (('+').code).to_natural_8,
					((',').code).to_natural_8, (('-').code).to_natural_8, (('.').code).to_natural_8, (('/').code).to_natural_8,
					(('0').code).to_natural_8, (('1').code).to_natural_8, (('2').code).to_natural_8, (('3').code).to_natural_8,
					(('4').code).to_natural_8, (('5').code).to_natural_8, (('6').code).to_natural_8, (('7').code).to_natural_8,
					(('8').code).to_natural_8, (('9').code).to_natural_8, ((':').code).to_natural_8, ((';').code).to_natural_8,
					(('<').code).to_natural_8, (('=').code).to_natural_8, (('>').code).to_natural_8, (('?').code).to_natural_8,
					(('@').code).to_natural_8, (('a').code).to_natural_8, (('b').code).to_natural_8, (('c').code).to_natural_8,
					(('d').code).to_natural_8, (('e').code).to_natural_8, (('f').code).to_natural_8, (('g').code).to_natural_8,
					(('h').code).to_natural_8, (('i').code).to_natural_8, (('j').code).to_natural_8, (('k').code).to_natural_8,
					(('l').code).to_natural_8, (('m').code).to_natural_8, (('n').code).to_natural_8, (('o').code).to_natural_8,
					(('p').code).to_natural_8, (('q').code).to_natural_8, (('r').code).to_natural_8, (('s').code).to_natural_8,
					(('t').code).to_natural_8, (('u').code).to_natural_8, (('v').code).to_natural_8, (('w').code).to_natural_8,
					(('x').code).to_natural_8, (('y').code).to_natural_8, (('z').code).to_natural_8, (('[').code).to_natural_8,
					(('\').code).to_natural_8, ((']').code).to_natural_8, (('^').code).to_natural_8, (('_').code).to_natural_8,
					(('`').code).to_natural_8, (('a').code).to_natural_8, (('b').code).to_natural_8, (('c').code).to_natural_8,
					(('d').code).to_natural_8, (('e').code).to_natural_8, (('f').code).to_natural_8, (('g').code).to_natural_8,
					(('h').code).to_natural_8, (('i').code).to_natural_8, (('j').code).to_natural_8, (('k').code).to_natural_8,
					(('l').code).to_natural_8, (('m').code).to_natural_8, (('n').code).to_natural_8, (('o').code).to_natural_8,
					(('p').code).to_natural_8, (('q').code).to_natural_8, (('r').code).to_natural_8, (('s').code).to_natural_8,
					(('t').code).to_natural_8, (('u').code).to_natural_8, (('v').code).to_natural_8, (('w').code).to_natural_8,
					(('x').code).to_natural_8, (('y').code).to_natural_8, (('z').code).to_natural_8, (('{').code).to_natural_8,
					(('|').code).to_natural_8, (('}').code).to_natural_8, (('~').code).to_natural_8, (('%/127/').code).to_natural_8,
					(('%/128/').code).to_natural_8, (('%/129/').code).to_natural_8, (('%/130/').code).to_natural_8, (('%/131/').code).to_natural_8,
					(('%/132/').code).to_natural_8, (('%/133/').code).to_natural_8, (('%/134/').code).to_natural_8, (('%/135/').code).to_natural_8,
					(('%/136/').code).to_natural_8, (('%/137/').code).to_natural_8, (('%/138/').code).to_natural_8, (('%/139/').code).to_natural_8,
					(('%/140/').code).to_natural_8, (('%/141/').code).to_natural_8, (('%/142/').code).to_natural_8, (('%/143/').code).to_natural_8,
					(('%/144/').code).to_natural_8, (('%/145/').code).to_natural_8, (('%/146/').code).to_natural_8, (('%/147/').code).to_natural_8,
					(('%/148/').code).to_natural_8, (('%/149/').code).to_natural_8, (('%/150/').code).to_natural_8, (('%/151/').code).to_natural_8,
					(('%/152/').code).to_natural_8, (('%/153/').code).to_natural_8, (('%/154/').code).to_natural_8, (('%/155/').code).to_natural_8,
					(('%/156/').code).to_natural_8, (('%/157/').code).to_natural_8, (('%/158/').code).to_natural_8, (('%/159/').code).to_natural_8,
					(('%/160/').code).to_natural_8, (('%/161/').code).to_natural_8, (('%/162/').code).to_natural_8, (('%/163/').code).to_natural_8,
					(('%/164/').code).to_natural_8, (('%/165/').code).to_natural_8, (('%/166/').code).to_natural_8, (('%/167/').code).to_natural_8,
					(('%/168/').code).to_natural_8, (('%/169/').code).to_natural_8, (('%/170/').code).to_natural_8, (('%/171/').code).to_natural_8,
					(('%/172/').code).to_natural_8, (('%/173/').code).to_natural_8, (('%/174/').code).to_natural_8, (('%/175/').code).to_natural_8,
					(('%/176/').code).to_natural_8, (('%/177/').code).to_natural_8, (('%/178/').code).to_natural_8, (('%/179/').code).to_natural_8,
					(('%/180/').code).to_natural_8, (('%/181/').code).to_natural_8, (('%/182/').code).to_natural_8, (('%/183/').code).to_natural_8,
					(('%/184/').code).to_natural_8, (('%/185/').code).to_natural_8, (('%/186/').code).to_natural_8, (('%/187/').code).to_natural_8,
					(('%/188/').code).to_natural_8, (('%/189/').code).to_natural_8, (('%/190/').code).to_natural_8, (('%/191/').code).to_natural_8,
					(('%/224/').code).to_natural_8, (('%/225/').code).to_natural_8, (('%/226/').code).to_natural_8, (('%/227/').code).to_natural_8,
					(('%/228/').code).to_natural_8, (('%/229/').code).to_natural_8, (('%/230/').code).to_natural_8, (('%/231/').code).to_natural_8,
					(('%/232/').code).to_natural_8, (('%/233/').code).to_natural_8, (('%/234/').code).to_natural_8, (('%/235/').code).to_natural_8,
					(('%/236/').code).to_natural_8, (('%/237/').code).to_natural_8, (('%/238/').code).to_natural_8, (('%/239/').code).to_natural_8,
					(('%/240/').code).to_natural_8, (('%/241/').code).to_natural_8, (('%/242/').code).to_natural_8, (('%/243/').code).to_natural_8,
					(('%/244/').code).to_natural_8, (('%/245/').code).to_natural_8, (('%/246/').code).to_natural_8, (('%/215/').code).to_natural_8,
					(('%/248/').code).to_natural_8, (('%/249/').code).to_natural_8, (('%/250/').code).to_natural_8, (('%/251/').code).to_natural_8,
					(('%/252/').code).to_natural_8, (('%/253/').code).to_natural_8, (('%/254/').code).to_natural_8, (('%/223/').code).to_natural_8,
					(('%/224/').code).to_natural_8, (('%/225/').code).to_natural_8, (('%/226/').code).to_natural_8, (('%/227/').code).to_natural_8,
					(('%/228/').code).to_natural_8, (('%/229/').code).to_natural_8, (('%/230/').code).to_natural_8, (('%/231/').code).to_natural_8,
					(('%/232/').code).to_natural_8, (('%/233/').code).to_natural_8, (('%/234/').code).to_natural_8, (('%/235/').code).to_natural_8,
					(('%/236/').code).to_natural_8, (('%/237/').code).to_natural_8, (('%/238/').code).to_natural_8, (('%/239/').code).to_natural_8,
					(('%/240/').code).to_natural_8, (('%/241/').code).to_natural_8, (('%/242/').code).to_natural_8, (('%/243/').code).to_natural_8,
					(('%/244/').code).to_natural_8, (('%/245/').code).to_natural_8, (('%/246/').code).to_natural_8, (('%/247/').code).to_natural_8,
					(('%/248/').code).to_natural_8, (('%/249/').code).to_natural_8, (('%/250/').code).to_natural_8, (('%/251/').code).to_natural_8,
					(('%/252/').code).to_natural_8, (('%/253/').code).to_natural_8, (('%/254/').code).to_natural_8, (('%/255/').code).to_natural_8,
					(('%/0/').code).to_natural_8
				>>)
		end

feature {ANY} -- public routines

	init_chartab: INTEGER_32
		do
			Result := (((create {P_GLOBALS_STATIC}).curbuf.item).item.buf_init_chartab (1))
		end

	trans_characters (a_buf___6: CE_POINTER [NATURAL_8]; a_bufsize: INTEGER_32)
		require
			not a_buf___6.is_void
		local
			l_buf___6: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_room: INTEGER_32
			l_trs: CE_POINTER [NATURAL_8]
			l_trs_len: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := a_buf___6
					l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6))).to_integer_32
					l_room := a_bufsize - l_len
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_buf___6.item).to_integer_32 /= 0)) then
						l_pos := -1 + 7 -- skip loop
					end
				when 2 then -- loop body:
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_trs_len := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_buf___6])
						if l_trs_len > 1 then
							l_len := l_len - l_trs_len
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						l_trs := transchar_byte ((l_buf___6.item).to_integer_32)
						l_trs_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_trs))).to_integer_32
						if l_trs_len > 1 then
							l_room := l_room - (l_trs_len - 1)
							if l_room <= 0 then
								l_return := True
							end
							if not l_return then
								memmove (create {CE_VOID_POINTER}.make_cast ((l_buf___6 + l_trs_len)), create {CE_VOID_POINTER}.make_cast ((l_buf___6 + 1)), l_len.to_natural_32).do_nothing
							end
						end
						if not l_return then
							memmove (create {CE_VOID_POINTER}.make_cast (l_buf___6), create {CE_VOID_POINTER}.make_cast (l_trs), l_trs_len.to_natural_32).do_nothing
							l_len := l_len - 1
						end
				when 6 then
						if not l_return then
							l_buf___6 := l_buf___6 + l_trs_len
						end
						l_pos := -1 + 1 -- back to loop condition
				when 7 then -- loop done
					if not l_return then
					end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	transstr (a_s: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_res: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_len: INTEGER_32
			l_c: INTEGER_32
			l_hexbuf: CE_ARRAY [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
		do
			create {CE_NATURAL_8_ARRAY} l_hexbuf.make (<<11>>)

			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				l_len := 0
				l_p___0 := a_s
				from
				until
					(l_p___0.item).to_integer_32 = 0
				loop
					l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
					if l_l > 1 then
						l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])
						l_p___0 := l_p___0 + l_l
						if (vim_isprintc (l_c)).to_boolean then
							l_len := l_len + l_l
						else
							transchar_hex (l_hexbuf, l_c)
							l_len := l_len + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_hexbuf))).to_integer_32
						end
					else
						l_tmp___1 := l_p___0
						l_p___0 := l_p___0 + 1
						l_l := byte2cells ((l_tmp___1.item).to_integer_32)
						if l_l > 0 then
							l_len := l_len + l_l
						else
							l_len := l_len + (4)
						end
					end
				end
				l_res := (create {P_MISC2_STATIC}).alloc ((l_len + 1).to_natural_32)
			else
				l_res := (create {P_MISC2_STATIC}).alloc (((vim_strsize (a_s)) + 1).to_natural_32)
			end
			if not l_res.is_void then
				l_res.item := (('%/0/').code).to_natural_8
				l_p___0 := a_s
				from
				until
					(l_p___0.item).to_integer_32 = 0
				loop
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0])
						if l_l > 1 then
							l_c := (create {P_GLOBALS_STATIC}).mb_ptr2char.item.integer_32_item ([l_p___0])
							if (vim_isprintc (l_c)).to_boolean then
								strncat (create {CE_INTEGER_8_POINTER}.make_cast (l_res), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0), l_l.to_natural_32).do_nothing
							else
								transchar_hex (l_res + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_res))).to_integer_32, l_c)
							end
							l_p___0 := l_p___0 + l_l
						else
							l_tmp___5 := l_p___0
							l_p___0 := l_p___0 + 1
							l_tmp___6 := transchar_byte ((l_tmp___5.item).to_integer_32)
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_res), create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___6)).do_nothing
						end
					else
						l_tmp___5 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___6 := transchar_byte ((l_tmp___5.item).to_integer_32)
						strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_res), create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___6)).do_nothing
					end
				end
			end
			Result := l_res
		end

	str_foldcase (a_str___1: CE_POINTER [NATURAL_8]; a_orglen: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]; a_buflen: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_i___0: INTEGER_32
			l_len: INTEGER_32
			l_c: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_ol: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_lc: INTEGER_32
			l_nl: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___10: CE_POINTER [NATURAL_8]
			l_tmp___11: CE_POINTER [NATURAL_8]
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_len := a_orglen
					if a_buf___6.is_void then
						l_ga.item.ga_init2 (1, 10)
						if (l_ga.item.ga_grow (l_len + 1)) = 0 then
							Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							memmove (l_ga.item.ga_data, create {CE_VOID_POINTER}.make_cast (a_str___1), l_len.to_natural_32).do_nothing
							l_ga.item.ga_len := l_len
						end
					else
						if l_len >= a_buflen then
							l_len := a_buflen - 1
						end
						memmove (create {CE_VOID_POINTER}.make_cast (a_buf___6), create {CE_VOID_POINTER}.make_cast (a_str___1), l_len.to_natural_32).do_nothing
					end
					if l_return then
						l_pos := -1 + 22 -- skip if block
					end
				when 1 then -- if:
						if a_buf___6.is_void then
							create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data)[l_len] := (('%/0/').code).to_natural_8
						else
							a_buf___6[l_len] := (('%/0/').code).to_natural_8
						end
						l_i___0 := 0
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 21 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if a_buf___6.is_void then
							l_tmp___16 := (create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data)[l_i___0]).to_integer_32
						else
							l_tmp___16 := (a_buf___6[l_i___0]).to_integer_32
						end
						if l_tmp___16 = 0 then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 20 -- skip if block
						end
				when 4 then -- if:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 9 -- goto _L___0
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 7 then -- else:
						if not (((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean) then
							l_pos := -1 + 19 -- skip if block
						end
				when 8 then -- if:
						if a_buf___6.is_void then
							l_tmp___15 := (create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data)[l_i___0]).to_integer_32
						else
							l_tmp___15 := (a_buf___6[l_i___0]).to_integer_32
						end
						if not (((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[l_tmp___15]).to_integer_32 > 1) then
							l_pos := -1 + 17 -- skip if block
						end
				when 9 then -- if: | _L___0:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 10 then -- if:
						if a_buf___6.is_void then
							l_tmp___0 := create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data) + l_i___0
						else
							l_tmp___0 := a_buf___6 + l_i___0
						end
						l_c := ((create {P_MBYTE_STATIC}).utf_ptr2char (l_tmp___0))
						if a_buf___6.is_void then
							l_tmp___2 := create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data) + l_i___0
						else
							l_tmp___2 := a_buf___6 + l_i___0
						end
						l_ol := ((create {P_MBYTE_STATIC}).utf_ptr2len (l_tmp___2))
						l_lc := ((create {P_MBYTE_STATIC}).utf_tolower (l_c))
						if not (l_c < 128) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 13 then -- else:
						if not (l_ol > 1) then
							l_pos := -1 + 15 -- skip if block
						end
				when 14 then -- if: | _L:
						if l_c /= l_lc then
							l_nl := ((create {P_MBYTE_STATIC}).utf_char2len (l_lc))
							if l_ol /= l_nl then
								if l_nl > l_ol then
									if a_buf___6.is_void then
										l_tmp___7 := ((l_ga.item.ga_grow ((l_nl - l_ol) + 1)) = 0).to_integer
									else
										l_tmp___7 := ((l_len + l_nl) - l_ol >= a_buflen).to_integer
									end
									if l_tmp___7.to_boolean then
										l_lc := l_c
										l_nl := l_ol
									end
								end
								if l_ol /= l_nl then
									if a_buf___6.is_void then
										memmove (create {CE_VOID_POINTER}.make_cast (((create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data) + l_i___0) + l_nl)), create {CE_VOID_POINTER}.make_cast (((create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data) + l_i___0) + l_ol)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data) + l_i___0) + l_ol)))) + {NATURAL_32} 1).do_nothing
										l_ga.item.ga_len := l_ga.item.ga_len + (l_nl - l_ol)
									else
										memmove (create {CE_VOID_POINTER}.make_cast (((a_buf___6 + l_i___0) + l_nl)), create {CE_VOID_POINTER}.make_cast (((a_buf___6 + l_i___0) + l_ol)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((a_buf___6 + l_i___0) + l_ol)))) + {NATURAL_32} 1).do_nothing
										l_len := l_len + (l_nl - l_ol)
									end
								end
							end
							if a_buf___6.is_void then
								l_tmp___10 := create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data) + l_i___0
							else
								l_tmp___10 := a_buf___6 + l_i___0
							end
							(create {P_MBYTE_STATIC}).utf_char2bytes (l_lc, l_tmp___10).do_nothing
						end
				when 15 then -- if done | if done
						if a_buf___6.is_void then
							l_tmp___11 := create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data) + l_i___0
						else
							l_tmp___11 := a_buf___6 + l_i___0
						end
						l_i___0 := l_i___0 + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_tmp___11]))
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						l_pos := -1 + 19 -- goto _L___1
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else: | _L___1:
						if a_buf___6.is_void then
							create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data)[l_i___0] := (tolower ((create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data)[l_i___0]).to_integer_32)).to_natural_8
						else
							a_buf___6[l_i___0] := (tolower ((a_buf___6[l_i___0]).to_integer_32)).to_natural_8
						end
						l_i___0 := l_i___0 + 1
				when 20 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 21 then -- loop done
						l_break := False
						if a_buf___6.is_void then
							Result := (create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data))
							l_return := True
						end
				when 22 then -- if done
					if not l_return then
						Result := a_buf___6
					end
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	transchar (a_c: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_c: INTEGER_32
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					l_i___0 := 0
					if l_c < 0 then
						transchar_buf.item[0] := (('~').code).to_natural_8
						transchar_buf.item[1] := (('@').code).to_natural_8
						l_i___0 := 2
						if l_c = 128 then
							l_c := 254
						else
							if l_c = 0 then
								l_tmp := 255
							else
								l_tmp := (-l_c).bit_and (255)
							end
							l_c := l_tmp
						end
					end
					if chartab_initialized.item.to_boolean then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_c >= 32 then
							if l_c <= 126 then
								transchar_buf.item[l_i___0] := l_c.to_natural_8
								transchar_buf.item[l_i___0 + 1] := (('%/0/').code).to_natural_8
							else
								l_pos := -1 + 3 -- goto _L
							end
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						if l_c < 256 then
							if (vim_isprintc_strict (l_c)).to_boolean then
								transchar_buf.item[l_i___0] := l_c.to_natural_8
								transchar_buf.item[l_i___0 + 1] := (('%/0/').code).to_natural_8
							else
								transchar_nonprint (transchar_buf.item + l_i___0, l_c)
							end
						else
							transchar_nonprint (transchar_buf.item + l_i___0, l_c)
						end
				when 4 then
					Result := transchar_buf.item
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	transchar_byte (a_c: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
				if a_c >= 128 then
					transchar_nonprint (transchar_buf.item, a_c)
					Result := transchar_buf.item
					l_return := True
				end
			end
			if not l_return then
				Result := (transchar (a_c))
			end
		end

	transchar_nonprint (a_buf___6: CE_POINTER [NATURAL_8]; a_c: INTEGER_32)
		local
			l_c: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_c := a_c
					if l_c = 10 then
						l_c := ('%/0/').code
					elseif l_c = 13 then
						if (((create {P_GLOBALS_STATIC}).curbuf.item).item.get_fileformat) = 2 then
							l_c := ('%N').code
						end
					end
					if not ((((create {P_OPTION_STATIC}).dy_flags.item.item).bit_and ({NATURAL_32} 2)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						transchar_hex (a_buf___6, l_c)
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if not (l_c <= 127) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						a_buf___6[0] := (('^').code).to_natural_8
						a_buf___6[1] := ((l_c).bit_xor (64)).to_natural_8
						a_buf___6[2] := (('%/0/').code).to_natural_8
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if not (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_c >= 128 then
							transchar_hex (a_buf___6, l_c)
						else
							l_pos := -1 + 9 -- goto _L
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else: | _L:
						if l_c >= 160 then
							if l_c <= 254 then
								a_buf___6[0] := (('|').code).to_natural_8
								a_buf___6[1] := (l_c - 128).to_natural_8
								a_buf___6[2] := (('%/0/').code).to_natural_8
							else
								a_buf___6[0] := (('~').code).to_natural_8
								a_buf___6[1] := (((l_c - 128)).bit_xor (64)).to_natural_8
								a_buf___6[2] := (('%/0/').code).to_natural_8
							end
						else
							a_buf___6[0] := (('~').code).to_natural_8
							a_buf___6[1] := (((l_c - 128)).bit_xor (64)).to_natural_8
							a_buf___6[2] := (('%/0/').code).to_natural_8
						end
				when 10 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	transchar_hex (a_buf___6: CE_POINTER [NATURAL_8]; a_c: INTEGER_32)
		require
			not a_buf___6.is_void
		local
			l_i___0: INTEGER_32
		do
			l_i___0 := 0
			a_buf___6[0] := (('<').code).to_natural_8
			if a_c > 255 then
				l_i___0 := l_i___0 + 1
				a_buf___6[l_i___0] := (nr2hex ((a_c.to_natural_32).bit_shift_right (12))).to_natural_8
				l_i___0 := l_i___0 + 1
				a_buf___6[l_i___0] := (nr2hex ((a_c.to_natural_32).bit_shift_right (8))).to_natural_8
			end
			l_i___0 := l_i___0 + 1
			a_buf___6[l_i___0] := (nr2hex ((a_c.to_natural_32).bit_shift_right (4))).to_natural_8
			l_i___0 := l_i___0 + 1
			a_buf___6[l_i___0] := (nr2hex (a_c.to_natural_32)).to_natural_8
			l_i___0 := l_i___0 + 1
			a_buf___6[l_i___0] := (('>').code).to_natural_8
			l_i___0 := l_i___0 + 1
			a_buf___6[l_i___0] := (('%/0/').code).to_natural_8
		end

	nr2hex (a_c: NATURAL_32): NATURAL_32
		local
			l_return: BOOLEAN
		do
			if ((a_c).bit_and ({NATURAL_32} 15)) <= {NATURAL_32} 9 then
				Result := (((a_c).bit_and ({NATURAL_32} 15)) + {NATURAL_32} 48)
				l_return := True
			end
			if not l_return then
				Result := ((((a_c).bit_and ({NATURAL_32} 15)) - {NATURAL_32} 10) + {NATURAL_32} 97)
			end
		end

	byte2cells (a_b: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
				if a_b >= 128 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				Result := ((((create {P_GLOBALS_STATIC}).chartab.item[a_b]).to_integer_32).bit_and (7))
			end
		end

	char2cells (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			if a_c < 0 then
				if a_c = 128 then
					l_tmp___0 := 254
				else
					if a_c = 0 then
						l_tmp := 255
					else
						l_tmp := (-a_c).bit_and (255)
					end
					l_tmp___0 := l_tmp
				end
				Result := ((char2cells (l_tmp___0)) + 2)
				l_return := True
			end
			if not l_return and then (a_c >= 128) then
				if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
					Result := ((create {P_MBYTE_STATIC}).utf_char2cells (a_c))
					l_return := True
				end
				if not l_return and then ((create {P_GLOBALS_STATIC}).enc_dbcs.item /= 0) then
					if a_c >= 256 then
						if (create {P_GLOBALS_STATIC}).enc_dbcs.item = 9_932 then
							if (a_c.to_natural_32).bit_shift_right (8) = {NATURAL_32} 142 then
								Result := 1
								l_return := True
							end
						end
						if not l_return then
							Result := 2
							l_return := True
						end
					end
				end
			end
			if not l_return then
				Result := ((((create {P_GLOBALS_STATIC}).chartab.item[(a_c).bit_and (255)]).to_integer_32).bit_and (7))
			end
		end

	ptr2cells (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
				if (a_p___0.item).to_integer_32 >= 128 then
					Result := ((create {P_MBYTE_STATIC}).utf_ptr2cells (a_p___0))
					l_return := True
				end
			end
			if not l_return then
				Result := ((((create {P_GLOBALS_STATIC}).chartab.item[(a_p___0.item).to_integer_32]).to_integer_32).bit_and (7))
			end
		end

	vim_strsize (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (vim_strnsize (a_s, 2_147_483_647))
		end

	vim_strnsize (a_s: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		require
			not a_s.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_size: INTEGER_32
			l_l: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			l_s := a_s
			l_len := a_len
			l_size := 0
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_s.item).to_integer_32 /= 0 then
					l_len := l_len - 1
					if not (l_len >= 0) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_l := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s]))
						l_size := l_size + (ptr2cells (l_s))
						l_s := l_s + l_l
						l_len := l_len - (l_l - 1)
					else
						l_tmp___1 := l_s
						l_s := l_s + 1
						l_size := l_size + (byte2cells ((l_tmp___1.item).to_integer_32))
					end
				end
			end
			l_break := False
			Result := l_size
		end

	chartabsize (a_p___0: CE_POINTER [NATURAL_8]; a_col: INTEGER_32): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_ts: INTEGER_32
			l_tmp: INTEGER_32
		do
			if (a_p___0.item).to_integer_32 = 9 then
				if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list).to_boolean then
					l_ts := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
					Result := (l_ts - a_col \\ l_ts)
				elseif ((create {P_GLOBALS_STATIC}).lcs_tab1.item).to_boolean then
					l_ts := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
					Result := (l_ts - a_col \\ l_ts)
				else
					l_tmp := ptr2cells (a_p___0)
					Result := l_tmp
				end
			else
				l_tmp := ptr2cells (a_p___0)
				Result := l_tmp
			end
		end

	linetabsize (a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := (linetabsize_col (0, a_s))
		end

	linetabsize_col (a_startcol: INTEGER_32; a_s: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_s: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_col: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_s.make (<<1>>)

			l_s.item := a_s
			l_col := a_startcol
			from
			until
				(l_s.item.item).to_integer_32 = 0
			loop
				l_col := l_col + (lbr_chartabsize_adv (l_s, l_col))
			end
			Result := l_col
		end

	win_linetabsize (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_p___0: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_col: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_col := 0
			l_s := a_p___0
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_s.item).to_integer_32 /= 0 then
					if a_len.to_integer_32 /= 2_147_483_647 then
						if not ((l_s.c_pointer.to_integer_32).to_natural_32 < ((a_p___0 + a_len).c_pointer.to_integer_32).to_natural_32) then
							l_break := True
						end
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_col := l_col + (a_wp___0.item.win_lbr_chartabsize (l_s, l_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s]))
					else
						l_tmp___0 := 1
					end
					l_s := l_s + l_tmp___0
				end
			end
			l_break := False
			Result := l_col
		end

	vim_isIDc (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_c > 0 then
				if a_c < 256 then
					if ((((create {P_GLOBALS_STATIC}).chartab.item[a_c]).to_integer_32).bit_and (32)).to_boolean then
						l_tmp := 1
					else
						l_tmp := 0
					end
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	vim_iswordc (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			if a_c >= 256 then
				if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 0 then
					Result := (((create {P_MBYTE_STATIC}).dbcs_class ((a_c.to_natural_32).bit_shift_right (8), ((a_c).bit_and (255)).to_natural_32)) >= 2).to_integer
					l_return := True
				end
				if not l_return and then (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
					Result := (((create {P_MBYTE_STATIC}).utf_class (a_c)) >= 2).to_integer
					l_return := True
				end
			end
			if not l_return then
				if a_c > 0 then
					if a_c < 256 then
						if ((((create {P_GLOBALS_STATIC}).curbuf.item.item.b_chartab[((a_c.to_natural_32).bit_shift_right (3)).to_integer_32]).to_integer_32).bit_and (((1).bit_shift_left (((a_c).bit_and (7)))))) /= 0 then
							l_tmp___1 := 1
						else
							l_tmp___1 := 0
						end
					else
						l_tmp___1 := 0
					end
				else
					l_tmp___1 := 0
				end
				Result := l_tmp___1
			end
		end

	vim_iswordp (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				if ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(a_p___0.item).to_integer_32]).to_integer_32 > 1 then
					Result := (((create {P_MBYTE_STATIC}).mb_get_class (a_p___0)) >= 2).to_integer
					l_return := True
				end
			end
			if not l_return then
				Result := (((((create {P_GLOBALS_STATIC}).curbuf.item.item.b_chartab[(((a_p___0.item).to_natural_32).bit_shift_right (3)).to_integer_32]).to_integer_32).bit_and (((1).bit_shift_left ((((a_p___0.item).to_integer_32).bit_and (7)))))) /= 0).to_integer
			end
		end

	vim_isfilec (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_c >= 256 then
				l_tmp := 1
			elseif a_c > 0 then
				if ((((create {P_GLOBALS_STATIC}).chartab.item[a_c]).to_integer_32).bit_and (64)).to_boolean then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	vim_isprintc (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
				if a_c >= 256 then
					Result := ((create {P_MBYTE_STATIC}).utf_printable (a_c))
					l_return := True
				end
			end
			if not l_return then
				if a_c >= 256 then
					l_tmp___0 := 1
				elseif a_c > 0 then
					if ((((create {P_GLOBALS_STATIC}).chartab.item[a_c]).to_integer_32).bit_and (16)).to_boolean then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
				Result := l_tmp___0
			end
		end

	vim_isprintc_strict (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			if (create {P_GLOBALS_STATIC}).enc_dbcs.item /= 0 then
				if a_c < 256 then
					if ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[a_c]).to_integer_32 > 1 then
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return and then (((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean) then
				if a_c >= 256 then
					Result := ((create {P_MBYTE_STATIC}).utf_printable (a_c))
					l_return := True
				end
			end
			if not l_return then
				if a_c >= 256 then
					l_tmp___0 := 1
				elseif a_c > 0 then
					if ((((create {P_GLOBALS_STATIC}).chartab.item[a_c]).to_integer_32).bit_and (16)).to_boolean then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
				else
					l_tmp___0 := 0
				end
				Result := l_tmp___0
			end
		end

	lbr_chartabsize (a_s: CE_POINTER [NATURAL_8]; a_col: INTEGER_32): INTEGER_32
		local
			l_ts: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_lbr).to_boolean then
				if ((create {P_OPTION_STATIC}).p_sbr.item.item.item).to_integer_32 = 0 then
					if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_wrap).to_boolean then
						Result := (win_nolbr_chartabsize ((create {P_GLOBALS_STATIC}).curwin.item, a_s, a_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
						l_return := True
					end
					if not l_return then
						if (a_s.item).to_integer_32 = 9 then
							if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list).to_boolean then
								l_ts := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
								Result := (l_ts - a_col \\ l_ts)
								l_return := True
							elseif ((create {P_GLOBALS_STATIC}).lcs_tab1.item).to_boolean then
								l_ts := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_ts).to_integer_32
								Result := (l_ts - a_col \\ l_ts)
								l_return := True
							else
								l_tmp___0 := ptr2cells (a_s)
								Result := l_tmp___0
								l_return := True
							end
						else
							l_tmp___0 := ptr2cells (a_s)
							Result := l_tmp___0
							l_return := True
						end
					end
				end
			end
			if not l_return then
				Result := (((create {P_GLOBALS_STATIC}).curwin.item).item.win_lbr_chartabsize (a_s, a_col, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)))
			end
		end

	lbr_chartabsize_adv (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_col: INTEGER_32): INTEGER_32
		require
			not a_s.is_void
		local
			l_retval: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_retval := lbr_chartabsize (a_s.item, a_col)
			if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
				l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([a_s.item]))
			else
				l_tmp___0 := 1
			end
			a_s.item := a_s.item + l_tmp___0
			Result := l_retval
		end

	win_nolbr_chartabsize (a_wp___0: CE_POINTER [PD_WINDOW_S]; a_s: CE_POINTER [NATURAL_8]; a_col: INTEGER_32; a_headp: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_s.is_void
		local
			l_n: INTEGER_32
			l_return: BOOLEAN
		do
			if (a_s.item).to_integer_32 = 9 then
				if not (a_wp___0.item.w_onebuf_opt.wo_list).to_boolean then
					l_n := ((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32
					Result := (l_n - a_col \\ l_n)
					l_return := True
				elseif ((create {P_GLOBALS_STATIC}).lcs_tab1.item).to_boolean then
					l_n := ((a_wp___0.item.w_buffer).item.b_p_ts).to_integer_32
					Result := (l_n - a_col \\ l_n)
					l_return := True
				end
			end
			if not l_return then
				l_n := ptr2cells (a_s)
				if l_n = 2 then
					if ((create {P_GLOBALS_STATIC}).mb_bytelen_tab.item[(a_s.item).to_integer_32]).to_integer_32 > 1 then
						if (a_wp___0.item.in_win_border (a_col)).to_boolean then
							if not a_headp.is_void then
								a_headp.item := 1
							end
							Result := 3
							l_return := True
						end
					end
				end
			end
			if not l_return then
				Result := l_n
			end
		end

	getvcol_nolist (a_posp: CE_POINTER [PD_POS_T]): INTEGER_32
		require
			not a_posp.is_void
		local
			l_list_save: INTEGER_32
			l_vcol: CE_ARRAY [INTEGER_32]
		do
			create {CE_INTEGER_32_ARRAY} l_vcol.make (<<1>>)

			l_list_save := (create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list;
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list := 0;
			((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (a_posp, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_vcol, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer));
			(create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_list := l_list_save
			Result := (l_vcol.item)
		end

	skipwhite (a_q: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_q.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			l_p___0 := a_q
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_p___0.item).to_integer_32 /= 32 then
					if (l_p___0.item).to_integer_32 /= 9 then
						l_break := True
					end
				end
				if not (l_break) then
					l_p___0 := l_p___0 + 1
				end
			end
			l_break := False
			Result := l_p___0
		end

	skipdigits (a_q: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_q.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			l_p___0 := a_q
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_p___0.item).to_integer_32 >= 48 then
					if not ((l_p___0.item).to_integer_32 <= 57) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_p___0 := l_p___0 + 1
				end
			end
			l_break := False
			Result := l_p___0
		end

	vim_isdigit (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
		do
			if a_c >= 48 then
				if a_c <= 57 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	vim_isxdigit (a_c: INTEGER_32): INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_c >= 48) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_c <= 57 then
							l_tmp := 1
						else
							l_pos := -1 + 3 -- goto _L___0
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else: | _L___0:
						if not (a_c >= 97) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_c <= 102 then
							l_tmp := 1
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						if a_c >= 65 then
							if a_c <= 70 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 7 then -- if done
					Result := l_tmp
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	vim_islower (a_c: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_c <= 64 then
				Result := 0
				l_return := True
			end
			if not l_return and then (a_c >= 128) then
				if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
					Result := ((create {P_MBYTE_STATIC}).utf_islower (a_c))
					l_return := True
				end
				if not l_return and then (a_c >= 256) then
					Result := 0
					l_return := True
				end
				if not l_return and then (((create {P_GLOBALS_STATIC}).enc_latin1like.item).to_boolean) then
					Result := ((((latin1flags.item[a_c]).to_integer_32).bit_and (108)) = 108).to_integer
					l_return := True
				end
			end
			if not l_return then
				Result := ((((ctype_b_loc).item[a_c]).to_integer_32).bit_and (512))
			end
		end

	vim_isupper (a_c: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_c <= 64 then
				Result := 0
				l_return := True
			end
			if not l_return and then (a_c >= 128) then
				if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
					Result := ((create {P_MBYTE_STATIC}).utf_isupper (a_c))
					l_return := True
				end
				if not l_return and then (a_c >= 256) then
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						Result := (iswupper (a_c.to_natural_32))
						l_return := True
					end
					if not l_return then
						Result := 0
						l_return := True
					end
				end
				if not l_return and then (((create {P_GLOBALS_STATIC}).enc_latin1like.item).to_boolean) then
					Result := ((((latin1flags.item[a_c]).to_integer_32).bit_and (85)) = 85).to_integer
					l_return := True
				end
			end
			if not l_return then
				Result := ((((ctype_b_loc).item[a_c]).to_integer_32).bit_and (256))
			end
		end

	vim_toupper (a_c: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_c <= 64 then
				Result := a_c
				l_return := True
			end
			if not l_return and then (a_c >= 128) then
				if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
					Result := ((create {P_MBYTE_STATIC}).utf_toupper (a_c))
					l_return := True
				end
				if not l_return and then (a_c >= 256) then
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						Result := (towupper (a_c.to_natural_32)).to_integer_32
						l_return := True
					end
					if not l_return then
						Result := a_c
						l_return := True
					end
				end
				if not l_return and then (((create {P_GLOBALS_STATIC}).enc_latin1like.item).to_boolean) then
					Result := (latin1upper.item[a_c]).to_integer_32
					l_return := True
				end
			end
			if not l_return then
				Result := (toupper (a_c))
			end
		end

	vim_tolower (a_c: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_c <= 64 then
				Result := a_c
				l_return := True
			end
			if not l_return and then (a_c >= 128) then
				if ((create {P_GLOBALS_STATIC}).enc_utf8.item).to_boolean then
					Result := ((create {P_MBYTE_STATIC}).utf_tolower (a_c))
					l_return := True
				end
				if not l_return and then (a_c >= 256) then
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						Result := (towlower (a_c.to_natural_32)).to_integer_32
						l_return := True
					end
					if not l_return then
						Result := a_c
						l_return := True
					end
				end
				if not l_return and then (((create {P_GLOBALS_STATIC}).enc_latin1like.item).to_boolean) then
					Result := (latin1lower.item[a_c]).to_integer_32
					l_return := True
				end
			end
			if not l_return then
				Result := (tolower (a_c))
			end
		end

	skiptowhite (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_p___0.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			l_p___0 := a_p___0
			from
			until
				(l_break)
			loop
				l_break := False
				if (l_p___0.item).to_integer_32 /= 32 then
					if (l_p___0.item).to_integer_32 /= 9 then
						if (l_p___0.item).to_integer_32 = 0 then
							l_break := True
						end
					else
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_p___0 := l_p___0 + 1
				end
			end
			l_break := False
			Result := l_p___0
		end

	skiptowhite_esc (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_p___0.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_p___0
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if (l_p___0.item).to_integer_32 /= 32 then
							if (l_p___0.item).to_integer_32 /= 9 then
								if (l_p___0.item).to_integer_32 = 0 then
									l_break := True
								end
							else
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (l_p___0.item).to_integer_32 /= 22 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if (l_p___0[1]).to_integer_32 /= 0 then
							l_p___0 := l_p___0 + 1
						end
				when 8 then -- if done
						l_p___0 := l_p___0 + 1
				when 9 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					l_break := False
					Result := l_p___0
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getdigits (a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		require
			not a_pp.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_retval: INTEGER_32
		do
			l_p___0 := a_pp.item
			l_retval := atol (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))
			if (l_p___0.item).to_integer_32 = 45 then
				l_p___0 := l_p___0 + 1
			end
			l_p___0 := skipdigits (l_p___0)
			a_pp.item := l_p___0
			Result := l_retval
		end

	vim_isblankline (a_lbuf: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_lbuf.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
		do
			l_p___0 := skipwhite (a_lbuf)
			if (l_p___0.item).to_integer_32 = 0 then
				l_tmp := 1
			elseif (l_p___0.item).to_integer_32 = 13 then
				l_tmp := 1
			elseif (l_p___0.item).to_integer_32 = 10 then
				l_tmp := 1
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	vim_str2nr (a_start___1: CE_POINTER [NATURAL_8]; a_hexp, a_len: CE_POINTER [INTEGER_32]; a_dooct, a_dohex: INTEGER_32; a_nptr: CE_POINTER [INTEGER_32]; a_unptr: CE_POINTER [NATURAL_32])
		require
			not a_start___1.is_void
		local
			l_ptr: CE_POINTER [NATURAL_8]
			l_hex: INTEGER_32
			l_negative: INTEGER_32
			l_un: NATURAL_32
			l_n: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ptr := a_start___1
					l_hex := 0
					l_negative := 0
					l_un := {NATURAL_32} 0
					if (l_ptr[0]).to_integer_32 = 45 then
						l_negative := 1
						l_ptr := l_ptr + 1
					end
					if (l_ptr[0]).to_integer_32 /= 48 then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						if (l_ptr[1]).to_integer_32 = 56 then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						if (l_ptr[1]).to_integer_32 = 57 then
							l_pos := -1 + 13 -- skip if block
						end
				when 3 then -- if:
						l_hex := (l_ptr[1]).to_integer_32
						if not (a_dohex.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if l_hex /= 88 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___1
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 7 then -- else:
						if l_hex /= 120 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L___1:
						if (vim_isxdigit ((l_ptr[2]).to_integer_32)).to_boolean then
							l_ptr := l_ptr + (2)
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___0
				when 11 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						l_hex := 0
						if a_dooct.to_boolean then
							l_n := 1
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_ptr[l_n]).to_integer_32 >= 48 then
									if not ((l_ptr[l_n]).to_integer_32 <= 57) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) and then ((l_ptr[l_n]).to_integer_32 > 55) then
									l_hex := 0
									l_break := True
								end
								if not (l_break) then
									if (l_ptr[l_n]).to_integer_32 > 48 then
										l_hex := ('0').code
									end
									l_n := l_n + 1
								end
							end
							l_break := False
						end
				when 13 then -- if done | if done | if done
					if l_hex /= 48 then
						l_pos := -1 + 16 -- skip if block
					end
				when 14 then -- if:
						l_pos := -1 + 17 -- goto _L___3
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 16 then -- else:
						if not (a_dooct > 1) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if: | _L___3:
						from
						until
							(l_break)
						loop
							l_break := False
							if 48 <= (l_ptr.item).to_integer_32 then
								if not ((l_ptr.item).to_integer_32 <= 55) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_un := {NATURAL_32} 8 * l_un + ((l_ptr.item).to_integer_32 - 48).to_natural_32
								l_ptr := l_ptr + 1
							end
						end
						l_break := False
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 19 then -- else:
						if l_hex = 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 23 -- goto _L___2
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 22 then -- else:
						if not (a_dohex > 1) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if: | _L___2:
						from
						until
							(l_break)
						loop
							l_break := False
							if not (vim_isxdigit ((l_ptr.item).to_integer_32)).to_boolean then
								l_break := True
							end
							if not (l_break) then
								l_un := {NATURAL_32} 16 * l_un + (hex2nr ((l_ptr.item).to_integer_32)).to_natural_32
								l_ptr := l_ptr + 1
							end
						end
						l_break := False
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_ptr.item).to_integer_32 >= 48 then
								if not ((l_ptr.item).to_integer_32 <= 57) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_un := {NATURAL_32} 10 * l_un + ((l_ptr.item).to_integer_32 - 48).to_natural_32
								l_ptr := l_ptr + 1
							end
						end
						l_break := False
				when 26 then -- if done | if done | if done
					if not a_hexp.is_void then
						a_hexp.item := l_hex
					end
					if not a_len.is_void then
						a_len.item := l_ptr.distance (a_start___1)
					end
					if not a_nptr.is_void then
						if l_negative.to_boolean then
							a_nptr.item := -l_un.to_integer_32
						else
							a_nptr.item := l_un.to_integer_32
						end
					end
					if not a_unptr.is_void then
						a_unptr.item := l_un
					end
				when 27 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	hex2nr (a_c: INTEGER_32): INTEGER_32
		local
			l_return: BOOLEAN
		do
			if a_c >= 97 then
				if a_c <= 102 then
					Result := ((a_c - 97) + 10)
					l_return := True
				end
			end
			if not l_return and then (a_c >= 65) then
				if a_c <= 70 then
					Result := ((a_c - 65) + 10)
					l_return := True
				end
			end
			if not l_return then
				Result := (a_c - 48)
			end
		end

	hexhex2nr (a_p___0: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_p___0.is_void
		local
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			if (vim_isxdigit ((a_p___0[0]).to_integer_32)).to_boolean then
				if not (vim_isxdigit ((a_p___0[1]).to_integer_32)).to_boolean then
					Result := (-1)
					l_return := True
				end
			else
				Result := (-1)
				l_return := True
			end
			if not l_return then
				l_tmp___1 := hex2nr ((a_p___0[0]).to_integer_32)
				Result := (((l_tmp___1).bit_shift_left (4)) + (hex2nr ((a_p___0[1]).to_integer_32)))
			end
		end

	rem_backslash (a_str___1: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_str___1.is_void
		local
			l_tmp: INTEGER_32
		do
			if (a_str___1[0]).to_integer_32 = 92 then
				if (a_str___1[1]).to_integer_32 /= 0 then
					l_tmp := 1
				else
					l_tmp := 0
				end
			else
				l_tmp := 0
			end
			Result := l_tmp
		end

	backslash_halve (a_p___0: CE_POINTER [NATURAL_8])
		require
			not a_p___0.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
		do
			l_p___0 := a_p___0
			from
			until
				not ((l_p___0.item).to_boolean)
			loop
				if (rem_backslash (l_p___0)).to_boolean then
					memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + 1)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
				end
				l_p___0 := l_p___0 + 1
			end
		end

	backslash_halve_save (a_p___0: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_res: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_res := (create {P_MISC2_STATIC}).vim_strsave (a_p___0)
			if l_res.is_void then
				Result := a_p___0
				l_return := True
			end
			if not l_return then
				backslash_halve (l_res)
				Result := l_res
			end
		end

end
