class
	P_MENU_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_CTYPE_STATIC

feature {ANY} -- public attributes

	menu_mode_chars: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('n').code).to_natural_8, (('v').code).to_natural_8, (('s').code).to_natural_8, (('o').code).to_natural_8,
					(('i').code).to_natural_8, (('c').code).to_natural_8, (('t').code).to_natural_8
				>>)
		end

	e_notsubmenu: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(('E').code).to_natural_8, (('3').code).to_natural_8, (('2').code).to_natural_8, (('7').code).to_natural_8,
					((':').code).to_natural_8, ((' ').code).to_natural_8, (('P').code).to_natural_8, (('a').code).to_natural_8,
					(('r').code).to_natural_8, (('t').code).to_natural_8, ((' ').code).to_natural_8, (('o').code).to_natural_8,
					(('f').code).to_natural_8, ((' ').code).to_natural_8, (('m').code).to_natural_8, (('e').code).to_natural_8,
					(('n').code).to_natural_8, (('u').code).to_natural_8, (('-').code).to_natural_8, (('i').code).to_natural_8,
					(('t').code).to_natural_8, (('e').code).to_natural_8, (('m').code).to_natural_8, ((' ').code).to_natural_8,
					(('p').code).to_natural_8, (('a').code).to_natural_8, (('t').code).to_natural_8, (('h').code).to_natural_8,
					((' ').code).to_natural_8, (('i').code).to_natural_8, (('s').code).to_natural_8, ((' ').code).to_natural_8,
					(('n').code).to_natural_8, (('o').code).to_natural_8, (('t').code).to_natural_8, ((' ').code).to_natural_8,
					(('s').code).to_natural_8, (('u').code).to_natural_8, (('b').code).to_natural_8, (('-').code).to_natural_8,
					(('m').code).to_natural_8, (('e').code).to_natural_8, (('n').code).to_natural_8, (('u').code).to_natural_8,
					(('%/0/').code).to_natural_8
				>>)
		end

	expand_menu: CE_STATIC [CE_POINTER [PD_VIMMENU]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_VIMMENU]}.make_shared (default_pointer)
		end

	expand_modes: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	expand_emenu: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	menu: CE_STATIC [CE_POINTER [PD_VIMMENU]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_VIMMENU]}.make_shared (default_pointer)
		end

	should_advance: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	menu___0: CE_STATIC [CE_POINTER [PD_VIMMENU]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_VIMMENU]}.make_shared (default_pointer)
		end

	tbuffer: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<256>>)
		end

	should_advance___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	prev_mode: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := -1
		end

	menutrans_ga: CE_STATIC [CE_ARRAY [PD_GROWARRAY]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GROWARRAY]}.make_initialized (<<
					create {PD_GROWARRAY}.make_initialized ([0, 0, 0, 0, create {CE_VOID_POINTER}.make_shared (default_pointer)])
				>>)
		end

feature {ANY} -- public routines

	free_menu (a_menup: CE_POINTER [CE_POINTER [PD_VIMMENU]])
		require
			not a_menup.is_void
		local
			l_i___0: INTEGER_32
			l_menu___1: CE_POINTER [PD_VIMMENU]
		do
			l_menu___1 := a_menup.item
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				l_menu___1.item.gui_mch_destroy_menu
			end
			a_menup.item := l_menu___1.item.next;
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_menu___1.item.name));
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_menu___1.item.dname));
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_menu___1.item.en_name));
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_menu___1.item.en_dname));
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_menu___1.item.actext));
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_menu___1.item.iconfile))
			l_i___0 := 0
			from
			until
				not (l_i___0 < 7)
			loop
				l_menu___1.item.free_menu_string (l_i___0)
				l_i___0 := l_i___0 + 1
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_menu___1));
			(create {P_GLOBALS_STATIC}).force_menu_update.item := 1
		end

	get_menu_name (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			if a_idx = 0 then
				menu.item := expand_menu.item
				should_advance.item := 0
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if not menu.item.is_void then
					if not (menu_is_hidden (menu.item.item.dname)).to_boolean then
						if not (menu_is_separator (menu.item.item.dname)).to_boolean then
							if not (menu_is_tearoff (menu.item.item.dname)).to_boolean then
								if not ((menu.item.item.children).is_void) then
									l_break := True
								end
							end
						end
					end
				else
					l_break := True
				end
				if not (l_break) then
					menu.item := menu.item.item.next
				end
			end
			l_break := False
			if menu.item.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if ((menu.item.item.modes).bit_and (expand_modes.item)).to_boolean then
					if should_advance.item.to_boolean then
						l_str___1 := menu.item.item.en_dname
					else
						l_str___1 := menu.item.item.dname
						if (menu.item.item.en_dname).is_void then
							should_advance.item := 1
						end
					end
				else
					l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
				end
				if should_advance.item.to_boolean then
					menu.item := menu.item.item.next
				end
				should_advance.item := (not should_advance.item.to_boolean).to_integer
				Result := l_str___1
			end
		end

	get_menu_names (a_xp: CE_POINTER [PD_EXPAND]; a_idx: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_idx = 0 then
						menu___0.item := expand_menu.item
						should_advance___0.item := 0
					end
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 11 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if menu___0.item.is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						if (menu_is_hidden (menu___0.item.item.dname)).to_boolean then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if not (expand_emenu.item.to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if not (menu_is_separator (menu___0.item.item.dname)).to_boolean then
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						if not (menu_is_tearoff (menu___0.item.item.dname)).to_boolean then
							l_break := True
						end
				when 8 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_break := True
				when 10 then
						if not (l_break) then
							menu___0.item := menu___0.item.item.next
						end
						l_pos := -1 + 1 -- back to loop condition
				when 11 then -- loop done
					l_break := False
					if menu___0.item.is_void then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						if ((menu___0.item.item.modes).bit_and (expand_modes.item)).to_boolean then
							if not (menu___0.item.item.children).is_void then
								if should_advance___0.item.to_boolean then
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast (tbuffer.item), create {CE_INTEGER_8_POINTER}.make_cast (menu___0.item.item.en_dname)).do_nothing
								else
									strcpy (create {CE_INTEGER_8_POINTER}.make_cast (tbuffer.item), create {CE_INTEGER_8_POINTER}.make_cast (menu___0.item.item.dname)).do_nothing
									if (menu___0.item.item.en_dname).is_void then
										should_advance___0.item := 1
									end
								end
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (tbuffer.item), ce_string ("%/1/")).do_nothing
								l_str___1 := tbuffer.item
							elseif should_advance___0.item.to_boolean then
								l_str___1 := menu___0.item.item.en_dname
							else
								l_str___1 := menu___0.item.item.dname
								if (menu___0.item.item.en_dname).is_void then
									should_advance___0.item := 1
								end
							end
						else
							l_str___1 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						end
						if should_advance___0.item.to_boolean then
							menu___0.item := menu___0.item.item.next
						end
						should_advance___0.item := (not should_advance___0.item.to_boolean).to_integer
						Result := l_str___1
					end
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_name_skip (a_name___1: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_name___1.is_void
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p___0 := a_name___1
				when 1 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if (l_p___0.item).to_boolean then
							if (l_p___0.item).to_integer_32 = 46 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if (l_p___0.item).to_integer_32 /= 92 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if (l_p___0.item).to_integer_32 /= 22 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + 1)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
						if (l_p___0.item).to_integer_32 = 0 then
							l_break := True
						end
				when 8 then -- if done | if done
						if not (l_break) then
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0]))
							else
								l_tmp___0 := 1
							end
							l_p___0 := l_p___0 + l_tmp___0
						end
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					l_break := False
					if (l_p___0.item).to_boolean then
						l_tmp___2 := l_p___0
						l_p___0 := l_p___0 + 1
						l_tmp___2.item := (('%/0/').code).to_natural_8
					end
					Result := l_p___0
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_menu_cmd_modes (a_cmd: CE_POINTER [NATURAL_8]; a_forceit: INTEGER_32; a_noremap, a_unmenu: CE_POINTER [INTEGER_32]): INTEGER_32
		require
			not a_cmd.is_void
		local
			l_cmd: CE_POINTER [NATURAL_8]
			l_modes: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_cmd := a_cmd
					l_tmp := l_cmd
					l_cmd := l_cmd + 1
					inspect (l_tmp.item).to_integer_32 -- switch 1 head
					when 118 then l_pos := -1 + 1
					when 120 then l_pos := -1 + 2
					when 115 then l_pos := -1 + 3
					when 111 then l_pos := -1 + 4
					when 105 then l_pos := -1 + 5
					when 116 then l_pos := -1 + 6
					when 99 then l_pos := -1 + 7
					when 97 then l_pos := -1 + 8
					when 110 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 1 then -- switch 1, case 118
					l_modes := (((1).bit_shift_left (1))).bit_or (((1).bit_shift_left (2)))
					l_pos := -1 + 11 -- switch 1; break
				when 2 then -- switch 1, case 120
					l_modes := (1).bit_shift_left (1)
					l_pos := -1 + 11 -- switch 1; break
				when 3 then -- switch 1, case 115
					l_modes := (1).bit_shift_left (2)
					l_pos := -1 + 11 -- switch 1; break
				when 4 then -- switch 1, case 111
					l_modes := (1).bit_shift_left (3)
					l_pos := -1 + 11 -- switch 1; break
				when 5 then -- switch 1, case 105
					l_modes := (1).bit_shift_left (4)
					l_pos := -1 + 11 -- switch 1; break
				when 6 then -- switch 1, case 116
					l_modes := (1).bit_shift_left (6)
					l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 99
					l_modes := (1).bit_shift_left (5)
					l_pos := -1 + 11 -- switch 1; break
				when 8 then -- switch 1, case 97
					l_modes := (((((((((((1).bit_shift_left (4))).bit_or (((1).bit_shift_left (5))))).bit_or (1))).bit_or (((1).bit_shift_left (1))))).bit_or (((1).bit_shift_left (2))))).bit_or (((1).bit_shift_left (3)))
					l_pos := -1 + 11 -- switch 1; break
				when 9 then -- switch 1, case 110
					if (l_cmd.item).to_integer_32 /= 111 then
						l_modes := 1
						l_pos := -1 + 11 -- switch 1; break
					end
				when 10 then -- switch 1, default:
					l_cmd := l_cmd - 1
					if a_forceit.to_boolean then
						l_modes := (((1).bit_shift_left (4))).bit_or (((1).bit_shift_left (5)))
					else
						l_modes := (((((1).bit_or (((1).bit_shift_left (1))))).bit_or (((1).bit_shift_left (2))))).bit_or (((1).bit_shift_left (3)))
					end
				when 11 then -- switch 1, done:
					if not a_noremap.is_void then
						if (l_cmd.item).to_integer_32 = 110 then
							a_noremap.item := -1
						else
							a_noremap.item := 0
						end
					end
					if not a_unmenu.is_void then
						a_unmenu.item := ((l_cmd.item).to_integer_32 = 117).to_integer
					end
					Result := l_modes
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_menu_index (a_menu___1: CE_POINTER [PD_VIMMENU]; a_state: INTEGER_32): INTEGER_32
		local
			l_idx: INTEGER_32
		do
			if ((a_state).bit_and (16)).to_boolean then
				l_idx := 4
			elseif ((a_state).bit_and (8)).to_boolean then
				l_idx := 5
			elseif ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
				if ((create {P_GLOBALS_STATIC}).VIsual_select.item).to_boolean then
					l_idx := 2
				else
					l_idx := 1
				end
			elseif a_state = 513 then
				l_idx := 5
			elseif a_state = 768 then
				l_idx := 5
			elseif ((create {P_GLOBALS_STATIC}).finish_op.item).to_boolean then
				l_idx := 3
			elseif ((a_state).bit_and (1)).to_boolean then
				l_idx := 0
			else
				l_idx := -1
			end
			if l_idx /= -1 then
				if (a_menu___1.item.strings[l_idx]).is_void then
					l_idx := -1
				end
			end
			Result := l_idx
		end

	menu_text (a_str___1: CE_POINTER [NATURAL_8]; a_mnemonic: CE_POINTER [INTEGER_32]; a_actext: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_text: CE_POINTER [NATURAL_8]
			l_break: BOOLEAN
		do
			l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (a_str___1, ('%T').code)
			if not l_p___0.is_void then
				if not a_actext.is_void then
					a_actext.item := (create {P_MISC2_STATIC}).vim_strsave (l_p___0 + 1)
				end
				l_text := (create {P_MISC2_STATIC}).vim_strnsave (a_str___1, l_p___0.distance (a_str___1))
			else
				l_text := (create {P_MISC2_STATIC}).vim_strsave (a_str___1)
			end
			l_p___0 := l_text
			from
			until
				not (not (l_break) and then (not l_p___0.is_void))
			loop
				l_break := False
				l_p___0 := (create {P_MISC2_STATIC}).vim_strchr (l_p___0, ('&').code)
				if not l_p___0.is_void then
					if (l_p___0[1]).to_integer_32 = 0 then
						l_break := True
					end
					if not (l_break) then
						if not a_mnemonic.is_void then
							if (l_p___0[1]).to_integer_32 /= 38 then
								a_mnemonic.item := (l_p___0[1]).to_integer_32
							end
						end
						memmove (create {CE_VOID_POINTER}.make_cast (l_p___0), create {CE_VOID_POINTER}.make_cast ((l_p___0 + 1)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_p___0 + 1)))) + {NATURAL_32} 1).do_nothing
						l_p___0 := l_p___0 + 1
					end
				end
			end
			l_break := False
			Result := l_text
		end

	menu_is_popup (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := ((strncmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("PopUp"), (5).to_natural_32)) = 0).to_integer
		end

	menu_is_toolbar (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := ((strncmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("ToolBar"), (7).to_natural_32)) = 0).to_integer
		end

	menu_is_separator (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_name___1.is_void
		local
			l_tmp___0: INTEGER_32
		do
			if (a_name___1[0]).to_integer_32 = 45 then
				if (a_name___1[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 = 45 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	menu_is_hidden (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_name___1.is_void
		local
			l_tmp___0: INTEGER_32
		do
			if (a_name___1[0]).to_integer_32 = 93 then
				l_tmp___0 := 1
			elseif (menu_is_popup (a_name___1)).to_boolean then
				if (a_name___1[5]).to_integer_32 /= 0 then
					l_tmp___0 := 1
				else
					l_tmp___0 := 0
				end
			else
				l_tmp___0 := 0
			end
			Result := l_tmp___0
		end

	menu_is_tearoff (a_name___1: CE_POINTER [NATURAL_8]): INTEGER_32
		do
			Result := ((strcmp (create {CE_INTEGER_8_POINTER}.make_cast (a_name___1), ce_string ("-->Detach"))) = 0).to_integer
		end

	get_menu_mode: INTEGER_32
		local
			l_return: BOOLEAN
		do
			if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
				if ((create {P_GLOBALS_STATIC}).VIsual_select.item).to_boolean then
					Result := 2
					l_return := True
				end
				if not l_return then
					Result := 1
					l_return := True
				end
			end
			if not l_return and then ((((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean) then
				Result := 4
				l_return := True
			end
			if not l_return then
				if (((create {P_GLOBALS_STATIC}).State.item).bit_and (8)).to_boolean then
					Result := 5
					l_return := True
				elseif (create {P_GLOBALS_STATIC}).State.item = 768 then
					Result := 5
					l_return := True
				elseif (create {P_GLOBALS_STATIC}).State.item = 513 then
					Result := 5
					l_return := True
				end
			end
			if not l_return and then (((create {P_GLOBALS_STATIC}).finish_op.item).to_boolean) then
				Result := 3
				l_return := True
			end
			if not l_return and then ((((create {P_GLOBALS_STATIC}).State.item).bit_and (1)).to_boolean) then
				Result := 0
				l_return := True
			end
			if not l_return and then ((((create {P_GLOBALS_STATIC}).State.item).bit_and (32)).to_boolean) then
				Result := 4
				l_return := True
			end
			if not l_return then
				Result := (-1)
			end
		end

	check_menu_pointer (a_root, a_menu_to_check: CE_POINTER [PD_VIMMENU]): INTEGER_32
		local
			l_p___0: CE_POINTER [PD_VIMMENU]
			l_return: BOOLEAN
		do
			l_p___0 := a_root
			from
			until
				not (not (l_return) and then (not l_p___0.is_void))
			loop
				if l_p___0.is_equal (a_menu_to_check) then
					Result := 1
					l_return := True
				elseif not (l_p___0.item.children).is_void then
					if (check_menu_pointer (l_p___0.item.children, a_menu_to_check)) = 1 then
						Result := 1
						l_return := True
					end
				end
				if not l_return then
					l_p___0 := l_p___0.item.next
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gui_create_initial_menus (a_menu___1: CE_POINTER [PD_VIMMENU])
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_idx: INTEGER_32
		do
			l_menu___1 := a_menu___1
			l_idx := 0
			from
			until
				l_menu___1.is_void
			loop
				if ((l_menu___1.item.modes).bit_and ((((1).bit_shift_left (6)) - 1))).to_boolean then
					if not (l_menu___1.item.children).is_void then
						l_menu___1.item.gui_mch_add_menu (l_idx)
						gui_create_initial_menus (l_menu___1.item.children)
					else
						l_menu___1.item.gui_mch_add_menu_item (l_idx)
					end
				end
				l_menu___1 := l_menu___1.item.next
				l_idx := l_idx + 1
			end
		end

	gui_update_menus_recurse (a_menu___1: CE_POINTER [PD_VIMMENU]; a_mode: INTEGER_32)
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_grey: INTEGER_32
		do
			l_menu___1 := a_menu___1
			from
			until
				l_menu___1.is_void
			loop
				if ((((l_menu___1.item.modes).bit_and (l_menu___1.item.enabled))).bit_and (a_mode)).to_boolean then
					l_grey := 0
				else
					l_grey := 1
				end
				if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_go.item.item, ('g').code)).is_void then
					l_menu___1.item.gui_mch_menu_grey (l_grey)
				elseif (l_menu___1.item.parent).is_void then
					l_menu___1.item.gui_mch_menu_grey (l_grey)
				elseif (menu_is_toolbar ((l_menu___1.item.parent).item.name)).to_boolean then
					l_menu___1.item.gui_mch_menu_grey (l_grey)
				else
					l_menu___1.item.gui_mch_menu_hidden (l_grey)
				end
				gui_update_menus_recurse (l_menu___1.item.children, a_mode)
				l_menu___1 := l_menu___1.item.next
			end
		end

	gui_update_menus (a_modes: INTEGER_32)
		local
			l_mode: INTEGER_32
		do
			l_mode := 0
			if a_modes /= 0 then
				l_mode := a_modes
			else
				l_mode := get_menu_mode
				if l_mode = -1 then
					l_mode := 0
				else
					l_mode := (1).bit_shift_left (l_mode)
				end
			end
			if ((create {P_GLOBALS_STATIC}).force_menu_update.item).to_boolean then
				gui_update_menus_recurse ((create {P_GLOBALS_STATIC}).root_menu.item.item, l_mode);
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_draw_menubar
				prev_mode.item := l_mode;
				(create {P_GLOBALS_STATIC}).force_menu_update.item := 0
			elseif l_mode /= prev_mode.item then
				gui_update_menus_recurse ((create {P_GLOBALS_STATIC}).root_menu.item.item, l_mode);
				(create {P_GUI_GTK_X11_STATIC}).gui_mch_draw_menubar
				prev_mode.item := l_mode;
				(create {P_GLOBALS_STATIC}).force_menu_update.item := 0
			end
		end

	gui_is_menu_shortcut (a_key: INTEGER_32): INTEGER_32
		local
			l_key: INTEGER_32
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_return: BOOLEAN
		do
			l_key := a_key
			if l_key < 256 then
				l_key := tolower (l_key)
			end
			l_menu___1 := (create {P_GLOBALS_STATIC}).root_menu.item.item
			from
			until
				not (not (l_return) and then (not l_menu___1.is_void))
			loop
				if l_menu___1.item.mnemonic = l_key then
					Result := 1
					l_return := True
				elseif l_menu___1.item.mnemonic < 256 then
					if (tolower (l_menu___1.item.mnemonic)) = l_key then
						Result := 1
						l_return := True
					end
				end
				if not l_return then
					l_menu___1 := l_menu___1.item.next
				end
			end
			if not l_return then
				Result := 0
			end
		end

	gui_show_popupmenu
		local
			l_menu___1: CE_POINTER [PD_VIMMENU]
			l_mode: INTEGER_32
			l_ename: CE_ARRAY [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_8_ARRAY} l_ename.make (<<2>>)

			l_mode := get_menu_mode
			if l_mode = -1 then
				l_return := True
			end
			if not l_return then
				l_mode := (menu_mode_chars.item[l_mode]).to_integer_32
				l_ename[0] := l_mode.to_natural_8
				l_ename[1] := (('%/0/').code).to_natural_8;
				(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_MENUPOPUP, l_ename, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
				l_menu___1 := (create {P_GLOBALS_STATIC}).root_menu.item.item
				from
				until
					not (not (l_break) and then (not l_menu___1.is_void))
				loop
					l_break := False
					if (strncmp (ce_string ("PopUp"), create {CE_INTEGER_8_POINTER}.make_cast (l_menu___1.item.name), (5).to_natural_32)) = 0 then
						if (l_menu___1.item.name[5]).to_integer_32 = l_mode then
							l_break := True
						end
					end
					if not (l_break) then
						l_menu___1 := l_menu___1.item.next
					end
				end
				l_break := False
				if not l_menu___1.is_void then
					if not (l_menu___1.item.children).is_void then
						l_menu___1.item.gui_mch_show_popupmenu
					end
				end
			end
		end

feature {ANY} -- routine addresses

	get_menu_name_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent get_menu_name)
		end

	get_menu_names_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent get_menu_names)
		end

end
