class
	P_NORMAL_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC
	S_LIBINTL_STATIC
	S_STDIO_STATIC

feature {ANY} -- public attributes

	restart_VIsual_select: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	e_noident: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("E349: No identifier under cursor")
		end

	nv_cmds: CE_STATIC [CE_ARRAY [PD_NV_CMD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_NV_CMD]}.make_initialized (<<
					create {PD_NV_CMD}.make_initialized ([('%/0/').code, (create {PD_CMDARG_S_STATIC}).nv_error_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([1, (create {PD_CMDARG_S_STATIC}).nv_addsub_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([2, (create {PD_CMDARG_S_STATIC}).nv_page_address, (64).to_natural_16, (-1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([3, (create {PD_CMDARG_S_STATIC}).nv_esc_address, (0).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([4, (create {PD_CMDARG_S_STATIC}).nv_halfpage_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([5, (create {PD_CMDARG_S_STATIC}).nv_scroll_line_address, (0).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([6, (create {PD_CMDARG_S_STATIC}).nv_page_address, (64).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([7, nv_ctrlg_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([8, nv_ctrlh_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([9, (create {PD_CMDARG_S_STATIC}).nv_pcmark_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('%N').code, (create {PD_CMDARG_S_STATIC}).nv_down_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([11, (create {PD_CMDARG_S_STATIC}).nv_error_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([12, (create {PD_CMDARG_S_STATIC}).nv_clear_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([13, (create {PD_CMDARG_S_STATIC}).nv_down_address, (0).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([14, (create {PD_CMDARG_S_STATIC}).nv_down_address, (64).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([15, nv_ctrlo_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([16, (create {PD_CMDARG_S_STATIC}).nv_up_address, (64).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([17, (create {PD_CMDARG_S_STATIC}).nv_visual_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([18, (create {PD_CMDARG_S_STATIC}).nv_redo_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([19, (create {PD_CMDARG_S_STATIC}).nv_ignore_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([20, (create {PD_CMDARG_S_STATIC}).nv_tagpop_address, (512).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([21, (create {PD_CMDARG_S_STATIC}).nv_halfpage_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([22, (create {PD_CMDARG_S_STATIC}).nv_visual_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('V').code, (create {PD_CMDARG_S_STATIC}).nv_visual_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('v').code, (create {PD_CMDARG_S_STATIC}).nv_visual_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([23, (create {PD_CMDARG_S_STATIC}).nv_window_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([24, (create {PD_CMDARG_S_STATIC}).nv_addsub_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([25, (create {PD_CMDARG_S_STATIC}).nv_scroll_line_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([26, (create {PD_CMDARG_S_STATIC}).nv_suspend_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('%/27/').code, (create {PD_CMDARG_S_STATIC}).nv_esc_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([28, (create {PD_CMDARG_S_STATIC}).nv_normal_address, (5).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([29, (create {PD_CMDARG_S_STATIC}).nv_ident_address, (512).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([30, (create {PD_CMDARG_S_STATIC}).nv_hat_address, (512).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([31, (create {PD_CMDARG_S_STATIC}).nv_error_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([(' ').code, nv_right_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('!').code, (create {PD_CMDARG_S_STATIC}).nv_operator_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('%"').code, (create {PD_CMDARG_S_STATIC}).nv_regname_address, (259).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('#').code, (create {PD_CMDARG_S_STATIC}).nv_ident_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('$').code, (create {PD_CMDARG_S_STATIC}).nv_dollar_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('%%').code, (create {PD_CMDARG_S_STATIC}).nv_percent_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('&').code, (create {PD_CMDARG_S_STATIC}).nv_optrans_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('%'').code, (create {PD_CMDARG_S_STATIC}).nv_gomark_address, (5).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('(').code, (create {PD_CMDARG_S_STATIC}).nv_brace_address, (0).to_natural_16, (-1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([(')').code, (create {PD_CMDARG_S_STATIC}).nv_brace_address, (0).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('*').code, (create {PD_CMDARG_S_STATIC}).nv_ident_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('+').code, (create {PD_CMDARG_S_STATIC}).nv_down_address, (0).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([(',').code, (create {PD_CMDARG_S_STATIC}).nv_csearch_address, (0).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('-').code, (create {PD_CMDARG_S_STATIC}).nv_up_address, (0).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('.').code, (create {PD_CMDARG_S_STATIC}).nv_dot_address, (256).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('/').code, (create {PD_CMDARG_S_STATIC}).nv_search_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('0').code, (create {PD_CMDARG_S_STATIC}).nv_beginline_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('1').code, (create {PD_CMDARG_S_STATIC}).nv_ignore_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('2').code, (create {PD_CMDARG_S_STATIC}).nv_ignore_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('3').code, (create {PD_CMDARG_S_STATIC}).nv_ignore_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('4').code, (create {PD_CMDARG_S_STATIC}).nv_ignore_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('5').code, (create {PD_CMDARG_S_STATIC}).nv_ignore_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('6').code, (create {PD_CMDARG_S_STATIC}).nv_ignore_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('7').code, (create {PD_CMDARG_S_STATIC}).nv_ignore_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('8').code, (create {PD_CMDARG_S_STATIC}).nv_ignore_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('9').code, (create {PD_CMDARG_S_STATIC}).nv_ignore_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([(':').code, (create {PD_CMDARG_S_STATIC}).nv_colon_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([(';').code, (create {PD_CMDARG_S_STATIC}).nv_csearch_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('<').code, (create {PD_CMDARG_S_STATIC}).nv_operator_address, (128).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('=').code, (create {PD_CMDARG_S_STATIC}).nv_operator_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('>').code, (create {PD_CMDARG_S_STATIC}).nv_operator_address, (128).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('?').code, (create {PD_CMDARG_S_STATIC}).nv_search_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('@').code, (create {PD_CMDARG_S_STATIC}).nv_at_address, (3).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('A').code, (create {PD_CMDARG_S_STATIC}).nv_edit_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('B').code, (create {PD_CMDARG_S_STATIC}).nv_bck_word_address, (0).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('C').code, (create {PD_CMDARG_S_STATIC}).nv_abbrev_address, (256).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('D').code, (create {PD_CMDARG_S_STATIC}).nv_abbrev_address, (256).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('E').code, (create {PD_CMDARG_S_STATIC}).nv_wordcmd_address, (0).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('F').code, (create {PD_CMDARG_S_STATIC}).nv_csearch_address, (13).to_natural_16, (-1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('G').code, (create {PD_CMDARG_S_STATIC}).nv_goto_address, (0).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('H').code, (create {PD_CMDARG_S_STATIC}).nv_scroll_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('I').code, (create {PD_CMDARG_S_STATIC}).nv_edit_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('J').code, (create {PD_CMDARG_S_STATIC}).nv_join_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('K').code, (create {PD_CMDARG_S_STATIC}).nv_ident_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('L').code, (create {PD_CMDARG_S_STATIC}).nv_scroll_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('M').code, (create {PD_CMDARG_S_STATIC}).nv_scroll_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('N').code, (create {PD_CMDARG_S_STATIC}).nv_next_address, (0).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('O').code, (create {PD_CMDARG_S_STATIC}).nv_open_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('P').code, (create {PD_CMDARG_S_STATIC}).nv_put_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('Q').code, nv_exmode_address, (512).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('R').code, (create {PD_CMDARG_S_STATIC}).nv_Replace2_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('S').code, (create {PD_CMDARG_S_STATIC}).nv_subst_address, (256).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('T').code, (create {PD_CMDARG_S_STATIC}).nv_csearch_address, (13).to_natural_16, (-1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('U').code, (create {PD_CMDARG_S_STATIC}).nv_Undo2_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('W').code, (create {PD_CMDARG_S_STATIC}).nv_wordcmd_address, (0).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('X').code, (create {PD_CMDARG_S_STATIC}).nv_abbrev_address, (256).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('Y').code, (create {PD_CMDARG_S_STATIC}).nv_abbrev_address, (256).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('Z').code, (create {PD_CMDARG_S_STATIC}).nv_Zet2_address, (515).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('[').code, (create {PD_CMDARG_S_STATIC}).nv_brackets_address, (5).to_natural_16, (-1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('\').code, (create {PD_CMDARG_S_STATIC}).nv_error_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([(']').code, (create {PD_CMDARG_S_STATIC}).nv_brackets_address, (5).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('^').code, (create {PD_CMDARG_S_STATIC}).nv_beginline_address, (0).to_natural_16, (5).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('_').code, (create {PD_CMDARG_S_STATIC}).nv_lineop_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('`').code, (create {PD_CMDARG_S_STATIC}).nv_gomark_address, (5).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('a').code, (create {PD_CMDARG_S_STATIC}).nv_edit_address, (1).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('b').code, (create {PD_CMDARG_S_STATIC}).nv_bck_word_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('c').code, (create {PD_CMDARG_S_STATIC}).nv_operator_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('d').code, (create {PD_CMDARG_S_STATIC}).nv_operator_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('e').code, (create {PD_CMDARG_S_STATIC}).nv_wordcmd_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('f').code, (create {PD_CMDARG_S_STATIC}).nv_csearch_address, (13).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('g').code, (create {PD_CMDARG_S_STATIC}).nv_g_cmd_address, (5).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('h').code, nv_left_address, (128).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('i').code, (create {PD_CMDARG_S_STATIC}).nv_edit_address, (1).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('j').code, (create {PD_CMDARG_S_STATIC}).nv_down_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('k').code, (create {PD_CMDARG_S_STATIC}).nv_up_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('l').code, nv_right_address, (128).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('m').code, (create {PD_CMDARG_S_STATIC}).nv_mark_address, (3).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('n').code, (create {PD_CMDARG_S_STATIC}).nv_next_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('o').code, (create {PD_CMDARG_S_STATIC}).nv_open_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('p').code, (create {PD_CMDARG_S_STATIC}).nv_put_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('q').code, (create {PD_CMDARG_S_STATIC}).nv_record_address, (1).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('r').code, (create {PD_CMDARG_S_STATIC}).nv_replace_address, (11).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('s').code, (create {PD_CMDARG_S_STATIC}).nv_subst_address, (256).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('t').code, (create {PD_CMDARG_S_STATIC}).nv_csearch_address, (13).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('u').code, (create {PD_CMDARG_S_STATIC}).nv_undo_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('w').code, (create {PD_CMDARG_S_STATIC}).nv_wordcmd_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('x').code, (create {PD_CMDARG_S_STATIC}).nv_abbrev_address, (256).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('y').code, (create {PD_CMDARG_S_STATIC}).nv_operator_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('z').code, (create {PD_CMDARG_S_STATIC}).nv_zet_address, (5).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('{').code, (create {PD_CMDARG_S_STATIC}).nv_findpar_address, (0).to_natural_16, (-1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('|').code, (create {PD_CMDARG_S_STATIC}).nv_pipe_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('}').code, (create {PD_CMDARG_S_STATIC}).nv_findpar_address, (0).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([('~').code, (create {PD_CMDARG_S_STATIC}).nv_tilde_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([163, (create {PD_CMDARG_S_STATIC}).nv_ident_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((76).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mousescroll_address, (0).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((75).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mousescroll_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((77).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mousescroll_address, (0).to_natural_16, (-1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((78).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mousescroll_address, (0).to_natural_16, (-2).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((44).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((69).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((45).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((46).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((70).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((47).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((48).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((49).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((50).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((51).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((52).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((89).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((90).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((91).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((92).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((93).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((94).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_mouse_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((53).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_ignore_address, (256).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((97).bit_shift_left (8))), nv_nop_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(107 + ((73).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_edit_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((79).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_edit_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(107 + ((98).bit_shift_left (8))), nv_ctrlh_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(107 + ((117).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_up_address, (96).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((4).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_page_address, (16).to_natural_16, (-1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(107 + ((100).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_down_address, (96).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((5).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_page_address, (16).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(107 + ((108).bit_shift_left (8))), nv_left_address, (224).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(35 + ((52).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_bck_word_address, (144).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((85).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_bck_word_address, (224).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(107 + ((114).bit_shift_left (8))), nv_right_address, (224).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(37 + ((105).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_wordcmd_address, (144).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((86).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_wordcmd_address, (224).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(107 + ((80).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_page_address, (96).to_natural_16, (-1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(75 + ((51).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_page_address, (96).to_natural_16, (-1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(107 + ((78).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_page_address, (96).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(75 + ((53).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_page_address, (96).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(64 + ((55).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_end_address, (96).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(75 + ((52).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_end_address, (96).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(42 + ((55).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_end_address, (16).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((88).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_end_address, (96).to_natural_16, (1).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(107 + ((104).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_home_address, (96).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(75 + ((49).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_home_address, (96).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(35 + ((50).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_home_address, (16).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((87).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_goto_address, (96).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(107 + ((68).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_abbrev_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((80).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_abbrev_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(38 + ((56).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_kundo_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(37 + ((49).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_help_address, (512).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(107 + ((49).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_help_address, (512).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((57).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_help_address, (512).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(245 + ((88).bit_shift_left (8))), nv_select_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(249 + ((88).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_ver_scrollbar_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(248 + ((88).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_hor_scrollbar_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(240 + ((88).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_tabline_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(239 + ((88).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_tabmenu_address, (0).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(70 + ((66).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_nbcmd_address, (5).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((95).bit_shift_left (8))), nv_drop_address, (64).to_natural_16, (0).to_integer_16]),
					create {PD_NV_CMD}.make_initialized ([-(253 + ((96).bit_shift_left (8))), (create {PD_CMDARG_S_STATIC}).nv_cursorhold_address, (256).to_natural_16, (0).to_integer_16])
				>>)
		end

	nv_cmd_idx: CE_STATIC [CE_ARRAY [CE_ARRAY [INTEGER_16]]]
		once ("PROCESS")
			Result.item := create {CE_ARRAY_ARRAY [INTEGER_16]}.make (<<1, (((create {PD_NV_CMD}.make).structure_size.to_natural_32 * (190).to_natural_32) // (create {PD_NV_CMD}.make).structure_size.to_natural_32).to_integer_32>>)
		end

	nv_max_linear: CE_STATIC [INTEGER_32]
		once ("PROCESS")
		end

	do_always: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	got_click: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	in_tab_line: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	orig_cursor: CE_STATIC [PD_POS_T]
		once ("PROCESS")
			Result.item := create {PD_POS_T}.make
		end

	did_check: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	showcmd_buf: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<41>>)
		end

	old_showcmd_buf: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<41>>)
		end

	showcmd_is_clear: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 1
		end

	showcmd_visual: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	ignore: CE_STATIC [CE_ARRAY [INTEGER_32]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_32_ARRAY}.make_initialized (<<
					-(249 + ((88).bit_shift_left (8))), -(248 + ((88).bit_shift_left (8))), -(253 + ((69).bit_shift_left (8))),
					-(253 + ((70).bit_shift_left (8))), -(253 + ((53).bit_shift_left (8))), -(253 + ((44).bit_shift_left (8))),
					-(253 + ((45).bit_shift_left (8))), -(253 + ((46).bit_shift_left (8))), -(253 + ((47).bit_shift_left (8))),
					-(253 + ((48).bit_shift_left (8))), -(253 + ((49).bit_shift_left (8))), -(253 + ((50).bit_shift_left (8))),
					-(253 + ((51).bit_shift_left (8))), -(253 + ((52).bit_shift_left (8))), -(253 + ((75).bit_shift_left (8))),
					-(253 + ((76).bit_shift_left (8))), -(253 + ((77).bit_shift_left (8))), -(253 + ((78).bit_shift_left (8))),
					-(253 + ((89).bit_shift_left (8))), -(253 + ((90).bit_shift_left (8))), -(253 + ((91).bit_shift_left (8))),
					-(253 + ((92).bit_shift_left (8))), -(253 + ((93).bit_shift_left (8))), -(253 + ((94).bit_shift_left (8))),
					-(253 + ((96).bit_shift_left (8))), 0
				>>)
		end

	old_curwin: CE_STATIC [CE_POINTER [PD_WINDOW_S]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
		end

	old_topline: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (0).to_integer_32
		end

	old_topfill: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	old_buf: CE_STATIC [CE_POINTER [PD_FILE_BUFFER]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
		end

	old_leftcol: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	nv_compare (a_s1, a_s2: CE_POINTER [ANY]): INTEGER_32
		local
			l_c1: INTEGER_32
			l_c2: INTEGER_32
		do
			l_c1 := nv_cmds.item[((create {CE_INTEGER_16_POINTER}.make_cast (a_s1)).item).to_integer_32].cmd_char
			l_c2 := nv_cmds.item[((create {CE_INTEGER_16_POINTER}.make_cast (a_s2)).item).to_integer_32].cmd_char
			if l_c1 < 0 then
				l_c1 := -l_c1
			end
			if l_c2 < 0 then
				l_c2 := -l_c2
			end
			Result := (l_c1 - l_c2)
		end

	init_normal_cmds
		local
			l_i___0: INTEGER_32
			l_break: BOOLEAN
		do
			l_i___0 := 0
			from
			until
				not (l_i___0 < (((create {PD_NV_CMD}.make).structure_size.to_natural_32 * (190).to_natural_32) // (create {PD_NV_CMD}.make).structure_size.to_natural_32).to_integer_32)
			loop
				nv_cmd_idx.item.item[l_i___0] := l_i___0.to_integer_16
				l_i___0 := l_i___0 + 1
			end
			qsort (create {CE_VOID_POINTER}.make_cast (nv_cmd_idx.item), ((create {PD_NV_CMD}.make).structure_size.to_natural_32 * (190).to_natural_32) // (create {PD_NV_CMD}.make).structure_size.to_natural_32, {PLATFORM}.Integer_16_bytes.to_natural_32, nv_compare_address)
			l_i___0 := 0
			from
			until
				not (not (l_break) and then (l_i___0 < (((create {PD_NV_CMD}.make).structure_size.to_natural_32 * (190).to_natural_32) // (create {PD_NV_CMD}.make).structure_size.to_natural_32).to_integer_32))
			loop
				l_break := False
				if l_i___0 /= nv_cmds.item[(nv_cmd_idx.item.item[l_i___0]).to_integer_32].cmd_char then
					l_break := True
				end
				if not (l_break) then
					l_i___0 := l_i___0 + 1
				end
			end
			l_break := False
			nv_max_linear.item := l_i___0 - 1
		end

	do_mouse (a_oap: CE_POINTER [PD_OPARG_S]; a_c, a_dir___0: INTEGER_32; a_count___2: INTEGER_32; a_fixindent: INTEGER_32): INTEGER_32
		local
			l_dir___0: INTEGER_32
			l_which_button: INTEGER_32
			l_is_click: CE_ARRAY [INTEGER_32]
			l_is_drag: CE_ARRAY [INTEGER_32]
			l_jump_flags: INTEGER_32
			l_start_visual: CE_ARRAY [PD_POS_T]
			l_moved: INTEGER_32
			l_in_status_line: INTEGER_32
			l_in_sep_line: INTEGER_32
			l_c1: INTEGER_32
			l_c2: INTEGER_32
			l_save_cursor: PD_POS_T
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_leftcol: CE_ARRAY [INTEGER_32]
			l_rightcol: CE_ARRAY [INTEGER_32]
			l_end_visual: CE_ARRAY [PD_POS_T]
			l_diff: INTEGER_32
			l_old_active: INTEGER_32
			l_old_mode: INTEGER_32
			l_regname___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_tmp___9: INTEGER_32
			l_m_pos: CE_ARRAY [PD_POS_T]
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			l_tmp___21: INTEGER_32
			l_tmp___24: INTEGER_32
			l_tmp___27: INTEGER_32
			l_tmp___28: INTEGER_32
			l_tmp___30: CE_POINTER [INTEGER_32]
			l_key: INTEGER_32
			l_tmp___32: INTEGER_32
			l_tmp___33: INTEGER_32
			l_tmp___34: INTEGER_32
			l_tmp___35: INTEGER_32
			l_pos___3: CE_POINTER [PD_POS_T]
			l_gc: INTEGER_32
			l_tmp___37: INTEGER_32
			l_tmp___38: INTEGER_32
			l_tmp___39: INTEGER_32
			l_tmp___45: INTEGER_32
			l_tmp___46: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_is_click.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_is_drag.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_POS_T]} l_start_visual.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_leftcol.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rightcol.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_POS_T]} l_end_visual.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_POS_T]} l_m_pos.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dir___0 := a_dir___0
					l_jump_flags := 0
					l_old_curwin___1 := (create {P_GLOBALS_STATIC}).curwin.item
					l_old_active := (create {P_GLOBALS_STATIC}).VIsual_active.item
					l_old_mode := (create {P_GLOBALS_STATIC}).VIsual_mode.item
					l_save_cursor := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
					if do_always.item.to_boolean then
						do_always.item := 0
					elseif not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							if not ((create {P_TERM_STATIC}).mouse_has (('v').code)).to_boolean then
								Result := 0
								l_return := True
							end
						elseif (create {P_GLOBALS_STATIC}).State.item = 1 then
							if not ((create {P_TERM_STATIC}).mouse_has (('n').code)).to_boolean then
								Result := 0
								l_return := True
							end
						end
					end
					if not l_return then
						l_which_button := (create {P_MISC2_STATIC}).get_mouse_button ((((((-a_c).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_integer_32, l_is_click, l_is_drag)
						if not (l_is_drag.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).drag_status_line.item).to_boolean then
								(create {P_GLOBALS_STATIC}).drag_status_line.item := 0;
								(create {P_MISC2_STATIC}).update_mouseshape (10)
							end
						end
						if not (l_is_drag.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).drag_sep_line.item).to_boolean then
								(create {P_GLOBALS_STATIC}).drag_sep_line.item := 0;
								(create {P_MISC2_STATIC}).update_mouseshape (12)
							end
						end
						if (l_is_click.item).to_boolean then
							got_click.item := 1
						else
							if not got_click.item.to_boolean then
								Result := 0
								l_return := True
							end
							if not l_return and then (not (l_is_drag.item).to_boolean) then
								got_click.item := 0
								if in_tab_line.item.to_boolean then
									in_tab_line.item := 0
									Result := 0
									l_return := True
								end
							end
						end
					end
					if not l_return and then ((l_is_click.item).to_boolean) then
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (4)).to_boolean then
							if l_which_button = 2 then
								if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
									(create {P_GETCHAR_STATIC}).stuffcharReadbuff (15)
								end
								if a_count___2 > 1 then
									(create {P_GETCHAR_STATIC}).stuffnumReadbuff (a_count___2)
								end
								(create {P_GETCHAR_STATIC}).stuffcharReadbuff (20)
								got_click.item := 0
								Result := 0
								l_return := True
							end
						end
					end
					if not l_return and then ((((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (4)).to_boolean) then
						if l_which_button /= 0 then
							Result := 0
							l_return := True
						end
					end
					if not (not l_return and then ((((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (30)).to_boolean)) then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if (l_is_click.item).to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 8 -- goto _L___1
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 4 then -- else:
						if not ((((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (96)).to_boolean) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___1
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 7 then -- else:
						if l_which_button /= 1 then
							l_pos := -1 + 12 -- skip if block
						end
				when 8 then -- if: | _L___1:
						if not ((((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (10)).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if ((create {P_TERM_STATIC}).mouse_model_popup).to_boolean then
							if l_which_button /= 0 then
								l_pos := -1 + 11 -- goto _L___0
							end
						else
							l_pos := -1 + 11 -- goto _L___0
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L___0:
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (8)).to_boolean then
							if ((create {P_TERM_STATIC}).mouse_model_popup).to_boolean then
								Result := 0
								l_return := True
							elseif l_which_button /= 2 then
								Result := 0
								l_return := True
							end
						else
							Result := 0
							l_return := True
						end
				when 12 then -- if done | if done | if done | if done
					if not l_return and then (not (l_is_click.item).to_boolean) then
						if l_which_button = 1 then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 27 -- skip if block
					end
				when 13 then -- if:
						if not a_oap.is_void then
							l_regname___0 := a_oap.item.regname
						else
							l_regname___0 := 0
						end
						if l_which_button /= 1 then
							l_pos := -1 + 27 -- skip if block
						end
				when 14 then -- if:
						if (create {P_GLOBALS_STATIC}).State.item = 1 then
							if not a_oap.is_void then
								if a_oap.item.op_type /= 0 then
									a_oap.item.clearopbeep
									Result := 0
									l_return := True
								end
							end
							if not l_return and then (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
								if ((create {P_GLOBALS_STATIC}).VIsual_select.item).to_boolean then
									(create {P_GETCHAR_STATIC}).stuffcharReadbuff (7);
									(create {P_GETCHAR_STATIC}).stuffReadbuff (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%"+p")))
								else
									(create {P_GETCHAR_STATIC}).stuffcharReadbuff (('y').code);
									(create {P_GETCHAR_STATIC}).stuffcharReadbuff (-(253 + ((47).bit_shift_left (8))))
								end
								do_always.item := 1
								Result := 0
								l_return := True
							end
						elseif (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)) = 0 then
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 27 -- skip if block
						end
				when 15 then -- if:
						if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						l_pos := -1 + 19 -- goto _L___3
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 18 then -- else:
						if ((create {P_TERM_STATIC}).mouse_has (('n').code)).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 19 then -- if: | _L___3:
						if l_regname___0 /= 46 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:;
						(create {P_OPS_STATIC}).insert_reg (l_regname___0, 1).do_nothing
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 22 then -- else:
						if ((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean then
							if l_regname___0 = 0 then
								l_regname___0 := ('*').code
							end
						end
						if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (64)).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						if ((create {P_OPS_STATIC}).yank_register_mline (l_regname___0)).to_boolean then
							l_pos := -1 + 25 -- goto _L___2
						else
							(create {P_OPS_STATIC}).insert_reg (l_regname___0, 1).do_nothing
						end
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else: | _L___2:;
						(create {P_OPS_STATIC}).do_put (l_regname___0, -1, 1, (a_fixindent).bit_or (2));
						(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (18)
						if a_fixindent.to_boolean then
							l_tmp___3 := 16
						else
							l_tmp___3 := 15
						end
						(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (l_tmp___3)
						if l_regname___0 = 0 then
							l_tmp___4 := ('%"').code
						else
							l_tmp___4 := l_regname___0
						end
						(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (l_tmp___4)
				when 26 then -- if done
						Result := 0
						l_return := True
				when 27 then -- if done | if done | if done | if done
					if l_return then
						l_pos := -1 + 32 -- skip if block
					end
				when 28 then -- if:
						if not (l_is_click.item).to_boolean then
							l_jump_flags := (l_jump_flags).bit_or ((5))
						end
						l_start_visual.item.lnum := (0).to_integer_32
						if (create {P_GLOBALS_STATIC}).mouse_row.item /= 0 then
							l_pos := -1 + 31 -- skip if block
						end
				when 29 then -- if:
						if (create {P_GLOBALS_STATIC}).firstwin.item.item.w_winrow > 0 then
							if (l_is_drag.item).to_boolean then
								if in_tab_line.item.to_boolean then
									l_c1 := ((create {P_GLOBALS_STATIC}).TabPageIdxs.item[(create {P_GLOBALS_STATIC}).mouse_col.item]).to_integer_32
									if l_c1 <= 0 then
										l_tmp___7 := 9_999
									else
										l_tmp___7 := l_c1 - 1
									end
									(create {P_WINDOW_STATIC}).tabpage_move (l_tmp___7)
								end
								Result := 0
								l_return := True
							end
							if not l_return then
								if (l_is_click.item).to_boolean then
									if (create {P_GLOBALS_STATIC}).cmdwin_type.item = 0 then
										if ((create {P_GLOBALS_STATIC}).mouse_col.item).to_integer_32 < (create {P_GLOBALS_STATIC}).Columns.item.item then
											in_tab_line.item := 1
											l_c1 := ((create {P_GLOBALS_STATIC}).TabPageIdxs.item[(create {P_GLOBALS_STATIC}).mouse_col.item]).to_integer_32
											if l_c1 >= 0 then
												if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (96)) = 32 then
													end_visual_mode;
													(create {P_EX_DOCMD_STATIC}).tabpage_new
													if l_c1 = 0 then
														l_tmp___8 := 9_999
													else
														l_tmp___8 := l_c1 - 1
													end
													(create {P_WINDOW_STATIC}).tabpage_move (l_tmp___8)
												else
													(create {P_WINDOW_STATIC}).goto_tabpage (l_c1)
													if not ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
														end_visual_mode
													end
												end
											elseif l_c1 < 0 then
												if l_c1 = -999 then
													l_tp := (create {P_GLOBALS_STATIC}).curtab.item
												else
													l_tp := (create {P_WINDOW_STATIC}).find_tabpage (-l_c1)
												end
												if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
													if not ((create {P_GLOBALS_STATIC}).first_tabpage.item.item.tp_next).is_void then
														(create {P_EX_DOCMD_STATIC}).tabpage_close (0)
													end
												elseif not l_tp.is_void then
													(create {P_EX_DOCMD_STATIC}).tabpage_close_other (l_tp, 0)
												end
											end
										end
									end
								end
								Result := 1
								l_return := True
							end
						else
							l_pos := -1 + 31 -- goto _L___4
						end
				when 30 then -- if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else: | _L___4:
						if (l_is_drag.item).to_boolean then
							if in_tab_line.item.to_boolean then
								l_c1 := ((create {P_GLOBALS_STATIC}).TabPageIdxs.item[(create {P_GLOBALS_STATIC}).mouse_col.item]).to_integer_32
								if l_c1 <= 0 then
									l_tmp___9 := 9_999
								else
									l_tmp___9 := l_c1 - 1
								end
								(create {P_WINDOW_STATIC}).tabpage_move (l_tmp___9)
								Result := 0
								l_return := True
							end
						end
				when 32 then -- if done
					if l_return then
						l_pos := -1 + 62 -- skip if block
					end
				when 33 then -- if:
						if not (((create {P_TERM_STATIC}).mouse_model_popup).to_boolean) then
							l_pos := -1 + 62 -- skip if block
						end
				when 34 then -- if:
						if l_which_button /= 2 then
							l_pos := -1 + 61 -- skip if block
						end
				when 35 then -- if:
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (6)).to_boolean then
							l_pos := -1 + 61 -- skip if block
						end
				when 36 then -- if:
						if not (l_is_click.item).to_boolean then
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 61 -- skip if block
						end
				when 37 then -- if:
						if not (((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean) then
							l_pos := -1 + 60 -- skip if block
						end
				when 38 then -- if:
						l_jump_flags := 0
						if (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_mousem.item.item), ce_string ("popup_setpos"))) /= 0 then
							l_pos := -1 + 58 -- skip if block
						end
				when 39 then -- if:
						if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
							l_pos := -1 + 57 -- skip if block
						end
				when 40 then -- if:
						if not ((create {P_GLOBALS_STATIC}).mouse_row.item < (create {P_GLOBALS_STATIC}).curwin.item.item.w_winrow) then
							l_pos := -1 + 43 -- skip if block
						end
				when 41 then -- if:
						l_jump_flags := 16
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 43 then -- else:
						if not ((create {P_GLOBALS_STATIC}).mouse_row.item > (create {P_GLOBALS_STATIC}).curwin.item.item.w_winrow + (create {P_GLOBALS_STATIC}).curwin.item.item.w_height) then
							l_pos := -1 + 46 -- skip if block
						end
				when 44 then -- if:
						l_jump_flags := 16
				when 45 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 46 then -- else:
						if ((create {P_UI_STATIC}).get_fpos_of_mouse (l_m_pos)) = 1 then
							l_pos := -1 + 49 -- skip if block
						end
				when 47 then -- if:
						l_jump_flags := 16
				when 48 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 49 then -- else:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
							l_tmp___11 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum).to_integer
						else
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= (create {P_GLOBALS_STATIC}).VIsual.item.item.col then
								l_tmp___10 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < (create {P_GLOBALS_STATIC}).VIsual.item.item.col).to_integer
							else
								l_tmp___10 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd < (create {P_GLOBALS_STATIC}).VIsual.item.item.coladd).to_integer
							end
							l_tmp___11 := l_tmp___10
						end
						if not (l_tmp___11.to_boolean) then
							l_pos := -1 + 52 -- skip if block
						end
				when 50 then -- if:
						if l_m_pos.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							l_tmp___13 := (l_m_pos.item.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum).to_integer
						else
							if l_m_pos.item.col /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
								l_tmp___12 := (l_m_pos.item.col < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col).to_integer
							else
								l_tmp___12 := (l_m_pos.item.coladd < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd).to_integer
							end
							l_tmp___13 := l_tmp___12
						end
						if l_tmp___13.to_boolean then
							l_jump_flags := 16
						else
							if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum /= l_m_pos.item.lnum then
								l_tmp___15 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.lnum < l_m_pos.item.lnum).to_integer
							else
								if (create {P_GLOBALS_STATIC}).VIsual.item.item.col /= l_m_pos.item.col then
									l_tmp___14 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.col < l_m_pos.item.col).to_integer
								else
									l_tmp___14 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.coladd < l_m_pos.item.coladd).to_integer
								end
								l_tmp___15 := l_tmp___14
							end
							if l_tmp___15.to_boolean then
								l_jump_flags := 16
							else
								l_pos := -1 + 52 -- goto _L___6
							end
						end
				when 51 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 52 then -- else: | _L___6:
						if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							l_tmp___17 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum).to_integer
						else
							if (create {P_GLOBALS_STATIC}).VIsual.item.item.col /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
								l_tmp___16 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.col < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col).to_integer
							else
								l_tmp___16 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.coladd < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd).to_integer
							end
							l_tmp___17 := l_tmp___16
						end
						if not (l_tmp___17.to_boolean) then
							l_pos := -1 + 55 -- skip if block
						end
				when 53 then -- if:
						if l_m_pos.item.lnum /= (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
							l_tmp___19 := (l_m_pos.item.lnum < (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum).to_integer
						else
							if l_m_pos.item.col /= (create {P_GLOBALS_STATIC}).VIsual.item.item.col then
								l_tmp___18 := (l_m_pos.item.col < (create {P_GLOBALS_STATIC}).VIsual.item.item.col).to_integer
							else
								l_tmp___18 := (l_m_pos.item.coladd < (create {P_GLOBALS_STATIC}).VIsual.item.item.coladd).to_integer
							end
							l_tmp___19 := l_tmp___18
						end
						if l_tmp___19.to_boolean then
							l_jump_flags := 16
						else
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= l_m_pos.item.lnum then
								l_tmp___21 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < l_m_pos.item.lnum).to_integer
							else
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= l_m_pos.item.col then
									l_tmp___20 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < l_m_pos.item.col).to_integer
								else
									l_tmp___20 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd < l_m_pos.item.coladd).to_integer
								end
								l_tmp___21 := l_tmp___20
							end
							if l_tmp___21.to_boolean then
								l_jump_flags := 16
							else
								l_pos := -1 + 55 -- goto _L___5
							end
						end
				when 54 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 55 then -- else: | _L___5:
						if (create {P_GLOBALS_STATIC}).VIsual_mode.item = 22 then
							((create {P_GLOBALS_STATIC}).curwin.item).item.getvcols (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), (create {P_GLOBALS_STATIC}).VIsual.item, l_leftcol, l_rightcol);
							((create {P_GLOBALS_STATIC}).curwin.item).item.getvcol (l_m_pos, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (l_m_pos.item.c_pointer + (create {PD_POS_T}.make).offset_of ("col")), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							if l_m_pos.item.col < l_leftcol.item then
								l_jump_flags := 16
							elseif l_m_pos.item.col > l_rightcol.item then
								l_jump_flags := 16
							end
						end
				when 56 then -- if done | if done | if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 58
				when 57 then -- else:
						l_jump_flags := 16
				when 58 then -- if done
						if l_jump_flags.to_boolean then
							l_jump_flags := (create {P_UI_STATIC}).jump_to_mouse (l_jump_flags, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_which_button)
							if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
								l_tmp___24 := 20
							else
								l_tmp___24 := 10
							end
							(create {P_SCREEN_STATIC}).update_curbuf (l_tmp___24);
							(create {P_SCREEN_STATIC}).setcursor;
							(create {P_TERM_STATIC}).out_flush
						end
						(create {P_MENU_STATIC}).gui_show_popupmenu
						Result := (((l_jump_flags).bit_and (256)) /= 0).to_integer
						l_return := True
				when 59 then -- if block done, skip else block:
						l_pos := -1 + 61
				when 60 then -- else:
						Result := 0
						l_return := True
				when 61 then -- if done | if done | if done | if done
						if not l_return and then (l_which_button = 0) then
							if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (10)).to_boolean then
								l_which_button := 2;
								(create {P_GLOBALS_STATIC}).mod_mask.item.item := ((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and ((-3))
							end
						end
				when 62 then -- if done | if done
					if not l_return then
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (17)).to_boolean then
							if not (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (6)).to_boolean then
								if l_which_button = 0 then
									if (l_is_click.item).to_boolean then
										if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
											l_jump_flags := (l_jump_flags).bit_or ((16))
										end
									elseif ((create {P_TERM_STATIC}).mouse_has (('v').code)).to_boolean then
										l_jump_flags := (l_jump_flags).bit_or ((2))
									end
								elseif l_which_button = 2 then
									if (l_is_click.item).to_boolean then
										if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
											if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
												l_tmp___28 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum).to_integer
											else
												if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= (create {P_GLOBALS_STATIC}).VIsual.item.item.col then
													l_tmp___27 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < (create {P_GLOBALS_STATIC}).VIsual.item.item.col).to_integer
												else
													l_tmp___27 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd < (create {P_GLOBALS_STATIC}).VIsual.item.item.coladd).to_integer
												end
												l_tmp___28 := l_tmp___27
											end
											if l_tmp___28.to_boolean then
												l_start_visual.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
												l_end_visual.item := ((create {P_GLOBALS_STATIC}).VIsual.item.item).twin
											else
												l_start_visual.item := ((create {P_GLOBALS_STATIC}).VIsual.item.item).twin
												l_end_visual.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
											end
										end
									end
									l_jump_flags := (l_jump_flags).bit_or ((1))
									if ((create {P_TERM_STATIC}).mouse_has (('v').code)).to_boolean then
										l_jump_flags := (l_jump_flags).bit_or ((2))
									end
								end
							end
						end
						if not (l_is_drag.item).to_boolean then
							if not a_oap.is_void then
								if a_oap.item.op_type /= 0 then
									got_click.item := 0
									a_oap.item.motion_type := 0
								end
							end
						end
						if not (l_is_click.item).to_boolean then
							if not (l_is_drag.item).to_boolean then
								l_jump_flags := (l_jump_flags).bit_or ((32))
							end
						end
						if a_oap.is_void then
							l_tmp___30 := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)
						else
							l_tmp___30 := create {CE_INTEGER_32_POINTER}.make_shared (a_oap.c_pointer + (create {PD_OPARG_S}.make).offset_of ("inclusive"))
						end
						l_jump_flags := (create {P_UI_STATIC}).jump_to_mouse (l_jump_flags, l_tmp___30, l_which_button)
						l_moved := (l_jump_flags).bit_and (256)
						l_in_status_line := (l_jump_flags).bit_and (2)
						l_in_sep_line := (l_jump_flags).bit_and (4)
						if ((create {P_NETBEANS_STATIC}).isNetbeansBuffer ((create {P_GLOBALS_STATIC}).curbuf.item)).to_boolean then
							if not ((l_jump_flags).bit_and (6)).to_boolean then
								l_key := (((((-a_c).to_natural_32).bit_shift_right (8))).bit_and ({NATURAL_32} 255)).to_integer_32
								if l_key = 46 then
									(create {P_NETBEANS_STATIC}).netbeans_button_release (l_which_button)
								elseif l_key = 49 then
									(create {P_NETBEANS_STATIC}).netbeans_button_release (l_which_button)
								elseif l_key = 52 then
									(create {P_NETBEANS_STATIC}).netbeans_button_release (l_which_button)
								end
							end
						end
						if not ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
							if not a_oap.is_void then
								if a_oap.item.op_type /= 0 then
									a_oap.item.clearop
								end
							end
						end
						if (create {P_GLOBALS_STATIC}).mod_mask.item.item = 0 then
							if not (l_is_drag.item).to_boolean then
								if ((l_jump_flags).bit_and (1_536)).to_boolean then
									if l_which_button = 0 then
										if ((l_jump_flags).bit_and (1_024)).to_boolean then
											(create {P_FOLD_STATIC}).openFold ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 1)
										else
											(create {P_FOLD_STATIC}).closeFold ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, 1)
										end
										if ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
											(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_save_cursor.twin
										end
									end
								end
							end
						end
						if ((l_jump_flags).bit_and (8)).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
								if ((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean then
									(create {P_UI_STATIC}).clip_modeless (l_which_button, l_is_click.item, l_is_drag.item)
									Result := 0
									l_return := True
								end
							end
						end
					end
					if l_return then
						l_pos := -1 + 126 -- skip if block
					end
				when 63 then -- if:
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							if (l_is_drag.item).to_boolean then
								if ((create {P_OPTION_STATIC}).p_so.item.item).to_boolean then
									if (create {P_GLOBALS_STATIC}).mouse_row.item = 0 then
										(create {P_GLOBALS_STATIC}).mouse_dragging.item := 2
									else
										(create {P_GLOBALS_STATIC}).mouse_dragging.item := 1
									end
								end
							end
						end
						if (l_is_drag.item).to_boolean then
							if (create {P_GLOBALS_STATIC}).mouse_row.item < 0 then
								if not l_in_status_line.to_boolean then
									scroll_redraw (0, 1);
									(create {P_GLOBALS_STATIC}).mouse_row.item := 0
								end
							end
						end
						if (l_start_visual.item.lnum).to_boolean then
							if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (8)).to_boolean then
								(create {P_GLOBALS_STATIC}).VIsual_mode.item := 22
							end
							if (create {P_GLOBALS_STATIC}).VIsual_mode.item = 22 then
								((create {P_GLOBALS_STATIC}).curwin.item).item.getvcols (l_start_visual, l_end_visual, l_leftcol, l_rightcol)
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant > (l_leftcol.item + l_rightcol.item) // 2 then
									l_end_visual.item.col := l_leftcol.item
								else
									l_end_visual.item.col := l_rightcol.item
								end
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (l_start_visual.item.lnum + l_end_visual.item.lnum) // 2 then
									l_end_visual.item.lnum := l_end_visual.item.lnum
								else
									l_end_visual.item.lnum := l_start_visual.item.lnum
								end
								l_start_visual.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_end_visual.item).twin;
								(create {P_MISC2_STATIC}).coladvance (l_end_visual.item.col).do_nothing;
								(create {P_GLOBALS_STATIC}).VIsual.item.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_start_visual.item).twin
							else
								if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= l_start_visual.item.lnum then
									l_tmp___35 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < l_start_visual.item.lnum).to_integer
								else
									if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= l_start_visual.item.col then
										l_tmp___34 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < l_start_visual.item.col).to_integer
									else
										l_tmp___34 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd < l_start_visual.item.coladd).to_integer
									end
									l_tmp___35 := l_tmp___34
								end
								if l_tmp___35.to_boolean then
									(create {P_GLOBALS_STATIC}).VIsual.item.item := (l_end_visual.item).twin
								else
									if l_end_visual.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
										l_tmp___33 := (l_end_visual.item.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum).to_integer
									else
										if l_end_visual.item.col /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
											l_tmp___32 := (l_end_visual.item.col < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col).to_integer
										else
											l_tmp___32 := (l_end_visual.item.coladd < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd).to_integer
										end
										l_tmp___33 := l_tmp___32
									end
									if l_tmp___33.to_boolean then
										(create {P_GLOBALS_STATIC}).VIsual.item.item := (l_start_visual.item).twin
									elseif l_end_visual.item.lnum = l_start_visual.item.lnum then
										if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - l_start_visual.item.col > l_end_visual.item.col - (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
											(create {P_GLOBALS_STATIC}).VIsual.item.item := (l_start_visual.item).twin
										else
											(create {P_GLOBALS_STATIC}).VIsual.item.item := (l_end_visual.item).twin
										end
									else
										l_diff := (((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum - l_start_visual.item.lnum) - (l_end_visual.item.lnum - (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)).to_integer_32
										if l_diff > 0 then
											(create {P_GLOBALS_STATIC}).VIsual.item.item := (l_start_visual.item).twin
										elseif l_diff < 0 then
											(create {P_GLOBALS_STATIC}).VIsual.item.item := (l_end_visual.item).twin
										elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < (l_start_visual.item.col + l_end_visual.item.col) // 2 then
											(create {P_GLOBALS_STATIC}).VIsual.item.item := (l_end_visual.item).twin
										else
											(create {P_GLOBALS_STATIC}).VIsual.item.item := (l_start_visual.item).twin
										end
									end
								end
							end
						elseif (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
							if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
								(create {P_GETCHAR_STATIC}).stuffcharReadbuff (15)
							end
						end
						if l_which_button /= 1 then
							l_pos := -1 + 66 -- skip if block
						end
				when 64 then -- if:
						if ((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean then
							if l_regname___0 = 0 then
								l_regname___0 := ('*').code
							end
						end
						if ((create {P_OPS_STATIC}).yank_register_mline (l_regname___0)).to_boolean then
							if ((create {P_GLOBALS_STATIC}).mouse_past_bottom.item).to_boolean then
								l_dir___0 := 1
							end
						elseif ((create {P_GLOBALS_STATIC}).mouse_past_eol.item).to_boolean then
							l_dir___0 := 1
						end
						if a_fixindent.to_boolean then
							if l_dir___0 = -1 then
								l_c1 := ('[').code
							else
								l_c1 := (']').code
							end
							l_c2 := ('p').code
						else
							if l_dir___0 = 1 then
								l_c1 := ('p').code
							else
								l_c1 := ('P').code
							end
							l_c2 := ('%/0/').code
						end
						prep_redo (l_regname___0, a_count___2, ('%/0/').code, l_c1, ('%/0/').code, l_c2, ('%/0/').code)
						if (create {P_GLOBALS_STATIC}).restart_edit.item /= 0 then
							(create {P_GLOBALS_STATIC}).where_paste_started.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
						end
						(create {P_OPS_STATIC}).do_put (l_regname___0, l_dir___0, a_count___2, (a_fixindent).bit_or (2))
				when 65 then -- if block done, skip else block:
						l_pos := -1 + 121
				when 66 then -- else:
						if not ((((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (4)).to_boolean) then
							l_pos := -1 + 69 -- skip if block
						end
				when 67 then -- if:
						l_pos := -1 + 70 -- goto _L___16
				when 68 then -- if block done, skip else block:
						l_pos := -1 + 121
				when 69 then -- else:
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (96)) /= 32 then
							l_pos := -1 + 72 -- skip if block
						end
				when 70 then -- if: | _L___16:
						if (((create {P_GLOBALS_STATIC}).curbuf.item).item.bt_quickfix).to_boolean then
							if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
								(create {P_GETCHAR_STATIC}).stuffcharReadbuff (15)
							end
							if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_llist_ref).is_void then
								(create {P_GETCHAR_STATIC}).stuffReadbuff (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":.cc%N")))
							else
								(create {P_GETCHAR_STATIC}).stuffReadbuff (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (":.ll%N")))
							end
							got_click.item := 0
						else
							l_pos := -1 + 72 -- goto _L___15
						end
				when 71 then -- if block done, skip else block:
						l_pos := -1 + 121
				when 72 then -- else: | _L___15:
						if not ((((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (4)).to_boolean) then
							l_pos := -1 + 75 -- skip if block
						end
				when 73 then -- if:
						l_pos := -1 + 77 -- goto _L___13
				when 74 then -- if block done, skip else block:
						l_pos := -1 + 121
				when 75 then -- else:
						if not (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_help).to_boolean) then
							l_pos := -1 + 81 -- skip if block
						end
				when 76 then -- if:
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (96)) /= 32 then
							l_pos := -1 + 79 -- skip if block
						end
				when 77 then -- if: | _L___13:
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
							(create {P_GETCHAR_STATIC}).stuffcharReadbuff (15)
						end
						(create {P_GETCHAR_STATIC}).stuffcharReadbuff (29)
						got_click.item := 0
				when 78 then -- if block done, skip else block:
						l_pos := -1 + 80
				when 79 then -- else:
						l_pos := -1 + 81 -- goto _L___14
				when 80 then -- if done | if block done, skip else block:
						l_pos := -1 + 121
				when 81 then -- else: | _L___14:
						if not ((((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (2)).to_boolean) then
							l_pos := -1 + 84 -- skip if block
						end
				when 82 then -- if:
						if (((create {P_GLOBALS_STATIC}).State.item).bit_and (16)).to_boolean then
							(create {P_GETCHAR_STATIC}).stuffcharReadbuff (15)
						elseif ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							if ((create {P_GLOBALS_STATIC}).VIsual_select.item).to_boolean then
								(create {P_GETCHAR_STATIC}).stuffcharReadbuff (15)
							end
						end
						if l_which_button = 0 then
							(create {P_GETCHAR_STATIC}).stuffcharReadbuff (('*').code)
						else
							(create {P_GETCHAR_STATIC}).stuffcharReadbuff (('#').code)
						end
				when 83 then -- if block done, skip else block:
						l_pos := -1 + 121
				when 84 then -- else:
						if not (l_in_status_line.to_boolean) then
							l_pos := -1 + 91 -- skip if block
						end
				when 85 then -- if:
						if not ((l_is_drag.item).to_boolean) then
							l_pos := -1 + 88 -- skip if block
						end
				when 86 then -- if:
						l_pos := -1 + 89 -- goto _L___7
				when 87 then -- if block done, skip else block:
						l_pos := -1 + 90
				when 88 then -- else:
						if not ((l_is_click.item).to_boolean) then
							l_pos := -1 + 90 -- skip if block
						end
				when 89 then -- if: | _L___7:
						if not ((create {P_GLOBALS_STATIC}).drag_status_line.item).to_boolean then
							(create {P_GLOBALS_STATIC}).drag_status_line.item := 1;
							(create {P_MISC2_STATIC}).update_mouseshape (-1)
						end
				when 90 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 121
				when 91 then -- else:
						if not (l_in_sep_line.to_boolean) then
							l_pos := -1 + 98 -- skip if block
						end
				when 92 then -- if:
						if not ((l_is_drag.item).to_boolean) then
							l_pos := -1 + 95 -- skip if block
						end
				when 93 then -- if:
						l_pos := -1 + 96 -- goto _L___8
				when 94 then -- if block done, skip else block:
						l_pos := -1 + 97
				when 95 then -- else:
						if not ((l_is_click.item).to_boolean) then
							l_pos := -1 + 97 -- skip if block
						end
				when 96 then -- if: | _L___8:
						if not ((create {P_GLOBALS_STATIC}).drag_sep_line.item).to_boolean then
							(create {P_GLOBALS_STATIC}).drag_sep_line.item := 1;
							(create {P_MISC2_STATIC}).update_mouseshape (-1)
						end
				when 97 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 121
				when 98 then -- else:
						if not ((((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (96)).to_boolean) then
							l_pos := -1 + 120 -- skip if block
						end
				when 99 then -- if:
						if not ((((create {P_GLOBALS_STATIC}).State.item).bit_and (17)).to_boolean) then
							l_pos := -1 + 118 -- skip if block
						end
				when 100 then -- if:
						if not (((create {P_TERM_STATIC}).mouse_has (('v').code)).to_boolean) then
							l_pos := -1 + 116 -- skip if block
						end
				when 101 then -- if:
						if not ((l_is_click.item).to_boolean) then
							l_pos := -1 + 104 -- skip if block
						end
				when 102 then -- if:
						l_pos := -1 + 105 -- goto _L___9
				when 103 then -- if block done, skip else block:
						l_pos := -1 + 106
				when 104 then -- else:
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							l_pos := -1 + 106 -- skip if block
						end
				when 105 then -- if: | _L___9:
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							orig_cursor.item := ((create {P_GLOBALS_STATIC}).VIsual.item.item).twin
						else
							check_visual_highlight;
							(create {P_GLOBALS_STATIC}).VIsual.item.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							orig_cursor.item := ((create {P_GLOBALS_STATIC}).VIsual.item.item).twin;
							(create {P_GLOBALS_STATIC}).VIsual_active.item := 1;
							(create {P_GLOBALS_STATIC}).VIsual_reselect.item := 1
							may_start_select (('o').code);
							(create {P_TERM_STATIC}).setmouse
						end
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (96)) = 32 then
							if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (8)).to_boolean then
								(create {P_GLOBALS_STATIC}).VIsual_mode.item := 22
							else
								(create {P_GLOBALS_STATIC}).VIsual_mode.item := ('v').code
							end
						elseif (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (96)) = 64 then
							(create {P_GLOBALS_STATIC}).VIsual_mode.item := ('V').code
						elseif (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (96)) = 96 then
							(create {P_GLOBALS_STATIC}).VIsual_mode.item := 22
						end
						(create {P_GLOBALS_STATIC}).clip_star.item.item.vmode := ('%/0/').code
				when 106 then -- if done
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (96)) /= 32 then
							l_pos := -1 + 114 -- skip if block
						end
				when 107 then -- if:
						l_pos___3 := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer)
						if (l_is_click.item).to_boolean then
							l_end_visual.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
							from
							until
								(l_break)
							loop
								l_break := False
								l_gc := l_end_visual.item.gchar_pos
								if l_gc = 32 then
									l_tmp___37 := 1
								elseif l_gc = 9 then
									l_tmp___37 := 1
								else
									l_tmp___37 := 0
								end
								if not l_tmp___37.to_boolean then
									l_break := True
								end
								if not (l_break) then
									l_end_visual.item.inc.do_nothing
								end
							end
							l_break := False
							if not a_oap.is_void then
								a_oap.item.motion_type := 0
							end
							if not a_oap.is_void then
								if (create {P_GLOBALS_STATIC}).VIsual_mode.item = 118 then
									if not ((create {P_CHARSET_STATIC}).vim_iswordc ((l_end_visual.item.gchar_pos))).to_boolean then
										if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum = (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
											if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col = (create {P_GLOBALS_STATIC}).VIsual.item.item.col then
												if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd = (create {P_GLOBALS_STATIC}).VIsual.item.item.coladd then
													l_pos___3 := (create {P_SEARCH_STATIC}).findmatch (a_oap, ('%/0/').code)
													if not l_pos___3.is_void then
														(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_pos___3.item).twin
														if a_oap.item.motion_type = 1 then
															(create {P_GLOBALS_STATIC}).VIsual_mode.item := ('V').code
														elseif ((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 = 101 then
															if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
																l_tmp___39 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum).to_integer
															else
																if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= (create {P_GLOBALS_STATIC}).VIsual.item.item.col then
																	l_tmp___38 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < (create {P_GLOBALS_STATIC}).VIsual.item.item.col).to_integer
																else
																	l_tmp___38 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd < (create {P_GLOBALS_STATIC}).VIsual.item.item.coladd).to_integer
																end
																l_tmp___39 := l_tmp___38
															end
															if l_tmp___39.to_boolean then
																(create {P_GLOBALS_STATIC}).VIsual.item.item.col := ((create {P_GLOBALS_STATIC}).VIsual.item.item.col) + 1
															else
																(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
															end
														end
													end
												end
											end
										end
									end
								end
							end
						end
						if not (l_pos___3.is_void) then
							l_pos := -1 + 113 -- skip if block
						end
				when 108 then -- if:
						if not ((l_is_click.item).to_boolean) then
							l_pos := -1 + 111 -- skip if block
						end
				when 109 then -- if:
						l_pos := -1 + 112 -- goto _L___10
				when 110 then -- if block done, skip else block:
						l_pos := -1 + 113
				when 111 then -- else:
						if not ((l_is_drag.item).to_boolean) then
							l_pos := -1 + 113 -- skip if block
						end
				when 112 then -- if: | _L___10:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= orig_cursor.item.lnum then
							l_tmp___46 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < orig_cursor.item.lnum).to_integer
						else
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= orig_cursor.item.col then
								l_tmp___45 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < orig_cursor.item.col).to_integer
							else
								l_tmp___45 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd < orig_cursor.item.coladd).to_integer
							end
							l_tmp___46 := l_tmp___45
						end
						if l_tmp___46.to_boolean then
							(create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))).item.find_start_of_word;
							((create {P_GLOBALS_STATIC}).VIsual.item).item.find_end_of_word
						else
							((create {P_GLOBALS_STATIC}).VIsual.item).item.find_start_of_word
							if ((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 = 101 then
								if (((create {P_MEMLINE_STATIC}).ml_get_cursor).item).to_integer_32 /= 0 then
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([((create {P_MEMLINE_STATIC}).ml_get_cursor)]))
								end
							end
							(create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))).item.find_end_of_word
						end
				when 113 then -- if done | if done;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
				when 114 then -- if done
						if (l_is_click.item).to_boolean then
							(create {P_SCREEN_STATIC}).redraw_curbuf_later (20)
						end
				when 115 then -- if block done, skip else block:
						l_pos := -1 + 117
				when 116 then -- else:
						l_pos := -1 + 120 -- goto _L___12
				when 117 then -- if done | if block done, skip else block:
						l_pos := -1 + 119
				when 118 then -- else:
						l_pos := -1 + 120 -- goto _L___12
				when 119 then -- if done | if block done, skip else block:
						l_pos := -1 + 121
				when 120 then -- else: | _L___12:
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							if not l_old_active.to_boolean then
								if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (8)).to_boolean then
									(create {P_GLOBALS_STATIC}).VIsual_mode.item := 22
								else
									(create {P_GLOBALS_STATIC}).VIsual_mode.item := ('v').code
								end
							end
						end
				when 121 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							l_pos := -1 + 124 -- skip if block
						end
				when 122 then -- if:
						if l_old_active.to_boolean then
							if ((create {P_GLOBALS_STATIC}).mode_displayed.item).to_boolean then
								(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
							else
								l_pos := -1 + 124 -- goto _L___18
							end
						else
							l_pos := -1 + 124 -- goto _L___18
						end
				when 123 then -- if block done, skip else block:
						l_pos := -1 + 125
				when 124 then -- else: | _L___18:
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							if ((create {P_OPTION_STATIC}).p_smd.item.item).to_boolean then
								if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
									if not l_old_active.to_boolean then
										(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
									elseif (create {P_GLOBALS_STATIC}).VIsual_mode.item /= l_old_mode then
										(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
									end
								end
							end
						end
				when 125 then
						Result := l_moved
				when 126 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_visual_highlight
		do
			if ((create {P_GLOBALS_STATIC}).full_screen.item).to_boolean then
				if not did_check.item.to_boolean then
					if (create {P_GLOBALS_STATIC}).highlight_attr.item[15] = 0 then
						(create {P_MESSAGE_STATIC}).msg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("Warning: terminal cannot highlight"))))).do_nothing
					end
				end
				did_check.item := 1
			end
		end

	end_visual_mode
		do
			if ((create {P_GLOBALS_STATIC}).clip_star.item.item.available).to_boolean then
				if ((create {P_GLOBALS_STATIC}).clip_star.item.item.owned).to_boolean then
					(create {P_UI_STATIC}).clip_auto_select
				end
			end
			(create {P_GLOBALS_STATIC}).VIsual_active.item := 0;
			(create {P_TERM_STATIC}).setmouse;
			(create {P_GLOBALS_STATIC}).mouse_dragging.item := 0;
			(create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_mode := (create {P_GLOBALS_STATIC}).VIsual_mode.item;
			(create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_start := ((create {P_GLOBALS_STATIC}).VIsual.item.item).twin;
			(create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_end := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
			(create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual.vi_curswant := (create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant;
			(create {P_GLOBALS_STATIC}).curbuf.item.item.b_visual_mode_eval := (create {P_GLOBALS_STATIC}).VIsual_mode.item
			if not ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0
			end
			if ((create {P_GLOBALS_STATIC}).mode_displayed.item).to_boolean then
				(create {P_GLOBALS_STATIC}).clear_cmdline.item := 1
			else
				clear_showcmd
			end
			(create {P_OPS_STATIC}).adjust_cursor_eol
		end

	reset_VIsual_and_resel
		do
			if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
				end_visual_mode;
				(create {P_SCREEN_STATIC}).redraw_curbuf_later (20)
			end
			(create {P_GLOBALS_STATIC}).VIsual_reselect.item := 0
		end

	reset_VIsual
		do
			if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
				end_visual_mode;
				(create {P_SCREEN_STATIC}).redraw_curbuf_later (20);
				(create {P_GLOBALS_STATIC}).VIsual_reselect.item := 0
			end
		end

	find_ident_under_cursor (a_string___0: CE_POINTER [CE_POINTER [NATURAL_8]]; a_find_type: INTEGER_32): INTEGER_32
		do
			Result := (((create {P_GLOBALS_STATIC}).curwin.item).item.find_ident_at_pos ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col, a_string___0, a_find_type))
		end

	prep_redo (a_regname___0: INTEGER_32; a_num: INTEGER_32; a_cmd1, a_cmd2, a_cmd3, a_cmd4, a_cmd5: INTEGER_32)
		do
			(create {P_GETCHAR_STATIC}).ResetRedobuff
			if a_regname___0 /= 0 then
				(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (('%"').code);
				(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (a_regname___0)
			end
			if a_num.to_boolean then
				(create {P_GETCHAR_STATIC}).AppendNumberToRedobuff (a_num)
			end
			if a_cmd1 /= 0 then
				(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (a_cmd1)
			end
			if a_cmd2 /= 0 then
				(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (a_cmd2)
			end
			if a_cmd3 /= 0 then
				(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (a_cmd3)
			end
			if a_cmd4 /= 0 then
				(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (a_cmd4)
			end
			if a_cmd5 /= 0 then
				(create {P_GETCHAR_STATIC}).AppendCharToRedobuff (a_cmd5)
			end
		end

	clear_showcmd
		local
			l_cursor_bot: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_lines___0: INTEGER_32
			l_leftcol: CE_ARRAY [INTEGER_32]
			l_rightcol: CE_ARRAY [INTEGER_32]
			l_top: CE_ARRAY [INTEGER_32]
			l_bot: CE_ARRAY [INTEGER_32]
			l_saved_sbr: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_l: INTEGER_32
			l_bytes___0: INTEGER_32
			l_chars: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_leftcol.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_rightcol.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_top.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_bot.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((create {P_OPTION_STATIC}).p_sc.item.item).to_boolean then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean) then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
							l_pos := -1 + 4 -- goto _L
						else
							if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
								l_tmp___0 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum).to_integer
							else
								if (create {P_GLOBALS_STATIC}).VIsual.item.item.col /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
									l_tmp := ((create {P_GLOBALS_STATIC}).VIsual.item.item.col < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col).to_integer
								else
									l_tmp := ((create {P_GLOBALS_STATIC}).VIsual.item.item.coladd < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd).to_integer
								end
								l_tmp___0 := l_tmp
							end
							l_cursor_bot := l_tmp___0
							if l_cursor_bot.to_boolean then
								l_top.item := (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum
								l_bot.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
							else
								l_top.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
								l_bot.item := (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum
							end
							(create {P_FOLD_STATIC}).hasFolding (l_top.item, l_top, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer)).do_nothing;
							(create {P_FOLD_STATIC}).hasFolding (l_bot.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_bot).do_nothing
							l_lines___0 := (l_bot.item - l_top.item) + 1
							if (create {P_GLOBALS_STATIC}).VIsual_mode.item = 22 then
								l_saved_sbr := (create {P_OPTION_STATIC}).p_sbr.item.item;
								(create {P_OPTION_STATIC}).p_sbr.item.item := (create {P_GLOBALS_STATIC}).empty_option.item;
								((create {P_GLOBALS_STATIC}).curwin.item).item.getvcols (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), (create {P_GLOBALS_STATIC}).VIsual.item, l_leftcol, l_rightcol);
								(create {P_OPTION_STATIC}).p_sbr.item.item := l_saved_sbr
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (showcmd_buf.item), ce_string ("%%ldx%%ld"), l_lines___0, ((l_rightcol.item - l_leftcol.item) + 1).to_integer_32]).do_nothing
							elseif (create {P_GLOBALS_STATIC}).VIsual_mode.item = 86 then
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (showcmd_buf.item), ce_string ("%%ld"), l_lines___0]).do_nothing
							elseif (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (showcmd_buf.item), ce_string ("%%ld"), l_lines___0]).do_nothing
							else
								l_bytes___0 := 0
								l_chars := 0
								if l_cursor_bot.to_boolean then
									l_s := ((create {P_GLOBALS_STATIC}).VIsual.item).item.ml_get_pos
									l_e := (create {P_MEMLINE_STATIC}).ml_get_cursor
								else
									l_s := (create {P_MEMLINE_STATIC}).ml_get_cursor
									l_e := ((create {P_GLOBALS_STATIC}).VIsual.item).item.ml_get_pos
								end
								from
								until
									(l_break)
								loop
									l_break := False
									if ((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 /= 101 then
										l_tmp___1 := ((l_s.c_pointer.to_integer_32).to_natural_32 <= (l_e.c_pointer.to_integer_32).to_natural_32).to_integer
									else
										l_tmp___1 := ((l_s.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32).to_integer
									end
									if not l_tmp___1.to_boolean then
										l_break := True
									end
									if not (l_break) then
										l_l := (create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_s])
										if l_l = 0 then
											l_bytes___0 := l_bytes___0 + 1
											l_chars := l_chars + 1
											l_break := True
										end
									end
									if not (l_break) then
										l_bytes___0 := l_bytes___0 + l_l
										l_chars := l_chars + 1
										l_s := l_s + l_l
									end
								end
								l_break := False
								if l_bytes___0 = l_chars then
									sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (showcmd_buf.item), ce_string ("%%d"), l_chars]).do_nothing
								else
									sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (showcmd_buf.item), ce_string ("%%d-%%d"), l_chars, l_bytes___0]).do_nothing
								end
							end
							showcmd_buf.item[10] := (('%/0/').code).to_natural_8
							showcmd_visual.item := 1
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						showcmd_buf.item[0] := (('%/0/').code).to_natural_8
						showcmd_visual.item := 0
						if showcmd_is_clear.item.to_boolean then
							l_return := True
						end
				when 5 then -- if done
					if not l_return then
						display_showcmd
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	add_to_showcmd (a_c: INTEGER_32): INTEGER_32
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_old_len: INTEGER_32
			l_extra_len: INTEGER_32
			l_overflow: INTEGER_32
			l_i___0: INTEGER_32
			l_return: BOOLEAN
		do
			if not ((create {P_OPTION_STATIC}).p_sc.item.item).to_boolean then
				Result := 0
				l_return := True
			elseif (create {P_GLOBALS_STATIC}).msg_silent.item /= 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				if showcmd_visual.item.to_boolean then
					showcmd_buf.item[0] := (('%/0/').code).to_natural_8
					showcmd_visual.item := 0
				end
				if a_c < 0 then
					l_i___0 := 0
					from
					until
						not (not (l_return) and then (ignore.item[l_i___0] /= 0))
					loop
						if ignore.item[l_i___0] = a_c then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_i___0 := l_i___0 + 1
						end
					end
				end
			end
			if not l_return then
				l_p___0 := (create {P_CHARSET_STATIC}).transchar (a_c)
				l_old_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (showcmd_buf.item))).to_integer_32
				l_extra_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0))).to_integer_32
				l_overflow := (l_old_len + l_extra_len) - 10
				if l_overflow > 0 then
					memmove (create {CE_VOID_POINTER}.make_cast (showcmd_buf.item), create {CE_VOID_POINTER}.make_cast ((showcmd_buf.item + l_overflow)), ((l_old_len - l_overflow) + 1).to_natural_32).do_nothing
				end
				strcat (create {CE_INTEGER_8_POINTER}.make_cast (showcmd_buf.item), create {CE_INTEGER_8_POINTER}.make_cast (l_p___0)).do_nothing
				if ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				display_showcmd
				Result := 1
			end
		end

	add_to_showcmd_c (a_c: INTEGER_32)
		do
			if not (add_to_showcmd (a_c)).to_boolean then
				(create {P_SCREEN_STATIC}).setcursor
			end
		end

	push_showcmd
		do
			if ((create {P_OPTION_STATIC}).p_sc.item.item).to_boolean then
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (old_showcmd_buf.item), create {CE_INTEGER_8_POINTER}.make_cast (showcmd_buf.item)).do_nothing
			end
		end

	pop_showcmd
		local
			l_return: BOOLEAN
		do
			if not ((create {P_OPTION_STATIC}).p_sc.item.item).to_boolean then
				l_return := True
			end
			if not l_return then
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (showcmd_buf.item), create {CE_INTEGER_8_POINTER}.make_cast (old_showcmd_buf.item)).do_nothing
				display_showcmd
			end
		end

	display_showcmd
		local
			l_len: INTEGER_32
		do
			(create {P_TERM_STATIC}).cursor_off
			l_len := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (showcmd_buf.item))).to_integer_32
			if l_len = 0 then
				showcmd_is_clear.item := 1
			else
				(create {P_SCREEN_STATIC}).screen_puts (showcmd_buf.item, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 1, (create {P_GLOBALS_STATIC}).sc_col.item, 0)
				showcmd_is_clear.item := 0
			end
			(create {P_SCREEN_STATIC}).screen_puts (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("          ")) + l_len, ((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 1, (create {P_GLOBALS_STATIC}).sc_col.item + l_len, 0);
			(create {P_SCREEN_STATIC}).setcursor
		end

	do_check_scrollbind (a_check: INTEGER_32)
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_check.to_boolean) then
						l_pos := -1 + 14 -- skip if block
					end
				when 1 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb).to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 2 then -- if:
						if not (((create {P_GLOBALS_STATIC}).did_syncbind.item).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:;
						(create {P_GLOBALS_STATIC}).did_syncbind.item := 0
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 5 then -- else:
						if not (((create {P_GLOBALS_STATIC}).curwin.item).is_equal (old_curwin.item)) then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer).is_equal (old_buf.item)) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 11
				when 9 then -- else:
						if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_diff).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 10 then -- if: | _L:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline /= old_topline.item then
							check_scrollbind ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline - old_topline.item, ((create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol - old_leftcol.item).to_integer_32)
						elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill /= old_topfill.item then
							check_scrollbind ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline - old_topline.item, ((create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol - old_leftcol.item).to_integer_32)
						elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol /= old_leftcol.item then
							check_scrollbind ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline - old_topline.item, ((create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol - old_leftcol.item).to_integer_32)
						end
				when 11 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						if (not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_sbo.item.item, ('j').code)).is_void) then
							check_scrollbind ((create {P_GLOBALS_STATIC}).curwin.item.item.w_topline - (create {P_GLOBALS_STATIC}).curwin.item.item.w_scbind_pos, 0)
						end
				when 13 then -- if done;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_scbind_pos := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
				when 14 then -- if done | if done
					old_curwin.item := (create {P_GLOBALS_STATIC}).curwin.item
					old_topline.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
					old_topfill.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
					old_buf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
					old_leftcol.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_scrollbind (a_topline_diff, a_leftcol_diff: INTEGER_32)
		local
			l_want_ver: INTEGER_32
			l_want_hor: INTEGER_32
			l_old_curwin___1: CE_POINTER [PD_WINDOW_S]
			l_old_curbuf: CE_POINTER [PD_FILE_BUFFER]
			l_old_VIsual_select: INTEGER_32
			l_old_VIsual_active: INTEGER_32
			l_tgt_leftcol: INTEGER_32
			l_topline: INTEGER_32
			l_y: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_old_curwin___1 := (create {P_GLOBALS_STATIC}).curwin.item
					l_old_curbuf := (create {P_GLOBALS_STATIC}).curbuf.item
					l_old_VIsual_select := (create {P_GLOBALS_STATIC}).VIsual_select.item
					l_old_VIsual_active := (create {P_GLOBALS_STATIC}).VIsual_active.item
					l_tgt_leftcol := (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol
					if (not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_sbo.item.item, ('v').code)).is_void) then
						if a_topline_diff /= 0 then
							l_tmp___0 := 1
						else
							l_tmp___0 := 0
						end
					else
						l_tmp___0 := 0
					end
					l_want_ver := l_tmp___0
					l_want_ver := (l_want_ver).bit_or ((l_old_curwin___1.item.w_onebuf_opt.wo_diff))
					if (not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_sbo.item.item, ('h').code)).is_void) then
						if a_leftcol_diff.to_boolean then
							l_tmp___2 := 1
						elseif a_topline_diff /= 0 then
							l_tmp___2 := 1
						else
							l_tmp___2 := 0
						end
					else
						l_tmp___2 := 0
					end
					l_want_hor := l_tmp___2;
					(create {P_GLOBALS_STATIC}).VIsual_active.item := 0;
					(create {P_GLOBALS_STATIC}).VIsual_select.item := (create {P_GLOBALS_STATIC}).VIsual_active.item;
					(create {P_GLOBALS_STATIC}).curwin.item := (create {P_GLOBALS_STATIC}).firstwin.item
				when 1 then -- loop condition:
					if ((create {P_GLOBALS_STATIC}).curwin.item).is_void then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:;
						(create {P_GLOBALS_STATIC}).curbuf.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_buffer
						if ((create {P_GLOBALS_STATIC}).curwin.item).is_equal (l_old_curwin___1) then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if not (((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb).to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 4 then -- if:
						if not (l_want_ver.to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if not ((l_old_curwin___1.item.w_onebuf_opt.wo_diff).to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_diff).to_boolean then
							l_old_curwin___1.item.diff_set_topline ((create {P_GLOBALS_STATIC}).curwin.item)
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_scbind_pos := (create {P_GLOBALS_STATIC}).curwin.item.item.w_scbind_pos + a_topline_diff
						l_topline := (create {P_GLOBALS_STATIC}).curwin.item.item.w_scbind_pos
						if l_topline > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							l_topline := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
						end
						if l_topline < 1 then
							l_topline := 1
						end
						l_y := l_topline - (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
						if l_y > 0 then
							(create {P_MOVE_STATIC}).scrollup (l_y, 0)
						else
							(create {P_MOVE_STATIC}).scrolldown (-l_y, 0)
						end
				when 9 then;
						(create {P_SCREEN_STATIC}).redraw_later (10);
						(create {P_MOVE_STATIC}).cursor_correct;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_status := 1
				when 10 then -- if done
						if l_want_hor.to_boolean then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol /= l_tgt_leftcol then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_leftcol := l_tgt_leftcol;
								(create {P_MISC2_STATIC}).leftcol_changed.do_nothing
							end
						end
				when 11 then -- if done | if done;
						(create {P_GLOBALS_STATIC}).curwin.item := (create {P_GLOBALS_STATIC}).curwin.item.item.w_next
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done;
					(create {P_GLOBALS_STATIC}).VIsual_select.item := l_old_VIsual_select;
					(create {P_GLOBALS_STATIC}).VIsual_active.item := l_old_VIsual_active;
					(create {P_GLOBALS_STATIC}).curwin.item := l_old_curwin___1;
					(create {P_GLOBALS_STATIC}).curbuf.item := l_old_curbuf
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	nv_nop (a_cap: CE_POINTER [PD_CMDARG_S])
		do
		end

	find_decl (a_ptr: CE_POINTER [NATURAL_8]; a_len, a_locally, a_thisblock, a_searchflags: INTEGER_32): INTEGER_32
		local
			l_pat: CE_POINTER [NATURAL_8]
			l_old_pos: PD_POS_T
			l_par_pos: PD_POS_T
			l_found_pos: PD_POS_T
			l_t: INTEGER_32
			l_save_p_ws: INTEGER_32
			l_save_p_scs: INTEGER_32
			l_retval: INTEGER_32
			l_incll: CE_ARRAY [INTEGER_32]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_pos___3: CE_POINTER [PD_POS_T]
			l_return, l_break, l_continue: BOOLEAN
		do
			create l_found_pos.make
			create {CE_INTEGER_32_ARRAY} l_incll.make (<<1>>)

			l_retval := 1
			l_pat := (create {P_MISC2_STATIC}).alloc ((a_len + 7).to_natural_32)
			if l_pat.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				if ((create {P_CHARSET_STATIC}).vim_iswordp (a_ptr)).to_boolean then
					l_tmp___0 := ce_string ("\V\<%%.*s\>")
				else
					l_tmp___0 := ce_string ("\V%%.*s")
				end
				sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_pat), l_tmp___0, a_len, a_ptr]).do_nothing
				l_old_pos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
				l_save_p_ws := (create {P_OPTION_STATIC}).p_ws.item.item
				l_save_p_scs := (create {P_OPTION_STATIC}).p_scs.item.item;
				(create {P_OPTION_STATIC}).p_ws.item.item := 0;
				(create {P_OPTION_STATIC}).p_scs.item.item := 0
				if not a_locally.to_boolean then
					(create {P_MARK_STATIC}).setpcmark;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (1).to_integer_32
					l_par_pos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
				elseif ((create {P_SEARCH_STATIC}).findpar (l_incll, -1, 1, ('{').code, 0)).to_boolean then
					l_par_pos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
					from
					until
						(l_break)
					loop
						l_break := False
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1 then
							if (((create {P_CHARSET_STATIC}).skipwhite (((create {P_MEMLINE_STATIC}).ml_get_curline))).item).to_integer_32 = 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1
						end
					end
					l_break := False
				else
					(create {P_MARK_STATIC}).setpcmark;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (1).to_integer_32
					l_par_pos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
				end
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
				l_found_pos.lnum := (0).to_integer_32
				l_found_pos.col := 0
				l_found_pos.coladd := 0
				from
				until
					(l_break)
				loop
					l_break := False
					l_continue := False
					l_t := (create {P_SEARCH_STATIC}).searchit ((create {P_GLOBALS_STATIC}).curwin.item, (create {P_GLOBALS_STATIC}).curbuf.item, create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")), 1, l_pat, 1, a_searchflags, 2, (0).to_integer_32, create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_shared (default_pointer))
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum >= l_old_pos.lnum then
						l_t := 0
					end
					if a_thisblock.to_boolean then
						if l_t /= 0 then
							l_pos___3 := (create {P_SEARCH_STATIC}).findmatchlimit (create {CE_CLASS_POINTER [PD_OPARG_S]}.make_shared (default_pointer), ('}').code, 2, ((l_old_pos.lnum - (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1).to_integer_32)
							if not l_pos___3.is_void then
								if l_pos___3.item.lnum < l_old_pos.lnum then
									l_continue := True
								end
							end
						end
					end
					if not (l_break or l_continue) and then (l_t = 0) then
						if l_found_pos.lnum /= 0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_found_pos.twin
							l_t := 1
						end
						l_break := True
					end
					if not (l_break or l_continue) then
						if ((create {P_MISC1_STATIC}).get_leader_len (((create {P_MEMLINE_STATIC}).ml_get_curline), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)) > 0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1;
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0
							l_continue := True
						end
					end
					if not (l_break or l_continue) and then (not a_locally.to_boolean) then
						l_break := True
					end
					if not (l_break or l_continue) and then ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum >= l_par_pos.lnum) then
						if l_found_pos.lnum /= 0 then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_found_pos.twin
						end
						l_break := True
					end
					if not (l_break or l_continue) then
						l_found_pos := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
					end
					if (not l_break) then
						
					end
				end
				l_break := False
				l_continue := False
				if l_t = 0 then
					l_retval := 0;
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := l_old_pos.twin
				else
					(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1;
					(create {P_SEARCH_STATIC}).reset_search_dir
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_pat));
				(create {P_OPTION_STATIC}).p_ws.item.item := l_save_p_ws;
				(create {P_OPTION_STATIC}).p_scs.item.item := l_save_p_scs
				Result := l_retval
			end
		end

	scroll_redraw (a_up: INTEGER_32; a_count___2: INTEGER_32)
		local
			l_prev_topline: INTEGER_32
			l_prev_topfill: INTEGER_32
			l_prev_lnum___1: INTEGER_32
			l_break: BOOLEAN
		do
			l_prev_topline := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
			l_prev_topfill := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill
			l_prev_lnum___1 := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
			if a_up.to_boolean then
				(create {P_MOVE_STATIC}).scrollup (a_count___2, 1)
			else
				(create {P_MOVE_STATIC}).scrolldown (a_count___2, 1)
			end
			if ((create {P_OPTION_STATIC}).p_so.item.item).to_boolean then
				(create {P_MOVE_STATIC}).cursor_correct;
				((create {P_GLOBALS_STATIC}).curwin.item).item.check_cursor_moved;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_or ((128))
				from
				until
					(l_break)
				loop
					l_break := False
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline = l_prev_topline then
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_topfill /= l_prev_topfill then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) then
						if a_up.to_boolean then
							if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > l_prev_lnum___1 then
								l_break := True
							elseif ((create {P_EDIT_STATIC}).cursor_down (1, 0)) = 0 then
								l_break := True
							end
						elseif (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < l_prev_lnum___1 then
							l_break := True
						elseif l_prev_topline = 1 then
							l_break := True
						elseif ((create {P_EDIT_STATIC}).cursor_up (1, 0)) = 0 then
							l_break := True
						end
					end
					if not (l_break) then
						((create {P_GLOBALS_STATIC}).curwin.item).item.check_cursor_moved;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_valid := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_valid).bit_or ((128))
					end
				end
				l_break := False
			end
			if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= l_prev_lnum___1 then
				(create {P_MISC2_STATIC}).coladvance ((create {P_GLOBALS_STATIC}).curwin.item.item.w_curswant).do_nothing
			end
			(create {P_SCREEN_STATIC}).redraw_later (10)
		end

	handle_tabmenu
		local
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect (create {P_GLOBALS_STATIC}).current_tabmenu.item -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 1
					if (create {P_GLOBALS_STATIC}).current_tab.item = 0 then
						(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tabclose"))).do_nothing
					else
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, ce_string ("tabclose %%d"), (create {P_GLOBALS_STATIC}).current_tab.item]).do_nothing;
						(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing
					end
					l_pos := -1 + 4 -- switch 1; break
				when 2 then -- switch 1, case 2
					if (create {P_GLOBALS_STATIC}).current_tab.item > 0 then
						l_tmp := (create {P_GLOBALS_STATIC}).current_tab.item - 1
					else
						l_tmp := 999
					end
					(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, ce_string ("%%dtabnew"), l_tmp]).do_nothing;
					(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing
					l_pos := -1 + 4 -- switch 1; break
				when 3 then -- switch 1, case 3
					if (create {P_GLOBALS_STATIC}).current_tab.item > 0 then
						l_tmp___0 := (create {P_GLOBALS_STATIC}).current_tab.item - 1
					else
						l_tmp___0 := 999
					end
					(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, ce_string ("browse %%dtabnew"), l_tmp___0]).do_nothing;
					(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing
					l_pos := -1 + 4 -- switch 1; break
				when 4 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	nv_exmode (a_cap: CE_POINTER [PD_CMDARG_S])
		do
			if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
				(create {P_MISC1_STATIC}).vim_beep
			elseif not ((a_cap.item.oap).item.checkclearop).to_boolean then
				(create {P_EX_DOCMD_STATIC}).do_exmode (0)
			end
		end

	nv_ctrlg (a_cap: CE_POINTER [PD_CMDARG_S])
		do
			if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
				(create {P_GLOBALS_STATIC}).VIsual_select.item := (not ((create {P_GLOBALS_STATIC}).VIsual_select.item).to_boolean).to_integer;
				(create {P_SCREEN_STATIC}).showmode.do_nothing
			elseif not ((a_cap.item.oap).item.checkclearop).to_boolean then
				(create {P_BUFFER_STATIC}).fileinfo ((a_cap.item.count0).to_integer_32, 0, 1)
			end
		end

	nv_ctrlh (a_cap: CE_POINTER [PD_CMDARG_S])
		do
			if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
				if ((create {P_GLOBALS_STATIC}).VIsual_select.item).to_boolean then
					a_cap.item.cmdchar := ('x').code
					a_cap.item.v_visop
				else
					nv_left (a_cap)
				end
			else
				nv_left (a_cap)
			end
		end

	nv_ctrlo (a_cap: CE_POINTER [PD_CMDARG_S])
		do
			if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
				if ((create {P_GLOBALS_STATIC}).VIsual_select.item).to_boolean then
					(create {P_GLOBALS_STATIC}).VIsual_select.item := 0;
					(create {P_SCREEN_STATIC}).showmode.do_nothing
					restart_VIsual_select.item := 2
				else
					a_cap.item.count1 := -a_cap.item.count1
					a_cap.item.nv_pcmark
				end
			else
				a_cap.item.count1 := -a_cap.item.count1
				a_cap.item.nv_pcmark
			end
		end

	do_nv_ident (a_c1, a_c2: INTEGER_32)
		local
			l_oa: CE_ARRAY [PD_OPARG_S]
			l_ca: CE_ARRAY [PD_CMDARG_S]
		do
			create {CE_CLASS_ARRAY [PD_OPARG_S]} l_oa.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_CMDARG_S]} l_ca.make (<<1>>);

			(create {P_OPS_STATIC}).clear_oparg (l_oa)
			memset (create {CE_VOID_POINTER}.make_cast (l_ca), 0, (create {PD_CMDARG_S}.make).structure_size.to_natural_32).do_nothing
			l_ca.item.oap := l_oa
			l_ca.item.cmdchar := a_c1
			l_ca.item.nchar := a_c2
			l_ca.item.nv_ident
		end

	get_visual_text (a_cap: CE_POINTER [PD_CMDARG_S]; a_pp: CE_POINTER [CE_POINTER [NATURAL_8]]; a_lenp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			if (create {P_GLOBALS_STATIC}).VIsual_mode.item /= 86 then
				unadjust_for_sel.do_nothing
			end
			if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
				if not a_cap.is_void then
					(a_cap.item.oap).item.clearopbeep
				end
				Result := 0
				l_return := True
			end
			if not l_return then
				if (create {P_GLOBALS_STATIC}).VIsual_mode.item = 86 then
					a_pp.item := (create {P_MEMLINE_STATIC}).ml_get_curline
					a_lenp.item := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_pp.item))).to_integer_32
				else
					if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum /= (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum then
						l_tmp___1 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum).to_integer
					else
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col /= (create {P_GLOBALS_STATIC}).VIsual.item.item.col then
							l_tmp___0 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col < (create {P_GLOBALS_STATIC}).VIsual.item.item.col).to_integer
						else
							l_tmp___0 := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd < (create {P_GLOBALS_STATIC}).VIsual.item.item.coladd).to_integer
						end
						l_tmp___1 := l_tmp___0
					end
					if l_tmp___1.to_boolean then
						a_pp.item := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))).item.ml_get_pos
						a_lenp.item := ((create {P_GLOBALS_STATIC}).VIsual.item.item.col - (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
					else
						a_pp.item := ((create {P_GLOBALS_STATIC}).VIsual.item).item.ml_get_pos
						a_lenp.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col - (create {P_GLOBALS_STATIC}).VIsual.item.item.col) + 1
					end
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						a_lenp.item := a_lenp.item + (((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([a_pp.item + (a_lenp.item - 1)])) - 1)
					end
				end
				reset_VIsual_and_resel
				Result := 1
			end
		end

	nv_right (a_cap: CE_POINTER [PD_CMDARG_S])
		local
			l_n: INTEGER_32
			l_PAST_LINE: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (6)).to_boolean then
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (4)).to_boolean then
							a_cap.item.arg := 1
						end
						a_cap.item.nv_wordcmd
						l_return := True
					end
					if l_return then
						l_pos := -1 + 24 -- skip if block
					end
				when 1 then -- if:;
						(a_cap.item.oap).item.motion_type := 0;
						(a_cap.item.oap).item.inclusive := 0
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							if ((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 /= 111 then
								l_tmp := 1
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
						l_PAST_LINE := l_tmp
						if ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
							l_PAST_LINE := 0
						end
						l_n := a_cap.item.count1
				when 2 then -- loop condition:
						if not (not (l_break) and then (l_n > 0)) then
							l_pos := -1 + 23 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						if l_PAST_LINE.to_boolean then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if ((create {P_EDIT_STATIC}).oneright) = 0 then
							l_pos := -1 + 8 -- goto _L___2
						else
							l_pos := -1 + 6 -- goto _L___4
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 6 then -- else: | _L___4:
						if not (l_PAST_LINE.to_boolean) then
							l_pos := -1 + 21 -- skip if block
						end
				when 7 then -- if:
						if (((create {P_MEMLINE_STATIC}).ml_get_cursor).item).to_integer_32 /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 8 then -- if: | _L___2:
						if a_cap.item.cmdchar /= 32 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_ww.item.item, ('s').code)).is_void then
							l_pos := -1 + 16 -- goto _L
						else
							l_pos := -1 + 11 -- goto _L___1
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 11 then -- else: | _L___1:
						if a_cap.item.cmdchar /= 108 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_ww.item.item, ('l').code)).is_void then
							l_pos := -1 + 16 -- goto _L
						else
							l_pos := -1 + 14 -- goto _L___0
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 14 then -- else: | _L___0:
						if a_cap.item.cmdchar /= -(107 + ((114).bit_shift_left (8))) then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_ww.item.item, ('>').code)).is_void then
							l_pos := -1 + 17 -- skip if block
						end
				when 16 then -- if: | _L:
						if (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum < (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
							if (a_cap.item.oap).item.op_type /= 0 then
								if not ((a_cap.item.oap).item.inclusive).to_boolean then
									if (((create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)).item).to_integer_32 = 0 then
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1;
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0;
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0;
										(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1;
										(a_cap.item.oap).item.inclusive := 0
									else
										(a_cap.item.oap).item.inclusive := 1
									end
								else
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1;
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0;
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0;
									(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1;
									(a_cap.item.oap).item.inclusive := 0
								end
							else
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) + 1;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := 0;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd := 0;
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1;
								(a_cap.item.oap).item.inclusive := 0
							end
							l_continue := True
						end
				when 17 then -- if done | if done | if done
						if not (l_break or l_continue) then
							if (a_cap.item.oap).item.op_type = 0 then
								if l_n = a_cap.item.count1 then
									(create {P_MISC1_STATIC}).beep_flush
								end
							elseif (((create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)).item).to_integer_32 /= 0 then
								(a_cap.item.oap).item.inclusive := 1
							end
							l_break := True
						end
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:
						l_pos := -1 + 21 -- goto _L___3
				when 20 then -- if done | if block done, skip else block:
						l_pos := -1 + 22
				when 21 then -- else: | _L___3:
						if l_PAST_LINE.to_boolean then
							(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
							if ((create {P_MISC2_STATIC}).virtual_active).to_boolean then
								(create {P_EDIT_STATIC}).oneright.do_nothing
							elseif ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col + ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([((create {P_MEMLINE_STATIC}).ml_get_cursor)]))
							else
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
							end
						end
				when 22 then -- if done
						if (not l_break) then
							l_n := l_n - 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 23 then -- loop done
						l_break := False
						l_continue := False
						if l_n /= a_cap.item.count1 then
							if (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 4)).to_boolean then
								if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
									if (a_cap.item.oap).item.op_type = 0 then
										(create {P_FOLD_STATIC}).foldOpenCursor
									end
								end
							end
						end
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	nv_left (a_cap: CE_POINTER [PD_CMDARG_S])
		local
			l_n: INTEGER_32
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (6)).to_boolean then
						if (((create {P_GLOBALS_STATIC}).mod_mask.item.item).bit_and (4)).to_boolean then
							a_cap.item.arg := 1
						end
						a_cap.item.nv_bck_word
						l_return := True
					end
					if l_return then
						l_pos := -1 + 31 -- skip if block
					end
				when 1 then -- if:;
						(a_cap.item.oap).item.motion_type := 0;
						(a_cap.item.oap).item.inclusive := 0
						l_n := a_cap.item.count1
				when 2 then -- loop condition:
						if not (not (l_break) and then (l_n > 0)) then
							l_pos := -1 + 30 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_continue := False
						if ((create {P_EDIT_STATIC}).oneleft) /= 0 then
							l_pos := -1 + 29 -- skip if block
						end
				when 4 then -- if:
						if a_cap.item.cmdchar /= -(107 + ((98).bit_shift_left (8))) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L___5
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 7 then -- else:
						if a_cap.item.cmdchar /= 8 then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if: | _L___5:
						if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_ww.item.item, ('b').code)).is_void then
							l_pos := -1 + 15 -- goto _L___1
						else
							l_pos := -1 + 10 -- goto _L___4
						end
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 10 then -- else: | _L___4:
						if a_cap.item.cmdchar /= 104 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_ww.item.item, ('h').code)).is_void then
							l_pos := -1 + 15 -- goto _L___1
						else
							l_pos := -1 + 13 -- goto _L___3
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 13 then -- else: | _L___3:
						if a_cap.item.cmdchar /= -(107 + ((108).bit_shift_left (8))) then
							l_pos := -1 + 27 -- skip if block
						end
				when 14 then -- if:
						if ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_ww.item.item, ('<').code)).is_void then
							l_pos := -1 + 25 -- skip if block
						end
				when 15 then -- if: | _L___1:
						if not ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum > 1) then
							l_pos := -1 + 23 -- skip if block
						end
				when 16 then -- if:;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum) - 1;
						(create {P_MISC2_STATIC}).coladvance ((2_147_483_647).to_integer_32).do_nothing;
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_set_curswant := 1
						if (a_cap.item.oap).item.op_type /= 1 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 19 then -- else:
						if (a_cap.item.oap).item.op_type /= 3 then
							l_pos := -1 + 21 -- skip if block
						end
				when 20 then -- if: | _L:
						if (((create {P_MEMLINE_STATIC}).ml_get ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum)).item).to_integer_32 /= 0 then
							if (((create {P_MEMLINE_STATIC}).ml_get_cursor).item).to_integer_32 /= 0 then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col) + 1
							end
							a_cap.item.retval := (a_cap.item.retval).bit_or ((2))
						end
				when 21 then -- if done
						l_continue := True
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 23 then -- else:
						l_pos := -1 + 27 -- goto _L___2
				when 24 then -- if done | if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_pos := -1 + 27 -- goto _L___2
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else: | _L___2:
						if (a_cap.item.oap).item.op_type = 0 then
							if l_n = a_cap.item.count1 then
								(create {P_MISC1_STATIC}).beep_flush
							end
						end
				when 28 then -- if done | if done | if done
						if not (l_break or l_continue) then
							l_break := True
						end
				when 29 then -- if done
						if (not l_break) then
							l_n := l_n - 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 30 then -- loop done
						l_break := False
						l_continue := False
						if l_n /= a_cap.item.count1 then
							if (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 4)).to_boolean then
								if ((create {P_GLOBALS_STATIC}).KeyTyped.item).to_boolean then
									if (a_cap.item.oap).item.op_type = 0 then
										(create {P_FOLD_STATIC}).foldOpenCursor
									end
								end
							end
						end
				when 31 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	start_selection
		do
			may_start_select (('k').code)
			n_start_visual_mode (('v').code)
		end

	may_start_select (a_c: INTEGER_32)
		local
			l_tmp___2: INTEGER_32
		do
			if ((create {P_GETCHAR_STATIC}).stuff_empty).to_boolean then
				if ((create {P_GETCHAR_STATIC}).typebuf_typed).to_boolean then
					if not ((create {P_MISC2_STATIC}).vim_strchr ((create {P_OPTION_STATIC}).p_slm.item.item, a_c)).is_void then
						l_tmp___2 := 1
					else
						l_tmp___2 := 0
					end
				else
					l_tmp___2 := 0
				end
			else
				l_tmp___2 := 0
			end
			(create {P_GLOBALS_STATIC}).VIsual_select.item := l_tmp___2
		end

	n_start_visual_mode (a_c: INTEGER_32)
		do
			(create {P_GLOBALS_STATIC}).VIsual_mode.item := a_c;
			(create {P_GLOBALS_STATIC}).VIsual_active.item := 1;
			(create {P_GLOBALS_STATIC}).VIsual_reselect.item := 1
			if a_c = 22 then
				if (((create {P_OPTION_STATIC}).ve_flags.item.item).bit_and ({NATURAL_32} 5)).to_boolean then
					if ((create {P_MISC1_STATIC}).gchar_cursor) = 9 then
						(create {P_MISC2_STATIC}).coladvance ((create {P_GLOBALS_STATIC}).curwin.item.item.w_virtcol).do_nothing
					end
				end
			end
			(create {P_GLOBALS_STATIC}).VIsual.item.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin;
			(create {P_FOLD_STATIC}).foldAdjustVisual;
			(create {P_TERM_STATIC}).setmouse
			if ((create {P_OPTION_STATIC}).p_smd.item.item).to_boolean then
				if (create {P_GLOBALS_STATIC}).msg_silent.item = 0 then
					(create {P_GLOBALS_STATIC}).redraw_cmdline.item := 1
				end
			end
			(create {P_GLOBALS_STATIC}).clip_star.item.item.vmode := ('%/0/').code
			if (create {P_GLOBALS_STATIC}).curwin.item.item.w_redr_type < 20 then
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_old_cursor_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum;
				(create {P_GLOBALS_STATIC}).curwin.item.item.w_old_visual_lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
			end
		end

	unadjust_for_sel: INTEGER_32
		local
			l_pp: CE_POINTER [PD_POS_T]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if ((create {P_OPTION_STATIC}).p_sel.item.item.item).to_integer_32 /= 101 then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if (create {P_GLOBALS_STATIC}).VIsual.item.item.col = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
							if (create {P_GLOBALS_STATIC}).VIsual.item.item.coladd /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd then
								l_pos := -1 + 4 -- goto _L___0
							end
						else
							l_pos := -1 + 4 -- goto _L___0
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L___0:
						if (create {P_GLOBALS_STATIC}).VIsual.item.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							l_tmp___0 := ((create {P_GLOBALS_STATIC}).VIsual.item.item.lnum < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum).to_integer
						else
							if (create {P_GLOBALS_STATIC}).VIsual.item.item.col /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
								l_tmp := ((create {P_GLOBALS_STATIC}).VIsual.item.item.col < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col).to_integer
							else
								l_tmp := ((create {P_GLOBALS_STATIC}).VIsual.item.item.coladd < (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd).to_integer
							end
							l_tmp___0 := l_tmp
						end
						if l_tmp___0.to_boolean then
							l_pp := create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor"))
						else
							l_pp := (create {P_GLOBALS_STATIC}).VIsual.item
						end
						if l_pp.item.coladd > 0 then
							l_pp.item.coladd := (l_pp.item.coladd) - 1
						elseif l_pp.item.col > 0 then
							l_pp.item.col := (l_pp.item.col) - 1
							l_pp.item.mb_adjustpos
						elseif l_pp.item.lnum > 1 then
							l_pp.item.lnum := (l_pp.item.lnum) - 1
							l_pp.item.col := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_MEMLINE_STATIC}).ml_get (l_pp.item.lnum))))).to_integer_32
							Result := 1
							l_return := True
						end
				when 5 then -- if done
					if not l_return then
						Result := 0
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	nv_select (a_cap: CE_POINTER [PD_CMDARG_S])
		do
			if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
				(create {P_GLOBALS_STATIC}).VIsual_select.item := 1
			elseif ((create {P_GLOBALS_STATIC}).VIsual_reselect.item).to_boolean then
				a_cap.item.nchar := ('v').code
				a_cap.item.arg := 1
				a_cap.item.nv_g_cmd
			end
		end

	nv_drop (a_cap: CE_POINTER [PD_CMDARG_S])
		do
			(create {P_OPS_STATIC}).do_put (('~').code, -1, 1, 2)
		end

feature {ANY} -- routine addresses

	nv_compare_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nv_compare)
		end

	nv_nop_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nv_nop)
		end

	nv_exmode_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nv_exmode)
		end

	nv_ctrlg_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nv_ctrlg)
		end

	nv_ctrlh_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nv_ctrlh)
		end

	nv_ctrlo_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nv_ctrlo)
		end

	nv_right_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nv_right)
		end

	nv_left_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nv_left)
		end

	nv_select_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nv_select)
		end

	nv_drop_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent nv_drop)
		end

end
