class
	PD_EXARG_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- routine addresses

	ex_buffer_all_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_buffer_all
				end)
		end

	ex_let_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_let
				end)
		end

	ex_call_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_call
				end)
		end

	ex_unlet_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_unlet
				end)
		end

	ex_lockvar_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_lockvar
				end)
		end

	ex_echo_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_echo
				end)
		end

	ex_echohl_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_echohl
				end)
		end

	ex_execute_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_execute
				end)
		end

	ex_function_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_function
				end)
		end

	ex_delfunction_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_delfunction
				end)
		end

	ex_return_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_return
				end)
		end

	ex_align_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_align
				end)
		end

	ex_sort_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_sort
				end)
		end

	ex_file_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_file
				end)
		end

	ex_write_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_write
				end)
		end

	ex_wnext_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_wnext
				end)
		end

	do_wqall_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.do_wqall
				end)
		end

	ex_append_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_append
				end)
		end

	ex_change_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_change
				end)
		end

	ex_z_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_z
				end)
		end

	do_sub_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.do_sub
				end)
		end

	ex_helptags_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_helptags
				end)
		end

	ex_sign_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_sign
				end)
		end

	ex_drop_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_drop
				end)
		end

	ex_debug_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_debug
				end)
		end

	ex_breakadd_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_breakadd
				end)
		end

	ex_debuggreedy_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_debuggreedy
				end)
		end

	ex_breakdel_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_breakdel
				end)
		end

	ex_args_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_args
				end)
		end

	ex_previous_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_previous
				end)
		end

	ex_argument_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_argument
				end)
		end

	ex_next_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_next
				end)
		end

	ex_argedit_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_argedit
				end)
		end

	ex_argadd_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_argadd
				end)
		end

	ex_argdelete_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_argdelete
				end)
		end

	ex_listdo_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_listdo
				end)
		end

	ex_compiler_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_compiler
				end)
		end

	ex_runtime_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_runtime
				end)
		end

	ex_source_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_source
				end)
		end

	ex_scriptencoding_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_scriptencoding
				end)
		end

	ex_finish_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_finish
				end)
		end

	ex_checktime_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_checktime
				end)
		end

	ex_language_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_language
				end)
		end

	ex_ni_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_ni
				end)
		end

	ex_script_ni_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_script_ni
				end)
		end

	ex_mapclear_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_mapclear
				end)
		end

	ex_abclear_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_abclear
				end)
		end

	ex_autocmd_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_autocmd
				end)
		end

	ex_doautocmd_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_doautocmd
				end)
		end

	ex_bunload_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_bunload
				end)
		end

	ex_buffer_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_buffer
				end)
		end

	ex_bmodified_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_bmodified
				end)
		end

	ex_bnext_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_bnext
				end)
		end

	ex_bprevious_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_bprevious
				end)
		end

	ex_brewind_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_brewind
				end)
		end

	ex_blast_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_blast
				end)
		end

	ex_command_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_command
				end)
		end

	ex_colorscheme_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_colorscheme
				end)
		end

	ex_highlight_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_highlight
				end)
		end

	ex_only_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_only
				end)
		end

	ex_all_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_all
				end)
		end

	ex_hide_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_hide
				end)
		end

	ex_goto_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_goto
				end)
		end

	ex_recover_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_recover
				end)
		end

	ex_wrongmodifier_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_wrongmodifier
				end)
		end

	ex_splitview_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_splitview
				end)
		end

	ex_tabnext_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_tabnext
				end)
		end

	ex_tabmove_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_tabmove
				end)
		end

	ex_mode_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_mode
				end)
		end

	ex_resize_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_resize
				end)
		end

	ex_find_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_find
				end)
		end

	ex_open_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_open
				end)
		end

	ex_popup_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_popup
				end)
		end

	ex_read_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_read
				end)
		end

	ex_cd_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_cd
				end)
		end

	ex_equal_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_equal
				end)
		end

	ex_sleep_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_sleep
				end)
		end

	ex_winsize_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_winsize
				end)
		end

	ex_wincmd_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_wincmd
				end)
		end

	ex_winpos_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_winpos
				end)
		end

	ex_operators_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_operators
				end)
		end

	ex_put_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_put
				end)
		end

	ex_copymove_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_copymove
				end)
		end

	ex_submagic_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_submagic
				end)
		end

	ex_join_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_join
				end)
		end

	ex_at_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_at
				end)
		end

	ex_bang_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_bang
				end)
		end

	ex_undo_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_undo
				end)
		end

	ex_wundo_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_wundo
				end)
		end

	ex_rundo_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_rundo
				end)
		end

	ex_later_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_later
				end)
		end

	ex_redir_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_redir
				end)
		end

	ex_redraw_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_redraw
				end)
		end

	ex_redrawstatus_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_redrawstatus
				end)
		end

	ex_mkrc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_mkrc
				end)
		end

	ex_mark_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_mark
				end)
		end

	ex_startinsert_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_startinsert
				end)
		end

	ex_checkpath_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_checkpath
				end)
		end

	ex_findpat_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_findpat
				end)
		end

	ex_ptag_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_ptag
				end)
		end

	ex_stag_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_stag
				end)
		end

	ex_tag_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_tag
				end)
		end

	ex_loadview_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_loadview
				end)
		end

	ex_viminfo_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_viminfo
				end)
		end

	ex_behave_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_behave
				end)
		end

	ex_filetype_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_filetype
				end)
		end

	ex_digraphs_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_digraphs
				end)
		end

	ex_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_set
				end)
		end

	ex_match_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_match
				end)
		end

	ex_foldopen_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_foldopen
				end)
		end

	ex_folddo_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_folddo
				end)
		end

	ex_if_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_if
				end)
		end

	ex_endif_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_endif
				end)
		end

	ex_else_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_else
				end)
		end

	ex_while_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_while
				end)
		end

	ex_continue_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_continue
				end)
		end

	ex_break_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_break
				end)
		end

	ex_endwhile_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_endwhile
				end)
		end

	ex_throw_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_throw
				end)
		end

	ex_try_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_try
				end)
		end

	ex_catch_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_catch
				end)
		end

	ex_finally_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_finally
				end)
		end

	ex_endtry_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_endtry
				end)
		end

	ex_history_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_history
				end)
		end

	ex_hardcopy_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_hardcopy
				end)
		end

	do_marks_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.do_marks
				end)
		end

	ex_delmarks_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_delmarks
				end)
		end

	ex_menu_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_menu
				end)
		end

	ex_emenu_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_emenu
				end)
		end

	ex_menutranslate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_menutranslate
				end)
		end

	ex_display_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_display
				end)
		end

	qf_list_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.qf_list
				end)
		end

	qf_age_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.qf_age
				end)
		end

	ex_cwindow_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_cwindow
				end)
		end

	ex_cclose_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_cclose
				end)
		end

	ex_copen_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_copen
				end)
		end

	ex_make_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_make
				end)
		end

	ex_cc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_cc
				end)
		end

	ex_cnext_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_cnext
				end)
		end

	ex_cfile_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_cfile
				end)
		end

	ex_vimgrep_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_vimgrep
				end)
		end

	ex_cbuffer_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_cbuffer
				end)
		end

	ex_cexpr_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_cexpr
				end)
		end

	ex_helpgrep_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_helpgrep
				end)
		end

	ex_mkspell_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_mkspell
				end)
		end

	ex_spell_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_spell
				end)
		end

	syn_cmd_case_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_case (a_syncing)
				end)
		end

	syn_cmd_spell_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_spell (a_syncing)
				end)
		end

	syn_cmd_clear_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_clear (a_syncing)
				end)
		end

	syn_cmd_reset_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_reset (a_syncing)
				end)
		end

	syn_cmd_list_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_list (a_syncing)
				end)
		end

	syn_cmd_include_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_include (a_syncing)
				end)
		end

	syn_cmd_keyword_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_keyword (a_syncing)
				end)
		end

	syn_cmd_match_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_match (a_syncing)
				end)
		end

	syn_cmd_region_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_region (a_syncing)
				end)
		end

	syn_cmd_cluster_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_cluster (a_syncing)
				end)
		end

	syn_cmd_sync_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_sync (a_syncing)
				end)
		end

	ex_syntax_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_syntax
				end)
		end

	ex_ownsyntax_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_ownsyntax
				end)
		end

	ex_gui_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_gui
				end)
		end

	ex_nbkey_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_nbkey
				end)
		end

	ex_nbstart_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_nbstart
				end)
		end

	ex_version_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_version
				end)
		end

	ex_abbreviate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_abbreviate
				end)
		end

	ex_map_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_map
				end)
		end

	ex_unmap_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_unmap
				end)
		end

	ex_psearch_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG])
				do
					a_eap.item.ex_psearch
				end)
		end

	syn_cmd_on_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_on (a_syncing)
				end)
		end

	syn_cmd_enable_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_enable (a_syncing)
				end)
		end

	syn_cmd_manual_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_manual (a_syncing)
				end)
		end

	syn_cmd_off_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_eap: CE_POINTER [PD_EXARG]; a_syncing: INTEGER_32)
				do
					a_eap.item.syn_cmd_off (a_syncing)
				end)
		end

	ex_rewind_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (create {PD_EXARG}.make).ex_rewind)
		end

	ex_options_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (create {PD_EXARG}.make).ex_options)
		end

	ex_pwd_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (create {PD_EXARG}.make).ex_pwd)
		end

	getexmodeline_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (create {PD_EXARG}.make).getexmodeline)
		end

end
