class
	PD_FORINFO_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create fi_lw.make
			create {CE_CLASS_POINTER [PD_LISTVAR_S]} fi_list.make
		end

feature {ANY} -- fields

	fi_semicolon: INTEGER_32 assign set_fi_semicolon

	fi_varcount: INTEGER_32 assign set_fi_varcount

	fi_lw: PD_LISTWATCH_S assign set_fi_lw

	fi_list: CE_POINTER [PD_LISTVAR_S] assign set_fi_list

feature {ANY} -- field setters

	set_fi_semicolon (a_fi_semicolon: INTEGER_32)
		do
			fi_semicolon := a_fi_semicolon
			update_memory_field ("fi_semicolon")
		end

	set_fi_varcount (a_fi_varcount: INTEGER_32)
		do
			fi_varcount := a_fi_varcount
			update_memory_field ("fi_varcount")
		end

	set_fi_lw (a_fi_lw: PD_LISTWATCH_S)
		do
			fi_lw := a_fi_lw
			update_memory_field ("fi_lw")
		end

	set_fi_list (a_fi_list: CE_POINTER [PD_LISTVAR_S])
		do
			fi_list := a_fi_list
			update_memory_field ("fi_list")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fi_semicolon := a_other.fi_semicolon
			fi_varcount := a_other.fi_varcount
			fi_lw := a_other.fi_lw.twin
			fi_list := a_other.fi_list
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fi_semicolon = a_other.fi_semicolon and
				fi_varcount = a_other.fi_varcount and
				fi_lw.is_equal (a_other.fi_lw) and
				fi_list.is_equal (a_other.fi_list)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fi_semicolon"),
					create {CE_STRUCTURE_FIELD}.make ("fi_varcount"),
					create {CE_STRUCTURE_FIELD}.make ("fi_lw"),
					create {CE_STRUCTURE_FIELD}.make ("fi_list")
				>>)
			init_structure_info
		end

end
