class
	PD_LIMITSCORE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {ANY} -- fields

	badi: INTEGER_32 assign set_badi

	goodi: INTEGER_32 assign set_goodi

	score: INTEGER_32 assign set_score

feature {ANY} -- field setters

	set_badi (a_badi: INTEGER_32)
		do
			badi := a_badi
			update_memory_field ("badi")
		end

	set_goodi (a_goodi: INTEGER_32)
		do
			goodi := a_goodi
			update_memory_field ("goodi")
		end

	set_score (a_score: INTEGER_32)
		do
			score := a_score
			update_memory_field ("score")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			badi := a_other.badi
			goodi := a_other.goodi
			score := a_other.score
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				badi = a_other.badi and
				goodi = a_other.goodi and
				score = a_other.score
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("badi"),
					create {CE_STRUCTURE_FIELD}.make ("goodi"),
					create {CE_STRUCTURE_FIELD}.make ("score")
				>>)
			init_structure_info
		end

end
