class
	PD_REGSAVE_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create rs_u.make
		end

feature {ANY} -- fields

	rs_u: PD_RS_U assign set_rs_u

	rs_len: INTEGER_32 assign set_rs_len

feature {ANY} -- field setters

	set_rs_u (a_rs_u: PD_RS_U)
		do
			rs_u := a_rs_u
			update_memory_field ("rs_u")
		end

	set_rs_len (a_rs_len: INTEGER_32)
		do
			rs_len := a_rs_len
			update_memory_field ("rs_len")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			rs_u := a_other.rs_u.twin
			rs_len := a_other.rs_len
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				rs_u.is_equal (a_other.rs_u) and
				rs_len = a_other.rs_len
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("rs_u"),
					create {CE_STRUCTURE_FIELD}.make ("rs_len")
				>>)
			init_structure_info
		end

end
