class
	PD_YANKREG

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_POINTER_POINTER [NATURAL_8]} y_array.make
			Precursor
		end

feature {ANY} -- fields

	y_array: CE_POINTER [CE_POINTER [NATURAL_8]] assign set_y_array

	y_size: INTEGER_32 assign set_y_size

	y_type: NATURAL_8 assign set_y_type

	y_width: INTEGER_32 assign set_y_width

feature {ANY} -- field setters

	set_y_array (a_y_array: CE_POINTER [CE_POINTER [NATURAL_8]])
		do
			y_array := a_y_array
			update_memory_field ("y_array")
		end

	set_y_size (a_y_size: INTEGER_32)
		do
			y_size := a_y_size
			update_memory_field ("y_size")
		end

	set_y_type (a_y_type: NATURAL_8)
		do
			y_type := a_y_type
			update_memory_field ("y_type")
		end

	set_y_width (a_y_width: INTEGER_32)
		do
			y_width := a_y_width
			update_memory_field ("y_width")
		end

feature {ANY} -- public routines

	str_to_reg (a_type: INTEGER_32; a_str___1: CE_POINTER [NATURAL_8]; a_len, a_blocklen: INTEGER_32)
		local
			l_lnum: INTEGER_32
			l_start___1: INTEGER_32
			l_i___0: INTEGER_32
			l_extra: INTEGER_32
			l_newlines: INTEGER_32
			l_extraline: INTEGER_32
			l_append: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_pp: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_maxlen: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_extraline := 0
			l_append := 0
			if y_array.is_void then
				Current.y_size := (0).to_integer_32
				update_class_fields -- Current might have been changed; synchronize
			end
			l_newlines := 0
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_len)
			loop
				if (a_str___1[l_i___0]).to_integer_32 = 10 then
					l_newlines := l_newlines + 1
				end
				l_i___0 := l_i___0 + 1
			end
			if a_type = 0 then
				l_extraline := 1
				l_newlines := l_newlines + 1
			elseif a_len = 0 then
				l_extraline := 1
				l_newlines := l_newlines + 1
			elseif (a_str___1[(a_len - 1)]).to_integer_32 /= 10 then
				l_extraline := 1
				l_newlines := l_newlines + 1
			end
			if y_size > 0 then
				if y_type.to_integer_32 = 0 then
					l_append := 1
					l_newlines := l_newlines - 1
				end
			end
			l_tmp := (create {P_MISC2_STATIC}).lalloc_clear ((y_size + l_newlines.to_integer_32).to_natural_32 * ({PLATFORM}.Pointer_bytes.to_natural_32).to_natural_32, 1)
			update_class_fields -- Current might have been changed; synchronize
			l_pp := create {CE_POINTER_POINTER [NATURAL_8]}.make_cast (l_tmp)
			if l_pp.is_void then
				l_return := True
			end
			if not l_return then
				l_lnum := 0
				from
				until
					not (l_lnum.to_integer_32 < y_size)
				loop
					l_pp[l_lnum] := y_array[l_lnum]
					update_class_fields -- Current might have been changed; synchronize
					l_lnum := l_lnum + 1
				end
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (y_array))
				update_class_fields -- Current might have been changed; synchronize
				Current.y_array := l_pp
				update_class_fields -- Current might have been changed; synchronize
				l_maxlen := 0
				l_start___1 := 0
				from
				until
					not (not (l_return or l_break) and then (l_start___1 < a_len + l_extraline.to_integer_32))
				loop
					l_break := False
					l_i___0 := l_start___1
					from
					until
						not (not (l_break) and then (l_i___0 < a_len))
					loop
						l_break := False
						if (a_str___1[l_i___0]).to_integer_32 = 10 then
							l_break := True
						end
						if not (l_break) then
							l_i___0 := l_i___0 + 1
						end
					end
					l_break := False
					l_i___0 := l_i___0 - l_start___1
					if l_i___0 > l_maxlen then
						l_maxlen := l_i___0
					end
					if l_append.to_boolean then
						l_lnum := l_lnum - 1
						l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (y_array[l_lnum]))
						update_class_fields -- Current might have been changed; synchronize
						l_extra := l_tmp___0.to_integer_32
					else
						l_extra := 0
					end
					l_s := (create {P_MISC2_STATIC}).alloc (((l_i___0 + l_extra.to_integer_32) + 1).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
					if l_s.is_void then
						l_break := True
					end
					if not (l_return or l_break) then
						if l_extra.to_boolean then
							memmove (create {CE_VOID_POINTER}.make_cast (l_s), create {CE_VOID_POINTER}.make_cast (y_array[l_lnum]), l_extra.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_append.to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (y_array[l_lnum]))
							update_class_fields -- Current might have been changed; synchronize
						end
						if l_i___0.to_boolean then
							memmove (create {CE_VOID_POINTER}.make_cast ((l_s + l_extra)), create {CE_VOID_POINTER}.make_cast ((a_str___1 + l_start___1)), l_i___0.to_natural_32).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						l_extra := (l_extra.to_integer_32 + l_i___0).to_integer_32
						l_s[l_extra] := (('%/0/').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___1 := l_lnum
						l_lnum := l_lnum + 1
						y_array[l_tmp___1] := l_s
						update_class_fields -- Current might have been changed; synchronize
						from
						until
							(l_break)
						loop
							l_break := False
							l_extra := l_extra - 1
							if not (l_extra >= 0) then
								l_break := True
							end
							if not (l_break) then
								if (l_s.item).to_integer_32 = 0 then
									l_s.item := (('%N').code).to_natural_8
									update_class_fields -- Current might have been changed; synchronize
								end
								l_s := l_s + 1
							end
						end
						l_break := False
						l_append := 0
						l_start___1 := l_start___1 + (l_i___0 + 1)
					end
				end
				l_break := False
				Current.y_type := a_type.to_natural_8
				update_class_fields -- Current might have been changed; synchronize
				Current.y_size := l_lnum.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				if a_type = 2 then
					if a_blocklen < 0 then
						Current.y_width := (l_maxlen - 1).to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					else
						Current.y_width := a_blocklen.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					Current.y_width := 0
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			y_array := a_other.y_array
			y_size := a_other.y_size
			y_type := a_other.y_type
			y_width := a_other.y_width
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				y_array.is_equal (a_other.y_array) and
				y_size = a_other.y_size and
				y_type = a_other.y_type and
				y_width = a_other.y_width
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("y_array"),
					create {CE_STRUCTURE_FIELD}.make ("y_size"),
					create {CE_STRUCTURE_FIELD}.make ("y_type"),
					create {CE_STRUCTURE_FIELD}.make ("y_width")
				>>)
			init_structure_info
		end

end
