class
	S_X11_SM_SMLIB_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	SmcOpenConnection (a_arg1: CE_POINTER [INTEGER_8]; a_arg2: CE_POINTER [ANY]; a_arg3, a_arg4: INTEGER_32; a_arg5: NATURAL_32; a_arg6: CE_POINTER [SD_SMCCALLBACKS]; a_arg7: CE_POINTER [INTEGER_8]; a_arg8: CE_POINTER [CE_POINTER [INTEGER_8]]; a_arg9: INTEGER_32; a_arg10: CE_POINTER [INTEGER_8]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_SmcOpenConnection (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3, a_arg4, a_arg5, a_arg6.c_pointer, a_arg7.c_pointer, a_arg8.c_pointer, a_arg9, a_arg10.c_pointer))
		end

	c_SmcOpenConnection (a_arg1: POINTER; a_arg2: POINTER; a_arg3: INTEGER_32; a_arg4: INTEGER_32; a_arg5: NATURAL_32; a_arg6: POINTER; a_arg7: POINTER; a_arg8: POINTER; a_arg9: INTEGER_32; a_arg10: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)SmcOpenConnection($a_arg1, $a_arg2, $a_arg3, $a_arg4, $a_arg5, $a_arg6, $a_arg7, $a_arg8, $a_arg9, $a_arg10);"
		end

	SmcCloseConnection (a_arg1: CE_POINTER [ANY]; a_arg2: INTEGER_32; a_arg3: CE_POINTER [CE_POINTER [INTEGER_8]]): NATURAL_32
		do
			Result := c_SmcCloseConnection (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer)
		end

	c_SmcCloseConnection (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return SmcCloseConnection($a_arg1, $a_arg2, $a_arg3);"
		end

	SmcInteractRequest (a_arg1: CE_POINTER [ANY]; a_arg2: INTEGER_32; a_arg3: CE_ROUTINE; a_arg4: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_SmcInteractRequest (a_arg1.c_pointer, a_arg2, a_arg3.c_pointer, a_arg4.c_pointer)
		end

	c_SmcInteractRequest (a_arg1: POINTER; a_arg2: INTEGER_32; a_arg3: POINTER; a_arg4: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return SmcInteractRequest($a_arg1, $a_arg2, $a_arg3, $a_arg4);"
		end

	SmcInteractDone (a_arg1: CE_POINTER [ANY]; a_arg2: INTEGER_32)
		do
			c_SmcInteractDone (a_arg1.c_pointer, a_arg2)
		end

	c_SmcInteractDone (a_arg1: POINTER; a_arg2: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"SmcInteractDone($a_arg1, $a_arg2);"
		end

	SmcSaveYourselfDone (a_arg1: CE_POINTER [ANY]; a_arg2: INTEGER_32)
		do
			c_SmcSaveYourselfDone (a_arg1.c_pointer, a_arg2)
		end

	c_SmcSaveYourselfDone (a_arg1: POINTER; a_arg2: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"SmcSaveYourselfDone($a_arg1, $a_arg2);"
		end

	SmcGetIceConnection (a_arg1: CE_POINTER [ANY]): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_SmcGetIceConnection (a_arg1.c_pointer))
		end

	c_SmcGetIceConnection (a_arg1: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return (EIF_POINTER)SmcGetIceConnection($a_arg1);"
		end

end
