class
	SD_GTKIMAGEPIXBUFDATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_VOID_POINTER} pixbuf.make
		end

feature {ANY} -- fields

	pixbuf: CE_POINTER [ANY] assign set_pixbuf

feature {ANY} -- field setters

	set_pixbuf (a_pixbuf: CE_POINTER [ANY])
		do
			pixbuf := a_pixbuf
			update_memory_field ("pixbuf")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			pixbuf := a_other.pixbuf
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				pixbuf.is_equal (a_other.pixbuf)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("pixbuf")
				>>)
			init_structure_info
		end

end
