class
	SD_PANGOATTRINT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create attr.make
		end

feature {ANY} -- fields

	attr: SD_PANGOATTRIBUTE assign set_attr

	value: INTEGER_32 assign set_value

feature {ANY} -- field setters

	set_attr (a_attr: SD_PANGOATTRIBUTE)
		do
			attr := a_attr
			update_memory_field ("attr")
		end

	set_value (a_value: INTEGER_32)
		do
			value := a_value
			update_memory_field ("value")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			attr := a_other.attr.twin
			value := a_other.value
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				attr.is_equal (a_other.attr) and
				value = a_other.value
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("attr"),
					create {CE_STRUCTURE_FIELD}.make ("value")
				>>)
			init_structure_info
		end

end
