class
	SD_XCLASSHINT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} res_name.make
			create {CE_INTEGER_8_POINTER} res_class.make
		end

feature {ANY} -- fields

	res_name: CE_POINTER [INTEGER_8] assign set_res_name

	res_class: CE_POINTER [INTEGER_8] assign set_res_class

feature {ANY} -- field setters

	set_res_name (a_res_name: CE_POINTER [INTEGER_8])
		do
			res_name := a_res_name
			update_memory_field ("res_name")
		end

	set_res_class (a_res_class: CE_POINTER [INTEGER_8])
		do
			res_class := a_res_class
			update_memory_field ("res_class")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			res_name := a_other.res_name
			res_class := a_other.res_class
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				res_name.is_equal (a_other.res_name) and
				res_class.is_equal (a_other.res_class)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("res_name"),
					create {CE_STRUCTURE_FIELD}.make ("res_class")
				>>)
			init_structure_info
		end

end
