class
	P_FILEINFO_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC

feature {ANY} -- public routines

	Curl_fileinfo_alloc: CE_POINTER [PD_CURL_FILEINFO]
		local
			l_tmp: CE_POINTER [PD_CURL_FILEINFO]
			l_return: BOOLEAN
		do
			l_tmp := create {CE_CLASS_POINTER [PD_CURL_FILEINFO]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(create {PD_CURL_FILEINFO}.make).structure_size.to_natural_32]))))
			if l_tmp.is_void then
				Result := (create {CE_CLASS_POINTER [PD_CURL_FILEINFO]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				memset (create {CE_VOID_POINTER}.make_cast (l_tmp), 0, (create {PD_CURL_FILEINFO}.make).structure_size.to_natural_32).do_nothing
				Result := l_tmp
			end
		end

	Curl_fileinfo_dtor (a_user, a_element: CE_POINTER [ANY])
		local
			l_finfo: CE_POINTER [PD_CURL_FILEINFO]
			l_return: BOOLEAN
		do
			l_finfo := create {CE_CLASS_POINTER [PD_CURL_FILEINFO]}.make_cast (a_element)
			if l_finfo.is_void then
				l_return := True
			end
			if not l_return then
				if (not (l_finfo.item.b_data).is_void) then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_finfo.item.b_data)])
				end
				(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_finfo)])
			end
		end

	Curl_fileinfo_dup (a_src: CE_POINTER [PD_CURL_FILEINFO]): CE_POINTER [PD_CURL_FILEINFO]
		local
			l_ptr: CE_POINTER [PD_CURL_FILEINFO]
			l_return: BOOLEAN
		do
			l_ptr := create {CE_CLASS_POINTER [PD_CURL_FILEINFO]}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(create {PD_CURL_FILEINFO}.make).structure_size.to_natural_32]))))
			if l_ptr.is_void then
				Result := (create {CE_CLASS_POINTER [PD_CURL_FILEINFO]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_ptr.item := (a_src.item).twin
				l_ptr.item.b_data := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([a_src.item.b_size]))))
				if (l_ptr.item.b_data).is_void then
					(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_ptr)])
					Result := (create {CE_CLASS_POINTER [PD_CURL_FILEINFO]}.make_shared (default_pointer))
				else
					memcpy (create {CE_VOID_POINTER}.make_cast (l_ptr.item.b_data), create {CE_VOID_POINTER}.make_cast (a_src.item.b_data), a_src.item.b_size).do_nothing
					Result := l_ptr
				end
			end
		end

feature {ANY} -- routine addresses

	Curl_fileinfo_dtor_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent Curl_fileinfo_dtor)
		end

end
