class
	P_BDIV_QR_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpn_bdiv_qr (a_qp, a_rp, a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): NATURAL_32
		require
			not a_dp.is_void
		local
			l_di: NATURAL_32
			l_rh: NATURAL_32
			l___n: NATURAL_32
			l___inv: NATURAL_32
			l___n___0: NATURAL_32
			l___inv___0: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if 60 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						l_pos := -1 + 15 -- skip if block
					end
				when 1 then -- if:
						if not (a_dn >= 60) then
							l_pos := -1 + 13 -- skip if block
						end
				when 2 then -- if:
						if 60 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 11 -- skip if block
						end
				when 3 then -- if:
						if not (a_nn - a_dn >= 60) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if 1_442 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						if a_dn >= 1_442 then
							l_rh := (create {P_MU_BDIV_QR_STATIC}).gmpn_mu_bdiv_qr (a_qp, a_rp, a_np, a_nn, a_dp, a_dn, a_tp)
						else
							l_pos := -1 + 7 -- goto _L
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_tp, a_np, a_nn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___n___0 := a_dp[0]
							l___inv___0 := ((create {P_GMP_IMPL_STATIC}).gmp_binvert_limb_table[((l___n___0 // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l___inv___0 := {NATURAL_32} 2 * l___inv___0 - (l___inv___0 * l___inv___0) * l___n___0
							l___inv___0 := {NATURAL_32} 2 * l___inv___0 - (l___inv___0 * l___inv___0) * l___n___0
							l_di := (l___inv___0).bit_and ({NATURAL_32} 4_294_967_295)
							l_break := True
						end
						l_break := False
						l_di := (-l_di.to_integer_32).to_natural_32
						l_rh := (create {P_DCPI1_BDIV_QR_STATIC}).gmpn_dcpi1_bdiv_qr (a_qp, a_tp, a_nn, a_dp, a_dn, l_di)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_rp, ((a_tp + a_nn) - a_dn), a_dn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
				when 8 then -- if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						l_pos := -1 + 11 -- goto _L___1
				when 10 then -- if done | if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else: | _L___1:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_tp, a_np, a_nn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							l___n := a_dp[0]
							l___inv := ((create {P_GMP_IMPL_STATIC}).gmp_binvert_limb_table[((l___n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
							l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
							l_di := (l___inv).bit_and ({NATURAL_32} 4_294_967_295)
							l_break := True
						end
						l_break := False
						l_di := (-l_di.to_integer_32).to_natural_32
						l_rh := (create {P_SBPI1_BDIV_QR_STATIC}).gmpn_sbpi1_bdiv_qr (a_qp, a_tp, a_nn, a_dp, a_dn, l_di)
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_GMP_STATIC}).gmpn_copyi (a_rp, ((a_tp + a_nn) - a_dn), a_dn)
								l_break := True
							end
							l_break := False
							l_break := True
						end
						l_break := False
				when 12 then -- if done | if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_pos := -1 + 11 -- goto _L___1
				when 14 then -- if done | if block done, skip else block:
						l_pos := -1 + 16
				when 15 then -- else:
						l_pos := -1 + 11 -- goto _L___1
				when 16 then
					Result := l_rh
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_bdiv_qr_itch (a_nn, a_dn: INTEGER_32): INTEGER_32
		do
			if 1_442 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if a_dn >= 1_442 then
					Result := ((create {P_MU_BDIV_QR_STATIC}).gmpn_mu_bdiv_qr_itch (a_nn, a_dn))
				else
					Result := a_nn
				end
			else
				Result := a_nn
			end
		end

end
