class
	P_CMPABS_D_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpz_cmpabs_d (a_z: CE_POINTER [PD_MPZ_STRUCT]; a_d: REAL_64): INTEGER_32
		local
			l_d: REAL_64
			l_darray: CE_ARRAY [NATURAL_32]
			l_zlimb: NATURAL_32
			l_dlimb: NATURAL_32
			l_zp: CE_POINTER [NATURAL_32]
			l_zsize: INTEGER_32
			l_dexp: INTEGER_32
			l_u: PD_IEEE_DOUBLE_EXTRACT
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l___i: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_darray.make (<<3>>)
			create l_u.make

			l_d := a_d
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_u.d := l_d
				l_u.update_class_fields -- synchronize union
				if (builtin_expect ((l_u.s.exp = {NATURAL_32} 2_047).to_integer, 0)).to_boolean then
					if l_u.s.manl = {NATURAL_32} 0 then
						if l_u.s.manh = {NATURAL_32} 0 then
							Result := (-1)
							l_return := True
						else
							(create {P_INVALID_STATIC}).gmp_invalid_operation
						end
					else
						(create {P_INVALID_STATIC}).gmp_invalid_operation
					end
				end
				if not l_return then
					l_break := True
				end
			end
			if not l_return then
				l_break := False
				l_zsize := (a_z.item.mp_size).to_integer_32
				if l_d = 0.0 then
					Result := (l_zsize /= 0).to_integer
					l_return := True
				end
			end
			if not l_return and then (l_zsize = 0) then
				if l_d /= (0).to_double then
					l_tmp___0 := -1
				else
					l_tmp___0 := 0
				end
				Result := l_tmp___0
				l_return := True
			end
			if not l_return then
				if l_zsize >= 0 then
					l_zsize := l_zsize
				else
					l_zsize := -l_zsize
				end
				if l_d >= (0).to_double then
					l_d := l_d
				else
					l_d := -l_d
				end
				if l_d < 1.0 then
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				l_dexp := (create {P_EXTRACT_DBL_STATIC}).gmp_extract_double (l_darray, l_d)
				if l_zsize /= l_dexp.to_integer_32 then
					if l_zsize >= l_dexp.to_integer_32 then
						l_tmp___1 := 1
					else
						l_tmp___1 := -1
					end
					Result := l_tmp___1
					l_return := True
				end
			end
			if not l_return then
				l_zp := a_z.item.mp_d
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_zlimb := l_zp[(l_zsize - 1)]
					l_dlimb := l_darray[2]
					if l_zlimb /= l_dlimb then
						if l_zlimb >= l_dlimb then
							l_tmp___2 := 1
						else
							l_tmp___2 := -1
						end
						Result := l_tmp___2
						l_return := True
					end
					if not l_return then
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				if l_zsize = 1 then
					if ((l_darray[0]).bit_or (l_darray[1])) /= {NATURAL_32} 0 then
						l_tmp___3 := -1
					else
						l_tmp___3 := 0
					end
					Result := l_tmp___3
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_zlimb := l_zp[(l_zsize - 2)]
					l_dlimb := l_darray[1]
					if l_zlimb /= l_dlimb then
						if l_zlimb >= l_dlimb then
							l_tmp___4 := 1
						else
							l_tmp___4 := -1
						end
						Result := l_tmp___4
						l_return := True
					end
					if not l_return then
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				if l_zsize = 2 then
					if l_darray[0] /= {NATURAL_32} 0 then
						l_tmp___5 := -1
					else
						l_tmp___5 := 0
					end
					Result := l_tmp___5
					l_return := True
				end
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_zlimb := l_zp[(l_zsize - 3)]
					l_dlimb := l_darray[0]
					if l_zlimb /= l_dlimb then
						if l_zlimb >= l_dlimb then
							l_tmp___6 := 1
						else
							l_tmp___6 := -1
						end
						Result := l_tmp___6
						l_return := True
					end
					if not l_return then
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l___i := (l_zsize - 3) - 1
					from
					until
						not (not (l_return) and then (l___i >= 0))
					loop
						if l_zp[l___i] /= {NATURAL_32} 0 then
							Result := 1
							l_return := True
						end
						if not l_return then
							l___i := l___i - 1
						end
					end
					if not l_return then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_break := True
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 0
			end
		end

end
