class
	P_SBPI1_BDIV_Q_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpn_sbpi1_bdiv_q (a_qp, a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: NATURAL_32)
		require
			not a_qp.is_void
			not a_np.is_void
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_cy: NATURAL_32
			l_q: NATURAL_32
			l_return: BOOLEAN
		do
			l_qp := a_qp
			l_np := a_np
			l_i := a_nn - a_dn
			from
			until
				not (not (l_return) and then (l_i > 0))
			loop
				l_q := a_dinv * l_np[0]
				l_qp[0] := (l_q).bit_not
				l_qp := l_qp + 1
				l_cy := (create {P_GMP_STATIC}).gmpn_addmul_1 (l_np, a_dp, a_dn, l_q);
				(create {P_GMP_STATIC}).gmpn_add_1 (l_np + a_dn, (l_np + a_dn), l_i, l_cy).do_nothing
				l_np := l_np + 1
				l_i := l_i - 1
			end
			l_i := a_dn
			from
			until
				not (not (l_return) and then (l_i > 1))
			loop
				l_q := a_dinv * l_np[0]
				l_qp[0] := (l_q).bit_not
				l_qp := l_qp + 1;
				(create {P_GMP_STATIC}).gmpn_addmul_1 (l_np, a_dp, l_i, l_q).do_nothing
				l_np := l_np + 1
				l_i := l_i - 1
			end
			l_q := a_dinv * l_np[0]
			l_qp[0] := (l_q).bit_not;
			(create {P_GMP_STATIC}).gmpn_add_1 ((l_qp - a_nn) + 1, ((l_qp - a_nn) + 1), a_nn, (1).to_natural_32).do_nothing
		end

end
