class
	P_TOOM_EVAL_DGR3_PM2_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpn_toom_eval_dgr3_pm2 (a_xp2, a_xm2, a_xp: CE_POINTER [NATURAL_32]; a_n, a_x3n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		require
			not a_xp2.is_void
			not a_tp.is_void
		local
			l_cy: NATURAL_32
			l_neg: INTEGER_32
		do
			l_cy := (create {P_GMP_STATIC}).gmpn_lshift (a_tp, a_xp + 2 * a_n, a_n, {NATURAL_32} 2)
			a_xp2[a_n] := l_cy + ((create {P_GMP_STATIC}).gmpn_add_n (a_xp2, a_tp, a_xp, a_n))
			a_tp[a_x3n] := (create {P_GMP_STATIC}).gmpn_lshift (a_tp, a_xp + 3 * a_n, a_x3n, {NATURAL_32} 2)
			if a_x3n < a_n then
				a_tp[a_n] := (create {P_GMP_STATIC}).gmpn_add (a_tp, a_xp + a_n, a_n, a_tp, a_x3n + 1)
			else
				a_tp[a_n] := a_tp[a_n] + ((create {P_GMP_STATIC}).gmpn_add_n (a_tp, a_xp + a_n, a_tp, a_n))
			end
			(create {P_GMP_STATIC}).gmpn_lshift (a_tp, a_tp, a_n + 1, {NATURAL_32} 1).do_nothing
			if ((create {P_GMP_STATIC}).gmpn_cmp (a_xp2, a_tp, a_n + 1)) < 0 then
				l_neg := (0).bit_not
			else
				l_neg := 0
			end
			if l_neg.to_boolean then
				(create {P_GMP_STATIC}).gmpn_sub_n (a_xm2, a_tp, a_xp2, a_n + 1).do_nothing
			else
				(create {P_GMP_STATIC}).gmpn_sub_n (a_xm2, a_xp2, a_tp, a_n + 1).do_nothing
			end
			(create {P_GMP_STATIC}).gmpn_add_n (a_xp2, a_xp2, a_tp, a_n + 1).do_nothing
			Result := l_neg
		end

end
