class
	P_TOOM_INTERPOLATE_7PTS_STATIC

inherit
	CE_UTILITIES
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_toom_interpolate_7pts (a_rp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_flags: NATURAL_32; a_w1, a_w3, a_w4, a_w5: CE_POINTER [NATURAL_32]; a_w6n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		require
			not a_tp.is_void
		local
			l_w5: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_w4: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_w3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_n: CE_ARRAY [INTEGER_32]
			l_rp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_m: INTEGER_32
			l_cy: CE_ARRAY [NATURAL_32]
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_w5.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_w4.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_w3.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_rp.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___1.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___2.make (<<1>>)

			l_w5.item := a_w5
			l_w4.item := a_w4
			l_w3.item := a_w3
			l_n.item := a_n
			l_rp.item := a_rp
			l_m := 2 * l_n.item + 1;
			(create {P_GMP_STATIC}).gmpn_add_n (l_w5.item, l_w5.item, l_w4.item, l_m).do_nothing
			if ((a_flags).bit_and ({NATURAL_32} 1)).to_boolean then
				(create {P_GMP_STATIC}).gmpn_add_n (a_w1, a_w1, l_w4.item, l_m).do_nothing;
				(create {P_GMP_STATIC}).gmpn_rshift (a_w1, a_w1, l_m, {NATURAL_32} 1).do_nothing
			else
				(create {P_GMP_STATIC}).gmpn_sub_n (a_w1, l_w4.item, a_w1, l_m).do_nothing;
				(create {P_GMP_STATIC}).gmpn_rshift (a_w1, a_w1, l_m, {NATURAL_32} 1).do_nothing
			end
			(create {P_GMP_STATIC}).gmpn_sub (l_w4.item, l_w4.item, l_m, l_rp.item, 2 * l_n.item).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_w4.item, l_w4.item, a_w1, l_m).do_nothing;
			(create {P_GMP_STATIC}).gmpn_rshift (l_w4.item, l_w4.item, l_m, {NATURAL_32} 2).do_nothing
			a_tp[a_w6n] := (create {P_GMP_STATIC}).gmpn_lshift (a_tp, (l_rp.item + 6 * l_n.item), a_w6n, {NATURAL_32} 4);
			(create {P_GMP_STATIC}).gmpn_sub (l_w4.item, l_w4.item, l_m, a_tp, a_w6n + 1).do_nothing
			if ((a_flags).bit_and ({NATURAL_32} 2)).to_boolean then
				(create {P_GMP_STATIC}).gmpn_add_n (l_w3.item, l_w3.item, (l_rp.item + 2 * l_n.item), l_m).do_nothing;
				(create {P_GMP_STATIC}).gmpn_rshift (l_w3.item, l_w3.item, l_m, {NATURAL_32} 1).do_nothing
			else
				(create {P_GMP_STATIC}).gmpn_sub_n (l_w3.item, (l_rp.item + 2 * l_n.item), l_w3.item, l_m).do_nothing;
				(create {P_GMP_STATIC}).gmpn_rshift (l_w3.item, l_w3.item, l_m, {NATURAL_32} 1).do_nothing
			end
			(create {P_GMP_STATIC}).gmpn_sub_n (l_rp.item + 2 * l_n.item, (l_rp.item + 2 * l_n.item), l_w3.item, l_m).do_nothing;
			(create {P_GMP_STATIC}).gmpn_submul_1 (l_w5.item, (l_rp.item + 2 * l_n.item), l_m, (65).to_natural_32).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub (l_rp.item + 2 * l_n.item, (l_rp.item + 2 * l_n.item), l_m, (l_rp.item + 6 * l_n.item), a_w6n).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub (l_rp.item + 2 * l_n.item, (l_rp.item + 2 * l_n.item), l_m, l_rp.item, 2 * l_n.item).do_nothing;
			(create {P_GMP_STATIC}).gmpn_addmul_1 (l_w5.item, (l_rp.item + 2 * l_n.item), l_m, (45).to_natural_32).do_nothing;
			(create {P_GMP_STATIC}).gmpn_rshift (l_w5.item, l_w5.item, l_m, {NATURAL_32} 1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_w4.item, l_w4.item, (l_rp.item + 2 * l_n.item), l_m).do_nothing
			l_tmp := (create {P_GMP_IMPL_STATIC}).gmpn_bdiv_dbm1c (l_w4.item, l_w4.item, l_m, {NATURAL_32} 1_431_655_765, (0).to_natural_32);
			(create {P_GMP_STATIC}).gmpn_sub_n (l_rp.item + 2 * l_n.item, (l_rp.item + 2 * l_n.item), l_w4.item, l_m).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub_n (a_w1, l_w5.item, a_w1, l_m).do_nothing;
			(create {P_GMP_STATIC}).gmpn_lshift (a_tp, l_w3.item, l_m, {NATURAL_32} 3).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_w5.item, l_w5.item, a_tp, l_m).do_nothing;
			(create {P_GMP_IMPL_STATIC}).gmpn_divexact_1 (l_w5.item, l_w5.item, l_m, (9).to_natural_32);
			(create {P_GMP_STATIC}).gmpn_sub_n (l_w3.item, l_w3.item, l_w5.item, l_m).do_nothing
			l_tmp___0 := (create {P_GMP_IMPL_STATIC}).gmpn_bdiv_dbm1c (a_w1, a_w1, l_m, {NATURAL_32} 286_331_153, (0).to_natural_32);
			(create {P_GMP_STATIC}).gmpn_add_n (a_w1, a_w1, l_w5.item, l_m).do_nothing;
			(create {P_GMP_STATIC}).gmpn_rshift (a_w1, a_w1, l_m, {NATURAL_32} 1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_w5.item, l_w5.item, a_w1, l_m).do_nothing
			l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_rp.item + l_n.item, (l_rp.item + l_n.item), a_w1, l_m)
			from
			until
				(l_break)
			loop
				l_break := False
				asm159 (l___ptr_dummy, l_rp, l_n, l_cy)
				l_break := True
			end
			l_break := False
			l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_rp.item + 3 * l_n.item, (l_rp.item + 3 * l_n.item), l_w3.item, l_n.item)
			from
			until
				(l_break)
			loop
				l_break := False
				asm160 (l___ptr_dummy___0, l_w3, l_n, l_rp, l_cy)
				l_break := True
			end
			l_break := False
			l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_rp.item + 4 * l_n.item, (l_w3.item + l_n.item), l_w4.item, l_n.item)
			from
			until
				(l_break)
			loop
				l_break := False
				asm161 (l___ptr_dummy___1, l_w4, l_n, l_w3, l_cy)
				l_break := True
			end
			l_break := False
			l_cy.item := (create {P_GMP_STATIC}).gmpn_add_n (l_rp.item + 5 * l_n.item, (l_w4.item + l_n.item), l_w5.item, l_n.item)
			from
			until
				(l_break)
			loop
				l_break := False
				asm162 (l___ptr_dummy___2, l_w5, l_n, l_w4, l_cy)
				l_break := True
			end
			l_break := False
			if a_w6n > l_n.item + 1 then
				(create {P_GMP_STATIC}).gmpn_add (l_rp.item + 6 * l_n.item, (l_rp.item + 6 * l_n.item), a_w6n, (l_w5.item + l_n.item), l_n.item + 1).do_nothing
			else
				(create {P_GMP_STATIC}).gmpn_add_n (l_rp.item + 6 * l_n.item, (l_rp.item + 6 * l_n.item), (l_w5.item + l_n.item), a_w6n).do_nothing
			end
		end

end
