class
	P_TOOM_INTERPOLATE_8PTS_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	DO_mpn_sublsh_n (a_dst, a_src: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_s: NATURAL_32; a_ws: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l___cy: NATURAL_32
		do
			l___cy := (create {P_GMP_STATIC}).gmpn_lshift (a_ws, a_src, a_n, a_s)
			Result := (l___cy + ((create {P_GMP_STATIC}).gmpn_sub_n (a_dst, a_dst, a_ws, a_n)))
		end

	gmpn_toom_interpolate_8pts (a_pp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_r3, a_r7: CE_POINTER [NATURAL_32]; a_spt: INTEGER_32; a_ws: CE_POINTER [NATURAL_32])
		local
			l_spt: CE_ARRAY [INTEGER_32]
			l_r7: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_r3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_n: CE_ARRAY [INTEGER_32]
			l_pp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_cy: CE_ARRAY [INTEGER_32]
			l_r5: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_r1: CE_POINTER [NATURAL_32]
			l___cy: CE_ARRAY [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___cy___0: CE_ARRAY [NATURAL_32]
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___4: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___5: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_tmp___3: NATURAL_32
			l___ptr_dummy___6: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___7: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___8: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___9: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___10: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___11: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___12: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_spt.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_r7.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_r3.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_pp.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_cy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l_r5.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l___cy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___1.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l___cy___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___2.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___3.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___4.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___5.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___6.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___7.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___8.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___9.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___10.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___11.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_32]} l___ptr_dummy___12.make (<<1>>)

			l_spt.item := a_spt
			l_r7.item := a_r7
			l_r3.item := a_r3
			l_n.item := a_n
			l_pp.item := a_pp
			l_r5.item := l_pp.item + 3 * l_n.item
			l_r1 := l_pp.item + 7 * l_n.item
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					asm163 (l___ptr_dummy, l_r3, l_n, l_pp)
					l_break := True
				end
				l_break := False
				l___cy.item := DO_mpn_sublsh_n (l_r3.item + l_n.item, (l_pp.item + 1), 2 * l_n.item - 1, {NATURAL_32} 28, a_ws)
				from
				until
					(l_break)
				loop
					l_break := False
					asm164 (l___ptr_dummy___0, l_r3, l_n, l___cy)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			l_cy.item := (DO_mpn_sublsh_n (l_r3.item, l_r1, l_spt.item, {NATURAL_32} 12, a_ws)).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				asm165 (l___ptr_dummy___1, l_r3, l_spt, l_cy)
				l_break := True
			end
			l_break := False
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				from
				until
					(l_break)
				loop
					l_break := False
					asm166 (l___ptr_dummy___2, l_r5, l_n, l_pp)
					l_break := True
				end
				l_break := False
				l___cy___0.item := DO_mpn_sublsh_n (l_r5.item + l_n.item, (l_pp.item + 1), 2 * l_n.item - 1, {NATURAL_32} 30, a_ws)
				from
				until
					(l_break)
				loop
					l_break := False
					asm167 (l___ptr_dummy___3, l_r5, l_n, l___cy___0)
					l_break := True
				end
				l_break := False
				l_break := True
			end
			l_break := False
			l_cy.item := (DO_mpn_sublsh_n (l_r5.item, l_r1, l_spt.item, {NATURAL_32} 6, a_ws)).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				asm168 (l___ptr_dummy___4, l_r5, l_spt, l_cy)
				l_break := True
			end
			l_break := False
			l_r7.item[3 * l_n.item] := l_r7.item[3 * l_n.item] - ((create {P_GMP_STATIC}).gmpn_sub_n (l_r7.item + l_n.item, (l_r7.item + l_n.item), l_pp.item, 2 * l_n.item))
			l_cy.item := ((create {P_GMP_STATIC}).gmpn_sub_n (l_r7.item, l_r7.item, l_r1, l_spt.item)).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				asm169 (l___ptr_dummy___5, l_r7, l_spt, l_cy)
				l_break := True
			end
			l_break := False;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_r3.item, l_r3.item, l_r5.item, 3 * l_n.item + 1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_rshift (l_r3.item, l_r3.item, 3 * l_n.item + 1, {NATURAL_32} 2).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_r5.item, l_r5.item, l_r7.item, 3 * l_n.item + 1).do_nothing;
			(create {P_GMP_STATIC}).gmpn_sub_n (l_r3.item, l_r3.item, l_r5.item, 3 * l_n.item + 1).do_nothing;
			(create {P_GMP_IMPL_STATIC}).gmpn_divexact_1 (l_r3.item, l_r3.item, 3 * l_n.item + 1, (45).to_natural_32)
			l_tmp___3 := (create {P_GMP_IMPL_STATIC}).gmpn_bdiv_dbm1c (l_r5.item, l_r5.item, 3 * l_n.item + 1, {NATURAL_32} 1_431_655_765, (0).to_natural_32)
			DO_mpn_sublsh_n (l_r5.item, l_r3.item, 3 * l_n.item + 1, {NATURAL_32} 2, a_ws).do_nothing
			l_cy.item := ((create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + l_n.item, (l_pp.item + l_n.item), l_r7.item, l_n.item)).to_integer_32
			l_cy.item := ((l_cy.item).to_natural_32 - ((create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + l_n.item, (l_pp.item + l_n.item), l_r5.item, l_n.item))).to_integer_32
			if 0 > l_cy.item then
				from
				until
					(l_break)
				loop
					l_break := False
					asm170 (l___ptr_dummy___6, l_r7, l_n)
					l_break := True
				end
				l_break := False
			else
				from
				until
					(l_break)
				loop
					l_break := False
					asm171 (l___ptr_dummy___7, l_r7, l_n, l_cy)
					l_break := True
				end
				l_break := False
			end
			l_cy.item := ((create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + 2 * l_n.item, (l_r7.item + l_n.item), (l_r5.item + l_n.item), l_n.item)).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				asm172 (l___ptr_dummy___8, l_r7, l_n, l_cy)
				l_break := True
			end
			l_break := False
			l_cy.item := ((create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + 3 * l_n.item, l_r5.item, (l_r7.item + 2 * l_n.item), l_n.item + 1)).to_integer_32
			l_r5.item[3 * l_n.item] := l_r5.item[3 * l_n.item] + ((create {P_GMP_STATIC}).gmpn_add_n (l_r5.item + 2 * l_n.item, (l_r5.item + 2 * l_n.item), l_r3.item, l_n.item))
			l_cy.item := ((l_cy.item).to_natural_32 - ((create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + 3 * l_n.item, (l_pp.item + 3 * l_n.item), (l_r5.item + 2 * l_n.item), l_n.item + 1))).to_integer_32
			if (builtin_expect ((0 > l_cy.item).to_integer, 0)).to_boolean then
				from
				until
					(l_break)
				loop
					l_break := False
					asm173 (l___ptr_dummy___9, l_r5, l_n)
					l_break := True
				end
				l_break := False
			else
				from
				until
					(l_break)
				loop
					l_break := False
					asm174 (l___ptr_dummy___10, l_r5, l_n, l_cy)
					l_break := True
				end
				l_break := False
			end
			(create {P_GMP_STATIC}).gmpn_sub_n (l_pp.item + 4 * l_n.item, (l_r5.item + l_n.item), (l_r3.item + l_n.item), 2 * l_n.item + 1).do_nothing
			l_cy.item := ((create {P_GMP_STATIC}).gmpn_add_1 (l_pp.item + 6 * l_n.item, (l_r3.item + l_n.item), l_n.item, l_pp.item[6 * l_n.item])).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				asm175 (l___ptr_dummy___11, l_r3, l_n, l_cy)
				l_break := True
			end
			l_break := False
			l_cy.item := (l_r3.item[3 * l_n.item] + ((create {P_GMP_STATIC}).gmpn_add_n (l_pp.item + 7 * l_n.item, (l_pp.item + 7 * l_n.item), (l_r3.item + 2 * l_n.item), l_n.item))).to_integer_32
			from
			until
				(l_break)
			loop
				l_break := False
				asm176 (l___ptr_dummy___12, l_pp, l_n, l_cy)
				l_break := True
			end
			l_break := False
		end

end
