class
	P_VASPRINTF_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	gmp_asprintf_funs: CE_STATIC [CE_ARRAY [PD_DOPRNT_FUNS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_DOPRNT_FUNS_T]}.make_initialized (<<
					create {PD_DOPRNT_FUNS_T}.make_initialized ([((create {PD_GMP_ASPRINTF_T_STATIC}).gmp_asprintf_format_address), ((create {PD_GMP_ASPRINTF_T_STATIC}).gmp_asprintf_memory_address), ((create {PD_GMP_ASPRINTF_T_STATIC}).gmp_asprintf_reps_address), ((create {PD_GMP_ASPRINTF_T_STATIC}).gmp_asprintf_final_address)])
				>>)
		end

feature {ANY} -- public routines

	gmp_vasprintf (a_result: CE_POINTER [CE_POINTER [INTEGER_8]]; a_fmt: CE_POINTER [INTEGER_8]; a_ap: CE_VA_LIST): INTEGER_32
		require
			not a_fmt.is_void
		local
			l_ap: CE_VA_LIST
			l_d: CE_ARRAY [PD_GMP_ASPRINTF_T]
			l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GMP_ASPRINTF_T]} l_d.make (<<1>>)

			l_ap := a_ap.twin
			from
			until
				(l_break)
			loop
				l_break := False
				l_d.item.result2 := a_result
				l_d.item.alloc := (256).to_natural_32
				l_d.item.buf := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_MEMORY_STATIC}).gmp_allocate_func.item.pointer_item ([l_d.item.alloc]))))
				l_d.item.size := (0).to_natural_32
				l_break := True
			end
			l_break := False
			Result := (gmp_asprintf_funs.item.item.gmp_doprnt (create {CE_VOID_POINTER}.make_cast (l_d), a_fmt, l_ap.twin))
		end

end
