class
	P_AIRY_DER_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_sf_airy_Ai_deriv_scaled (a_x: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_airy_Ai_deriv_scaled_e (a_x, a_mode))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_airy_Ai_deriv_scaled_e(x, mode, &result)"), ce_string ("airy_der.c"), 872, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_airy_Ai_deriv (a_x: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_airy_Ai_deriv_e (a_x, a_mode))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_airy_Ai_deriv_e(x, mode, &result)"), ce_string ("airy_der.c"), 877, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_airy_Bi_deriv_scaled (a_x: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_airy_Bi_deriv_scaled_e (a_x, a_mode))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_airy_Bi_deriv_scaled_e(x, mode, &result)"), ce_string ("airy_der.c"), 882, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_airy_Bi_deriv (a_x: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_airy_Bi_deriv_e (a_x, a_mode))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_airy_Bi_deriv_e(x, mode, &result)"), ce_string ("airy_der.c"), 887, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

end
