class
	P_DROTG_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	cblas_drotg (a_a___5, a_b___0, a_c___1, a_s: CE_POINTER [REAL_64])
		require
			not a_a___5.is_void
			not a_b___0.is_void
			not a_c___1.is_void
			not a_s.is_void
		local
			l_roe: REAL_64
			l_tmp___1: REAL_64
			l_tmp___2: REAL_64
			l_scale: REAL_64
			l_tmp___4: REAL_64
			l_r___3: REAL_64
			l_z: REAL_64
			l_aos: REAL_64
			l_bos: REAL_64
			l_tmp___7: INTEGER_32
			l_tmp___8: REAL_64
			l_tmp___10: REAL_64
		do
			l_tmp___2 := fabs (a_a___5.item)
			if l_tmp___2 > (fabs (a_b___0.item)) then
				l_tmp___1 := a_a___5.item
			else
				l_tmp___1 := a_b___0.item
			end
			l_roe := l_tmp___1
			l_tmp___4 := fabs (a_a___5.item)
			l_scale := l_tmp___4 + (fabs (a_b___0.item))
			if l_scale /= 0.0 then
				l_aos := a_a___5.item / l_scale
				l_bos := a_b___0.item / l_scale
				l_r___3 := l_scale * (sqrt (l_aos * l_aos + l_bos * l_bos))
				if l_roe >= 0.0 then
					l_tmp___7 := 1
				else
					l_tmp___7 := -1
				end
				l_r___3 := l_tmp___7.to_double * l_r___3
				a_c___1.item := a_a___5.item / l_r___3
				a_s.item := a_b___0.item / l_r___3
				l_z := 1.0
				l_tmp___8 := fabs (a_a___5.item)
				if l_tmp___8 > (fabs (a_b___0.item)) then
					l_z := a_s.item
				end
				l_tmp___10 := fabs (a_b___0.item)
				if l_tmp___10 >= (fabs (a_a___5.item)) then
					if a_c___1.item /= 0.0 then
						l_z := 1.0 / a_c___1.item
					end
				end
			else
				a_c___1.item := 1.0
				a_s.item := 0.0
				l_r___3 := 0.0
				l_z := 0.0
			end
			a_a___5.item := l_r___3
			a_b___0.item := l_z
		end

end
