class
	P_FCMP_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_fcmp (a_x1___0, a_x2___1, a_epsilon: REAL_64): INTEGER_32
		local
			l_exponent: CE_ARRAY [INTEGER_32]
			l_delta___0: REAL_64
			l_difference: REAL_64
			l_max: REAL_64
			l_tmp___1: REAL_64
			l_tmp___2: REAL_64
		do
			create {CE_INTEGER_32_ARRAY} l_exponent.make (<<1>>)

			l_tmp___2 := fabs (a_x1___0)
			if l_tmp___2 > (fabs (a_x2___1)) then
				l_tmp___1 := a_x1___0
			else
				l_tmp___1 := a_x2___1
			end
			l_max := l_tmp___1
			frexp (l_max, l_exponent).do_nothing
			l_delta___0 := ldexp (a_epsilon, l_exponent.item)
			l_difference := a_x1___0 - a_x2___1
			if l_difference > l_delta___0 then
				Result := 1
			elseif l_difference < -l_delta___0 then
				Result := (-1)
			else
				Result := 0
			end
		end

end
