class
	P_GUMBEL_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_gumbel1_pdf (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_p: REAL_64
		do
			l_p := (a_a___5 * a_b___0) * (exp (-(a_b___0 * (exp (-a_a___5 * a_x)) + a_a___5 * a_x)))
			Result := l_p
		end

	gsl_ran_gumbel2_pdf (a_x, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_tmp: REAL_64
		do
			if a_x <= (0).to_double then
				Result := (0).to_double
			else
				l_tmp := pow (a_x, -(a_a___5 + (1).to_double))
				l_p := ((a_b___0 * a_a___5) * l_tmp) * (exp (-a_b___0 * (pow (a_x, -a_a___5))))
				Result := l_p
			end
		end

end
