class
	P_HOUSEHOLDERCOMPLEX_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_linalg_complex_householder_mh (a_tau: PD_GSL_COMPLEX; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_A___0: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_tauwi: PD_GSL_COMPLEX
			l_Ai0: PD_GSL_COMPLEX
			l_wi: PD_GSL_COMPLEX
			l_Aij: PD_GSL_COMPLEX
			l_vj: PD_GSL_COMPLEX
			l_Av: PD_GSL_COMPLEX
			l_Atw: PD_GSL_COMPLEX
			l_vj___0: PD_GSL_COMPLEX
			l_tauwv: PD_GSL_COMPLEX
			l_Aij___0: PD_GSL_COMPLEX
			l_Atwv: PD_GSL_COMPLEX
			l_return: BOOLEAN
		do
			if a_tau.dat[0] = 0.0 then
				if a_tau.dat[1] = 0.0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				l_i := (0).to_natural_32
				from
				until
					not (not (l_return) and then (l_i < a_A___0.item.size1))
				loop
					l_Ai0 := ((a_A___0.item.gsl_matrix_complex_get (l_i, (0).to_natural_32)).twin).twin
					l_wi := l_Ai0.twin
					l_j := (1).to_natural_32
					from
					until
						not (l_j < a_A___0.item.size2)
					loop
						l_Aij := ((a_A___0.item.gsl_matrix_complex_get (l_i, l_j)).twin).twin
						l_vj := ((a_v.item.gsl_vector_complex_get (l_j)).twin).twin
						l_Av := (((create {P_MATH_STATIC}).gsl_complex_mul (l_Aij.twin, l_vj.twin)).twin).twin
						l_wi := ((create {P_MATH_STATIC}).gsl_complex_add (l_wi.twin, l_Av.twin)).twin
						l_j := l_j + 1
					end
					l_tauwi := ((create {P_MATH_STATIC}).gsl_complex_mul (a_tau.twin, l_wi.twin)).twin
					l_Atw := (((create {P_MATH_STATIC}).gsl_complex_sub (l_Ai0.twin, l_tauwi.twin)).twin).twin
					a_A___0.item.gsl_matrix_complex_set (l_i, (0).to_natural_32, l_Atw.twin)
					l_j := (1).to_natural_32
					from
					until
						not (l_j < a_A___0.item.size2)
					loop
						l_vj___0 := ((a_v.item.gsl_vector_complex_get (l_j)).twin).twin
						l_tauwv := (((create {P_MATH_STATIC}).gsl_complex_mul ((((create {P_MATH_STATIC}).gsl_complex_conjugate (l_vj___0.twin)).twin).twin, l_tauwi.twin)).twin).twin
						l_Aij___0 := ((a_A___0.item.gsl_matrix_complex_get (l_i, l_j)).twin).twin
						l_Atwv := (((create {P_MATH_STATIC}).gsl_complex_sub (l_Aij___0.twin, l_tauwv.twin)).twin).twin
						a_A___0.item.gsl_matrix_complex_set (l_i, l_j, l_Atwv.twin)
						l_j := l_j + 1
					end
					l_i := l_i + 1
				end
				Result := 0
			end
		end

end
