class
	P_MRG_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	m___3: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (2_147_483_647).to_integer_32
		end

	a1___3: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (107_374_182).to_integer_32
		end

	q1___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (20).to_integer_32
		end

	r1___0: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (7).to_integer_32
		end

	a5: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (104_480).to_integer_32
		end

	q52: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (20_554).to_integer_32
		end

	r5: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (1_727).to_integer_32
		end

	mrg_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("mrg"), {NATURAL_32} 2_147_483_646, {NATURAL_32} 0, (create {PD_MRG_STATE_T}.make).structure_size.to_natural_32, mrg_set_address, mrg_get_address, mrg_get_double_address])
				>>)
		end

	gsl_rng_mrg: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := mrg_type.item
		end

feature {ANY} -- public routines

	mrg_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_MRG_STATE_T]
			l_p1: INTEGER_32
			l_h1: INTEGER_32
			l_p5: INTEGER_32
			l_h5: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_MRG_STATE_T]}.make_cast (a_vstate)
			l_h5 := l_state.item.x5 // q52.item
			l_p5 := (a5.item * (l_state.item.x5 - l_h5 * q52.item) - (l_h5 * r5.item))
			if l_p5 > 0 then
				l_p5 := l_p5 - m___3.item
			end
			l_h1 := l_state.item.x1 // q1___0.item
			l_p1 := (a1___3.item * (l_state.item.x1 - l_h1 * q1___0.item) - (l_h1 * r1___0.item))
			if l_p1 < 0 then
				l_p1 := l_p1 + m___3.item
			end
			l_state.item.x5 := l_state.item.x4
			l_state.item.x4 := l_state.item.x3
			l_state.item.x3 := l_state.item.x2
			l_state.item.x2 := l_state.item.x1
			l_state.item.x1 := l_p1 + l_p5
			if l_state.item.x1 < 0 then
				l_state.item.x1 := l_state.item.x1 + m___3.item
			end
			Result := (l_state.item.x1).to_natural_32
		end

	mrg_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((mrg_get (a_vstate)).to_real_64 / 2147483647.0)
		end

	mrg_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_MRG_STATE_T]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_MRG_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.x1 := (l_s \\ m___3.item.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.x2 := (l_s \\ m___3.item.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.x3 := (l_s \\ m___3.item.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.x4 := (l_s \\ m___3.item.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.x5 := (l_s \\ m___3.item.to_natural_32).to_integer_32
			mrg_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			mrg_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			mrg_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			mrg_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			mrg_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			mrg_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
		end

feature {ANY} -- routine addresses

	mrg_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent mrg_get)
		end

	mrg_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent mrg_get_double)
		end

	mrg_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent mrg_set)
		end

end
