class
	P_POW_INT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_pow_int (a_x: REAL_64; a_n: INTEGER_32): REAL_64
		local
			l_x: REAL_64
			l_n: INTEGER_32
			l_value: REAL_64
			l_break: BOOLEAN
		do
			l_x := a_x
			l_n := a_n
			l_value := 1.0
			if l_n < 0 then
				l_x := 1.0 / l_x
				l_n := -l_n
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if ((l_n).bit_and (1)).to_boolean then
					l_value := l_value * l_x
				end
				l_n := (l_n).bit_shift_right ((1))
				l_x := l_x * l_x
				if not l_n.to_boolean then
					l_break := True
				end
			end
			l_break := False
			Result := l_value
		end

end
