class
	P_QRSTEP_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	create_givens (a_a___5, a_b___0: REAL_64; a_c___1, a_s: CE_POINTER [REAL_64])
		require
			not a_c___1.is_void
			not a_s.is_void
		local
			l_t: REAL_64
			l_s1: REAL_64
			l_t___0: REAL_64
			l_c1___2: REAL_64
			l_tmp___1: REAL_64
		do
			if a_b___0 = (0).to_double then
				a_c___1.item := (1).to_double
				a_s.item := (0).to_double
			else
				l_tmp___1 := fabs (a_b___0)
				if l_tmp___1 > (fabs (a_a___5)) then
					l_t := -a_a___5 / a_b___0
					l_s1 := 1.0 / (sqrt ((1).to_double + l_t * l_t))
					a_s.item := l_s1
					a_c___1.item := l_s1 * l_t
				else
					l_t___0 := -a_b___0 / a_a___5
					l_c1___2 := 1.0 / (sqrt ((1).to_double + l_t___0 * l_t___0))
					a_c___1.item := l_c1___2
					a_s.item := l_c1___2 * l_t___0
				end
			end
		end

	trailing_eigenvalue (a_n: NATURAL_32; a_d, a_sd: CE_POINTER [REAL_64]): REAL_64
		require
			not a_d.is_void
			not a_sd.is_void
		local
			l_ta: REAL_64
			l_tb: REAL_64
			l_tab: REAL_64
			l_dt: REAL_64
			l_mu: REAL_64
		do
			l_ta := a_d[(a_n - {NATURAL_32} 2).to_integer_32]
			l_tb := a_d[(a_n - {NATURAL_32} 1).to_integer_32]
			l_tab := a_sd[(a_n - {NATURAL_32} 2).to_integer_32]
			l_dt := (l_ta - l_tb) / 2.0
			if l_dt > (0).to_double then
				l_mu := l_tb - l_tab * (l_tab / (l_dt + (hypot (l_dt, l_tab))))
			elseif l_dt = (0).to_double then
				l_mu := l_tb - (fabs (l_tab))
			else
				l_mu := l_tb + l_tab * (l_tab / (-l_dt + (hypot (l_dt, l_tab))))
			end
			Result := l_mu
		end

end
