class
	P_SPHERE_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_dir_nd (a_r___3: CE_POINTER [PD_GSL_RNG]; a_n: NATURAL_32; a_x: CE_POINTER [REAL_64])
		local
			l_d: REAL_64
			l_i: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			l_d := (0).to_double
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_i := (0).to_natural_32
				from
				until
					not (l_i < a_n)
				loop
					a_x[l_i.to_integer_32] := a_r___3.item.gsl_ran_gaussian (1.0)
					l_d := l_d + (a_x[l_i.to_integer_32] * a_x[l_i.to_integer_32])
					l_i := l_i + 1
				end
				if l_d /= (0).to_double then
					l_break := True
				end
			end
			l_break := False
			l_d := sqrt (l_d)
			l_i := (0).to_natural_32
			from
			until
				not (l_i < a_n)
			loop
				a_x[l_i.to_integer_32] := a_x[l_i.to_integer_32] / l_d
				l_i := l_i + 1
			end
		end

end
