class
	P_SSPR_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	cblas_sspr (a_order, a_Uplo: NATURAL_32; a_N: INTEGER_32; a_alpha: REAL_32; a_X: CE_POINTER [REAL_32]; a_incX: INTEGER_32; a_Ap: CE_POINTER [REAL_32])
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: REAL_32
			l_jx: INTEGER_32
			l_ix___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: REAL_32
			l_jx___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_N = 0 then
						l_return := True
					end
					if not l_return and then (a_alpha.to_double = 0.0) then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_Uplo = {NATURAL_32} 121 then
							l_pos := -1 + 6 -- goto _L___1
						else
							l_pos := -1 + 4 -- goto _L___3
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 4 then -- else: | _L___3:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___1:
						if a_incX > 0 then
							l_tmp := 0
						else
							l_tmp := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_tmp___0 := a_alpha * a_X[l_ix]
							l_jx := l_ix
							l_j := l_i
							from
							until
								not (l_j < a_N)
							loop
								a_Ap[(((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i)] := a_Ap[(((((l_i - 1) + 1) * (2 * a_N - (l_i - 1))) // 2 + l_j) - l_i)] + (a_X[l_jx] * l_tmp___0)
								l_jx := l_jx + a_incX
								l_j := l_j + 1
							end
							l_ix := l_ix + a_incX
							l_i := l_i + 1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 10 -- goto _L___2
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 10 then -- else: | _L___2:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						if a_Uplo = {NATURAL_32} 122 then
							l_pos := -1 + 15 -- goto _L
						else
							l_pos := -1 + 13 -- goto _L___0
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 13 then -- else: | _L___0:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 19 -- skip if block
						end
				when 14 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___1
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_tmp___2 := a_alpha * a_X[l_ix___0]
							if a_incX > 0 then
								l_tmp___3 := 0
							else
								l_tmp___3 := (a_N - 1) * -a_incX
							end
							l_jx___0 := l_tmp___3
							l_j := 0
							from
							until
								not (l_j <= l_i)
							loop
								a_Ap[((l_i * (l_i + 1)) // 2 + l_j)] := a_Ap[((l_i * (l_i + 1)) // 2 + l_j)] + (a_X[l_jx___0] * l_tmp___2)
								l_jx___0 := l_jx___0 + a_incX
								l_j := l_j + 1
							end
							l_ix___0 := l_ix___0 + a_incX
							l_i := l_i + 1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_spr.h"), ce_string ("unrecognized operation")])
				when 18 then -- if done | if block done, skip else block:
						l_pos := -1 + 20
				when 19 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_spr.h"), ce_string ("unrecognized operation")])
				when 20 then -- if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
