class
	PD_GSL_FUNCTION_STRUCT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- routine addresses

	quad_golden_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_minimum, a_f_minimum, a_x_lower, a_f_lower, a_x_upper, a_f_upper: CE_POINTER [REAL_64]): INTEGER_32
				do
					Result := a_f.item.quad_golden_iterate (a_vstate, a_x_minimum, a_f_minimum, a_x_lower, a_f_lower, a_x_upper, a_f_upper)
				end)
		end

	goldensection_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_minimum, a_f_minimum, a_x_lower, a_f_lower, a_x_upper, a_f_upper: CE_POINTER [REAL_64]): INTEGER_32
				do
					Result := a_f.item.goldensection_iterate (a_vstate, a_x_minimum, a_f_minimum, a_x_lower, a_f_lower, a_x_upper, a_f_upper)
				end)
		end

	brent_init_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_minimum, a_f_minimum, a_x_lower, a_f_lower, a_x_upper, a_f_upper: REAL_64): INTEGER_32
				do
					Result := a_f.item.brent_init (a_vstate, a_x_minimum, a_f_minimum, a_x_lower, a_f_lower, a_x_upper, a_f_upper)
				end)
		end

	brent_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x_minimum, a_f_minimum, a_x_lower, a_f_lower, a_x_upper, a_f_upper: CE_POINTER [REAL_64]): INTEGER_32
				do
					Result := a_f.item.brent_iterate (a_vstate, a_x_minimum, a_f_minimum, a_x_lower, a_f_lower, a_x_upper, a_f_upper)
				end)
		end

	bisection_init_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_root: CE_POINTER [REAL_64]; a_x_lower, a_x_upper: REAL_64): INTEGER_32
				do
					Result := a_f.item.bisection_init (a_vstate, a_root, a_x_lower, a_x_upper)
				end)
		end

	brent_init___0_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_root: CE_POINTER [REAL_64]; a_x_lower, a_x_upper: REAL_64): INTEGER_32
				do
					Result := a_f.item.brent_init___0 (a_vstate, a_root, a_x_lower, a_x_upper)
				end)
		end

	falsepos_init_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_root: CE_POINTER [REAL_64]; a_x_lower, a_x_upper: REAL_64): INTEGER_32
				do
					Result := a_f.item.falsepos_init (a_vstate, a_root, a_x_lower, a_x_upper)
				end)
		end

	gsl_integration_qk31_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5, a_b___0: REAL_64; a_result, a_abserr, a_resabs, a_resasc: CE_POINTER [REAL_64])
				do
					a_f.item.gsl_integration_qk31 (a_a___5, a_b___0, a_result, a_abserr, a_resabs, a_resasc)
				end)
		end

	gsl_integration_qk21_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5, a_b___0: REAL_64; a_result, a_abserr, a_resabs, a_resasc: CE_POINTER [REAL_64])
				do
					a_f.item.gsl_integration_qk21 (a_a___5, a_b___0, a_result, a_abserr, a_resabs, a_resasc)
				end)
		end

	gsl_integration_qk61_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5, a_b___0: REAL_64; a_result, a_abserr, a_resabs, a_resasc: CE_POINTER [REAL_64])
				do
					a_f.item.gsl_integration_qk61 (a_a___5, a_b___0, a_result, a_abserr, a_resabs, a_resasc)
				end)
		end

	gsl_integration_qk51_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5, a_b___0: REAL_64; a_result, a_abserr, a_resabs, a_resasc: CE_POINTER [REAL_64])
				do
					a_f.item.gsl_integration_qk51 (a_a___5, a_b___0, a_result, a_abserr, a_resabs, a_resasc)
				end)
		end

	gsl_integration_qk41_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5, a_b___0: REAL_64; a_result, a_abserr, a_resabs, a_resasc: CE_POINTER [REAL_64])
				do
					a_f.item.gsl_integration_qk41 (a_a___5, a_b___0, a_result, a_abserr, a_resabs, a_resasc)
				end)
		end

	gsl_integration_qk15_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_a___5, a_b___0: REAL_64; a_result, a_abserr, a_resabs, a_resasc: CE_POINTER [REAL_64])
				do
					a_f.item.gsl_integration_qk15 (a_a___5, a_b___0, a_result, a_abserr, a_resabs, a_resasc)
				end)
		end

end
