class
	P_PROMPT_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC

feature {ANY} -- public attributes

	s_proto: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("?n?f%%f .?m(%%T %%i of %%m) ..?e(END) ?x- Next\: %%x..%%t%/0/")
		end

	m_proto: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("?n?f%%f .?m(%%T %%i of %%m) ..?e(END) ?x- Next\: %%x.:?pB%%pB\%%:byte %%bB?s/%%s...%%t%/0/")
		end

	M_proto2: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("?f%%f .?n?m(%%T %%i of %%m) ..?ltlines %%lt-%%lb?L/%%L. :byte %%bB?s/%%s. .?e(END) ?x- Next\: %%x.:?pB%%pB\%%..%%t%/0/")
		end

	e_proto: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("?f%%f .?m(%%T %%i of %%m) .?ltlines %%lt-%%lb?L/%%L. .byte %%bB?s/%%s. ?e(END) :?pB%%pB\%%..%%t%/0/")
		end

	h_proto: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("HELP -- ?eEND -- Press g to see it again:Press RETURN for more., or q when done%/0/")
		end

	w_proto: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("Waiting for data%/0/")
		end

	eqproto: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					e_proto.item
				>>)
		end

	hproto: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					h_proto.item
				>>)
		end

	wproto: CE_STATIC [CE_ARRAY [CE_POINTER [INTEGER_8]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [INTEGER_8]}.make_initialized (<<
					w_proto.item
				>>)
		end

	message: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_ARRAY}.make (<<200>>)
		end

	mp: CE_STATIC [CE_POINTER [INTEGER_8]]
		once ("PROCESS")
			Result.item := create {CE_INTEGER_8_POINTER}.make
		end

feature {ANY} -- public routines

	init_prompt
		do
			(create {P_OPTFUNC_STATIC}).prproto.item[0] := (create {P_MAIN_STATIC}).save (s_proto.item);
			(create {P_OPTFUNC_STATIC}).prproto.item[1] := (create {P_MAIN_STATIC}).save (m_proto.item);
			(create {P_OPTFUNC_STATIC}).prproto.item[2] := (create {P_MAIN_STATIC}).save (M_proto2.item)
			eqproto.item.item := ((create {P_MAIN_STATIC}).save (e_proto.item))
			hproto.item.item := ((create {P_MAIN_STATIC}).save (h_proto.item))
			wproto.item.item := ((create {P_MAIN_STATIC}).save (w_proto.item))
		end

	ap_str (a_s: CE_POINTER [INTEGER_8])
		require
			not a_s.is_void
		local
			l_len: INTEGER_32
		do
			l_len := (strlen (a_s)).to_integer_32
			if ((mp.item + l_len).c_pointer.to_integer_32).to_natural_32 >= ((message.item + 200).c_pointer.to_integer_32).to_natural_32 then
				l_len := ((message.item + 200).distance (mp.item)) - 1
			end
			strncpy (mp.item, a_s, l_len.to_natural_32).do_nothing
			mp.item := mp.item + l_len
			mp.item[0] := (('%/0/').code).to_integer_8
		end

	ap_char (a_c: INTEGER_8)
		local
			l_buf___1: CE_ARRAY [INTEGER_8]
		do
			create {CE_INTEGER_8_ARRAY} l_buf___1.make (<<2>>)

			l_buf___1[0] := a_c
			l_buf___1[1] := (('%/0/').code).to_integer_8
			ap_str (l_buf___1)
		end

	ap_pos (a_pos: INTEGER_32)
		local
			l_buf___1: CE_ARRAY [INTEGER_8]
		do
			create {CE_INTEGER_8_ARRAY} l_buf___1.make (<<((((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32>>);

			(create {P_OUTPUT_STATIC}).postoa (a_pos, l_buf___1)
			ap_str (l_buf___1)
		end

	ap_linenum (a_linenum: INTEGER_32)
		local
			l_buf___1: CE_ARRAY [INTEGER_8]
		do
			create {CE_INTEGER_8_ARRAY} l_buf___1.make (<<((((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32>>);

			(create {P_OUTPUT_STATIC}).linenumtoa (a_linenum, l_buf___1)
			ap_str (l_buf___1)
		end

	ap_int (a_num: INTEGER_32)
		local
			l_buf___1: CE_ARRAY [INTEGER_8]
		do
			create {CE_INTEGER_8_ARRAY} l_buf___1.make (<<((((({PLATFORM}.Integer_32_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1) * {NATURAL_32} 302) // {NATURAL_32} 1_000 + {NATURAL_32} 1) + {NATURAL_32} 1) + {NATURAL_32} 2).to_integer_32>>);

			(create {P_OUTPUT_STATIC}).inttoa (a_num, l_buf___1)
			ap_str (l_buf___1)
		end

	ap_quest
		do
			ap_str (ce_string ("?"))
		end

	curr_byte (a_where: INTEGER_32): INTEGER_32
		local
			l_where: INTEGER_32
			l_pos2: INTEGER_32
			l_break: BOOLEAN
		do
			l_where := a_where
			l_pos2 := (create {P_POSITION_STATIC}).position (l_where)
			from
			until
				(l_break)
			loop
				l_break := False
				if l_pos2 = -1 then
					if l_where >= 0 then
						if not (l_where < (create {P_SCREEN_STATIC}).sc_height.item) then
							l_break := True
						end
					else
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					l_where := l_where + 1
					l_pos2 := (create {P_POSITION_STATIC}).position (l_where)
				end
			end
			l_break := False
			if l_pos2 = -1 then
				l_pos2 := (create {P_CH_STATIC}).ch_length
			end
			Result := l_pos2
		end

	cond (a_c: INTEGER_8; a_where: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___17: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_c.to_integer_32 -- switch 1 head
					when 97 then l_pos := -1 + 1
					when 98 then l_pos := -1 + 2
					when 99 then l_pos := -1 + 3
					when 101 then l_pos := -1 + 4
					when 102 then l_pos := -1 + 5
					when 108 then l_pos := -1 + 6
					when 100 then l_pos := -1 + 6
					when 76 then l_pos := -1 + 7
					when 68 then l_pos := -1 + 7
					when 109 then l_pos := -1 + 8
					when 110 then l_pos := -1 + 9
					when 112 then l_pos := -1 + 10
					when 80 then l_pos := -1 + 11
					when 115 then l_pos := -1 + 12
					when 66 then l_pos := -1 + 12
					when 120 then l_pos := -1 + 13
					else l_pos := -1 + 14
					end
				when 1 then -- switch 1, case 97
					Result := ((mp.item.c_pointer.to_integer_32).to_natural_32 > (message.item.c_pointer.to_integer_32).to_natural_32).to_integer
					l_return := True
				when 2 then -- switch 1, case 98
					if not l_return then
						Result := ((curr_byte (a_where)) /= -1).to_integer
						l_return := True
					end
				when 3 then -- switch 1, case 99
					if not l_return then
						Result := ((create {P_COMMAND_STATIC}).hshift.item /= 0).to_integer
						l_return := True
					end
				when 4 then -- switch 1, case 101
					if not l_return then
						Result := ((create {P_COMMAND_STATIC}).hit_eof.item)
						l_return := True
					end
				when 5 then -- switch 1, case 102
					if not l_return then
						Result := ((strcmp (((create {P_IFILE_STATIC}).get_filename ((create {P_MAIN_STATIC}).curr_ifile.item)), ce_string ("-"))) /= 0).to_integer
						l_return := True
					end
				when 6 then -- switch 1, case 108 | switch 1, case 100
					if not l_return then
						Result := ((create {P_LINE_STATIC}).linenums.item.item)
						l_return := True
					end
				when 7 then -- switch 1, case 76 | switch 1, case 68
					if not l_return then
						if ((create {P_LINE_STATIC}).linenums.item.item).to_boolean then
							if ((create {P_CH_STATIC}).ch_length) /= -1 then
								l_tmp___3 := 1
							else
								l_tmp___3 := 0
							end
						else
							l_tmp___3 := 0
						end
						Result := l_tmp___3
						l_return := True
					end
				when 8 then -- switch 1, case 109
					if not l_return then
						if ((create {P_TAGS_STATIC}).ntags).to_boolean then
							l_tmp___7 := (((create {P_TAGS_STATIC}).ntags) > 1).to_integer
						else
							l_tmp___7 := (((create {P_IFILE_STATIC}).nifile) > 1).to_integer
						end
						Result := l_tmp___7
						l_return := True
					end
				when 9 then -- switch 1, case 110
					if not l_return then
						if ((create {P_TAGS_STATIC}).ntags).to_boolean then
							l_tmp___10 := 1
						else
							l_tmp___10 := (create {P_MAIN_STATIC}).new_file.item
						end
						Result := l_tmp___10
						l_return := True
					end
				when 10 then -- switch 1, case 112
					if not l_return then
						if (curr_byte (a_where)) /= -1 then
							if ((create {P_CH_STATIC}).ch_length) > 0 then
								l_tmp___14 := 1
							else
								l_tmp___14 := 0
							end
						else
							l_tmp___14 := 0
						end
						Result := l_tmp___14
						l_return := True
					end
				when 11 then -- switch 1, case 80
					if not l_return then
						if ((create {P_LINENUM_STATIC}).currline (a_where)) /= 0 then
							l_len := (create {P_CH_STATIC}).ch_length
							if l_len > 0 then
								if ((create {P_LINENUM_STATIC}).find_linenum (l_len)) /= 0 then
									l_tmp___17 := 1
								else
									l_tmp___17 := 0
								end
							else
								l_tmp___17 := 0
							end
						else
							l_tmp___17 := 0
						end
						Result := l_tmp___17
						l_return := True
					end
				when 12 then -- switch 1, case 115 | switch 1, case 66
					if not l_return then
						Result := (((create {P_CH_STATIC}).ch_length) /= -1).to_integer
						l_return := True
					end
				when 13 then -- switch 1, case 120
					if not l_return then
						if ((create {P_TAGS_STATIC}).ntags).to_boolean then
							Result := 0
							l_return := True
						end
					end
					if not l_return then
						Result := (not ((create {P_IFILE_STATIC}).next_ifile ((create {P_MAIN_STATIC}).curr_ifile.item)).is_void).to_integer
						l_return := True
					end
				when 14 then -- switch 1, done:
					if not l_return then
						Result := 0
					end
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	protochar (a_c, a_where, a_iseditproto: INTEGER_32)
		local
			l_pos2: INTEGER_32
			l_len: INTEGER_32
			l_n: INTEGER_32
			l_linenum: INTEGER_32
			l_last_linenum: INTEGER_32
			l_h: CE_POINTER [ANY]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_c -- switch 1 head
					when 98 then l_pos := -1 + 1
					when 99 then l_pos := -1 + 2
					when 100 then l_pos := -1 + 3
					when 68 then l_pos := -1 + 4
					when 69 then l_pos := -1 + 5
					when 102 then l_pos := -1 + 6
					when 105 then l_pos := -1 + 7
					when 108 then l_pos := -1 + 8
					when 76 then l_pos := -1 + 9
					when 109 then l_pos := -1 + 10
					when 112 then l_pos := -1 + 11
					when 80 then l_pos := -1 + 12
					when 115 then l_pos := -1 + 13
					when 66 then l_pos := -1 + 13
					when 116 then l_pos := -1 + 14
					when 84 then l_pos := -1 + 15
					when 120 then l_pos := -1 + 16
					else l_pos := -1 + 17
					end
				when 1 then -- switch 1, case 98
					l_pos2 := curr_byte (a_where)
					if l_pos2 /= -1 then
						ap_pos (l_pos2)
					else
						ap_quest
					end
					l_pos := -1 + 17 -- switch 1; break
				when 2 then -- switch 1, case 99
					ap_int ((create {P_COMMAND_STATIC}).hshift.item)
					l_pos := -1 + 17 -- switch 1; break
				when 3 then -- switch 1, case 100
					l_linenum := (create {P_LINENUM_STATIC}).currline (a_where)
					if l_linenum > 0 then
						if (create {P_SCREEN_STATIC}).sc_height.item > 1 then
							ap_linenum ((l_linenum - 1) // ((create {P_SCREEN_STATIC}).sc_height.item - 1).to_integer_32 + 1)
						else
							ap_quest
						end
					else
						ap_quest
					end
					l_pos := -1 + 17 -- switch 1; break
				when 4 then -- switch 1, case 68
					l_len := (create {P_CH_STATIC}).ch_length
					if l_len = -1 then
						ap_quest
					elseif l_len = 0 then
						ap_quest
					else
						l_linenum := (create {P_LINENUM_STATIC}).find_linenum (l_len)
						if l_linenum <= 0 then
							ap_quest
						else
							ap_linenum ((l_linenum - 1) // ((create {P_SCREEN_STATIC}).sc_height.item - 1).to_integer_32 + 1)
						end
					end
					l_pos := -1 + 17 -- switch 1; break
				when 5 then -- switch 1, case 69
					ap_str ((create {P_MAIN_STATIC}).editor.item)
					l_pos := -1 + 17 -- switch 1; break
				when 6 then -- switch 1, case 102
					ap_str (((create {P_IFILE_STATIC}).get_filename ((create {P_MAIN_STATIC}).curr_ifile.item)))
					l_pos := -1 + 17 -- switch 1; break
				when 7 then -- switch 1, case 105
					if ((create {P_TAGS_STATIC}).ntags).to_boolean then
						ap_int (((create {P_TAGS_STATIC}).curr_tag))
					else
						ap_int (((create {P_IFILE_STATIC}).get_index ((create {P_MAIN_STATIC}).curr_ifile.item)))
					end
					l_pos := -1 + 17 -- switch 1; break
				when 8 then -- switch 1, case 108
					l_linenum := (create {P_LINENUM_STATIC}).currline (a_where)
					if l_linenum /= 0 then
						ap_linenum (l_linenum)
					else
						ap_quest
					end
					l_pos := -1 + 17 -- switch 1; break
				when 9 then -- switch 1, case 76
					l_len := (create {P_CH_STATIC}).ch_length
					if l_len = -1 then
						ap_quest
					elseif l_len = 0 then
						ap_quest
					else
						l_linenum := (create {P_LINENUM_STATIC}).find_linenum (l_len)
						if l_linenum <= 0 then
							ap_quest
						else
							ap_linenum (l_linenum - 1)
						end
					end
					l_pos := -1 + 17 -- switch 1; break
				when 10 then -- switch 1, case 109
					l_n := (create {P_TAGS_STATIC}).ntags
					if l_n.to_boolean then
						ap_int (l_n)
					else
						ap_int (((create {P_IFILE_STATIC}).nifile))
					end
					l_pos := -1 + 17 -- switch 1; break
				when 11 then -- switch 1, case 112
					l_pos2 := curr_byte (a_where)
					l_len := (create {P_CH_STATIC}).ch_length
					if l_pos2 /= -1 then
						if l_len > 0 then
							ap_int (((create {P_OS_STATIC}).percentage (l_pos2, l_len)))
						else
							ap_quest
						end
					else
						ap_quest
					end
					l_pos := -1 + 17 -- switch 1; break
				when 12 then -- switch 1, case 80
					l_linenum := (create {P_LINENUM_STATIC}).currline (a_where)
					if l_linenum = 0 then
						ap_quest
					else
						l_len := (create {P_CH_STATIC}).ch_length
						if l_len = -1 then
							ap_quest
						elseif l_len = 0 then
							ap_quest
						else
							l_last_linenum := (create {P_LINENUM_STATIC}).find_linenum (l_len)
							if l_last_linenum <= 0 then
								ap_quest
							else
								ap_int (((create {P_OS_STATIC}).percentage (l_linenum, l_last_linenum)))
							end
						end
					end
					l_pos := -1 + 17 -- switch 1; break
				when 13 then -- switch 1, case 115 | switch 1, case 66
					l_len := (create {P_CH_STATIC}).ch_length
					if l_len /= -1 then
						ap_pos (l_len)
					else
						ap_quest
					end
					l_pos := -1 + 17 -- switch 1; break
				when 14 then -- switch 1, case 116
					from
					until
						(l_break)
					loop
						l_break := False
						if (mp.item.c_pointer.to_integer_32).to_natural_32 > (message.item.c_pointer.to_integer_32).to_natural_32 then
							if (mp.item[-1]).to_integer_32 /= 32 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							mp.item := mp.item - 1
						end
					end
					l_break := False
					l_pos := -1 + 17 -- switch 1; break
				when 15 then -- switch 1, case 84
					if ((create {P_TAGS_STATIC}).ntags).to_boolean then
						ap_str (ce_string ("tag"))
					else
						ap_str (ce_string ("file"))
					end
					l_pos := -1 + 17 -- switch 1; break
				when 16 then -- switch 1, case 120
					l_h := (create {P_IFILE_STATIC}).next_ifile ((create {P_MAIN_STATIC}).curr_ifile.item)
					if not l_h.is_void then
						ap_str (((create {P_IFILE_STATIC}).get_filename (l_h)))
					else
						ap_quest
					end
					l_pos := -1 + 17 -- switch 1; break
				when 17 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	skipcond (a_p: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_p.is_void
		local
			l_p: CE_POINTER [INTEGER_8]
			l_iflevel: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p := a_p
					l_iflevel := 1
				when 1 then -- loop condition:
					if (l_return) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						l_p := l_p + 1
						inspect (l_p[0]).to_integer_32 -- switch 1 head
						when 63 then l_pos := -1 + 3
						when 58 then l_pos := -1 + 4
						when 46 then l_pos := -1 + 5
						when 92 then l_pos := -1 + 6
						when 0 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 3 then -- switch 1, case 63
						l_iflevel := l_iflevel + 1
						l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 58
						if l_iflevel = 1 then
							Result := l_p
							l_return := True
						end
						l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 46
						l_iflevel := l_iflevel - 1
						if l_iflevel = 0 then
							Result := l_p
							l_return := True
						end
						l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 92
						l_p := l_p + 1
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, case 0
						Result := (l_p - 1)
						l_return := True
				when 8 then -- switch 1, done:
						l_pos := -1 + 1 -- back to loop condition
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	wherechar (a_p: CE_POINTER [INTEGER_8]; a_wp: CE_POINTER [INTEGER_32]): CE_POINTER [INTEGER_8]
		require
			not a_p.is_void
		local
			l_p: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_p := a_p
					inspect (l_p[0]).to_integer_32 -- switch 1 head
					when 98 then l_pos := -1 + 1
					when 100 then l_pos := -1 + 1
					when 108 then l_pos := -1 + 1
					when 112 then l_pos := -1 + 1
					when 80 then l_pos := -1 + 1
					else l_pos := -1 + 8
					end
				when 1 then -- switch 1, case 98 | switch 1, case 100 | switch 1, case 108 | switch 1, case 112 | switch 1, case 80
					l_p := l_p + 1
					inspect (l_p[0]).to_integer_32 -- switch 2 head
					when 116 then l_pos := -1 + 2
					when 109 then l_pos := -1 + 3
					when 98 then l_pos := -1 + 4
					when 66 then l_pos := -1 + 5
					when 106 then l_pos := -1 + 6
					else l_pos := -1 + 7
					end
				when 2 then -- switch 2, case 116
					a_wp.item := 0
					l_pos := -1 + 8 -- switch 2; break
				when 3 then -- switch 2, case 109
					a_wp.item := -3
					l_pos := -1 + 8 -- switch 2; break
				when 4 then -- switch 2, case 98
					a_wp.item := -1
					l_pos := -1 + 8 -- switch 2; break
				when 5 then -- switch 2, case 66
					a_wp.item := -2
					l_pos := -1 + 8 -- switch 2; break
				when 6 then -- switch 2, case 106
					a_wp.item := (create {P_POSITION_STATIC}).adjsline ((create {P_MAIN_STATIC}).jump_sline.item.item)
					l_pos := -1 + 8 -- switch 2; break
				when 7 then -- switch 2, default:
					a_wp.item := 0
					l_p := l_p - 1
					l_pos := -1 + 8 -- switch 2; break
				when 8 then -- switch 2, done: | switch 1, done:
					Result := l_p
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	pr_expand (a_proto: CE_POINTER [INTEGER_8]; a_maxwidth: INTEGER_32): CE_POINTER [INTEGER_8]
		require
			not a_proto.is_void
		local
			l_p: CE_POINTER [INTEGER_8]
			l_c: INTEGER_32
			l_where: CE_ARRAY [INTEGER_32]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_where.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					mp.item := message.item
					if (a_proto[0]).to_integer_32 = 0 then
						Result := (ce_string (""))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						l_p := a_proto
				when 2 then -- loop condition:
						if (l_p[0]).to_integer_32 = 0 then
							l_pos := -1 + 11 -- skip loop
						end
				when 3 then -- loop body:
						inspect (l_p[0]).to_integer_32 -- switch 1 head
						when 92 then l_pos := -1 + 5
						when 63 then l_pos := -1 + 6
						when 58 then l_pos := -1 + 7
						when 46 then l_pos := -1 + 8
						when 37 then l_pos := -1 + 9
						else l_pos := -1 + 4
						end
				when 4 then -- switch 1, default:
						ap_char (l_p[0])
						l_pos := -1 + 10 -- switch 1; break
				when 5 then -- switch 1, case 92
						l_p := l_p + 1
						ap_char (l_p[0])
						l_pos := -1 + 10 -- switch 1; break
				when 6 then -- switch 1, case 63
						l_p := l_p + 1
						l_c := (l_p[0]).to_integer_32
						if l_c = 0 then
							l_p := l_p - 1
						else
							l_where.item := 0
							l_p := wherechar (l_p, l_where)
							if not (cond (l_c.to_integer_8, l_where.item)).to_boolean then
								l_p := skipcond (l_p)
							end
						end
						l_pos := -1 + 10 -- switch 1; break
				when 7 then -- switch 1, case 58
						l_p := skipcond (l_p)
						l_pos := -1 + 10 -- switch 1; break
				when 8 then -- switch 1, case 46
						l_pos := -1 + 10 -- switch 1; break
				when 9 then -- switch 1, case 37
						l_p := l_p + 1
						l_c := (l_p[0]).to_integer_32
						if l_c = 0 then
							l_p := l_p - 1
						else
							l_where.item := 0
							l_p := wherechar (l_p, l_where)
							protochar (l_c, l_where.item, (a_proto.is_equal ((create {P_MAIN_STATIC}).editproto.item)).to_integer)
						end
						l_pos := -1 + 10 -- switch 1; break
				when 10 then -- switch 1, done:
						l_p := l_p + 1
						l_pos := -1 + 2 -- back to loop condition
				when 11 then -- loop done
						if mp.item.is_equal (message.item) then
							Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
							l_return := True
						end
				when 12 then -- if done
					if not l_return and then (a_maxwidth > 0) then
						if (mp.item.c_pointer.to_integer_32).to_natural_32 >= ((message.item + a_maxwidth).c_pointer.to_integer_32).to_natural_32 then
							Result := (mp.item - a_maxwidth)
							l_return := True
						end
					end
					if not l_return then
						Result := message.item
					end
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eq_message: CE_POINTER [INTEGER_8]
		do
			Result := (pr_expand (eqproto.item.item, 0))
		end

	pr_string: CE_POINTER [INTEGER_8]
		local
			l_prompt___0: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
		do
			if ((((create {P_CH_STATIC}).ch_getflags)).bit_and (8)).to_boolean then
				l_tmp___0 := hproto.item.item
			else
				l_tmp___0 := (create {P_OPTFUNC_STATIC}).prproto.item[(create {P_OPTFUNC_STATIC}).pr_type.item.item]
			end
			l_prompt___0 := pr_expand (l_tmp___0, (((create {P_SCREEN_STATIC}).sc_width.item - (create {P_SCREEN_STATIC}).so_s_width.item) - (create {P_SCREEN_STATIC}).so_e_width.item) - 2);
			(create {P_MAIN_STATIC}).new_file.item := 0
			Result := l_prompt___0
		end

	wait_message: CE_POINTER [INTEGER_8]
		do
			Result := (pr_expand (wproto.item.item, (((create {P_SCREEN_STATIC}).sc_width.item - (create {P_SCREEN_STATIC}).so_s_width.item) - (create {P_SCREEN_STATIC}).so_e_width.item) - 2))
		end

end
