class
	P_XMALLOC_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public routines

	xmalloc (a_n: NATURAL_32): CE_POINTER [ANY]
		local
			l_p___0: CE_POINTER [ANY]
		do
			l_p___0 := (malloc (a_n))
			if l_p___0.is_void then
				if a_n /= {NATURAL_32} 0 then
					(create {P_XALLOC_DIE_STATIC}).xalloc_die
				end
			end
			Result := l_p___0
		end

	xrealloc (a_p___0: CE_POINTER [ANY]; a_n: NATURAL_32): CE_POINTER [ANY]
		local
			l_p___0: CE_POINTER [ANY]
		do
			l_p___0 := a_p___0
			l_p___0 := realloc (l_p___0, a_n)
			if l_p___0.is_void then
				if a_n /= {NATURAL_32} 0 then
					(create {P_XALLOC_DIE_STATIC}).xalloc_die
				end
			end
			Result := l_p___0
		end

	x2realloc (a_p___0: CE_POINTER [ANY]; a_pn: CE_POINTER [NATURAL_32]): CE_POINTER [ANY]
		require
			not a_pn.is_void
		do
			Result := ((create {P_XALLOC_STATIC}).x2nrealloc (a_p___0, a_pn, (1).to_natural_32))
		end

	xzalloc (a_s: NATURAL_32): CE_POINTER [ANY]
		do
			Result := (memset ((xmalloc (a_s)), 0, a_s))
		end

	xcalloc (a_n, a_s: NATURAL_32): CE_POINTER [ANY]
		local
			l_p___0: CE_POINTER [ANY]
		do
			l_p___0 := calloc (a_n, a_s)
			if l_p___0.is_void then
				(create {P_XALLOC_DIE_STATIC}).xalloc_die
			end
			Result := l_p___0
		end

	xmemdup (a_p___0: CE_POINTER [ANY]; a_s: NATURAL_32): CE_POINTER [ANY]
		do
			Result := (memcpy ((xmalloc (a_s)), a_p___0, a_s))
		end

	xstrdup (a_string: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		require
			not a_string.is_void
		do
			Result := (create {CE_INTEGER_8_POINTER}.make_cast ((xmemdup (create {CE_VOID_POINTER}.make_cast (a_string), (strlen (a_string)) + {NATURAL_32} 1))))
		end

end
