class
	P_BFU_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC

feature {ANY} -- public attributes

	m_bar: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make_initialized (<<
					(0).to_natural_8
				>>)
		end

feature {ANY} -- public routines

	getml (a_args: TUPLE [a_p: CE_POINTER [ANY]]): CE_POINTER [PD_MEMORY_LIST]
		local
			l_ml: CE_POINTER [PD_MEMORY_LIST]
			l_ap: CE_VA_LIST
			l_n: INTEGER_32
			l_q: CE_POINTER [ANY]
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			create l_ap.make_shared (default_pointer)

			l_n := 0
			l_q := a_args.a_p
			l_ap := create {CE_VA_LIST}.make (a_args, agent getml)
			from
			until
				not (not (l_return) and then (not l_q.is_void))
			loop
				if l_n = 2_147_483_647 then
					from
					until
						False
					loop
						(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 11]);
						(create {P_KBD_STATIC}).fatal_tty_exit
						exit (4)
					end
				end
				l_n := l_n + 1
				l_q := (create {CE_VOID_POINTER}.make_cast (l_ap.pointer_item))
			end
			if l_n.to_natural_32 > ({NATURAL_32} 2_147_483_647 - (create {PD_MEMORY_LIST}.make).structure_size.to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 14]);
					(create {P_KBD_STATIC}).fatal_tty_exit
					exit (4)
				end
			end
			l_ml := create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 15, (create {PD_MEMORY_LIST}.make).structure_size.to_natural_32 + l_n.to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
			l_ml.item.n := l_n
			l_n := 0
			l_q := a_args.a_p
			l_ap := create {CE_VA_LIST}.make (a_args, agent getml)
			from
			until
				l_q.is_void
			loop
				l_tmp___0 := l_n
				l_n := l_n + 1
				l_ml.item.p[l_tmp___0] := l_q
				l_q := (create {CE_VOID_POINTER}.make_cast (l_ap.pointer_item))
			end
			Result := l_ml
		end

	add_to_ml (a_args: TUPLE [a_ml: CE_POINTER [CE_POINTER [PD_MEMORY_LIST]]])
		require
			not a_args.a_ml.is_void
		local
			l_nml: CE_POINTER [PD_MEMORY_LIST]
			l_ap: CE_VA_LIST
			l_n: INTEGER_32
			l_q: CE_POINTER [ANY]
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create l_ap.make_shared (default_pointer)

			l_n := 0
			if (a_args.a_ml.item).is_void then
				a_args.a_ml.item := create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 33, (create {PD_MEMORY_LIST}.make).structure_size.to_natural_32)));
				(a_args.a_ml.item).item.n := 0
			end
			l_ap := create {CE_VA_LIST}.make (a_args, agent add_to_ml)
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_q := (create {CE_VOID_POINTER}.make_cast (l_ap.pointer_item))
				if l_q.is_void then
					l_break := True
				end
				if not (l_return or l_break) then
					if l_n = 2_147_483_647 then
						from
						until
							False
						loop
							(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 38]);
							(create {P_KBD_STATIC}).fatal_tty_exit
							exit (4)
						end
					end
					l_n := l_n + 1
				end
			end
			l_break := False
			if l_n.to_natural_32 + ((a_args.a_ml.item).item.n).to_natural_32 > ({NATURAL_32} 2_147_483_647 - (create {PD_MEMORY_LIST}.make).structure_size.to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 41]);
					(create {P_KBD_STATIC}).fatal_tty_exit
					exit (4)
				end
			end
			l_nml := create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 42, create {CE_VOID_POINTER}.make_cast (a_args.a_ml.item), (create {PD_MEMORY_LIST}.make).structure_size.to_natural_32 + (l_n + (a_args.a_ml.item).item.n).to_natural_32 * {PLATFORM}.Pointer_bytes.to_natural_32)))
			l_ap := create {CE_VA_LIST}.make (a_args, agent add_to_ml)
			from
			until
				(l_break)
			loop
				l_break := False
				l_q := (create {CE_VOID_POINTER}.make_cast (l_ap.pointer_item))
				if l_q.is_void then
					l_break := True
				end
				if not (l_return or l_break) then
					l_tmp___1 := l_nml.item.n
					l_nml.item.n := (l_nml.item.n) + 1
					l_nml.item.p[l_tmp___1] := l_q
				end
			end
			l_break := False
			a_args.a_ml.item := l_nml
		end

	freeml (a_ml: CE_POINTER [PD_MEMORY_LIST])
		local
			l_i: INTEGER_32
			l_return: BOOLEAN
		do
			if a_ml.is_void then
				l_return := True
			end
			if not l_return then
				l_i := 0
				from
				until
					not (l_i < a_ml.item.n)
				loop
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 54, a_ml.item.p[l_i])
					l_i := l_i + 1
				end
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 55, create {CE_VOID_POINTER}.make_cast (a_ml))
			end
		end

	new_menu (a_free_i: INTEGER_32): CE_POINTER [PD_MENU_ITEM]
		local
			l_mi: CE_POINTER [PD_MENU_ITEM]
		do
			l_mi := create {CE_CLASS_POINTER [PD_MENU_ITEM]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 419, (create {PD_MENU_ITEM}.make).structure_size.to_natural_32)))
			memset (create {CE_VOID_POINTER}.make_cast (l_mi), 0, (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).do_nothing
			l_mi.item.free_i := a_free_i
			Result := l_mi
		end

	add_to_menu (a_mi: CE_POINTER [CE_POINTER [PD_MENU_ITEM]]; a_text, a_rtext, a_hotkey: CE_POINTER [NATURAL_8]; a_func: CE_ROUTINE; a_data: CE_POINTER [ANY]; a_in_m: INTEGER_32)
		require
			not a_mi.is_void
		local
			l_mii: CE_POINTER [PD_MENU_ITEM]
			l_n: INTEGER_32
			l_return: BOOLEAN
		do
			l_n := 0
			from
			until
				not (not (l_return) and then (not ((a_mi.item + l_n).item.text).is_void))
			loop
				if l_n = 2_147_483_647 then
					from
					until
						False
					loop
						(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 429]);
						(create {P_KBD_STATIC}).fatal_tty_exit
						exit (4)
					end
				end
				l_n := l_n + 1
			end
			if l_n.to_natural_32 + {NATURAL_32} 2 > {NATURAL_32} 2_147_483_647 // (create {PD_MENU_ITEM}.make).structure_size.to_natural_32 then
				from
				until
					False
				loop
					(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 430]);
					(create {P_KBD_STATIC}).fatal_tty_exit
					exit (4)
				end
			end
			l_mii := create {CE_CLASS_POINTER [PD_MENU_ITEM]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 431, create {CE_VOID_POINTER}.make_cast (a_mi.item), (l_n + 2).to_natural_32 * (create {PD_MENU_ITEM}.make).structure_size.to_natural_32)))
			a_mi.item := l_mii
			memcpy (create {CE_VOID_POINTER}.make_cast (((l_mii + l_n) + 1)), create {CE_VOID_POINTER}.make_cast ((l_mii + l_n)), (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).do_nothing;
			(l_mii + l_n).item.text := a_text;
			(l_mii + l_n).item.rtext := a_rtext;
			(l_mii + l_n).item.hotkey := a_hotkey;
			(l_mii + l_n).item.func := a_func;
			(l_mii + l_n).item.data := a_data;
			(l_mii + l_n).item.in_m := a_in_m
		end

	check_number (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		require
			not a_di.is_void
		local
			l_end: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_end.make (<<1>>)

			l_l := (strtol (create {CE_INTEGER_8_POINTER}.make_cast (a_di.item.cdata), create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (l_end), 10))
			if not ((a_di.item.cdata).item).to_boolean then
				((a_dlg.item.win).item.term).item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 4, 1, (create {P_LINKS_STATIC}).dummyarray.item + 5, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
				Result := 1
				l_return := True
			elseif (l_end.item.item).to_boolean then
				((a_dlg.item.win).item.term).item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 4, 1, (create {P_LINKS_STATIC}).dummyarray.item + 5, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
				Result := 1
				l_return := True
			end
			if not l_return then
				if l_l < ((a_di.item.item).item.gid).to_integer_32 then
					((a_dlg.item.win).item.term).item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 4, 1, (create {P_LINKS_STATIC}).dummyarray.item + 7, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
					Result := 1
					l_return := True
				elseif l_l > ((a_di.item.item).item.gnum).to_integer_32 then
					((a_dlg.item.win).item.term).item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 4, 1, (create {P_LINKS_STATIC}).dummyarray.item + 7, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	check_nonempty (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		require
			not a_di.is_void
		local
			l_p: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_p := a_di.item.cdata
			from
			until
				not (not (l_return) and then ((l_p.item).to_boolean))
			loop
				if (l_p.item).to_integer_32 > 32 then
					Result := 0
					l_return := True
				end
				if not l_return then
					l_p := l_p + 1
				end
			end
			if not l_return then
				((a_dlg.item.win).item.term).item.msg_box ([create {CE_CLASS_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), (create {P_LINKS_STATIC}).dummyarray.item + 8, 1, (create {P_LINKS_STATIC}).dummyarray.item + 9, create {CE_VOID_POINTER}.make_shared (default_pointer), 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
				Result := 1
			end
		end

	add_to_history (a_h: CE_POINTER [PD_HISTORY]; a_t: CE_POINTER [NATURAL_8])
		local
			l_hi: CE_POINTER [PD_HISTORY_ITEM]
			l_hs: CE_POINTER [PD_HISTORY_ITEM]
			l_l: NATURAL_32
			l_hd: CE_POINTER [PD_HISTORY_ITEM]
			l_hd___0: CE_POINTER [PD_HISTORY_ITEM]
			l_return, l_break: BOOLEAN
		do
			if a_h.is_void then
				l_return := True
			elseif a_t.is_void then
				l_return := True
			elseif not (a_t.item).to_boolean then
				l_return := True
			end
			if not l_return then
				l_l := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_t))) + {NATURAL_32} 1
				if l_l > {NATURAL_32} 2_147_483_647 - (create {PD_HISTORY_ITEM}.make).structure_size.to_natural_32 then
					from
					until
						False
					loop
						(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("bfu.c"), 1_278]);
						(create {P_KBD_STATIC}).fatal_tty_exit
						exit (4)
					end
				end
				l_hi := create {CE_CLASS_POINTER [PD_HISTORY_ITEM]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 1_279, (create {PD_HISTORY_ITEM}.make).structure_size.to_natural_32 + l_l)))
				memcpy (create {CE_VOID_POINTER}.make_cast ((l_hi.item.d)), create {CE_VOID_POINTER}.make_cast (a_t), l_l).do_nothing
				l_hs := create {CE_CLASS_POINTER [PD_HISTORY_ITEM]}.make_cast (a_h.item.items.next)
				from
				until
					l_hs.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_h.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))
				loop
					if not (strcmp (create {CE_INTEGER_8_POINTER}.make_cast ((l_hs.item.d)), create {CE_INTEGER_8_POINTER}.make_cast (a_t))).to_boolean then
						l_hd := l_hs
						l_hs := l_hs.item.prev;
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_hd));
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_hd.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_hd.item.prev);
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_hd.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_hd.item.next);
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_hd));
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 1_285, create {CE_VOID_POINTER}.make_cast (l_hd))
						a_h.item.n := (a_h.item.n) - 1
					end
					l_hs := l_hs.item.next
				end
				from
				until
					(l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_h.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))))
					l_hi.item.next := (create {CE_CLASS_POINTER [PD_HISTORY_ITEM]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_h.c_pointer + (create {PD_HISTORY}.make).offset_of ("items"))))).item.next
					l_hi.item.prev := create {CE_CLASS_POINTER [PD_HISTORY_ITEM]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_h.c_pointer + (create {PD_HISTORY}.make).offset_of ("items"))));
					(create {CE_CLASS_POINTER [PD_HISTORY_ITEM]}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_h.c_pointer + (create {PD_HISTORY}.make).offset_of ("items"))))).item.next := l_hi;
					(l_hi.item.next).item.prev := l_hi;
					(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_h.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))))
					l_break := True
				end
				l_break := False
				a_h.item.n := (a_h.item.n) + 1
				from
				until
					not (not (l_return) and then (a_h.item.n > 4_096))
				loop
					l_hd___0 := create {CE_CLASS_POINTER [PD_HISTORY_ITEM]}.make_cast (a_h.item.items.prev)
					if l_hd___0.is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_h.c_pointer + (create {PD_HISTORY}.make).offset_of ("items"))) then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c"));
							(create {P_LINKS_STATIC}).errline.item := 1_293;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("history is empty"))])
						end
						a_h.item.n := 0
						l_return := True
					end
					if not l_return then
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_hd___0));
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_hd___0.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_hd___0.item.prev);
						(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_hd___0.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_hd___0.item.next);
						(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_hd___0));
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bfu.c")), 1_298, create {CE_VOID_POINTER}.make_cast (l_hd___0))
						a_h.item.n := (a_h.item.n) - 1
					end
				end
			end
			if not l_return then
			end
		end

feature {ANY} -- routine addresses

	freeml_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent freeml)
		end

	check_number_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent check_number)
		end

	check_nonempty_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent check_nonempty)
		end

end
