class
	P_CONNECT_STATIC

inherit
	CE_UTILITIES
	S_UNISTD_STATIC
	S_STRING_STATIC

feature {ANY} -- public routines

	close_socket (a_s: CE_POINTER [INTEGER_32])
		require
			not a_s.is_void
		local
			l_return: BOOLEAN
		do
			if a_s.item = -1 then
				l_return := True
			end
			if not l_return then
				close (a_s.item).do_nothing;
				(create {P_SELECT_STATIC}).set_handlers (a_s.item, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer))
				a_s.item := -1
			end
		end

	alloc_read_buffer (a_c: CE_POINTER [PD_CONNECTION]): CE_POINTER [PD_READ_BUFFER]
		local
			l_rb: CE_POINTER [PD_READ_BUFFER]
		do
			l_rb := create {CE_CLASS_POINTER [PD_READ_BUFFER]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("connect.c")), 335, (create {PD_READ_BUFFER}.make).structure_size.to_natural_32 + {NATURAL_32} 64_240)))
			memset (create {CE_VOID_POINTER}.make_cast (l_rb), 0, (create {PD_READ_BUFFER}.make).structure_size.to_natural_32).do_nothing
			Result := l_rb
		end

end
