class
	P_TYPES_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC

feature {ANY} -- public attributes

	mailto_prog: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (mailto_prog.item), create {CE_VOID_POINTER}.make_cast (mailto_prog.item)])
		end

	telnet_prog: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (telnet_prog.item), create {CE_VOID_POINTER}.make_cast (telnet_prog.item)])
		end

	tn3270_prog: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (tn3270_prog.item), create {CE_VOID_POINTER}.make_cast (tn3270_prog.item)])
		end

	mms_prog: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (mms_prog.item), create {CE_VOID_POINTER}.make_cast (mms_prog.item)])
		end

	assoc: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (assoc.item), create {CE_VOID_POINTER}.make_cast (assoc.item)])
		end

	assoc_cnt: CE_STATIC [NATURAL_32]
		once ("PROCESS")
			Result.item := (0).to_natural_32
		end

	extensions: CE_STATIC [CE_ARRAY [PD_LIST_HEAD]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_LIST_HEAD]}.make (<<1>>)
			Result.item[0] := create {PD_LIST_HEAD}.make_initialized ([create {CE_VOID_POINTER}.make_cast (extensions.item), create {CE_VOID_POINTER}.make_cast (extensions.item)])
		end

	mi_no_assoc: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 201, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_BFU_STATIC}).m_bar.item, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

	mi_no_ext: CE_STATIC [CE_ARRAY [PD_MENU_ITEM]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_MENU_ITEM]}.make_initialized (<<
					create {PD_MENU_ITEM}.make_initialized ([(create {P_LINKS_STATIC}).dummyarray.item + 204, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), (create {P_BFU_STATIC}).m_bar.item, create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0]),
					create {PD_MENU_ITEM}.make_initialized ([create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_VOID_POINTER}.make_shared (default_pointer), 0, 0])
				>>)
		end

feature {ANY} -- public routines

	get_assoc_cnt: NATURAL_32
		do
			assoc_cnt.item := assoc_cnt.item + 1
			if not assoc_cnt.item.to_boolean then
				assoc_cnt.item := (1).to_natural_32
			end
			Result := assoc_cnt.item
		end

	is_in_list (a_list, a_str: CE_POINTER [NATURAL_8]; a_l: INTEGER_32): INTEGER_32
		local
			l_list: CE_POINTER [NATURAL_8]
			l_l2: CE_POINTER [NATURAL_8]
			l_l3: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_list := a_list
					if not a_l.to_boolean then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 2 -- skip if block
					end
				when 1 then -- if: | rep:
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_list.item).to_boolean then
								if not ((l_list.item).to_integer_32 <= 32) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_list := l_list + 1
							end
						end
						l_break := False
						if not (l_list.item).to_boolean then
							Result := 0
							l_return := True
						end
				when 2 then -- if done
					if not l_return then
						l_l2 := l_list
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_l2.item).to_boolean then
								if (l_l2.item).to_integer_32 = 44 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_l2 := l_l2 + 1
							end
						end
						l_break := False
						l_l3 := l_l2 - 1
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_l3.c_pointer.to_integer_32).to_natural_32 >= (l_list.c_pointer.to_integer_32).to_natural_32 then
								if not ((l_l3.item).to_integer_32 <= 32) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_l3 := l_l3 - 1
							end
						end
						l_break := False
						l_l3 := l_l3 + 1
						if l_l3.distance (l_list) = a_l then
							if not ((create {P_LINKS_STATIC}).casecmp (a_str, l_list, a_l.to_natural_32)).to_boolean then
								Result := 1
								l_return := True
							end
						end
					end
					if not l_return then
						l_list := l_l2
						if (l_list.item).to_integer_32 = 44 then
							l_list := l_list + 1
						end
						l_pos := -1 + 1 -- goto rep
					end
				when 3 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_content_type (a_head___0, a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_e: CE_POINTER [PD_EXTENSION]
			l_a: CE_POINTER [PD_ASSOC]
			l_ct: CE_POINTER [NATURAL_8]
			l_ext: CE_POINTER [NATURAL_8]
			l_exxt: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_extl: INTEGER_32
			l_el: CE_ARRAY [INTEGER_32]
			l_s: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_POINTER} l_ext.make
			create {CE_POINTER_ARRAY [NATURAL_8]} l_exxt.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_el.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (not a_head___0.is_void) then
						l_ct := (create {P_HTTP_STATIC}).parse_http_header (a_head___0, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Content-Type")), create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer))
						if (not l_ct.is_void) then
							l_s := create {CE_NATURAL_8_POINTER}.make_cast ((strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_ct), (';').code)))
							if (not l_s.is_void) then
								l_s.item := (0).to_natural_8
							end
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_ct.item).to_boolean then
									if not ((l_ct[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ct))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 <= 32) then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_ct[((strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ct))) - {NATURAL_32} 1).to_integer_32] := (0).to_natural_8
								end
							end
							l_break := False
							Result := l_ct
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_ext := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_extl := 0
						l_ct := a_url
						from
						until
							(l_break)
						loop
							l_break := False
							if (l_ct.item).to_boolean then
								if ((create {P_LINKS_STATIC}).end_of_dir (l_ct.item)).to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								if (l_ct.item).to_integer_32 = 46 then
									l_ext := l_ct + 1
								elseif ((create {P_OS_DEP_STATIC}).dir_sep ((l_ct.item).to_integer_8)).to_boolean then
									l_ext := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
								end
								l_ct := l_ct + 1
							end
						end
						l_break := False
						if (not l_ext.is_void) then
							from
							until
								(l_break)
							loop
								l_break := False
								if (l_ext[l_extl]).to_boolean then
									if ((create {P_OS_DEP_STATIC}).dir_sep ((l_ext[l_extl]).to_integer_8)).to_boolean then
										l_break := True
									elseif ((create {P_LINKS_STATIC}).end_of_dir (l_ext[l_extl])).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_extl := l_extl + 1
								end
							end
							l_break := False
						end
						if l_extl /= 3 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if ((create {P_LINKS_STATIC}).casecmp (l_ext, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("htm")), (3).to_natural_32)).to_boolean then
							l_pos := -1 + 4 -- goto _L
						else
							l_tmp___6 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 70, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("text/html")))
							Result := l_tmp___6
							l_return := True
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if l_extl = 4 then
							if not ((create {P_LINKS_STATIC}).casecmp (l_ext, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("html")), (4).to_natural_32)).to_boolean then
								l_tmp___6 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 70, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("text/html")))
								Result := l_tmp___6
								l_return := True
							end
						end
				when 5 then -- if done
					if not l_return then
						l_e := create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast (extensions.item.item.next)
						from
						until
							not (not (l_return) and then (not l_e.is_equal (extensions.item)))
						loop
							if (is_in_list (l_e.item.ext, l_ext, l_extl)).to_boolean then
								Result := ((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 71, l_e.item.ct))
								l_return := True
							end
							if not l_return then
								l_e := l_e.item.next
							end
						end
					end
					if not l_return then
						l_exxt.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 72)
						l_el.item := 0;
						(create {P_LINKS_STATIC}).add_to_str (l_exxt, l_el, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("application/x-")));
						(create {P_LINKS_STATIC}).add_bytes_to_str (l_exxt, l_el, l_ext, l_extl)
						l_a := create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast (assoc.item.item.next)
						from
						until
							not (not (l_return) and then (not l_a.is_equal (assoc.item)))
						loop
							if (is_in_list (l_a.item.ct, l_exxt.item, l_el.item)).to_boolean then
								Result := (l_exxt.item)
								l_return := True
							end
							if not l_return then
								l_a := l_a.item.next
							end
						end
					end
					if not l_return then
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 76, create {CE_VOID_POINTER}.make_cast (l_exxt.item))
						if not ((create {P_DEFAULT_STATIC}).force_html.item).to_boolean then
							l_tmp___14 := ((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 77, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("text/plain"))))
						else
							l_tmp___14 := ((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 77, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("text/html"))))
						end
						Result := l_tmp___14
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	free_types
		local
			l_a: CE_POINTER [PD_ASSOC]
			l_e: CE_POINTER [PD_EXTENSION]
			l_p: CE_POINTER [PD_PROTOCOL_PROGRAM]
			l_a__: CE_POINTER [PD_XLIST_HEAD]
			l_a_____0: CE_POINTER [PD_XLIST_HEAD]
			l_a_____1: CE_POINTER [PD_XLIST_HEAD]
			l_a_____2: CE_POINTER [PD_XLIST_HEAD]
			l_a_____3: CE_POINTER [PD_XLIST_HEAD]
			l_a_____4: CE_POINTER [PD_XLIST_HEAD]
		do
			l_a := create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast (assoc.item.item.next)
			from
			until
				l_a.is_equal (assoc.item)
			loop
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 93, create {CE_VOID_POINTER}.make_cast (l_a.item.ct));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 94, create {CE_VOID_POINTER}.make_cast (l_a.item.prog));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 95, create {CE_VOID_POINTER}.make_cast (l_a.item.label))
				l_a := l_a.item.next
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (assoc.item))
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (assoc.item.item.next)
			from
			until
				l_a__.is_equal (assoc.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (assoc.item.item.prev)
			from
			until
				l_a__.is_equal (assoc.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__))
				l_a__ := l_a__.item.prev
			end
			from
			until
				(assoc.item.item.next).is_equal (assoc.item)
			loop
				l_a__ := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (assoc.item.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a__.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a__.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a__));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 97, create {CE_VOID_POINTER}.make_cast (l_a__))
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (assoc.item))
			l_e := create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast (extensions.item.item.next)
			from
			until
				l_e.is_equal (extensions.item)
			loop
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 99, create {CE_VOID_POINTER}.make_cast (l_e.item.ext));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 100, create {CE_VOID_POINTER}.make_cast (l_e.item.ct))
				l_e := l_e.item.next
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (extensions.item))
			l_a_____0 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (extensions.item.item.next)
			from
			until
				l_a_____0.is_equal (extensions.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____0))
				l_a_____0 := l_a_____0.item.next
			end
			l_a_____0 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (extensions.item.item.prev)
			from
			until
				l_a_____0.is_equal (extensions.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____0))
				l_a_____0 := l_a_____0.item.prev
			end
			from
			until
				(extensions.item.item.next).is_equal (extensions.item)
			loop
				l_a_____0 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (extensions.item.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____0));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____0.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a_____0.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____0.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a_____0.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____0));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 102, create {CE_VOID_POINTER}.make_cast (l_a_____0))
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (extensions.item))
			l_p := create {CE_CLASS_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (mailto_prog.item.item.next)
			from
			until
				l_p.is_equal (mailto_prog.item)
			loop
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 103, create {CE_VOID_POINTER}.make_cast (l_p.item.prog))
				l_p := l_p.item.next
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (mailto_prog.item))
			l_a_____1 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (mailto_prog.item.item.next)
			from
			until
				l_a_____1.is_equal (mailto_prog.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____1))
				l_a_____1 := l_a_____1.item.next
			end
			l_a_____1 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (mailto_prog.item.item.prev)
			from
			until
				l_a_____1.is_equal (mailto_prog.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____1))
				l_a_____1 := l_a_____1.item.prev
			end
			from
			until
				(mailto_prog.item.item.next).is_equal (mailto_prog.item)
			loop
				l_a_____1 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (mailto_prog.item.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____1));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____1.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a_____1.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____1.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a_____1.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____1));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 104, create {CE_VOID_POINTER}.make_cast (l_a_____1))
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (mailto_prog.item))
			l_p := create {CE_CLASS_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (telnet_prog.item.item.next)
			from
			until
				l_p.is_equal (telnet_prog.item)
			loop
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 105, create {CE_VOID_POINTER}.make_cast (l_p.item.prog))
				l_p := l_p.item.next
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (telnet_prog.item))
			l_a_____2 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (telnet_prog.item.item.next)
			from
			until
				l_a_____2.is_equal (telnet_prog.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____2))
				l_a_____2 := l_a_____2.item.next
			end
			l_a_____2 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (telnet_prog.item.item.prev)
			from
			until
				l_a_____2.is_equal (telnet_prog.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____2))
				l_a_____2 := l_a_____2.item.prev
			end
			from
			until
				(telnet_prog.item.item.next).is_equal (telnet_prog.item)
			loop
				l_a_____2 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (telnet_prog.item.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____2));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____2.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a_____2.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____2.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a_____2.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____2));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 106, create {CE_VOID_POINTER}.make_cast (l_a_____2))
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (telnet_prog.item))
			l_p := create {CE_CLASS_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (tn3270_prog.item.item.next)
			from
			until
				l_p.is_equal (tn3270_prog.item)
			loop
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 107, create {CE_VOID_POINTER}.make_cast (l_p.item.prog))
				l_p := l_p.item.next
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (tn3270_prog.item))
			l_a_____3 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (tn3270_prog.item.item.next)
			from
			until
				l_a_____3.is_equal (tn3270_prog.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____3))
				l_a_____3 := l_a_____3.item.next
			end
			l_a_____3 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (tn3270_prog.item.item.prev)
			from
			until
				l_a_____3.is_equal (tn3270_prog.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____3))
				l_a_____3 := l_a_____3.item.prev
			end
			from
			until
				(tn3270_prog.item.item.next).is_equal (tn3270_prog.item)
			loop
				l_a_____3 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (tn3270_prog.item.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____3));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____3.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a_____3.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____3.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a_____3.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____3));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 108, create {CE_VOID_POINTER}.make_cast (l_a_____3))
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (tn3270_prog.item))
			l_p := create {CE_CLASS_POINTER [PD_PROTOCOL_PROGRAM]}.make_cast (mms_prog.item.item.next)
			from
			until
				l_p.is_equal (mms_prog.item)
			loop
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 109, create {CE_VOID_POINTER}.make_cast (l_p.item.prog))
				l_p := l_p.item.next
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (mms_prog.item))
			l_a_____4 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (mms_prog.item.item.next)
			from
			until
				l_a_____4.is_equal (mms_prog.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____4))
				l_a_____4 := l_a_____4.item.next
			end
			l_a_____4 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (mms_prog.item.item.prev)
			from
			until
				l_a_____4.is_equal (mms_prog.item)
			loop
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____4))
				l_a_____4 := l_a_____4.item.prev
			end
			from
			until
				(mms_prog.item.item.next).is_equal (mms_prog.item)
			loop
				l_a_____4 := create {CE_CLASS_POINTER [PD_XLIST_HEAD]}.make_cast (mms_prog.item.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____4));
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____4.item.next)).item.prev := create {CE_VOID_POINTER}.make_cast (l_a_____4.item.prev);
				(create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____4.item.prev)).item.next := create {CE_VOID_POINTER}.make_cast (l_a_____4.item.next);
				(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (l_a_____4));
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 110, create {CE_VOID_POINTER}.make_cast (l_a_____4))
			end
			(create {P_ERROR_STATIC}).do_not_optimize_here (create {CE_VOID_POINTER}.make_cast (mms_prog.item))
		end

	really_del_ct (a_fcp: CE_POINTER [ANY])
		local
			l_fc: NATURAL_32
			l_del: CE_POINTER [PD_ASSOC]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fc := ((a_fcp.c_pointer.to_integer_32).to_integer_32).to_natural_32
					l_del := create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast (assoc.item.item.next)
				when 1 then -- loop condition:
					if l_del.is_equal (assoc.item) then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_del.item.cnt = l_fc then
							l_pos := -1 + 5 -- goto ok
						end
				when 3 then
						l_del := l_del.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_return := True
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | ok:
						l_del.item.delete_association
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_del_ct (a_term: CE_POINTER [PD_TERMINAL]; a_fcp, a_xxx2: CE_POINTER [ANY])
		local
			l_str: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_fc: NATURAL_32
			l_del: CE_POINTER [PD_ASSOC]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_str.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fc := ((a_fcp.c_pointer.to_integer_32).to_integer_32).to_natural_32
					l_del := create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast (assoc.item.item.next)
				when 1 then -- loop condition:
					if l_del.is_equal (assoc.item) then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_del.item.cnt = l_fc then
							l_pos := -1 + 5 -- goto ok
						end
				when 3 then
						l_del := l_del.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_return := True
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | ok:
						l_str.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 237)
						l_l.item := 0;
						(create {P_LINKS_STATIC}).add_to_str (l_str, l_l, l_del.item.ct);
						(create {P_LINKS_STATIC}).add_to_str (l_str, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" -> ")));
						(create {P_LINKS_STATIC}).add_to_str (l_str, l_l, l_del.item.prog)
						a_term.item.msg_box ([((create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_str.item), create {CE_VOID_POINTER}.make_shared (default_pointer)])), (create {P_LINKS_STATIC}).dummyarray.item + 197, 129, (create {P_LINKS_STATIC}).dummyarray.item + 197, ce_string (": "), l_str.item, ce_string ("?"), create {CE_VOID_POINTER}.make_shared (default_pointer), a_fcp, 2, (create {P_LINKS_STATIC}).dummyarray.item + 166, really_del_ct_address, 1, (create {P_LINKS_STATIC}).dummyarray.item + 167, create {CE_VOID_POINTER}.make_shared (default_pointer), 2])
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_add_ct (a_term: CE_POINTER [PD_TERMINAL]; a_fcp, a_xxx2: CE_POINTER [ANY])
		local
			l_p: INTEGER_32
			l_fc: NATURAL_32
			l_new: CE_POINTER [PD_ASSOC]
			l_from: CE_POINTER [PD_ASSOC]
			l_label: CE_POINTER [NATURAL_8]
			l_ct: CE_POINTER [NATURAL_8]
			l_prog: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [PD_DIALOG]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fc := ((a_fcp.c_pointer.to_integer_32).to_integer_32).to_natural_32
					if not (l_fc.to_boolean) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_from := create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast (assoc.item.item.next)
				when 2 then -- loop condition:
						if l_from.is_equal (assoc.item) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if l_from.item.cnt = l_fc then
							l_pos := -1 + 8 -- goto ok
						end
				when 4 then
						l_from := l_from.item.next
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						l_return := True
				when 6 then -- if done
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						l_from := create {CE_CLASS_POINTER [PD_ASSOC]}.make_shared (default_pointer)
				when 8 then -- ok:
						l_d := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 259, (((create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 10 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32) + (create {PD_ASSOC}.make).structure_size.to_natural_32) + {NATURAL_32} 3_072)))
						memset (create {CE_VOID_POINTER}.make_cast (l_d), 0, (((create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 10 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32) + (create {PD_ASSOC}.make).structure_size.to_natural_32) + {NATURAL_32} 3_072).do_nothing
						l_new := create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast ((create {CE_CLASS_POINTER [PD_DIALOG_ITEM]}.make_shared (l_d.c_pointer + (create {PD_DIALOG}.make).offset_of ("items") + (create {PD_DIALOG_ITEM}.make).structure_size * (10))))
						l_label := create {CE_NATURAL_8_POINTER}.make_cast ((l_new + 1))
						l_new.item.label := l_label
						l_ct := l_label + 1_024
						l_new.item.ct := l_ct
						l_prog := l_ct + 1_024
						l_new.item.prog := l_prog
						if (not l_from.is_void) then
							strncpy (create {CE_INTEGER_8_POINTER}.make_cast (l_label), create {CE_INTEGER_8_POINTER}.make_cast (l_from.item.label), (1_023).to_natural_32).do_nothing
							strncpy (create {CE_INTEGER_8_POINTER}.make_cast (l_ct), create {CE_INTEGER_8_POINTER}.make_cast (l_from.item.ct), (1_023).to_natural_32).do_nothing
							strncpy (create {CE_INTEGER_8_POINTER}.make_cast (l_prog), create {CE_INTEGER_8_POINTER}.make_cast (l_from.item.prog), (1_023).to_natural_32).do_nothing
							l_new.item.block := l_from.item.block
							l_new.item.cons := l_from.item.cons
							l_new.item.xwin := l_from.item.xwin
							l_new.item.ask := l_from.item.ask
							l_new.item.system := l_from.item.system
							l_new.item.cnt := l_from.item.cnt
						else
							l_tmp___1 := 1
							l_new.item.cons := l_tmp___1
							l_tmp___0 := l_tmp___1
							l_new.item.xwin := l_tmp___0
							l_new.item.block := l_tmp___0
							l_new.item.ask := 1
							l_new.item.system := 1
						end
						l_d.item.title := (create {P_LINKS_STATIC}).dummyarray.item + 198
						l_d.item.fn := (create {PD_DIALOG_DATA_STATIC}).add_ct_fn_address
						l_d.item.refresh := ((create {PD_ASSOC_STATIC}).update_assoc_address)
						l_d.item.refresh_data := create {CE_VOID_POINTER}.make_cast (l_new)
						l_d.item.items[0].type := 2
						l_d.item.items[0].dlen := 1_024
						l_d.item.items[0].data := l_label
						l_d.item.items[0].fn := (create {P_BFU_STATIC}).check_nonempty_address
						l_d.item.items[1].type := 2
						l_d.item.items[1].dlen := 1_024
						l_d.item.items[1].data := l_ct
						l_d.item.items[1].fn := (create {P_BFU_STATIC}).check_nonempty_address
						l_d.item.items[2].type := 2
						l_d.item.items[2].dlen := 1_024
						l_d.item.items[2].data := l_prog
						l_d.item.items[2].fn := (create {P_BFU_STATIC}).check_nonempty_address
						l_p := 3
						l_d.item.items[l_p].type := 1
						l_d.item.items[l_p].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_new.c_pointer + (create {PD_ASSOC}.make).offset_of ("block"))))
						l_tmp___2 := l_p
						l_p := l_p + 1
						l_d.item.items[l_tmp___2].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
						l_d.item.items[l_p].type := 1
						l_d.item.items[l_p].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_new.c_pointer + (create {PD_ASSOC}.make).offset_of ("cons"))))
						l_tmp___3 := l_p
						l_p := l_p + 1
						l_d.item.items[l_tmp___3].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
						l_d.item.items[l_p].type := 1
						l_d.item.items[l_p].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_new.c_pointer + (create {PD_ASSOC}.make).offset_of ("xwin"))))
						l_tmp___4 := l_p
						l_p := l_p + 1
						l_d.item.items[l_tmp___4].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
						l_d.item.items[l_p].type := 1
						l_d.item.items[l_p].data := create {CE_NATURAL_8_POINTER}.make_cast ((create {CE_INTEGER_32_POINTER}.make_shared (l_new.c_pointer + (create {PD_ASSOC}.make).offset_of ("ask"))))
						l_tmp___5 := l_p
						l_p := l_p + 1
						l_d.item.items[l_tmp___5].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
						l_d.item.items[l_p].type := 4
						l_d.item.items[l_p].gid := 1
						l_d.item.items[l_p].fn := (create {PD_DIALOG_DATA_STATIC}).ok_dialog_address
						l_tmp___6 := l_p
						l_p := l_p + 1
						l_d.item.items[l_tmp___6].text := (create {P_LINKS_STATIC}).dummyarray.item + 14
						l_d.item.items[l_p].type := 4
						l_d.item.items[l_p].gid := 2
						l_d.item.items[l_p].text := (create {P_LINKS_STATIC}).dummyarray.item + 6
						l_tmp___7 := l_p
						l_p := l_p + 1
						l_d.item.items[l_tmp___7].fn := (create {PD_DIALOG_DATA_STATIC}).cancel_dialog_address
						l_tmp___8 := l_p
						l_p := l_p + 1
						l_d.item.items[l_tmp___8].type := 0
						a_term.item.do_dialog (l_d, ((create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_d), create {CE_VOID_POINTER}.make_shared (default_pointer)])))
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_list_assoc (a_term: CE_POINTER [PD_TERMINAL]; a_fn, a_xxx: CE_POINTER [ANY])
		local
			l_a: CE_POINTER [PD_ASSOC]
			l_mi: CE_ARRAY [CE_POINTER [PD_MENU_ITEM]]
			l_n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_MENU_ITEM]} l_mi.make (<<1>>)

			l_mi.item := create {CE_CLASS_POINTER [PD_MENU_ITEM]}.make_shared (default_pointer)
			l_n := 0
			l_a := create {CE_CLASS_POINTER [PD_ASSOC]}.make_cast (assoc.item.item.prev)
			from
			until
				not (not (l_return) and then (not l_a.is_equal (assoc.item)))
			loop
				if l_a.item.system = 1 then
					if (l_mi.item).is_void then
						l_mi.item := (create {P_BFU_STATIC}).new_menu (7)
						if (l_mi.item).is_void then
							l_return := True
						end
					end
					if not l_return then
						l_tmp := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 337, l_a.item.ct);
						(create {P_BFU_STATIC}).add_to_menu (l_mi, ((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 337, l_a.item.label)), l_tmp, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), create {CE_ROUTINE}.make_cast (a_fn), create {CE_VOID_POINTER}.make_shared (default_pointer + (l_a.item.cnt).to_integer_32), 0)
						l_n := l_n + 1
					end
				end
				if not l_return then
					l_a := l_a.item.prev
				end
			end
			if not l_return then
				if (l_mi.item).is_void then
					a_term.item.do_menu (mi_no_assoc.item, a_xxx)
				else
					a_term.item.do_menu (l_mi.item, a_xxx)
				end
			end
		end

	really_del_ext (a_fcp: CE_POINTER [ANY])
		local
			l_fc: NATURAL_32
			l_del: CE_POINTER [PD_EXTENSION]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fc := ((a_fcp.c_pointer.to_integer_32).to_integer_32).to_natural_32
					l_del := create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast (extensions.item.item.next)
				when 1 then -- loop condition:
					if l_del.is_equal (extensions.item) then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_del.item.cnt = l_fc then
							l_pos := -1 + 5 -- goto ok
						end
				when 3 then
						l_del := l_del.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_return := True
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | ok:
						l_del.item.delete_extension
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_del_ext (a_term: CE_POINTER [PD_TERMINAL]; a_fcp, a_xxx2: CE_POINTER [ANY])
		local
			l_str: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_fc: NATURAL_32
			l_del: CE_POINTER [PD_EXTENSION]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_str.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fc := ((a_fcp.c_pointer.to_integer_32).to_integer_32).to_natural_32
					l_del := create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast (extensions.item.item.next)
				when 1 then -- loop condition:
					if l_del.is_equal (extensions.item) then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_del.item.cnt = l_fc then
							l_pos := -1 + 5 -- goto ok
						end
				when 3 then
						l_del := l_del.item.next
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					l_return := True
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | ok:
						l_str.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 431)
						l_l.item := 0;
						(create {P_LINKS_STATIC}).add_to_str (l_str, l_l, l_del.item.ext);
						(create {P_LINKS_STATIC}).add_to_str (l_str, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (" -> ")));
						(create {P_LINKS_STATIC}).add_to_str (l_str, l_l, l_del.item.ct)
						a_term.item.msg_box ([((create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_str.item), create {CE_VOID_POINTER}.make_shared (default_pointer)])), (create {P_LINKS_STATIC}).dummyarray.item + 202, 129, (create {P_LINKS_STATIC}).dummyarray.item + 202, ce_string (" "), l_str.item, ce_string ("?"), create {CE_VOID_POINTER}.make_shared (default_pointer), a_fcp, 2, (create {P_LINKS_STATIC}).dummyarray.item + 166, really_del_ext_address, 1, (create {P_LINKS_STATIC}).dummyarray.item + 167, create {CE_VOID_POINTER}.make_shared (default_pointer), 2])
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_add_ext (a_term: CE_POINTER [PD_TERMINAL]; a_fcp, a_xxx2: CE_POINTER [ANY])
		local
			l_fc: NATURAL_32
			l_new: CE_POINTER [PD_EXTENSION]
			l_from: CE_POINTER [PD_EXTENSION]
			l_ext: CE_POINTER [NATURAL_8]
			l_ct: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [PD_DIALOG]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fc := ((a_fcp.c_pointer.to_integer_32).to_integer_32).to_natural_32
					if not (l_fc.to_boolean) then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_from := create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast (extensions.item.item.next)
				when 2 then -- loop condition:
						if l_from.is_equal (extensions.item) then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						if l_from.item.cnt = l_fc then
							l_pos := -1 + 8 -- goto ok
						end
				when 4 then
						l_from := l_from.item.next
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done
						l_return := True
				when 6 then -- if done
					if l_return then
						l_pos := -1 + 9 -- skip if block
					end
				when 7 then -- if:
						l_from := create {CE_CLASS_POINTER [PD_EXTENSION]}.make_shared (default_pointer)
				when 8 then -- ok:
						l_d := create {CE_CLASS_POINTER [PD_DIALOG]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 451, (((create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 5 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32) + (create {PD_EXTENSION}.make).structure_size.to_natural_32) + {NATURAL_32} 2_048)))
						memset (create {CE_VOID_POINTER}.make_cast (l_d), 0, (((create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 5 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32) + (create {PD_EXTENSION}.make).structure_size.to_natural_32) + {NATURAL_32} 2_048).do_nothing
						l_new := create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast ((create {CE_CLASS_POINTER [PD_DIALOG_ITEM]}.make_shared (l_d.c_pointer + (create {PD_DIALOG}.make).offset_of ("items") + (create {PD_DIALOG_ITEM}.make).structure_size * (5))))
						l_ext := create {CE_NATURAL_8_POINTER}.make_cast ((l_new + 1))
						l_new.item.ext := l_ext
						l_ct := l_ext + 1_024
						l_new.item.ct := l_ct
						if (not l_from.is_void) then
							strncpy (create {CE_INTEGER_8_POINTER}.make_cast (l_ext), create {CE_INTEGER_8_POINTER}.make_cast (l_from.item.ext), (1_023).to_natural_32).do_nothing
							strncpy (create {CE_INTEGER_8_POINTER}.make_cast (l_ct), create {CE_INTEGER_8_POINTER}.make_cast (l_from.item.ct), (1_023).to_natural_32).do_nothing
							l_new.item.cnt := l_from.item.cnt
						end
						l_d.item.title := (create {P_LINKS_STATIC}).dummyarray.item + 203
						l_d.item.fn := (create {PD_DIALOG_DATA_STATIC}).add_ext_fn_address
						l_d.item.refresh := ((create {PD_EXTENSION_STATIC}).update_ext_address)
						l_d.item.refresh_data := create {CE_VOID_POINTER}.make_cast (l_new)
						l_d.item.items[0].type := 2
						l_d.item.items[0].dlen := 1_024
						l_d.item.items[0].data := l_ext
						l_d.item.items[0].fn := (create {P_BFU_STATIC}).check_nonempty_address
						l_d.item.items[1].type := 2
						l_d.item.items[1].dlen := 1_024
						l_d.item.items[1].data := l_ct
						l_d.item.items[1].fn := (create {P_BFU_STATIC}).check_nonempty_address
						l_d.item.items[2].type := 4
						l_d.item.items[2].gid := 1
						l_d.item.items[2].fn := (create {PD_DIALOG_DATA_STATIC}).ok_dialog_address
						l_d.item.items[2].text := (create {P_LINKS_STATIC}).dummyarray.item + 14
						l_d.item.items[3].type := 4
						l_d.item.items[3].gid := 2
						l_d.item.items[3].text := (create {P_LINKS_STATIC}).dummyarray.item + 6
						l_d.item.items[3].fn := (create {PD_DIALOG_DATA_STATIC}).cancel_dialog_address
						l_d.item.items[4].type := 0
						a_term.item.do_dialog (l_d, ((create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_d), create {CE_VOID_POINTER}.make_shared (default_pointer)])))
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	menu_list_ext (a_term: CE_POINTER [PD_TERMINAL]; a_fn, a_xxx: CE_POINTER [ANY])
		local
			l_a: CE_POINTER [PD_EXTENSION]
			l_mi: CE_ARRAY [CE_POINTER [PD_MENU_ITEM]]
			l_n: INTEGER_32
			l_tmp: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_MENU_ITEM]} l_mi.make (<<1>>)

			l_mi.item := create {CE_CLASS_POINTER [PD_MENU_ITEM]}.make_shared (default_pointer)
			l_n := 0
			l_a := create {CE_CLASS_POINTER [PD_EXTENSION]}.make_cast (extensions.item.item.prev)
			from
			until
				not (not (l_return) and then (not l_a.is_equal (extensions.item)))
			loop
				if (l_mi.item).is_void then
					l_mi.item := (create {P_BFU_STATIC}).new_menu (7)
					if (l_mi.item).is_void then
						l_return := True
					end
				end
				if not l_return then
					l_tmp := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 497, l_a.item.ct);
					(create {P_BFU_STATIC}).add_to_menu (l_mi, ((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("types.c")), 497, l_a.item.ext)), l_tmp, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")), create {CE_ROUTINE}.make_cast (a_fn), create {CE_VOID_POINTER}.make_shared (default_pointer + (l_a.item.cnt).to_integer_32), 0)
					l_n := l_n + 1
					l_a := l_a.item.prev
				end
			end
			if not l_return then
				if (l_mi.item).is_void then
					a_term.item.do_menu (mi_no_ext.item, a_xxx)
				else
					a_term.item.do_menu (l_mi.item, a_xxx)
				end
			end
		end

feature {ANY} -- routine addresses

	really_del_ct_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent really_del_ct)
		end

	menu_del_ct_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent menu_del_ct)
		end

	menu_add_ct_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent menu_add_ct)
		end

	menu_list_assoc_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent menu_list_assoc)
		end

	really_del_ext_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent really_del_ext)
		end

	menu_del_ext_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent menu_del_ext)
		end

	menu_add_ext_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent menu_add_ext)
		end

	menu_list_ext_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent menu_list_ext)
		end

end
