class
	P_VIEW_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC
	S_STRING_STATIC
	S_BITS_ERRNO_STATIC
	S_FCNTL_STATIC
	S_UNISTD_STATIC
	S_STDIO_STATIC

feature {ANY} -- public routines

	format_text (a_text: CE_POINTER [NATURAL_8]; a_width, a_wrap: INTEGER_32): CE_POINTER [PD_LINE_INFO]
		require
			not a_text.is_void
		local
			l_text: CE_POINTER [NATURAL_8]
			l_ln: CE_POINTER [PD_LINE_INFO]
			l_lnn: INTEGER_32
			l_b: CE_POINTER [NATURAL_8]
			l_sk: INTEGER_32
			l_ps: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_text := a_text
					l_ln := create {CE_CLASS_POINTER [PD_LINE_INFO]}.make_shared (default_pointer + -1)
					l_lnn := 0
					l_b := l_text
					l_ps := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_text.item).to_boolean)) then
						l_pos := -1 + 12 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False
						if (l_text.item).to_integer_32 /= 10 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_sk := 1
				when 4 then -- put:
						if not ((l_lnn).bit_and (63)).to_boolean then
							if l_lnn.to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_LINE_INFO}.make).structure_size.to_natural_32 - {NATURAL_32} 64 then
								from
								until
									False
								loop
									(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 268]);
									(create {P_KBD_STATIC}).fatal_tty_exit
									exit (4)
								end
							end
							l_ln := create {CE_CLASS_POINTER [PD_LINE_INFO]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 269, create {CE_VOID_POINTER}.make_cast (l_ln), (l_lnn + 64).to_natural_32 * (create {PD_LINE_INFO}.make).structure_size.to_natural_32)))
						end
						(l_ln + l_lnn).item.st := l_b
						l_tmp___0 := l_lnn
						l_lnn := l_lnn + 1;
						(l_ln + l_tmp___0).item.en := l_text
						l_text := l_text + l_sk
						l_b := l_text
						l_continue := True
				when 5 then -- if done
						if not (l_return or l_break or l_continue) then
							if not a_wrap.to_boolean then
								l_text := l_text + 1
								l_continue := True
							elseif l_text.distance (l_b) < a_width then
								l_text := l_text + 1
								l_continue := True
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 11 -- skip if block
						end
				when 6 then -- if:
						l_s := l_text
				when 7 then -- loop condition:
						if not (not (l_return) and then ((l_s.c_pointer.to_integer_32).to_natural_32 >= (l_b.c_pointer.to_integer_32).to_natural_32)) then
							l_pos := -1 + 10 -- skip loop
						end
				when 8 then -- loop body:
						if (l_s.item).to_integer_32 = 32 then
							l_text := l_s
							if a_wrap = 2 then
								l_s.item := (('%N').code).to_natural_8
								l_s := l_s + 1
								from
								until
									not (not (l_break) and then ((l_s.item).to_boolean))
								loop
									l_break := False
									if (l_s.item).to_integer_32 = 10 then
										if (l_s[1]).to_integer_32 /= 10 then
											l_s.item := ((' ').code).to_natural_8
										end
										l_break := True
									end
									if not (l_break) then
										l_s := l_s + 1
									end
								end
								l_break := False
							end
							l_sk := 1
							l_pos := -1 + 4 -- goto put
						end
				when 9 then
						l_s := l_s - 1
						l_pos := -1 + 7 -- back to loop condition
				when 10 then -- loop done
						l_sk := 0
						l_pos := -1 + 4 -- goto put
				when 11 then
						l_pos := -1 + 1 -- back to loop condition
				when 12 then -- loop done
					l_continue := False
					if l_ps < 2 then
						l_ps := l_ps + 1
						l_sk := 0
						l_pos := -1 + 4 -- goto put
					end
				when 13 then
					l_tmp___1 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
					(l_ln + (l_lnn - 1)).item.en := l_tmp___1;
					(l_ln + (l_lnn - 1)).item.st := l_tmp___1
					Result := l_ln
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	draw_link (a_t: CE_POINTER [PD_TERMINAL]; a_scr: CE_POINTER [PD_F_DATA_C]; a_l: INTEGER_32)
		require
			not a_scr.is_void
		local
			l_link___0: CE_POINTER [PD_LINK]
			l_xp: INTEGER_32
			l_yp: INTEGER_32
			l_xw: INTEGER_32
			l_yw: INTEGER_32
			l_vx: INTEGER_32
			l_vy: INTEGER_32
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_f: INTEGER_32
			l_i: INTEGER_32
			l_q: INTEGER_32
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_fs___0: CE_POINTER [PD_FORM_STATE]
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_co: NATURAL_32
			l_xx: INTEGER_32
			l_yy: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_link___0 := (a_scr.item.f_data).item.links + a_l
					l_xp := a_scr.item.xp
					l_yp := a_scr.item.yp
					l_xw := a_scr.item.xw
					l_yw := a_scr.item.yw
					l_vs := a_scr.item.vs
					l_f := 0
					l_vx := l_vs.item.view_posx
					l_vy := l_vs.item.view_pos
					if (not (a_scr.item.link_bg).is_void) then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c"));
							(create {P_LINKS_STATIC}).errline.item := 340;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("link background not empty"))])
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 341, create {CE_VOID_POINTER}.make_cast (a_scr.item.link_bg))
					end
					if a_l = -1 then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 35 -- skip if block
					end
				when 1 then -- if:
						inspect l_link___0.item.type -- switch 1 head
						when 0 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 2
						when 1 then l_pos := -1 + 2
						when 3 then l_pos := -1 + 2
						when 4 then l_pos := -1 + 2
						when 5 then l_pos := -1 + 2
						else l_pos := -1 + 34
						end
				when 2 then -- switch 1, case 0 | switch 1, case 2 | switch 1, case 1 | switch 1, case 3 | switch 1, case 4 | switch 1, case 5
						l_q := 0
						if l_link___0.item.type = 4 then
							l_fs := (a_scr.item.find_form_state (l_link___0.item.form))
							if (not l_fs.is_void) then
								l_q := l_fs.item.state - l_fs.item.vpos
							end
						elseif l_link___0.item.type = 5 then
							l_fs___0 := (a_scr.item.find_form_state (l_link___0.item.form))
							if (not l_fs___0.is_void) then
								l_q := (l_link___0.item.form).item.area_cursor (l_fs___0)
							end
						end
						if (l_link___0.item.n).to_natural_32 > {NATURAL_32} 2_147_483_647 // (create {PD_LINK_BG}.make).structure_size.to_natural_32 then
							from
							until
								False
							loop
								(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 363]);
								(create {P_KBD_STATIC}).fatal_tty_exit
								exit (4)
							end
						end
						a_scr.item.link_bg := create {CE_CLASS_POINTER [PD_LINK_BG]}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 364, (l_link___0.item.n).to_natural_32 * (create {PD_LINK_BG}.make).structure_size.to_natural_32)))
						a_scr.item.link_bg_n := l_link___0.item.n
						l_i := 0
				when 3 then -- loop condition:
						if not (l_i < l_link___0.item.n) then
							l_pos := -1 + 33 -- skip loop
						end
				when 4 then -- loop body:
						l_x := ((l_link___0.item.pos + l_i).item.x + l_xp) - l_vx
						l_y := ((l_link___0.item.pos + l_i).item.y + l_yp) - l_vy
						if not (l_x >= l_xp) then
							l_pos := -1 + 31 -- skip if block
						end
				when 5 then -- if:
						if not (l_y >= l_yp) then
							l_pos := -1 + 29 -- skip if block
						end
				when 6 then -- if:
						if not (l_x < l_xp + l_xw) then
							l_pos := -1 + 27 -- skip if block
						end
				when 7 then -- if:
						if not (l_y < l_yp + l_yw) then
							l_pos := -1 + 25 -- skip if block
						end
				when 8 then -- if:
						l_co := a_t.item.get_char (l_x, l_y)
						if (not (a_scr.item.link_bg).is_void) then
							(a_scr.item.link_bg + l_i).item.x := l_x;
							(a_scr.item.link_bg + l_i).item.y := l_y;
							(a_scr.item.link_bg + l_i).item.c := l_co
						end
						if l_f.to_boolean then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 22 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 11 then -- else:
						if l_link___0.item.type /= 2 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						if l_i = 1 then
							l_pos := -1 + 22 -- goto _L
						else
							l_pos := -1 + 14 -- goto _L___2
						end
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 14 then -- else: | _L___2:
						if l_link___0.item.type /= 1 then
							l_pos := -1 + 17 -- skip if block
						end
				when 15 then -- if:
						if l_i = 2 then
							l_pos := -1 + 22 -- goto _L
						else
							l_pos := -1 + 17 -- goto _L___1
						end
				when 16 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 17 then -- else: | _L___1:
						if l_link___0.item.type /= 4 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 20 then -- else:
						if l_link___0.item.type /= 5 then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if: | _L___0:
						if l_i /= l_q then
							l_pos := -1 + 23 -- skip if block
						end
				when 22 then -- if: | _L:
						l_xx := l_x
						l_yy := l_y
						if l_link___0.item.type /= 4 then
							if l_link___0.item.type /= 5 then
								if ((((l_co).bit_shift_right (8))).bit_and ({NATURAL_32} 56)) /= ((l_link___0.item.sel_color).bit_and ({NATURAL_32} 56)) then
									l_xx := (l_xp + l_xw) - 1
									l_yy := (l_yp + l_yw) - 1
								end
							end
						end
						a_t.item.set_cursor (l_x, l_y, l_xx, l_yy);
						(a_t.item.get_root_window).item.set_window_ptr (l_x, l_y)
						l_f := 1
				when 23 then -- if done | if done | if done | if done | if done
						a_t.item.set_color (l_x, l_y, (l_link___0.item.sel_color).bit_shift_left (8))
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 26
				when 25 then -- else:
						l_tmp___4 := {NATURAL_32} 4_294_967_295;
						(a_scr.item.link_bg + l_i).item.c := l_tmp___4
						l_tmp___3 := l_tmp___4.to_integer_32;
						(a_scr.item.link_bg + l_i).item.y := l_tmp___3;
						(a_scr.item.link_bg + l_i).item.x := l_tmp___3
				when 26 then -- if done | if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else:
						l_tmp___4 := {NATURAL_32} 4_294_967_295;
						(a_scr.item.link_bg + l_i).item.c := l_tmp___4
						l_tmp___3 := l_tmp___4.to_integer_32;
						(a_scr.item.link_bg + l_i).item.y := l_tmp___3;
						(a_scr.item.link_bg + l_i).item.x := l_tmp___3
				when 28 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						l_tmp___4 := {NATURAL_32} 4_294_967_295;
						(a_scr.item.link_bg + l_i).item.c := l_tmp___4
						l_tmp___3 := l_tmp___4.to_integer_32;
						(a_scr.item.link_bg + l_i).item.y := l_tmp___3;
						(a_scr.item.link_bg + l_i).item.x := l_tmp___3
				when 30 then -- if done | if block done, skip else block:
						l_pos := -1 + 32
				when 31 then -- else:
						l_tmp___4 := {NATURAL_32} 4_294_967_295;
						(a_scr.item.link_bg + l_i).item.c := l_tmp___4
						l_tmp___3 := l_tmp___4.to_integer_32;
						(a_scr.item.link_bg + l_i).item.y := l_tmp___3;
						(a_scr.item.link_bg + l_i).item.x := l_tmp___3
				when 32 then -- if done
						l_i := l_i + 1
						l_pos := -1 + 3 -- back to loop condition
				when 33 then -- loop done
						l_pos := -1 + 35 -- switch 1; break
				when 34 then -- switch 1, default:
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c"));
							(create {P_LINKS_STATIC}).errline.item := 388;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("bad link type"))])
						end
				when 35 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	clear_link (a_t: CE_POINTER [PD_TERMINAL]; a_scr: CE_POINTER [PD_F_DATA_C])
		require
			not a_scr.is_void
		local
			l_i: INTEGER_32
		do
			if (not (a_scr.item.link_bg).is_void) then
				l_i := a_scr.item.link_bg_n - 1
				from
				until
					not (l_i >= 0)
				loop
					a_t.item.set_char ((a_scr.item.link_bg + l_i).item.x, (a_scr.item.link_bg + l_i).item.y, (a_scr.item.link_bg + l_i).item.c)
					l_i := l_i - 1
				end
				a_scr.item.free_link
			end
		end

	get_range (a_f: CE_POINTER [PD_F_DATA]; a_y, a_yw, a_l: INTEGER_32; a_s1, a_s2: CE_POINTER [CE_POINTER [PD_SEARCH]]): INTEGER_32
		require
			not a_s1.is_void
			not a_s2.is_void
		local
			l_i: INTEGER_32
			l_tmp: CE_POINTER [PD_SEARCH]
			l_tmp___0: CE_POINTER [PD_SEARCH]
			l_return, l_break: BOOLEAN
		do
			l_tmp := create {CE_CLASS_POINTER [PD_SEARCH]}.make_shared (default_pointer)
			a_s2.item := l_tmp
			a_s1.item := l_tmp
			if a_y < 0 then
				l_i := 0
			else
				l_i := a_y
			end
			from
			until
				(l_break)
			loop
				l_break := False
				if l_i < a_y + a_yw then
					if not (l_i < a_f.item.y) then
						l_break := True
					end
				else
					l_break := True
				end
				if not (l_break) then
					if (not (a_f.item.slines1[l_i]).is_void) then
						if (a_s1.item).is_void then
							a_s1.item := a_f.item.slines1[l_i]
						elseif ((a_f.item.slines1[l_i]).c_pointer.to_integer_32).to_natural_32 < ((a_s1.item).c_pointer.to_integer_32).to_natural_32 then
							a_s1.item := a_f.item.slines1[l_i]
						end
					end
					if (not (a_f.item.slines2[l_i]).is_void) then
						if (a_s2.item).is_void then
							a_s2.item := a_f.item.slines2[l_i]
						elseif ((a_f.item.slines2[l_i]).c_pointer.to_integer_32).to_natural_32 > ((a_s2.item).c_pointer.to_integer_32).to_natural_32 then
							a_s2.item := a_f.item.slines2[l_i]
						end
					end
					l_i := l_i + 1
				end
			end
			l_break := False
			if (a_s1.item).is_void then
				Result := (-1)
				l_return := True
			elseif (a_s2.item).is_void then
				Result := (-1)
				l_return := True
			end
			if not l_return then
				a_s1.item := a_s1.item - a_l
				if ((a_s1.item).c_pointer.to_integer_32).to_natural_32 < ((a_f.item.search).c_pointer.to_integer_32).to_natural_32 then
					a_s1.item := a_f.item.search
				end
				if ((a_s2.item + a_l).c_pointer.to_integer_32).to_natural_32 > ((a_f.item.search + a_f.item.nsearch).c_pointer.to_integer_32).to_natural_32 then
					a_s2.item := (a_f.item.search + a_f.item.nsearch) - a_l
				end
				if ((a_s1.item).c_pointer.to_integer_32).to_natural_32 > ((a_s2.item).c_pointer.to_integer_32).to_natural_32 then
					l_tmp___0 := create {CE_CLASS_POINTER [PD_SEARCH]}.make_shared (default_pointer)
					a_s2.item := l_tmp___0
					a_s1.item := l_tmp___0
				end
				if (a_s1.item).is_void then
					Result := (-1)
					l_return := True
				elseif (a_s2.item).is_void then
					Result := (-1)
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	draw_searched (a_t: CE_POINTER [PD_TERMINAL]; a_scr: CE_POINTER [PD_F_DATA_C])
		require
			not a_scr.is_void
		local
			l_xp: INTEGER_32
			l_yp: INTEGER_32
			l_vx: INTEGER_32
			l_vy: INTEGER_32
			l_pt: CE_ARRAY [CE_POINTER [PD_POINT]]
			l_len: CE_ARRAY [INTEGER_32]
			l_i: INTEGER_32
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_co: NATURAL_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [PD_POINT]} l_pt.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_len.make (<<1>>)

			l_xp := a_scr.item.xp
			l_yp := a_scr.item.yp
			l_vx := (a_scr.item.vs).item.view_posx
			l_vy := (a_scr.item.vs).item.view_pos
			if (a_scr.item.search_word).is_void then
				l_return := True
			elseif ((a_scr.item.search_word).item).is_void then
				l_return := True
			elseif not ((a_scr.item.search_word).item[0]).to_boolean then
				l_return := True
			end
			if not l_return then
				a_scr.item.get_searched (l_pt, l_len)
				l_i := 0
				from
				until
					not (l_i < l_len.item)
				loop
					l_x := ((l_pt.item + l_i).item.x + l_xp) - l_vx
					l_y := ((l_pt.item + l_i).item.y + l_yp) - l_vy
					l_co := a_t.item.get_char (l_x, l_y)
					l_co := (((((l_co).bit_shift_right (3))).bit_and ({NATURAL_32} 1_792))).bit_or (((((l_co).bit_shift_left (3))).bit_and ({NATURAL_32} 14_336)))
					a_t.item.set_color (l_x, l_y, l_co)
					l_i := l_i + 1
				end
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 518, create {CE_VOID_POINTER}.make_cast (l_pt.item))
			end
		end

	draw_current_link (a_t: CE_POINTER [PD_TERMINAL]; a_scr: CE_POINTER [PD_F_DATA_C])
		require
			not a_scr.is_void
		do
			draw_link (a_t, a_scr, (a_scr.item.vs).item.current_link)
			draw_searched (a_t, a_scr)
		end

	draw_form_entry (a_t: CE_POINTER [PD_TERMINAL]; a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK])
		require
			not a_f.is_void
			not a_l.is_void
		local
			l_xp: INTEGER_32
			l_yp: INTEGER_32
			l_xw: INTEGER_32
			l_yw: INTEGER_32
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_vx: INTEGER_32
			l_vy: INTEGER_32
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_form___0: CE_POINTER [PD_FORM_CONTROL]
			l_i: INTEGER_32
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_ln: CE_POINTER [PD_LINE_INFO]
			l_lnx: CE_POINTER [PD_LINE_INFO]
			l_sl: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xp := a_f.item.xp
					l_yp := a_f.item.yp
					l_xw := a_f.item.xw
					l_yw := a_f.item.yw
					l_vs := a_f.item.vs
					l_vx := l_vs.item.view_posx
					l_vy := l_vs.item.view_pos
					l_form___0 := a_l.item.form
					if l_form___0.is_void then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c"));
							(create {P_LINKS_STATIC}).errline.item := 631;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("link %%d has no form")), a_l.distance (((a_f.item.f_data).item.links))])
						end
						l_return := True
					end
					if not l_return then
						l_fs := a_f.item.find_form_state (l_form___0)
						if l_fs.is_void then
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 11 -- skip if block
					end
				when 1 then -- if:
						inspect l_form___0.item.type -- switch 1 head
						when 1 then l_pos := -1 + 2
						when 2 then l_pos := -1 + 2
						when 3 then l_pos := -1 + 2
						when 4 then l_pos := -1 + 4
						when 5 then l_pos := -1 + 7
						when 6 then l_pos := -1 + 7
						when 7 then l_pos := -1 + 9
						when 8 then l_pos := -1 + 10
						when 9 then l_pos := -1 + 10
						when 10 then l_pos := -1 + 10
						when 11 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 2 then -- switch 1, case 1 | switch 1, case 2 | switch 1, case 3
						if l_fs.item.state >= l_fs.item.vpos + l_form___0.item.size then
							l_fs.item.vpos := (l_fs.item.state - l_form___0.item.size) + 1
						end
						if l_fs.item.state < l_fs.item.vpos then
							l_fs.item.vpos := l_fs.item.state
						end
						if not (a_l.item.n).to_boolean then
							l_pos := -1 + 11 -- switch 1; break
						end
				when 3 then
						l_x := ((a_l.item.pos + 0).item.x + l_xp) - l_vx
						l_y := ((a_l.item.pos + 0).item.y + l_yp) - l_vy
						l_i := 0
						from
						until
							not (l_i < l_form___0.item.size)
						loop
							if l_x >= l_xp then
								if l_y >= l_yp then
									if l_x < l_xp + l_xw then
										if l_y < l_yp + l_yw then
											if (not (l_fs.item.value).is_void) then
												if l_i >= -l_fs.item.vpos then
													if l_i < (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fs.item.value))).to_integer_32 - l_fs.item.vpos then
														if l_form___0.item.type /= 2 then
															l_tmp := (l_fs.item.value[(l_i + l_fs.item.vpos)]).to_integer_32
														else
															l_tmp := ('*').code
														end
														a_t.item.set_only_char (l_x, l_y, l_tmp.to_natural_32)
													else
														a_t.item.set_only_char (l_x, l_y, (('_').code).to_natural_32)
													end
												else
													a_t.item.set_only_char (l_x, l_y, (('_').code).to_natural_32)
												end
											else
												a_t.item.set_only_char (l_x, l_y, (('_').code).to_natural_32)
											end
										end
									end
								end
							end
							l_i := l_i + 1
							l_x := l_x + 1
						end
						l_pos := -1 + 11 -- switch 1; break
				when 4 then -- switch 1, case 4
						if not (a_l.item.n).to_boolean then
							l_pos := -1 + 11 -- switch 1; break
						end
				when 5 then
						l_x := ((a_l.item.pos + 0).item.x + l_xp) - l_vx
						l_y := ((a_l.item.pos + 0).item.y + l_yp) - l_vy
						l_form___0.item.area_cursor (l_fs).do_nothing
						l_lnx := format_text (l_fs.item.value, l_form___0.item.cols, l_form___0.item.wrap)
						if l_lnx.is_void then
							l_pos := -1 + 11 -- switch 1; break
						end
				when 6 then
						l_ln := l_lnx
						l_sl := l_fs.item.vypos
						from
						until
							(l_break)
						loop
							l_break := False
							if (not (l_ln.item.st).is_void) then
								if not l_sl.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_break) then
								l_sl := l_sl - 1
								l_ln := l_ln + 1
							end
						end
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if (not (l_ln.item.st).is_void) then
								if not (l_y < (((a_l.item.pos + 0).item.y + l_yp) - l_vy) + l_form___0.item.rows) then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_i := 0
								from
								until
									not (l_i < l_form___0.item.cols)
								loop
									if l_x + l_i >= l_xp then
										if l_y >= l_yp then
											if l_x + l_i < l_xp + l_xw then
												if l_y < l_yp + l_yw then
													if (not (l_fs.item.value).is_void) then
														if l_i >= -l_fs.item.vpos then
															if l_i + l_fs.item.vpos < (l_ln.item.en).distance ((l_ln.item.st)) then
																a_t.item.set_only_char (l_x + l_i, l_y, (l_ln.item.st[(l_i + l_fs.item.vpos)]).to_natural_32)
															else
																a_t.item.set_only_char (l_x + l_i, l_y, (('_').code).to_natural_32)
															end
														else
															a_t.item.set_only_char (l_x + l_i, l_y, (('_').code).to_natural_32)
														end
													else
														a_t.item.set_only_char (l_x + l_i, l_y, (('_').code).to_natural_32)
													end
												end
											end
										end
									end
									l_i := l_i + 1
								end
								l_ln := l_ln + 1
								l_y := l_y + 1
							end
						end
						l_break := False
						from
						until
							not (not (l_return) and then (l_y < (((a_l.item.pos + 0).item.y + l_yp) - l_vy) + l_form___0.item.rows))
						loop
							l_i := 0
							from
							until
								not (l_i < l_form___0.item.cols)
							loop
								if l_x + l_i >= l_xp then
									if l_y >= l_yp then
										if l_x + l_i < l_xp + l_xw then
											if l_y < l_yp + l_yw then
												a_t.item.set_only_char (l_x + l_i, l_y, (('_').code).to_natural_32)
											end
										end
									end
								end
								l_i := l_i + 1
							end
							l_y := l_y + 1
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 675, create {CE_VOID_POINTER}.make_cast (l_lnx))
						l_pos := -1 + 11 -- switch 1; break
				when 7 then -- switch 1, case 5 | switch 1, case 6
						if a_l.item.n < 2 then
							l_pos := -1 + 11 -- switch 1; break
						end
				when 8 then
						l_x := ((a_l.item.pos + 1).item.x + l_xp) - l_vx
						l_y := ((a_l.item.pos + 1).item.y + l_yp) - l_vy
						if l_x >= l_xp then
							if l_y >= l_yp then
								if l_x < l_xp + l_xw then
									if l_y < l_yp + l_yw then
										if (l_fs.item.state).to_boolean then
											l_tmp___1 := ('X').code
										else
											l_tmp___1 := (' ').code
										end
										a_t.item.set_only_char (l_x, l_y, l_tmp___1.to_natural_32)
									end
								end
							end
						end
						l_pos := -1 + 11 -- switch 1; break
				when 9 then -- switch 1, case 7
						l_form___0.item.fixup_select_state (l_fs)
						if l_fs.item.state < l_form___0.item.nvalues then
							l_s := l_form___0.item.labels[l_fs.item.state]
						else
							l_s := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
						end
						if (not l_s.is_void) then
							l_sl := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_s))).to_integer_32
						else
							l_sl := 0
						end
						l_i := 0
						from
						until
							not (l_i < a_l.item.n)
						loop
							l_x := ((a_l.item.pos + l_i).item.x + l_xp) - l_vx
							l_y := ((a_l.item.pos + l_i).item.y + l_yp) - l_vy
							if l_x >= l_xp then
								if l_y >= l_yp then
									if l_x < l_xp + l_xw then
										if l_y < l_yp + l_yw then
											if l_i < l_sl then
												l_tmp___3 := (l_s[l_i]).to_integer_32
											else
												l_tmp___3 := ('_').code
											end
											a_t.item.set_only_char (l_x, l_y, l_tmp___3.to_natural_32)
										end
									end
								end
							end
							l_i := l_i + 1
						end
						l_pos := -1 + 11 -- switch 1; break
				when 10 then -- switch 1, case 8 | switch 1, case 9 | switch 1, case 10 | switch 1, case 11
						l_pos := -1 + 11 -- switch 1; break
				when 11 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	draw_forms (a_t: CE_POINTER [PD_TERMINAL]; a_f: CE_POINTER [PD_F_DATA_C])
		require
			not a_f.is_void
		local
			l_l1: CE_POINTER [PD_LINK]
			l_l2: CE_POINTER [PD_LINK]
			l_tmp___1: CE_POINTER [PD_LINK]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_l1 := (a_f.item.get_first_link)
					l_l2 := (a_f.item.get_last_link)
					if (not l_l1.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if (not l_l2.is_void) then
							l_pos := -1 + 10 -- skip if block
						end
				when 4 then -- if: | _L___0:
						if l_l1.is_void then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_l2.is_void then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c"));
							(create {P_LINKS_STATIC}).errline.item := 709;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("get_first_link == %%p, get_last_link == %%p")), l_l1, l_l2])
						end
				when 9 then -- if done
						l_return := True
				when 10 then -- if done
					if not l_return then
						from
						until
							(l_break)
						loop
							l_break := False
							if l_l1.item.type /= 0 then
								draw_form_entry (a_t, a_f, l_l1)
							end
							l_tmp___1 := l_l1
							l_l1 := l_l1 + 1
							if not ((l_tmp___1.c_pointer.to_integer_32).to_natural_32 < (l_l2.c_pointer.to_integer_32).to_natural_32) then
								l_break := True
							end
						end
						l_break := False
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	draw_frame_lines (a_t: CE_POINTER [PD_TERMINAL]; a_fsd: CE_POINTER [PD_FRAMESET_DESC]; a_xp, a_yp: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_x: INTEGER_32
			l_y: INTEGER_32
			l_wwy: INTEGER_32
			l_wwx: INTEGER_32
			l_wwy___0: INTEGER_32
			l_wwx___0: INTEGER_32
			l_return: BOOLEAN
		do
			if a_fsd.is_void then
				l_return := True
			end
			if not l_return then
				l_y := a_yp - 1
				l_j := 0
				from
				until
					not (not (l_return) and then (l_j < a_fsd.item.y))
				loop
					l_wwy := a_fsd.item.f[l_j * a_fsd.item.x].yw
					l_x := a_xp - 1
					l_i := 0
					from
					until
						not (l_i < a_fsd.item.x)
					loop
						l_wwx := a_fsd.item.f[l_i].xw
						if l_i.to_boolean then
							a_t.item.fill_area (l_x, l_y + 1, 1, l_wwy, {NATURAL_32} 32_947)
							if l_j = a_fsd.item.y - 1 then
								a_t.item.set_xchar (l_x, (l_y + l_wwy) + 1, {NATURAL_32} 3)
							end
						elseif l_j.to_boolean then
							a_t.item.set_xchar (l_x, l_y, {NATURAL_32} 0)
						end
						if l_j.to_boolean then
							a_t.item.fill_area (l_x + 1, l_y, l_wwx, 1, {NATURAL_32} 32_964)
							if l_i = a_fsd.item.x - 1 then
								a_t.item.set_xchar ((l_x + l_wwx) + 1, l_y, {NATURAL_32} 1)
							end
						elseif l_i.to_boolean then
							a_t.item.set_xchar (l_x, l_y, {NATURAL_32} 2)
						end
						if l_i.to_boolean then
							if l_j.to_boolean then
								a_t.item.set_char (l_x, l_y, {NATURAL_32} 32_965)
							end
						end
						l_x := l_x + (l_wwx + 1)
						l_i := l_i + 1
					end
					l_y := l_y + (l_wwy + 1)
					l_j := l_j + 1
				end
				l_y := a_yp - 1
				l_j := 0
				from
				until
					not (not (l_return) and then (l_j < a_fsd.item.y))
				loop
					l_wwy___0 := a_fsd.item.f[l_j * a_fsd.item.x].yw
					l_x := a_xp - 1
					l_i := 0
					from
					until
						not (l_i < a_fsd.item.x)
					loop
						l_wwx___0 := a_fsd.item.f[l_i].xw
						if (not (a_fsd.item.f[l_j * a_fsd.item.x + l_i].subframe).is_void) then
							draw_frame_lines (a_t, a_fsd.item.f[l_j * a_fsd.item.x + l_i].subframe, l_x + 1, l_y + 1)
						end
						l_x := l_x + (l_wwx___0 + 1)
						l_i := l_i + 1
					end
					l_y := l_y + (l_wwy___0 + 1)
					l_j := l_j + 1
				end
			end
		end

	draw_doc (a_t: CE_POINTER [PD_TERMINAL]; a_scr: CE_POINTER [PD_F_DATA_C]; a_active: INTEGER_32)
		require
			not a_scr.is_void
		local
			l_y: INTEGER_32
			l_xp: INTEGER_32
			l_yp: INTEGER_32
			l_xw: INTEGER_32
			l_yw: INTEGER_32
			l_vs: CE_POINTER [PD_VIEW_STATE]
			l_vx: INTEGER_32
			l_vy: INTEGER_32
			l_ce: CE_ARRAY [CE_POINTER [PD_CACHE_ENTRY]]
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_ol: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
			l_st: INTEGER_32
			l_tmp___6: INTEGER_32
			l_en: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_POINTER [PD_VIEW_STATE]} l_vs.make
			create {CE_POINTER_ARRAY [PD_CACHE_ENTRY]} l_ce.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xp := a_scr.item.xp
					l_yp := a_scr.item.yp
					l_xw := a_scr.item.xw
					l_yw := a_scr.item.yw
					if a_active.to_boolean then
						a_t.item.set_cursor ((l_xp + l_xw) - 1, (l_yp + l_yw) - 1, (l_xp + l_xw) - 1, (l_yp + l_yw) - 1);
						(a_t.item.get_root_window).item.set_window_ptr (l_xp, l_yp)
					end
					if (a_scr.item.vs).is_void then
						if ((a_scr.item.f_data).item.y).to_boolean then
							l_tmp___0 := (a_scr.item.f_data).item.bg
						else
							l_tmp___0 := (' ').code
						end
						a_t.item.fill_area (l_xp, l_yp, l_xw, l_yw, l_tmp___0.to_natural_32)
						l_return := True
					end
					if not l_return and then (((a_scr.item.f_data).item.frame).to_boolean) then
						if ((a_scr.item.f_data).item.y).to_boolean then
							l_tmp___1 := (a_scr.item.f_data).item.bg
						else
							l_tmp___1 := (' ').code
						end
						a_t.item.fill_area (l_xp, l_yp, l_xw, l_yw, l_tmp___1.to_natural_32)
						draw_frame_lines (a_t, (a_scr.item.f_data).item.frame_desc, l_xp, l_yp)
						if (not (a_scr.item.vs).is_void) then
							if (a_scr.item.vs).item.current_link = -1 then
								(a_scr.item.vs).item.current_link := 0;
								(a_scr.item.vs).item.orig_link := (a_scr.item.vs).item.current_link
							end
						end
						l_return := True
					end
					if l_return then
						l_pos := -1 + 27 -- skip if block
					end
				when 1 then -- if:
						a_scr.item.check_vs
						l_vs := a_scr.item.vs
						if (not (l_vs.item.goto_position).is_void) then
							if not ((create {P_CACHE_STATIC}).get_cache_entry (l_vs.item.url, l_ce)).to_boolean then
								l_vy := (a_scr.item.f_data).item.find_tag (l_vs.item.goto_position)
								if l_vy /= -1 then
									if (not (l_vs.item.goto_position_end).is_void) then
										(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 798, create {CE_VOID_POINTER}.make_cast (l_vs.item.goto_position_end))
									end
									if (l_ce.item.item.incomplete).to_boolean then
										l_vs.item.goto_position_end := l_vs.item.goto_position
									else
										l_vs.item.goto_position_end := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
										(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 803, create {CE_VOID_POINTER}.make_cast (l_vs.item.goto_position))
									end
									l_vs.item.goto_position := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
									l_pos := -1 + 7 -- goto goto_vy
								end
							end
						end
				when 2 then
						if (l_vs.item.goto_position_end).is_void then
							l_pos := -1 + 8 -- skip if block
						end
				when 3 then -- if:
						if ((create {P_CACHE_STATIC}).get_cache_entry (l_vs.item.url, l_ce)).to_boolean then
							l_pos := -1 + 8 -- skip if block
						end
				when 4 then -- if:
						if (l_ce.item.item.incomplete).to_boolean then
							l_pos := -1 + 8 -- skip if block
						end
				when 5 then -- if:
						l_vy := (a_scr.item.f_data).item.find_tag (l_vs.item.goto_position_end)
						if l_vy = -1 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 809, create {CE_VOID_POINTER}.make_cast (l_vs.item.goto_position_end))
						l_vs.item.goto_position_end := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
				when 7 then -- goto_vy:
						if l_vy > (a_scr.item.f_data).item.y then
							l_vy := (a_scr.item.f_data).item.y - 1
						end
						if l_vy < 0 then
							l_vy := 0
						end
						l_vs.item.view_pos := l_vy
						l_vs.item.view_posx := 0
						l_vs.item.orig_view_pos := l_vs.item.view_pos
						l_vs.item.orig_view_posx := l_vs.item.view_posx
						a_scr.item.set_link
				when 8 then -- if done | if done | if done | if done
						if l_vs.item.view_pos = l_vs.item.orig_view_pos then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						l_pos := -1 + 15 -- goto _L
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 11 then -- else:
						if l_vs.item.view_posx = l_vs.item.orig_view_posx then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						if l_vs.item.current_link = l_vs.item.orig_link then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L:
						l_vs.item.view_pos := l_vs.item.orig_view_pos
						l_vs.item.view_posx := l_vs.item.orig_view_posx
						l_ol := l_vs.item.orig_link
						if l_ol < (a_scr.item.f_data).item.nlinks then
							l_vs.item.current_link := l_ol
						end
						a_scr.item.set_link
						a_scr.item.check_vs
						l_vs.item.orig_link := l_ol
				when 16 then -- if done | if done
						l_vx := l_vs.item.view_posx
						l_vy := l_vs.item.view_pos
						if a_scr.item.xl /= l_vx then
							l_pos := -1 + 27 -- skip if block
						end
				when 17 then -- if:
						if a_scr.item.yl /= l_vy then
							l_pos := -1 + 27 -- skip if block
						end
				when 18 then -- if:
						if a_scr.item.xl = -1 then
							l_pos := -1 + 27 -- skip if block
						end
				when 19 then -- if:
						if (not (a_scr.item.search_word).is_void) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						l_pos := -1 + 26 -- goto _L___0
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 22 then -- else:
						if (not ((a_scr.item.search_word).item).is_void) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_pos := -1 + 26 -- goto _L___0
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 27
				when 25 then -- else:
						if ((a_scr.item.search_word).item[0]).to_boolean then
							l_pos := -1 + 27 -- skip if block
						end
				when 26 then -- if: | _L___0:
						clear_link (a_t, a_scr)
						draw_forms (a_t, a_scr)
						if a_active.to_boolean then
							draw_current_link (a_t, a_scr)
						end
						l_return := True
				when 27 then -- if done | if done | if done | if done | if done | if done
					if not l_return then
						a_scr.item.free_link
						a_scr.item.xl := l_vx
						a_scr.item.yl := l_vy
						if ((a_scr.item.f_data).item.y).to_boolean then
							l_tmp___4 := (a_scr.item.f_data).item.bg
						else
							l_tmp___4 := (' ').code
						end
						a_t.item.fill_area (l_xp, l_yp, l_xw, l_yw, l_tmp___4.to_natural_32)
						if not ((a_scr.item.f_data).item.y).to_boolean then
							l_return := True
						end
					end
					if not l_return then
						from
						until
							not (l_vs.item.view_pos >= (a_scr.item.f_data).item.y)
						loop
							if l_yw.to_boolean then
								l_tmp___5 := l_yw
							else
								l_tmp___5 := 1
							end
							l_vs.item.view_pos := l_vs.item.view_pos - l_tmp___5
						end
						if l_vs.item.view_pos < 0 then
							l_vs.item.view_pos := 0
						end
						if l_vy /= l_vs.item.view_pos then
							l_vy := l_vs.item.view_pos
							a_scr.item.check_vs
						end
						if l_vy <= 0 then
							l_y := 0
						else
							l_y := l_vy
						end
						from
						until
							(l_break)
						loop
							l_break := False
							if -l_vy + (a_scr.item.f_data).item.y <= l_yw then
								l_tmp___8 := (a_scr.item.f_data).item.y
							else
								l_tmp___8 := l_yw + l_vy
							end
							if not (l_y < l_tmp___8) then
								l_break := True
							end
							if not (l_break) then
								if l_vx <= 0 then
									l_tmp___6 := 0
								else
									l_tmp___6 := l_vx
								end
								l_st := l_tmp___6
								if -l_vx + ((a_scr.item.f_data).item.data + l_y).item.l <= l_xw then
									l_tmp___7 := ((a_scr.item.f_data).item.data + l_y).item.l
								else
									l_tmp___7 := l_xw + l_vx
								end
								l_en := l_tmp___7
								a_t.item.set_line ((l_xp + l_st) - l_vx, (l_yp + l_y) - l_vy, l_en - l_st, ((a_scr.item.f_data).item.data + l_y).item.d + l_st)
								l_y := l_y + 1
							end
						end
						l_break := False
						draw_forms (a_t, a_scr)
						if a_active.to_boolean then
							draw_current_link (a_t, a_scr)
						end
						if (not (a_scr.item.search_word).is_void) then
							if (not ((a_scr.item.search_word).item).is_void) then
								if ((a_scr.item.search_word).item[0]).to_boolean then
									l_tmp___9 := -1
									a_scr.item.yl := l_tmp___9
									a_scr.item.xl := l_tmp___9
								end
							end
						end
					end
				when 28 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	page_up (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		require
			not a_f.is_void
		do
			(a_f.item.vs).item.view_pos := (a_f.item.vs).item.view_pos - (a_f.item.yw)
			a_f.item.find_link (-1, a_a)
			if (a_f.item.vs).item.view_pos < 0 then
				(a_f.item.vs).item.view_pos := 0
			end
			(a_f.item.vs).item.orig_view_pos := (a_f.item.vs).item.view_pos
		end

	up (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		require
			not a_f.is_void
		local
			l_l: INTEGER_32
		do
			l_l := (a_f.item.vs).item.current_link
			if (a_f.item.vs).item.current_link = -1 then
				page_up (a_ses, a_f, 1)
			elseif not (a_f.item.next_in_view ((a_f.item.vs).item.current_link - 1, -1, (create {PD_F_DATA_C_STATIC}).in_viewy_address, (create {PD_F_DATA_C_STATIC}).set_pos_x_address)).to_boolean then
				page_up (a_ses, a_f, 1)
			end
			if l_l /= (a_f.item.vs).item.current_link then
				set_textarea (a_ses, a_f, 263)
			end
		end

	scroll_dirty_workaround_for_name_clash_with_libraries_on_macos (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		require
			not a_f.is_void
		local
			l_tmp___0: INTEGER_32
			l_return: BOOLEAN
		do
			if (a_f.item.vs).item.view_pos + (a_f.item.f_data).item.opt.yw >= (a_f.item.f_data).item.y then
				if a_a > 0 then
					l_return := True
				end
			end
			if not l_return then
				(a_f.item.vs).item.view_pos := (a_f.item.vs).item.view_pos + a_a
				if (a_f.item.vs).item.view_pos > (a_f.item.f_data).item.y - (a_f.item.f_data).item.opt.yw then
					if a_a > 0 then
						(a_f.item.vs).item.view_pos := (a_f.item.f_data).item.y - (a_f.item.f_data).item.opt.yw
					end
				end
				if (a_f.item.vs).item.view_pos < 0 then
					(a_f.item.vs).item.view_pos := 0
				end
				(a_f.item.vs).item.orig_view_pos := (a_f.item.vs).item.view_pos
				if (a_f.item.c2_in_view).to_boolean then
					l_return := True
				end
			end
			if not l_return then
				if a_a < 0 then
					l_tmp___0 := -1
				else
					l_tmp___0 := 1
				end
				a_f.item.find_link (l_tmp___0, 0)
			end
		end

	hscroll (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		require
			not a_f.is_void
		local
			l_return: BOOLEAN
		do
			(a_f.item.vs).item.view_posx := (a_f.item.vs).item.view_posx + a_a
			if (a_f.item.vs).item.view_posx >= (a_f.item.f_data).item.x then
				(a_f.item.vs).item.view_posx := (a_f.item.f_data).item.x - 1
			end
			if (a_f.item.vs).item.view_posx < 0 then
				(a_f.item.vs).item.view_posx := 0
			end
			(a_f.item.vs).item.orig_view_posx := (a_f.item.vs).item.view_posx
			if (a_f.item.c2_in_view).to_boolean then
				l_return := True
			end
			if not l_return then
				a_f.item.find_link (1, 0)
			end
		end

	home (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		require
			not a_f.is_void
		local
			l_tmp: INTEGER_32
		do
			l_tmp := 0;
			(a_f.item.vs).item.view_posx := l_tmp;
			(a_f.item.vs).item.view_pos := l_tmp;
			(a_f.item.vs).item.orig_view_posx := (a_f.item.vs).item.view_posx;
			(a_f.item.vs).item.orig_view_pos := (a_f.item.vs).item.view_pos
			a_f.item.find_link (1, 0)
		end

	x_end (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		require
			not a_f.is_void
		do
			(a_f.item.vs).item.view_posx := 0
			if (a_f.item.vs).item.view_pos < (a_f.item.f_data).item.y - (a_f.item.f_data).item.opt.yw then
				(a_f.item.vs).item.view_pos := (a_f.item.f_data).item.y - (a_f.item.f_data).item.opt.yw
			end
			if (a_f.item.vs).item.view_pos < 0 then
				(a_f.item.vs).item.view_pos := 0
			end
			(a_f.item.vs).item.orig_view_pos := (a_f.item.vs).item.view_pos;
			(a_f.item.vs).item.orig_view_posx := (a_f.item.vs).item.view_posx
			a_f.item.find_link (-1, 0)
		end

	strip_file_name (a_f: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		require
			not a_f.is_void
		local
			l_n: CE_POINTER [NATURAL_8]
			l_l: CE_POINTER [NATURAL_8]
		do
			l_l := a_f - 1
			l_n := a_f
			from
			until
				not ((l_n.item).to_boolean)
			loop
				if ((create {P_OS_DEP_STATIC}).dir_sep ((l_n.item).to_integer_8)).to_boolean then
					l_l := l_n
				end
				l_n := l_n + 1
			end
			Result := (l_l + 1)
		end

	encode_multipart (a_ses: CE_POINTER [PD_SESSION]; a_l: CE_POINTER [PD_LIST_HEAD]; a_data: CE_POINTER [CE_POINTER [NATURAL_8]]; a_len: CE_POINTER [INTEGER_32]; a_bound: CE_POINTER [NATURAL_8]; a_cp_from, a_cp_to: INTEGER_32)
		require
			not a_l.is_void
			not a_data.is_void
			not a_len.is_void
		local
			l_bound_ptrs: CE_POINTER [INTEGER_32]
			l_nbound_ptrs: INTEGER_32
			l_m1: CE_POINTER [NATURAL_8]
			l_m2: CE_POINTER [NATURAL_8]
			l_sv: CE_POINTER [PD_SUBMITTED_VALUE]
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_flg: INTEGER_32
			l_p: CE_POINTER [INTEGER_8]
			l_convert_table___0: CE_POINTER [PD_CONV_TABLE]
			l_ct: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_o: CE_ARRAY [PD_DOCUMENT_OPTIONS]
			l_tmp___6: NATURAL_32
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_fh: INTEGER_32
			l_rd: INTEGER_32
			l_buffer___0: CE_ARRAY [NATURAL_8]
			l_tmp___10: NATURAL_8
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_DOCUMENT_OPTIONS]} l_o.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_buffer___0.make (<<1_024>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bound_ptrs := create {CE_INTEGER_32_POINTER}.make_shared (default_pointer + -1)
					l_nbound_ptrs := 0
					l_flg := 0
					l_convert_table___0 := ((create {P_CHARSETS_STATIC}).get_translation_table (a_cp_from, a_cp_to))
					memset (create {CE_VOID_POINTER}.make_cast (a_bound), ('x').code, (56).to_natural_32).do_nothing
					a_len.item := 0
					a_data.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_379)
					l_sv := create {CE_CLASS_POINTER [PD_SUBMITTED_VALUE]}.make_cast (a_l.item.next)
				when 1 then -- loop condition:
					if not (not (l_return or l_break) and then (not l_sv.is_equal (a_l))) then
						l_pos := -1 + 17 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
				when 3 then -- bnd:;
						(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("--")))
						if not ((l_nbound_ptrs).bit_and (63)).to_boolean then
							if l_nbound_ptrs.to_natural_32 > {NATURAL_32} 2_147_483_647 // {PLATFORM}.Integer_32_bytes.to_natural_32 - {NATURAL_32} 64 then
								from
								until
									False
								loop
									(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 1_385]);
									(create {P_KBD_STATIC}).fatal_tty_exit
									exit (4)
								end
							end
							l_bound_ptrs := create {CE_INTEGER_32_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_386, create {CE_VOID_POINTER}.make_cast (l_bound_ptrs), (l_nbound_ptrs + 64).to_natural_32 * {PLATFORM}.Integer_32_bytes.to_natural_32)))
						end
						l_tmp___1 := l_nbound_ptrs
						l_nbound_ptrs := l_nbound_ptrs + 1
						l_bound_ptrs[l_tmp___1] := a_len.item;
						(create {P_LINKS_STATIC}).add_bytes_to_str (a_data, a_len, a_bound, 56)
						if l_flg.to_boolean then
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 16 -- skip if block
						end
				when 4 then -- if:;
						(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%NContent-Disposition: form-data; name=%"")));
						(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, l_sv.item.name);
						(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%"")))
						if l_sv.item.type = 3 then
							(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("; filename=%"")));
							(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, (strip_file_name (l_sv.item.value)));
							(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%"")))
							if ((l_sv.item.value).item).to_boolean then
								l_ct := (create {P_TYPES_STATIC}).get_content_type (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_sv.item.value)
								if (not l_ct.is_void) then
									(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%NContent-Type: ")));
									(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, l_ct)
									if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_ct))) >= {NATURAL_32} 4 then
										if not ((create {P_LINKS_STATIC}).casecmp (l_ct, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("text")), (4).to_natural_32)).to_boolean then
											(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("; charset=")));
											(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, ((create {P_CHARSETS_STATIC}).get_cp_mime_name (((a_ses.item.term).item.spec).item.charset)))
										end
									end
									(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_407, create {CE_VOID_POINTER}.make_cast (l_ct))
								end
							end
						end
						(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N%R%N")))
						if l_sv.item.type = 3 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_o.item.plain := 1;
						(create {P_LINKS_STATIC}).d_opt.item := l_o
						if l_sv.item.type = 1 then
							l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_sv.item.value))
							l_tmp___7 := (create {P_CHARSETS_STATIC}).convert_string (l_convert_table___0, l_sv.item.value, l_tmp___6.to_integer_32)
							l_p := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___7)
						elseif l_sv.item.type = 2 then
							l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_sv.item.value))
							l_tmp___7 := (create {P_CHARSETS_STATIC}).convert_string (l_convert_table___0, l_sv.item.value, l_tmp___6.to_integer_32)
							l_p := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___7)
						elseif l_sv.item.type = 4 then
							l_tmp___6 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_sv.item.value))
							l_tmp___7 := (create {P_CHARSETS_STATIC}).convert_string (l_convert_table___0, l_sv.item.value, l_tmp___6.to_integer_32)
							l_p := create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___7)
						else
							l_p := create {CE_INTEGER_8_POINTER}.make_cast (((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_417, l_sv.item.value)))
						end
						(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, create {CE_NATURAL_8_POINTER}.make_cast (l_p));
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_419, create {CE_VOID_POINTER}.make_cast (l_p))
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 15
				when 7 then -- else:
						if not (((l_sv.item.value).item).to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 8 then -- if:
						if ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
							(errno_location).item := 1
							l_pos := -1 + 29 -- goto error
						end
				when 9 then
						l_fh := open ([create {CE_INTEGER_8_POINTER}.make_cast (l_sv.item.value), 0])
						if l_fh = -1 then
							l_pos := -1 + 29 -- goto error
						end
				when 10 then;
						(create {P_OS_DEP_STATIC}).set_bin (l_fh)
				when 11 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 14 -- skip loop
						end
				when 12 then -- loop body:
						l_break := False
						l_rd := read (l_fh, create {CE_VOID_POINTER}.make_cast (l_buffer___0), (1_024).to_natural_32)
						if l_rd = -1 then
							close (l_fh).do_nothing
							l_pos := -1 + 29 -- goto error
						end
				when 13 then
						if l_rd.to_boolean then
							(create {P_LINKS_STATIC}).add_bytes_to_str (a_data, a_len, l_buffer___0, l_rd)
						end
						if not l_rd.to_boolean then
							l_break := True
						end
						l_pos := -1 + 11 -- back to loop condition
				when 14 then -- loop done
						l_break := False
						close (l_fh).do_nothing
				when 15 then -- if done | if done;
						(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%R%N")))
						l_sv := l_sv.item.next
				when 16 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 17 then -- loop done
					l_break := False
					if not l_flg.to_boolean then
						l_flg := 1
						l_pos := -1 + 3 -- goto bnd
					end
				when 18 then;
					(create {P_LINKS_STATIC}).add_to_str (a_data, a_len, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("--%R%N")))
					memset (create {CE_VOID_POINTER}.make_cast (a_bound), ('-').code, (27).to_natural_32).do_nothing
					memset (create {CE_VOID_POINTER}.make_cast ((a_bound + 27)), ('0').code, (29).to_natural_32).do_nothing
				when 19 then -- again:
					l_i := 0
				when 20 then -- loop condition:
					if not (not (l_return) and then (l_i <= a_len.item - 56)) then
						l_pos := -1 + 28 -- skip loop
					end
				when 21 then -- loop body:
						l_j := 0
				when 22 then -- loop condition:
						if not (l_j < 56) then
							l_pos := -1 + 25 -- skip loop
						end
				when 23 then -- loop body:
						if (a_data.item[(l_i + l_j)]).to_integer_32 /= (a_bound[l_j]).to_integer_32 then
							l_pos := -1 + 27 -- goto nb
						end
				when 24 then
						l_j := l_j + 1
						l_pos := -1 + 22 -- back to loop condition
				when 25 then -- loop done
						l_j := 55
						from
						until
							not (l_j >= 0)
						loop
							if (a_bound[l_j]).to_integer_32 < 48 then
								a_bound[l_j] := (47).to_natural_8
							end
							l_j := l_j - 1
						end
						l_tmp___10 := a_bound[l_j]
						a_bound[l_j] := ((a_bound[l_j]).to_integer_32 + 1).to_natural_8
						if l_tmp___10 >= 57 then
							a_bound[l_j] := (('0').code).to_natural_8
						else
							l_pos := -1 + 19 -- goto again
						end
				when 26 then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c"));
							(create {P_LINKS_STATIC}).errline.item := 1_461;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Counld not assing boundary"))])
						end
				when 27 then -- nb:
						l_i := l_i + 1
						l_pos := -1 + 20 -- back to loop condition
				when 28 then -- loop done
					l_i := 0
					from
					until
						not (l_i < l_nbound_ptrs)
					loop
						memcpy (create {CE_VOID_POINTER}.make_cast ((a_data.item + l_bound_ptrs[l_i])), create {CE_VOID_POINTER}.make_cast (a_bound), (56).to_natural_32).do_nothing
						l_i := l_i + 1
					end
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_465, create {CE_VOID_POINTER}.make_cast (l_bound_ptrs))
					l_return := True
					if l_return then
						l_pos := -1 + 30 -- skip if block
					end
				when 29 then -- if: | error:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_468, create {CE_VOID_POINTER}.make_cast (l_bound_ptrs));
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_469, create {CE_VOID_POINTER}.make_cast (a_data.item))
						a_data.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						l_m1 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_471, l_sv.item.value)
						l_m2 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_472, create {CE_NATURAL_8_POINTER}.make_cast ((strerror ((errno_location).item))));
						(a_ses.item.term).item.msg_box ([((create {P_BFU_STATIC}).getml ([create {CE_VOID_POINTER}.make_cast (l_m1), l_m2, create {CE_VOID_POINTER}.make_shared (default_pointer)])), (create {P_LINKS_STATIC}).dummyarray.item + 205, 129, (create {P_LINKS_STATIC}).dummyarray.item + 206, ce_string (" "), l_m1, ce_string (": "), l_m2, create {CE_VOID_POINTER}.make_shared (default_pointer), a_ses, 1, (create {P_LINKS_STATIC}).dummyarray.item + 6, create {CE_VOID_POINTER}.make_shared (default_pointer), 3])
				when 30 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_form_url (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_form___0: CE_POINTER [PD_FORM_CONTROL]): CE_POINTER [NATURAL_8]
		local
			l_submit: CE_ARRAY [PD_LIST_HEAD]
			l_data: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_bound: CE_ARRAY [NATURAL_8]
			l_len: CE_ARRAY [INTEGER_32]
			l_go: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_cp_from: INTEGER_32
			l_cp_to: INTEGER_32
			l_pos___0: CE_POINTER [NATURAL_8]
			l_poss: CE_POINTER [NATURAL_8]
			l_l: CE_ARRAY [INTEGER_32]
			l_i: INTEGER_32
			l_p: CE_ARRAY [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_LIST_HEAD]} l_submit.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_data.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_bound.make (<<56>>)
			create {CE_INTEGER_32_ARRAY} l_len.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_go.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_p.make (<<3>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_go.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					if a_form___0.is_void then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return and then (a_form___0.item.type = 10) then
						a_f.item.reset_form (a_form___0.item.form_num)
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return and then ((a_form___0.item.action).is_void) then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
						l_return := True
					end
					if l_return then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						a_f.item.get_succesful_controls (a_form___0, l_submit)
						l_cp_from := ((a_ses.item.term).item.spec).item.charset
						l_cp_to := (a_f.item.f_data).item.cp
						if a_form___0.item.method = 0 then
							l_submit.item.encode_controls (l_data, l_len, l_cp_from, l_cp_to)
						elseif a_form___0.item.method = 1 then
							l_submit.item.encode_controls (l_data, l_len, l_cp_from, l_cp_to)
						else
							encode_multipart (a_ses, l_submit, l_data, l_len, l_bound, l_cp_from, l_cp_to)
						end
						if (l_data.item).is_void then
							l_pos := -1 + 3 -- goto ff
						end
				when 2 then
						if a_form___0.item.method = 0 then
							if ((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_form___0.item.action))) + {NATURAL_32} 2) + (l_len.item).to_natural_32 < (l_len.item).to_natural_32 then
								from
								until
									False
								loop
									(create {P_ERROR_STATIC}).error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ERROR: attempting to allocate too large block at %%s:%%d")), ce_string ("view.c"), 1_509]);
									(create {P_KBD_STATIC}).fatal_tty_exit
									exit (4)
								end
							end
							l_go.item := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_alloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_510, (((strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_form___0.item.action))) + {NATURAL_32} 1) + (l_len.item).to_natural_32) + {NATURAL_32} 1)))
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_go.item), create {CE_INTEGER_8_POINTER}.make_cast (a_form___0.item.action)).do_nothing
							l_pos___0 := create {CE_NATURAL_8_POINTER}.make_cast ((strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_go.item), ('#').code)))
							if (not l_pos___0.is_void) then
								l_poss := l_pos___0
								l_pos___0 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_514, l_pos___0)
								l_poss.item := (0).to_natural_8
							end
							if (not (strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_go.item), ('?').code)).is_void) then
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_go.item), ce_string ("&")).do_nothing
							else
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_go.item), ce_string ("?")).do_nothing
							end
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_go.item), create {CE_INTEGER_8_POINTER}.make_cast (l_data.item)).do_nothing
							if (not l_pos___0.is_void) then
								strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_go.item), create {CE_INTEGER_8_POINTER}.make_cast (l_pos___0)).do_nothing;
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_520, create {CE_VOID_POINTER}.make_cast (l_pos___0))
							end
						else
							l_l.item := 0
							l_go.item := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_524);
							(create {P_LINKS_STATIC}).add_to_str (l_go, l_l, a_form___0.item.action);
							(create {P_LINKS_STATIC}).add_chr_to_str (l_go, l_l, (1).to_natural_8)
							if a_form___0.item.method = 1 then
								(create {P_LINKS_STATIC}).add_to_str (l_go, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("application/x-www-form-urlencoded%N")))
							else
								(create {P_LINKS_STATIC}).add_to_str (l_go, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("multipart/form-data; boundary=")));
								(create {P_LINKS_STATIC}).add_bytes_to_str (l_go, l_l, l_bound, 56);
								(create {P_LINKS_STATIC}).add_to_str (l_go, l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("%N")))
							end
							l_i := 0
							from
							until
								not (l_i < l_len.item)
							loop
								sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (l_p), ce_string ("%%02x"), (l_data.item[l_i]).to_integer_32]).do_nothing;
								(create {P_LINKS_STATIC}).add_to_str (l_go, l_l, l_p)
								l_i := l_i + 1
							end
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_539, create {CE_VOID_POINTER}.make_cast (l_data.item))
				when 3 then -- ff:
						l_submit.item.free_succesful_controls
						Result := (l_go.item)
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_link_url (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK]): CE_POINTER [NATURAL_8]
		require
			not a_l.is_void
		local
			l_return: BOOLEAN
		do
			if a_l.item.type = 0 then
				if (a_l.item.where).is_void then
					Result := ((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_548, a_l.item.where_img))
					l_return := True
				end
				if not l_return then
					Result := ((create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_549, a_l.item.where))
					l_return := True
				end
			end
			if not l_return and then (a_l.item.type /= 1) then
				if a_l.item.type /= 4 then
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				Result := (get_form_url (a_ses, a_f, a_l.item.form))
			end
		end

	selected_item (a_term: CE_POINTER [PD_TERMINAL]; a_pitem: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_ses.is_void
		local
			l_item: INTEGER_32
			l_f: CE_POINTER [PD_F_DATA_C]
			l_l: CE_POINTER [PD_LINK]
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_form___0: CE_POINTER [PD_FORM_CONTROL]
			l_return: BOOLEAN
		do
			l_item := (a_pitem.c_pointer.to_integer_32).to_integer_32
			l_f := (a_ses.item.current_frame)
			if l_f.is_void then
				l_return := True
			end
			if not l_return and then ((l_f.item.vs).item.current_link = -1) then
				l_return := True
			end
			if not l_return then
				l_l := (l_f.item.f_data).item.links + (l_f.item.vs).item.current_link
				if l_l.item.type /= 3 then
					l_return := True
				end
			end
			if not l_return then
				l_fs := l_f.item.find_form_state (l_l.item.form)
				if (not l_fs.is_void) then
					l_form___0 := l_l.item.form
					if l_item >= 0 then
						if l_item < l_form___0.item.nvalues then
							l_fs.item.state := l_item
							if (not (l_fs.item.value).is_void) then
								(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_629, create {CE_VOID_POINTER}.make_cast (l_fs.item.value))
							end
							l_fs.item.value := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_630, l_form___0.item.values[l_item])
						end
					end
					l_form___0.item.fixup_select_state (l_fs)
				end
				draw_doc (a_ses.item.term, l_f, 1)
				a_ses.item.print_screen_status;
				(create {P_TERMINAL_STATIC}).redraw_from_window (a_ses.item.win)
			end
		end

	field_op (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_l: CE_POINTER [PD_LINK]; a_ev: CE_POINTER [PD_EVENT]; a_rep: INTEGER_32): INTEGER_32
		require
			not a_l.is_void
		local
			l_form___0: CE_POINTER [PD_FORM_CONTROL]
			l_fs: CE_POINTER [PD_FORM_STATE]
			l_x: INTEGER_32
			l_ln: CE_POINTER [PD_LINE_INFO]
			l_y: INTEGER_32
			l_ln___0: CE_POINTER [PD_LINE_INFO]
			l_y___0: INTEGER_32
			l_ln___1: CE_POINTER [PD_LINE_INFO]
			l_y___1: INTEGER_32
			l_ln___2: CE_POINTER [PD_LINE_INFO]
			l_y___2: INTEGER_32
			l_clipboard: CE_POINTER [INTEGER_8]
			l_v: CE_POINTER [NATURAL_8]
			l_v___0: CE_POINTER [NATURAL_8]
			l_tmp___15: INTEGER_32
			l_v___1: CE_POINTER [NATURAL_8]
			l_tmp___24: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_form___0 := a_l.item.form
					l_x := 1
					if l_form___0.is_void then
						from
						until
							False
						loop
							(create {P_LINKS_STATIC}).errfile.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c"));
							(create {P_LINKS_STATIC}).errline.item := 1_679;
							(create {P_ERROR_STATIC}).int_error ([create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("link has no form control"))])
						end
						Result := 0
						l_return := True
					end
					if not l_return and then ((a_l.item.form).item.ro = 2) then
						Result := 0
						l_return := True
					end
					if not l_return then
						l_fs := a_f.item.find_form_state (l_form___0)
						if l_fs.is_void then
							Result := 0
							l_return := True
						end
					end
					if not l_return and then ((l_fs.item.value).is_void) then
						Result := 0
						l_return := True
					end
					if l_return then
						l_pos := -1 + 73 -- skip if block
					end
				when 1 then -- if:
						if a_ev.item.ev /= 1 then
							l_pos := -1 + 71 -- skip if block
						end
				when 2 then -- if:
						inspect (a_ev.item.kbd_action (1)) -- switch 1 head
						when 23 then l_pos := -1 + 3
						when 35 then l_pos := -1 + 4
						when 20 then l_pos := -1 + 5
						when 45 then l_pos := -1 + 16
						when 9 then l_pos := -1 + 31
						when 11 then l_pos := -1 + 46
						when 5 then l_pos := -1 + 57
						when 6 then l_pos := -1 + 58
						when 30 then l_pos := -1 + 59
						when 12 then l_pos := -1 + 61
						when 3 then l_pos := -1 + 62
						when 7 then l_pos := -1 + 63
						when 21 then l_pos := -1 + 64
						when 22 then l_pos := -1 + 65
						else l_pos := -1 + 66
						end
				when 3 then -- switch 1, case 23
						if (l_fs.item.state).to_boolean then
							l_fs.item.state := (l_fs.item.state) - 1
						else
							l_fs.item.state := 0
						end
						l_pos := -1 + 70 -- switch 1; break
				when 4 then -- switch 1, case 35
						if (l_fs.item.state).to_natural_32 < (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fs.item.value))) then
							l_fs.item.state := (l_fs.item.state) + 1
						else
							l_fs.item.state := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fs.item.value))).to_integer_32
						end
						l_pos := -1 + 70 -- switch 1; break
				when 5 then -- switch 1, case 20
						if l_form___0.item.type /= 4 then
							l_pos := -1 + 14 -- skip if block
						end
				when 6 then -- if:
						l_ln := format_text (l_fs.item.value, l_form___0.item.cols, l_form___0.item.wrap)
						if l_ln.is_void then
							l_pos := -1 + 13 -- skip if block
						end
				when 7 then -- if:
						l_y := 0
				when 8 then -- loop condition:
						if ((l_ln + l_y).item.st).is_void then
							l_pos := -1 + 11 -- skip loop
						end
				when 9 then -- loop body:
						if ((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 >= (((l_ln + l_y).item.st).c_pointer.to_integer_32).to_natural_32 then
							if ((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 < (((l_ln + l_y).item.en + (not ((l_ln + (l_y + 1)).item.st).is_equal ((l_ln + l_y).item.en)).to_integer).c_pointer.to_integer_32).to_natural_32 then
								l_fs.item.state := ((l_ln + l_y).item.st).distance ((l_fs.item.value))
								l_pos := -1 + 12 -- goto x
							end
						end
				when 10 then
						l_y := l_y + 1
						l_pos := -1 + 8 -- back to loop condition
				when 11 then -- loop done
						l_fs.item.state := 0
				when 12 then -- x:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_700, create {CE_VOID_POINTER}.make_cast (l_ln))
				when 13 then -- if done | if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_fs.item.state := 0
				when 15 then -- if done
						l_pos := -1 + 70 -- switch 1; break
				when 16 then -- switch 1, case 45
						if l_form___0.item.type /= 4 then
							l_pos := -1 + 29 -- skip if block
						end
				when 17 then -- if:
						l_ln___0 := format_text (l_fs.item.value, l_form___0.item.cols, l_form___0.item.wrap)
						if l_ln___0.is_void then
							l_pos := -1 + 28 -- skip if block
						end
				when 18 then -- if: | rep1:
						l_y___0 := 0
				when 19 then -- loop condition:
						if ((l_ln___0 + l_y___0).item.st).is_void then
							l_pos := -1 + 25 -- skip loop
						end
				when 20 then -- loop body:
						if not (((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 >= (((l_ln___0 + l_y___0).item.st).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 24 -- skip if block
						end
				when 21 then -- if:
						if not (((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 < (((l_ln___0 + l_y___0).item.en + (not ((l_ln___0 + (l_y___0 + 1)).item.st).is_equal ((l_ln___0 + l_y___0).item.en)).to_integer).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if not l_y___0.to_boolean then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_712, create {CE_VOID_POINTER}.make_cast (l_ln___0))
							l_pos := -1 + 69 -- goto b
						end
				when 23 then
						l_fs.item.state := l_fs.item.state - (((l_ln___0 + l_y___0).item.st).distance (((l_ln___0 + (l_y___0 - 1)).item.st)))
						if ((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 > (((l_ln___0 + (l_y___0 - 1)).item.en).c_pointer.to_integer_32).to_natural_32 then
							l_fs.item.state := ((l_ln___0 + (l_y___0 - 1)).item.en).distance ((l_fs.item.value))
						end
						l_pos := -1 + 26 -- goto xx
				when 24 then -- if done
						l_y___0 := l_y___0 + 1
						l_pos := -1 + 19 -- back to loop condition
				when 25 then -- loop done;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_719, create {CE_VOID_POINTER}.make_cast (l_ln___0))
						l_pos := -1 + 69 -- goto b
				when 26 then -- xx:
						if a_rep.to_boolean then
							l_pos := -1 + 18 -- goto rep1
						end
				when 27 then;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_723, create {CE_VOID_POINTER}.make_cast (l_ln___0))
				when 28 then -- if done | if block done, skip else block:
						l_pos := -1 + 30
				when 29 then -- else:
						l_x := 0
				when 30 then -- if done
						l_pos := -1 + 70 -- switch 1; break
				when 31 then -- switch 1, case 9
						if l_form___0.item.type /= 4 then
							l_pos := -1 + 44 -- skip if block
						end
				when 32 then -- if:
						l_ln___1 := format_text (l_fs.item.value, l_form___0.item.cols, l_form___0.item.wrap)
						if l_ln___1.is_void then
							l_pos := -1 + 43 -- skip if block
						end
				when 33 then -- if: | rep2:
						l_y___1 := 0
				when 34 then -- loop condition:
						if ((l_ln___1 + l_y___1).item.st).is_void then
							l_pos := -1 + 40 -- skip loop
						end
				when 35 then -- loop body:
						if not (((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 >= (((l_ln___1 + l_y___1).item.st).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 39 -- skip if block
						end
				when 36 then -- if:
						if not (((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 < (((l_ln___1 + l_y___1).item.en + (not ((l_ln___1 + (l_y___1 + 1)).item.st).is_equal ((l_ln___1 + l_y___1).item.en)).to_integer).c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if ((l_ln___1 + (l_y___1 + 1)).item.st).is_void then
							(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_735, create {CE_VOID_POINTER}.make_cast (l_ln___1))
							l_pos := -1 + 69 -- goto b
						end
				when 38 then
						l_fs.item.state := l_fs.item.state + (((l_ln___1 + (l_y___1 + 1)).item.st).distance (((l_ln___1 + l_y___1).item.st)))
						if ((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 > (((l_ln___1 + (l_y___1 + 1)).item.en).c_pointer.to_integer_32).to_natural_32 then
							l_fs.item.state := ((l_ln___1 + (l_y___1 + 1)).item.en).distance ((l_fs.item.value))
						end
						l_pos := -1 + 41 -- goto yy
				when 39 then -- if done
						l_y___1 := l_y___1 + 1
						l_pos := -1 + 34 -- back to loop condition
				when 40 then -- loop done;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_742, create {CE_VOID_POINTER}.make_cast (l_ln___1))
						l_pos := -1 + 69 -- goto b
				when 41 then -- yy:
						if a_rep.to_boolean then
							l_pos := -1 + 33 -- goto rep2
						end
				when 42 then;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_746, create {CE_VOID_POINTER}.make_cast (l_ln___1))
				when 43 then -- if done | if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else:
						l_x := 0
				when 45 then -- if done
						l_pos := -1 + 70 -- switch 1; break
				when 46 then -- switch 1, case 11
						if l_form___0.item.type /= 4 then
							l_pos := -1 + 55 -- skip if block
						end
				when 47 then -- if:
						l_ln___2 := format_text (l_fs.item.value, l_form___0.item.cols, l_form___0.item.wrap)
						if l_ln___2.is_void then
							l_pos := -1 + 54 -- skip if block
						end
				when 48 then -- if:
						l_y___2 := 0
				when 49 then -- loop condition:
						if ((l_ln___2 + l_y___2).item.st).is_void then
							l_pos := -1 + 52 -- skip loop
						end
				when 50 then -- loop body:
						if ((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 >= (((l_ln___2 + l_y___2).item.st).c_pointer.to_integer_32).to_natural_32 then
							if ((l_fs.item.value + l_fs.item.state).c_pointer.to_integer_32).to_natural_32 < (((l_ln___2 + l_y___2).item.en + (not ((l_ln___2 + (l_y___2 + 1)).item.st).is_equal ((l_ln___2 + l_y___2).item.en)).to_integer).c_pointer.to_integer_32).to_natural_32 then
								l_fs.item.state := ((l_ln___2 + l_y___2).item.en).distance ((l_fs.item.value))
								if (l_fs.item.state).to_boolean then
									if (l_fs.item.state).to_natural_32 < (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fs.item.value))) then
										if ((l_ln___2 + (l_y___2 + 1)).item.st).is_equal ((l_ln___2 + l_y___2).item.en) then
											l_fs.item.state := (l_fs.item.state) - 1
										end
									end
								end
								l_pos := -1 + 53 -- goto yyyy
							end
						end
				when 51 then
						l_y___2 := l_y___2 + 1
						l_pos := -1 + 49 -- back to loop condition
				when 52 then -- loop done
						l_fs.item.state := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fs.item.value))).to_integer_32
				when 53 then -- yyyy:;
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_762, create {CE_VOID_POINTER}.make_cast (l_ln___2))
				when 54 then -- if done | if block done, skip else block:
						l_pos := -1 + 56
				when 55 then -- else:
						l_fs.item.state := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fs.item.value))).to_integer_32
				when 56 then -- if done
						l_pos := -1 + 70 -- switch 1; break
				when 57 then -- switch 1, case 5;
						(create {P_OS_DEP_STATIC}).set_clipboard_text (create {CE_INTEGER_8_POINTER}.make_cast (l_fs.item.value))
						l_pos := -1 + 70 -- switch 1; break
				when 58 then -- switch 1, case 6;
						(create {P_OS_DEP_STATIC}).set_clipboard_text (create {CE_INTEGER_8_POINTER}.make_cast (l_fs.item.value))
						if not (l_form___0.item.ro).to_boolean then
							l_fs.item.value[0] := (0).to_natural_8
						end
						l_fs.item.state := 0
						l_pos := -1 + 70 -- switch 1; break
				when 59 then -- switch 1, case 30
						l_clipboard := ((create {P_OS_DEP_STATIC}).get_clipboard_text)
						if l_clipboard.is_void then
							l_pos := -1 + 70 -- switch 1; break
						end
				when 60 then
						if not (l_form___0.item.ro).to_boolean then
							if (strlen (l_clipboard)) <= (l_form___0.item.maxlength).to_natural_32 then
								l_v := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_779, create {CE_VOID_POINTER}.make_cast (l_fs.item.value), (strlen (l_clipboard)) + {NATURAL_32} 1)))
								l_fs.item.value := l_v
								memmove (create {CE_VOID_POINTER}.make_cast (l_v), create {CE_VOID_POINTER}.make_cast (l_clipboard), (strlen (l_clipboard)) + {NATURAL_32} 1).do_nothing
								l_fs.item.state := (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fs.item.value))).to_integer_32
							end
						end
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_784, create {CE_VOID_POINTER}.make_cast (l_clipboard))
						l_pos := -1 + 70 -- switch 1; break
				when 61 then -- switch 1, case 12
						if l_form___0.item.type = 4 then
							if not (l_form___0.item.ro).to_boolean then
								if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fs.item.value))) < (l_form___0.item.maxlength).to_natural_32 then
									l_v___0 := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_791, create {CE_VOID_POINTER}.make_cast (l_fs.item.value), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fs.item.value))) + {NATURAL_32} 2)))
									l_fs.item.value := l_v___0
									memmove (create {CE_VOID_POINTER}.make_cast (((l_v___0 + l_fs.item.state) + 1)), create {CE_VOID_POINTER}.make_cast ((l_v___0 + l_fs.item.state)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_v___0 + l_fs.item.state)))) + {NATURAL_32} 1).do_nothing
									l_tmp___15 := l_fs.item.state
									l_fs.item.state := (l_fs.item.state) + 1
									l_v___0[l_tmp___15] := (('%N').code).to_natural_8
								end
							end
						else
							l_x := 0
						end
						l_pos := -1 + 70 -- switch 1; break
				when 62 then -- switch 1, case 3
						if not (l_form___0.item.ro).to_boolean then
							if (l_fs.item.state).to_boolean then
								memmove (create {CE_VOID_POINTER}.make_cast (((l_fs.item.value + l_fs.item.state) - 1)), create {CE_VOID_POINTER}.make_cast ((l_fs.item.value + l_fs.item.state)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_fs.item.value + l_fs.item.state)))) + {NATURAL_32} 1).do_nothing
								l_fs.item.state := (l_fs.item.state) - 1
							end
						end
						l_pos := -1 + 70 -- switch 1; break
				when 63 then -- switch 1, case 7
						if not (l_form___0.item.ro).to_boolean then
							if (l_fs.item.state).to_natural_32 < (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fs.item.value))) then
								memmove (create {CE_VOID_POINTER}.make_cast ((l_fs.item.value + l_fs.item.state)), create {CE_VOID_POINTER}.make_cast (((l_fs.item.value + l_fs.item.state) + 1)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_fs.item.value + l_fs.item.state))))).do_nothing
							end
						end
						l_pos := -1 + 70 -- switch 1; break
				when 64 then -- switch 1, case 21
						if not (l_form___0.item.ro).to_boolean then
							memmove (create {CE_VOID_POINTER}.make_cast (l_fs.item.value), create {CE_VOID_POINTER}.make_cast ((l_fs.item.value + l_fs.item.state)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_fs.item.value + l_fs.item.state)))) + {NATURAL_32} 1).do_nothing
						end
						l_fs.item.state := 0
						l_pos := -1 + 70 -- switch 1; break
				when 65 then -- switch 1, case 22
						l_fs.item.value[l_fs.item.state] := (0).to_natural_8
						l_pos := -1 + 70 -- switch 1; break
				when 66 then -- switch 1, default:
						if (a_ev.item.y).to_boolean then
							l_pos := -1 + 69 -- skip if block
						end
				when 67 then -- if:
						if a_ev.item.x >= 32 then
							if a_ev.item.x < 256 then
								if ((create {P_CHARSETS_STATIC}).cp2u ((a_ev.item.x).to_natural_8, ((a_ses.item.term).item.spec).item.charset)) /= -1 then
									if not (l_form___0.item.ro).to_boolean then
										if (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fs.item.value))) < (l_form___0.item.maxlength).to_natural_32 then
											l_v___1 := create {CE_NATURAL_8_POINTER}.make_cast (((create {P_ERROR_STATIC}).debug_mem_realloc (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 1_816, create {CE_VOID_POINTER}.make_cast (l_fs.item.value), (strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_fs.item.value))) + {NATURAL_32} 2)))
											l_fs.item.value := l_v___1
											memmove (create {CE_VOID_POINTER}.make_cast (((l_v___1 + l_fs.item.state) + 1)), create {CE_VOID_POINTER}.make_cast ((l_v___1 + l_fs.item.state)), (strlen (create {CE_INTEGER_8_POINTER}.make_cast ((l_v___1 + l_fs.item.state)))) + {NATURAL_32} 1).do_nothing
											l_tmp___24 := l_fs.item.state
											l_fs.item.state := (l_fs.item.state) + 1
											l_v___1[l_tmp___24] := (a_ev.item.x).to_natural_8
										end
									end
								else
									l_pos := -1 + 69 -- goto b
								end
							else
								l_pos := -1 + 69 -- goto b
							end
						else
							l_pos := -1 + 69 -- goto b
						end
				when 68 then -- if block done, skip else block:
						l_pos := -1 + 70
				when 69 then -- else: | b:
						l_x := 0
				when 70 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 72
				when 71 then -- else:
						l_x := 0
				when 72 then -- if done
						if l_x.to_boolean then
							if a_ev.item.x /= 262 then
								if a_ev.item.x /= 263 then
									if l_form___0.item.type = 4 then
										a_f.item.textarea_adjust_viewport (a_l).do_nothing
									end
								end
							end
							draw_form_entry (a_ses.item.term, a_f, a_l);
							(create {P_TERMINAL_STATIC}).redraw_from_window (a_ses.item.win)
						end
						Result := l_x
				when 73 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_textarea (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_kbd: INTEGER_32)
		require
			not a_f.is_void
		local
			l_ev: CE_ARRAY [PD_EVENT]
		do
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)

			if (a_f.item.vs).item.current_link /= -1 then
				if ((a_f.item.f_data).item.links + (a_f.item.vs).item.current_link).item.type = 5 then
					l_ev.item.ev := 1
					l_ev.item.x := 0
					l_ev.item.y := 0
					l_ev.item.b := 0
					l_ev.item.x := a_kbd.to_integer_32
					field_op (a_ses, a_f, (a_f.item.f_data).item.links + (a_f.item.vs).item.current_link, l_ev, 1).do_nothing
				end
			end
		end

	send_event (a_ses: CE_POINTER [PD_SESSION]; a_ev: CE_POINTER [PD_EVENT])
		require
			not a_ev.is_void
		local
			l_s: CE_POINTER [NATURAL_8]
			l_url: CE_ARRAY [NATURAL_8]
			l_m: CE_POINTER [PD_WINDOW]
			l_m___0: CE_POINTER [PD_WINDOW]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_url.make (<<1_024>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_ev.item.ev /= 1 then
						l_pos := -1 + 29 -- skip if block
					end
				when 1 then -- if:
						if (a_ses.item.send_to_frame (a_ev)).to_boolean then
							l_return := True
						end
						if l_return then
							l_pos := -1 + 29 -- skip if block
						end
				when 2 then -- if:
						inspect (a_ev.item.kbd_action (0)) -- switch 1 head
						when 24 then l_pos := -1 + 3
						when 13 then l_pos := -1 + 4
						when 25 then l_pos := -1 + 5
						when 31 then l_pos := -1 + 6
						when 2 then l_pos := -1 + 7
						when 34 then l_pos := -1 + 8
						when 16 then l_pos := -1 + 9
						when 17 then l_pos := -1 + 10
						when 18 then l_pos := -1 + 12
						when 0 then l_pos := -1 + 14
						when 4 then l_pos := -1 + 15
						when 32 then l_pos := -1 + 16
						when 33 then l_pos := -1 + 17
						when 8 then l_pos := -1 + 18
						when 19 then l_pos := -1 + 19
						when 42 then l_pos := -1 + 20
						when 43 then l_pos := -1 + 21
						when 44 then l_pos := -1 + 22
						when 26 then l_pos := -1 + 23
						when 27 then l_pos := -1 + 24
						else l_pos := -1 + 25
						end
				when 3 then -- switch 1, case 24
						a_ses.item.activate_bfu_technology (-1)
						l_pos := -1 + 35 -- goto x
				when 4 then -- switch 1, case 13
						a_ses.item.activate_bfu_technology (0)
						l_pos := -1 + 35 -- goto x
				when 5 then -- switch 1, case 25
						a_ses.item.next_frame (1)
						a_ses.item.draw_formatted
						l_pos := -1 + 35 -- goto x
				when 6 then -- switch 1, case 31
						a_ses.item.next_frame (-1)
						a_ses.item.draw_formatted
						l_pos := -1 + 35 -- goto x
				when 7 then -- switch 1, case 2
						a_ses.item.back (create {CE_CLASS_POINTER [PD_F_DATA_C]}.make_shared (default_pointer), 0)
						l_pos := -1 + 35 -- goto x
				when 8 then -- switch 1, case 34
						a_ses.item.reload (-1)
						l_pos := -1 + 35 -- goto x
				when 9 then -- quak: | switch 1, case 16
						a_ses.item.dialog_goto_url (ce_string (""))
						l_pos := -1 + 35 -- goto x
				when 10 then -- switch 1, case 17
						if (a_ses.item.history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
							l_pos := -1 + 9 -- goto quak
						end
				when 11 then
						l_s := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_229, (create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)).item.vs.url)
						if (not (strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_s), 1)).is_void) then
							(strchr (create {CE_INTEGER_8_POINTER}.make_cast (l_s), 1))[0] := (0).to_integer_8
						end
						a_ses.item.dialog_goto_url (create {CE_INTEGER_8_POINTER}.make_cast (l_s));
						(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_232, create {CE_VOID_POINTER}.make_cast (l_s))
						l_pos := -1 + 35 -- goto x
				when 12 then -- switch 1, case 18
						if (a_ses.item.get_current_link_url (l_url, ({PLATFORM}.Natural_8_bytes.to_natural_32 * (1_024).to_natural_32))).is_void then
							l_pos := -1 + 9 -- goto quak
						end
				when 13 then
						a_ses.item.dialog_goto_url (create {CE_INTEGER_8_POINTER}.make_cast (l_url))
						l_pos := -1 + 35 -- goto x
				when 14 then -- switch 1, case 0
						if not ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
							(a_ses.item.term).item.launch_bm_add_doc_dialog (create {CE_CLASS_POINTER [PD_DIALOG_DATA]}.make_shared (default_pointer), a_ses)
						end
						l_pos := -1 + 35 -- goto x
				when 15 then -- switch 1, case 4
						if not ((create {P_DEFAULT_STATIC}).anonymous.item).to_boolean then
							(a_ses.item.term).item.menu_bookmark_manager (create {CE_VOID_POINTER}.make_shared (default_pointer), a_ses)
						end
						l_pos := -1 + 35 -- goto x
				when 16 then -- switch 1, case 32;
						(create {P_MENU_STATIC}).exit_prog (a_ses.item.term, create {CE_VOID_POINTER}.make_shared (default_pointer + 1), a_ses)
						l_pos := -1 + 35 -- goto x
				when 17 then -- quit: | switch 1, case 33;
						(create {P_MENU_STATIC}).exit_prog (a_ses.item.term, create {CE_VOID_POINTER}.make_shared (default_pointer + (a_ev.item.x = 512).to_integer), a_ses)
						l_pos := -1 + 35 -- goto x
				when 18 then -- switch 1, case 8
						a_ses.item.state_msg
						l_pos := -1 + 35 -- goto x
				when 19 then -- switch 1, case 19
						a_ses.item.head_msg
						l_pos := -1 + 35 -- goto x
				when 20 then -- switch 1, case 42
						a_ses.item.ds.images := (not (a_ses.item.ds.images).to_boolean).to_integer
						a_ses.item.html_interpret
						a_ses.item.draw_formatted
						l_pos := -1 + 35 -- goto x
				when 21 then -- switch 1, case 43
						a_ses.item.ds.tables := (not (a_ses.item.ds.tables).to_boolean).to_integer
						a_ses.item.html_interpret
						a_ses.item.draw_formatted
						l_pos := -1 + 35 -- goto x
				when 22 then -- switch 1, case 44
						a_ses.item.toggle (a_ses.item.screen, 0)
						l_pos := -1 + 35 -- goto x
				when 23 then -- switch 1, case 26;
						(a_ses.item.term).item.open_in_new_window (send_open_new_xterm_address, a_ses)
						l_pos := -1 + 35 -- goto x
				when 24 then -- switch 1, case 27;
						(a_ses.item.term).item.open_in_new_window (send_open_in_new_xterm_address, a_ses)
						l_pos := -1 + 35 -- goto x
				when 25 then -- switch 1, default:
						if a_ev.item.x = 512 then
							l_pos := -1 + 17 -- goto quit
						end
				when 26 then
						if not (((a_ev.item.y).bit_and (4)).to_boolean) then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						a_ev.item.y := (a_ev.item.y).bit_and ((-5))
						a_ses.item.activate_bfu_technology (-1)
						l_m := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast ((a_ses.item.term).item.windows.next);
						(l_m.item.handler).call ([l_m, a_ev, 0])
						if ((a_ses.item.term).item.windows.next).is_equal (l_m) then
							l_m.item.delete_window
						else
							l_pos := -1 + 35 -- goto x
						end
				when 28 then
						a_ev.item.y := (a_ev.item.y).bit_or ((4))
				when 29 then -- switch 1, done: | if done | if done
					if l_return then
						l_pos := -1 + 34 -- skip if block
					end
				when 30 then -- if:
						if a_ev.item.ev /= 2 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if a_ev.item.y = 0 then
							if ((a_ev.item.b).bit_and (12)) = 0 then
								a_ses.item.activate_bfu_technology (-1)
								l_m___0 := create {CE_CLASS_POINTER [PD_WINDOW]}.make_cast ((a_ses.item.term).item.windows.next);
								(l_m___0.item.handler).call ([l_m___0, a_ev, 0])
								l_pos := -1 + 35 -- goto x
							end
						end
				when 32 then
						a_ses.item.do_mouse_event (a_ev)
				when 33 then -- if done
						l_return := True
				when 34 then -- if done
					if l_return then
						l_pos := -1 + 36 -- skip if block
					end
				when 35 then -- if: | x:
						a_ses.item.kbdprefix.rep := 0
				when 36 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	send_enter (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_ev: CE_ARRAY [PD_EVENT]
		do
			create {CE_CLASS_ARRAY [PD_EVENT]} l_ev.make (<<1>>)

			l_ev.item.ev := 1
			l_ev.item.x := 256
			l_ev.item.y := 0
			l_ev.item.b := 0
			send_event (a_ses, l_ev)
		end

	send_download_image (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_ses.is_void
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_fd := (a_ses.item.current_frame)
			if l_fd.is_void then
				l_return := True
			end
			if not l_return and then ((l_fd.item.vs).item.current_link = -1) then
				l_return := True
			end
			if not l_return then
				if (not (a_ses.item.dn_url).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_337, create {CE_VOID_POINTER}.make_cast (a_ses.item.dn_url))
				end
				l_tmp___0 := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_338, ((l_fd.item.f_data).item.links + (l_fd.item.vs).item.current_link).item.where_img)
				a_ses.item.dn_url := l_tmp___0
				if (not l_tmp___0.is_void) then
					a_ses.item.query_file (a_ses.item.dn_url, (create {PD_SESSION_STATIC}).start_download_address, create {CE_ROUTINE}.make_shared (default_pointer))
				end
			end
		end

	send_download (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_ses.is_void
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_fd := (a_ses.item.current_frame)
			if l_fd.is_void then
				l_return := True
			end
			if not l_return and then ((l_fd.item.vs).item.current_link = -1) then
				l_return := True
			end
			if not l_return then
				if (not (a_ses.item.dn_url).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_347, create {CE_VOID_POINTER}.make_cast (a_ses.item.dn_url))
				end
				l_tmp___0 := get_link_url (a_ses, l_fd, (l_fd.item.f_data).item.links + (l_fd.item.vs).item.current_link)
				a_ses.item.dn_url := l_tmp___0
				if (not l_tmp___0.is_void) then
					a_ses.item.query_file (a_ses.item.dn_url, (create {PD_SESSION_STATIC}).start_download_address, create {CE_ROUTINE}.make_shared (default_pointer))
				end
			end
		end

	send_open_in_new_xterm (a_term: CE_POINTER [PD_TERMINAL]; a_open_window: CE_ROUTINE; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_ses.is_void
		local
			l_fd: CE_POINTER [PD_F_DATA_C]
			l_enc_url: CE_POINTER [NATURAL_8]
			l_path: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			l_fd := (a_ses.item.current_frame)
			if l_fd.is_void then
				l_return := True
			end
			if not l_return and then ((l_fd.item.vs).item.current_link = -1) then
				l_return := True
			end
			if not l_return then
				if (not (a_ses.item.dn_url).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_358, create {CE_VOID_POINTER}.make_cast (a_ses.item.dn_url))
				end
				l_tmp___2 := get_link_url (a_ses, l_fd, (l_fd.item.f_data).item.links + (l_fd.item.vs).item.current_link)
				a_ses.item.dn_url := l_tmp___2
				if (not l_tmp___2.is_void) then
					l_enc_url := ((create {P_SESSION_STATIC}).encode_url (a_ses.item.dn_url))
					l_path := ((create {P_OS_DEP_STATIC}).escape_path ((create {P_LINKS_STATIC}).path_to_exe.item))
					a_open_window.call ([a_term, l_path, l_enc_url]);
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_363, create {CE_VOID_POINTER}.make_cast (l_enc_url));
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_364, create {CE_VOID_POINTER}.make_cast (l_path))
				end
			end
		end

	send_open_new_xterm (a_term: CE_POINTER [PD_TERMINAL]; a_open_window: CE_ROUTINE; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_open_window.is_void
			not a_ses.is_void
		local
			l_l: CE_ARRAY [INTEGER_32]
			l_path: CE_POINTER [NATURAL_8]
		do
			create {CE_INTEGER_32_ARRAY} l_l.make (<<1>>)

			if (not (a_ses.item.dn_url).is_void) then
				(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_372, create {CE_VOID_POINTER}.make_cast (a_ses.item.dn_url))
			end
			a_ses.item.dn_url := (create {P_LINKS_STATIC}).init_str_x (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_373)
			l_l.item := 0;
			(create {P_LINKS_STATIC}).add_to_str (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("dn_url")), l_l, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("-base-session ")));
			(create {P_LINKS_STATIC}).add_num_to_str (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("dn_url")), l_l, (a_ses.item.id).to_integer_32)
			l_path := (create {P_OS_DEP_STATIC}).escape_path ((create {P_LINKS_STATIC}).path_to_exe.item)
			a_open_window.call ([a_term, l_path, a_ses.item.dn_url]);
			(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_379, create {CE_VOID_POINTER}.make_cast (l_path))
		end

	save_as (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_ses.is_void
		local
			l_l: CE_POINTER [PD_LOCATION]
			l_tmp: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
		do
			if (a_ses.item.history.next).is_equal (create {CE_CLASS_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
				l_return := True
			end
			if not l_return then
				l_l := create {CE_CLASS_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)
				if (not (a_ses.item.dn_url).is_void) then
					(create {P_ERROR_STATIC}).debug_mem_free (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_441, create {CE_VOID_POINTER}.make_cast (a_ses.item.dn_url))
				end
				l_tmp := (create {P_LINKS_STATIC}).debug_stracpy (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("view.c")), 2_442, l_l.item.vs.url)
				a_ses.item.dn_url := l_tmp
				if (not l_tmp.is_void) then
					a_ses.item.query_file (a_ses.item.dn_url, (create {PD_SESSION_STATIC}).start_download_address, create {CE_ROUTINE}.make_shared (default_pointer))
				end
			end
		end

	menu_save_formatted (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		require
			not a_ses.is_void
		local
			l_f: CE_POINTER [PD_F_DATA_C]
			l_return: BOOLEAN
		do
			l_f := a_ses.item.current_frame
			if (not l_f.is_void) then
				if (l_f.item.f_data).is_void then
					l_return := True
				end
			else
				l_return := True
			end
			if not l_return then
				a_ses.item.query_file ((l_f.item.vs).item.url, (create {PD_SESSION_STATIC}).save_formatted_address, create {CE_ROUTINE}.make_shared (default_pointer))
			end
		end

feature {ANY} -- routine addresses

	page_up_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent page_up)
		end

	up_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent up)
		end

	scroll_dirty_workaround_for_name_clash_with_libraries_on_macos_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent scroll_dirty_workaround_for_name_clash_with_libraries_on_macos)
		end

	hscroll_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent hscroll)
		end

	home_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent home)
		end

	x_end_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent x_end)
		end

	selected_item_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent selected_item)
		end

	send_enter_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent send_enter)
		end

	send_download_image_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent send_download_image)
		end

	send_download_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent send_download)
		end

	send_open_in_new_xterm_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent send_open_in_new_xterm)
		end

	send_open_new_xterm_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent send_open_new_xterm)
		end

	save_as_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent save_as)
		end

	menu_save_formatted_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent menu_save_formatted)
		end

end
