class
	PD_CONV_TABLE

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create u.make
		end

feature {ANY} -- fields

	t: INTEGER_32 assign set_t

	u: PD_U assign set_u

feature {ANY} -- field setters

	set_t (a_t: INTEGER_32)
		do
			t := a_t
			update_memory_field ("t")
		end

	set_u (a_u: PD_U)
		do
			u := a_u
			update_memory_field ("u")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			t := a_other.t
			u := a_other.u.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				t = a_other.t and
				u.is_equal (a_other.u)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("t"),
					create {CE_STRUCTURE_FIELD}.make ("u")
				>>)
			init_structure_info
		end

end
