class
	PD_ROMAN_TBL

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} s.make
		end

feature {ANY} -- fields

	n: NATURAL_16 assign set_n

	s: CE_POINTER [INTEGER_8] assign set_s

feature {ANY} -- field setters

	set_n (a_n: NATURAL_16)
		do
			n := a_n
			update_memory_field ("n")
		end

	set_s (a_s: CE_POINTER [INTEGER_8])
		do
			s := a_s
			update_memory_field ("s")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			n := a_other.n
			s := a_other.s
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				n = a_other.n and
				s.is_equal (a_other.s)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("n"),
					create {CE_STRUCTURE_FIELD}.make ("s")
				>>)
			init_structure_info
		end

end
