class
	P_MAIN_STATIC

inherit
	CE_UTILITIES
	S_STRING_STATIC
	S_STDIO_STATIC
	S_TIME_STATIC
	S_UNISTD_STATIC
	S_STDLIB_STATIC
	S_LIBINTL_STATIC
	S_SIGNAL_STATIC
	S_LOCALE_STATIC
	S_GTK_GTK_STATIC
	S_SYS_TIME_STATIC

feature {ANY} -- public attributes

	prev_timeval: CE_STATIC [CE_ARRAY [SD_TIMEVAL]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [SD_TIMEVAL]}.make (<<1>>)
		end

	start: CE_STATIC [CE_ARRAY [SD_TIMEVAL]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [SD_TIMEVAL]}.make (<<1>>)
		end

feature {ANY} -- public routines

	main (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_params: CE_ARRAY [PD_MPARM_T]
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_MPARM_T]} l_params.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
					(create {P_OS_UNIX_STATIC}).mch_early_init
					memset (create {CE_VOID_POINTER}.make_cast (l_params), 0, (create {PD_MPARM_T}.make).structure_size.to_natural_32).do_nothing
					l_params.item.argc := a_argc
					l_params.item.argv := a_argv
					l_params.item.want_full_screen := 1
					l_params.item.use_debug_break_level := -1
					l_params.item.window_count := -1
					l_i___0 := 1
					from
					until
						not (not (l_break) and then (l_i___0 < a_argc))
					loop
						l_break := False
						if (strcasecmp (a_argv[l_i___0], ce_string ("--startuptime"))) = 0 then
							if l_i___0 + 1 < a_argc then
								(create {P_GLOBALS_STATIC}).time_fd.item := fopen (a_argv[(l_i___0 + 1)], ce_string ("a"))
								if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
									time_msg (ce_string ("--- VIM STARTING ---"), create {CE_VOID_POINTER}.make_shared (default_pointer))
								end
								l_break := True
							end
						end
						if not (l_break) then
							l_i___0 := l_i___0 + 1
						end
					end
					l_break := False;
					(create {P_GLOBALS_STATIC}).starttime.item := time (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer));
					(create {P_MBYTE_STATIC}).mb_init.do_nothing;
					(create {P_EVAL_STATIC}).eval_init;
					(create {P_NORMAL_STATIC}).init_normal_cmds;
					(create {P_GLOBALS_STATIC}).IObuff.item := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 1_025)
					if ((create {P_GLOBALS_STATIC}).IObuff.item).is_void then
						(create {P_OS_UNIX_STATIC}).mch_exit (0)
					else
						(create {P_GLOBALS_STATIC}).NameBuff.item.item := (create {P_MISC2_STATIC}).alloc ({NATURAL_32} 4_096)
						if ((create {P_GLOBALS_STATIC}).NameBuff.item.item).is_void then
							(create {P_OS_UNIX_STATIC}).mch_exit (0)
						end
					end
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("Allocated generic buffers"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					init_locale
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("locale set"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					(create {P_GUI_STATIC}).gui.item.item.dofork := 1
					l_params.item.early_arg_scan;
					(create {P_GUI_STATIC}).gui_prepare (create {CE_INTEGER_32_POINTER}.make_shared (l_params.item.c_pointer + (create {PD_MPARM_T}.make).offset_of ("argc")), l_params.item.argv)
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("GUI prepared"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					(create {P_UI_STATIC}).clip_init (0)
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("clipboard setup"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					l_params.item.stdout_isatty := (((create {P_OS_UNIX_STATIC}).mch_check_win (l_params.item.argc, l_params.item.argv)) /= 0).to_integer
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("window checked"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					if ((create {P_WINDOW_STATIC}).win_alloc_first) = 0 then
						(create {P_OS_UNIX_STATIC}).mch_exit (0)
					end
					(create {P_OPS_STATIC}).init_yank;
					(create {P_EX_DOCMD_STATIC}).alist_init ((create {P_GLOBALS_STATIC}).global_alist.item);
					(create {P_MISC1_STATIC}).init_homedir;
					(create {P_OPTION_STATIC}).set_init_1
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("inits 1"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					(create {P_EX_CMDS2_STATIC}).set_lang_var
					l_params.item.exec_on_server
					l_params.item.parse_command_name
					l_params.item.command_line_scan
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("parsing arguments"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					if ((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean then
						if ((create {P_GUI_STATIC}).gui_init_check) = 0 then
							(create {P_GUI_STATIC}).gui.item.item.starting := 0
							if (l_params.item.evim_mode).to_boolean then
								(create {P_OS_UNIX_STATIC}).mch_exit (1)
							end
						end
					end
					if (create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_len > 0 then
						l_fname := (create {CE_CLASS_POINTER [PD_ARGENTRY]}.make_cast ((create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_data) + 0).item.alist_name
					end
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("expanding arguments"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					if (l_params.item.diff_mode).to_boolean then
						if l_params.item.window_count = -1 then
							l_params.item.window_count := 0
						end
					end
					(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := (create {P_GLOBALS_STATIC}).RedrawingDisabled.item + 1
					if ((create {P_GLOBALS_STATIC}).recoverymode.item).to_boolean then
						if l_fname.is_void then
							l_params.item.want_full_screen := 0
						end
					end
					if ((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean then
						if not (isatty (2)).to_boolean then
							l_params.item.want_full_screen := 0
						end
					end
					(create {P_OS_UNIX_STATIC}).mch_init
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("shell init"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					if not ((create {P_GLOBALS_STATIC}).x_no_connect.item).to_boolean then
						l_p___0 := (getenv (ce_string ("SESSION_MANAGER")))
						if not l_p___0.is_void then
							if (l_p___0[0]).to_integer_32 /= 0 then
								(create {P_OS_UNIX_STATIC}).xsmp_init
								if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
									time_msg (ce_string ("xsmp init"), create {CE_VOID_POINTER}.make_shared (default_pointer))
								end
							end
						end
					end
					check_tty (l_params)
					if (create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_len > 1 then
						if not ((create {P_GLOBALS_STATIC}).silent_mode.item).to_boolean then
							printf ([(gettext (ce_string ("%%d files to edit%N"))), (create {P_GLOBALS_STATIC}).global_alist.item.item.al_ga.ga_len]).do_nothing
						end
					end
					if (l_params.item.want_full_screen).to_boolean then
						if not ((create {P_GLOBALS_STATIC}).silent_mode.item).to_boolean then
							(create {P_TERM_STATIC}).termcapinit (l_params.item.term);
							(create {P_SCREEN_STATIC}).screen_start
							if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
								time_msg (ce_string ("Termcap init"), create {CE_VOID_POINTER}.make_shared (default_pointer))
							end
						end
					end
					(create {P_UI_STATIC}).ui_get_shellsize.do_nothing;
					(create {P_WINDOW_STATIC}).win_init_size
					if (l_params.item.diff_mode).to_boolean then
						((create {P_GLOBALS_STATIC}).firstwin.item).item.diff_win_options (0)
					end
					(create {P_GLOBALS_STATIC}).cmdline_row.item := ((create {P_GLOBALS_STATIC}).Rows.item.item - (create {P_OPTION_STATIC}).p_ch.item.item).to_integer_32;
					(create {P_GLOBALS_STATIC}).msg_row.item := (create {P_GLOBALS_STATIC}).cmdline_row.item;
					(create {P_SCREEN_STATIC}).screenalloc (0);
					(create {P_OPTION_STATIC}).set_init_2
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("inits 2"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					(create {P_GLOBALS_STATIC}).msg_scroll.item := 1;
					(create {P_GLOBALS_STATIC}).no_wait_return.item := 1;
					(create {P_GETCHAR_STATIC}).init_mappings;
					(create {P_SYNTAX_STATIC}).init_highlight (1, 0)
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("init highlight"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					(create {P_GLOBALS_STATIC}).debug_break_level.item := l_params.item.use_debug_break_level
					l_params.item.exe_pre_commands
					l_params.item.source_startup_scripts
					if ((create {P_OPTION_STATIC}).p_lpl.item.item).to_boolean then
						(create {P_EX_CMDS2_STATIC}).source_runtime (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("plugin/**/*.vim")), 1).do_nothing
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							time_msg (ce_string ("loading plugins"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						end
					end
					if (l_params.item.diff_mode).to_boolean then
						if l_params.item.window_layout = 0 then
							if ((create {P_DIFF_STATIC}).diffopt_horizontal).to_boolean then
								l_params.item.window_layout := 1
							else
								l_params.item.window_layout := 2
							end
						end
					end
					if ((create {P_GLOBALS_STATIC}).recoverymode.item).to_boolean then
						if l_fname.is_void then
							(create {P_MEMLINE_STATIC}).recover_names (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 1, 0, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing;
							(create {P_OS_UNIX_STATIC}).mch_exit (0)
						end
					end
					(create {P_OPTION_STATIC}).set_init_3
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("inits 3"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					if (l_params.item.no_swap_file).to_boolean then
						(create {P_OPTION_STATIC}).p_uc.item.item := 0
					end
					if ((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean then
						if ((create {P_GLOBALS_STATIC}).did_emsg.item).to_boolean then
							putchar (('%N').code).do_nothing
						elseif ((create {P_GLOBALS_STATIC}).msg_didout.item).to_boolean then
							putchar (('%N').code).do_nothing
						end
						(create {P_GUI_STATIC}).gui_start
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							time_msg (ce_string ("starting GUI"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						end
						if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							if (l_params.item.evim_mode).to_boolean then
								(create {P_OS_UNIX_STATIC}).mch_exit (1)
							end
						end
					end
					if ((create {P_OPTION_STATIC}).p_viminfo.item.item.item).to_integer_32 /= 0 then
						(create {P_EX_CMDS_STATIC}).read_viminfo (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 9).do_nothing
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							time_msg (ce_string ("reading viminfo"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						end
					end
					if l_params.item.edit_type = 4 then
						if not (l_params.item.use_ef).is_void then
							(create {P_OPTION_STATIC}).set_string_option_direct (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("ef")), -1, l_params.item.use_ef, 1, -3)
						end
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, ce_string ("cfile %%s"), (create {P_OPTION_STATIC}).p_ef.item.item]).do_nothing
						if ((create {P_QUICKFIX_STATIC}).qf_init (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), (create {P_OPTION_STATIC}).p_ef.item.item, (create {P_OPTION_STATIC}).p_efm.item.item, 1, (create {P_GLOBALS_STATIC}).IObuff.item)) < 0 then
							(create {P_TERM_STATIC}).out_char ((('%N').code).to_natural_32);
							(create {P_OS_UNIX_STATIC}).mch_exit (3)
						end
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							time_msg (ce_string ("reading errorfile"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						end
					end
					(create {P_GLOBALS_STATIC}).starting.item := 1;
					(create {P_GLOBALS_STATIC}).no_wait_return.item := 0
					if not ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
						(create {P_GLOBALS_STATIC}).msg_scroll.item := 0
					end
					if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
						(create {P_GUI_STATIC}).gui_wait_for_chars (50).do_nothing
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							time_msg (ce_string ("GUI delay"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						end
					end
					if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
						(create {P_OS_UNIX_STATIC}).setup_term_clip
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							time_msg (ce_string ("setup clipboard"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						end
					end
					l_params.item.prepare_server
					if l_params.item.edit_type = 2 then
						if not ((create {P_GLOBALS_STATIC}).recoverymode.item).to_boolean then
							read_stdin
						end
					end
					if not (((create {P_GLOBALS_STATIC}).did_emsg.item).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (((create {P_GLOBALS_STATIC}).msg_didout.item).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (((create {P_TERM_STATIC}).term_strings.item[33]).item).to_integer_32 /= 0 then
							(create {P_GLOBALS_STATIC}).newline_on_exit.item := 1
						end
				when 5 then -- if done;
					(create {P_TERM_STATIC}).settmode (2)
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("setting raw mode"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					if not (((create {P_GLOBALS_STATIC}).need_wait_return.item).to_boolean) then
						l_pos := -1 + 8 -- skip if block
					end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L___0
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 8 then -- else:
						if not (((create {P_GLOBALS_STATIC}).msg_didany.item).to_boolean) then
							l_pos := -1 + 10 -- skip if block
						end
				when 9 then -- if: | _L___0:;
						(create {P_MESSAGE_STATIC}).wait_return (1)
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							time_msg (ce_string ("waiting for return"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						end
				when 10 then -- if done;
					(create {P_TERM_STATIC}).starttermcap
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("start termcap"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					(create {P_TERM_STATIC}).setmouse
					if ((create {P_GLOBALS_STATIC}).scroll_region.item).to_boolean then
						(create {P_TERM_STATIC}).scroll_region_reset
					end
					(create {P_TERM_STATIC}).scroll_start
					if not (((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean) then
						l_pos := -1 + 13 -- skip if block
					end
				when 11 then -- if:
						if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
							(create {P_GLOBALS_STATIC}).must_redraw.item := 50
						else
							l_pos := -1 + 13 -- goto _L___1
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else: | _L___1:;
						(create {P_SCREEN_STATIC}).screenclear
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							time_msg (ce_string ("clearing screen"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						end
				when 14 then
					if (l_params.item.ask_for_key).to_boolean then
						(create {P_BLOWFISH_STATIC}).blowfish_self_test.do_nothing;
						(create {P_MISC2_STATIC}).get_crypt_key (1, 1).do_nothing
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							time_msg (ce_string ("getting crypt key"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						end
					end
					(create {P_GLOBALS_STATIC}).no_wait_return.item := 1
					l_params.item.create_windows
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("opening buffers"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					(create {P_EVAL_STATIC}).set_vim_var_string (47, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), -1)
					if ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
						(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
					end
					(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFENTER, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("BufEnter autocommands"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					(create {P_MARK_STATIC}).setpcmark
					if l_params.item.edit_type = 4 then
						(create {P_QUICKFIX_STATIC}).qf_jump (create {CE_CLASS_POINTER [PD_QF_INFO_S]}.make_shared (default_pointer), 0, 0, 0)
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							time_msg (ce_string ("jump to first error"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						end
					end
					l_params.item.edit_buffers
					if (l_params.item.diff_mode).to_boolean then
						l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
						from
						until
							l_wp___0.is_void
						loop
							l_wp___0.item.diff_win_options (1)
							l_wp___0 := l_wp___0.item.w_next
						end
					end
					(create {P_FILEIO_STATIC}).shorten_fnames (0)
					if not (l_params.item.tagname).is_void then
						(create {P_GLOBALS_STATIC}).swap_exists_did_quit.item := 0;
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).IObuff.item), (1_025).to_natural_32, ce_string ("ta %%s"), l_params.item.tagname]).do_nothing;
						(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd ((create {P_GLOBALS_STATIC}).IObuff.item).do_nothing
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							time_msg (ce_string ("jumping to tag"), create {CE_VOID_POINTER}.make_shared (default_pointer))
						end
						if ((create {P_GLOBALS_STATIC}).swap_exists_did_quit.item).to_boolean then
							getout (1)
						end
					end
					if l_params.item.n_commands > 0 then
						l_params.item.exe_commands
					end
					(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := 0;
					(create {P_SCREEN_STATIC}).redraw_all_later (40);
					(create {P_GLOBALS_STATIC}).no_wait_return.item := 0;
					(create {P_GLOBALS_STATIC}).starting.item := 0;
					(create {P_TERM_STATIC}).may_req_termresponse
					if ((create {P_OPTION_STATIC}).p_im.item.item).to_boolean then
						(create {P_GLOBALS_STATIC}).need_start_insertmode.item := 1
					end
					(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_VIMENTER, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("VimEnter autocommands"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_diff).to_boolean then
						if ((create {P_GLOBALS_STATIC}).curwin.item.item.w_onebuf_opt.wo_scb).to_boolean then
							(create {P_MOVE_STATIC}).update_topline;
							(create {P_NORMAL_STATIC}).check_scrollbind ((0).to_integer_32, 0)
							if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
								time_msg (ce_string ("diff scrollbinding"), create {CE_VOID_POINTER}.make_shared (default_pointer))
							end
						end
					end
					if not ((create {P_GLOBALS_STATIC}).first_tabpage.item.item.tp_next).is_void then
						(create {P_TERM_STATIC}).out_flush;
						(create {P_GUI_STATIC}).gui_init_which_components (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer));
						(create {P_GUI_STATIC}).gui_update_scrollbars (1)
					end
					(create {P_GLOBALS_STATIC}).need_mouse_correct.item := 1
					if (create {P_GLOBALS_STATIC}).restart_edit.item /= 0 then
						(create {P_GETCHAR_STATIC}).stuffcharReadbuff (-(253 + ((97).bit_shift_left (8))))
					end
					if not ((create {P_GLOBALS_STATIC}).netbeansArg.item).is_void then
						if (strncmp (ce_string ("-nb"), (create {P_GLOBALS_STATIC}).netbeansArg.item, (3).to_natural_32)) = 0 then
							(create {P_NETBEANS_STATIC}).netbeans_open ((create {P_GLOBALS_STATIC}).netbeansArg.item + 3, 1)
						end
					end
					if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
						time_msg (ce_string ("before starting main loop"), create {CE_VOID_POINTER}.make_shared (default_pointer))
					end
					main_loop (0, 0)
					Result := 0
				when 15 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	main_loop (a_cmdwin, a_noexmode: INTEGER_32)
		local
			l_oa: CE_ARRAY [PD_OPARG_S]
			l_previous_got_int: INTEGER_32
			l_tmp: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___7: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_OPARG_S]} l_oa.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_previous_got_int := 0
					if a_cmdwin.to_boolean then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if a_noexmode.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:;
						(create {P_GLOBALS_STATIC}).x_jump_env.item := create {CE_EXCEPTION}.make ($main_loop, l_pos, $l_tmp)
				when 3 then -- continue here on raising x_jump_env:
						if l_tmp.to_boolean then
							(create {P_GLOBALS_STATIC}).State.item := 1;
							(create {P_GLOBALS_STATIC}).VIsual_active.item := 0;
							(create {P_GLOBALS_STATIC}).got_int.item := 1;
							(create {P_GLOBALS_STATIC}).need_wait_return.item := 0;
							(create {P_GLOBALS_STATIC}).global_busy.item := 0;
							(create {P_GLOBALS_STATIC}).exmode_active.item := 0;
							(create {P_GLOBALS_STATIC}).skip_redraw.item := 0;
							(create {P_GLOBALS_STATIC}).RedrawingDisabled.item := 0;
							(create {P_GLOBALS_STATIC}).no_wait_return.item := 0;
							(create {P_GLOBALS_STATIC}).emsg_skip.item := 0;
							(create {P_GLOBALS_STATIC}).emsg_off.item := 0;
							(create {P_TERM_STATIC}).setmouse;
							(create {P_TERM_STATIC}).settmode (2);
							(create {P_TERM_STATIC}).starttermcap;
							(create {P_TERM_STATIC}).scroll_start;
							(create {P_SCREEN_STATIC}).redraw_later_clear
						end
				when 4 then -- if done | if done;
					(create {P_OPS_STATIC}).clear_oparg (l_oa)
				when 5 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 38 -- skip loop
					end
				when 6 then -- loop body:
						l_break := False
						if a_cmdwin.to_boolean then
							if (create {P_GLOBALS_STATIC}).cmdwin_result.item /= 0 then
								l_break := True
							end
						end
						if (l_return or l_break) then
							l_pos := -1 + 37 -- skip if block
						end
				when 7 then -- if:
						if ((create {P_GETCHAR_STATIC}).stuff_empty).to_boolean then
							(create {P_GLOBALS_STATIC}).did_check_timestamps.item := 0
							if ((create {P_GLOBALS_STATIC}).need_check_timestamps.item).to_boolean then
								(create {P_FILEIO_STATIC}).check_timestamps (0).do_nothing
							end
							if ((create {P_GLOBALS_STATIC}).need_wait_return.item).to_boolean then
								(create {P_MESSAGE_STATIC}).wait_return (0)
							end
							if ((create {P_GLOBALS_STATIC}).need_start_insertmode.item).to_boolean then
								if ((create {P_MISC1_STATIC}).goto_im).to_boolean then
									if not ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
										(create {P_GLOBALS_STATIC}).need_start_insertmode.item := 0;
										(create {P_GETCHAR_STATIC}).stuffReadbuff (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("i")));
										(create {P_GLOBALS_STATIC}).need_fileinfo.item := 0
									end
								end
							end
						end
						if not (((create {P_GLOBALS_STATIC}).got_int.item).to_boolean) then
							l_pos := -1 + 18 -- skip if block
						end
				when 8 then -- if:
						if not (a_noexmode.to_boolean) then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if:
						if ((create {P_GLOBALS_STATIC}).global_busy.item).to_boolean then
							if not ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
								if l_previous_got_int.to_boolean then
									(create {P_GLOBALS_STATIC}).exmode_active.item := 1;
									(create {P_GLOBALS_STATIC}).State.item := 1
								else
									l_pos := -1 + 11 -- goto _L___2
								end
							else
								l_pos := -1 + 11 -- goto _L___2
							end
						else
							l_pos := -1 + 11 -- goto _L___2
						end
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 11 then -- else: | _L___2:
						if ((create {P_GLOBALS_STATIC}).global_busy.item).to_boolean then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if:
						l_pos := -1 + 15 -- goto _L
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 14 then -- else:
						if ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
							l_pos := -1 + 16 -- skip if block
						end
				when 15 then -- if: | _L:
						if not ((create {P_GLOBALS_STATIC}).quit_more.item).to_boolean then
							(create {P_GETCHAR_STATIC}).vgetc.do_nothing
						end
						(create {P_GLOBALS_STATIC}).got_int.item := 0
				when 16 then -- if done | if done
						l_previous_got_int := 1
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 19
				when 18 then -- else:
						l_previous_got_int := 0
				when 19 then -- if done
						if not ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
							(create {P_GLOBALS_STATIC}).msg_scroll.item := 0
						end
						(create {P_GLOBALS_STATIC}).quit_more.item := 0
						if not (((create {P_GLOBALS_STATIC}).skip_redraw.item).to_boolean) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:;
						(create {P_GLOBALS_STATIC}).skip_redraw.item := 0
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 22 then -- else:
						if not (((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean) then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:;
						(create {P_GLOBALS_STATIC}).skip_redraw.item := 0
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 25 then -- else:
						if not (((create {P_GLOBALS_STATIC}).do_redraw.item).to_boolean) then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_pos := -1 + 29 -- goto _L___5
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 28 then -- else:
						if not (((create {P_GETCHAR_STATIC}).stuff_empty).to_boolean) then
							l_pos := -1 + 36 -- skip if block
						end
				when 29 then -- if: | _L___5:
						if ((create {P_GLOBALS_STATIC}).finish_op.item).to_boolean then
							l_pos := -1 + 35 -- skip if block
						end
				when 30 then -- if:
						if not (((create {P_FILEIO_STATIC}).has_cursormoved).to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 31 then -- if:
						if (create {P_GLOBALS_STATIC}).last_cursormoved.item.lnum /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum then
							l_pos := -1 + 34 -- skip if block
						end
				when 32 then -- if:
						if (create {P_GLOBALS_STATIC}).last_cursormoved.item.col = (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.col then
							if (create {P_GLOBALS_STATIC}).last_cursormoved.item.coladd /= (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.coladd then
								l_pos := -1 + 34 -- goto _L___4
							end
						else
							l_pos := -1 + 34 -- goto _L___4
						end
				when 33 then -- if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else: | _L___4:
						if ((create {P_FILEIO_STATIC}).has_cursormoved).to_boolean then
							(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_CURSORMOVED, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
						end
						(create {P_GLOBALS_STATIC}).last_cursormoved.item := ((create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor).twin
				when 35 then -- if done | if done
						if ((create {P_GLOBALS_STATIC}).diff_need_scrollbind.item).to_boolean then
							(create {P_NORMAL_STATIC}).check_scrollbind ((0).to_integer_32, 0);
							(create {P_GLOBALS_STATIC}).diff_need_scrollbind.item := 0
						end
						(create {P_FOLD_STATIC}).foldAdjustVisual
						if (((create {P_GLOBALS_STATIC}).curwin.item).item.hasAnyFolding).to_boolean then
							if not ((create {P_GETCHAR_STATIC}).char_avail).to_boolean then
								(create {P_FOLD_STATIC}).foldCheckClose
								if (((create {P_OPTION_STATIC}).fdo_flags.item.item).bit_and ({NATURAL_32} 1)).to_boolean then
									(create {P_FOLD_STATIC}).foldOpenCursor
								end
							end
						end
						(create {P_MOVE_STATIC}).update_topline;
						(create {P_MOVE_STATIC}).validate_cursor
						if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
							(create {P_SCREEN_STATIC}).update_curbuf (20)
						elseif ((create {P_GLOBALS_STATIC}).must_redraw.item).to_boolean then
							(create {P_SCREEN_STATIC}).update_screen (0)
						elseif ((create {P_GLOBALS_STATIC}).redraw_cmdline.item).to_boolean then
							(create {P_SCREEN_STATIC}).showmode.do_nothing
						elseif ((create {P_GLOBALS_STATIC}).clear_cmdline.item).to_boolean then
							(create {P_SCREEN_STATIC}).showmode.do_nothing
						end
						(create {P_SCREEN_STATIC}).redraw_statuslines
						if ((create {P_GLOBALS_STATIC}).need_maketitle.item).to_boolean then
							(create {P_BUFFER_STATIC}).maketitle
						end
						if not ((create {P_GLOBALS_STATIC}).keep_msg.item).is_void then
							l_p___0 := (create {P_GLOBALS_STATIC}).keep_msg.item;
							(create {P_GLOBALS_STATIC}).keep_msg.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer);
							(create {P_MESSAGE_STATIC}).msg_attr (l_p___0, (create {P_GLOBALS_STATIC}).keep_msg_attr.item).do_nothing;
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
						end
						if ((create {P_GLOBALS_STATIC}).need_fileinfo.item).to_boolean then
							(create {P_BUFFER_STATIC}).fileinfo (0, 1, 0);
							(create {P_GLOBALS_STATIC}).need_fileinfo.item := 0
						end
						(create {P_GLOBALS_STATIC}).emsg_on_display.item := 0;
						(create {P_GLOBALS_STATIC}).did_emsg.item := 0;
						(create {P_GLOBALS_STATIC}).msg_didany.item := 0;
						(create {P_MESSAGE_STATIC}).may_clear_sb_text;
						(create {P_SCREEN_STATIC}).showruler (0);
						(create {P_SCREEN_STATIC}).setcursor;
						(create {P_TERM_STATIC}).cursor_on;
						(create {P_GLOBALS_STATIC}).do_redraw.item := 0
						if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
							if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
								time_msg (ce_string ("first screen update"), create {CE_VOID_POINTER}.make_shared (default_pointer))
							end
							if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
								time_msg (ce_string ("--- VIM STARTED ---"), create {CE_VOID_POINTER}.make_shared (default_pointer))
							end
							fclose ((create {P_GLOBALS_STATIC}).time_fd.item).do_nothing;
							(create {P_GLOBALS_STATIC}).time_fd.item := create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
						end
				when 36 then -- if done | if done | if done
						if ((create {P_GLOBALS_STATIC}).need_mouse_correct.item).to_boolean then
							(create {P_GUI_STATIC}).gui_mouse_correct
						end
						(create {P_MOVE_STATIC}).update_curswant
						if not a_cmdwin.to_boolean then
							if not a_noexmode.to_boolean then
								l_tmp___7 := 1
							else
								l_tmp___7 := 0
							end
						else
							l_tmp___7 := 0
						end
						(create {P_GLOBALS_STATIC}).may_garbage_collect.item := l_tmp___7
						if ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
							if a_noexmode.to_boolean then
								l_return := True
							end
							if not l_return then
								(create {P_EX_DOCMD_STATIC}).do_exmode (((create {P_GLOBALS_STATIC}).exmode_active.item = 2).to_integer)
							end
						else
							l_oa.item.normal_cmd (1)
						end
				when 37 then -- if done
						l_pos := -1 + 5 -- back to loop condition
				when 38 then -- loop done
					if not l_return then
						l_break := False
					end
				when 39 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		rescue
			if attached {CE_EXCEPTION} (create {EXCEPTION_MANAGER}).last_exception as ex then
				if ex.routine = $main_loop then
					l_pos := ex.position + 1
					retry
				end
				ex.re_raise
			end
		end

	getout_preserve_modified (a_exitval: INTEGER_32)
		do
			signal (1, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing;
			(create {P_MEMLINE_STATIC}).ml_close_notmod;
			(create {P_MEMLINE_STATIC}).ml_sync_all (0, 0);
			(create {P_MEMLINE_STATIC}).ml_close_all (0)
			getout (a_exitval)
		end

	getout (a_exitval: INTEGER_32)
		local
			l_exitval: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_next_tp: CE_POINTER [PD_TABPAGE_S]
			l_return, l_break: BOOLEAN
		do
			l_exitval := a_exitval;
			(create {P_GLOBALS_STATIC}).exiting.item := 1
			if ((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean then
				l_exitval := l_exitval + ((create {P_GLOBALS_STATIC}).ex_exitval.item)
			end
			if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_SCREEN_STATIC}).windgoto (((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 1, 0)
			end
			(create {P_HASHTAB_STATIC}).hash_debug_results;
			(create {P_GLOBALS_STATIC}).msg_didany.item := 0
			if ((create {P_EVAL_STATIC}).get_vim_var_nr (28)) <= 1 then
				l_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
				from
				until
					not (not (l_return) and then (not l_tp.is_void))
				loop
					l_next_tp := l_tp.item.tp_next
					if l_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
						l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
					else
						l_wp___0 := l_tp.item.tp_firstwin
					end
					from
					until
						not (not (l_break) and then (not l_wp___0.is_void))
					loop
						l_break := False
						l_buf___6 := l_wp___0.item.w_buffer
						if l_buf___6.item.b_changedtick /= -1 then
							(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFWINLEAVE, l_buf___6.item.b_fname, l_buf___6.item.b_fname, 0, l_buf___6).do_nothing
							l_buf___6.item.b_changedtick := -1
							l_next_tp := (create {P_GLOBALS_STATIC}).first_tabpage.item
							l_break := True
						end
						if not (l_break) then
							l_wp___0 := l_wp___0.item.w_next
						end
					end
					l_break := False
					l_tp := l_next_tp
				end
				l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
				from
				until
					not (not (l_break) and then (not l_buf___6.is_void))
				loop
					l_break := False
					if not (l_buf___6.item.b_ml.ml_mfp).is_void then
						(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFUNLOAD, l_buf___6.item.b_fname, l_buf___6.item.b_fname, 0, l_buf___6).do_nothing
						if not ((create {P_BUFFER_STATIC}).buf_valid (l_buf___6)).to_boolean then
							l_break := True
						end
					end
					if not (l_return or l_break) then
						l_buf___6 := l_buf___6.item.b_next
					end
				end
				l_break := False;
				(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_VIMLEAVEPRE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
			end
			if ((create {P_OPTION_STATIC}).p_viminfo.item.item.item).to_integer_32 /= 0 then
				(create {P_EX_CMDS_STATIC}).write_viminfo (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0)
			end
			if ((create {P_EVAL_STATIC}).get_vim_var_nr (28)) <= 1 then
				(create {P_FILEIO_STATIC}).apply_autocmds ({PC_AUTO_EVENT}.EVENT_VIMLEAVE, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), 0, (create {P_GLOBALS_STATIC}).curbuf.item).do_nothing
			end
			if ((create {P_GLOBALS_STATIC}).did_emsg.item).to_boolean then
				(create {P_GLOBALS_STATIC}).no_wait_return.item := 0;
				(create {P_MESSAGE_STATIC}).wait_return (0)
			elseif ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				if ((create {P_GLOBALS_STATIC}).msg_didany.item).to_boolean then
					if (create {P_OPTION_STATIC}).p_verbose.item.item > 0 then
						(create {P_GLOBALS_STATIC}).no_wait_return.item := 0;
						(create {P_MESSAGE_STATIC}).wait_return (0)
					end
				end
			end
			if not ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_SCREEN_STATIC}).windgoto (((create {P_GLOBALS_STATIC}).Rows.item.item).to_integer_32 - 1, 0)
			end
			(create {P_NETBEANS_STATIC}).netbeans_end
			if ((create {P_GLOBALS_STATIC}).garbage_collect_at_exit.item).to_boolean then
				(create {P_EVAL_STATIC}).garbage_collect.do_nothing
			end
			(create {P_OS_UNIX_STATIC}).mch_exit (l_exitval)
		end

	init_locale
		local
			l_mustfree: CE_ARRAY [INTEGER_32]
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create {CE_INTEGER_32_ARRAY} l_mustfree.make (<<1>>)

			setlocale (6, ce_string ("")).do_nothing
			gtk_disable_setlocale
			setlocale (1, ce_string ("C")).do_nothing
			l_mustfree.item := 0
			l_p___0 := (create {P_MISC1_STATIC}).vim_getenv (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("VIMRUNTIME")), l_mustfree)
			if not l_p___0.is_void then
				if (l_p___0.item).to_integer_32 /= 0 then
					(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item), (4_096).to_natural_32, ce_string ("%%s/lang"), l_p___0]).do_nothing
					bindtextdomain (ce_string ("vim"), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_GLOBALS_STATIC}).NameBuff.item.item)).do_nothing
				end
			end
			if (l_mustfree.item).to_boolean then
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_p___0))
			end
			textdomain (ce_string ("vim")).do_nothing
		end

	check_tty (a_parmp: CE_POINTER [PD_MPARM_T])
		local
			l_input_isatty: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_input_isatty := (create {P_OS_UNIX_STATIC}).mch_input_isatty
					if not (((create {P_GLOBALS_STATIC}).exmode_active.item).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not l_input_isatty.to_boolean then
							(create {P_GLOBALS_STATIC}).silent_mode.item := 1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 3 then -- else:
						if not ((a_parmp.item.want_full_screen).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if (a_parmp.item.stdout_isatty).to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_input_isatty.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if not ((create {P_GUI_STATIC}).gui.item.item.starting).to_boolean then
							if not (a_parmp.item.stdout_isatty).to_boolean then
								(create {P_MESSAGE_STATIC}).mch_errmsg ((gettext (ce_string ("Vim: Warning: Output is not to a terminal%N"))))
							end
							if not l_input_isatty.to_boolean then
								(create {P_MESSAGE_STATIC}).mch_errmsg ((gettext (ce_string ("Vim: Warning: Input is not from a terminal%N"))))
							end
							(create {P_TERM_STATIC}).out_flush
							if ((create {P_GLOBALS_STATIC}).scriptin.item[0]).is_void then
								(create {P_UI_STATIC}).ui_delay (2_000, 1)
							end
							if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
								time_msg (ce_string ("Warning delay"), create {CE_VOID_POINTER}.make_shared (default_pointer))
							end
						end
				when 9 then -- if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	read_stdin
		local
			l_i___0: INTEGER_32
		do
			(create {P_GLOBALS_STATIC}).swap_exists_action.item := 1;
			(create {P_GLOBALS_STATIC}).no_wait_return.item := 1
			l_i___0 := (create {P_GLOBALS_STATIC}).msg_didany.item;
			(create {P_BUFFER_STATIC}).set_buflisted (1);
			(create {P_BUFFER_STATIC}).open_buffer (1, create {CE_CLASS_POINTER [PD_EXARG]}.make_shared (default_pointer), 0).do_nothing;
			(create {P_GLOBALS_STATIC}).no_wait_return.item := 0;
			(create {P_GLOBALS_STATIC}).msg_didany.item := l_i___0
			if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
				time_msg (ce_string ("reading stdin"), create {CE_VOID_POINTER}.make_shared (default_pointer))
			end
			check_swap_exists_action
			close (0).do_nothing;
			(create {P_GLOBALS_STATIC}).ignored.item := dup (2)
		end

	process_env (a_env: CE_POINTER [NATURAL_8]; a_is_viminit: INTEGER_32): INTEGER_32
		local
			l_initstr: CE_POINTER [NATURAL_8]
			l_save_sourcing_name: CE_POINTER [NATURAL_8]
			l_save_sourcing_lnum: INTEGER_32
			l_save_sid: INTEGER_32
			l_return: BOOLEAN
		do
			l_initstr := create {CE_NATURAL_8_POINTER}.make_cast ((getenv (create {CE_INTEGER_8_POINTER}.make_cast (a_env))))
			if not l_initstr.is_void then
				if (l_initstr.item).to_integer_32 /= 0 then
					if a_is_viminit.to_boolean then
						(create {P_OPTION_STATIC}).vimrc_found (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					end
					l_save_sourcing_name := (create {P_GLOBALS_STATIC}).sourcing_name.item
					l_save_sourcing_lnum := (create {P_GLOBALS_STATIC}).sourcing_lnum.item;
					(create {P_GLOBALS_STATIC}).sourcing_name.item := a_env;
					(create {P_GLOBALS_STATIC}).sourcing_lnum.item := (0).to_integer_32
					l_save_sid := (create {P_GLOBALS_STATIC}).current_SID.item;
					(create {P_GLOBALS_STATIC}).current_SID.item := -4;
					(create {P_EX_DOCMD_STATIC}).do_cmdline_cmd (l_initstr).do_nothing;
					(create {P_GLOBALS_STATIC}).sourcing_name.item := l_save_sourcing_name;
					(create {P_GLOBALS_STATIC}).sourcing_lnum.item := l_save_sourcing_lnum;
					(create {P_GLOBALS_STATIC}).current_SID.item := l_save_sid
					Result := 1
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	check_swap_exists_action
		do
			if (create {P_GLOBALS_STATIC}).swap_exists_action.item = 2 then
				getout (1)
			end
			(create {P_BUFFER_STATIC}).handle_swap_exists (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
		end

	time_push (a_tv_rel, a_tv_start: CE_POINTER [ANY])
		do
			(create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item := (prev_timeval.item.item).twin
			gettimeofday (prev_timeval.item, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing;
			(create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_usec := prev_timeval.item.item.tv_usec - (create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_usec;
			(create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_sec := prev_timeval.item.item.tv_sec - (create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_sec
			if (create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_usec < 0 then
				(create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_usec := (create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_usec + (1_000_000);
				(create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_sec := ((create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_sec) - 1
			end
			(create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (a_tv_start)).item := (prev_timeval.item.item).twin
		end

	time_pop (a_tp: CE_POINTER [ANY])
		do
			prev_timeval.item.item.tv_usec := prev_timeval.item.item.tv_usec - ((create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (a_tp)).item.tv_usec)
			prev_timeval.item.item.tv_sec := prev_timeval.item.item.tv_sec - ((create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (a_tp)).item.tv_sec)
			if prev_timeval.item.item.tv_usec < 0 then
				prev_timeval.item.item.tv_usec := prev_timeval.item.item.tv_usec + (1_000_000)
				prev_timeval.item.item.tv_sec := (prev_timeval.item.item.tv_sec) - 1
			end
		end

	time_diff (a_then, a_now: CE_POINTER [SD_TIMEVAL])
		require
			not a_then.is_void
			not a_now.is_void
		local
			l_usec: INTEGER_32
			l_msec: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_usec := a_now.item.tv_usec - a_then.item.tv_usec
			l_msec := (a_now.item.tv_sec - a_then.item.tv_sec) * 1_000 + l_usec // 1_000
			l_usec := l_usec \\ (1_000)
			if l_usec >= 0 then
				l_tmp := l_usec
			else
				l_tmp := l_usec + 1_000
			end
			fprintf ([(create {P_GLOBALS_STATIC}).time_fd.item, ce_string ("%%03ld.%%03ld"), l_msec, l_tmp]).do_nothing
		end

	time_msg (a_mesg: CE_POINTER [INTEGER_8]; a_tv_start: CE_POINTER [ANY])
		local
			l_now: CE_ARRAY [SD_TIMEVAL]
		do
			create {CE_CLASS_ARRAY [SD_TIMEVAL]} l_now.make (<<1>>)

			if not ((create {P_GLOBALS_STATIC}).time_fd.item).is_void then
				if not (strstr (a_mesg, ce_string ("STARTING"))).is_void then
					gettimeofday (start.item, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
					prev_timeval.item.item := (start.item.item).twin
					fprintf ([(create {P_GLOBALS_STATIC}).time_fd.item, ce_string ("%N%Ntimes in msec%N")]).do_nothing
					fprintf ([(create {P_GLOBALS_STATIC}).time_fd.item, ce_string (" clock   self+sourced   self:  sourced script%N")]).do_nothing
					fprintf ([(create {P_GLOBALS_STATIC}).time_fd.item, ce_string (" clock   elapsed:              other lines%N%N")]).do_nothing
				end
				gettimeofday (l_now, create {CE_CLASS_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
				time_diff (start.item, l_now)
				if not a_tv_start.is_void then
					fprintf ([(create {P_GLOBALS_STATIC}).time_fd.item, ce_string ("  ")]).do_nothing
					time_diff (create {CE_CLASS_POINTER [SD_TIMEVAL]}.make_cast (a_tv_start), l_now)
				end
				fprintf ([(create {P_GLOBALS_STATIC}).time_fd.item, ce_string ("  ")]).do_nothing
				time_diff (prev_timeval.item, l_now)
				prev_timeval.item.item := (l_now.item).twin
				fprintf ([(create {P_GLOBALS_STATIC}).time_fd.item, ce_string (": %%s%N"), a_mesg]).do_nothing
			end
		end

	server_to_input_buf (a_str___1: CE_POINTER [NATURAL_8])
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_ptr: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_cpo_save: CE_POINTER [NATURAL_8]
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_ptr.make (<<1>>)

			l_str___1 := a_str___1
			l_ptr.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			l_cpo_save := (create {P_OPTION_STATIC}).p_cpo.item.item;
			(create {P_OPTION_STATIC}).p_cpo.item.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("Bk"))
			l_str___1 := (create {P_TERM_STATIC}).replace_termcodes (l_str___1, l_ptr, 0, 1, 0);
			(create {P_OPTION_STATIC}).p_cpo.item.item := l_cpo_save
			if (l_ptr.item.item).to_integer_32 /= 0 then
				if (create {P_GLOBALS_STATIC}).typebuf.item.tb_maplen < (create {P_GLOBALS_STATIC}).typebuf.item.tb_len then
					(create {P_GETCHAR_STATIC}).del_typebuf ((create {P_GLOBALS_STATIC}).typebuf.item.tb_len - (create {P_GLOBALS_STATIC}).typebuf.item.tb_maplen, (create {P_GLOBALS_STATIC}).typebuf.item.tb_maplen)
				end
				(create {P_GETCHAR_STATIC}).ins_typebuf (l_str___1, -1, (create {P_GLOBALS_STATIC}).typebuf.item.tb_len, 1, 0).do_nothing;
				(create {P_GLOBALS_STATIC}).typebuf_was_filled.item := 1
			end
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_ptr.item))
		end

	eval_client_expr_to_string (a_expr: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_res: CE_POINTER [NATURAL_8]
			l_save_dbl: INTEGER_32
			l_save_ro: INTEGER_32
		do
			l_save_dbl := (create {P_GLOBALS_STATIC}).debug_break_level.item
			l_save_ro := (create {P_GLOBALS_STATIC}).redir_off.item;
			(create {P_GLOBALS_STATIC}).debug_break_level.item := -1;
			(create {P_GLOBALS_STATIC}).redir_off.item := 0;
			(create {P_GLOBALS_STATIC}).emsg_skip.item := (create {P_GLOBALS_STATIC}).emsg_skip.item + 1
			l_res := (create {P_EVAL_STATIC}).eval_to_string (a_expr, create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (default_pointer), 1);
			(create {P_GLOBALS_STATIC}).debug_break_level.item := l_save_dbl;
			(create {P_GLOBALS_STATIC}).redir_off.item := l_save_ro;
			(create {P_GLOBALS_STATIC}).emsg_skip.item := (create {P_GLOBALS_STATIC}).emsg_skip.item - 1;
			(create {P_SCREEN_STATIC}).setcursor;
			(create {P_TERM_STATIC}).out_flush
			if ((create {P_GUI_STATIC}).gui.item.item.in_use).to_boolean then
				(create {P_GUI_STATIC}).gui_update_cursor (0, 0)
			end
			Result := l_res
		end

	serverConvert (a_client_enc, a_data: CE_POINTER [NATURAL_8]; a_tofree: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		require
			not a_tofree.is_void
		local
			l_res: CE_POINTER [NATURAL_8]
			l_vimconv: CE_ARRAY [PD_VIMCONV_T]
		do
			create {CE_CLASS_ARRAY [PD_VIMCONV_T]} l_vimconv.make (<<1>>)

			l_res := a_data
			a_tofree.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if not a_client_enc.is_void then
				if not ((create {P_OPTION_STATIC}).p_enc.item.item).is_void then
					l_vimconv.item.vc_type := 0
					if (l_vimconv.item.convert_setup (a_client_enc, (create {P_OPTION_STATIC}).p_enc.item.item)) /= 0 then
						if l_vimconv.item.vc_type /= 0 then
							l_res := (create {P_MBYTE_STATIC}).string_convert (l_vimconv, a_data, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
							if l_res.is_void then
								l_res := a_data
							else
								a_tofree.item := l_res
							end
						end
					end
					l_vimconv.item.convert_setup (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)).do_nothing
				end
			end
			Result := l_res
		end

end
