class
	PD_FF_VISITED_LIST_HDR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_FF_VISITED_LIST_HDR]} ffvl_next.make
			create {CE_NATURAL_8_POINTER} ffvl_filename.make
			create {CE_CLASS_POINTER [PD_FF_VISITED]} ffvl_visited_list.make
		end

feature {ANY} -- fields

	ffvl_next: CE_POINTER [PD_FF_VISITED_LIST_HDR] assign set_ffvl_next

	ffvl_filename: CE_POINTER [NATURAL_8] assign set_ffvl_filename

	ffvl_visited_list: CE_POINTER [PD_FF_VISITED] assign set_ffvl_visited_list

feature {ANY} -- field setters

	set_ffvl_next (a_ffvl_next: CE_POINTER [PD_FF_VISITED_LIST_HDR])
		do
			ffvl_next := a_ffvl_next
			update_memory_field ("ffvl_next")
		end

	set_ffvl_filename (a_ffvl_filename: CE_POINTER [NATURAL_8])
		do
			ffvl_filename := a_ffvl_filename
			update_memory_field ("ffvl_filename")
		end

	set_ffvl_visited_list (a_ffvl_visited_list: CE_POINTER [PD_FF_VISITED])
		do
			ffvl_visited_list := a_ffvl_visited_list
			update_memory_field ("ffvl_visited_list")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ffvl_next := a_other.ffvl_next
			ffvl_filename := a_other.ffvl_filename
			ffvl_visited_list := a_other.ffvl_visited_list
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ffvl_next.is_equal (a_other.ffvl_next) and
				ffvl_filename.is_equal (a_other.ffvl_filename) and
				ffvl_visited_list.is_equal (a_other.ffvl_visited_list)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ffvl_next"),
					create {CE_STRUCTURE_FIELD}.make ("ffvl_filename"),
					create {CE_STRUCTURE_FIELD}.make ("ffvl_visited_list")
				>>)
			init_structure_info
		end

end
