class
	PD_SPELLINFO_S

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_WORDNODE_S]} si_foldroot.make
			create {CE_CLASS_POINTER [PD_WORDNODE_S]} si_keeproot.make
			create {CE_CLASS_POINTER [PD_WORDNODE_S]} si_prefroot.make
			create {CE_CLASS_POINTER [PD_SBLOCK_S]} si_blocks.make
			create {CE_CLASS_POINTER [PD_WORDNODE_S]} si_first_free.make
			create {CE_CLASS_POINTER [PD_FILE_BUFFER]} si_spellbuf.make
			create si_conv.make
			create {CE_NATURAL_8_POINTER} si_info.make
			create {CE_NATURAL_8_ARRAY} si_region_name.make (<<16>>)
			create si_rep.make
			create si_repsal.make
			create si_sal.make
			create {CE_NATURAL_8_POINTER} si_sofofr.make
			create {CE_NATURAL_8_POINTER} si_sofoto.make
			create si_commonwords.make
			create si_map.make
			create {CE_NATURAL_8_POINTER} si_midword.make
			create si_comppat.make
			create {CE_NATURAL_8_POINTER} si_compflags.make
			create {CE_NATURAL_8_POINTER} si_syllable.make
			create si_prefcond.make
			Precursor
		end

feature {ANY} -- fields

	si_foldroot: CE_POINTER [PD_WORDNODE_S] assign set_si_foldroot

	si_foldwcount: INTEGER_32 assign set_si_foldwcount

	si_keeproot: CE_POINTER [PD_WORDNODE_S] assign set_si_keeproot

	si_keepwcount: INTEGER_32 assign set_si_keepwcount

	si_prefroot: CE_POINTER [PD_WORDNODE_S] assign set_si_prefroot

	si_sugtree: INTEGER_32 assign set_si_sugtree

	si_blocks: CE_POINTER [PD_SBLOCK_S] assign set_si_blocks

	si_blocks_cnt: INTEGER_32 assign set_si_blocks_cnt

	si_compress_cnt: INTEGER_32 assign set_si_compress_cnt

	si_first_free: CE_POINTER [PD_WORDNODE_S] assign set_si_first_free

	si_free_count: INTEGER_32 assign set_si_free_count

	si_spellbuf: CE_POINTER [PD_FILE_BUFFER] assign set_si_spellbuf

	si_ascii: INTEGER_32 assign set_si_ascii

	si_add: INTEGER_32 assign set_si_add

	si_clear_chartab: INTEGER_32 assign set_si_clear_chartab

	si_region: INTEGER_32 assign set_si_region

	si_conv: PD_VIMCONV_T assign set_si_conv

	si_memtot: INTEGER_32 assign set_si_memtot

	si_verbose: INTEGER_32 assign set_si_verbose

	si_msg_count: INTEGER_32 assign set_si_msg_count

	si_info: CE_POINTER [NATURAL_8] assign set_si_info

	si_region_count: INTEGER_32 assign set_si_region_count

	si_region_name: CE_ARRAY [NATURAL_8]

	si_rep: PD_GROWARRAY assign set_si_rep

	si_repsal: PD_GROWARRAY assign set_si_repsal

	si_sal: PD_GROWARRAY assign set_si_sal

	si_sofofr: CE_POINTER [NATURAL_8] assign set_si_sofofr

	si_sofoto: CE_POINTER [NATURAL_8] assign set_si_sofoto

	si_nosugfile: INTEGER_32 assign set_si_nosugfile

	si_nosplitsugs: INTEGER_32 assign set_si_nosplitsugs

	si_followup: INTEGER_32 assign set_si_followup

	si_collapse: INTEGER_32 assign set_si_collapse

	si_commonwords: PD_HASHTABLE_S assign set_si_commonwords

	si_sugtime: INTEGER_32 assign set_si_sugtime

	si_rem_accents: INTEGER_32 assign set_si_rem_accents

	si_map: PD_GROWARRAY assign set_si_map

	si_midword: CE_POINTER [NATURAL_8] assign set_si_midword

	si_compmax: INTEGER_32 assign set_si_compmax

	si_compminlen: INTEGER_32 assign set_si_compminlen

	si_compsylmax: INTEGER_32 assign set_si_compsylmax

	si_compoptions: INTEGER_32 assign set_si_compoptions

	si_comppat: PD_GROWARRAY assign set_si_comppat

	si_compflags: CE_POINTER [NATURAL_8] assign set_si_compflags

	si_nobreak: NATURAL_8 assign set_si_nobreak

	si_syllable: CE_POINTER [NATURAL_8] assign set_si_syllable

	si_prefcond: PD_GROWARRAY assign set_si_prefcond

	si_newprefID: INTEGER_32 assign set_si_newprefID

	si_newcompID: INTEGER_32 assign set_si_newcompID

feature {ANY} -- field setters

	set_si_foldroot (a_si_foldroot: CE_POINTER [PD_WORDNODE_S])
		do
			si_foldroot := a_si_foldroot
			update_memory_field ("si_foldroot")
		end

	set_si_foldwcount (a_si_foldwcount: INTEGER_32)
		do
			si_foldwcount := a_si_foldwcount
			update_memory_field ("si_foldwcount")
		end

	set_si_keeproot (a_si_keeproot: CE_POINTER [PD_WORDNODE_S])
		do
			si_keeproot := a_si_keeproot
			update_memory_field ("si_keeproot")
		end

	set_si_keepwcount (a_si_keepwcount: INTEGER_32)
		do
			si_keepwcount := a_si_keepwcount
			update_memory_field ("si_keepwcount")
		end

	set_si_prefroot (a_si_prefroot: CE_POINTER [PD_WORDNODE_S])
		do
			si_prefroot := a_si_prefroot
			update_memory_field ("si_prefroot")
		end

	set_si_sugtree (a_si_sugtree: INTEGER_32)
		do
			si_sugtree := a_si_sugtree
			update_memory_field ("si_sugtree")
		end

	set_si_blocks (a_si_blocks: CE_POINTER [PD_SBLOCK_S])
		do
			si_blocks := a_si_blocks
			update_memory_field ("si_blocks")
		end

	set_si_blocks_cnt (a_si_blocks_cnt: INTEGER_32)
		do
			si_blocks_cnt := a_si_blocks_cnt
			update_memory_field ("si_blocks_cnt")
		end

	set_si_compress_cnt (a_si_compress_cnt: INTEGER_32)
		do
			si_compress_cnt := a_si_compress_cnt
			update_memory_field ("si_compress_cnt")
		end

	set_si_first_free (a_si_first_free: CE_POINTER [PD_WORDNODE_S])
		do
			si_first_free := a_si_first_free
			update_memory_field ("si_first_free")
		end

	set_si_free_count (a_si_free_count: INTEGER_32)
		do
			si_free_count := a_si_free_count
			update_memory_field ("si_free_count")
		end

	set_si_spellbuf (a_si_spellbuf: CE_POINTER [PD_FILE_BUFFER])
		do
			si_spellbuf := a_si_spellbuf
			update_memory_field ("si_spellbuf")
		end

	set_si_ascii (a_si_ascii: INTEGER_32)
		do
			si_ascii := a_si_ascii
			update_memory_field ("si_ascii")
		end

	set_si_add (a_si_add: INTEGER_32)
		do
			si_add := a_si_add
			update_memory_field ("si_add")
		end

	set_si_clear_chartab (a_si_clear_chartab: INTEGER_32)
		do
			si_clear_chartab := a_si_clear_chartab
			update_memory_field ("si_clear_chartab")
		end

	set_si_region (a_si_region: INTEGER_32)
		do
			si_region := a_si_region
			update_memory_field ("si_region")
		end

	set_si_conv (a_si_conv: PD_VIMCONV_T)
		do
			si_conv := a_si_conv
			update_memory_field ("si_conv")
		end

	set_si_memtot (a_si_memtot: INTEGER_32)
		do
			si_memtot := a_si_memtot
			update_memory_field ("si_memtot")
		end

	set_si_verbose (a_si_verbose: INTEGER_32)
		do
			si_verbose := a_si_verbose
			update_memory_field ("si_verbose")
		end

	set_si_msg_count (a_si_msg_count: INTEGER_32)
		do
			si_msg_count := a_si_msg_count
			update_memory_field ("si_msg_count")
		end

	set_si_info (a_si_info: CE_POINTER [NATURAL_8])
		do
			si_info := a_si_info
			update_memory_field ("si_info")
		end

	set_si_region_count (a_si_region_count: INTEGER_32)
		do
			si_region_count := a_si_region_count
			update_memory_field ("si_region_count")
		end

	set_si_rep (a_si_rep: PD_GROWARRAY)
		do
			si_rep := a_si_rep
			update_memory_field ("si_rep")
		end

	set_si_repsal (a_si_repsal: PD_GROWARRAY)
		do
			si_repsal := a_si_repsal
			update_memory_field ("si_repsal")
		end

	set_si_sal (a_si_sal: PD_GROWARRAY)
		do
			si_sal := a_si_sal
			update_memory_field ("si_sal")
		end

	set_si_sofofr (a_si_sofofr: CE_POINTER [NATURAL_8])
		do
			si_sofofr := a_si_sofofr
			update_memory_field ("si_sofofr")
		end

	set_si_sofoto (a_si_sofoto: CE_POINTER [NATURAL_8])
		do
			si_sofoto := a_si_sofoto
			update_memory_field ("si_sofoto")
		end

	set_si_nosugfile (a_si_nosugfile: INTEGER_32)
		do
			si_nosugfile := a_si_nosugfile
			update_memory_field ("si_nosugfile")
		end

	set_si_nosplitsugs (a_si_nosplitsugs: INTEGER_32)
		do
			si_nosplitsugs := a_si_nosplitsugs
			update_memory_field ("si_nosplitsugs")
		end

	set_si_followup (a_si_followup: INTEGER_32)
		do
			si_followup := a_si_followup
			update_memory_field ("si_followup")
		end

	set_si_collapse (a_si_collapse: INTEGER_32)
		do
			si_collapse := a_si_collapse
			update_memory_field ("si_collapse")
		end

	set_si_commonwords (a_si_commonwords: PD_HASHTABLE_S)
		do
			si_commonwords := a_si_commonwords
			update_memory_field ("si_commonwords")
		end

	set_si_sugtime (a_si_sugtime: INTEGER_32)
		do
			si_sugtime := a_si_sugtime
			update_memory_field ("si_sugtime")
		end

	set_si_rem_accents (a_si_rem_accents: INTEGER_32)
		do
			si_rem_accents := a_si_rem_accents
			update_memory_field ("si_rem_accents")
		end

	set_si_map (a_si_map: PD_GROWARRAY)
		do
			si_map := a_si_map
			update_memory_field ("si_map")
		end

	set_si_midword (a_si_midword: CE_POINTER [NATURAL_8])
		do
			si_midword := a_si_midword
			update_memory_field ("si_midword")
		end

	set_si_compmax (a_si_compmax: INTEGER_32)
		do
			si_compmax := a_si_compmax
			update_memory_field ("si_compmax")
		end

	set_si_compminlen (a_si_compminlen: INTEGER_32)
		do
			si_compminlen := a_si_compminlen
			update_memory_field ("si_compminlen")
		end

	set_si_compsylmax (a_si_compsylmax: INTEGER_32)
		do
			si_compsylmax := a_si_compsylmax
			update_memory_field ("si_compsylmax")
		end

	set_si_compoptions (a_si_compoptions: INTEGER_32)
		do
			si_compoptions := a_si_compoptions
			update_memory_field ("si_compoptions")
		end

	set_si_comppat (a_si_comppat: PD_GROWARRAY)
		do
			si_comppat := a_si_comppat
			update_memory_field ("si_comppat")
		end

	set_si_compflags (a_si_compflags: CE_POINTER [NATURAL_8])
		do
			si_compflags := a_si_compflags
			update_memory_field ("si_compflags")
		end

	set_si_nobreak (a_si_nobreak: NATURAL_8)
		do
			si_nobreak := a_si_nobreak
			update_memory_field ("si_nobreak")
		end

	set_si_syllable (a_si_syllable: CE_POINTER [NATURAL_8])
		do
			si_syllable := a_si_syllable
			update_memory_field ("si_syllable")
		end

	set_si_prefcond (a_si_prefcond: PD_GROWARRAY)
		do
			si_prefcond := a_si_prefcond
			update_memory_field ("si_prefcond")
		end

	set_si_newprefID (a_si_newprefID: INTEGER_32)
		do
			si_newprefID := a_si_newprefID
			update_memory_field ("si_newprefID")
		end

	set_si_newcompID (a_si_newcompID: INTEGER_32)
		do
			si_newcompID := a_si_newcompID
			update_memory_field ("si_newcompID")
		end

feature {ANY} -- public routines

	process_compflags (a_aff: CE_POINTER [PD_AFFFILE_S]; a_compflags: CE_POINTER [NATURAL_8])
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_prevp: CE_POINTER [NATURAL_8]
			l_flag: NATURAL_32
			l_ci: CE_POINTER [PD_COMPITEM_S]
			l_id: INTEGER_32
			l_len: INTEGER_32
			l_tp: CE_POINTER [NATURAL_8]
			l_key: CE_ARRAY [NATURAL_8]
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: CE_POINTER [ANY]
			l_tmp___2: NATURAL_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___6: INTEGER_32
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
			l_tmp___9: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_key.make (<<17>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_compflags))
					update_class_fields -- Current might have been changed; synchronize
					l_len := l_tmp.to_integer_32 + 1
					if not si_compflags.is_void then
						l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (si_compflags))
						update_class_fields -- Current might have been changed; synchronize
						l_len := l_len + (l_tmp___0.to_integer_32 + 1)
					end
					l_tmp___1 := ((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer))).item.getroom (l_len.to_natural_32, 0)
					update_class_fields -- Current might have been changed; synchronize
					l_p___0.item := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)
					update_class_fields -- Current might have been changed; synchronize
					if (l_p___0.item).is_void then
						l_return := True
					end
					if l_return then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						if not si_compflags.is_void then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), create {CE_INTEGER_8_POINTER}.make_cast (si_compflags)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							strcat (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item), ce_string ("/")).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
						Current.si_compflags := l_p___0.item
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_p___0.item))
						update_class_fields -- Current might have been changed; synchronize
						l_tp := l_p___0.item + l_tmp___2.to_integer_32
						l_p___0.item := a_compflags
						update_class_fields -- Current might have been changed; synchronize
				when 2 then -- loop condition:
						if not (not (l_return or l_break) and then ((l_p___0.item.item).to_integer_32 /= 0)) then
							l_pos := -1 + 17 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						l_tmp___9 := (create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/*+[]")), (l_p___0.item.item).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___9.is_void then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_tmp___3 := l_tp
						l_tp := l_tp + 1
						l_tmp___4 := l_p___0.item
						l_p___0.item := l_p___0.item + 1
						update_class_fields -- Current might have been changed; synchronize
						l_tmp___3.item := l_tmp___4.item
						update_class_fields -- Current might have been changed; synchronize
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 6 then -- else:
						l_prevp := l_p___0.item
						l_flag := (create {P_SPELL_STATIC}).get_affitem (a_aff.item.af_flagtype, l_p___0)
						update_class_fields -- Current might have been changed; synchronize
						if l_flag = {NATURAL_32} 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 7 then -- if:;
						(create {P_MISC2_STATIC}).vim_strncpy (l_key, l_prevp, ((l_p___0.item).distance (l_prevp)).to_natural_32)
						update_class_fields -- Current might have been changed; synchronize
						l_hi___1 := (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_comp"))).item.hash_find (l_key)
						update_class_fields -- Current might have been changed; synchronize
						if not ((l_hi___1.item.hi_key).is_void) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 10 then -- else:
						if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if: | _L:
						l_tmp___5 := ((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer))).item.getroom ((create {PD_COMPITEM_S}.make).structure_size.to_natural_32, 1)
						update_class_fields -- Current might have been changed; synchronize
						l_ci := create {CE_CLASS_POINTER [PD_COMPITEM_S]}.make_cast (l_tmp___5)
						if l_ci.is_void then
							l_break := True
						end
						if not (l_return or l_break) then
							strcpy (create {CE_INTEGER_8_POINTER}.make_cast ((l_ci.item.ci_key)), create {CE_INTEGER_8_POINTER}.make_cast (l_key)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_ci.item.ci_flag := l_flag
							update_class_fields -- Current might have been changed; synchronize
							from
							until
								(l_break)
							loop
								l_break := False;
								((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer))).item.check_renumber
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___6 := si_newcompID
								Current.si_newcompID := si_newcompID - 1
								update_class_fields -- Current might have been changed; synchronize
								l_id := l_tmp___6
								l_tmp___7 := (create {P_MISC2_STATIC}).vim_strchr (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("/+*[]\-^")), l_id)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp___7.is_void then
									l_break := True
								end
							end
							l_break := False
							l_ci.item.ci_newID := l_id
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (a_aff.c_pointer + (create {PD_AFFFILE_S}.make).offset_of ("af_comp"))).item.hash_add (l_ci.item.ci_key).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 13 then -- else:
						l_id := (create {CE_CLASS_POINTER [PD_COMPITEM_S]}.make_cast (l_hi___1.item.hi_key)).item.ci_newID
				when 14 then -- if done
						if not (l_return or l_break) then
							l_tmp___8 := l_tp
							l_tp := l_tp + 1
							l_tmp___8.item := l_id.to_natural_8
							update_class_fields -- Current might have been changed; synchronize
						end
				when 15 then -- if done
						if not (l_return or l_break) and then (a_aff.item.af_flagtype = 3) then
							if (l_p___0.item.item).to_integer_32 = 44 then
								l_p___0.item := l_p___0.item + 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
				when 16 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 17 then -- loop done
						l_break := False
						l_tp.item := (('%/0/').code).to_natural_8
						update_class_fields -- Current might have been changed; synchronize
				when 18 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_renumber
		do
			if si_newprefID = si_newcompID then
				if si_newcompID < 128 then
					Current.si_newprefID := 127
					update_class_fields -- Current might have been changed; synchronize
					Current.si_newcompID := 255
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	getroom (a_len: NATURAL_32; a_align: INTEGER_32): CE_POINTER [ANY]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_bl: CE_POINTER [PD_SBLOCK_S]
			l_tmp: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_bl := si_blocks
					if a_align.to_boolean then
						if not l_bl.is_void then
							l_bl.item.sb_used := (((((l_bl.item.sb_used).to_natural_32 + {PLATFORM}.Pointer_bytes.to_natural_32) - {NATURAL_32} 1)).bit_and ((({PLATFORM}.Pointer_bytes.to_natural_32 - {NATURAL_32} 1)).bit_not)).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					if not (l_bl.is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((l_bl.item.sb_used).to_natural_32 + a_len > {NATURAL_32} 16_000) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_tmp := (create {P_MISC2_STATIC}).alloc_clear ((create {PD_SBLOCK_S}.make).structure_size.to_natural_32 + {NATURAL_32} 16_000)
						update_class_fields -- Current might have been changed; synchronize
						l_bl := create {CE_CLASS_POINTER [PD_SBLOCK_S]}.make_cast (l_tmp)
						if l_bl.is_void then
							Result := (create {CE_VOID_POINTER}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							l_bl.item.sb_next := si_blocks
							update_class_fields -- Current might have been changed; synchronize
							Current.si_blocks := l_bl
							update_class_fields -- Current might have been changed; synchronize
							l_bl.item.sb_used := 0
							update_class_fields -- Current might have been changed; synchronize
							Current.si_blocks_cnt := si_blocks_cnt + 1
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then -- if done
					if not l_return then
						l_p___0 := l_bl.item.sb_data + l_bl.item.sb_used
						l_bl.item.sb_used := l_bl.item.sb_used + a_len.to_integer_32
						update_class_fields -- Current might have been changed; synchronize
						Result := (create {CE_VOID_POINTER}.make_cast (l_p___0))
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	getroom_save (a_s: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_sc: CE_POINTER [NATURAL_8]
			l_tmp: NATURAL_32
			l_tmp___0: CE_POINTER [ANY]
		do
			l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_s))
			update_class_fields -- Current might have been changed; synchronize
			l_tmp___0 := ((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer))).item.getroom (l_tmp + {NATURAL_32} 1, 0)
			update_class_fields -- Current might have been changed; synchronize
			l_sc := create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0)
			if not l_sc.is_void then
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_sc), create {CE_INTEGER_8_POINTER}.make_cast (a_s)).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_sc
		end

	wordtree_alloc: CE_POINTER [PD_WORDNODE_S]
		local
			l_tmp: CE_POINTER [ANY]
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer))).item.getroom ((create {PD_WORDNODE_S}.make).structure_size.to_natural_32, 1)
			update_class_fields -- Current might have been changed; synchronize
			Result := (create {CE_CLASS_POINTER [PD_WORDNODE_S]}.make_cast (l_tmp))
		end

	store_word (a_word: CE_POINTER [NATURAL_8]; a_flags___0, a_region: INTEGER_32; a_pfxlist: CE_POINTER [NATURAL_8]; a_need_affix: INTEGER_32): INTEGER_32
		local
			l_len: INTEGER_32
			l_tmp: NATURAL_32
			l_ct: INTEGER_32
			l_tmp___0: INTEGER_32
			l_foldword: CE_ARRAY [NATURAL_8]
			l_res: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_foldword.make (<<250>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tmp := strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_word))
					update_class_fields -- Current might have been changed; synchronize
					l_len := l_tmp.to_integer_32
					l_tmp___0 := (create {P_SPELL_STATIC}).captype (a_word, a_word + l_len)
					update_class_fields -- Current might have been changed; synchronize
					l_ct := l_tmp___0
					l_res := 1;
					(create {P_SPELL_STATIC}).spell_casefold (a_word, l_len, l_foldword, 250).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_p___0 := a_pfxlist
				when 1 then -- loop condition:
					if not (not (l_break) and then (l_res = 1)) then
						l_pos := -1 + 9 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if a_need_affix.to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 5 then -- else:
						if l_p___0.is_void then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						if l_p___0.is_void then
							l_tmp___1 := 0
						else
							l_tmp___1 := (l_p___0.item).to_integer_32
						end
						l_res := ((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer))).item.tree_add_word (l_foldword, si_foldroot, (l_ct).bit_or (a_flags___0), a_region, l_tmp___1)
						update_class_fields -- Current might have been changed; synchronize
				when 8 then -- if done | if done
						if l_p___0.is_void then
							l_break := True
						elseif (l_p___0.item).to_integer_32 = 0 then
							l_break := True
						end
						if not (l_break) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 9 then -- loop done
					l_break := False
					Current.si_foldwcount := si_foldwcount + 1
					update_class_fields -- Current might have been changed; synchronize
					if l_res /= 1 then
						l_pos := -1 + 24 -- skip if block
					end
				when 10 then -- if:
						if l_ct /= 128 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 14 -- goto _L___1
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 24
				when 13 then -- else:
						if not (((a_flags___0).bit_and (128)).to_boolean) then
							l_pos := -1 + 24 -- skip if block
						end
				when 14 then -- if: | _L___1:
						l_p___0 := a_pfxlist
				when 15 then -- loop condition:
						if not (not (l_break) and then (l_res = 1)) then
							l_pos := -1 + 23 -- skip loop
						end
				when 16 then -- loop body:
						l_break := False
						if a_need_affix.to_boolean then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 21 -- goto _L___0
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 22
				when 19 then -- else:
						if l_p___0.is_void then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						if (l_p___0.item).to_integer_32 = 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 21 then -- if: | _L___0:
						if l_p___0.is_void then
							l_tmp___2 := 0
						else
							l_tmp___2 := (l_p___0.item).to_integer_32
						end
						l_res := ((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer))).item.tree_add_word (a_word, si_keeproot, a_flags___0, a_region, l_tmp___2)
						update_class_fields -- Current might have been changed; synchronize
				when 22 then -- if done | if done
						if l_p___0.is_void then
							l_break := True
						elseif (l_p___0.item).to_integer_32 = 0 then
							l_break := True
						end
						if not (l_break) then
							l_p___0 := l_p___0 + 1
						end
						l_pos := -1 + 15 -- back to loop condition
				when 23 then -- loop done
						l_break := False
						Current.si_keepwcount := si_keepwcount + 1
						update_class_fields -- Current might have been changed; synchronize
				when 24 then -- if done | if done
					Result := l_res
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_wordnode: CE_POINTER [PD_WORDNODE_S]
		local
			l_n: CE_POINTER [PD_WORDNODE_S]
			l_tmp: CE_POINTER [ANY]
		do
			if si_first_free.is_void then
				l_tmp := ((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer))).item.getroom ((create {PD_WORDNODE_S}.make).structure_size.to_natural_32, 1)
				update_class_fields -- Current might have been changed; synchronize
				l_n := create {CE_CLASS_POINTER [PD_WORDNODE_S]}.make_cast (l_tmp)
			else
				l_n := si_first_free
				Current.si_first_free := l_n.item.wn_child
				update_class_fields -- Current might have been changed; synchronize
				memset (create {CE_VOID_POINTER}.make_cast (l_n), 0, (create {PD_WORDNODE_S}.make).structure_size.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Current.si_free_count := si_free_count - 1
				update_class_fields -- Current might have been changed; synchronize
			end
			Result := l_n
		end

	free_wordnode (a_n: CE_POINTER [PD_WORDNODE_S])
		require
			not a_n.is_void
		do
			a_n.item.wn_child := si_first_free
			update_class_fields -- Current might have been changed; synchronize
			Current.si_first_free := a_n
			update_class_fields -- Current might have been changed; synchronize
			Current.si_free_count := si_free_count + 1
			update_class_fields -- Current might have been changed; synchronize
		end

	sug_filltree (a_slang: CE_POINTER [PD_SLANG_S]): INTEGER_32
		local
			l_byts: CE_POINTER [NATURAL_8]
			l_idxs: CE_POINTER [INTEGER_32]
			l_depth___1: INTEGER_32
			l_arridx: CE_ARRAY [INTEGER_32]
			l_curi: CE_ARRAY [INTEGER_32]
			l_tword: CE_ARRAY [NATURAL_8]
			l_tsalword: CE_ARRAY [NATURAL_8]
			l_c: INTEGER_32
			l_n: INTEGER_32
			l_words_done: NATURAL_32
			l_wordcount: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_arridx.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_curi.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} l_tword.make (<<250>>)
			create {CE_NATURAL_8_ARRAY} l_tsalword.make (<<250>>)
			create {CE_INTEGER_32_ARRAY} l_wordcount.make (<<250>>)

			l_words_done := {NATURAL_32} 0
			Current.si_foldroot := ((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer))).item.wordtree_alloc
			update_class_fields -- Current might have been changed; synchronize
			if si_foldroot.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				Current.si_sugtree := 1
				update_class_fields -- Current might have been changed; synchronize
				l_byts := a_slang.item.sl_fbyts
				l_idxs := a_slang.item.sl_fidxs
				l_arridx[0] := 0
				update_class_fields -- Current might have been changed; synchronize
				l_curi[0] := 1
				update_class_fields -- Current might have been changed; synchronize
				l_wordcount[0] := 0
				update_class_fields -- Current might have been changed; synchronize
				l_depth___1 := 0
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if l_depth___1 >= 0 then
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_return or l_break) then
						if l_curi[l_depth___1] > (l_byts[(l_arridx[l_depth___1])]).to_integer_32 then
							l_idxs[(l_arridx[l_depth___1])] := l_wordcount[l_depth___1]
							update_class_fields -- Current might have been changed; synchronize
							if l_depth___1 > 0 then
								l_wordcount[l_depth___1 - 1] := l_wordcount[l_depth___1 - 1] + (l_wordcount[l_depth___1])
								update_class_fields -- Current might have been changed; synchronize
							end
							l_depth___1 := l_depth___1 - 1;
							(create {P_MISC1_STATIC}).line_breakcheck
							update_class_fields -- Current might have been changed; synchronize
						else
							l_n := l_arridx[l_depth___1] + l_curi[l_depth___1]
							l_curi[l_depth___1] := (l_curi[l_depth___1]) + 1
							update_class_fields -- Current might have been changed; synchronize
							l_c := (l_byts[l_n]).to_integer_32
							if l_c = 0 then
								l_tword[l_depth___1] := (('%/0/').code).to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								a_slang.item.spell_soundfold (l_tword, 1, l_tsalword)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp := ((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer))).item.tree_add_word (l_tsalword, si_foldroot, ((l_words_done).bit_shift_right (16)).to_integer_32, ((l_words_done).bit_and ({NATURAL_32} 65_535)).to_integer_32, 0)
								update_class_fields -- Current might have been changed; synchronize
								if l_tmp = 0 then
									Result := 0
									l_return := True
								end
								if not l_return then
									l_words_done := l_words_done + 1
									l_wordcount[l_depth___1] := (l_wordcount[l_depth___1]) + 1
									update_class_fields -- Current might have been changed; synchronize
									Current.si_blocks_cnt := 0
									update_class_fields -- Current might have been changed; synchronize
									from
									until
										(l_byts[(l_n + 1)]).to_integer_32 /= 0
									loop
										l_n := l_n + 1
										l_curi[l_depth___1] := (l_curi[l_depth___1]) + 1
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							else
								l_tmp___0 := l_depth___1
								l_depth___1 := l_depth___1 + 1
								l_tword[l_tmp___0] := l_c.to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_arridx[l_depth___1] := l_idxs[l_n]
								update_class_fields -- Current might have been changed; synchronize
								l_curi[l_depth___1] := 1
								update_class_fields -- Current might have been changed; synchronize
								l_wordcount[l_depth___1] := 0
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
				end
			end
			if not l_return then
				l_break := False
				l_tmp___1 := gettext (ce_string ("Total number of words: %%d"))
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MESSAGE_STATIC}).smsg ([create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1), l_words_done]).do_nothing
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
			end
		end

	sug_maketable: INTEGER_32
		local
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_res: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)

			l_res := 1
			Current.si_spellbuf := (create {P_SPELL_STATIC}).open_spellbuf
			update_class_fields -- Current might have been changed; synchronize
			if si_spellbuf.is_void then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_ga.item.ga_init2 (1, 100)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := sug_filltable ((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer)), si_foldroot.item.wn_sibling, 0, l_ga)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp = -1 then
					l_res := 0
				end
				l_ga.item.ga_clear
				update_class_fields -- Current might have been changed; synchronize
				Result := l_res
			end
		end

	spell_message (a_str___1: CE_POINTER [NATURAL_8])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (si_verbose.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((create {P_OPTION_STATIC}).p_verbose.item.item > 2) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if not si_verbose.to_boolean then
							(create {P_MESSAGE_STATIC}).verbose_enter
							update_class_fields -- Current might have been changed; synchronize
						end
						(create {P_MESSAGE_STATIC}).msg (a_str___1).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_TERM_STATIC}).out_flush
						update_class_fields -- Current might have been changed; synchronize
						if not si_verbose.to_boolean then
							(create {P_MESSAGE_STATIC}).verbose_leave
							update_class_fields -- Current might have been changed; synchronize
						end
				when 5 then -- if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tree_add_word (a_word: CE_POINTER [NATURAL_8]; a_root: CE_POINTER [PD_WORDNODE_S]; a_flags___0, a_region, a_affixID: INTEGER_32): INTEGER_32
		local
			l_node: CE_POINTER [PD_WORDNODE_S]
			l_np: CE_POINTER [PD_WORDNODE_S]
			l_copyp: CE_POINTER [PD_WORDNODE_S]
			l_copyprev: CE_POINTER [CE_POINTER [PD_WORDNODE_S]]
			l_prev: CE_POINTER [CE_POINTER [PD_WORDNODE_S]]
			l_i___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_node := a_root
					l_prev := create {CE_POINTER_POINTER [PD_WORDNODE_S]}.make_shared (default_pointer)
					l_i___0 := 0
				when 1 then -- loop condition:
					if (l_return or l_break) then
						l_pos := -1 + 22 -- skip loop
					end
				when 2 then -- loop body:
						l_break := False
						if not l_node.is_void then
							if l_node.item.wn_refs > 1 then
								l_node.item.wn_refs := (l_node.item.wn_refs) - 1
								update_class_fields -- Current might have been changed; synchronize
								l_copyprev := l_prev
								l_copyp := l_node
								from
								until
									not (not (l_return) and then (not l_copyp.is_void))
								loop
									l_np := ((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer))).item.get_wordnode
									update_class_fields -- Current might have been changed; synchronize
									if l_np.is_void then
										Result := 0
										l_return := True
									end
									if not l_return then
										l_np.item.wn_child := l_copyp.item.wn_child
										update_class_fields -- Current might have been changed; synchronize
										if not (l_np.item.wn_child).is_void then
											(l_np.item.wn_child).item.wn_refs := ((l_np.item.wn_child).item.wn_refs) + 1
											update_class_fields -- Current might have been changed; synchronize
										end
										l_np.item.wn_byte := l_copyp.item.wn_byte
										update_class_fields -- Current might have been changed; synchronize
										if (l_np.item.wn_byte).to_integer_32 = 0 then
											l_np.item.wn_flags := l_copyp.item.wn_flags
											update_class_fields -- Current might have been changed; synchronize
											l_np.item.wn_region := l_copyp.item.wn_region
											update_class_fields -- Current might have been changed; synchronize
											l_np.item.wn_affixID := l_copyp.item.wn_affixID
											update_class_fields -- Current might have been changed; synchronize
										end
										l_np.item.wn_refs := 1
										update_class_fields -- Current might have been changed; synchronize
										if not l_copyprev.is_void then
											l_copyprev.item := l_np
											update_class_fields -- Current might have been changed; synchronize
										end
										l_copyprev := create {CE_POINTER_POINTER [PD_WORDNODE_S]}.make_shared (l_np.c_pointer + (create {PD_WORDNODE_S}.make).offset_of ("wn_sibling"))
										if l_copyp.is_equal (l_node) then
											l_node := l_np
										end
										l_copyp := l_copyp.item.wn_sibling
									end
								end
							end
						end
						if l_return then
							l_pos := -1 + 21 -- skip if block
						end
				when 3 then -- if:
						from
						until
							(l_break)
						loop
							l_break := False
							if not l_node.is_void then
								if not ((l_node.item.wn_byte).to_integer_32 < (a_word[l_i___0]).to_integer_32) then
									if (l_node.item.wn_byte).to_integer_32 = 0 then
										if a_flags___0 < 0 then
											l_tmp___1 := ((l_node.item.wn_affixID).to_natural_32 < a_affixID.to_natural_32).to_integer
										else
											if (l_node.item.wn_flags).to_natural_32 < ((a_flags___0).bit_and (65_535)).to_natural_32 then
												l_tmp___0 := 1
											elseif (l_node.item.wn_flags).to_integer_32 = ((a_flags___0).bit_and (65_535)) then
												if si_sugtree.to_boolean then
													l_tmp := ((((l_node.item.wn_region).to_integer_32).bit_and (65_535)) < a_region).to_integer
												else
													l_tmp := ((l_node.item.wn_affixID).to_natural_32 < a_affixID.to_natural_32).to_integer
												end
												if l_tmp.to_boolean then
													l_tmp___0 := 1
												else
													l_tmp___0 := 0
												end
											else
												l_tmp___0 := 0
											end
											l_tmp___1 := l_tmp___0
										end
										if not l_tmp___1.to_boolean then
											l_break := True
										end
									else
										l_break := True
									end
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_prev := create {CE_POINTER_POINTER [PD_WORDNODE_S]}.make_shared (l_node.c_pointer + (create {PD_WORDNODE_S}.make).offset_of ("wn_sibling"))
								l_node := l_prev.item
							end
						end
						l_break := False
						if not (l_node.is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 6 then -- else:
						if (l_node.item.wn_byte).to_integer_32 = (a_word[l_i___0]).to_integer_32 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 9 then -- else:
						if (a_word[l_i___0]).to_integer_32 /= 0 then
							l_pos := -1 + 21 -- skip if block
						end
				when 10 then -- if:
						if not (a_flags___0 < 0) then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 12 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 13 then -- else:
						if not (si_sugtree.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 16 then -- else:
						if (l_node.item.wn_flags).to_integer_32 = ((a_flags___0).bit_and (65_535)) then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 19 then -- else:
						if (l_node.item.wn_affixID).to_integer_32 = a_affixID then
							l_pos := -1 + 21 -- skip if block
						end
				when 20 then -- if: | _L___0:
						l_np := ((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer))).item.get_wordnode
						update_class_fields -- Current might have been changed; synchronize
						if l_np.is_void then
							Result := 0
							l_return := True
						end
						if not l_return then
							l_np.item.wn_byte := a_word[l_i___0]
							update_class_fields -- Current might have been changed; synchronize
							if l_node.is_void then
								l_np.item.wn_refs := 1
								update_class_fields -- Current might have been changed; synchronize
							else
								l_np.item.wn_refs := l_node.item.wn_refs
								update_class_fields -- Current might have been changed; synchronize
								l_node.item.wn_refs := 1
								update_class_fields -- Current might have been changed; synchronize
							end
							if not l_prev.is_void then
								l_prev.item := l_np
								update_class_fields -- Current might have been changed; synchronize
							end
							l_np.item.wn_sibling := l_node
							update_class_fields -- Current might have been changed; synchronize
							l_node := l_np
						end
				when 21 then -- if done | if done | if done | if done | if done | if done | if done
						if not l_return then
							if (a_word[l_i___0]).to_integer_32 = 0 then
								l_node.item.wn_flags := a_flags___0.to_natural_16
								update_class_fields -- Current might have been changed; synchronize
								l_node.item.wn_region := (((l_node.item.wn_region).to_integer_32).bit_or (a_region)).to_integer_16
								update_class_fields -- Current might have been changed; synchronize
								l_node.item.wn_affixID := a_affixID.to_natural_8
								update_class_fields -- Current might have been changed; synchronize
								l_break := True
							end
							if not (l_return or l_break) then
								l_prev := create {CE_POINTER_POINTER [PD_WORDNODE_S]}.make_shared (l_node.c_pointer + (create {PD_WORDNODE_S}.make).offset_of ("wn_child"))
								l_node := l_prev.item
								l_i___0 := l_i___0 + 1
							end
						end
						l_pos := -1 + 1 -- back to loop condition
				when 22 then -- loop done
					if not l_return then
						l_break := False
						Current.si_msg_count := si_msg_count + 1
						update_class_fields -- Current might have been changed; synchronize
						if si_compress_cnt > 1 then
							Current.si_compress_cnt := si_compress_cnt - 1
							update_class_fields -- Current might have been changed; synchronize
							if si_compress_cnt = 1 then
								Current.si_blocks_cnt := si_blocks_cnt + ((create {P_SPELL_STATIC}).compress_inc.item)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						if si_compress_cnt = 1 then
							l_tmp___3 := (si_free_count < 250).to_integer
						else
							l_tmp___3 := (si_blocks_cnt >= (create {P_SPELL_STATIC}).compress_start.item).to_integer
						end
						if l_tmp___3.to_boolean then
							Current.si_blocks_cnt := si_blocks_cnt - ((create {P_SPELL_STATIC}).compress_inc.item)
							update_class_fields -- Current might have been changed; synchronize
							Current.si_compress_cnt := (create {P_SPELL_STATIC}).compress_added.item
							update_class_fields -- Current might have been changed; synchronize
							if si_verbose.to_boolean then
								(create {P_MESSAGE_STATIC}).msg_start
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___2 := gettext ((create {P_SPELL_STATIC}).msg_compressing.item)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MESSAGE_STATIC}).msg_puts (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___2))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MESSAGE_STATIC}).msg_clr_eos
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).msg_didout.item := 0
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_GLOBALS_STATIC}).msg_col.item := 0
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_TERM_STATIC}).out_flush
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_SPELL_STATIC}).wordtree_compress ((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer)), si_foldroot)
							update_class_fields -- Current might have been changed; synchronize
							if a_affixID >= 0 then
								(create {P_SPELL_STATIC}).wordtree_compress ((create {CE_CLASS_POINTER [PD_SPELLINFO_S]}.make_shared (c_pointer)), si_keeproot)
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						Result := 1
					end
				when 23 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

feature {PD_SPELLINFO_S} -- private routines

	sug_filltable (a_spin: CE_POINTER [PD_SPELLINFO_S]; a_node: CE_POINTER [PD_WORDNODE_S]; a_startwordnr: INTEGER_32; a_gap: CE_POINTER [PD_GROWARRAY]): INTEGER_32
		local
			l_p___0: CE_POINTER [PD_WORDNODE_S]
			l_np: CE_POINTER [PD_WORDNODE_S]
			l_wordnr: INTEGER_32
			l_nr: INTEGER_32
			l_prev_nr: INTEGER_32
			l_tmp___1: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_wordnr := a_startwordnr
			l_p___0 := a_node
			from
			until
				not (not (l_return) and then (not l_p___0.is_void))
			loop
				if (l_p___0.item.wn_byte).to_integer_32 = 0 then
					a_gap.item.ga_len := 0
					l_prev_nr := 0
					l_np := l_p___0
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						if not l_np.is_void then
							if (l_np.item.wn_byte).to_integer_32 /= 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_return or l_break) then
							if (a_gap.item.ga_grow (10)) = 0 then
								Result := (-1)
								l_return := True
							end
							if not l_return then
								l_nr := (((l_np.item.wn_flags).to_integer_32).bit_shift_left (16)) + (((l_np.item.wn_region).to_integer_32).bit_and (65_535))
								l_nr := l_nr - l_prev_nr
								l_prev_nr := l_prev_nr + l_nr
								a_gap.item.ga_len := a_gap.item.ga_len + (offset2bytes (l_nr, create {CE_NATURAL_8_POINTER}.make_cast (a_gap.item.ga_data) + a_gap.item.ga_len))
								l_np := l_np.item.wn_sibling
							end
						end
					end
					if not l_return then
						l_break := False
						l_tmp___1 := a_gap.item.ga_len
						a_gap.item.ga_len := (a_gap.item.ga_len) + 1
						create {CE_NATURAL_8_POINTER}.make_cast (a_gap.item.ga_data)[l_tmp___1] := (('%/0/').code).to_natural_8
						if ((a_spin.item.si_spellbuf).item.ml_append_buf (l_wordnr.to_integer_32, create {CE_NATURAL_8_POINTER}.make_cast (a_gap.item.ga_data), a_gap.item.ga_len, 1)) = 0 then
							Result := (-1)
							l_return := True
						end
					end
					if not l_return then
						l_wordnr := l_wordnr + 1
						from
						until
							(l_break)
						loop
							l_break := False
							if not (l_p___0.item.wn_sibling).is_void then
								if ((l_p___0.item.wn_sibling).item.wn_byte).to_integer_32 /= 0 then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_p___0.item.wn_sibling := (l_p___0.item.wn_sibling).item.wn_sibling
							end
						end
						l_break := False
						l_p___0.item.wn_flags := (0).to_natural_16
						l_p___0.item.wn_region := (0).to_integer_16
					end
				else
					l_wordnr := sug_filltable (a_spin, l_p___0.item.wn_child, l_wordnr, a_gap)
					if l_wordnr = -1 then
						Result := (-1)
						l_return := True
					end
				end
				if not l_return then
					l_p___0 := l_p___0.item.wn_sibling
				end
			end
			if not l_return then
				Result := l_wordnr
			end
		end

	offset2bytes (a_nr: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]): INTEGER_32
		require
			not a_buf___6.is_void
		local
			l_rem: INTEGER_32
			l_b1: INTEGER_32
			l_b2: INTEGER_32
			l_b3: INTEGER_32
			l_b4: INTEGER_32
			l_return: BOOLEAN
		do
			l_b1 := a_nr \\ 255 + 1
			l_rem := a_nr // 255
			l_b2 := l_rem \\ 255 + 1
			l_rem := l_rem // (255)
			l_b3 := l_rem \\ 255 + 1
			l_b4 := l_rem // 255 + 1
			if l_b4 > 1 then
				a_buf___6[0] := (224 + l_b4).to_natural_8
				a_buf___6[1] := l_b3.to_natural_8
				a_buf___6[2] := l_b2.to_natural_8
				a_buf___6[3] := l_b1.to_natural_8
				Result := 4
				l_return := True
			elseif l_b3 > 31 then
				a_buf___6[0] := (224 + l_b4).to_natural_8
				a_buf___6[1] := l_b3.to_natural_8
				a_buf___6[2] := l_b2.to_natural_8
				a_buf___6[3] := l_b1.to_natural_8
				Result := 4
				l_return := True
			end
			if not l_return then
				if l_b3 > 1 then
					a_buf___6[0] := (192 + l_b3).to_natural_8
					a_buf___6[1] := l_b2.to_natural_8
					a_buf___6[2] := l_b1.to_natural_8
					Result := 3
					l_return := True
				elseif l_b2 > 63 then
					a_buf___6[0] := (192 + l_b3).to_natural_8
					a_buf___6[1] := l_b2.to_natural_8
					a_buf___6[2] := l_b1.to_natural_8
					Result := 3
					l_return := True
				end
			end
			if not l_return then
				if l_b2 > 1 then
					a_buf___6[0] := (128 + l_b2).to_natural_8
					a_buf___6[1] := l_b1.to_natural_8
					Result := 2
					l_return := True
				elseif l_b1 > 127 then
					a_buf___6[0] := (128 + l_b2).to_natural_8
					a_buf___6[1] := l_b1.to_natural_8
					Result := 2
					l_return := True
				end
			end
			if not l_return then
				a_buf___6[0] := l_b1.to_natural_8
				Result := 1
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			si_foldroot := a_other.si_foldroot
			si_foldwcount := a_other.si_foldwcount
			si_keeproot := a_other.si_keeproot
			si_keepwcount := a_other.si_keepwcount
			si_prefroot := a_other.si_prefroot
			si_sugtree := a_other.si_sugtree
			si_blocks := a_other.si_blocks
			si_blocks_cnt := a_other.si_blocks_cnt
			si_compress_cnt := a_other.si_compress_cnt
			si_first_free := a_other.si_first_free
			si_free_count := a_other.si_free_count
			si_spellbuf := a_other.si_spellbuf
			si_ascii := a_other.si_ascii
			si_add := a_other.si_add
			si_clear_chartab := a_other.si_clear_chartab
			si_region := a_other.si_region
			si_conv := a_other.si_conv.twin
			si_memtot := a_other.si_memtot
			si_verbose := a_other.si_verbose
			si_msg_count := a_other.si_msg_count
			si_info := a_other.si_info
			si_region_count := a_other.si_region_count
			si_region_name := a_other.si_region_name.twin
			si_rep := a_other.si_rep.twin
			si_repsal := a_other.si_repsal.twin
			si_sal := a_other.si_sal.twin
			si_sofofr := a_other.si_sofofr
			si_sofoto := a_other.si_sofoto
			si_nosugfile := a_other.si_nosugfile
			si_nosplitsugs := a_other.si_nosplitsugs
			si_followup := a_other.si_followup
			si_collapse := a_other.si_collapse
			si_commonwords := a_other.si_commonwords.twin
			si_sugtime := a_other.si_sugtime
			si_rem_accents := a_other.si_rem_accents
			si_map := a_other.si_map.twin
			si_midword := a_other.si_midword
			si_compmax := a_other.si_compmax
			si_compminlen := a_other.si_compminlen
			si_compsylmax := a_other.si_compsylmax
			si_compoptions := a_other.si_compoptions
			si_comppat := a_other.si_comppat.twin
			si_compflags := a_other.si_compflags
			si_nobreak := a_other.si_nobreak
			si_syllable := a_other.si_syllable
			si_prefcond := a_other.si_prefcond.twin
			si_newprefID := a_other.si_newprefID
			si_newcompID := a_other.si_newcompID
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				si_foldroot.is_equal (a_other.si_foldroot) and
				si_foldwcount = a_other.si_foldwcount and
				si_keeproot.is_equal (a_other.si_keeproot) and
				si_keepwcount = a_other.si_keepwcount and
				si_prefroot.is_equal (a_other.si_prefroot) and
				si_sugtree = a_other.si_sugtree and
				si_blocks.is_equal (a_other.si_blocks) and
				si_blocks_cnt = a_other.si_blocks_cnt and
				si_compress_cnt = a_other.si_compress_cnt and
				si_first_free.is_equal (a_other.si_first_free) and
				si_free_count = a_other.si_free_count and
				si_spellbuf.is_equal (a_other.si_spellbuf) and
				si_ascii = a_other.si_ascii and
				si_add = a_other.si_add and
				si_clear_chartab = a_other.si_clear_chartab and
				si_region = a_other.si_region and
				si_conv.is_equal (a_other.si_conv) and
				si_memtot = a_other.si_memtot and
				si_verbose = a_other.si_verbose and
				si_msg_count = a_other.si_msg_count and
				si_info.is_equal (a_other.si_info) and
				si_region_count = a_other.si_region_count and
				si_region_name.is_equal (a_other.si_region_name) and
				si_rep.is_equal (a_other.si_rep) and
				si_repsal.is_equal (a_other.si_repsal) and
				si_sal.is_equal (a_other.si_sal) and
				si_sofofr.is_equal (a_other.si_sofofr) and
				si_sofoto.is_equal (a_other.si_sofoto) and
				si_nosugfile = a_other.si_nosugfile and
				si_nosplitsugs = a_other.si_nosplitsugs and
				si_followup = a_other.si_followup and
				si_collapse = a_other.si_collapse and
				si_commonwords.is_equal (a_other.si_commonwords) and
				si_sugtime = a_other.si_sugtime and
				si_rem_accents = a_other.si_rem_accents and
				si_map.is_equal (a_other.si_map) and
				si_midword.is_equal (a_other.si_midword) and
				si_compmax = a_other.si_compmax and
				si_compminlen = a_other.si_compminlen and
				si_compsylmax = a_other.si_compsylmax and
				si_compoptions = a_other.si_compoptions and
				si_comppat.is_equal (a_other.si_comppat) and
				si_compflags.is_equal (a_other.si_compflags) and
				si_nobreak = a_other.si_nobreak and
				si_syllable.is_equal (a_other.si_syllable) and
				si_prefcond.is_equal (a_other.si_prefcond) and
				si_newprefID = a_other.si_newprefID and
				si_newcompID = a_other.si_newcompID
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("si_foldroot"),
					create {CE_STRUCTURE_FIELD}.make ("si_foldwcount"),
					create {CE_STRUCTURE_FIELD}.make ("si_keeproot"),
					create {CE_STRUCTURE_FIELD}.make ("si_keepwcount"),
					create {CE_STRUCTURE_FIELD}.make ("si_prefroot"),
					create {CE_STRUCTURE_FIELD}.make ("si_sugtree"),
					create {CE_STRUCTURE_FIELD}.make ("si_blocks"),
					create {CE_STRUCTURE_FIELD}.make ("si_blocks_cnt"),
					create {CE_STRUCTURE_FIELD}.make ("si_compress_cnt"),
					create {CE_STRUCTURE_FIELD}.make ("si_first_free"),
					create {CE_STRUCTURE_FIELD}.make ("si_free_count"),
					create {CE_STRUCTURE_FIELD}.make ("si_spellbuf"),
					create {CE_STRUCTURE_FIELD}.make ("si_ascii"),
					create {CE_STRUCTURE_FIELD}.make ("si_add"),
					create {CE_STRUCTURE_FIELD}.make ("si_clear_chartab"),
					create {CE_STRUCTURE_FIELD}.make ("si_region"),
					create {CE_STRUCTURE_FIELD}.make ("si_conv"),
					create {CE_STRUCTURE_FIELD}.make ("si_memtot"),
					create {CE_STRUCTURE_FIELD}.make ("si_verbose"),
					create {CE_STRUCTURE_FIELD}.make ("si_msg_count"),
					create {CE_STRUCTURE_FIELD}.make ("si_info"),
					create {CE_STRUCTURE_FIELD}.make ("si_region_count"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("si_region_name", <<16>>),
					create {CE_STRUCTURE_FIELD}.make ("si_rep"),
					create {CE_STRUCTURE_FIELD}.make ("si_repsal"),
					create {CE_STRUCTURE_FIELD}.make ("si_sal"),
					create {CE_STRUCTURE_FIELD}.make ("si_sofofr"),
					create {CE_STRUCTURE_FIELD}.make ("si_sofoto"),
					create {CE_STRUCTURE_FIELD}.make ("si_nosugfile"),
					create {CE_STRUCTURE_FIELD}.make ("si_nosplitsugs"),
					create {CE_STRUCTURE_FIELD}.make ("si_followup"),
					create {CE_STRUCTURE_FIELD}.make ("si_collapse"),
					create {CE_STRUCTURE_FIELD}.make ("si_commonwords"),
					create {CE_STRUCTURE_FIELD}.make ("si_sugtime"),
					create {CE_STRUCTURE_FIELD}.make ("si_rem_accents"),
					create {CE_STRUCTURE_FIELD}.make ("si_map"),
					create {CE_STRUCTURE_FIELD}.make ("si_midword"),
					create {CE_STRUCTURE_FIELD}.make ("si_compmax"),
					create {CE_STRUCTURE_FIELD}.make ("si_compminlen"),
					create {CE_STRUCTURE_FIELD}.make ("si_compsylmax"),
					create {CE_STRUCTURE_FIELD}.make ("si_compoptions"),
					create {CE_STRUCTURE_FIELD}.make ("si_comppat"),
					create {CE_STRUCTURE_FIELD}.make ("si_compflags"),
					create {CE_STRUCTURE_FIELD}.make ("si_nobreak"),
					create {CE_STRUCTURE_FIELD}.make ("si_syllable"),
					create {CE_STRUCTURE_FIELD}.make ("si_prefcond"),
					create {CE_STRUCTURE_FIELD}.make ("si_newprefID"),
					create {CE_STRUCTURE_FIELD}.make ("si_newcompID")
				>>)
			init_structure_info
		end

end
