class
	PD_TAGNAME_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} tn_tags.make
			create {CE_NATURAL_8_POINTER} tn_np.make
			create {CE_VOID_POINTER} tn_search_ctx.make
			Precursor
		end

feature {ANY} -- fields

	tn_tags: CE_POINTER [NATURAL_8] assign set_tn_tags

	tn_np: CE_POINTER [NATURAL_8] assign set_tn_np

	tn_did_filefind_init: INTEGER_32 assign set_tn_did_filefind_init

	tn_hf_idx: INTEGER_32 assign set_tn_hf_idx

	tn_search_ctx: CE_POINTER [ANY] assign set_tn_search_ctx

feature {ANY} -- field setters

	set_tn_tags (a_tn_tags: CE_POINTER [NATURAL_8])
		do
			tn_tags := a_tn_tags
			update_memory_field ("tn_tags")
		end

	set_tn_np (a_tn_np: CE_POINTER [NATURAL_8])
		do
			tn_np := a_tn_np
			update_memory_field ("tn_np")
		end

	set_tn_did_filefind_init (a_tn_did_filefind_init: INTEGER_32)
		do
			tn_did_filefind_init := a_tn_did_filefind_init
			update_memory_field ("tn_did_filefind_init")
		end

	set_tn_hf_idx (a_tn_hf_idx: INTEGER_32)
		do
			tn_hf_idx := a_tn_hf_idx
			update_memory_field ("tn_hf_idx")
		end

	set_tn_search_ctx (a_tn_search_ctx: CE_POINTER [ANY])
		do
			tn_search_ctx := a_tn_search_ctx
			update_memory_field ("tn_search_ctx")
		end

feature {ANY} -- public routines

	get_tagfname (a_first___0: INTEGER_32; a_buf___6: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_r_ptr: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_filename: CE_POINTER [NATURAL_8]
			l_tmp___2: NATURAL_32
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			l_fname := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
			if a_first___0.to_boolean then
				memset (create {CE_VOID_POINTER}.make_shared (c_pointer), 0, (create {PD_TAGNAME_T}.make).structure_size.to_natural_32).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			if ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_help).to_boolean then
				if a_first___0.to_boolean then
					((create {P_TAG_STATIC}).tag_fnames.item).item.ga_clear_strings
					update_class_fields; -- Current might have been changed; synchronize
					((create {P_TAG_STATIC}).tag_fnames.item).item.ga_init2 (({PLATFORM}.Pointer_bytes.to_natural_32).to_integer_32, 10)
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_EX_CMDS2_STATIC}).do_in_runtimepath (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("doc/tags doc/tags-??")), 1, (create {P_TAG_STATIC}).found_tagfile_cb_address, create {CE_VOID_POINTER}.make_shared (default_pointer)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
				if tn_hf_idx >= (create {P_TAG_STATIC}).tag_fnames.item.item.ga_len then
					if tn_hf_idx > (create {P_TAG_STATIC}).tag_fnames.item.item.ga_len then
						Result := 0
						l_return := True
					elseif ((create {P_OPTION_STATIC}).p_hf.item.item.item).to_integer_32 = 0 then
						Result := 0
						l_return := True
					end
					if not l_return then
						Current.tn_hf_idx := tn_hf_idx + 1
						update_class_fields -- Current might have been changed; synchronize
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), create {CE_INTEGER_8_POINTER}.make_cast ((create {P_OPTION_STATIC}).p_hf.item.item)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						l_tmp := (create {P_MISC1_STATIC}).gettail (a_buf___6)
						update_class_fields -- Current might have been changed; synchronize
						strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp), ce_string ("tags")).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
				else
					l_tmp___0 := tn_hf_idx
					Current.tn_hf_idx := tn_hf_idx + 1
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MISC2_STATIC}).vim_strncpy (a_buf___6, create {CE_POINTER_POINTER [NATURAL_8]}.make_cast ((create {P_TAG_STATIC}).tag_fnames.item.item.ga_data)[l_tmp___0], (4_095).to_natural_32)
					update_class_fields -- Current might have been changed; synchronize
				end
				if not l_return then
					Result := 1
					l_return := True
				end
			end
			if not l_return and then (a_first___0.to_boolean) then
				if (((create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_tags).item).to_integer_32 /= 0 then
					l_tmp___1 := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_p_tags
				else
					l_tmp___1 := (create {P_OPTION_STATIC}).p_tags.item.item
				end
				Current.tn_tags := (create {P_MISC2_STATIC}).vim_strsave (l_tmp___1)
				update_class_fields -- Current might have been changed; synchronize
				if tn_tags.is_void then
					Result := 0
					l_return := True
				end
				if not l_return then
					Current.tn_np := tn_tags
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					if tn_did_filefind_init.to_boolean then
						l_fname := (create {P_MISC2_STATIC}).vim_findfile (tn_search_ctx)
						update_class_fields -- Current might have been changed; synchronize
						if not l_fname.is_void then
							l_break := True
						end
						if not (l_return or l_break) then
							Current.tn_did_filefind_init := 0
							update_class_fields -- Current might have been changed; synchronize
						end
					else
						l_filename := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						if (tn_np.item).to_integer_32 = 0 then
							(create {P_MISC2_STATIC}).vim_findfile_cleanup (tn_search_ctx)
							update_class_fields -- Current might have been changed; synchronize
							Current.tn_search_ctx := create {CE_VOID_POINTER}.make_shared (default_pointer)
							update_class_fields -- Current might have been changed; synchronize
							Result := 0
							l_return := True
						end
						if not l_return then
							a_buf___6[0] := (('%/0/').code).to_natural_8
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MISC2_STATIC}).copy_option_part (create {CE_POINTER_POINTER [NATURAL_8]}.make_shared (c_pointer + (create {PD_TAGNAME_T}.make).offset_of ("tn_np")), a_buf___6, 4_095, ce_string (" ,")).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_r_ptr := (create {P_MISC2_STATIC}).vim_findfile_stopdir (a_buf___6)
							update_class_fields -- Current might have been changed; synchronize
							l_filename := (create {P_MISC1_STATIC}).gettail (a_buf___6)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___2 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_filename))
							update_class_fields -- Current might have been changed; synchronize
							memmove (create {CE_VOID_POINTER}.make_cast ((l_filename + 1)), create {CE_VOID_POINTER}.make_cast (l_filename), l_tmp___2 + {NATURAL_32} 1).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___3 := l_filename
							l_filename := l_filename + 1
							l_tmp___3.item := (('%/0/').code).to_natural_8
							update_class_fields -- Current might have been changed; synchronize
							Current.tn_search_ctx := (create {P_MISC2_STATIC}).vim_findfile_init (a_buf___6, l_filename, l_r_ptr, 100, 0, 0, tn_search_ctx, 1, (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ffname)
							update_class_fields -- Current might have been changed; synchronize
							if not tn_search_ctx.is_void then
								Current.tn_did_filefind_init := 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
					end
				end
			end
			if not l_return then
				l_break := False
				strcpy (create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), create {CE_INTEGER_8_POINTER}.make_cast (l_fname)).do_nothing
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_fname))
				update_class_fields -- Current might have been changed; synchronize
				Result := 1
			end
		end

	tagname_free
		do
			(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (tn_tags))
			update_class_fields; -- Current might have been changed; synchronize
			(create {P_MISC2_STATIC}).vim_findfile_cleanup (tn_search_ctx)
			update_class_fields -- Current might have been changed; synchronize
			Current.tn_search_ctx := create {CE_VOID_POINTER}.make_shared (default_pointer)
			update_class_fields; -- Current might have been changed; synchronize
			((create {P_TAG_STATIC}).tag_fnames.item).item.ga_clear_strings
			update_class_fields -- Current might have been changed; synchronize
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tn_tags := a_other.tn_tags
			tn_np := a_other.tn_np
			tn_did_filefind_init := a_other.tn_did_filefind_init
			tn_hf_idx := a_other.tn_hf_idx
			tn_search_ctx := a_other.tn_search_ctx
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tn_tags.is_equal (a_other.tn_tags) and
				tn_np.is_equal (a_other.tn_np) and
				tn_did_filefind_init = a_other.tn_did_filefind_init and
				tn_hf_idx = a_other.tn_hf_idx and
				tn_search_ctx.is_equal (a_other.tn_search_ctx)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tn_tags"),
					create {CE_STRUCTURE_FIELD}.make ("tn_np"),
					create {CE_STRUCTURE_FIELD}.make ("tn_did_filefind_init"),
					create {CE_STRUCTURE_FIELD}.make ("tn_hf_idx"),
					create {CE_STRUCTURE_FIELD}.make ("tn_search_ctx")
				>>)
			init_structure_info
		end

end
