class
	PD_TYPVAL_T

inherit
	PD_TYPVAL_T_STATIC
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end
	S_STRING_STATIC
		redefine
			copy,
			is_equal
		end
	S_LIBINTL_STATIC
		redefine
			copy,
			is_equal
		end
	S_CTYPE_STATIC
		redefine
			copy,
			is_equal
		end
	S_STDIO_STATIC
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create vval.make
			Precursor
		end

feature {ANY} -- fields

	v_type: INTEGER_8 assign set_v_type

	v_lock: INTEGER_8 assign set_v_lock

	vval: PD_VVAL assign set_vval

feature {ANY} -- field setters

	set_v_type (a_v_type: INTEGER_8)
		do
			v_type := a_v_type
			update_memory_field ("v_type")
		end

	set_v_lock (a_v_lock: INTEGER_8)
		do
			v_lock := a_v_lock
			update_memory_field ("v_lock")
		end

	set_vval (a_vval: PD_VVAL)
		do
			vval := a_vval
			update_memory_field ("vval")
		end

feature {PD_TYPVAL_T} -- private attributes

	recursive: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

	pos: CE_STATIC [CE_ARRAY [PD_POS_T]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_POS_T]}.make (<<1>>)
		end

	mybuf: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<30>>)
		end

	mybuf___0: CE_STATIC [CE_ARRAY [NATURAL_8]]
		once ("PROCESS")
			Result.item := create {CE_NATURAL_8_ARRAY}.make (<<30>>)
		end

feature {ANY} -- public routines

	ins_compl_add_tv (a_dir___0: INTEGER_32): INTEGER_32
		local
			l_word: CE_POINTER [NATURAL_8]
			l_icase: INTEGER_32
			l_adup: INTEGER_32
			l_cptext: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_cptext.make (<<4>>)

			l_icase := 0
			l_adup := 0
			if v_type.to_integer_32 = 5 then
				if not (vval.v_dict).is_void then
					l_word := (create {P_EVAL_STATIC}).get_dict_string (vval.v_dict, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("word")), 0)
					update_class_fields -- Current might have been changed; synchronize
					l_cptext[0] := (create {P_EVAL_STATIC}).get_dict_string (vval.v_dict, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("abbr")), 0)
					update_class_fields -- Current might have been changed; synchronize
					l_cptext[1] := (create {P_EVAL_STATIC}).get_dict_string (vval.v_dict, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("menu")), 0)
					update_class_fields -- Current might have been changed; synchronize
					l_cptext[2] := (create {P_EVAL_STATIC}).get_dict_string (vval.v_dict, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("kind")), 0)
					update_class_fields -- Current might have been changed; synchronize
					l_cptext[3] := (create {P_EVAL_STATIC}).get_dict_string (vval.v_dict, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("info")), 0)
					update_class_fields -- Current might have been changed; synchronize
					l_tmp___0 := (create {P_EVAL_STATIC}).get_dict_string (vval.v_dict, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("icase")), 0)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp___0.is_void then
						l_tmp := (create {P_EVAL_STATIC}).get_dict_number (vval.v_dict, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("icase")))
						update_class_fields -- Current might have been changed; synchronize
						l_icase := l_tmp.to_integer_32
					end
					l_tmp___2 := (create {P_EVAL_STATIC}).get_dict_string (vval.v_dict, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("dup")), 0)
					update_class_fields -- Current might have been changed; synchronize
					if not l_tmp___2.is_void then
						l_tmp___1 := (create {P_EVAL_STATIC}).get_dict_number (vval.v_dict, create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("dup")))
						update_class_fields -- Current might have been changed; synchronize
						l_adup := l_tmp___1.to_integer_32
					end
				else
					l_word := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.get_tv_string_chk
					update_class_fields -- Current might have been changed; synchronize
					memset (create {CE_VOID_POINTER}.make_cast (l_cptext), 0, ({PLATFORM}.Pointer_bytes.to_natural_32 * (4).to_natural_32)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				end
			else
				l_word := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.get_tv_string_chk
				update_class_fields -- Current might have been changed; synchronize
				memset (create {CE_VOID_POINTER}.make_cast (l_cptext), 0, ({PLATFORM}.Pointer_bytes.to_natural_32 * (4).to_natural_32)).do_nothing
				update_class_fields -- Current might have been changed; synchronize
			end
			if l_word.is_void then
				Result := 0
				l_return := True
			elseif (l_word.item).to_integer_32 = 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_tmp___3 := (create {P_EDIT_STATIC}).ins_compl_add (l_word, -1, l_icase, create {CE_NATURAL_8_POINTER}.make_shared (default_pointer), l_cptext, a_dir___0, 0, l_adup)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp___3
			end
		end

	restore_vimvar (a_idx: INTEGER_32)
		local
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_tmp: CE_POINTER [INTEGER_8]
		do
			(create {P_EVAL_STATIC}).vimvars.item[a_idx].vv_di.di_tv := twin
			update_class_fields -- Current might have been changed; synchronize
			if ((create {P_EVAL_STATIC}).vimvars.item[a_idx].vv_di.di_tv.v_type).to_integer_32 = 0 then
				l_hi___1 := (create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared ((create {P_EVAL_STATIC}).vimvardict.item.item.c_pointer + (create {PD_DICTVAR_S}.make).offset_of ("dv_hashtab"))).item.hash_find ((create {P_EVAL_STATIC}).vimvars.item[a_idx].vv_di.di_key)
				update_class_fields -- Current might have been changed; synchronize
				if (l_hi___1.item.hi_key).is_void then
					l_tmp := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item)))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("restore_vimvar()"))).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				elseif (l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item) then
					l_tmp := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item)))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("restore_vimvar()"))).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				else
					(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared ((create {P_EVAL_STATIC}).vimvardict.item.item.c_pointer + (create {PD_DICTVAR_S}.make).offset_of ("dv_hashtab"))).item.hash_remove (l_hi___1)
					update_class_fields -- Current might have been changed; synchronize
				end
			end
		end

	tv_islocked: INTEGER_32
		local
			l_tmp: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (((v_lock.to_integer_32).bit_and (1)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_tmp := 1
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if v_type.to_integer_32 /= 4 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if not (vval.v_list).is_void then
							if ((((vval.v_list).item.lv_lock).to_integer_32).bit_and (1)).to_boolean then
								l_tmp := 1
							else
								l_pos := -1 + 6 -- goto _L___0
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						if v_type.to_integer_32 = 5 then
							if not (vval.v_dict).is_void then
								if ((((vval.v_dict).item.dv_lock).to_integer_32).bit_and (1)).to_boolean then
									l_tmp := 1
								else
									l_tmp := 0
								end
							else
								l_tmp := 0
							end
						else
							l_tmp := 0
						end
				when 7 then -- if done
					Result := l_tmp
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eval7 (a_arg: CE_POINTER [CE_POINTER [NATURAL_8]]; a_evaluate, a_want_string: INTEGER_32): INTEGER_32
		require
			not a_arg.is_void
		local
			l_n: CE_ARRAY [INTEGER_32]
			l_len: CE_ARRAY [INTEGER_32]
			l_s: CE_POINTER [NATURAL_8]
			l_start_leader: CE_POINTER [NATURAL_8]
			l_end_leader: CE_POINTER [NATURAL_8]
			l_ret: INTEGER_32
			l_alias: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_get_float: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [CE_POINTER [NATURAL_16]]
			l_tmp___2: INTEGER_32
			l_f: CE_ARRAY [REAL_64]
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: INTEGER_32
			l_error: CE_ARRAY [INTEGER_32]
			l_val___0: INTEGER_32
			l_f___0: REAL_64
			l_tmp___6: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_len.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_alias.make (<<1>>)
			create {CE_REAL_64_ARRAY} l_f.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_error.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ret := 1
					Current.v_type := (0).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					l_start_leader := a_arg.item
					from
					until
						(l_break)
					loop
						l_break := False
						if ((a_arg.item).item).to_integer_32 /= 33 then
							if ((a_arg.item).item).to_integer_32 /= 45 then
								if ((a_arg.item).item).to_integer_32 /= 43 then
									l_break := True
								end
							end
						end
						if not (l_break) then
							a_arg.item := (create {P_CHARSET_STATIC}).skipwhite (a_arg.item + 1)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_break := False
					l_end_leader := a_arg.item
					inspect ((a_arg.item).item).to_integer_32 -- switch 1 head
					when 48 then l_pos := -1 + 1
					when 49 then l_pos := -1 + 1
					when 50 then l_pos := -1 + 1
					when 51 then l_pos := -1 + 1
					when 52 then l_pos := -1 + 1
					when 53 then l_pos := -1 + 1
					when 54 then l_pos := -1 + 1
					when 55 then l_pos := -1 + 1
					when 56 then l_pos := -1 + 1
					when 57 then l_pos := -1 + 1
					when 34 then l_pos := -1 + 14
					when 39 then l_pos := -1 + 15
					when 91 then l_pos := -1 + 16
					when 123 then l_pos := -1 + 17
					when 38 then l_pos := -1 + 18
					when 36 then l_pos := -1 + 19
					when 64 then l_pos := -1 + 20
					when 40 then l_pos := -1 + 21
					else l_pos := -1 + 22
					end
				when 1 then -- switch 1, case 48 | switch 1, case 49 | switch 1, case 50 | switch 1, case 51 | switch 1, case 52 | switch 1, case 53 | switch 1, case 54 | switch 1, case 55 | switch 1, case 56 | switch 1, case 57
					l_tmp := (create {P_CHARSET_STATIC}).skipdigits (a_arg.item + 1)
					update_class_fields -- Current might have been changed; synchronize
					l_p___0 := l_tmp
					l_get_float := 0
					if a_want_string.to_boolean then
						l_pos := -1 + 13 -- skip if block
					end
				when 2 then -- if:
						if (l_p___0[0]).to_integer_32 /= 46 then
							l_pos := -1 + 13 -- skip if block
						end
				when 3 then -- if:
						l_tmp___2 := (create {P_CHARSET_STATIC}).vim_isdigit ((l_p___0[1]).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___2.to_boolean) then
							l_pos := -1 + 13 -- skip if block
						end
				when 4 then -- if:
						l_get_float := 1
						l_p___0 := (create {P_CHARSET_STATIC}).skipdigits (l_p___0 + 2)
						update_class_fields -- Current might have been changed; synchronize
						if (l_p___0.item).to_integer_32 /= 101 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if (l_p___0.item).to_integer_32 /= 69 then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						l_p___0 := l_p___0 + 1
						if (l_p___0.item).to_integer_32 = 45 then
							l_p___0 := l_p___0 + 1
						elseif (l_p___0.item).to_integer_32 = 43 then
							l_p___0 := l_p___0 + 1
						end
						l_tmp___0 := (create {P_CHARSET_STATIC}).vim_isdigit ((l_p___0.item).to_integer_32)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___0.to_boolean then
							l_p___0 := (create {P_CHARSET_STATIC}).skipdigits (l_p___0 + 1)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_get_float := 0
						end
				when 9 then -- if done
						if not ((l_p___0.item).to_integer_32 < 127) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_tmp___1 := ctype_b_loc
						update_class_fields -- Current might have been changed; synchronize
						if (((l_tmp___1.item[(l_p___0.item).to_integer_32]).to_integer_32).bit_and (1_024)).to_boolean then
							l_get_float := 0
						else
							l_pos := -1 + 12 -- goto _L___0
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						if (l_p___0.item).to_integer_32 = 46 then
							l_get_float := 0
						end
				when 13 then -- if done | if done | if done
					if l_get_float.to_boolean then
						l_tmp___3 := (create {P_EVAL_STATIC}).string2float (a_arg.item, l_f)
						update_class_fields -- Current might have been changed; synchronize
						a_arg.item := a_arg.item + l_tmp___3
						update_class_fields -- Current might have been changed; synchronize
						if a_evaluate.to_boolean then
							Current.v_type := (6).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							vval.v_float := l_f.item
							update_class_fields -- Current might have been changed; synchronize
						end
					else
						(create {P_CHARSET_STATIC}).vim_str2nr (a_arg.item, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), l_len, 1, 1, l_n, create {CE_NATURAL_32_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
						a_arg.item := a_arg.item + (l_len.item)
						update_class_fields -- Current might have been changed; synchronize
						if a_evaluate.to_boolean then
							Current.v_type := (1).to_integer_8
							update_class_fields -- Current might have been changed; synchronize
							vval.v_number := (l_n.item).to_integer_32
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_pos := -1 + 23 -- switch 1; break
				when 14 then -- switch 1, case 34
					l_ret := get_string_tv (a_arg, (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)), a_evaluate)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 23 -- switch 1; break
				when 15 then -- switch 1, case 39
					l_ret := get_lit_string_tv (a_arg, (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)), a_evaluate)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 23 -- switch 1; break
				when 16 then -- switch 1, case 91
					l_ret := get_list_tv (a_arg, (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)), a_evaluate)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 23 -- switch 1; break
				when 17 then -- switch 1, case 123
					l_ret := get_dict_tv (a_arg, (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)), a_evaluate)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 23 -- switch 1; break
				when 18 then -- switch 1, case 38
					l_ret := (create {P_EVAL_STATIC}).get_option_tv (a_arg, (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)), a_evaluate)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 23 -- switch 1; break
				when 19 then -- switch 1, case 36
					l_ret := get_env_tv (a_arg, (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)), a_evaluate)
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 23 -- switch 1; break
				when 20 then -- switch 1, case 64
					a_arg.item := (a_arg.item) + 1
					update_class_fields -- Current might have been changed; synchronize
					if a_evaluate.to_boolean then
						Current.v_type := (2).to_integer_8
						update_class_fields -- Current might have been changed; synchronize
						vval.v_string := (create {P_OPS_STATIC}).get_reg_contents (((a_arg.item).item).to_integer_32, 1, 1)
						update_class_fields -- Current might have been changed; synchronize
					end
					if ((a_arg.item).item).to_integer_32 /= 0 then
						a_arg.item := (a_arg.item) + 1
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 23 -- switch 1; break
				when 21 then -- switch 1, case 40
					a_arg.item := (create {P_CHARSET_STATIC}).skipwhite (a_arg.item + 1)
					update_class_fields -- Current might have been changed; synchronize
					l_ret := (create {P_EVAL_STATIC}).eval1 (a_arg, (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)), a_evaluate)
					update_class_fields -- Current might have been changed; synchronize
					if ((a_arg.item).item).to_integer_32 = 41 then
						a_arg.item := (a_arg.item) + 1
						update_class_fields -- Current might have been changed; synchronize
					elseif l_ret = 1 then
						l_tmp___4 := gettext (ce_string ("E110: Missing %')%'"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___4)).do_nothing
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_EVAL_STATIC}).clear_tv ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)))
						update_class_fields -- Current might have been changed; synchronize
						l_ret := 0
					end
					l_pos := -1 + 23 -- switch 1; break
				when 22 then -- switch 1, default:
					l_ret := 2
					l_pos := -1 + 23 -- switch 1; break
				when 23 then -- switch 1, done:
					if l_ret = 2 then
						l_s := a_arg.item
						l_len.item := (create {P_EVAL_STATIC}).get_name_len (a_arg, l_alias, a_evaluate, 1)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_alias.item).is_void then
							l_s := l_alias.item
						end
						if l_len.item <= 0 then
							l_ret := 0
						elseif ((a_arg.item).item).to_integer_32 = 40 then
							l_s := (create {P_EVAL_STATIC}).deref_func_name (l_s, l_len)
							update_class_fields -- Current might have been changed; synchronize
							l_ret := (create {P_EVAL_STATIC}).get_func_tv (l_s, l_len.item, (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)), a_arg, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum, l_len, a_evaluate, create {CE_CLASS_POINTER [PD_DICTVAR_S]}.make_shared (default_pointer))
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___5 := (create {P_EX_EVAL_STATIC}).aborting
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___5.to_boolean then
								if l_ret = 1 then
									(create {P_EVAL_STATIC}).clear_tv ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)))
									update_class_fields -- Current might have been changed; synchronize
								end
								l_ret := 0
							end
						elseif a_evaluate.to_boolean then
							l_ret := (create {P_EVAL_STATIC}).get_var_tv (l_s, l_len.item, (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)), 1)
							update_class_fields -- Current might have been changed; synchronize
						else
							l_ret := 1
						end
						if not (l_alias.item).is_void then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_alias.item))
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					a_arg.item := (create {P_CHARSET_STATIC}).skipwhite (a_arg.item)
					update_class_fields -- Current might have been changed; synchronize
					if l_ret = 1 then
						l_ret := (create {P_EVAL_STATIC}).handle_subscript (a_arg, (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)), a_evaluate, 1)
						update_class_fields -- Current might have been changed; synchronize
					end
					if l_ret = 1 then
						if a_evaluate.to_boolean then
							if (l_end_leader.c_pointer.to_integer_32).to_natural_32 > (l_start_leader.c_pointer.to_integer_32).to_natural_32 then
								l_error.item := 0
								update_class_fields -- Current might have been changed; synchronize
								l_val___0 := 0
								l_f___0 := 0.0
								if v_type.to_integer_32 = 6 then
									l_f___0 := vval.v_float
								else
									l_tmp___6 := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.get_tv_number_chk (l_error)
									update_class_fields -- Current might have been changed; synchronize
									l_val___0 := l_tmp___6.to_integer_32
								end
								if (l_error.item).to_boolean then
									(create {P_EVAL_STATIC}).clear_tv ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)))
									update_class_fields -- Current might have been changed; synchronize
									l_ret := 0
								else
									from
									until
										not ((l_end_leader.c_pointer.to_integer_32).to_natural_32 > (l_start_leader.c_pointer.to_integer_32).to_natural_32)
									loop
										l_end_leader := l_end_leader - 1
										if (l_end_leader.item).to_integer_32 = 33 then
											if v_type.to_integer_32 = 6 then
												l_f___0 := (not l_f___0.truncated_to_integer.to_boolean).to_integer.to_double
											else
												l_val___0 := (not l_val___0.to_boolean).to_integer
											end
										elseif (l_end_leader.item).to_integer_32 = 45 then
											if v_type.to_integer_32 = 6 then
												l_f___0 := -l_f___0
											else
												l_val___0 := -l_val___0
											end
										end
									end
									if v_type.to_integer_32 = 6 then
										(create {P_EVAL_STATIC}).clear_tv ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)))
										update_class_fields -- Current might have been changed; synchronize
										vval.v_float := l_f___0
										update_class_fields -- Current might have been changed; synchronize
									else
										(create {P_EVAL_STATIC}).clear_tv ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)))
										update_class_fields -- Current might have been changed; synchronize
										Current.v_type := (1).to_integer_8
										update_class_fields -- Current might have been changed; synchronize
										vval.v_number := l_val___0
										update_class_fields -- Current might have been changed; synchronize
									end
								end
							end
						end
					end
					Result := l_ret
				when 24 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	tv_equal (a_tv2: CE_POINTER [PD_TYPVAL_T]; a_ic: INTEGER_32): INTEGER_32
		require
			not a_tv2.is_void
		local
			l_buf1: CE_ARRAY [NATURAL_8]
			l_buf2: CE_ARRAY [NATURAL_8]
			l_s1: CE_POINTER [NATURAL_8]
			l_s2: CE_POINTER [NATURAL_8]
			l_r: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_buf1.make (<<30>>)
			create {CE_NATURAL_8_ARRAY} l_buf2.make (<<30>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if v_type.to_integer_32 /= (a_tv2.item.v_type).to_integer_32 then
						Result := 0
						l_return := True
					end
					if not l_return and then (recursive.item >= 1_000) then
						Result := 1
						l_return := True
					end
					if l_return then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						inspect v_type.to_integer_32 -- switch 1 head
						when 4 then l_pos := -1 + 2
						when 5 then l_pos := -1 + 3
						when 3 then l_pos := -1 + 4
						when 1 then l_pos := -1 + 5
						when 6 then l_pos := -1 + 6
						when 2 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 2 then -- switch 1, case 4
						recursive.item := recursive.item + 1
						l_r := (create {P_EVAL_STATIC}).list_equal (vval.v_list, a_tv2.item.vval.v_list, a_ic)
						update_class_fields -- Current might have been changed; synchronize
						recursive.item := recursive.item - 1
						Result := l_r
						l_return := True
				when 3 then -- switch 1, case 5
						if not l_return then
							recursive.item := recursive.item + 1
							l_r := (create {P_EVAL_STATIC}).dict_equal (vval.v_dict, a_tv2.item.vval.v_dict, a_ic)
							update_class_fields -- Current might have been changed; synchronize
							recursive.item := recursive.item - 1
							Result := l_r
							l_return := True
						end
				when 4 then -- switch 1, case 3
						if not l_return then
							if not (vval.v_string).is_void then
								if not (a_tv2.item.vval.v_string).is_void then
									l_tmp := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (vval.v_string), create {CE_INTEGER_8_POINTER}.make_cast (a_tv2.item.vval.v_string))
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp = 0 then
										l_tmp___0 := 1
									else
										l_tmp___0 := 0
									end
								else
									l_tmp___0 := 0
								end
							else
								l_tmp___0 := 0
							end
							Result := l_tmp___0
							l_return := True
						end
				when 5 then -- switch 1, case 1
						if not l_return then
							Result := (vval.v_number = a_tv2.item.vval.v_number).to_integer
							l_return := True
						end
				when 6 then -- switch 1, case 6
						if not l_return then
							Result := (vval.v_float = a_tv2.item.vval.v_float).to_integer
							l_return := True
						end
				when 7 then -- switch 1, case 2
						if not l_return then
							l_s1 := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.get_tv_string_buf (l_buf1)
							update_class_fields -- Current might have been changed; synchronize
							l_s2 := a_tv2.item.get_tv_string_buf (l_buf2)
							update_class_fields -- Current might have been changed; synchronize
							if a_ic.to_boolean then
								l_tmp___1 := (create {P_MBYTE_STATIC}).mb_strnicmp (l_s1, l_s2, (2_147_483_647).to_natural_32)
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___3 := l_tmp___1
							else
								l_tmp___2 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_s1), create {CE_INTEGER_8_POINTER}.make_cast (l_s2))
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___3 := l_tmp___2
							end
							Result := (l_tmp___3 = 0).to_integer
							l_return := True
						end
				when 8 then -- switch 1, done: | if done
					if not l_return then
						l_tmp___4 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item)))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___4), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tv_equal()"))).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := 1
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	list2string (a_copyID: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)

			if (vval.v_list).is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_ga.item.ga_init2 (({PLATFORM}.Integer_8_bytes.to_natural_32).to_integer_32, 80)
				update_class_fields -- Current might have been changed; synchronize
				l_ga.item.ga_append (('[').code)
				update_class_fields -- Current might have been changed; synchronize
				l_tmp := (create {P_EVAL_STATIC}).list_join (l_ga, vval.v_list, create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")), 0, a_copyID)
				update_class_fields -- Current might have been changed; synchronize
				if l_tmp = 0 then
					(create {P_MISC2_STATIC}).vim_free (l_ga.item.ga_data)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_ga.item.ga_append ((']').code)
				update_class_fields -- Current might have been changed; synchronize
				l_ga.item.ga_append (('%/0/').code)
				update_class_fields -- Current might have been changed; synchronize
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data))
			end
		end

	set_ref_in_item (a_copyID: INTEGER_32)
		local
			l_dd: CE_POINTER [PD_DICTVAR_S]
			l_ll: CE_POINTER [PD_LISTVAR_S]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect v_type.to_integer_32 -- switch 1 head
					when 5 then l_pos := -1 + 1
					when 4 then l_pos := -1 + 2
					else l_pos := -1 + 3
					end
				when 1 then -- switch 1, case 5
					l_dd := vval.v_dict
					if not l_dd.is_void then
						if l_dd.item.dv_copyID /= a_copyID then
							l_dd.item.dv_copyID := a_copyID
							update_class_fields; -- Current might have been changed; synchronize
							(create {CE_CLASS_POINTER [PD_HASHTABLE_S]}.make_shared (l_dd.c_pointer + (create {PD_DICTVAR_S}.make).offset_of ("dv_hashtab"))).item.set_ref_in_ht (a_copyID)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, case 4
					l_ll := vval.v_list
					if not l_ll.is_void then
						if l_ll.item.lv_copyID /= a_copyID then
							l_ll.item.lv_copyID := a_copyID
							update_class_fields -- Current might have been changed; synchronize
							set_ref_in_list (l_ll, a_copyID)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dict2string (a_copyID: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_first___0: INTEGER_32
			l_tofree: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_numbuf: CE_ARRAY [NATURAL_8]
			l_hi___1: CE_POINTER [PD_HASHITEM_S]
			l_s: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [PD_DICTVAR_S]
			l_todo: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GROWARRAY]} l_ga.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_tofree.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_numbuf.make (<<30>>)

			l_first___0 := 1
			l_d := vval.v_dict
			if l_d.is_void then
				Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				l_ga.item.ga_init2 (({PLATFORM}.Integer_8_bytes.to_natural_32).to_integer_32, 80)
				update_class_fields -- Current might have been changed; synchronize
				l_ga.item.ga_append (('{').code)
				update_class_fields -- Current might have been changed; synchronize
				l_todo := (l_d.item.dv_hashtab.ht_used).to_integer_32
				l_hi___1 := l_d.item.dv_hashtab.ht_array
				from
				until
					(l_break)
				loop
					l_break := False
					if l_todo > 0 then
						if ((create {P_GLOBALS_STATIC}).got_int.item).to_boolean then
							l_break := True
						end
					else
						l_break := True
					end
					if not (l_break) and then (not ((l_hi___1.item.hi_key).is_void)) then
						if not ((l_hi___1.item.hi_key).is_equal ((create {P_GLOBALS_STATIC}).hash_removed.item)) then
							l_todo := l_todo - 1
							if l_first___0.to_boolean then
								l_first___0 := 0
							else
								l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (", ")))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_tofree.item := string_quote (l_hi___1.item.hi_key, 0)
							update_class_fields -- Current might have been changed; synchronize
							if not (l_tofree.item).is_void then
								l_ga.item.ga_concat (l_tofree.item)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tofree.item))
								update_class_fields -- Current might have been changed; synchronize
							end
							l_ga.item.ga_concat (create {CE_NATURAL_8_POINTER}.make_cast (ce_string (": ")))
							update_class_fields -- Current might have been changed; synchronize
							l_s := (create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared ((create {CE_CLASS_POINTER [PD_DICTITEM_S]}.make_cast ((l_hi___1.item.hi_key - (((create {P_EVAL_STATIC}).dumdi.item.item.di_key).distance ((create {CE_NATURAL_8_POINTER}.make_cast (((create {P_EVAL_STATIC}).dumdi.item)))))))).c_pointer + (create {PD_DICTITEM_S}.make).offset_of ("di_tv"))).item.tv2string (l_tofree, l_numbuf, a_copyID)
							update_class_fields -- Current might have been changed; synchronize
							if not l_s.is_void then
								l_ga.item.ga_concat (l_s)
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_tofree.item))
							update_class_fields -- Current might have been changed; synchronize
							if l_s.is_void then
								l_break := True
							end
						end
					end
					if not (l_break) then
						l_hi___1 := l_hi___1 + 1
					end
				end
				l_break := False
				if l_todo > 0 then
					(create {P_MISC2_STATIC}).vim_free (l_ga.item.ga_data)
					update_class_fields -- Current might have been changed; synchronize
					Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					l_return := True
				end
			end
			if not l_return then
				l_ga.item.ga_append (('}').code)
				update_class_fields -- Current might have been changed; synchronize
				l_ga.item.ga_append (('%/0/').code)
				update_class_fields -- Current might have been changed; synchronize
				Result := (create {CE_NATURAL_8_POINTER}.make_cast (l_ga.item.ga_data))
			end
		end

	tv2string (a_tofree: CE_POINTER [CE_POINTER [NATURAL_8]]; a_numbuf: CE_POINTER [NATURAL_8]; a_copyID: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect v_type.to_integer_32 -- switch 1 head
					when 3 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 6 then l_pos := -1 + 3
					when 1 then l_pos := -1 + 4
					when 4 then l_pos := -1 + 4
					when 5 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 3
					a_tofree.item := string_quote (vval.v_string, 1)
					update_class_fields -- Current might have been changed; synchronize
					Result := (a_tofree.item)
					l_return := True
				when 2 then -- switch 1, case 2
					if not l_return then
						a_tofree.item := string_quote (vval.v_string, 0)
						update_class_fields -- Current might have been changed; synchronize
						Result := (a_tofree.item)
						l_return := True
					end
				when 3 then -- switch 1, case 6
					if not l_return then
						a_tofree.item := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).vim_snprintf ([create {CE_INTEGER_8_POINTER}.make_cast (a_numbuf), (29).to_natural_32, ce_string ("%%g"), vval.v_float]).do_nothing
						update_class_fields -- Current might have been changed; synchronize
						Result := a_numbuf
						l_return := True
					end
				when 4 then -- switch 1, case 1 | switch 1, case 4 | switch 1, case 5
					l_pos := -1 + 6 -- switch 1; break
				when 5 then -- switch 1, default:
					l_tmp := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item)))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("tv2string()"))).do_nothing
					update_class_fields -- Current might have been changed; synchronize
				when 6 then -- switch 1, done:
					if not l_return then
						l_tmp___0 := (create {P_EVAL_STATIC}).echo_string ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)), a_tofree, a_numbuf, a_copyID)
						update_class_fields -- Current might have been changed; synchronize
						Result := l_tmp___0
					end
				when 7 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	find_buffer: CE_POINTER [PD_FILE_BUFFER]
		local
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_buf___6 := create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
					if v_type.to_integer_32 /= 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_buf___6 := (create {P_BUFFER_STATIC}).buflist_findnr (vval.v_number)
						update_class_fields -- Current might have been changed; synchronize
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 16
				when 3 then -- else:
						if v_type.to_integer_32 /= 2 then
							l_pos := -1 + 16 -- skip if block
						end
				when 4 then -- if:
						if (vval.v_string).is_void then
							l_pos := -1 + 16 -- skip if block
						end
				when 5 then -- if:
						l_buf___6 := (create {P_BUFFER_STATIC}).buflist_findname_exp (vval.v_string)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_buf___6.is_void) then
							l_pos := -1 + 16 -- skip if block
						end
				when 6 then -- if:
						l_buf___6 := (create {P_GLOBALS_STATIC}).firstbuf.item
				when 7 then -- loop condition:
						if not (not (l_break) and then (not l_buf___6.is_void)) then
							l_pos := -1 + 15 -- skip loop
						end
				when 8 then -- loop body:
						l_break := False
						if (l_buf___6.item.b_fname).is_void then
							l_pos := -1 + 14 -- skip if block
						end
				when 9 then -- if:
						l_tmp := (create {P_WINDOW_STATIC}).path_with_url (l_buf___6.item.b_fname)
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						l_pos := -1 + 13 -- goto _L
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 12 then -- else:
						l_tmp___0 := l_buf___6.item.bt_nofile
						update_class_fields -- Current might have been changed; synchronize
						if not (l_tmp___0.to_boolean) then
							l_pos := -1 + 14 -- skip if block
						end
				when 13 then -- if: | _L:
						l_tmp___1 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_buf___6.item.b_fname), create {CE_INTEGER_8_POINTER}.make_cast (vval.v_string))
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___1 = 0 then
							l_break := True
						end
				when 14 then -- if done | if done
						if not (l_break) then
							l_buf___6 := l_buf___6.item.b_next
						end
						l_pos := -1 + 7 -- back to loop condition
				when 15 then -- loop done
						l_break := False
				when 16 then -- if done | if done | if done | if done
					Result := l_buf___6
				when 17 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_buf_tv: CE_POINTER [PD_FILE_BUFFER]
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_save_magic: INTEGER_32
			l_save_cpo: CE_POINTER [NATURAL_8]
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_tmp: CE_POINTER [PD_FILE_BUFFER]
			l_tmp___0: NATURAL_32
			l_tmp___1: INTEGER_32
			l_return: BOOLEAN
		do
			l_name___1 := vval.v_string
			if v_type.to_integer_32 = 1 then
				l_tmp := (create {P_BUFFER_STATIC}).buflist_findnr (vval.v_number)
				update_class_fields -- Current might have been changed; synchronize
				Result := l_tmp
				l_return := True
			end
			if not l_return and then (v_type.to_integer_32 /= 2) then
				Result := (create {CE_CLASS_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return then
				if l_name___1.is_void then
					Result := ((create {P_GLOBALS_STATIC}).curbuf.item)
					l_return := True
				elseif (l_name___1.item).to_integer_32 = 0 then
					Result := ((create {P_GLOBALS_STATIC}).curbuf.item)
					l_return := True
				end
			end
			if not l_return and then ((l_name___1[0]).to_integer_32 = 36) then
				if (l_name___1[1]).to_integer_32 = 0 then
					Result := ((create {P_GLOBALS_STATIC}).lastbuf.item)
					l_return := True
				end
			end
			if not l_return then
				l_save_magic := (create {P_OPTION_STATIC}).p_magic.item.item;
				(create {P_OPTION_STATIC}).p_magic.item.item := 1
				update_class_fields -- Current might have been changed; synchronize
				l_save_cpo := (create {P_OPTION_STATIC}).p_cpo.item.item;
				(create {P_OPTION_STATIC}).p_cpo.item.item := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___0 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_name___1))
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___1 := (create {P_BUFFER_STATIC}).buflist_findpat (l_name___1, l_name___1 + l_tmp___0.to_integer_32, 1, 0)
				update_class_fields -- Current might have been changed; synchronize
				l_buf___6 := (create {P_BUFFER_STATIC}).buflist_findnr (l_tmp___1)
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_OPTION_STATIC}).p_magic.item.item := l_save_magic
				update_class_fields; -- Current might have been changed; synchronize
				(create {P_OPTION_STATIC}).p_cpo.item.item := l_save_cpo
				update_class_fields -- Current might have been changed; synchronize
				if l_buf___6.is_void then
					l_buf___6 := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.find_buffer
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := l_buf___6
			end
		end

	list2proftime (a_tm: CE_POINTER [SD_TIMEVAL]): INTEGER_32
		local
			l_n1: INTEGER_32
			l_n2: INTEGER_32
			l_error: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_return: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_error.make (<<1>>)

			l_error.item := 0
			update_class_fields -- Current might have been changed; synchronize
			if v_type.to_integer_32 /= 4 then
				Result := 0
				l_return := True
			elseif (vval.v_list).is_void then
				Result := 0
				l_return := True
			elseif (vval.v_list).item.lv_len /= 2 then
				Result := 0
				l_return := True
			end
			if not l_return then
				l_n1 := list_find_nr (vval.v_list, 0, l_error)
				update_class_fields -- Current might have been changed; synchronize
				l_n2 := list_find_nr (vval.v_list, 1, l_error)
				update_class_fields -- Current might have been changed; synchronize
				a_tm.item.tv_sec := l_n1
				update_class_fields -- Current might have been changed; synchronize
				a_tm.item.tv_usec := l_n2
				update_class_fields -- Current might have been changed; synchronize
				if (l_error.item).to_boolean then
					l_tmp := 0
				else
					l_tmp := 1
				end
				Result := l_tmp
			end
		end

	get_search_arg (a_flagsp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_dir___0: INTEGER_32
			l_flags___0: CE_POINTER [NATURAL_8]
			l_nbuf: CE_ARRAY [NATURAL_8]
			l_mask: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_nbuf.make (<<30>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dir___0 := 1
					if v_type.to_integer_32 = 0 then
						l_pos := -1 + 19 -- skip if block
					end
				when 1 then -- if:
						l_flags___0 := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.get_tv_string_buf_chk (l_nbuf)
						update_class_fields -- Current might have been changed; synchronize
						if l_flags___0.is_void then
							Result := 0
							l_return := True
						end
						if l_return then
							l_pos := -1 + 19 -- skip if block
						end
				when 2 then -- if: | loop condition:
						if not (not (l_break) and then ((l_flags___0.item).to_integer_32 /= 0)) then
							l_pos := -1 + 18 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						inspect (l_flags___0.item).to_integer_32 -- switch 1 head
						when 98 then l_pos := -1 + 4
						when 119 then l_pos := -1 + 5
						when 87 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 4 then -- switch 1, case 98
						l_dir___0 := -1
						l_pos := -1 + 17 -- switch 1; break
				when 5 then -- switch 1, case 119;
						(create {P_OPTION_STATIC}).p_ws.item.item := 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 17 -- switch 1; break
				when 6 then -- switch 1, case 87;
						(create {P_OPTION_STATIC}).p_ws.item.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 17 -- switch 1; break
				when 7 then -- switch 1, default:
						l_mask := 0
						if a_flagsp.is_void then
							l_pos := -1 + 16 -- skip if block
						end
				when 8 then -- if:
						inspect (l_flags___0.item).to_integer_32 -- switch 2 head
						when 99 then l_pos := -1 + 9
						when 101 then l_pos := -1 + 10
						when 109 then l_pos := -1 + 11
						when 110 then l_pos := -1 + 12
						when 112 then l_pos := -1 + 13
						when 114 then l_pos := -1 + 14
						when 115 then l_pos := -1 + 15
						else l_pos := -1 + 16
						end
				when 9 then -- switch 2, case 99
						l_mask := 16
						l_pos := -1 + 16 -- switch 2; break
				when 10 then -- switch 2, case 101
						l_mask := 64
						l_pos := -1 + 16 -- switch 2; break
				when 11 then -- switch 2, case 109
						l_mask := 4
						l_pos := -1 + 16 -- switch 2; break
				when 12 then -- switch 2, case 110
						l_mask := 1
						l_pos := -1 + 16 -- switch 2; break
				when 13 then -- switch 2, case 112
						l_mask := 32
						l_pos := -1 + 16 -- switch 2; break
				when 14 then -- switch 2, case 114
						l_mask := 2
						l_pos := -1 + 16 -- switch 2; break
				when 15 then -- switch 2, case 115
						l_mask := 8
						l_pos := -1 + 16 -- switch 2; break
				when 16 then -- switch 2, done: | if done
						if l_mask = 0 then
							l_tmp := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_invarg2.item)))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), l_flags___0).do_nothing
							update_class_fields -- Current might have been changed; synchronize
							l_dir___0 := 0
						else
							a_flagsp.item := (a_flagsp.item).bit_or (l_mask)
							update_class_fields -- Current might have been changed; synchronize
						end
				when 17 then -- switch 1, done:
						if l_dir___0 = 0 then
							l_break := True
						end
						if not (l_break) then
							l_flags___0 := l_flags___0 + 1
						end
						l_pos := -1 + 2 -- back to loop condition
				when 18 then -- loop done
						l_break := False
				when 19 then -- if done | if done
					if not l_return then
						Result := l_dir___0
					end
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	var2fpos (a_dollar_lnum: INTEGER_32; a_fnum___0: CE_POINTER [INTEGER_32]): CE_POINTER [PD_POS_T]
		local
			l_name___1: CE_POINTER [NATURAL_8]
			l_pp: CE_POINTER [PD_POS_T]
			l_l: CE_POINTER [PD_LISTVAR_S]
			l_len: INTEGER_32
			l_error: CE_ARRAY [INTEGER_32]
			l_li: CE_POINTER [PD_LISTITEM_S]
			l_tmp: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: NATURAL_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: NATURAL_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_error.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if v_type.to_integer_32 = 4 then
						l_error.item := 0
						update_class_fields -- Current might have been changed; synchronize
						l_l := vval.v_list
						if l_l.is_void then
							Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							pos.item.item.lnum := list_find_nr (l_l, 0, l_error)
							update_class_fields -- Current might have been changed; synchronize
							if (l_error.item).to_boolean then
								Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer))
								l_return := True
							elseif pos.item.item.lnum <= 0 then
								Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer))
								l_return := True
							elseif pos.item.item.lnum > (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count then
								Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer))
								l_return := True
							end
						end
						if not l_return then
							l_tmp := list_find_nr (l_l, 1, l_error)
							update_class_fields -- Current might have been changed; synchronize
							pos.item.item.col := l_tmp.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							if (l_error.item).to_boolean then
								Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer))
								l_return := True
							end
						end
						if not l_return then
							l_tmp___0 := (create {P_MEMLINE_STATIC}).ml_get (pos.item.item.lnum)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___1 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___0))
							update_class_fields -- Current might have been changed; synchronize
							l_len := (l_tmp___1.to_integer_32).to_integer_32
							l_li := (create {P_EVAL_STATIC}).list_find (l_l, 1)
							update_class_fields -- Current might have been changed; synchronize
							if not l_li.is_void then
								if (l_li.item.li_tv.v_type).to_integer_32 = 2 then
									if not (l_li.item.li_tv.vval.v_string).is_void then
										l_tmp___2 := strcmp (create {CE_INTEGER_8_POINTER}.make_cast (l_li.item.li_tv.vval.v_string), ce_string ("$"))
										update_class_fields -- Current might have been changed; synchronize
										if l_tmp___2 = 0 then
											pos.item.item.col := l_len + 1
											update_class_fields -- Current might have been changed; synchronize
										end
									end
								end
							end
							if pos.item.item.col = 0 then
								Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer))
								l_return := True
							elseif pos.item.item.col > l_len + 1 then
								Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer))
								l_return := True
							end
						end
						if not l_return then
							pos.item.item.col := (pos.item.item.col) - 1
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___3 := list_find_nr (l_l, 2, l_error)
							update_class_fields -- Current might have been changed; synchronize
							pos.item.item.coladd := l_tmp___3.to_integer_32
							update_class_fields -- Current might have been changed; synchronize
							if (l_error.item).to_boolean then
								pos.item.item.coladd := 0
								update_class_fields -- Current might have been changed; synchronize
							end
							Result := pos.item
							l_return := True
						end
					end
					if not l_return then
						l_name___1 := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.get_tv_string_chk
						update_class_fields -- Current might have been changed; synchronize
						if l_name___1.is_void then
							Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer))
							l_return := True
						end
					end
					if not l_return and then ((l_name___1[0]).to_integer_32 = 46) then
						Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")))
						l_return := True
					end
					if not l_return and then ((l_name___1[0]).to_integer_32 = 118) then
						if (l_name___1[1]).to_integer_32 = 0 then
							if ((create {P_GLOBALS_STATIC}).VIsual_active.item).to_boolean then
								Result := ((create {P_GLOBALS_STATIC}).VIsual.item)
								l_return := True
							end
							if not l_return then
								Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared ((create {P_GLOBALS_STATIC}).curwin.item.c_pointer + (create {PD_WINDOW_S}.make).offset_of ("w_cursor")))
								l_return := True
							end
						end
					end
					if not l_return and then ((l_name___1[0]).to_integer_32 = 39) then
						l_pp := (create {P_MARK_STATIC}).getmark_fnum ((l_name___1[1]).to_integer_32, 0, a_fnum___0)
						update_class_fields -- Current might have been changed; synchronize
						if l_pp.is_void then
							Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer))
							l_return := True
						elseif (l_pp.c_pointer.to_integer_32).to_natural_32 = ((create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer + -1)).c_pointer.to_integer_32).to_natural_32 then
							Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer))
							l_return := True
						elseif l_pp.item.lnum <= 0 then
							Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer))
							l_return := True
						end
						if not l_return then
							Result := l_pp
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						pos.item.item.coladd := 0
						update_class_fields -- Current might have been changed; synchronize
						if (l_name___1[0]).to_integer_32 /= 119 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						if a_dollar_lnum.to_boolean then
							pos.item.item.col := 0
							update_class_fields -- Current might have been changed; synchronize
							if (l_name___1[1]).to_integer_32 = 48 then
								(create {P_MOVE_STATIC}).update_topline
								update_class_fields -- Current might have been changed; synchronize
								pos.item.item.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_topline
								update_class_fields -- Current might have been changed; synchronize
								Result := pos.item
								l_return := True
							elseif (l_name___1[1]).to_integer_32 = 36 then
								(create {P_MOVE_STATIC}).validate_botline
								update_class_fields -- Current might have been changed; synchronize
								pos.item.item.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_botline - 1
								update_class_fields -- Current might have been changed; synchronize
								Result := pos.item
								l_return := True
							end
						else
							l_pos := -1 + 4 -- goto _L
						end
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 4 then -- else: | _L:
						if (l_name___1[0]).to_integer_32 = 36 then
							if a_dollar_lnum.to_boolean then
								pos.item.item.lnum := (create {P_GLOBALS_STATIC}).curbuf.item.item.b_ml.ml_line_count
								update_class_fields -- Current might have been changed; synchronize
								pos.item.item.col := 0
								update_class_fields -- Current might have been changed; synchronize
							else
								pos.item.item.lnum := (create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor.lnum
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___4 := (create {P_MEMLINE_STATIC}).ml_get_curline
								update_class_fields -- Current might have been changed; synchronize
								l_tmp___5 := strlen (create {CE_INTEGER_8_POINTER}.make_cast (l_tmp___4))
								update_class_fields -- Current might have been changed; synchronize
								pos.item.item.col := l_tmp___5.to_integer_32
								update_class_fields -- Current might have been changed; synchronize
							end
							Result := pos.item
							l_return := True
						end
				when 5 then -- if done
					if not l_return then
						Result := (create {CE_CLASS_POINTER [PD_POS_T]}.make_shared (default_pointer))
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	list2fpos (a_posp: CE_POINTER [PD_POS_T]; a_fnump: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_l: CE_POINTER [PD_LISTVAR_S]
			l_i___0: INTEGER_32
			l_n: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
			l_return: BOOLEAN
		do
			l_l := vval.v_list
			l_i___0 := 0
			if v_type.to_integer_32 /= 4 then
				Result := 0
				l_return := True
			elseif l_l.is_void then
				Result := 0
				l_return := True
			else
				if a_fnump.is_void then
					l_tmp := 2
				else
					l_tmp := 3
				end
				if l_l.item.lv_len < l_tmp then
					Result := 0
					l_return := True
				else
					if a_fnump.is_void then
						l_tmp___0 := 3
					else
						l_tmp___0 := 4
					end
					if l_l.item.lv_len > l_tmp___0 then
						Result := 0
						l_return := True
					end
				end
			end
			if not l_return and then (not a_fnump.is_void) then
				l_tmp___1 := l_i___0
				l_i___0 := l_i___0 + 1
				l_n := list_find_nr (l_l, l_tmp___1, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if l_n < 0 then
					Result := 0
					l_return := True
				end
				if not l_return then
					if l_n = 0 then
						l_n := ((create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum).to_integer_32
					end
					a_fnump.item := l_n.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
			end
			if not l_return then
				l_tmp___2 := l_i___0
				l_i___0 := l_i___0 + 1
				l_n := list_find_nr (l_l, l_tmp___2, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if l_n < 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				a_posp.item.lnum := l_n
				update_class_fields -- Current might have been changed; synchronize
				l_tmp___3 := l_i___0
				l_i___0 := l_i___0 + 1
				l_n := list_find_nr (l_l, l_tmp___3, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if l_n < 0 then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				a_posp.item.col := l_n.to_integer_32
				update_class_fields -- Current might have been changed; synchronize
				l_n := list_find_nr (l_l, l_i___0, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
				update_class_fields -- Current might have been changed; synchronize
				if l_n < 0 then
					a_posp.item.coladd := 0
					update_class_fields -- Current might have been changed; synchronize
				else
					a_posp.item.coladd := l_n.to_integer_32
					update_class_fields -- Current might have been changed; synchronize
				end
				Result := 1
			end
		end

	get_tv_number_chk (a_denote: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_n: CE_ARRAY [INTEGER_32]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n.item := 0
					update_class_fields -- Current might have been changed; synchronize
					inspect v_type.to_integer_32 -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 6 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					when 2 then l_pos := -1 + 4
					when 4 then l_pos := -1 + 5
					when 5 then l_pos := -1 + 6
					else l_pos := -1 + 7
					end
				when 1 then -- switch 1, case 1
					Result := (vval.v_number).to_integer_32
					l_return := True
				when 2 then -- switch 1, case 6
					if not l_return then
						l_tmp := gettext (ce_string ("E805: Using a Float as a Number"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 8 -- switch 1; break
				when 3 then -- switch 1, case 3
					l_tmp___0 := gettext (ce_string ("E703: Using a Funcref as a Number"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 2
					if not (vval.v_string).is_void then
						(create {P_CHARSET_STATIC}).vim_str2nr (vval.v_string, create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), create {CE_INTEGER_32_POINTER}.make_shared (default_pointer), 1, 1, l_n, create {CE_NATURAL_32_POINTER}.make_shared (default_pointer))
						update_class_fields -- Current might have been changed; synchronize
					end
					Result := (l_n.item)
					l_return := True
				when 5 then -- switch 1, case 4
					if not l_return then
						l_tmp___1 := gettext (ce_string ("E745: Using a List as a Number"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 5
					l_tmp___2 := gettext (ce_string ("E728: Using a Dictionary as a Number"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___2)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:
					l_tmp___3 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item)))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("get_tv_number()"))).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done:
					if not l_return then
						if a_denote.is_void then
							l_n.item := -1
							update_class_fields -- Current might have been changed; synchronize
						else
							a_denote.item := 1
							update_class_fields -- Current might have been changed; synchronize
						end
						Result := (l_n.item)
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_tv_string_buf_chk (a_buf___6: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: CE_POINTER [INTEGER_8]
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect v_type.to_integer_32 -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 3 then l_pos := -1 + 2
					when 4 then l_pos := -1 + 3
					when 5 then l_pos := -1 + 4
					when 6 then l_pos := -1 + 5
					when 2 then l_pos := -1 + 6
					else l_pos := -1 + 7
					end
				when 1 then -- switch 1, case 1
					sprintf ([create {CE_INTEGER_8_POINTER}.make_cast (a_buf___6), ce_string ("%%ld"), (vval.v_number).to_integer_32]).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					Result := a_buf___6
					l_return := True
				when 2 then -- switch 1, case 3
					if not l_return then
						l_tmp := gettext (ce_string ("E729: using Funcref as a String"))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 8 -- switch 1; break
				when 3 then -- switch 1, case 4
					l_tmp___0 := gettext (ce_string ("E730: using List as a String"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___0)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 8 -- switch 1; break
				when 4 then -- switch 1, case 5
					l_tmp___1 := gettext (ce_string ("E731: using Dictionary as a String"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 6
					l_tmp___2 := gettext (ce_string ("E806: using Float as a String"))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___2)).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 2
					if not (vval.v_string).is_void then
						Result := (vval.v_string)
						l_return := True
					end
					if not l_return then
						Result := (create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("")))
						l_return := True
					end
				when 7 then -- switch 1, default:
					if not l_return then
						l_tmp___3 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item)))
						update_class_fields; -- Current might have been changed; synchronize
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___3), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("get_tv_string_buf()"))).do_nothing
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done:
					if not l_return then
						Result := (create {CE_NATURAL_8_POINTER}.make_shared (default_pointer))
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	copy_tv (a_to: CE_POINTER [PD_TYPVAL_T])
		require
			not a_to.is_void
		local
			l_tmp: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_to.item.v_type := v_type
					update_class_fields -- Current might have been changed; synchronize
					a_to.item.v_lock := (0).to_integer_8
					update_class_fields -- Current might have been changed; synchronize
					inspect v_type.to_integer_32 -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 6 then l_pos := -1 + 2
					when 2 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 3
					when 4 then l_pos := -1 + 4
					when 5 then l_pos := -1 + 5
					else l_pos := -1 + 6
					end
				when 1 then -- switch 1, case 1
					a_to.item.vval.v_number := vval.v_number
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 7 -- switch 1; break
				when 2 then -- switch 1, case 6
					a_to.item.vval.v_float := vval.v_float
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 7 -- switch 1; break
				when 3 then -- switch 1, case 2 | switch 1, case 3
					if (vval.v_string).is_void then
						a_to.item.vval.v_string := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
					else
						a_to.item.vval.v_string := (create {P_MISC2_STATIC}).vim_strsave (vval.v_string)
						update_class_fields -- Current might have been changed; synchronize
						if v_type.to_integer_32 = 3 then
							func_ref (a_to.item.vval.v_string)
							update_class_fields -- Current might have been changed; synchronize
						end
					end
					l_pos := -1 + 7 -- switch 1; break
				when 4 then -- switch 1, case 4
					if (vval.v_list).is_void then
						a_to.item.vval.v_list := create {CE_CLASS_POINTER [PD_LISTVAR_S]}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
					else
						a_to.item.vval.v_list := vval.v_list
						update_class_fields; -- Current might have been changed; synchronize
						(a_to.item.vval.v_list).item.lv_refcount := ((a_to.item.vval.v_list).item.lv_refcount) + 1
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 7 -- switch 1; break
				when 5 then -- switch 1, case 5
					if (vval.v_dict).is_void then
						a_to.item.vval.v_dict := create {CE_CLASS_POINTER [PD_DICTVAR_S]}.make_shared (default_pointer)
						update_class_fields -- Current might have been changed; synchronize
					else
						a_to.item.vval.v_dict := vval.v_dict
						update_class_fields; -- Current might have been changed; synchronize
						(a_to.item.vval.v_dict).item.dv_refcount := ((a_to.item.vval.v_dict).item.dv_refcount) + 1
						update_class_fields -- Current might have been changed; synchronize
					end
					l_pos := -1 + 7 -- switch 1; break
				when 6 then -- switch 1, default:
					l_tmp := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item)))
					update_class_fields; -- Current might have been changed; synchronize
					(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("copy_tv()"))).do_nothing
					update_class_fields -- Current might have been changed; synchronize
					l_pos := -1 + 7 -- switch 1; break
				when 7 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eval6 (a_arg: CE_POINTER [CE_POINTER [NATURAL_8]]; a_evaluate, a_want_string: INTEGER_32): INTEGER_32
		local
			l_var2: CE_ARRAY [PD_TYPVAL_T]
			l_op: INTEGER_32
			l_n1: INTEGER_32
			l_n2: INTEGER_32
			l_use_float: INTEGER_32
			l_f1: REAL_64
			l_f2: REAL_64
			l_error: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_TYPVAL_T]} l_var2.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_error.make (<<1>>)

			l_use_float := 0
			l_f1 := (0).to_double
			l_error.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.eval7 (a_arg, a_evaluate, a_want_string)
			update_class_fields -- Current might have been changed; synchronize
			if l_tmp = 0 then
				Result := 0
				l_return := True
			end
			if not l_return then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_op := ((a_arg.item).item).to_integer_32
					if l_op /= 42 then
						if l_op /= 47 then
							if l_op /= 37 then
								l_break := True
							end
						end
					end
					if not (l_return or l_break) then
						if a_evaluate.to_boolean then
							if v_type.to_integer_32 = 6 then
								l_f1 := vval.v_float
								l_use_float := 1
								l_n1 := 0
							else
								l_n1 := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.get_tv_number_chk (l_error)
								update_class_fields -- Current might have been changed; synchronize
							end
							(create {P_EVAL_STATIC}).clear_tv ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)))
							update_class_fields -- Current might have been changed; synchronize
							if (l_error.item).to_boolean then
								Result := 0
								l_return := True
							end
						else
							l_n1 := 0
						end
						if not l_return then
							a_arg.item := (create {P_CHARSET_STATIC}).skipwhite (a_arg.item + 1)
							update_class_fields -- Current might have been changed; synchronize
							l_tmp___0 := l_var2.item.eval7 (a_arg, a_evaluate, 0)
							update_class_fields -- Current might have been changed; synchronize
							if l_tmp___0 = 0 then
								Result := 0
								l_return := True
							end
						end
						if not l_return and then (a_evaluate.to_boolean) then
							if (l_var2.item.v_type).to_integer_32 = 6 then
								if not l_use_float.to_boolean then
									l_f1 := l_n1.to_double
									l_use_float := 1
								end
								l_f2 := l_var2.item.vval.v_float
								l_n2 := 0
							else
								l_n2 := l_var2.item.get_tv_number_chk (l_error)
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_EVAL_STATIC}).clear_tv (l_var2)
								update_class_fields -- Current might have been changed; synchronize
								if (l_error.item).to_boolean then
									Result := 0
									l_return := True
								end
								if not l_return and then (l_use_float.to_boolean) then
									l_f2 := l_n2.to_double
								end
							end
							if not l_return then
								if l_use_float.to_boolean then
									if l_op = 42 then
										l_f1 := l_f1 * l_f2
									elseif l_op = 47 then
										l_f1 := l_f1 / l_f2
									else
										l_tmp___1 := gettext (ce_string ("E804: Cannot use %'%%%' with Float"))
										update_class_fields; -- Current might have been changed; synchronize
										(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
										update_class_fields -- Current might have been changed; synchronize
										Result := 0
										l_return := True
									end
									if not l_return then
										Current.v_type := (6).to_integer_8
										update_class_fields -- Current might have been changed; synchronize
										vval.v_float := l_f1
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									if l_op = 42 then
										l_n1 := l_n1 * l_n2
									elseif l_op = 47 then
										if l_n2 = 0 then
											if l_n1 = 0 then
												l_n1 := (-0x7fffffff - 1)
											elseif l_n1 < 0 then
												l_n1 := -2_147_483_647
											else
												l_n1 := 2_147_483_647
											end
										else
											l_n1 := l_n1 // l_n2
										end
									elseif l_n2 = 0 then
										l_n1 := 0
									else
										l_n1 := l_n1 \\ l_n2
									end
									Current.v_type := (1).to_integer_8
									update_class_fields -- Current might have been changed; synchronize
									vval.v_number := l_n1.to_integer_32
									update_class_fields -- Current might have been changed; synchronize
								end
							end
						end
					end
				end
			end
			if not l_return then
				l_break := False
				Result := 1
			end
		end

	find_win_by_nr (a_tp: CE_POINTER [PD_TABPAGE_S]): CE_POINTER [PD_WINDOW_S]
		local
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_nr: INTEGER_32
			l_tmp: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.get_tv_number_chk (create {CE_INTEGER_32_POINTER}.make_shared (default_pointer))
			update_class_fields -- Current might have been changed; synchronize
			l_nr := l_tmp.to_integer_32
			if l_nr < 0 then
				Result := (create {CE_CLASS_POINTER [PD_WINDOW_S]}.make_shared (default_pointer))
				l_return := True
			end
			if not l_return and then (l_nr = 0) then
				Result := ((create {P_GLOBALS_STATIC}).curwin.item)
				l_return := True
			end
			if not l_return then
				if a_tp.is_void then
					l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
				elseif a_tp.is_equal ((create {P_GLOBALS_STATIC}).curtab.item) then
					l_wp___0 := (create {P_GLOBALS_STATIC}).firstwin.item
				else
					l_wp___0 := a_tp.item.tp_firstwin
				end
				from
				until
					not (not (l_break) and then (not l_wp___0.is_void))
				loop
					l_break := False
					l_nr := l_nr - 1
					if l_nr <= 0 then
						l_break := True
					end
					if not (l_break) then
						l_wp___0 := l_wp___0.item.w_next
					end
				end
				l_break := False
				Result := l_wp___0
			end
		end

	get_tv_number: INTEGER_32
		local
			l_error: CE_ARRAY [INTEGER_32]
			l_tmp: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_error.make (<<1>>)

			l_error.item := 0
			update_class_fields -- Current might have been changed; synchronize
			l_tmp := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.get_tv_number_chk (l_error)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	get_tv_string_buf (a_buf___6: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_res: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [NATURAL_8]
			l_tmp___0: CE_POINTER [NATURAL_8]
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.get_tv_string_buf_chk (a_buf___6)
			update_class_fields -- Current might have been changed; synchronize
			l_res := l_tmp
			if not l_res.is_void then
				l_tmp___0 := l_res
			else
				l_tmp___0 := create {CE_NATURAL_8_POINTER}.make_cast (ce_string (""))
			end
			Result := l_tmp___0
		end

	get_tv_string_chk: CE_POINTER [NATURAL_8]
		local
			l_tmp: CE_POINTER [NATURAL_8]
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.get_tv_string_buf_chk (mybuf___0.item)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

	f_setpos (a_rettv: CE_POINTER [PD_TYPVAL_T])
		require
			not a_rettv.is_void
		local
			l_pos___3: CE_ARRAY [PD_POS_T]
			l_fnum___0: CE_ARRAY [INTEGER_32]
			l_name___1: CE_POINTER [NATURAL_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___0: INTEGER_32
			l_tmp___1: CE_POINTER [INTEGER_8]
			l_tmp___2: INTEGER_32
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_POS_T]} l_pos___3.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_fnum___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					a_rettv.item.vval.v_number := -1
					update_class_fields -- Current might have been changed; synchronize
					l_name___1 := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.get_tv_string_chk
					update_class_fields -- Current might have been changed; synchronize
					if l_name___1.is_void then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l_tmp___2 := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)) + 1).item.list2fpos (l_pos___3, l_fnum___0)
						update_class_fields -- Current might have been changed; synchronize
						if l_tmp___2 /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 2 then -- if:
						l_pos___3.item.col := (l_pos___3.item.col) - 1
						update_class_fields -- Current might have been changed; synchronize
						if l_pos___3.item.col < 0 then
							l_pos___3.item.col := 0
							update_class_fields -- Current might have been changed; synchronize
						end
						if (l_name___1[0]).to_integer_32 /= 46 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_name___1[1]).to_integer_32 = 0 then
							if l_fnum___0.item = (create {P_GLOBALS_STATIC}).curbuf.item.item.b_fnum then
								(create {P_GLOBALS_STATIC}).curwin.item.item.w_cursor := (l_pos___3.item).twin
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MISC2_STATIC}).check_cursor
								update_class_fields -- Current might have been changed; synchronize
								a_rettv.item.vval.v_number := 0
								update_class_fields -- Current might have been changed; synchronize
							else
								l_tmp := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_invarg.item)))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if (l_name___1[0]).to_integer_32 = 39 then
							if (l_name___1[1]).to_integer_32 /= 0 then
								if (l_name___1[2]).to_integer_32 = 0 then
									l_tmp___0 := (create {P_MARK_STATIC}).setmark_pos ((l_name___1[1]).to_integer_32, l_pos___3, l_fnum___0.item)
									update_class_fields -- Current might have been changed; synchronize
									if l_tmp___0 = 1 then
										a_rettv.item.vval.v_number := 0
										update_class_fields -- Current might have been changed; synchronize
									end
								else
									l_tmp___1 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_invarg.item)))
									update_class_fields; -- Current might have been changed; synchronize
									(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
									update_class_fields -- Current might have been changed; synchronize
								end
							else
								l_tmp___1 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_invarg.item)))
								update_class_fields; -- Current might have been changed; synchronize
								(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
								update_class_fields -- Current might have been changed; synchronize
							end
						else
							l_tmp___1 := gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_invarg.item)))
							update_class_fields; -- Current might have been changed; synchronize
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast (l_tmp___1)).do_nothing
							update_class_fields -- Current might have been changed; synchronize
						end
				when 6 then -- if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	f_setreg (a_rettv: CE_POINTER [PD_TYPVAL_T])
		require
			not a_rettv.is_void
		local
			l_regname___0: INTEGER_32
			l_strregname: CE_POINTER [NATURAL_8]
			l_stropt: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_strval: CE_POINTER [NATURAL_8]
			l_append: INTEGER_32
			l_yank_type: NATURAL_8
			l_block_len: INTEGER_32
			l_tmp: INTEGER_32
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_stropt.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_block_len := -1
					l_yank_type := (255).to_natural_8
					l_append := 0
					l_strregname := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.get_tv_string_chk
					update_class_fields -- Current might have been changed; synchronize
					a_rettv.item.vval.v_number := 1
					update_class_fields -- Current might have been changed; synchronize
					if l_strregname.is_void then
						l_return := True
					end
					if not l_return then
						l_regname___0 := (l_strregname.item).to_integer_32
						if l_regname___0 = 0 then
							l_regname___0 := ('%"').code
						elseif l_regname___0 = 64 then
							l_regname___0 := ('%"').code
						elseif l_regname___0 = 61 then
							l_return := True
						end
					end
					if not (not l_return and then ((((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)) + 2).item.v_type).to_integer_32 /= 0)) then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						l_stropt.item := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)) + 2).item.get_tv_string_chk
						update_class_fields -- Current might have been changed; synchronize
						if (l_stropt.item).is_void then
							l_return := True
						end
						if l_return then
							l_pos := -1 + 9 -- skip if block
						end
				when 2 then -- if: | loop condition:
						if (l_stropt.item.item).to_integer_32 = 0 then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						inspect (l_stropt.item.item).to_integer_32 -- switch 1 head
						when 97 then l_pos := -1 + 4
						when 65 then l_pos := -1 + 4
						when 118 then l_pos := -1 + 5
						when 99 then l_pos := -1 + 5
						when 86 then l_pos := -1 + 6
						when 108 then l_pos := -1 + 6
						when 98 then l_pos := -1 + 7
						when 22 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 4 then -- switch 1, case 97 | switch 1, case 65
						l_append := 1
						l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 118 | switch 1, case 99
						l_yank_type := (0).to_natural_8
						l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 86 | switch 1, case 108
						l_yank_type := (1).to_natural_8
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, case 98 | switch 1, case 22
						l_yank_type := (2).to_natural_8
						if (l_stropt.item[1]).to_integer_32 >= 48 then
							if (l_stropt.item[1]).to_integer_32 <= 57 then
								l_stropt.item := l_stropt.item + 1
								update_class_fields -- Current might have been changed; synchronize
								l_tmp := (create {P_CHARSET_STATIC}).getdigits (l_stropt)
								update_class_fields -- Current might have been changed; synchronize
								l_block_len := l_tmp - 1
								l_stropt.item := l_stropt.item - 1
								update_class_fields -- Current might have been changed; synchronize
							end
						end
						l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done:
						l_stropt.item := l_stropt.item + 1
						update_class_fields -- Current might have been changed; synchronize
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done | if done | if done
					if not l_return then
						l_strval := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer)) + 1).item.get_tv_string_chk
						update_class_fields -- Current might have been changed; synchronize
						if not l_strval.is_void then
							(create {P_OPS_STATIC}).write_reg_contents_ex (l_regname___0, l_strval, -1, l_append, l_yank_type.to_integer_32, l_block_len)
							update_class_fields -- Current might have been changed; synchronize
						end
						a_rettv.item.vval.v_number := 0
						update_class_fields -- Current might have been changed; synchronize
					end
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_tv_string: CE_POINTER [NATURAL_8]
		local
			l_tmp: CE_POINTER [NATURAL_8]
		do
			l_tmp := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (c_pointer))).item.get_tv_string_buf (mybuf.item)
			update_class_fields -- Current might have been changed; synchronize
			Result := l_tmp
		end

feature {PD_TYPVAL_T} -- private routines

	list_find_nr (a_l: CE_POINTER [PD_LISTVAR_S]; a_idx: INTEGER_32; a_errorp: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_li: CE_POINTER [PD_LISTITEM_S]
			l_return: BOOLEAN
		do
			l_li := (create {P_EVAL_STATIC}).list_find (a_l, a_idx)
			if l_li.is_void then
				if not a_errorp.is_void then
					a_errorp.item := 1
				end
				Result := (-1)
				l_return := True
			end
			if not l_return then
				Result := ((create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_li.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv"))).item.get_tv_number_chk (a_errorp))
			end
		end

	string_quote (a_str___1: CE_POINTER [NATURAL_8]; a_function: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_len: NATURAL_32
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_r: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_s: CE_POINTER [NATURAL_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_tmp___8: CE_POINTER [NATURAL_8]
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_r.make (<<1>>)

			if a_function.to_boolean then
				l_len := {NATURAL_32} 13
			else
				l_len := {NATURAL_32} 3
			end
			if not a_str___1.is_void then
				l_len := l_len + (strlen (create {CE_INTEGER_8_POINTER}.make_cast (a_str___1)))
				l_p___0.item := a_str___1
				from
				until
					(l_p___0.item.item).to_integer_32 = 0
				loop
					if (l_p___0.item.item).to_integer_32 = 39 then
						l_len := l_len + 1
					end
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___1 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0.item]))
					else
						l_tmp___1 := 1
					end
					l_p___0.item := l_p___0.item + l_tmp___1
				end
			end
			l_r.item := (create {P_MISC2_STATIC}).alloc (l_len)
			l_s := l_r.item
			if not (l_r.item).is_void then
				if a_function.to_boolean then
					strcpy (create {CE_INTEGER_8_POINTER}.make_cast (l_r.item), ce_string ("function(%'")).do_nothing
					l_r.item := l_r.item + (10)
				else
					l_tmp___2 := l_r.item
					l_r.item := l_r.item + 1
					l_tmp___2.item := (('%'').code).to_natural_8
				end
				if not a_str___1.is_void then
					l_p___0.item := a_str___1
					from
					until
						(l_p___0.item.item).to_integer_32 = 0
					loop
						if (l_p___0.item.item).to_integer_32 = 39 then
							l_tmp___3 := l_r.item
							l_r.item := l_r.item + 1
							l_tmp___3.item := (('%'').code).to_natural_8
						end
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							(create {P_MBYTE_STATIC}).mb_copy_char (l_p___0, l_r)
						else
							l_tmp___4 := l_r.item
							l_r.item := l_r.item + 1
							l_tmp___5 := l_p___0.item
							l_p___0.item := l_p___0.item + 1
							l_tmp___4.item := l_tmp___5.item
						end
					end
				end
				l_tmp___6 := l_r.item
				l_r.item := l_r.item + 1
				l_tmp___6.item := (('%'').code).to_natural_8
				if a_function.to_boolean then
					l_tmp___7 := l_r.item
					l_r.item := l_r.item + 1
					l_tmp___7.item := ((')').code).to_natural_8
				end
				l_tmp___8 := l_r.item
				l_r.item := l_r.item + 1
				l_tmp___8.item := (('%/0/').code).to_natural_8
			end
			Result := l_s
		end

	get_string_tv (a_arg: CE_POINTER [CE_POINTER [NATURAL_8]]; a_rettv: CE_POINTER [PD_TYPVAL_T]; a_evaluate: INTEGER_32): INTEGER_32
		require
			not a_arg.is_void
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_name___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_extra: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_tmp___5: CE_POINTER [NATURAL_8]
			l_tmp___6: CE_POINTER [NATURAL_8]
			l_tmp___7: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_nr: INTEGER_32
			l_c: INTEGER_32
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___14: CE_POINTER [NATURAL_8]
			l_tmp___15: CE_POINTER [NATURAL_8]
			l_tmp___16: CE_POINTER [NATURAL_8]
			l_tmp___17: CE_POINTER [NATURAL_8]
			l_tmp___18: CE_POINTER [NATURAL_8]
			l_tmp___19: CE_POINTER [NATURAL_8]
			l_tmp___20: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_name___1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_extra := 0
					l_p___0.item := a_arg.item + 1
					from
					until
						(l_break)
					loop
						l_break := False
						if (l_p___0.item.item).to_integer_32 /= 0 then
							if (l_p___0.item.item).to_integer_32 = 34 then
								l_break := True
							end
						else
							l_break := True
						end
						if not (l_break) then
							if (l_p___0.item.item).to_integer_32 = 92 then
								if (l_p___0.item[1]).to_integer_32 /= 0 then
									l_p___0.item := l_p___0.item + 1
									if (l_p___0.item.item).to_integer_32 = 60 then
										l_extra := l_extra + (2)
									end
								end
							end
							if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
								l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0.item]))
							else
								l_tmp___0 := 1
							end
							l_p___0.item := l_p___0.item + l_tmp___0
						end
					end
					l_break := False
					if (l_p___0.item.item).to_integer_32 /= 34 then
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E114: Missing quote: %%s")))), a_arg.item).do_nothing
						Result := 0
						l_return := True
					end
					if not l_return and then (not a_evaluate.to_boolean) then
						a_arg.item := l_p___0.item + 1
						Result := 1
						l_return := True
					end
					if not l_return then
						l_name___1.item := (create {P_MISC2_STATIC}).alloc ((((l_p___0.item).distance ((a_arg.item))) + l_extra).to_natural_32)
						if (l_name___1.item).is_void then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						a_rettv.item.v_type := (2).to_integer_8
						a_rettv.item.vval.v_string := l_name___1.item
						l_p___0.item := a_arg.item + 1
				when 2 then -- loop condition:
						if (l_return or l_break) then
							l_pos := -1 + 19 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if (l_p___0.item.item).to_integer_32 /= 0 then
							if (l_p___0.item.item).to_integer_32 = 34 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_return or l_break) then
							l_pos := -1 + 18 -- skip if block
						end
				when 4 then -- if:
						if (l_p___0.item.item).to_integer_32 /= 92 then
							l_pos := -1 + 17 -- skip if block
						end
				when 5 then -- if:
						l_p___0.item := l_p___0.item + 1
						inspect (l_p___0.item.item).to_integer_32 -- switch 1 head
						when 98 then l_pos := -1 + 6
						when 101 then l_pos := -1 + 7
						when 102 then l_pos := -1 + 8
						when 110 then l_pos := -1 + 9
						when 114 then l_pos := -1 + 10
						when 116 then l_pos := -1 + 11
						when 88 then l_pos := -1 + 12
						when 120 then l_pos := -1 + 12
						when 117 then l_pos := -1 + 12
						when 85 then l_pos := -1 + 12
						when 48 then l_pos := -1 + 13
						when 49 then l_pos := -1 + 13
						when 50 then l_pos := -1 + 13
						when 51 then l_pos := -1 + 13
						when 52 then l_pos := -1 + 13
						when 53 then l_pos := -1 + 13
						when 54 then l_pos := -1 + 13
						when 55 then l_pos := -1 + 13
						when 60 then l_pos := -1 + 14
						else l_pos := -1 + 15
						end
				when 6 then -- switch 1, case 98
						l_tmp___2 := l_name___1.item
						l_name___1.item := l_name___1.item + 1
						l_tmp___2.item := (('%B').code).to_natural_8
						l_p___0.item := l_p___0.item + 1
						l_pos := -1 + 16 -- switch 1; break
				when 7 then -- switch 1, case 101
						l_tmp___3 := l_name___1.item
						l_name___1.item := l_name___1.item + 1
						l_tmp___3.item := (('%/27/').code).to_natural_8
						l_p___0.item := l_p___0.item + 1
						l_pos := -1 + 16 -- switch 1; break
				when 8 then -- switch 1, case 102
						l_tmp___4 := l_name___1.item
						l_name___1.item := l_name___1.item + 1
						l_tmp___4.item := (('%F').code).to_natural_8
						l_p___0.item := l_p___0.item + 1
						l_pos := -1 + 16 -- switch 1; break
				when 9 then -- switch 1, case 110
						l_tmp___5 := l_name___1.item
						l_name___1.item := l_name___1.item + 1
						l_tmp___5.item := (('%N').code).to_natural_8
						l_p___0.item := l_p___0.item + 1
						l_pos := -1 + 16 -- switch 1; break
				when 10 then -- switch 1, case 114
						l_tmp___6 := l_name___1.item
						l_name___1.item := l_name___1.item + 1
						l_tmp___6.item := (('%R').code).to_natural_8
						l_p___0.item := l_p___0.item + 1
						l_pos := -1 + 16 -- switch 1; break
				when 11 then -- switch 1, case 116
						l_tmp___7 := l_name___1.item
						l_name___1.item := l_name___1.item + 1
						l_tmp___7.item := (('%T').code).to_natural_8
						l_p___0.item := l_p___0.item + 1
						l_pos := -1 + 16 -- switch 1; break
				when 12 then -- switch 1, case 88 | switch 1, case 120 | switch 1, case 117 | switch 1, case 85
						if ((create {P_CHARSET_STATIC}).vim_isxdigit ((l_p___0.item[1]).to_integer_32)).to_boolean then
							l_c := (toupper ((l_p___0.item.item).to_integer_32))
							if l_c = 88 then
								l_n := 2
							else
								l_n := 4
							end
							l_nr := 0
							from
							until
								(l_break)
							loop
								l_break := False
								l_n := l_n - 1
								if l_n >= 0 then
									if not ((create {P_CHARSET_STATIC}).vim_isxdigit ((l_p___0.item[1]).to_integer_32)).to_boolean then
										l_break := True
									end
								else
									l_break := True
								end
								if not (l_break) then
									l_p___0.item := l_p___0.item + 1
									l_nr := ((l_nr).bit_shift_left (4)) + ((create {P_CHARSET_STATIC}).hex2nr ((l_p___0.item.item).to_integer_32))
								end
							end
							l_break := False
							l_p___0.item := l_p___0.item + 1
							if l_c /= 88 then
								l_name___1.item := l_name___1.item + ((create {P_GLOBALS_STATIC}).mb_char2bytes.item.integer_32_item ([l_nr, l_name___1.item]))
							else
								l_tmp___12 := l_name___1.item
								l_name___1.item := l_name___1.item + 1
								l_tmp___12.item := l_nr.to_natural_8
							end
						end
						l_pos := -1 + 16 -- switch 1; break
				when 13 then -- switch 1, case 48 | switch 1, case 49 | switch 1, case 50 | switch 1, case 51 | switch 1, case 52 | switch 1, case 53 | switch 1, case 54 | switch 1, case 55
						l_tmp___14 := l_p___0.item
						l_p___0.item := l_p___0.item + 1
						l_name___1.item.item := ((l_tmp___14.item).to_integer_32 - 48).to_natural_8
						if (l_p___0.item.item).to_integer_32 >= 48 then
							if (l_p___0.item.item).to_integer_32 <= 55 then
								l_tmp___15 := l_p___0.item
								l_p___0.item := l_p___0.item + 1
								l_name___1.item.item := (((((l_name___1.item.item).to_integer_32).bit_shift_left (3)) + (l_tmp___15.item).to_integer_32) - 48).to_natural_8
								if (l_p___0.item.item).to_integer_32 >= 48 then
									if (l_p___0.item.item).to_integer_32 <= 55 then
										l_tmp___16 := l_p___0.item
										l_p___0.item := l_p___0.item + 1
										l_name___1.item.item := (((((l_name___1.item.item).to_integer_32).bit_shift_left (3)) + (l_tmp___16.item).to_integer_32) - 48).to_natural_8
									end
								end
							end
						end
						l_name___1.item := l_name___1.item + 1
						l_pos := -1 + 16 -- switch 1; break
				when 14 then -- switch 1, case 60
						l_extra := (create {P_MISC2_STATIC}).trans_special (l_p___0, l_name___1.item, 1)
						if l_extra /= 0 then
							l_name___1.item := l_name___1.item + l_extra
							l_pos := -1 + 16 -- switch 1; break
						end
				when 15 then -- switch 1, default:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							(create {P_MBYTE_STATIC}).mb_copy_char (l_p___0, l_name___1)
						else
							l_tmp___17 := l_name___1.item
							l_name___1.item := l_name___1.item + 1
							l_tmp___18 := l_p___0.item
							l_p___0.item := l_p___0.item + 1
							l_tmp___17.item := l_tmp___18.item
						end
						l_pos := -1 + 16 -- switch 1; break
				when 16 then -- switch 1, done: | if block done, skip else block:
						l_pos := -1 + 18
				when 17 then -- else:
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							(create {P_MBYTE_STATIC}).mb_copy_char (l_p___0, l_name___1)
						else
							l_tmp___19 := l_name___1.item
							l_name___1.item := l_name___1.item + 1
							l_tmp___20 := l_p___0.item
							l_p___0.item := l_p___0.item + 1
							l_tmp___19.item := l_tmp___20.item
						end
				when 18 then -- if done | if done
						l_pos := -1 + 2 -- back to loop condition
				when 19 then -- loop done
						l_break := False
						l_name___1.item.item := (('%/0/').code).to_natural_8
						a_arg.item := l_p___0.item + 1
						Result := 1
				when 20 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_lit_string_tv (a_arg: CE_POINTER [CE_POINTER [NATURAL_8]]; a_rettv: CE_POINTER [PD_TYPVAL_T]; a_evaluate: INTEGER_32): INTEGER_32
		require
			not a_arg.is_void
		local
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_str___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_reduce: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_8]} l_p___0.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_str___1.make (<<1>>)

			l_reduce := 0
			l_p___0.item := a_arg.item + 1
			from
			until
				not (not (l_break) and then ((l_p___0.item.item).to_integer_32 /= 0))
			loop
				l_break := False
				if (l_p___0.item.item).to_integer_32 = 39 then
					if (l_p___0.item[1]).to_integer_32 /= 39 then
						l_break := True
					end
					if not (l_break) then
						l_reduce := l_reduce + 1
						l_p___0.item := l_p___0.item + 1
					end
				end
				if not (l_break) then
					if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
						l_tmp___0 := ((create {P_GLOBALS_STATIC}).mb_ptr2len.item.integer_32_item ([l_p___0.item]))
					else
						l_tmp___0 := 1
					end
					l_p___0.item := l_p___0.item + l_tmp___0
				end
			end
			l_break := False
			if (l_p___0.item.item).to_integer_32 /= 39 then
				(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E115: Missing quote: %%s")))), a_arg.item).do_nothing
				Result := 0
				l_return := True
			end
			if not l_return and then (not a_evaluate.to_boolean) then
				a_arg.item := l_p___0.item + 1
				Result := 1
				l_return := True
			end
			if not l_return then
				l_str___1.item := (create {P_MISC2_STATIC}).alloc ((((l_p___0.item).distance ((a_arg.item))) - l_reduce).to_natural_32)
				if (l_str___1.item).is_void then
					Result := 0
					l_return := True
				end
			end
			if not l_return then
				a_rettv.item.v_type := (2).to_integer_8
				a_rettv.item.vval.v_string := l_str___1.item
				l_p___0.item := a_arg.item + 1
				from
				until
					not (not (l_break) and then ((l_p___0.item.item).to_integer_32 /= 0))
				loop
					l_break := False
					if (l_p___0.item.item).to_integer_32 = 39 then
						if (l_p___0.item[1]).to_integer_32 /= 39 then
							l_break := True
						end
						if not (l_break) then
							l_p___0.item := l_p___0.item + 1
						end
					end
					if not (l_break) then
						if ((create {P_GLOBALS_STATIC}).has_mbyte.item).to_boolean then
							(create {P_MBYTE_STATIC}).mb_copy_char (l_p___0, l_str___1)
						else
							l_tmp___2 := l_str___1.item
							l_str___1.item := l_str___1.item + 1
							l_tmp___3 := l_p___0.item
							l_p___0.item := l_p___0.item + 1
							l_tmp___2.item := l_tmp___3.item
						end
					end
				end
				l_break := False
				l_str___1.item.item := (('%/0/').code).to_natural_8
				a_arg.item := l_p___0.item + 1
				Result := 1
			end
		end

	get_list_tv (a_arg: CE_POINTER [CE_POINTER [NATURAL_8]]; a_rettv: CE_POINTER [PD_TYPVAL_T]; a_evaluate: INTEGER_32): INTEGER_32
		local
			l_l: CE_POINTER [PD_LISTVAR_S]
			l_tv: CE_ARRAY [PD_TYPVAL_T]
			l_item: CE_POINTER [PD_LISTITEM_S]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_TYPVAL_T]} l_tv.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_l := create {CE_CLASS_POINTER [PD_LISTVAR_S]}.make_shared (default_pointer)
					if a_evaluate.to_boolean then
						l_l := (create {P_EVAL_STATIC}).list_alloc
						if l_l.is_void then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 13 -- skip if block
					end
				when 1 then -- if:
						a_arg.item := (create {P_CHARSET_STATIC}).skipwhite (a_arg.item + 1)
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if ((a_arg.item).item).to_integer_32 /= 93 then
							if ((a_arg.item).item).to_integer_32 = 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if ((create {P_EVAL_STATIC}).eval1 (a_arg, l_tv, a_evaluate)) = 0 then
							l_pos := -1 + 12 -- goto failret
						end
				when 5 then
						if a_evaluate.to_boolean then
							l_item := (create {P_EVAL_STATIC}).listitem_alloc
							if not l_item.is_void then
								l_item.item.li_tv := (l_tv.item).twin
								l_item.item.li_tv.v_lock := (0).to_integer_8
								l_l.item.list_append (l_item)
							else
								(create {P_EVAL_STATIC}).clear_tv (l_tv)
							end
						end
						if ((a_arg.item).item).to_integer_32 = 93 then
							l_break := True
						end
				when 6 then -- if done
						if (l_break) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if ((a_arg.item).item).to_integer_32 /= 44 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E696: Missing comma in List: %%s")))), a_arg.item).do_nothing
							l_pos := -1 + 12 -- goto failret
						end
				when 8 then
						a_arg.item := (create {P_CHARSET_STATIC}).skipwhite (a_arg.item + 1)
				when 9 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done
						l_break := False
						if ((a_arg.item).item).to_integer_32 = 93 then
							l_pos := -1 + 13 -- skip if block
						end
				when 11 then -- if:;
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E697: Missing end of List %']%': %%s")))), a_arg.item).do_nothing
				when 12 then -- failret:
						if a_evaluate.to_boolean then
							l_l.item.list_free (1)
						end
						Result := 0
						l_return := True
				when 13 then -- if done | if done
					if not l_return then
						a_arg.item := (create {P_CHARSET_STATIC}).skipwhite (a_arg.item + 1)
						if a_evaluate.to_boolean then
							a_rettv.item.v_type := (4).to_integer_8
							a_rettv.item.vval.v_list := l_l
							l_l.item.lv_refcount := (l_l.item.lv_refcount) + 1
						end
						Result := 1
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	set_ref_in_list (a_l: CE_POINTER [PD_LISTVAR_S]; a_copyID: INTEGER_32)
		require
			not a_l.is_void
		local
			l_li: CE_POINTER [PD_LISTITEM_S]
		do
			l_li := a_l.item.lv_first
			from
			until
				l_li.is_void
			loop
				(create {CE_CLASS_POINTER [PD_TYPVAL_T]}.make_shared (l_li.c_pointer + (create {PD_LISTITEM_S}.make).offset_of ("li_tv"))).item.set_ref_in_item (a_copyID)
				l_li := l_li.item.li_next
			end
		end

	get_dict_tv (a_arg: CE_POINTER [CE_POINTER [NATURAL_8]]; a_rettv: CE_POINTER [PD_TYPVAL_T]; a_evaluate: INTEGER_32): INTEGER_32
		require
			not a_arg.is_void
		local
			l_d: CE_POINTER [PD_DICTVAR_S]
			l_tvkey: CE_ARRAY [PD_TYPVAL_T]
			l_tv: CE_ARRAY [PD_TYPVAL_T]
			l_key: CE_POINTER [NATURAL_8]
			l_item: CE_POINTER [PD_DICTITEM_S]
			l_start___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_buf___6: CE_ARRAY [NATURAL_8]
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_TYPVAL_T]} l_tvkey.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_TYPVAL_T]} l_tv.make (<<1>>)
			create {CE_POINTER_ARRAY [NATURAL_8]} l_start___1.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_buf___6.make (<<30>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_d := create {CE_CLASS_POINTER [PD_DICTVAR_S]}.make_shared (default_pointer)
					l_key := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_start___1.item := ((create {P_CHARSET_STATIC}).skipwhite (a_arg.item + 1))
					if (l_start___1.item.item).to_integer_32 /= 125 then
						if ((create {P_EVAL_STATIC}).eval1 (l_start___1, l_tv, 0)) = 0 then
							Result := 0
							l_return := True
						end
						if not l_return and then ((l_start___1.item.item).to_integer_32 = 125) then
							Result := 2
							l_return := True
						end
					end
					if not l_return and then (a_evaluate.to_boolean) then
						l_d := (create {P_EVAL_STATIC}).dict_alloc
						if l_d.is_void then
							Result := 0
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 24 -- skip if block
					end
				when 1 then -- if:
						l_tvkey.item.v_type := (0).to_integer_8
						l_tv.item.v_type := (0).to_integer_8
						a_arg.item := (create {P_CHARSET_STATIC}).skipwhite (a_arg.item + 1)
				when 2 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 21 -- skip loop
						end
				when 3 then -- loop body:
						l_break := False
						if ((a_arg.item).item).to_integer_32 /= 125 then
							if ((a_arg.item).item).to_integer_32 = 0 then
								l_break := True
							end
						else
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 17 -- skip if block
						end
				when 4 then -- if:
						if ((create {P_EVAL_STATIC}).eval1 (a_arg, l_tvkey, a_evaluate)) = 0 then
							l_pos := -1 + 23 -- goto failret
						end
				when 5 then
						if ((a_arg.item).item).to_integer_32 /= 58 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E720: Missing colon in Dictionary: %%s")))), a_arg.item).do_nothing;
							(create {P_EVAL_STATIC}).clear_tv (l_tvkey)
							l_pos := -1 + 23 -- goto failret
						end
				when 6 then
						if not (a_evaluate.to_boolean) then
							l_pos := -1 + 12 -- skip if block
						end
				when 7 then -- if:
						l_key := l_tvkey.item.get_tv_string_buf_chk (l_buf___6)
						if not (l_key.is_void) then
							l_pos := -1 + 10 -- skip if block
						end
				when 8 then -- if:
						l_pos := -1 + 11 -- goto _L
				when 9 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 10 then -- else:
						if (l_key.item).to_integer_32 /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | _L:
						if not l_key.is_void then
							(create {P_MESSAGE_STATIC}).emsg (create {CE_NATURAL_8_POINTER}.make_cast ((gettext ((create {P_EVAL_STATIC}).e_emptykey.item)))).do_nothing
						end
						(create {P_EVAL_STATIC}).clear_tv (l_tvkey)
						l_pos := -1 + 23 -- goto failret
				when 12 then -- if done | if done
						a_arg.item := (create {P_CHARSET_STATIC}).skipwhite (a_arg.item + 1)
						if ((create {P_EVAL_STATIC}).eval1 (a_arg, l_tv, a_evaluate)) = 0 then
							if a_evaluate.to_boolean then
								(create {P_EVAL_STATIC}).clear_tv (l_tvkey)
							end
							l_pos := -1 + 23 -- goto failret
						end
				when 13 then
						if not (a_evaluate.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 14 then -- if:
						l_item := (create {P_EVAL_STATIC}).dict_find (l_d, l_key, -1)
						if not l_item.is_void then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E721: Duplicate key in Dictionary: %"%%s%"")))), l_key).do_nothing;
							(create {P_EVAL_STATIC}).clear_tv (l_tvkey);
							(create {P_EVAL_STATIC}).clear_tv (l_tv)
							l_pos := -1 + 23 -- goto failret
						end
				when 15 then
						l_item := (create {P_EVAL_STATIC}).dictitem_alloc (l_key);
						(create {P_EVAL_STATIC}).clear_tv (l_tvkey)
						if not l_item.is_void then
							l_item.item.di_tv := (l_tv.item).twin
							l_item.item.di_tv.v_lock := (0).to_integer_8
							if ((create {P_EVAL_STATIC}).dict_add (l_d, l_item)) = 0 then
								(create {P_EVAL_STATIC}).dictitem_free (l_item)
							end
						end
				when 16 then -- if done
						if ((a_arg.item).item).to_integer_32 = 125 then
							l_break := True
						end
				when 17 then -- if done
						if (l_break) then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if:
						if ((a_arg.item).item).to_integer_32 /= 44 then
							(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E722: Missing comma in Dictionary: %%s")))), a_arg.item).do_nothing
							l_pos := -1 + 23 -- goto failret
						end
				when 19 then
						a_arg.item := (create {P_CHARSET_STATIC}).skipwhite (a_arg.item + 1)
				when 20 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 21 then -- loop done
						l_break := False
						if ((a_arg.item).item).to_integer_32 = 125 then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:;
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (ce_string ("E723: Missing end of Dictionary %'}%': %%s")))), a_arg.item).do_nothing
				when 23 then -- failret:
						if a_evaluate.to_boolean then
							l_d.item.dict_free (1)
						end
						Result := 0
						l_return := True
				when 24 then -- if done | if done
					if not l_return then
						a_arg.item := (create {P_CHARSET_STATIC}).skipwhite (a_arg.item + 1)
						if a_evaluate.to_boolean then
							a_rettv.item.v_type := (5).to_integer_8
							a_rettv.item.vval.v_dict := l_d
							l_d.item.dv_refcount := (l_d.item.dv_refcount) + 1
						end
						Result := 1
					end
				when 25 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	get_env_tv (a_arg: CE_POINTER [CE_POINTER [NATURAL_8]]; a_rettv: CE_POINTER [PD_TYPVAL_T]; a_evaluate: INTEGER_32): INTEGER_32
		require
			not a_arg.is_void
		local
			l_string___0: CE_POINTER [NATURAL_8]
			l_len: INTEGER_32
			l_cc___0: INTEGER_32
			l_name___1: CE_POINTER [NATURAL_8]
			l_mustfree: CE_ARRAY [INTEGER_32]
			l_pos: INTEGER_32
		do
			create {CE_INTEGER_32_ARRAY} l_mustfree.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_string___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
					l_mustfree.item := 0
					a_arg.item := (a_arg.item) + 1
					l_name___1 := a_arg.item
					l_len := (create {P_EVAL_STATIC}).get_env_len (a_arg)
					if not (a_evaluate.to_boolean) then
						l_pos := -1 + 8 -- skip if block
					end
				when 1 then -- if:
						if l_len = 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 2 then -- if:
						l_cc___0 := (l_name___1[l_len]).to_integer_32
						l_name___1[l_len] := (('%/0/').code).to_natural_8
						l_string___0 := (create {P_MISC1_STATIC}).vim_getenv (l_name___1, l_mustfree)
						if l_string___0.is_void then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (l_string___0.item).to_integer_32 /= 0 then
							if not (l_mustfree.item).to_boolean then
								l_string___0 := (create {P_MISC2_STATIC}).vim_strsave (l_string___0)
							end
						else
							l_pos := -1 + 5 -- goto _L
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 5 then -- else: | _L:
						if (l_mustfree.item).to_boolean then
							(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_string___0))
						end
						l_string___0 := (create {P_MISC1_STATIC}).expand_env_save (l_name___1 - 1)
						if not l_string___0.is_void then
							if (l_string___0.item).to_integer_32 = 36 then
								(create {P_MISC2_STATIC}).vim_free (create {CE_VOID_POINTER}.make_cast (l_string___0))
								l_string___0 := create {CE_NATURAL_8_POINTER}.make_shared (default_pointer)
							end
						end
				when 6 then
						l_name___1[l_len] := l_cc___0.to_natural_8
				when 7 then -- if done
						a_rettv.item.v_type := (2).to_integer_8
						a_rettv.item.vval.v_string := l_string___0
				when 8 then -- if done
					Result := 1
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	func_ref (a_name___1: CE_POINTER [NATURAL_8])
		local
			l_fp: CE_POINTER [PD_UFUNC]
		do
			if not a_name___1.is_void then
				if ((((ctype_b_loc).item[(a_name___1.item).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
					l_fp := (create {P_EVAL_STATIC}).find_func (a_name___1)
					if l_fp.is_void then
						(create {P_MESSAGE_STATIC}).emsg2 (create {CE_NATURAL_8_POINTER}.make_cast ((gettext (create {CE_INTEGER_8_POINTER}.make_cast (((create {P_GLOBALS_STATIC}).e_intern2.item))))), create {CE_NATURAL_8_POINTER}.make_cast (ce_string ("func_ref()"))).do_nothing
					else
						l_fp.item.uf_refcount := (l_fp.item.uf_refcount) + 1
					end
				end
			end
		end

feature {ANY}

	copy (a_other: like Current)
		do
			v_type := a_other.v_type
			v_lock := a_other.v_lock
			vval := a_other.vval.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				v_type = a_other.v_type and
				v_lock = a_other.v_lock and
				vval.is_equal (a_other.vval)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("v_type"),
					create {CE_STRUCTURE_FIELD}.make ("v_lock"),
					create {CE_STRUCTURE_FIELD}.make ("vval")
				>>)
			init_structure_info
		end

end
