class
	SD_PANGOATTRCOLOR

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create attr.make
			create color.make
		end

feature {ANY} -- fields

	attr: SD_PANGOATTRIBUTE assign set_attr

	color: SD_PANGOCOLOR assign set_color

feature {ANY} -- field setters

	set_attr (a_attr: SD_PANGOATTRIBUTE)
		do
			attr := a_attr
			update_memory_field ("attr")
		end

	set_color (a_color: SD_PANGOCOLOR)
		do
			color := a_color
			update_memory_field ("color")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			attr := a_other.attr.twin
			color := a_other.color.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				attr.is_equal (a_other.attr) and
				color.is_equal (a_other.color)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("attr"),
					create {CE_STRUCTURE_FIELD}.make ("color")
				>>)
			init_structure_info
		end

end
