class
	SD_SIGNAL_DATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create f.make
			create {CE_VOID_POINTER} d.make
		end

feature {ANY} -- fields

	f: CE_ROUTINE assign set_f

	d: CE_POINTER [ANY] assign set_d

feature {ANY} -- field setters

	set_f (a_f: CE_ROUTINE)
		do
			f := a_f
			update_memory_field ("f")
		end

	set_d (a_d: CE_POINTER [ANY])
		do
			d := a_d
			update_memory_field ("d")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			f := a_other.f
			d := a_other.d
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				f.is_equal (a_other.f) and
				d.is_equal (a_other.d)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("f"),
					create {CE_STRUCTURE_FIELD}.make ("d")
				>>)
			init_structure_info
		end

end
