class
	P_MPRINTF_STATIC

inherit
	CE_UTILITIES
	S_CTYPE_STATIC
	S_STDLIB_STATIC
	S_STRING_STATIC
	S_STDIO_STATIC

feature {ANY} -- public attributes

	lower_digits: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("0123456789abcdefghijklmnopqrstuvwxyz%/0/")
		end

	upper_digits: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ%/0/")
		end

	null: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("(nil)%/0/")
		end

	strnil: CE_STATIC [CE_ARRAY [INTEGER_8]]
		once ("PROCESS")
			Result.item := ce_string ("(nil)%/0/")
		end

feature {ANY} -- public routines

	dprintf_DollarString (a_input: CE_POINTER [INTEGER_8]; a_end: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		require
			not a_input.is_void
		local
			l_input: CE_POINTER [INTEGER_8]
			l_number: INTEGER_32
			l_tmp___0: CE_POINTER [INTEGER_8]
			l_return, l_break: BOOLEAN
		do
			l_input := a_input
			l_number := 0
			from
			until
				(l_break)
			loop
				l_break := False
				if not ((((ctype_b_loc).item[((l_input[0]).to_natural_8).to_integer_32]).to_integer_32).bit_and (2_048)).to_boolean then
					l_break := True
				end
				if not (l_break) then
					l_number := l_number * (10)
					l_number := l_number + ((l_input[0]).to_integer_32 - 48)
					l_input := l_input + 1
				end
			end
			l_break := False
			if l_number.to_boolean then
				l_tmp___0 := l_input
				l_input := l_input + 1
				if 36 = (l_tmp___0[0]).to_integer_32 then
					a_end.item := l_input
					Result := l_number.to_integer_32
					l_return := True
				end
			end
			if not l_return then
				Result := 0
			end
		end

	dprintf_IsQualifierNoDollar (a_c: INTEGER_8): INTEGER_32
		local
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_c.to_integer_32 -- switch 1 head
					when 45 then l_pos := -1 + 1
					when 43 then l_pos := -1 + 1
					when 32 then l_pos := -1 + 1
					when 35 then l_pos := -1 + 1
					when 46 then l_pos := -1 + 1
					when 48 then l_pos := -1 + 1
					when 49 then l_pos := -1 + 1
					when 50 then l_pos := -1 + 1
					when 51 then l_pos := -1 + 1
					when 52 then l_pos := -1 + 1
					when 53 then l_pos := -1 + 1
					when 54 then l_pos := -1 + 1
					when 55 then l_pos := -1 + 1
					when 56 then l_pos := -1 + 1
					when 57 then l_pos := -1 + 1
					when 104 then l_pos := -1 + 1
					when 108 then l_pos := -1 + 1
					when 76 then l_pos := -1 + 1
					when 122 then l_pos := -1 + 1
					when 113 then l_pos := -1 + 1
					when 42 then l_pos := -1 + 1
					when 79 then l_pos := -1 + 1
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case 45 | switch 1, case 43 | switch 1, case 32 | switch 1, case 35 | switch 1, case 46 | switch 1, case 48 | switch 1, case 49 | switch 1, case 50 | switch 1, case 51 | switch 1, case 52 | switch 1, case 53 | switch 1, case 54 | switch 1, case 55 | switch 1, case 56 | switch 1, case 57 | switch 1, case 104 | switch 1, case 108 | switch 1, case 76 | switch 1, case 122 | switch 1, case 113 | switch 1, case 42 | switch 1, case 79
					Result := 1
					l_return := True
				when 2 then -- switch 1, default:
					if not l_return then
						Result := 0
					end
				when 3 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dprintf_Pass1 (a_format: CE_POINTER [INTEGER_8]; a_vto: CE_POINTER [PD_VA_STACK_T]; a_endpos: CE_POINTER [CE_POINTER [INTEGER_8]]; a_arglist: CE_VA_LIST): INTEGER_32
		local
			l_endpos: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_arglist: CE_VA_LIST
			l_fmt: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_param_num: INTEGER_32
			l_this_param: INTEGER_32
			l_width: INTEGER_32
			l_precision: INTEGER_32
			l_flags: INTEGER_32
			l_max_param: INTEGER_32
			l_i: INTEGER_32
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_fmt.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_endpos := a_endpos
					l_arglist := a_arglist.twin
					l_fmt.item := a_format
					l_param_num := 0
					l_max_param := 0
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_fmt.item[0]).to_boolean)) then
						l_pos := -1 + 43 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False
						l_tmp___4 := l_fmt.item
						l_fmt.item := l_fmt.item + 1
						if (l_tmp___4[0]).to_integer_32 /= 37 then
							l_pos := -1 + 42 -- skip if block
						end
				when 3 then -- if:
						if (l_fmt.item[0]).to_integer_32 = 37 then
							l_fmt.item := l_fmt.item + 1
							l_continue := True
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 42 -- skip if block
						end
				when 4 then -- if:
						l_flags := 0
						l_param_num := l_param_num + 1
						l_this_param := dprintf_DollarString (l_fmt.item, l_fmt)
						if 0 = l_this_param then
							l_this_param := l_param_num.to_integer_32
						end
						if l_this_param > l_max_param then
							l_max_param := l_this_param
						end
						l_width := 0
						l_precision := 0
				when 5 then -- loop condition:
						if (l_break) then
							l_pos := -1 + 24 -- skip loop
						end
				when 6 then -- loop body:
						l_break := False
						if not (dprintf_IsQualifierNoDollar (l_fmt.item[0])).to_boolean then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 23 -- skip if block
						end
				when 7 then -- if:
						l_tmp := l_fmt.item
						l_fmt.item := l_fmt.item + 1
						inspect (l_tmp[0]).to_integer_32 -- switch 1 head
						when 32 then l_pos := -1 + 8
						when 43 then l_pos := -1 + 9
						when 45 then l_pos := -1 + 10
						when 35 then l_pos := -1 + 11
						when 46 then l_pos := -1 + 12
						when 104 then l_pos := -1 + 13
						when 108 then l_pos := -1 + 14
						when 76 then l_pos := -1 + 15
						when 113 then l_pos := -1 + 16
						when 122 then l_pos := -1 + 17
						when 79 then l_pos := -1 + 18
						when 48 then l_pos := -1 + 19
						when 49 then l_pos := -1 + 20
						when 50 then l_pos := -1 + 20
						when 51 then l_pos := -1 + 20
						when 52 then l_pos := -1 + 20
						when 53 then l_pos := -1 + 20
						when 54 then l_pos := -1 + 20
						when 55 then l_pos := -1 + 20
						when 56 then l_pos := -1 + 20
						when 57 then l_pos := -1 + 20
						when 42 then l_pos := -1 + 21
						else l_pos := -1 + 22
						end
				when 8 then -- switch 1, case 32
						l_flags := (l_flags).bit_or ((1))
						l_pos := -1 + 23 -- switch 1; break
				when 9 then -- switch 1, case 43
						l_flags := (l_flags).bit_or ((2))
						l_pos := -1 + 23 -- switch 1; break
				when 10 then -- switch 1, case 45
						l_flags := (l_flags).bit_or ((4))
						l_flags := (l_flags).bit_and ((-257))
						l_pos := -1 + 23 -- switch 1; break
				when 11 then -- switch 1, case 35
						l_flags := (l_flags).bit_or ((8))
						l_pos := -1 + 23 -- switch 1; break
				when 12 then -- switch 1, case 46
						l_flags := (l_flags).bit_or ((32_768))
						if 42 = (l_fmt.item[0]).to_integer_32 then
							l_flags := (l_flags).bit_or ((65_536))
							l_fmt.item := l_fmt.item + 1
							l_param_num := l_param_num + 1
							l_i := dprintf_DollarString (l_fmt.item, l_fmt)
							if l_i.to_boolean then
								l_precision := l_i
							else
								l_precision := l_param_num.to_integer_32
							end
							if l_precision > l_max_param then
								l_max_param := l_precision
							end
						else
							l_flags := (l_flags).bit_or ((32_768))
							l_precision := strtol (l_fmt.item, l_fmt, 10)
						end
						l_pos := -1 + 23 -- switch 1; break
				when 13 then -- switch 1, case 104
						l_flags := (l_flags).bit_or ((16))
						l_pos := -1 + 23 -- switch 1; break
				when 14 then -- switch 1, case 108
						if ((l_flags).bit_and (32)).to_boolean then
							l_flags := (l_flags).bit_or ((64))
						else
							l_flags := (l_flags).bit_or ((32))
						end
						l_pos := -1 + 23 -- switch 1; break
				when 15 then -- switch 1, case 76
						l_flags := (l_flags).bit_or ((128))
						l_pos := -1 + 23 -- switch 1; break
				when 16 then -- switch 1, case 113
						l_flags := (l_flags).bit_or ((64))
						l_pos := -1 + 23 -- switch 1; break
				when 17 then -- switch 1, case 122
						l_flags := (l_flags).bit_or ((32))
						l_pos := -1 + 23 -- switch 1; break
				when 18 then -- switch 1, case 79
						l_flags := (l_flags).bit_or ((64))
						l_pos := -1 + 23 -- switch 1; break
				when 19 then -- switch 1, case 48
						if not ((l_flags).bit_and (4)).to_boolean then
							l_flags := (l_flags).bit_or ((256))
						end
				when 20 then -- switch 1, case 49 | switch 1, case 50 | switch 1, case 51 | switch 1, case 52 | switch 1, case 53 | switch 1, case 54 | switch 1, case 55 | switch 1, case 56 | switch 1, case 57
						l_flags := (l_flags).bit_or ((8_192))
						l_width := strtol ((l_fmt.item - 1), l_fmt, 10)
						l_pos := -1 + 23 -- switch 1; break
				when 21 then -- switch 1, case 42
						l_flags := (l_flags).bit_or ((16_384))
						l_param_num := l_param_num + 1
						l_i := dprintf_DollarString (l_fmt.item, l_fmt)
						if l_i.to_boolean then
							l_width := l_i
						else
							l_width := l_param_num.to_integer_32
						end
						if l_width > l_max_param then
							l_max_param := l_width
						end
						l_pos := -1 + 23 -- switch 1; break
				when 22 then -- switch 1, default:
						l_pos := -1 + 23 -- switch 1; break
				when 23 then -- switch 1, done: | if done
						l_pos := -1 + 5 -- back to loop condition
				when 24 then -- loop done
						l_break := False
						l_i := l_this_param - 1
						inspect (l_fmt.item[0]).to_integer_32 -- switch 2 head
						when 83 then l_pos := -1 + 25
						when 115 then l_pos := -1 + 26
						when 110 then l_pos := -1 + 27
						when 112 then l_pos := -1 + 28
						when 100 then l_pos := -1 + 29
						when 105 then l_pos := -1 + 29
						when 117 then l_pos := -1 + 30
						when 111 then l_pos := -1 + 31
						when 120 then l_pos := -1 + 32
						when 88 then l_pos := -1 + 33
						when 99 then l_pos := -1 + 34
						when 102 then l_pos := -1 + 35
						when 101 then l_pos := -1 + 36
						when 69 then l_pos := -1 + 37
						when 103 then l_pos := -1 + 38
						when 71 then l_pos := -1 + 39
						else l_pos := -1 + 40
						end
				when 25 then -- switch 2, case 83
						l_flags := (l_flags).bit_or ((8))
				when 26 then -- switch 2, case 115;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_STRING
						l_pos := -1 + 41 -- switch 2; break
				when 27 then -- switch 2, case 110;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_INTPTR
						l_pos := -1 + 41 -- switch 2; break
				when 28 then -- switch 2, case 112;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_PTR
						l_pos := -1 + 41 -- switch 2; break
				when 29 then -- switch 2, case 100 | switch 2, case 105;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_INT
						l_pos := -1 + 41 -- switch 2; break
				when 30 then -- switch 2, case 117;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_INT
						l_flags := (l_flags).bit_or ((512))
						l_pos := -1 + 41 -- switch 2; break
				when 31 then -- switch 2, case 111;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_INT
						l_flags := (l_flags).bit_or ((1_024))
						l_pos := -1 + 41 -- switch 2; break
				when 32 then -- switch 2, case 120;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_INT
						l_flags := (l_flags).bit_or ((2_048))
						l_pos := -1 + 41 -- switch 2; break
				when 33 then -- switch 2, case 88;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_INT
						l_flags := (l_flags).bit_or ((6_144))
						l_pos := -1 + 41 -- switch 2; break
				when 34 then -- switch 2, case 99;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_INT
						l_flags := (l_flags).bit_or ((131_072))
						l_pos := -1 + 41 -- switch 2; break
				when 35 then -- switch 2, case 102;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_DOUBLE
						l_pos := -1 + 41 -- switch 2; break
				when 36 then -- switch 2, case 101;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_DOUBLE
						l_flags := (l_flags).bit_or ((262_144))
						l_pos := -1 + 41 -- switch 2; break
				when 37 then -- switch 2, case 69;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_DOUBLE
						l_flags := (l_flags).bit_or ((266_240))
						l_pos := -1 + 41 -- switch 2; break
				when 38 then -- switch 2, case 103;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_DOUBLE
						l_flags := (l_flags).bit_or ((524_288))
						l_pos := -1 + 41 -- switch 2; break
				when 39 then -- switch 2, case 71;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_DOUBLE
						l_flags := (l_flags).bit_or ((528_384))
						l_pos := -1 + 41 -- switch 2; break
				when 40 then -- switch 2, default:;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_UNKNOWN
						l_pos := -1 + 41 -- switch 2; break
				when 41 then -- switch 2, done:;
						(a_vto + l_i).item.flags := l_flags;
						(a_vto + l_i).item.width := l_width;
						(a_vto + l_i).item.precision := l_precision
						if ((l_flags).bit_and (16_384)).to_boolean then
							(a_vto + l_i).item.width := l_width - 1
							l_i := l_width - 1;
							(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_WIDTH;
							(a_vto + l_i).item.flags := 0
							l_tmp___1 := 0;
							(a_vto + l_i).item.width := l_tmp___1;
							(a_vto + l_i).item.precision := l_tmp___1
						end
						if ((l_flags).bit_and (65_536)).to_boolean then
							(a_vto + l_i).item.precision := l_precision - 1
							l_i := l_precision - 1;
							(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_WIDTH;
							(a_vto + l_i).item.flags := 0
							l_tmp___2 := 0;
							(a_vto + l_i).item.width := l_tmp___2;
							(a_vto + l_i).item.precision := l_tmp___2
						end
						l_tmp___3 := l_endpos
						l_endpos := l_endpos + 1
						l_tmp___3.item := l_fmt.item + 1
				when 42 then -- if done | if done
						l_pos := -1 + 1 -- back to loop condition
				when 43 then -- loop done
					l_continue := False
					l_i := 0
				when 44 then -- loop condition:
					if not (l_i < l_max_param) then
						l_pos := -1 + 63 -- skip loop
					end
				when 45 then -- loop body:
						if l_i + 1 < l_max_param then
							if (a_vto + (l_i + 1)).item.type = {NATURAL_32} 9 then
								(a_vto + (l_i + 1)).item.data.num.as_signed := (l_arglist.integer_32_item).to_integer_64
							end
						end
						inspect ((a_vto + l_i).item.type).to_integer_32 -- switch 3 head
						when 1 then l_pos := -1 + 46
						when 4 then l_pos := -1 + 47
						when 0 then l_pos := -1 + 47
						when 2 then l_pos := -1 + 47
						when 3 then l_pos := -1 + 48
						when 7 then l_pos := -1 + 59
						when 9 then l_pos := -1 + 60
						else l_pos := -1 + 61
						end
				when 46 then -- switch 3, case 1;
						(a_vto + l_i).item.data.str := (create {CE_INTEGER_8_POINTER}.make_cast (l_arglist.pointer_item))
						l_pos := -1 + 62 -- switch 3; break
				when 47 then -- switch 3, case 4 | switch 3, case 0 | switch 3, case 2;
						(a_vto + l_i).item.data.ptr := (create {CE_VOID_POINTER}.make_cast (l_arglist.pointer_item))
						l_pos := -1 + 62 -- switch 3; break
				when 48 then -- switch 3, case 3
						if not ((((a_vto + l_i).item.flags).bit_and (64)).to_boolean) then
							l_pos := -1 + 51 -- skip if block
						end
				when 49 then -- if:
						if (((a_vto + l_i).item.flags).bit_and (512)).to_boolean then
							(a_vto + l_i).item.data.num.as_unsigned := (l_arglist.natural_64_item)
						else
							l_pos := -1 + 51 -- goto _L___0
						end
				when 50 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 51 then -- else: | _L___0:
						if not ((((a_vto + l_i).item.flags).bit_and (64)).to_boolean) then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:;
						(a_vto + l_i).item.data.num.as_signed := (l_arglist.integer_64_item)
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 54 then -- else:
						if not ((((a_vto + l_i).item.flags).bit_and (32)).to_boolean) then
							l_pos := -1 + 57 -- skip if block
						end
				when 55 then -- if:
						if (((a_vto + l_i).item.flags).bit_and (512)).to_boolean then
							(a_vto + l_i).item.data.num.as_unsigned := (l_arglist.natural_32_item).to_natural_64
						else
							l_pos := -1 + 57 -- goto _L
						end
				when 56 then -- if block done, skip else block:
						l_pos := -1 + 58
				when 57 then -- else: | _L:
						if (((a_vto + l_i).item.flags).bit_and (32)).to_boolean then
							(a_vto + l_i).item.data.num.as_signed := (l_arglist.integer_32_item).to_integer_64
						elseif (((a_vto + l_i).item.flags).bit_and (512)).to_boolean then
							(a_vto + l_i).item.data.num.as_unsigned := (l_arglist.natural_32_item).to_natural_64
						else
							(a_vto + l_i).item.data.num.as_signed := (l_arglist.integer_32_item).to_integer_64
						end
				when 58 then -- if done | if done
						l_pos := -1 + 62 -- switch 3; break
				when 59 then -- switch 3, case 7;
						(a_vto + l_i).item.data.dnum := l_arglist.real_64_item
						l_pos := -1 + 62 -- switch 3; break
				when 60 then -- switch 3, case 9;
						(a_vto + l_i).item.type := {PC_FORMATTYPE}.FORMAT_INT
						l_pos := -1 + 62 -- switch 3; break
				when 61 then -- switch 3, default:
						l_pos := -1 + 62 -- switch 3; break
				when 62 then -- switch 3, done:
						l_i := l_i + 1
						l_pos := -1 + 44 -- back to loop condition
				when 63 then -- loop done
					Result := l_max_param
				when 64 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	dprintf_formatf (a_data: CE_POINTER [ANY]; a_stream: CE_ROUTINE; a_format: CE_POINTER [INTEGER_8]; a_ap_save: CE_VA_LIST): INTEGER_32
		local
			l_ap_save: CE_VA_LIST
			l_digits: CE_POINTER [INTEGER_8]
			l_f: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_done: INTEGER_32
			l_param: INTEGER_32
			l_param_num: INTEGER_32
			l_vto: CE_ARRAY [PD_VA_STACK_T]
			l_endpos: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_end: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_work: CE_ARRAY [INTEGER_8]
			l_p: CE_POINTER [PD_VA_STACK_T]
			l_is_alt: INTEGER_32
			l_width: INTEGER_32
			l_prec: INTEGER_32
			l_is_neg: INTEGER_32
			l_base: INTEGER_32
			l_num: NATURAL_64
			l_signed_num: INTEGER_64
			l_workend: CE_POINTER [INTEGER_8]
			l_w: CE_POINTER [INTEGER_8]
			l_tmp___4: CE_POINTER [INTEGER_8]
			l_tmp___5: CE_POINTER [INTEGER_8]
			l_tmp___6: CE_POINTER [INTEGER_8]
			l_tmp___7: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___20: INTEGER_32
			l_str: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			l_tmp___23: INTEGER_32
			l_tmp___24: CE_POINTER [INTEGER_8]
			l_tmp___26: NATURAL_32
			l_tmp___28: INTEGER_32
			l_ptr: CE_POINTER [ANY]
			l_point: CE_POINTER [INTEGER_8]
			l_tmp___31: INTEGER_32
			l_tmp___34: INTEGER_32
			l_formatbuf: CE_ARRAY [INTEGER_8]
			l_fptr: CE_POINTER [INTEGER_8]
			l_left: NATURAL_32
			l_len___0: INTEGER_32
			l_tmp___37: CE_POINTER [INTEGER_8]
			l_tmp___38: CE_POINTER [INTEGER_8]
			l_tmp___39: INTEGER_32
			l_tmp___40: CE_POINTER [INTEGER_8]
			l_tmp___41: INTEGER_32
			l_tmp___42: CE_POINTER [INTEGER_8]
			l_tmp___44: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_return, l_break, l_continue: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_f.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_VA_STACK_T]} l_vto.make (<<128>>)
			create {CE_POINTER_ARRAY [INTEGER_8]} l_endpos.make (<<128>>)
			create {CE_INTEGER_8_ARRAY} l_work.make (<<256>>)
			create {CE_INTEGER_8_POINTER} l_workend.make
			create {CE_INTEGER_8_POINTER} l_w.make
			create {CE_INTEGER_8_ARRAY} l_formatbuf.make (<<32>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ap_save := a_ap_save.twin
					l_digits := lower_digits.item
					l_done := 0
					l_param_num := 0
					dprintf_Pass1 (a_format, l_vto, l_endpos, l_ap_save.twin).do_nothing
					l_end := l_endpos + 0
					l_f.item := a_format
				when 1 then -- loop condition:
					if not (not (l_return) and then ((l_f.item[0]).to_integer_32 /= 0)) then
						l_pos := -1 + 21 -- skip loop
					end
				when 2 then -- loop body:
						l_continue := False
						if (l_f.item[0]).to_integer_32 /= 37 then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (a_stream.integer_32_item ([((l_f.item[0]).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
										l_done := l_done + 1
									else
										Result := l_done
										l_return := True
									end
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
									l_f.item := l_f.item + 1
									if (l_f.item[0]).to_boolean then
										if 37 = (l_f.item[0]).to_integer_32 then
											l_break := True
										end
									else
										l_break := True
									end
								end
							end
							if not l_return then
								l_break := False
								l_continue := True
							end
						end
						if not (l_return or l_break or l_continue) then
							l_f.item := l_f.item + 1
							if (l_f.item[0]).to_integer_32 = 37 then
								l_f.item := l_f.item + 1
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (a_stream.integer_32_item ([((('%%').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
										l_done := l_done + 1
									else
										Result := l_done
										l_return := True
									end
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
									l_continue := True
								end
							end
						end
						if (l_return or l_break or l_continue) then
							l_pos := -1 + 20 -- skip if block
						end
				when 3 then -- if:
						l_param := dprintf_DollarString (l_f.item, l_f)
						if not l_param.to_boolean then
							l_param := l_param_num
						else
							l_param := l_param - 1
						end
						l_param_num := l_param_num + 1
						l_p := l_vto + l_param
						if ((l_p.item.flags).bit_and (16_384)).to_boolean then
							l_width := (l_vto[l_p.item.width].data.num.as_signed).to_integer_32
						else
							l_width := l_p.item.width
						end
						if ((l_p.item.flags).bit_and (65_536)).to_boolean then
							l_prec := (l_vto[l_p.item.precision].data.num.as_signed).to_integer_32
							l_param_num := l_param_num + 1
						elseif ((l_p.item.flags).bit_and (32_768)).to_boolean then
							l_prec := l_p.item.precision
						else
							l_prec := -1
						end
						if ((l_p.item.flags).bit_and (8)).to_boolean then
							l_is_alt := 1
						else
							l_is_alt := 0
						end
						inspect (l_p.item.type).to_integer_32 -- switch 1 head
						when 3 then l_pos := -1 + 4
						when 1 then l_pos := -1 + 13
						when 2 then l_pos := -1 + 14
						when 7 then l_pos := -1 + 16
						when 4 then l_pos := -1 + 17
						else l_pos := -1 + 18
						end
				when 4 then -- switch 1, case 3
						l_num := l_p.item.data.num.as_unsigned
						if ((l_p.item.flags).bit_and (131_072)).to_boolean then
							if not ((l_p.item.flags).bit_and (4)).to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_width := l_width - 1
									if not (l_width > 0) then
										l_break := True
									end
									if not (l_return or l_break) then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											if (a_stream.integer_32_item ([(((' ').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
												l_done := l_done + 1
											else
												Result := l_done
												l_return := True
											end
											if not l_return then
												l_break := True
											end
										end
										if not l_return then
											l_break := False
										end
									end
								end
								if not l_return then
									l_break := False
								end
							end
							if not l_return then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (a_stream.integer_32_item ([((l_num.to_integer_8).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
										l_done := l_done + 1
									else
										Result := l_done
										l_return := True
									end
									if not l_return then
										l_break := True
									end
								end
							end
							if not l_return then
								l_break := False
								if ((l_p.item.flags).bit_and (4)).to_boolean then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										l_width := l_width - 1
										if not (l_width > 0) then
											l_break := True
										end
										if not (l_return or l_break) then
											from
											until
												(l_return or l_break)
											loop
												l_break := False
												if (a_stream.integer_32_item ([(((' ').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
													l_done := l_done + 1
												else
													Result := l_done
													l_return := True
												end
												if not l_return then
													l_break := True
												end
											end
											if not l_return then
												l_break := False
											end
										end
									end
									if not l_return then
										l_break := False
									end
								end
							end
							l_pos := -1 + 19 -- switch 1; break
						end
				when 5 then
						if l_return then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
						if ((l_p.item.flags).bit_and (512)).to_boolean then
							l_base := 10
							l_pos := -1 + 10 -- goto unsigned_number
						end
				when 7 then
						if ((l_p.item.flags).bit_and (1_024)).to_boolean then
							l_base := 8
							l_pos := -1 + 10 -- goto unsigned_number
						end
				when 8 then
						if ((l_p.item.flags).bit_and (2_048)).to_boolean then
							if ((l_p.item.flags).bit_and (4_096)).to_boolean then
								l_digits := upper_digits.item
							else
								l_digits := lower_digits.item
							end
							l_base := 16
							l_pos := -1 + 10 -- goto unsigned_number
						end
				when 9 then
						l_base := 10
						if l_p.item.data.num.as_signed < {INTEGER_64} 0 then
							l_is_neg := 1
						else
							l_is_neg := 0
						end
						if l_is_neg.to_boolean then
							l_signed_num := l_p.item.data.num.as_signed + {INTEGER_64} 1
							l_signed_num := -l_signed_num
							l_num := l_signed_num.to_natural_64
							l_num := l_num + 1
						end
						l_pos := -1 + 11 -- goto number
				when 10 then -- unsigned_number:
						l_is_neg := 0
				when 11 then -- number:
						l_workend := l_work + (({PLATFORM}.Integer_8_bytes.to_natural_32 * (256).to_natural_32) - {NATURAL_32} 1).to_integer_32
						if l_prec = -1 then
							l_prec := 1
						end
						l_w := l_workend
						from
						until
							not (l_num > {NATURAL_64} 0)
						loop
							l_tmp___4 := l_w
							l_w := l_w - 1
							l_tmp___4[0] := l_digits[(l_num \\ l_base.to_natural_64).to_integer_32]
							l_num := l_num // l_base.to_natural_64
						end
						l_width := l_width - (l_workend.distance (l_w)).to_integer_32
						l_prec := l_prec - (l_workend.distance (l_w)).to_integer_32
						if l_is_alt.to_boolean then
							if l_base = 8 then
								if l_prec <= 0 then
									l_tmp___5 := l_w
									l_w := l_w - 1
									l_tmp___5[0] := (('0').code).to_integer_8
									l_width := l_width - 1
								end
							end
						end
						if l_prec > 0 then
							l_width := l_width - l_prec
							from
							until
								(l_break)
							loop
								l_break := False
								l_tmp___7 := l_prec
								l_prec := l_prec - 1
								if not (l_tmp___7 > 0) then
									l_break := True
								end
								if not (l_return or l_break) then
									l_tmp___6 := l_w
									l_w := l_w - 1
									l_tmp___6[0] := (('0').code).to_integer_8
								end
							end
							l_break := False
						end
						if l_is_alt.to_boolean then
							if l_base = 16 then
								l_width := l_width - (2)
							end
						end
						if l_is_neg.to_boolean then
							l_width := l_width - 1
						elseif ((l_p.item.flags).bit_and (2)).to_boolean then
							l_width := l_width - 1
						elseif ((l_p.item.flags).bit_and (1)).to_boolean then
							l_width := l_width - 1
						end
						if not ((l_p.item.flags).bit_and (4)).to_boolean then
							if not ((l_p.item.flags).bit_and (256)).to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_tmp___9 := l_width
									l_width := l_width - 1
									if not (l_tmp___9 > 0) then
										l_break := True
									end
									if not (l_return or l_break) then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											if (a_stream.integer_32_item ([(((' ').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
												l_done := l_done + 1
											else
												Result := l_done
												l_return := True
											end
											if not l_return then
												l_break := True
											end
										end
										if not l_return then
											l_break := False
										end
									end
								end
								if not l_return then
									l_break := False
								end
							end
						end
				when 12 then -- if done
						if not l_return then
							if l_is_neg.to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (a_stream.integer_32_item ([((('-').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
										l_done := l_done + 1
									else
										Result := l_done
										l_return := True
									end
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							elseif ((l_p.item.flags).bit_and (2)).to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (a_stream.integer_32_item ([((('+').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
										l_done := l_done + 1
									else
										Result := l_done
										l_return := True
									end
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							elseif ((l_p.item.flags).bit_and (1)).to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (a_stream.integer_32_item ([(((' ').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
										l_done := l_done + 1
									else
										Result := l_done
										l_return := True
									end
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							end
						end
						if not l_return and then (l_is_alt.to_boolean) then
							if l_base = 16 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									if (a_stream.integer_32_item ([((('0').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
										l_done := l_done + 1
									else
										Result := l_done
										l_return := True
									end
									if not l_return then
										l_break := True
									end
								end
								if not l_return then
									l_break := False
									if ((l_p.item.flags).bit_and (4_096)).to_boolean then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											if (a_stream.integer_32_item ([((('X').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
												l_done := l_done + 1
											else
												Result := l_done
												l_return := True
											end
											if not l_return then
												l_break := True
											end
										end
										if not l_return then
											l_break := False
										end
									else
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											if (a_stream.integer_32_item ([((('x').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
												l_done := l_done + 1
											else
												Result := l_done
												l_return := True
											end
											if not l_return then
												l_break := True
											end
										end
										if not l_return then
											l_break := False
										end
									end
								end
							end
						end
						if not l_return and then (not ((l_p.item.flags).bit_and (4)).to_boolean) then
							if ((l_p.item.flags).bit_and (256)).to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_tmp___17 := l_width
									l_width := l_width - 1
									if not (l_tmp___17 > 0) then
										l_break := True
									end
									if not (l_return or l_break) then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											if (a_stream.integer_32_item ([((('0').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
												l_done := l_done + 1
											else
												Result := l_done
												l_return := True
											end
											if not l_return then
												l_break := True
											end
										end
										if not l_return then
											l_break := False
										end
									end
								end
								if not l_return then
									l_break := False
								end
							end
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_w := l_w + 1
								if not ((l_w.c_pointer.to_integer_32).to_natural_32 <= (l_workend.c_pointer.to_integer_32).to_natural_32) then
									l_break := True
								end
								if not (l_return or l_break) then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										if (a_stream.integer_32_item ([((l_w[0]).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
											l_done := l_done + 1
										else
											Result := l_done
											l_return := True
										end
										if not l_return then
											l_break := True
										end
									end
									if not l_return then
										l_break := False
									end
								end
							end
						end
						if not l_return then
							l_break := False
							if ((l_p.item.flags).bit_and (4)).to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_tmp___20 := l_width
									l_width := l_width - 1
									if not (l_tmp___20 > 0) then
										l_break := True
									end
									if not (l_return or l_break) then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											if (a_stream.integer_32_item ([(((' ').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
												l_done := l_done + 1
											else
												Result := l_done
												l_return := True
											end
											if not l_return then
												l_break := True
											end
										end
										if not l_return then
											l_break := False
										end
									end
								end
								if not l_return then
									l_break := False
								end
							end
						end
						l_pos := -1 + 19 -- switch 1; break
				when 13 then -- switch 1, case 1
						l_str := l_p.item.data.str
						if l_str.is_void then
							if l_prec = -1 then
								l_str := null.item
								l_len := ({PLATFORM}.Integer_8_bytes.to_natural_32 * (6).to_natural_32) - {NATURAL_32} 1
								l_p.item.flags := (l_p.item.flags).bit_and ((-9))
							elseif l_prec >= ({PLATFORM}.Integer_8_bytes.to_natural_32 * (6).to_natural_32).to_integer_32 - 1 then
								l_str := null.item
								l_len := ({PLATFORM}.Integer_8_bytes.to_natural_32 * (6).to_natural_32) - {NATURAL_32} 1
								l_p.item.flags := (l_p.item.flags).bit_and ((-9))
							else
								l_str := ce_string ("")
								l_len := (0).to_natural_32
							end
						else
							l_len := strlen (l_str)
						end
						if l_prec /= -1 then
							if l_prec.to_natural_32 < l_len then
								l_len := l_prec.to_natural_32
							end
						end
						l_width := l_width - l_len.to_integer_32
						if ((l_p.item.flags).bit_and (8)).to_boolean then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if (a_stream.integer_32_item ([((('%"').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
									l_done := l_done + 1
								else
									Result := l_done
									l_return := True
								end
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
						if not l_return and then (not ((l_p.item.flags).bit_and (4)).to_boolean) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_tmp___23 := l_width
								l_width := l_width - 1
								if not (l_tmp___23 > 0) then
									l_break := True
								end
								if not (l_return or l_break) then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										if (a_stream.integer_32_item ([(((' ').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
											l_done := l_done + 1
										else
											Result := l_done
											l_return := True
										end
										if not l_return then
											l_break := True
										end
									end
									if not l_return then
										l_break := False
									end
								end
							end
							if not l_return then
								l_break := False
							end
						end
						if not l_return then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								l_tmp___26 := l_len
								l_len := l_len - 1
								if not (l_tmp___26 > {NATURAL_32} 0) then
									l_break := True
								end
								if not (l_return or l_break) then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										l_tmp___24 := l_str
										l_str := l_str + 1
										if (a_stream.integer_32_item ([((l_tmp___24[0]).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
											l_done := l_done + 1
										else
											Result := l_done
											l_return := True
										end
										if not l_return then
											l_break := True
										end
									end
									if not l_return then
										l_break := False
									end
								end
							end
						end
						if not l_return then
							l_break := False
							if ((l_p.item.flags).bit_and (4)).to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_tmp___28 := l_width
									l_width := l_width - 1
									if not (l_tmp___28 > 0) then
										l_break := True
									end
									if not (l_return or l_break) then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											if (a_stream.integer_32_item ([(((' ').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
												l_done := l_done + 1
											else
												Result := l_done
												l_return := True
											end
											if not l_return then
												l_break := True
											end
										end
										if not l_return then
											l_break := False
										end
									end
								end
								if not l_return then
									l_break := False
								end
							end
						end
						if not l_return and then (((l_p.item.flags).bit_and (8)).to_boolean) then
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if (a_stream.integer_32_item ([((('%"').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
									l_done := l_done + 1
								else
									Result := l_done
									l_return := True
								end
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
							end
						end
						l_pos := -1 + 19 -- switch 1; break
				when 14 then -- switch 1, case 2
						l_ptr := l_p.item.data.ptr
						if not l_ptr.is_void then
							l_base := 16
							if ((l_p.item.flags).bit_and (4_096)).to_boolean then
								l_digits := upper_digits.item
							else
								l_digits := lower_digits.item
							end
							l_is_alt := 1
							l_num := ((l_ptr.c_pointer.to_integer_32).to_natural_32).to_natural_64
							l_is_neg := 0
							l_pos := -1 + 11 -- goto number
						else
							l_width := l_width - (({PLATFORM}.Integer_8_bytes.to_natural_32 * (6).to_natural_32) - {NATURAL_32} 1).to_integer_32
							if ((l_p.item.flags).bit_and (4)).to_boolean then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_tmp___31 := l_width
									l_width := l_width - 1
									if not (l_tmp___31 > 0) then
										l_break := True
									end
									if not (l_return or l_break) then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											if (a_stream.integer_32_item ([(((' ').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
												l_done := l_done + 1
											else
												Result := l_done
												l_return := True
											end
											if not l_return then
												l_break := True
											end
										end
										if not l_return then
											l_break := False
										end
									end
								end
								if not l_return then
									l_break := False
								end
							end
							if not l_return then
								l_point := strnil.item
								from
								until
									not (not (l_return) and then ((l_point[0]).to_integer_32 /= 0))
								loop
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										if (a_stream.integer_32_item ([((l_point[0]).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
											l_done := l_done + 1
										else
											Result := l_done
											l_return := True
										end
										if not l_return then
											l_break := True
										end
									end
									if not l_return then
										l_break := False
										l_point := l_point + 1
									end
								end
							end
							if not l_return and then (not ((l_p.item.flags).bit_and (4)).to_boolean) then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									l_tmp___34 := l_width
									l_width := l_width - 1
									if not (l_tmp___34 > 0) then
										l_break := True
									end
									if not (l_return or l_break) then
										from
										until
											(l_return or l_break)
										loop
											l_break := False
											if (a_stream.integer_32_item ([(((' ').code).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
												l_done := l_done + 1
											else
												Result := l_done
												l_return := True
											end
											if not l_return then
												l_break := True
											end
										end
										if not l_return then
											l_break := False
										end
									end
								end
								if not l_return then
									l_break := False
								end
							end
						end
				when 15 then
						l_pos := -1 + 19 -- switch 1; break
				when 16 then -- switch 1, case 7
						l_formatbuf[0] := (('%%').code).to_integer_8
						l_formatbuf[1] := (('%/0/').code).to_integer_8
						l_left := ({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32) - (strlen (l_formatbuf))
						l_width := -1
						if ((l_p.item.flags).bit_and (8_192)).to_boolean then
							l_width := l_p.item.width
						elseif ((l_p.item.flags).bit_and (16_384)).to_boolean then
							l_width := (l_vto[l_p.item.width].data.num.as_signed).to_integer_32
						end
						l_prec := -1
						if ((l_p.item.flags).bit_and (32_768)).to_boolean then
							l_prec := l_p.item.precision
						elseif ((l_p.item.flags).bit_and (65_536)).to_boolean then
							l_prec := (l_vto[l_p.item.precision].data.num.as_signed).to_integer_32
						end
						if ((l_p.item.flags).bit_and (4)).to_boolean then
							strcat (l_formatbuf, ce_string ("-")).do_nothing
						end
						if ((l_p.item.flags).bit_and (2)).to_boolean then
							strcat (l_formatbuf, ce_string ("+")).do_nothing
						end
						if ((l_p.item.flags).bit_and (1)).to_boolean then
							strcat (l_formatbuf, ce_string (" ")).do_nothing
						end
						if ((l_p.item.flags).bit_and (8)).to_boolean then
							strcat (l_formatbuf, ce_string ("#")).do_nothing
						end
						l_fptr := l_formatbuf + (strlen (l_formatbuf)).to_integer_32
						if l_width >= 0 then
							l_len___0 := curl_msnprintf ([l_fptr, l_left, ce_string ("%%ld"), l_width])
							l_fptr := l_fptr + l_len___0
							l_left := l_left - l_len___0.to_natural_32
						end
						if l_prec >= 0 then
							l_len___0 := curl_msnprintf ([l_fptr, l_left, ce_string (".%%ld"), l_prec])
							l_fptr := l_fptr + l_len___0
						end
						if ((l_p.item.flags).bit_and (32)).to_boolean then
							l_tmp___37 := l_fptr
							l_fptr := l_fptr + 1
							l_tmp___37[0] := (('l').code).to_integer_8
						end
						if ((l_p.item.flags).bit_and (262_144)).to_boolean then
							l_tmp___38 := l_fptr
							l_fptr := l_fptr + 1
							if ((l_p.item.flags).bit_and (4_096)).to_boolean then
								l_tmp___39 := ('E').code
							else
								l_tmp___39 := ('e').code
							end
							l_tmp___38[0] := l_tmp___39.to_integer_8
						elseif ((l_p.item.flags).bit_and (524_288)).to_boolean then
							l_tmp___40 := l_fptr
							l_fptr := l_fptr + 1
							if ((l_p.item.flags).bit_and (4_096)).to_boolean then
								l_tmp___41 := ('G').code
							else
								l_tmp___41 := ('g').code
							end
							l_tmp___40[0] := l_tmp___41.to_integer_8
						else
							l_tmp___42 := l_fptr
							l_fptr := l_fptr + 1
							l_tmp___42[0] := (('f').code).to_integer_8
						end
						l_fptr[0] := (0).to_integer_8
						sprintf ([l_work, l_formatbuf, l_p.item.data.dnum]).do_nothing
						l_fptr := l_work
						from
						until
							not (not (l_return) and then ((l_fptr[0]).to_boolean))
						loop
							from
							until
								(l_return or l_break)
							loop
								l_break := False
								if (a_stream.integer_32_item ([((l_fptr[0]).to_natural_8).to_integer_32, create {CE_CLASS_POINTER [SD_IO_FILE]}.make_cast (a_data)])) /= -1 then
									l_done := l_done + 1
								else
									Result := l_done
									l_return := True
								end
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
								l_fptr := l_fptr + 1
							end
						end
						l_pos := -1 + 19 -- switch 1; break
				when 17 then -- switch 1, case 4
						if ((l_p.item.flags).bit_and (64)).to_boolean then
							(create {CE_INTEGER_64_POINTER}.make_cast (l_p.item.data.ptr)).item := l_done.to_integer_64
						elseif ((l_p.item.flags).bit_and (32)).to_boolean then
							(create {CE_INTEGER_32_POINTER}.make_cast (l_p.item.data.ptr)).item := l_done.to_integer_32
						elseif not ((l_p.item.flags).bit_and (16)).to_boolean then
							(create {CE_INTEGER_32_POINTER}.make_cast (l_p.item.data.ptr)).item := l_done
						else
							(create {CE_INTEGER_16_POINTER}.make_cast (l_p.item.data.ptr)).item := l_done.to_integer_16
						end
						l_pos := -1 + 19 -- switch 1; break
				when 18 then -- switch 1, default:
						l_pos := -1 + 19 -- switch 1; break
				when 19 then -- switch 1, done:
						if not l_return then
							l_tmp___44 := l_end
							l_end := l_end + 1
							l_f.item := l_tmp___44.item
						end
				when 20 then -- if done
						l_pos := -1 + 1 -- back to loop condition
				when 21 then -- loop done
					if not l_return then
						l_continue := False
						Result := l_done
					end
				when 22 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	addbyter (a_output: INTEGER_32; a_data: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_infop: CE_POINTER [PD_NSPRINTF]
			l_outc: NATURAL_8
			l_return: BOOLEAN
		do
			l_infop := create {CE_CLASS_POINTER [PD_NSPRINTF]}.make_cast (a_data)
			l_outc := a_output.to_natural_8
			if l_infop.item.length < l_infop.item.max then
				l_infop.item.buffer[0] := l_outc.to_integer_8
				l_infop.item.buffer := (l_infop.item.buffer) + 1
				l_infop.item.length := (l_infop.item.length) + 1
				Result := l_outc.to_integer_32
				l_return := True
			end
			if not l_return then
				Result := (-1)
			end
		end

	curl_mvsnprintf (a_buffer: CE_POINTER [INTEGER_8]; a_maxlength: NATURAL_32; a_format: CE_POINTER [INTEGER_8]; a_ap_save: CE_VA_LIST): INTEGER_32
		local
			l_ap_save: CE_VA_LIST
			l_retcode: INTEGER_32
			l_info: CE_ARRAY [PD_NSPRINTF]
		do
			create {CE_CLASS_ARRAY [PD_NSPRINTF]} l_info.make (<<1>>)

			l_ap_save := a_ap_save.twin
			l_info.item.buffer := a_buffer
			l_info.item.length := (0).to_natural_32
			l_info.item.max := a_maxlength
			l_retcode := dprintf_formatf (create {CE_VOID_POINTER}.make_cast (l_info), addbyter_address, a_format, l_ap_save.twin)
			if (l_info.item.max).to_boolean then
				if l_info.item.max = l_info.item.length then
					l_info.item.buffer[-1] := (0).to_integer_8
				else
					l_info.item.buffer[0] := (0).to_integer_8
				end
			end
			Result := l_retcode
		end

	curl_msnprintf (a_args: TUPLE [a_buffer: CE_POINTER [INTEGER_8]; a_maxlength: NATURAL_32; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_retcode: INTEGER_32
			l_ap_save: CE_VA_LIST
		do
			create l_ap_save.make_shared (default_pointer)

			l_ap_save := create {CE_VA_LIST}.make (a_args, agent curl_msnprintf)
			l_retcode := curl_mvsnprintf (a_args.a_buffer, a_args.a_maxlength, a_args.a_format, l_ap_save.twin)
			Result := l_retcode
		end

	alloc_addbyter (a_output: INTEGER_32; a_data: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_infop: CE_POINTER [PD_ASPRINTF]
			l_outc: NATURAL_8
			l_newptr: CE_POINTER [INTEGER_8]
			l_return: BOOLEAN
		do
			l_infop := create {CE_CLASS_POINTER [PD_ASPRINTF]}.make_cast (a_data)
			l_outc := a_output.to_natural_8
			if (l_infop.item.buffer).is_void then
				l_infop.item.buffer := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cmalloc.item.pointer_item ([(32).to_natural_32]))))
				if (l_infop.item.buffer).is_void then
					l_infop.item.fail := 1
					Result := (-1)
					l_return := True
				end
				if not l_return then
					l_infop.item.alloc := (32).to_natural_32
					l_infop.item.len := (0).to_natural_32
				end
			elseif l_infop.item.len + {NATURAL_32} 1 >= l_infop.item.alloc then
				l_newptr := create {CE_INTEGER_8_POINTER}.make_cast ((create {CE_VOID_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_crealloc.item.pointer_item ([create {CE_VOID_POINTER}.make_cast (l_infop.item.buffer), l_infop.item.alloc * {NATURAL_32} 2]))))
				if l_newptr.is_void then
					l_infop.item.fail := 1
					Result := (-1)
					l_return := True
				end
				if not l_return then
					l_infop.item.buffer := l_newptr
					l_infop.item.alloc := l_infop.item.alloc * ({NATURAL_32} 2)
				end
			end
			if not l_return then
				l_infop.item.buffer[(l_infop.item.len).to_integer_32] := l_outc.to_integer_8
				l_infop.item.len := (l_infop.item.len) + 1
				Result := l_outc.to_integer_32
			end
		end

	curl_maprintf (a_args: TUPLE [a_format: CE_POINTER [INTEGER_8]]): CE_POINTER [INTEGER_8]
		local
			l_ap_save: CE_VA_LIST
			l_retcode: INTEGER_32
			l_info: CE_ARRAY [PD_ASPRINTF]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create l_ap_save.make_shared (default_pointer)
			create {CE_CLASS_ARRAY [PD_ASPRINTF]} l_info.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_info.item.buffer := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					l_info.item.len := (0).to_natural_32
					l_info.item.alloc := (0).to_natural_32
					l_info.item.fail := 0
					l_ap_save := create {CE_VA_LIST}.make (a_args, agent curl_maprintf)
					l_retcode := dprintf_formatf (create {CE_VOID_POINTER}.make_cast (l_info), alloc_addbyter_address, a_args.a_format, l_ap_save.twin)
					if -1 /= l_retcode then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((l_info.item.fail).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (l_info.item.alloc).to_boolean then
							(create {P_EASY_STATIC}).Curl_cfree.item.call ([create {CE_VOID_POINTER}.make_cast (l_info.item.buffer)])
						end
						Result := (create {CE_INTEGER_8_POINTER}.make_shared (default_pointer))
						l_return := True
				when 5 then -- if done
					if not l_return then
						if (l_info.item.alloc).to_boolean then
							l_info.item.buffer[(l_info.item.len).to_integer_32] := (0).to_integer_8
							Result := (l_info.item.buffer)
						else
							Result := (create {CE_INTEGER_8_POINTER}.make_cast ((create {P_EASY_STATIC}).Curl_cstrdup.item.pointer_item ([ce_string ("")])))
						end
					end
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	storebuffer (a_output: INTEGER_32; a_data: CE_POINTER [SD_IO_FILE]): INTEGER_32
		local
			l_buffer: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_outc: NATURAL_8
		do
			l_buffer := create {CE_POINTER_POINTER [INTEGER_8]}.make_cast (a_data)
			l_outc := a_output.to_natural_8;
			(l_buffer.item).item := l_outc.to_integer_8
			l_buffer.item := (l_buffer.item) + 1
			Result := l_outc.to_integer_32
		end

	curl_msprintf (a_args: TUPLE [a_buffer, a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_buffer: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_ap_save: CE_VA_LIST
			l_retcode: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_buffer.make (<<1>>)
			create l_ap_save.make_shared (default_pointer)

			l_buffer.item := a_args.a_buffer
			l_ap_save := create {CE_VA_LIST}.make (a_args, agent curl_msprintf)
			l_retcode := dprintf_formatf (create {CE_VOID_POINTER}.make_cast (l_buffer), storebuffer_address, a_args.a_format, l_ap_save.twin)
			l_buffer.item[0] := (0).to_integer_8
			Result := l_retcode
		end

	curl_mprintf (a_args: TUPLE [a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_retcode: INTEGER_32
			l_ap_save: CE_VA_LIST
		do
			create l_ap_save.make_shared (default_pointer)

			l_ap_save := create {CE_VA_LIST}.make (a_args, agent curl_mprintf)
			l_retcode := dprintf_formatf (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))), fputc_address, a_args.a_format, l_ap_save.twin)
			Result := l_retcode
		end

	curl_mfprintf (a_args: TUPLE [a_whereto: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_retcode: INTEGER_32
			l_ap_save: CE_VA_LIST
		do
			create l_ap_save.make_shared (default_pointer)

			l_ap_save := create {CE_VA_LIST}.make (a_args, agent curl_mfprintf)
			l_retcode := dprintf_formatf (create {CE_VOID_POINTER}.make_cast (a_args.a_whereto), fputc_address, a_args.a_format, l_ap_save.twin)
			Result := l_retcode
		end

	curl_mvsprintf (a_buffer, a_format: CE_POINTER [INTEGER_8]; a_ap_save: CE_VA_LIST): INTEGER_32
		local
			l_buffer: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_ap_save: CE_VA_LIST
			l_retcode: INTEGER_32
		do
			create {CE_POINTER_ARRAY [INTEGER_8]} l_buffer.make (<<1>>)

			l_buffer.item := a_buffer
			l_ap_save := a_ap_save.twin
			l_retcode := dprintf_formatf (create {CE_VOID_POINTER}.make_cast (l_buffer), storebuffer_address, a_format, l_ap_save.twin)
			l_buffer.item[0] := (0).to_integer_8
			Result := l_retcode
		end

	curl_mvprintf (a_format: CE_POINTER [INTEGER_8]; a_ap_save: CE_VA_LIST): INTEGER_32
		local
			l_ap_save: CE_VA_LIST
		do
			l_ap_save := a_ap_save.twin
			Result := (dprintf_formatf (create {CE_VOID_POINTER}.make_cast ((create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer))), fputc_address, a_format, l_ap_save.twin))
		end

	curl_mvfprintf (a_whereto: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]; a_ap_save: CE_VA_LIST): INTEGER_32
		local
			l_ap_save: CE_VA_LIST
		do
			l_ap_save := a_ap_save.twin
			Result := (dprintf_formatf (create {CE_VOID_POINTER}.make_cast (a_whereto), fputc_address, a_format, l_ap_save.twin))
		end

feature {ANY} -- routine addresses

	addbyter_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent addbyter)
		end

	alloc_addbyter_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent alloc_addbyter)
		end

	storebuffer_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent storebuffer)
		end

end
