class
	PD_DATA2

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	whatever: CE_POINTER [ANY] assign set_whatever

	result2: NATURAL_32 assign set_result2

feature {ANY} -- field setters

	set_whatever (a_whatever: CE_POINTER [ANY])
		do
			whatever := a_whatever
			update_memory_field ("whatever")
		end

	set_result2 (a_result2: NATURAL_32)
		do
			result2 := a_result2
			update_memory_field ("result2")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			whatever := a_other.whatever
			result2 := a_other.result2
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				whatever.is_equal (a_other.whatever) and
				result2 = a_other.result2
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make ("whatever"),
					create {CE_STRUCTURE_FIELD}.make ("result2")
				>>)
			init_structure_info
		end

end
