class
	PD_TFTP_PACKET

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_NATURAL_8_POINTER} data.make
		end

feature {ANY} -- fields

	data: CE_POINTER [NATURAL_8] assign set_data

feature {ANY} -- field setters

	set_data (a_data: CE_POINTER [NATURAL_8])
		do
			data := a_data
			update_memory_field ("data")
		end

feature {ANY} -- public routines

	getrpacketblock: NATURAL_16
		do
			Result := (((((data[2]).to_integer_32).bit_shift_left (8))).bit_or ((data[3]).to_integer_32)).to_natural_16
		end

feature {ANY}

	copy (a_other: like Current)
		do
			data := a_other.data
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				data.is_equal (a_other.data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("data")
				>>)
			init_structure_info
		end

end
