class
	P_ERRNO_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public attributes

	gmp_errno: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := 0
		end

feature {ANY} -- public routines

	gmp_exception (a_error_bit: INTEGER_32)
		do
			gmp_errno.item := (gmp_errno.item).bit_or (a_error_bit);
			(create {P_GMP_IMPL_STATIC}).gmp_junk.item := 10 // (create {P_MP_BPL_STATIC}).gmp_0.item
			abort
		end

	gmp_sqrt_of_negative
		do
			gmp_exception (4)
		end

	gmp_divide_by_zero
		do
			gmp_exception (2)
		end

end
