class
	P_GET_STR_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	mpn_sb_get_str (a_str: CE_POINTER [NATURAL_8]; a_len: NATURAL_32; a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_base: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_base: CE_ARRAY [INTEGER_32]
			l_str: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_un: INTEGER_32
			l_rl: NATURAL_32
			l_ul: NATURAL_32
			l_s: CE_POINTER [NATURAL_8]
			l_l: NATURAL_32
			l_buf: CE_ARRAY [NATURAL_8]
			l_rp: CE_ARRAY [NATURAL_32]
			l_i: INTEGER_32
			l_frac: CE_ARRAY [NATURAL_32]
			l_digit: CE_ARRAY [NATURAL_32]
			l_tmp: CE_POINTER [NATURAL_8]
			l___q: NATURAL_32
			l___r: NATURAL_32
			l_chars_per_limb: NATURAL_32
			l_big_base: NATURAL_32
			l_big_base_inverted: NATURAL_32
			l_normalization_steps: NATURAL_32
			l_i___0: INTEGER_32
			l_frac___0: CE_ARRAY [NATURAL_32]
			l_digit___0: CE_ARRAY [NATURAL_32]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l___q___0: NATURAL_32
			l___r___0: NATURAL_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			l_return, l_break: BOOLEAN
		do
			create {CE_INTEGER_32_ARRAY} l_base.make (<<1>>)
			create {CE_NATURAL_8_ARRAY} l_buf.make (<<448>>)
			create {CE_NATURAL_32_ARRAY} l_rp.make (<<22>>)
			create {CE_NATURAL_32_ARRAY} l_frac.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_digit.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_frac___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_digit___0.make (<<1>>)

			l_base.item := a_base
			l_str := a_str
			l_len := a_len
			l_un := a_un
			if l_base.item = 10 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_rp + 1, a_up, l_un)
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				l_s := l_buf + 448
				from
				until
					not (not (l_return) and then (l_un > 1))
				loop
					(create {P_GMP_IMPL_STATIC}).gmpn_preinv_divrem_1 (l_rp, (1).to_integer_32, (l_rp + 1), l_un, (1_000_000_000).to_natural_32, (316_718_722).to_natural_32, 2).do_nothing
					l_un := l_un - (l_rp[l_un] = {NATURAL_32} 0).to_integer
					l_frac.item := l_rp[0] + {NATURAL_32} 1
					l_s := l_s - (9)
					l_i := 9
					from
					until
						(l_break)
					loop
						l_break := False
						asm103 (l_frac, l_digit)
						l_tmp := l_s
						l_s := l_s + 1
						l_tmp.item := (l_digit.item).to_natural_8
						l_i := l_i - 1
						if not l_i.to_boolean then
							l_break := True
						end
					end
					l_break := False
					l_s := l_s - (9)
				end
				l_ul := l_rp[1]
				from
				until
					not (not (l_return) and then (l_ul /= {NATURAL_32} 0))
				loop
					from
					until
						(l_break)
					loop
						l_break := False
						l___q := l_ul // {NATURAL_32} 10
						l___r := l_ul \\ {NATURAL_32} 10
						l_ul := l___q
						l_rl := l___r
						l_break := True
					end
					l_break := False
					l_s := l_s - 1
					l_s.item := l_rl.to_natural_8
				end
			else
				l_chars_per_limb := ((create {P_MP_BASES_STATIC}).gmpn_bases.item[l_base.item].chars_per_limb).to_natural_32
				l_big_base := (create {P_MP_BASES_STATIC}).gmpn_bases.item[l_base.item].big_base
				l_big_base_inverted := (create {P_MP_BASES_STATIC}).gmpn_bases.item[l_base.item].big_base_inverted
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_normalization_steps := (builtin_clzl (l_big_base)).to_natural_32
					l_break := True
				end
				l_break := False
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					from
					until
						(l_return or l_break)
					loop
						l_break := False;
						(create {P_GMP_STATIC}).gmpn_copyi (l_rp + 1, a_up, l_un)
						l_break := True
					end
					l_break := False
					l_break := True
				end
				l_break := False
				l_s := l_buf + 448
				from
				until
					not (not (l_return) and then (l_un > 1))
				loop
					(create {P_GMP_IMPL_STATIC}).gmpn_preinv_divrem_1 (l_rp, (1).to_integer_32, (l_rp + 1), l_un, l_big_base, l_big_base_inverted, l_normalization_steps.to_integer_32).do_nothing
					l_un := l_un - (l_rp[l_un] = {NATURAL_32} 0).to_integer
					l_frac___0.item := l_rp[0] + {NATURAL_32} 1
					l_s := l_s - l_chars_per_limb.to_integer_32
					l_i___0 := l_chars_per_limb.to_integer_32
					from
					until
						(l_break)
					loop
						l_break := False
						asm104 (l_frac___0, l_digit___0, l_base)
						l_tmp___1 := l_s
						l_s := l_s + 1
						l_tmp___1.item := (l_digit___0.item).to_natural_8
						l_i___0 := l_i___0 - 1
						if not l_i___0.to_boolean then
							l_break := True
						end
					end
					l_break := False
					l_s := l_s - l_chars_per_limb.to_integer_32
				end
				l_ul := l_rp[1]
				from
				until
					not (not (l_return) and then (l_ul /= {NATURAL_32} 0))
				loop
					from
					until
						(l_break)
					loop
						l_break := False
						l___q___0 := l_ul // (l_base.item).to_natural_32
						l___r___0 := l_ul \\ (l_base.item).to_natural_32
						l_ul := l___q___0
						l_rl := l___r___0
						l_break := True
					end
					l_break := False
					l_s := l_s - 1
					l_s.item := l_rl.to_natural_8
				end
			end
			l_l := ((l_buf + 448).distance (l_s)).to_natural_32
			from
			until
				not (l_l < l_len)
			loop
				l_tmp___2 := l_str
				l_str := l_str + 1
				l_tmp___2.item := (0).to_natural_8
				l_len := l_len - 1
			end
			from
			until
				l_l = {NATURAL_32} 0
			loop
				l_tmp___3 := l_str
				l_str := l_str + 1
				l_tmp___4 := l_s
				l_s := l_s + 1
				l_tmp___3.item := l_tmp___4.item
				l_l := l_l - 1
			end
			Result := l_str
		end

	mpn_dc_get_str (a_str: CE_POINTER [NATURAL_8]; a_len: NATURAL_32; a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_powtab: CE_POINTER [PD_POWERS]; a_tmp: CE_POINTER [NATURAL_32]): CE_POINTER [NATURAL_8]
		local
			l_str: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_pwp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_pwn: INTEGER_32
			l_qn: INTEGER_32
			l_sn: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str := a_str
					l_len := a_len
					if 13 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if not (a_un >= 13) then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						l_pwp := a_powtab.item.p
						l_pwn := a_powtab.item.n
						l_sn := a_powtab.item.shift
						if not (a_un < l_pwn + l_sn) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_str := mpn_dc_get_str (l_str, l_len, a_up, a_un, a_powtab - 1, a_tmp)
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if a_un /= l_pwn + l_sn then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if ((create {P_GMP_STATIC}).gmpn_cmp ((a_up + l_sn), l_pwp, a_un - l_sn)) < 0 then
							l_str := mpn_dc_get_str (l_str, l_len, a_up, a_un, a_powtab - 1, a_tmp)
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						l_qp := a_tmp
						l_rp := a_up;
						(create {P_TDIV_QR_STATIC}).gmpn_tdiv_qr (l_qp, l_rp + l_sn, 0, (a_up + l_sn), a_un - l_sn, l_pwp, l_pwn)
						l_qn := (a_un - l_sn) - l_pwn
						l_qn := l_qn + (l_qp[l_qn] /= {NATURAL_32} 0).to_integer
						if l_len /= {NATURAL_32} 0 then
							l_len := l_len - (a_powtab.item.digits_in_base)
						end
						l_str := mpn_dc_get_str (l_str, l_len, l_qp, l_qn, a_powtab - 1, a_tmp + l_qn)
						l_str := mpn_dc_get_str (l_str, a_powtab.item.digits_in_base, l_rp, l_pwn + l_sn, a_powtab - 1, a_tmp)
				when 9 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___0
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						if a_un /= 0 then
							l_str := mpn_sb_get_str (l_str, l_len, a_up, a_un, a_powtab.item.base)
						else
							from
							until
								l_len = {NATURAL_32} 0
							loop
								l_tmp___0 := l_str
								l_str := l_str + 1
								l_tmp___0.item := (0).to_natural_8
								l_len := l_len - 1
							end
						end
				when 13 then
					Result := l_str
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_get_str (a_str: CE_POINTER [NATURAL_8]; a_base: INTEGER_32; a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32): NATURAL_32
		local
			l_powtab_mem: CE_POINTER [NATURAL_32]
			l_powtab_mem_ptr: CE_POINTER [NATURAL_32]
			l_big_base: CE_ARRAY [NATURAL_32]
			l_digits_in_base: NATURAL_32
			l_powtab: CE_ARRAY [PD_POWERS]
			l_pi: INTEGER_32
			l_n: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_t: CE_POINTER [NATURAL_32]
			l_out_len: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_n1: NATURAL_32
			l_n0: NATURAL_32
			l_bits_per_digit: INTEGER_32
			l_cnt: INTEGER_32
			l_bit_pos: INTEGER_32
			l_i: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_bits: NATURAL_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_n_pows: INTEGER_32
			l_xn: INTEGER_32
			l_pn: INTEGER_32
			l_exptab: CE_ARRAY [INTEGER_32]
			l_bexp: INTEGER_32
			l_cy: NATURAL_32
			l_shift: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_big_base.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_POWERS]} l_powtab.make (<<32>>)
			create {CE_POINTER_ARRAY [PD_TMP_REENTRANT_T]} l___tmp_marker.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_exptab.make (<<32>>)

			if a_un = 0 then
				a_str[0] := (0).to_natural_8
				Result := (1).to_natural_32
				l_return := True
			end
			if not l_return and then (((a_base).bit_and ((a_base - 1))) = 0) then
				l_bits_per_digit := ((create {P_MP_BASES_STATIC}).gmpn_bases.item[a_base].big_base).to_integer_32
				l_s := a_str
				l_n1 := a_up[(a_un - 1)]
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_cnt := builtin_clzl (l_n1)
					l_break := True
				end
				l_break := False
				l_bits := {NATURAL_32} 32 * a_un.to_natural_32 - l_cnt.to_natural_32
				l_cnt := (l_bits \\ l_bits_per_digit.to_natural_32).to_integer_32
				if l_cnt /= 0 then
					l_bits := l_bits + (l_bits_per_digit - l_cnt).to_natural_32
				end
				l_bit_pos := (l_bits - (a_un - 1).to_natural_32 * {NATURAL_32} 32).to_integer_32
				l_i := a_un - 1
				from
				until
					(l_return or l_break)
				loop
					l_break := False
					l_bit_pos := l_bit_pos - l_bits_per_digit
					from
					until
						not (l_bit_pos >= 0)
					loop
						l_tmp___0 := l_s
						l_s := l_s + 1
						l_tmp___0.item := ((((l_n1).bit_shift_right (l_bit_pos))).bit_and ((((1).bit_shift_left (l_bits_per_digit)) - 1).to_natural_32)).to_natural_8
						l_bit_pos := l_bit_pos - l_bits_per_digit
					end
					l_i := l_i - 1
					if l_i < 0 then
						l_break := True
					end
					if not (l_return or l_break) then
						l_n0 := (((l_n1).bit_shift_left (-l_bit_pos))).bit_and ((((1).bit_shift_left (l_bits_per_digit)) - 1).to_natural_32)
						l_n1 := a_up[l_i]
						l_bit_pos := l_bit_pos + (32)
						l_tmp___1 := l_s
						l_s := l_s + 1
						l_tmp___1.item := ((l_n0).bit_or (((l_n1).bit_shift_right (l_bit_pos)))).to_natural_8
					end
				end
				l_break := False
				Result := (l_s.distance (a_str)).to_natural_32
				l_return := True
			end
			if not l_return then
				if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (a_un >= 22) then
						l_tmp___2 := mpn_sb_get_str (a_str, (0).to_natural_32, a_up, a_un, a_base)
						Result := (l_tmp___2.distance (a_str)).to_natural_32
						l_return := True
					end
				else
					l_tmp___2 := mpn_sb_get_str (a_str, (0).to_natural_32, a_up, a_un, a_base)
					Result := (l_tmp___2.distance (a_str)).to_natural_32
					l_return := True
				end
			end
			if not l_return then
				l___tmp_marker.item := create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_powtab_mem := create {CE_NATURAL_32_POINTER}.make_cast (((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((a_un + 64).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				l_powtab_mem_ptr := l_powtab_mem
				l_big_base.item := (create {P_MP_BASES_STATIC}).gmpn_bases.item[a_base].big_base
				l_digits_in_base := ((create {P_MP_BASES_STATIC}).gmpn_bases.item[a_base].chars_per_limb).to_natural_32
				l_n_pows := (0).to_integer_32
				l_xn := ((1).to_double + (a_un.to_double * ((create {P_MP_BASES_STATIC}).gmpn_bases.item[a_base].chars_per_bit_exactly * (32).to_double)) / ((create {P_MP_BASES_STATIC}).gmpn_bases.item[a_base].chars_per_limb).to_double).truncated_to_integer
				l_pn := l_xn
				from
				until
					l_pn = 1
				loop
					l_exptab[l_n_pows] := l_pn
					l_n_pows := l_n_pows + 1
					l_pn := ((l_pn + 1)).bit_shift_right (1)
				end
				l_exptab[l_n_pows] := (1).to_integer_32
				l_powtab[0].p := l_big_base
				l_powtab[0].n := (1).to_integer_32
				l_powtab[0].digits_in_base := l_digits_in_base
				l_powtab[0].base := a_base
				l_powtab[0].shift := (0).to_integer_32
				l_powtab[1].p := l_powtab_mem_ptr
				l_powtab_mem_ptr := l_powtab_mem_ptr + (2)
				l_powtab[1].p[0] := l_big_base.item
				l_powtab[1].n := (1).to_integer_32
				l_powtab[1].digits_in_base := l_digits_in_base
				l_powtab[1].base := a_base
				l_powtab[1].shift := (0).to_integer_32
				l_n := (1).to_integer_32
				l_p := l_big_base
				l_bexp := (1).to_integer_32
				l_shift := (0).to_integer_32
				l_pi := 2
				from
				until
					not (not (l_return) and then (l_pi.to_integer_32 < l_n_pows))
				loop
					l_t := l_powtab_mem_ptr
					l_powtab_mem_ptr := l_powtab_mem_ptr + (2 * l_n + 2)
					from
					until
						(l_break)
					loop
						l_break := False
						if not ((l_powtab_mem_ptr.c_pointer.to_integer_32).to_natural_32 < ((l_powtab_mem + (a_un + 64)).c_pointer.to_integer_32).to_natural_32) then
							(create {P_ASSERT_STATIC}).gmp_assert_fail (ce_string ("get_str.c"), 474, ce_string ("powtab_mem_ptr < powtab_mem + ((un) + 2 * 32)"))
						end
						l_break := True
					end
					l_break := False;
					(create {P_SQR_STATIC}).gmpn_sqr (l_t, l_p, l_n)
					l_digits_in_base := l_digits_in_base * ({NATURAL_32} 2)
					l_n := l_n * (2)
					l_n := l_n - (l_t[(l_n - 1)] = {NATURAL_32} 0).to_integer
					l_bexp := l_bexp * (2)
					if l_bexp + 1 < l_exptab[l_n_pows - l_pi.to_integer_32] then
						l_digits_in_base := l_digits_in_base + ((create {P_MP_BASES_STATIC}).gmpn_bases.item[a_base].chars_per_limb).to_natural_32
						l_cy := (create {P_GMP_STATIC}).gmpn_mul_1 (l_t, l_t, l_n, l_big_base.item)
						l_t[l_n] := l_cy
						l_n := l_n + (l_cy /= {NATURAL_32} 0).to_integer
						l_bexp := l_bexp + 1
					end
					l_shift := l_shift * (2)
					from
					until
						l_t[0] /= {NATURAL_32} 0
					loop
						l_t := l_t + 1
						l_n := l_n - 1
						l_shift := l_shift + 1
					end
					l_p := l_t
					l_powtab[l_pi].p := l_p
					l_powtab[l_pi].n := l_n
					l_powtab[l_pi].digits_in_base := l_digits_in_base
					l_powtab[l_pi].base := a_base
					l_powtab[l_pi].shift := l_shift
					l_pi := l_pi + 1
				end
				l_pi := 1
				from
				until
					not (l_pi.to_integer_32 < l_n_pows)
				loop
					l_t := l_powtab[l_pi].p
					l_n := l_powtab[l_pi].n
					l_cy := (create {P_GMP_STATIC}).gmpn_mul_1 (l_t, l_t, l_n, l_big_base.item)
					l_t[l_n] := l_cy
					l_n := l_n + (l_cy /= {NATURAL_32} 0).to_integer
					if l_t[0] = {NATURAL_32} 0 then
						l_powtab[l_pi].p := l_t + 1
						l_n := l_n - 1
						l_powtab[l_pi].shift := (l_powtab[l_pi].shift) + 1
					end
					l_powtab[l_pi].n := l_n
					l_powtab[l_pi].digits_in_base := l_powtab[l_pi].digits_in_base + ((create {P_MP_BASES_STATIC}).gmpn_bases.item[a_base].chars_per_limb).to_natural_32
					l_pi := l_pi + 1
				end
				l_out_len := ((mpn_dc_get_str (a_str, (0).to_natural_32, a_up, a_un, ((l_powtab - 1) + l_pi), (create {CE_NATURAL_32_POINTER}.make_cast (((create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_alloc (l___tmp_marker, ((a_un + 32).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))))).distance (a_str)).to_natural_32
				from
				until
					(l_break)
				loop
					l_break := False
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						(create {P_TAL_REENT_STATIC}).gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					l_break := True
				end
				l_break := False
				Result := l_out_len
			end
		end

end
