class
	P_MOD_1_2_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC
	LIBGMP_ASSEMBLER

feature {ANY} -- public routines

	gmpn_mod_1s_2p_cps (a_cps: CE_POINTER [NATURAL_32]; a_b: NATURAL_32)
		require
			not a_cps.is_void
		local
			l_b: NATURAL_32
			l_bi: CE_ARRAY [NATURAL_32]
			l_B1modb: CE_ARRAY [NATURAL_32]
			l_B2modb: CE_ARRAY [NATURAL_32]
			l_B3modb: NATURAL_32
			l_cnt: INTEGER_32
			l__qh: CE_ARRAY [NATURAL_32]
			l__ql: CE_ARRAY [NATURAL_32]
			l__r: NATURAL_32
			l__qh___0: CE_ARRAY [NATURAL_32]
			l__ql___0: CE_ARRAY [NATURAL_32]
			l__r___0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_NATURAL_32_ARRAY} l_bi.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_B1modb.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_B2modb.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__qh.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__ql.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__qh___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__ql___0.make (<<1>>)

			l_b := a_b
			from
			until
				(l_return or l_break)
			loop
				l_break := False
				l_cnt := builtin_clzl (l_b)
				l_break := True
			end
			l_break := False
			l_b := (l_b).bit_shift_left (l_cnt)
			from
			until
				(l_break)
			loop
				l_break := False
				l_bi.item := (create {P_GMP_IMPL_STATIC}).gmpn_invert_limb (l_b)
				l_break := True
			end
			l_break := False
			l_B1modb.item := (-l_b.to_integer_32).to_natural_32 * ((((l_bi.item).bit_shift_right ((32 - l_cnt)))).bit_or ((({NATURAL_32} 1).bit_shift_left (l_cnt))))
			from
			until
				(l_break)
			loop
				l_break := False
				asm46 (l__ql, l__qh, l_B1modb, l_bi)
				l__qh.item := l__qh.item + (l_B1modb.item + {NATURAL_32} 1)
				l__r := (-(l__qh.item).to_integer_32).to_natural_32 * l_b
				if l__r > l__ql.item then
					l__r := l__r + l_b
				end
				l_B2modb.item := l__r
				l_break := True
			end
			l_break := False
			from
			until
				(l_break)
			loop
				l_break := False
				asm47 (l__ql___0, l__qh___0, l_B2modb, l_bi)
				l__qh___0.item := l__qh___0.item + (l_B2modb.item + {NATURAL_32} 1)
				l__r___0 := (-(l__qh___0.item).to_integer_32).to_natural_32 * l_b
				if l__r___0 > l__ql___0.item then
					l__r___0 := l__r___0 + l_b
				end
				l_B3modb := l__r___0
				l_break := True
			end
			l_break := False
			a_cps[0] := l_bi.item
			a_cps[1] := l_cnt.to_natural_32
			a_cps[2] := (l_B1modb.item).bit_shift_right (l_cnt)
			a_cps[3] := (l_B2modb.item).bit_shift_right (l_cnt)
			a_cps[4] := (l_B3modb).bit_shift_right (l_cnt)
		end

	gmpn_mod_1s_2p (a_ap: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_b: NATURAL_32; a_cps: CE_POINTER [NATURAL_32]): NATURAL_32
		require
			not a_cps.is_void
		local
			l_ap: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_n: CE_ARRAY [INTEGER_32]
			l_rh: CE_ARRAY [NATURAL_32]
			l_rl: CE_ARRAY [NATURAL_32]
			l_bi: CE_ARRAY [NATURAL_32]
			l_q: NATURAL_32
			l_ph: CE_ARRAY [NATURAL_32]
			l_pl: CE_ARRAY [NATURAL_32]
			l_ch: CE_ARRAY [NATURAL_32]
			l_cl: CE_ARRAY [NATURAL_32]
			l_r: CE_ARRAY [NATURAL_32]
			l_B1modb: CE_ARRAY [NATURAL_32]
			l_B2modb: CE_ARRAY [NATURAL_32]
			l_B3modb: CE_ARRAY [NATURAL_32]
			l_i: CE_ARRAY [INTEGER_32]
			l_cnt: CE_ARRAY [INTEGER_32]
			l__qh: CE_ARRAY [NATURAL_32]
			l__ql: CE_ARRAY [NATURAL_32]
			l__r: NATURAL_32
			l__qh___0: CE_ARRAY [NATURAL_32]
			l__ql___0: CE_ARRAY [NATURAL_32]
			l__r___0: NATURAL_32
			l_return, l_break: BOOLEAN
		do
			create {CE_POINTER_ARRAY [NATURAL_32]} l_ap.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_n.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_rh.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_rl.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_bi.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_ph.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_pl.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_ch.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_cl.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_r.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_B1modb.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_B2modb.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l_B3modb.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_i.make (<<1>>)
			create {CE_INTEGER_32_ARRAY} l_cnt.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__qh.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__ql.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__qh___0.make (<<1>>)
			create {CE_NATURAL_32_ARRAY} l__ql___0.make (<<1>>)

			l_ap.item := a_ap
			l_n.item := a_n
			l_B1modb.item := a_cps[2]
			l_B2modb.item := a_cps[3]
			l_B3modb.item := a_cps[4]
			if ((l_n.item).bit_and (1)) /= 0 then
				if l_n.item = 1 then
					l_rl.item := l_ap.item[(l_n.item - 1)]
					l_bi.item := a_cps[0]
					l_cnt.item := (a_cps[1]).to_integer_32
					from
					until
						(l_break)
					loop
						l_break := False
						asm48 (l__ql, l__qh, l_rl, l_cnt, l_bi)
						asm49 (l__qh, l__ql, l_rl, l_cnt)
						l__r := ((l_rl.item).bit_shift_left (l_cnt.item)) - l__qh.item * a_b
						if l__r > l__ql.item then
							l__r := l__r + a_b
							l__qh.item := l__qh.item - 1
						end
						if (builtin_expect ((l__r >= a_b).to_integer, 0)).to_boolean then
							l__r := l__r - a_b
							l__qh.item := l__qh.item + 1
						end
						l_r.item := l__r
						l_q := l__qh.item
						l_break := True
					end
					l_break := False
					Result := ((l_r.item).bit_shift_right (l_cnt.item))
					l_return := True
				end
				if not l_return then
					asm50 (l_pl, l_ph, l_ap, l_n, l_B1modb)
					asm51 (l_ph, l_pl, l_ap, l_n)
					asm52 (l_rl, l_rh, l_ap, l_n, l_B2modb)
					asm53 (l_rh, l_rl, l_ph, l_pl)
					l_n.item := l_n.item - 1
				end
			else
				asm54 (l_rl, l_rh, l_ap, l_n, l_B1modb)
				asm55 (l_rh, l_rl, l_ap, l_n)
			end
			if not l_return then
				l_i.item := l_n.item - 4
				from
				until
					not (l_i.item >= 0)
				loop
					asm56 (l_pl, l_ph, l_ap, l_i, l_B1modb)
					asm57 (l_ph, l_pl, l_ap, l_i)
					asm58 (l_cl, l_ch, l_rl, l_B2modb)
					asm59 (l_ph, l_pl, l_ch, l_cl)
					asm60 (l_rl, l_rh, l_B3modb)
					asm61 (l_rh, l_rl, l_ph, l_pl)
					l_i.item := l_i.item - (2)
				end
				l_bi.item := a_cps[0]
				l_cnt.item := (a_cps[1]).to_integer_32
				asm62 (l_cl, l_rh, l_B1modb)
				asm63 (l_rh, l_rl, l_cl)
				l_r.item := (((l_rh.item).bit_shift_left (l_cnt.item))).bit_or (((l_rl.item).bit_shift_right ((32 - l_cnt.item))))
				from
				until
					(l_break)
				loop
					l_break := False
					asm64 (l__ql___0, l__qh___0, l_r, l_bi)
					asm65 (l__qh___0, l__ql___0, l_r, l_rl, l_cnt)
					l__r___0 := ((l_rl.item).bit_shift_left (l_cnt.item)) - l__qh___0.item * a_b
					if l__r___0 > l__ql___0.item then
						l__r___0 := l__r___0 + a_b
						l__qh___0.item := l__qh___0.item - 1
					end
					if (builtin_expect ((l__r___0 >= a_b).to_integer, 0)).to_boolean then
						l__r___0 := l__r___0 - a_b
						l__qh___0.item := l__qh___0.item + 1
					end
					l_r.item := l__r___0
					l_q := l__qh___0.item
					l_break := True
				end
				l_break := False
				Result := ((l_r.item).bit_shift_right (l_cnt.item))
			end
		end

end
