class
	P_POW_1_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gmpn_pow_1 (a_rp, a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_exp: NATURAL_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_exp: NATURAL_32
			l_tp: CE_POINTER [NATURAL_32]
			l_x___2: NATURAL_32
			l_cnt: INTEGER_32
			l_i: INTEGER_32
			l_rn: INTEGER_32
			l_par: INTEGER_32
			l_bl: NATURAL_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___1: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___2: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___3: CE_POINTER [NATURAL_32]
			l_return, l_break: BOOLEAN
		do
			l_rp := a_rp
			l_exp := a_exp
			l_tp := a_tp
			if l_exp <= {NATURAL_32} 1 then
				if l_exp = {NATURAL_32} 0 then
					l_rp[0] := (1).to_natural_32
					Result := (1).to_integer_32
					l_return := True
				else
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						from
						until
							(l_return or l_break)
						loop
							l_break := False;
							(create {P_GMP_STATIC}).gmpn_copyi (l_rp, a_bp, a_bn)
							l_break := True
						end
						l_break := False
						l_break := True
					end
					l_break := False
					Result := a_bn
					l_return := True
				end
			end
			if not l_return then
				l_par := 0
				l_cnt := 32
				l_x___2 := l_exp
				from
				until
					l_x___2 = {NATURAL_32} 0
				loop
					l_par := ((l_par.to_natural_32).bit_xor (((l_x___2).bit_and ({NATURAL_32} 1)))).to_integer_32
					l_cnt := l_cnt - 1
					l_x___2 := (l_x___2).bit_shift_right ((1))
				end
				l_exp := (l_exp).bit_shift_left (l_cnt)
				if a_bn = 1 then
					l_bl := a_bp[0]
					if ((l_cnt).bit_and (1)) /= 0 then
						from
						until
							(l_break)
						loop
							l_break := False
							l___mp_ptr_swap__tmp := l_rp
							l_rp := l_tp
							l_tp := l___mp_ptr_swap__tmp
							l_break := True
						end
						l_break := False
					end
					(create {P_SQR_STATIC}).gmpn_sqr (l_rp, a_bp, a_bn)
					l_rn := 2 * a_bn
					l_rn := l_rn - (l_rp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
					l_i := (32 - l_cnt) - 1
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_exp := (l_exp).bit_shift_left ((1))
						if ((l_exp).bit_and ((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))))) /= {NATURAL_32} 0 then
							l_rp[l_rn] := (create {P_GMP_STATIC}).gmpn_mul_1 (l_rp, l_rp, l_rn, l_bl)
							l_rn := l_rn + (l_rp[l_rn] /= {NATURAL_32} 0).to_integer
						end
						l_i := l_i - 1
						if l_i = 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							(create {P_SQR_STATIC}).gmpn_sqr (l_tp, l_rp, l_rn)
							l_rn := 2 * l_rn
							l_rn := l_rn - (l_tp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
							from
							until
								(l_break)
							loop
								l_break := False
								l___mp_ptr_swap__tmp___0 := l_rp
								l_rp := l_tp
								l_tp := l___mp_ptr_swap__tmp___0
								l_break := True
							end
							l_break := False
						end
					end
					l_break := False
				else
					if ((((l_par).bit_xor (l_cnt))).bit_and (1)) = 0 then
						from
						until
							(l_break)
						loop
							l_break := False
							l___mp_ptr_swap__tmp___1 := l_rp
							l_rp := l_tp
							l_tp := l___mp_ptr_swap__tmp___1
							l_break := True
						end
						l_break := False
					end
					(create {P_SQR_STATIC}).gmpn_sqr (l_rp, a_bp, a_bn)
					l_rn := 2 * a_bn
					l_rn := l_rn - (l_rp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
					l_i := (32 - l_cnt) - 1
					from
					until
						(l_return or l_break)
					loop
						l_break := False
						l_exp := (l_exp).bit_shift_left ((1))
						if ((l_exp).bit_and ((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))))) /= {NATURAL_32} 0 then
							l_rn := (l_rn + a_bn) - (((create {P_MUL_STATIC}).gmpn_mul (l_tp, l_rp, l_rn, a_bp, a_bn)) = {NATURAL_32} 0).to_integer
							from
							until
								(l_break)
							loop
								l_break := False
								l___mp_ptr_swap__tmp___2 := l_rp
								l_rp := l_tp
								l_tp := l___mp_ptr_swap__tmp___2
								l_break := True
							end
							l_break := False
						end
						l_i := l_i - 1
						if l_i = 0 then
							l_break := True
						end
						if not (l_return or l_break) then
							(create {P_SQR_STATIC}).gmpn_sqr (l_tp, l_rp, l_rn)
							l_rn := 2 * l_rn
							l_rn := l_rn - (l_tp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
							from
							until
								(l_break)
							loop
								l_break := False
								l___mp_ptr_swap__tmp___3 := l_rp
								l_rp := l_tp
								l_tp := l___mp_ptr_swap__tmp___3
								l_break := True
							end
							l_break := False
						end
					end
					l_break := False
				end
				Result := l_rn
			end
		end

end
