class
	P_RANDLC2S_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	gmp_rand_lc_scheme: CE_STATIC [CE_ARRAY [PD_GMP_RAND_LC_SCHEME_STRUCT]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GMP_RAND_LC_SCHEME_STRUCT]}.make_initialized (<<
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 32, ce_string ("29CF535"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 33, ce_string ("51F666D"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 34, ce_string ("A3D73AD"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 35, ce_string ("147E5B85"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 36, ce_string ("28F725C5"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 37, ce_string ("51EE3105"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 38, ce_string ("A3DD5CDD"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 39, ce_string ("147AF833D"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 40, ce_string ("28F5DA175"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 56, ce_string ("AA7D735234C0DD"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 64, ce_string ("BAECD515DAF0B49D"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 100, ce_string ("292787EBD3329AD7E7575E2FD"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 128, ce_string ("48A74F367FA7B5C8ACBB36901308FA85"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 156, ce_string ("78A7FDDDC43611B527C3F1D760F36E5D7FC7C45"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 196, ce_string ("41BA2E104EE34C66B3520CE706A56498DE6D44721E5E24F5"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 200, ce_string ("4E5A24C38B981EAFE84CD9D0BEC48E83911362C114F30072C5"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 256, ce_string ("AF66BA932AAF58A071FD8F0742A99A0C76982D648509973DB802303128A14CB5"), {NATURAL_32} 1]),
					create {PD_GMP_RAND_LC_SCHEME_STRUCT}.make_initialized ([{NATURAL_32} 0, create {CE_INTEGER_8_POINTER}.make_shared (default_pointer), {NATURAL_32} 0])
				>>)
		end

feature {ANY} -- public routines

	gmp_randinit_lc_2exp_size (a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_size: NATURAL_32): INTEGER_32
		local
			l_sp: CE_POINTER [PD_GMP_RAND_LC_SCHEME_STRUCT]
			l_a: CE_ARRAY [PD_MPZ_STRUCT]
			l_return: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_MPZ_STRUCT]} l_a.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_sp := gmp_rand_lc_scheme.item
				when 1 then -- loop condition:
					if l_sp.item.m2exp = {NATURAL_32} 0 then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if l_sp.item.m2exp // {NATURAL_32} 2 >= a_size then
							l_pos := -1 + 5 -- goto found
						end
				when 3 then
						l_sp := l_sp + 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					Result := 0
					l_return := True
					if l_return then
						l_pos := -1 + 6 -- skip if block
					end
				when 5 then -- if: | found:
						l_a.item.gmpz_init_set_str (l_sp.item.astr, 16).do_nothing
						a_rstate.item.gmp_randinit_lc_2exp (create {CE_CLASS_POINTER [PD_MPZ_STRUCT]}.make_cast (l_a), l_sp.item.c, l_sp.item.m2exp)
						l_a.item.gmpz_clear
						Result := 1
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
