class
	P_SET_DFL_PREC_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	gmp_default_fp_limb_precision: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (3).to_integer_32
		end

feature {ANY} -- public routines

	gmpf_set_default_prec (a_prec_in_bits: NATURAL_32)
		local
			l_tmp: NATURAL_32
		do
			if {NATURAL_32} 53 > a_prec_in_bits then
				l_tmp := (53).to_natural_32
			else
				l_tmp := a_prec_in_bits
			end
			gmp_default_fp_limb_precision.item := (((l_tmp + {NATURAL_32} 64) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
		end

end
