class
	P_TOOM8H_MUL_STATIC

inherit
	CE_UTILITIES
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public routines

	gmpn_toom8h_mul (a_pp, a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: INTEGER_32
			l_s: INTEGER_32
			l_t: INTEGER_32
			l_p: INTEGER_32
			l_q: INTEGER_32
			l_half: INTEGER_32
			l_sign: INTEGER_32
			l_tmp: NATURAL_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___13: INTEGER_32
			l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((builtin_expect ((a_an = a_bn).to_integer, 1)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_an * ((20).bit_shift_right (1)).to_integer_32 < 21 * ((a_bn).bit_shift_right (1))) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						l_half := 0
						l_n := 1 + (((a_an - 1)).bit_shift_right (3))
						l_q := 7
						l_p := l_q
						l_s := a_an - l_p.to_integer_32 * l_n
						l_t := a_bn - l_q.to_integer_32 * l_n
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_an * 13 < 16 * a_bn then
							l_p := 9
							l_q := 8
						elseif a_an * ((20).bit_shift_right (1)).to_integer_32 < 27 * ((a_bn).bit_shift_right (1)) then
							l_p := 9
							l_q := 7
						elseif a_an * 10 < 33 * ((a_bn).bit_shift_right (1)) then
							l_p := 10
							l_q := 7
						elseif a_an * 4 < 7 * a_bn then
							l_p := 10
							l_q := 6
						elseif a_an * 6 < 13 * a_bn then
							l_p := 11
							l_q := 6
						else
							l_p := 11
							l_q := 5
						end
						l_half := ((l_p + l_q)).bit_and (1)
						if l_q.to_integer_32 * a_an >= l_p.to_integer_32 * a_bn then
							l_tmp := (a_an - 1).to_natural_32 // (l_p.to_natural_32).to_natural_32
						else
							l_tmp := (a_bn - 1).to_natural_32 // (l_q.to_natural_32).to_natural_32
						end
						l_n := ({NATURAL_32} 1 + l_tmp).to_integer_32
						l_p := l_p - 1
						l_q := l_q - 1
						l_s := a_an - l_p.to_integer_32 * l_n
						l_t := a_bn - l_q.to_integer_32 * l_n
						if l_half.to_boolean then
							if l_s < 1 then
								l_p := l_p - 1
								l_s := l_s + l_n
								l_half := 0
							elseif l_t < 1 then
								l_q := l_q - 1
								l_t := l_t + l_n
								l_half := 0
							end
						end
				when 7 then -- if done
					l_tmp___1 := (create {P_TOOM_EVAL_PM2REXP_STATIC}).gmpn_toom_eval_pm2rexp ((a_pp + 13 * l_n) + 2, a_pp + 11 * l_n, l_p.to_natural_32, a_ap, l_n, l_s, {NATURAL_32} 3, a_pp)
					l_sign := (l_tmp___1).bit_xor (((create {P_TOOM_EVAL_PM2REXP_STATIC}).gmpn_toom_eval_pm2rexp ((a_scratch + 12 * l_n) + 4, (a_pp + 12 * l_n) + 1, l_q.to_natural_32, a_bp, l_n, l_t, {NATURAL_32} 3, a_pp)))
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n + 1 >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n + 1 >= 381 then
														gmpn_toom8h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n + 1 >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n + 1 >= 381 then
														gmpn_toom8h_mul (a_scratch, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_scratch, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_scratch, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_scratch, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_scratch, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_scratch, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_scratch, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_scratch, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_scratch, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
						end
						l_break := True
					end
					l_break := False;
					(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling (a_scratch, (2 * l_n + 1) + 1, a_pp, l_sign, l_n, 3 * (1 + l_half), 3 * l_half)
					l_tmp___3 := (create {P_TOOM_EVAL_PM2REXP_STATIC}).gmpn_toom_eval_pm2rexp ((a_pp + 13 * l_n) + 2, a_pp + 11 * l_n, l_p.to_natural_32, a_ap, l_n, l_s, {NATURAL_32} 2, a_pp)
					l_sign := (l_tmp___3).bit_xor (((create {P_TOOM_EVAL_PM2REXP_STATIC}).gmpn_toom_eval_pm2rexp ((a_scratch + 12 * l_n) + 4, (a_pp + 12 * l_n) + 1, l_q.to_natural_32, a_bp, l_n, l_t, {NATURAL_32} 2, a_pp)))
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n + 1 >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n + 1 >= 381 then
														gmpn_toom8h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n + 1 >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n + 1 >= 381 then
														gmpn_toom8h_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul ((a_scratch + 3 * l_n) + 1, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
						end
						l_break := True
					end
					l_break := False;
					(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling ((a_scratch + 3 * l_n) + 1, 2 * l_n + 1, a_pp, l_sign, l_n, 2 * (1 + l_half), 2 * l_half)
					l_tmp___5 := (create {P_TOOM_EVAL_PM2_STATIC}).gmpn_toom_eval_pm2 ((a_pp + 13 * l_n) + 2, a_pp + 11 * l_n, l_p.to_natural_32, a_ap, l_n, l_s, a_pp)
					l_sign := (l_tmp___5).bit_xor (((create {P_TOOM_EVAL_PM2_STATIC}).gmpn_toom_eval_pm2 ((a_scratch + 12 * l_n) + 4, (a_pp + 12 * l_n) + 1, l_q.to_natural_32, a_bp, l_n, l_t, a_pp)))
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n + 1 >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n + 1 >= 381 then
														gmpn_toom8h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n + 1 >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n + 1 >= 381 then
														gmpn_toom8h_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul ((a_scratch + 6 * l_n) + 2, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
						end
						l_break := True
					end
					l_break := False;
					(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling ((a_scratch + 6 * l_n) + 2, 2 * l_n + 1, a_pp, l_sign, l_n, 1, 2)
					l_tmp___7 := (create {P_TOOM_EVAL_PM2EXP_STATIC}).gmpn_toom_eval_pm2exp ((a_pp + 13 * l_n) + 2, a_pp + 11 * l_n, l_p.to_natural_32, a_ap, l_n, l_s, {NATURAL_32} 3, a_pp)
					l_sign := (l_tmp___7).bit_xor (((create {P_TOOM_EVAL_PM2EXP_STATIC}).gmpn_toom_eval_pm2exp ((a_scratch + 12 * l_n) + 4, (a_pp + 12 * l_n) + 1, l_q.to_natural_32, a_bp, l_n, l_t, {NATURAL_32} 3, a_pp)))
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n + 1 >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n + 1 >= 381 then
														gmpn_toom8h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n + 1 >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n + 1 >= 381 then
														gmpn_toom8h_mul ((a_scratch + 9 * l_n) + 3, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul ((a_scratch + 9 * l_n) + 3, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul ((a_scratch + 9 * l_n) + 3, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul ((a_scratch + 9 * l_n) + 3, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul ((a_scratch + 9 * l_n) + 3, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul ((a_scratch + 9 * l_n) + 3, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul ((a_scratch + 9 * l_n) + 3, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul ((a_scratch + 9 * l_n) + 3, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul ((a_scratch + 9 * l_n) + 3, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
						end
						l_break := True
					end
					l_break := False;
					(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling ((a_scratch + 9 * l_n) + 3, (2 * l_n + 1) + 1, a_pp, l_sign, l_n, 3, 6)
					l_tmp___9 := (create {P_TOOM_EVAL_PM2REXP_STATIC}).gmpn_toom_eval_pm2rexp ((a_pp + 13 * l_n) + 2, a_pp + 11 * l_n, l_p.to_natural_32, a_ap, l_n, l_s, {NATURAL_32} 1, a_pp)
					l_sign := (l_tmp___9).bit_xor (((create {P_TOOM_EVAL_PM2REXP_STATIC}).gmpn_toom_eval_pm2rexp ((a_scratch + 12 * l_n) + 4, (a_pp + 12 * l_n) + 1, l_q.to_natural_32, a_bp, l_n, l_t, {NATURAL_32} 1, a_pp)))
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n + 1 >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n + 1 >= 381 then
														gmpn_toom8h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n + 1 >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n + 1 >= 381 then
														gmpn_toom8h_mul (a_pp + 3 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp + 3 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp + 3 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp + 3 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp + 3 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp + 3 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp + 3 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp + 3 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp + 3 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
						end
						l_break := True
					end
					l_break := False;
					(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling (a_pp + 3 * l_n, 2 * l_n + 1, a_pp, l_sign, l_n, 1 + l_half, l_half)
					l_sign := (create {P_TOOM_EVAL_PM1_STATIC}).gmpn_toom_eval_pm1 ((a_pp + 13 * l_n) + 2, a_pp + 11 * l_n, l_p.to_natural_32, a_ap, l_n, l_s, a_pp)
					if l_q = 3 then
						l_sign := (l_sign).bit_xor (((create {P_TOOM_EVAL_DGR3_PM1_STATIC}).gmpn_toom_eval_dgr3_pm1 ((a_scratch + 12 * l_n) + 4, (a_pp + 12 * l_n) + 1, a_bp, l_n, l_t, a_pp)))
					else
						l_sign := (l_sign).bit_xor (((create {P_TOOM_EVAL_PM1_STATIC}).gmpn_toom_eval_pm1 ((a_scratch + 12 * l_n) + 4, (a_pp + 12 * l_n) + 1, l_q.to_natural_32, a_bp, l_n, l_t, a_pp)))
					end
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n + 1 >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n + 1 >= 381 then
														gmpn_toom8h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n + 1 >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n + 1 >= 381 then
														gmpn_toom8h_mul (a_pp + 7 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp + 7 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp + 7 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp + 7 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp + 7 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp + 7 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp + 7 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp + 7 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp + 7 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
						end
						l_break := True
					end
					l_break := False;
					(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling (a_pp + 7 * l_n, 2 * l_n + 1, a_pp, l_sign, l_n, 0, 0)
					l_tmp___13 := (create {P_TOOM_EVAL_PM2EXP_STATIC}).gmpn_toom_eval_pm2exp ((a_pp + 13 * l_n) + 2, a_pp + 11 * l_n, l_p.to_natural_32, a_ap, l_n, l_s, {NATURAL_32} 2, a_pp)
					l_sign := (l_tmp___13).bit_xor (((create {P_TOOM_EVAL_PM2EXP_STATIC}).gmpn_toom_eval_pm2exp ((a_scratch + 12 * l_n) + 4, (a_pp + 12 * l_n) + 1, l_q.to_natural_32, a_bp, l_n, l_t, {NATURAL_32} 2, a_pp)))
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n + 1 >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n + 1 >= 381 then
														gmpn_toom8h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, (a_pp + 11 * l_n), l_n + 1, ((a_pp + 12 * l_n) + 1), l_n + 1, (a_scratch + 13 * l_n) + 5)
						end
						l_break := True
					end
					l_break := False
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n + 1 >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n + 1 >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n + 1 >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n + 1 >= 381 then
														gmpn_toom8h_mul (a_pp + 11 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp + 11 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp + 11 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp + 11 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp + 11 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp + 11 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp + 11 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp + 11 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp + 11 * l_n, ((a_pp + 13 * l_n) + 2), l_n + 1, ((a_scratch + 12 * l_n) + 4), l_n + 1, (a_scratch + 13 * l_n) + 5)
						end
						l_break := True
					end
					l_break := False;
					(create {P_TOOM_COUPLE_HANDLING_STATIC}).gmpn_toom_couple_handling (a_pp + 11 * l_n, 2 * l_n + 1, a_pp, l_sign, l_n, 2, 4)
					from
					until
						(l_break)
					loop
						l_break := False
						if 77 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_n >= 77 then
								if 182 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
									if l_n >= 182 then
										if 252 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
											if l_n >= 252 then
												if 381 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
													if l_n >= 381 then
														gmpn_toom8h_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 12 * l_n) + 4)
													else
														(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 12 * l_n) + 4)
													end
												else
													(create {P_TOOM6H_MUL_STATIC}).gmpn_toom6h_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 12 * l_n) + 4)
												end
											else
												(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 12 * l_n) + 4)
											end
										else
											(create {P_TOOM44_MUL_STATIC}).gmpn_toom44_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 12 * l_n) + 4)
										end
									else
										(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 12 * l_n) + 4)
									end
								else
									(create {P_TOOM33_MUL_STATIC}).gmpn_toom33_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 12 * l_n) + 4)
								end
							else
								(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 12 * l_n) + 4)
							end
						else
							(create {P_TOOM22_MUL_STATIC}).gmpn_toom22_mul (a_pp, a_ap, l_n, a_bp, l_n, (a_scratch + 12 * l_n) + 4)
						end
						l_break := True
					end
					l_break := False
					if l_half /= 0 then
						if l_s > l_t then
							from
							until
								(l_break)
							loop
								l_break := False;
								(create {P_MUL_STATIC}).gmpn_mul (a_pp + 15 * l_n, a_ap + l_p.to_integer_32 * l_n, l_s, a_bp + l_q.to_integer_32 * l_n, l_t).do_nothing
								l_break := True
							end
							l_break := False
						else
							from
							until
								(l_break)
							loop
								l_break := False;
								(create {P_MUL_STATIC}).gmpn_mul (a_pp + 15 * l_n, a_bp + l_q.to_integer_32 * l_n, l_t, a_ap + l_p.to_integer_32 * l_n, l_s).do_nothing
								l_break := True
							end
							l_break := False
						end
					end
					(create {P_TOOM_INTERPOLATE_16PTS_STATIC}).gmpn_toom_interpolate_16pts (a_pp, (a_scratch + 9 * l_n) + 3, (a_scratch + 6 * l_n) + 2, (a_scratch + 3 * l_n) + 1, a_scratch, l_n, l_s + l_t, l_half, (a_scratch + 12 * l_n) + 4)
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
