class
	PD_GMP_RAND_LC_SCHEME_STRUCT

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_INTEGER_8_POINTER} astr.make
		end

feature {ANY} -- fields

	m2exp: NATURAL_32 assign set_m2exp

	astr: CE_POINTER [INTEGER_8] assign set_astr

	c: NATURAL_32 assign set_c

feature {ANY} -- field setters

	set_m2exp (a_m2exp: NATURAL_32)
		do
			m2exp := a_m2exp
			update_memory_field ("m2exp")
		end

	set_astr (a_astr: CE_POINTER [INTEGER_8])
		do
			astr := a_astr
			update_memory_field ("astr")
		end

	set_c (a_c: NATURAL_32)
		do
			c := a_c
			update_memory_field ("c")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			m2exp := a_other.m2exp
			astr := a_other.astr
			c := a_other.c
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				m2exp = a_other.m2exp and
				astr.is_equal (a_other.astr) and
				c = a_other.c
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("m2exp"),
					create {CE_STRUCTURE_FIELD}.make ("astr"),
					create {CE_STRUCTURE_FIELD}.make ("c")
				>>)
			init_structure_info
		end

end
