class
	PD_TMP_REENTRANT_T

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			create {CE_CLASS_POINTER [PD_TMP_REENTRANT_T]} next.make
		end

feature {ANY} -- fields

	next: CE_POINTER [PD_TMP_REENTRANT_T] assign set_next

	size: NATURAL_32 assign set_size

feature {ANY} -- field setters

	set_next (a_next: CE_POINTER [PD_TMP_REENTRANT_T])
		do
			next := a_next
			update_memory_field ("next")
		end

	set_size (a_size: NATURAL_32)
		do
			size := a_size
			update_memory_field ("size")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			next := a_other.next
			size := a_other.size
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				next.is_equal (a_other.next) and
				size = a_other.size
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("next"),
					create {CE_STRUCTURE_FIELD}.make ("size")
				>>)
			init_structure_info
		end

end
