class
	P_BERNOULLI_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_ran_bernoulli_pdf (a_k: NATURAL_32; a_p: REAL_64): REAL_64
		do
			if a_k = {NATURAL_32} 0 then
				Result := ((1).to_double - a_p)
			elseif a_k = {NATURAL_32} 1 then
				Result := a_p
			else
				Result := (0).to_double
			end
		end

end
