class
	P_CMRG_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	m1___2: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (2_147_483_647).to_integer_32
		end

	m2___2: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (2_145_483_479).to_integer_32
		end

	a2___2: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (63_308).to_integer_32
		end

	qa2: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (33_921).to_integer_32
		end

	ra2: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (12_979).to_integer_32
		end

	a32: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (-183_326).to_integer_32
		end

	qa3: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (11_714).to_integer_32
		end

	ra3: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (2_883).to_integer_32
		end

	b1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (86_098).to_integer_32
		end

	qb1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (24_919).to_integer_32
		end

	rb1: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (7_417).to_integer_32
		end

	b3___2: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (-539_608).to_integer_32
		end

	qb3: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (3_976).to_integer_32
		end

	rb3: CE_STATIC [INTEGER_32]
		once ("PROCESS")
			Result.item := (2_071).to_integer_32
		end

	cmrg_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("cmrg"), {NATURAL_32} 2_147_483_646, {NATURAL_32} 0, (create {PD_CMRG_STATE_T}.make).structure_size.to_natural_32, cmrg_set_address, cmrg_get_address, cmrg_get_double_address])
				>>)
		end

	gsl_rng_cmrg: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := cmrg_type.item
		end

feature {ANY} -- public routines

	cmrg_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_CMRG_STATE_T]
			l_h3: INTEGER_32
			l_p3: INTEGER_32
			l_h2: INTEGER_32
			l_p2: INTEGER_32
			l_h3___0: INTEGER_32
			l_p3___0: INTEGER_32
			l_h1: INTEGER_32
			l_p1: INTEGER_32
		do
			l_state := create {CE_CLASS_POINTER [PD_CMRG_STATE_T]}.make_cast (a_vstate)
			l_h3 := l_state.item.x3 // qa3.item
			l_p3 := (-a32.item * (l_state.item.x3 - l_h3 * qa3.item) - (l_h3 * ra3.item))
			l_h2 := l_state.item.x2 // qa2.item
			l_p2 := (a2___2.item * (l_state.item.x2 - l_h2 * qa2.item) - (l_h2 * ra2.item))
			if l_p3 < 0 then
				l_p3 := l_p3 + m1___2.item
			end
			if l_p2 < 0 then
				l_p2 := l_p2 + m1___2.item
			end
			l_state.item.x3 := l_state.item.x2
			l_state.item.x2 := l_state.item.x1
			l_state.item.x1 := l_p2 - l_p3
			if l_state.item.x1 < 0 then
				l_state.item.x1 := l_state.item.x1 + m1___2.item
			end
			l_h3___0 := l_state.item.y3 // qb3.item
			l_p3___0 := (-b3___2.item * (l_state.item.y3 - l_h3___0 * qb3.item) - (l_h3___0 * rb3.item))
			l_h1 := l_state.item.y1 // qb1.item
			l_p1 := (b1.item * (l_state.item.y1 - l_h1 * qb1.item) - (l_h1 * rb1.item))
			if l_p3___0 < 0 then
				l_p3___0 := l_p3___0 + m2___2.item
			end
			if l_p1 < 0 then
				l_p1 := l_p1 + m2___2.item
			end
			l_state.item.y3 := l_state.item.y2
			l_state.item.y2 := l_state.item.y1
			l_state.item.y1 := l_p1 - l_p3___0
			if l_state.item.y1 < 0 then
				l_state.item.y1 := l_state.item.y1 + m2___2.item
			end
			if l_state.item.x1 < l_state.item.y1 then
				Result := ((l_state.item.x1 - l_state.item.y1) + m1___2.item).to_natural_32
			else
				Result := (l_state.item.x1 - l_state.item.y1).to_natural_32
			end
		end

	cmrg_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((cmrg_get (a_vstate)).to_real_64 / 2147483647.0)
		end

	cmrg_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_CMRG_STATE_T]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_CMRG_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.x1 := (l_s \\ m1___2.item.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.x2 := (l_s \\ m1___2.item.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.x3 := (l_s \\ m1___2.item.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.y1 := (l_s \\ m2___2.item.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.y2 := (l_s \\ m2___2.item.to_natural_32).to_integer_32
			l_s := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.y3 := (l_s \\ m2___2.item.to_natural_32).to_integer_32
			cmrg_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			cmrg_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			cmrg_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			cmrg_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			cmrg_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			cmrg_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			cmrg_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
		end

feature {ANY} -- routine addresses

	cmrg_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent cmrg_get)
		end

	cmrg_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent cmrg_get_double)
		end

	cmrg_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent cmrg_set)
		end

end
