class
	P_CTBMV_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	cblas_ctbmv (a_order, a_Uplo, a_TransA, a_Diag: NATURAL_32; a_N, a_K: INTEGER_32; a_A___0: CE_POINTER [ANY]; a_lda: INTEGER_32; a_X: CE_POINTER [ANY]; a_incX: INTEGER_32)
		local
			l_conj: INTEGER_32
			l_tmp: INTEGER_32
			l_Trans: INTEGER_32
			l_tmp___0: NATURAL_32
			l_nonunit: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_ix: INTEGER_32
			l_tmp___1: INTEGER_32
			l_temp_r: REAL_32
			l_temp_i: REAL_32
			l_j_min: INTEGER_32
			l_j_max: INTEGER_32
			l_tmp___2: INTEGER_32
			l_jx: INTEGER_32
			l_tmp___3: INTEGER_32
			l_x_real: REAL_32
			l_x_imag: REAL_32
			l_A_real: REAL_32
			l_A_imag: REAL_32
			l_x_real___0: REAL_32
			l_x_imag___0: REAL_32
			l_A_real___0: REAL_32
			l_A_imag___0: REAL_32
			l_ix___0: INTEGER_32
			l_tmp___4: INTEGER_32
			l_temp_r___0: REAL_32
			l_temp_i___0: REAL_32
			l_j_min___0: INTEGER_32
			l_tmp___5: INTEGER_32
			l_j_max___0: INTEGER_32
			l_jx___0: INTEGER_32
			l_tmp___6: INTEGER_32
			l_x_real___1: REAL_32
			l_x_imag___1: REAL_32
			l_A_real___1: REAL_32
			l_A_imag___1: REAL_32
			l_x_real___2: REAL_32
			l_x_imag___2: REAL_32
			l_A_real___2: REAL_32
			l_A_imag___2: REAL_32
			l_tmp___7: INTEGER_32
			l_ix___1: INTEGER_32
			l_tmp___8: INTEGER_32
			l_temp_r___1: REAL_32
			l_temp_i___1: REAL_32
			l_j_min___1: INTEGER_32
			l_tmp___9: INTEGER_32
			l_j_max___1: INTEGER_32
			l_jx___1: INTEGER_32
			l_tmp___10: INTEGER_32
			l_x_real___3: REAL_32
			l_x_imag___3: REAL_32
			l_A_real___3: REAL_32
			l_A_imag___3: REAL_32
			l_x_real___4: REAL_32
			l_x_imag___4: REAL_32
			l_A_real___4: REAL_32
			l_A_imag___4: REAL_32
			l_tmp___11: INTEGER_32
			l_ix___2: INTEGER_32
			l_tmp___12: INTEGER_32
			l_temp_r___2: REAL_32
			l_temp_i___2: REAL_32
			l_j_min___2: INTEGER_32
			l_j_max___2: INTEGER_32
			l_tmp___13: INTEGER_32
			l_jx___2: INTEGER_32
			l_tmp___14: INTEGER_32
			l_x_real___5: REAL_32
			l_x_imag___5: REAL_32
			l_A_real___5: REAL_32
			l_A_imag___5: REAL_32
			l_x_real___6: REAL_32
			l_x_imag___6: REAL_32
			l_A_real___6: REAL_32
			l_A_imag___6: REAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_TransA = {NATURAL_32} 113 then
						l_tmp := -1
					else
						l_tmp := 1
					end
					l_conj := l_tmp
					if a_TransA /= {NATURAL_32} 113 then
						l_tmp___0 := a_TransA
					else
						l_tmp___0 := {NATURAL_32} 112
					end
					l_Trans := l_tmp___0.to_integer_32
					l_nonunit := (a_Diag = {NATURAL_32} 131).to_integer
					if a_order /= {NATURAL_32} 101 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 6 -- goto _L___12
							else
								l_pos := -1 + 3 -- goto _L___16
							end
						else
							l_pos := -1 + 3 -- goto _L___16
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 3 then -- else: | _L___16:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___12:
						if a_incX > 0 then
							l_tmp___1 := 0
						else
							l_tmp___1 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___1
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_temp_r := (0.0).truncated_to_real
							l_temp_i := (0.0).truncated_to_real
							l_j_min := l_i + 1
							if a_N < (l_i + a_K) + 1 then
								l_tmp___2 := a_N
							else
								l_tmp___2 := (l_i + a_K) + 1
							end
							l_j_max := l_tmp___2
							if a_incX > 0 then
								l_tmp___3 := 0
							else
								l_tmp___3 := (a_N - 1) * -a_incX
							end
							l_jx := l_tmp___3 + a_incX * l_j_min
							l_j := l_j_min
							from
							until
								not (l_j < l_j_max)
							loop
								l_x_real := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx]
								l_x_imag := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx + 1)]
								l_A_real := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + (l_j - l_i))]
								l_A_imag := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + (l_j - l_i)) + 1)])
								l_temp_r := l_temp_r + (l_A_real * l_x_real - l_A_imag * l_x_imag)
								l_temp_i := l_temp_i + (l_A_real * l_x_imag + l_A_imag * l_x_real)
								l_jx := l_jx + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								l_x_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix]
								l_x_imag___0 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)]
								l_A_real___0 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i)]
								l_A_imag___0 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i) + 1)])
								create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := l_temp_r + (l_A_real___0 * l_x_real___0 - l_A_imag___0 * l_x_imag___0)
								create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := l_temp_i + (l_A_real___0 * l_x_imag___0 + l_A_imag___0 * l_x_real___0)
							else
								create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix] + l_temp_r
								create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix + 1)] + l_temp_i
							end
							l_ix := l_ix + a_incX
							l_i := l_i + 1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 12 -- goto _L___14
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___14
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 12 then -- else: | _L___14:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 18 -- goto _L___7
							else
								l_pos := -1 + 15 -- goto _L___11
							end
						else
							l_pos := -1 + 15 -- goto _L___11
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 15 then -- else: | _L___11:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 24 -- skip if block
						end
				when 16 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 22 -- skip if block
						end
				when 17 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if: | _L___7:
						if a_incX > 0 then
							l_tmp___4 := 0
						else
							l_tmp___4 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___4 + (a_N - 1) * a_incX
						l_i := a_N
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___7 := l_i
								l_i := l_i - 1
								if not l_tmp___7.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_temp_r___0 := (0.0).truncated_to_real
								l_temp_i___0 := (0.0).truncated_to_real
								if a_K > l_i then
									l_tmp___5 := 0
								else
									l_tmp___5 := l_i - a_K
								end
								l_j_min___0 := l_tmp___5
								l_j_max___0 := l_i
								if a_incX > 0 then
									l_tmp___6 := 0
								else
									l_tmp___6 := (a_N - 1) * -a_incX
								end
								l_jx___0 := l_tmp___6 + l_j_min___0 * a_incX
								l_j := l_j_min___0
								from
								until
									not (l_j < l_j_max___0)
								loop
									l_x_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx___0]
									l_x_imag___1 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx___0 + 1)]
									l_A_real___1 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + ((a_K - l_i) + l_j))]
									l_A_imag___1 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + ((a_K - l_i) + l_j)) + 1)])
									l_temp_r___0 := l_temp_r___0 + (l_A_real___1 * l_x_real___1 - l_A_imag___1 * l_x_imag___1)
									l_temp_i___0 := l_temp_i___0 + (l_A_real___1 * l_x_imag___1 + l_A_imag___1 * l_x_real___1)
									l_jx___0 := l_jx___0 + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									l_x_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___0]
									l_x_imag___2 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)]
									l_A_real___2 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + a_K)]
									l_A_imag___2 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + a_K) + 1)])
									create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___0] := l_temp_r___0 + (l_A_real___2 * l_x_real___2 - l_A_imag___2 * l_x_imag___2)
									create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)] := l_temp_i___0 + (l_A_real___2 * l_x_imag___2 + l_A_imag___2 * l_x_real___2)
								else
									create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___0] := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___0] + l_temp_r___0
									create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___0 + 1)] + l_temp_i___0
								end
								l_ix___0 := l_ix___0 - a_incX
							end
						end
						l_break := False
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_pos := -1 + 24 -- goto _L___9
				when 21 then -- if done | if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 24 -- goto _L___9
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 24 then -- else: | _L___9:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 30 -- goto _L___2
							else
								l_pos := -1 + 27 -- goto _L___6
							end
						else
							l_pos := -1 + 27 -- goto _L___6
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 27 then -- else: | _L___6:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 36 -- skip if block
						end
				when 28 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 34 -- skip if block
						end
				when 29 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if: | _L___2:
						if a_incX > 0 then
							l_tmp___8 := 0
						else
							l_tmp___8 := (a_N - 1) * -a_incX
						end
						l_ix___1 := l_tmp___8 + (a_N - 1) * a_incX
						l_i := a_N
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							if l_i > 0 then
								l_tmp___11 := l_i
								l_i := l_i - 1
								if not l_tmp___11.to_boolean then
									l_break := True
								end
							else
								l_break := True
							end
							if not (l_return or l_break) then
								l_temp_r___1 := (0.0).truncated_to_real
								l_temp_i___1 := (0.0).truncated_to_real
								if a_K > l_i then
									l_tmp___9 := 0
								else
									l_tmp___9 := l_i - a_K
								end
								l_j_min___1 := l_tmp___9
								l_j_max___1 := l_i
								if a_incX > 0 then
									l_tmp___10 := 0
								else
									l_tmp___10 := (a_N - 1) * -a_incX
								end
								l_jx___1 := l_tmp___10 + l_j_min___1 * a_incX
								l_j := l_j_min___1
								from
								until
									not (l_j < l_j_max___1)
								loop
									l_x_real___3 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx___1]
									l_x_imag___3 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx___1 + 1)]
									l_A_real___3 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_j + (l_i - l_j))]
									l_A_imag___3 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_j + (l_i - l_j)) + 1)])
									l_temp_r___1 := l_temp_r___1 + (l_A_real___3 * l_x_real___3 - l_A_imag___3 * l_x_imag___3)
									l_temp_i___1 := l_temp_i___1 + (l_A_real___3 * l_x_imag___3 + l_A_imag___3 * l_x_real___3)
									l_jx___1 := l_jx___1 + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									l_x_real___4 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___1]
									l_x_imag___4 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)]
									l_A_real___4 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i)]
									l_A_imag___4 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i) + 1)])
									create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___1] := l_temp_r___1 + (l_A_real___4 * l_x_real___4 - l_A_imag___4 * l_x_imag___4)
									create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)] := l_temp_i___1 + (l_A_real___4 * l_x_imag___4 + l_A_imag___4 * l_x_real___4)
								else
									create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___1] := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___1] + l_temp_r___1
									create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___1 + 1)] + l_temp_i___1
								end
								l_ix___1 := l_ix___1 - a_incX
							end
						end
						l_break := False
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						l_pos := -1 + 36 -- goto _L___4
				when 33 then -- if done | if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_pos := -1 + 36 -- goto _L___4
				when 35 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 36 then -- else: | _L___4:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 42 -- goto _L
							else
								l_pos := -1 + 39 -- goto _L___1
							end
						else
							l_pos := -1 + 39 -- goto _L___1
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 39 then -- else: | _L___1:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 48 -- skip if block
						end
				when 40 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 46 -- skip if block
						end
				when 41 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___12 := 0
						else
							l_tmp___12 := (a_N - 1) * -a_incX
						end
						l_ix___2 := l_tmp___12
						l_i := 0
						from
						until
							not (not (l_return) and then (l_i < a_N))
						loop
							l_temp_r___2 := (0.0).truncated_to_real
							l_temp_i___2 := (0.0).truncated_to_real
							l_j_min___2 := l_i + 1
							if a_N < (l_i + a_K) + 1 then
								l_tmp___13 := a_N
							else
								l_tmp___13 := (l_i + a_K) + 1
							end
							l_j_max___2 := l_tmp___13
							if a_incX > 0 then
								l_tmp___14 := 0
							else
								l_tmp___14 := (a_N - 1) * -a_incX
							end
							l_jx___2 := l_tmp___14 + l_j_min___2 * a_incX
							l_j := l_j_min___2
							from
							until
								not (l_j < l_j_max___2)
							loop
								l_x_real___5 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_jx___2]
								l_x_imag___5 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_jx___2 + 1)]
								l_A_real___5 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_j + ((a_K - l_j) + l_i))]
								l_A_imag___5 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_j + ((a_K - l_j) + l_i)) + 1)])
								l_temp_r___2 := l_temp_r___2 + (l_A_real___5 * l_x_real___5 - l_A_imag___5 * l_x_imag___5)
								l_temp_i___2 := l_temp_i___2 + (l_A_real___5 * l_x_imag___5 + l_A_imag___5 * l_x_real___5)
								l_jx___2 := l_jx___2 + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								l_x_real___6 := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___2]
								l_x_imag___6 := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)]
								l_A_real___6 := create {CE_REAL_32_POINTER}.make_cast (a_A___0)[2 * (a_lda * l_i + a_K)]
								l_A_imag___6 := (l_conj.to_real * create {CE_REAL_32_POINTER}.make_cast (a_A___0)[(2 * (a_lda * l_i + a_K) + 1)])
								create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___2] := l_temp_r___2 + (l_A_real___6 * l_x_real___6 - l_A_imag___6 * l_x_imag___6)
								create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)] := l_temp_i___2 + (l_A_real___6 * l_x_imag___6 + l_A_imag___6 * l_x_real___6)
							else
								create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___2] := create {CE_REAL_32_POINTER}.make_cast (a_X)[2 * l_ix___2] + l_temp_r___2
								create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)] := create {CE_REAL_32_POINTER}.make_cast (a_X)[(2 * l_ix___2 + 1)] + l_temp_i___2
							end
							l_ix___2 := l_ix___2 + a_incX
							l_i := l_i + 1
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_tbmv_c.h"), ce_string ("unrecognized operation")])
				when 45 then -- if done | if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_tbmv_c.h"), ce_string ("unrecognized operation")])
				when 47 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 48 then -- else:;
						(create {P_XERBLA_STATIC}).cblas_xerbla ([0, ce_string ("source_tbmv_c.h"), ce_string ("unrecognized operation")])
				when 49 then -- if done | if done | if done | if done | if done | if done | if done
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
