class
	P_DERIV_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_poly_eval_derivs (a_c___1: CE_POINTER [REAL_64]; a_lenc: NATURAL_32; a_x: REAL_64; a_res: CE_POINTER [REAL_64]; a_lenres: NATURAL_32): INTEGER_32
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_nmax: NATURAL_32
			l_k: NATURAL_32
			l_l: NATURAL_32
			l_lmax: NATURAL_32
			l_f: REAL_64
			l_return: BOOLEAN
		do
			l_i := (0).to_natural_32
			l_n := (0).to_natural_32
			l_nmax := (0).to_natural_32
			from
			until
				not (l_i < a_lenres)
			loop
				if l_n < a_lenc then
					a_res[l_i.to_integer_32] := a_c___1[(a_lenc - {NATURAL_32} 1).to_integer_32]
					l_nmax := l_n
					l_n := l_n + 1
				else
					a_res[l_i.to_integer_32] := 0.0
				end
				l_i := l_i + 1
			end
			l_i := (0).to_natural_32
			from
			until
				not (not (l_return) and then (l_i < a_lenc - {NATURAL_32} 1))
			loop
				l_k := (a_lenc - {NATURAL_32} 1) - l_i
				a_res[0] := a_x * a_res[0] + a_c___1[(l_k - {NATURAL_32} 1).to_integer_32]
				if l_nmax < l_k then
					l_lmax := l_nmax
				else
					l_lmax := l_k - {NATURAL_32} 1
				end
				l_l := (1).to_natural_32
				from
				until
					not (l_l <= l_lmax)
				loop
					a_res[l_l.to_integer_32] := a_x * a_res[l_l.to_integer_32] + a_res[(l_l - {NATURAL_32} 1).to_integer_32]
					l_l := l_l + 1
				end
				l_i := l_i + 1
			end
			l_f := 1.0
			l_i := (2).to_natural_32
			from
			until
				not (l_i <= l_nmax)
			loop
				l_f := l_f * l_i.to_real_64
				a_res[l_i.to_integer_32] := a_res[l_i.to_integer_32] * l_f
				l_i := l_i + 1
			end
			Result := 0
		end

end
