class
	P_ERLANG_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC

feature {ANY} -- public routines

	gsl_ran_erlang_pdf (a_x, a_a___5, a_n: REAL_64): REAL_64
		local
			l_p: REAL_64
			l_lngamma: REAL_64
		do
			if a_x <= (0).to_double then
				Result := (0).to_double
			else
				l_lngamma := ((create {P_GAMMA_STATIC}).gsl_sf_lngamma (a_n))
				l_p := (exp (((a_n - (1).to_double) * (log (a_x / a_a___5)) - a_x / a_a___5) - l_lngamma)) / a_a___5
				Result := l_p
			end
		end

end
