class
	P_FLATINV_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	gsl_cdf_flat_Pinv (a_P___2, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_return: BOOLEAN
		do
			if a_P___2 = 1.0 then
				Result := a_b___0
				l_return := True
			elseif a_P___2 = 0.0 then
				Result := a_a___5
				l_return := True
			end
			if not l_return then
				l_x := ((1).to_double - a_P___2) * a_a___5 + a_P___2 * a_b___0
				Result := l_x
			end
		end

	gsl_cdf_flat_Qinv (a_Q___1, a_a___5, a_b___0: REAL_64): REAL_64
		local
			l_x: REAL_64
			l_return: BOOLEAN
		do
			if a_Q___1 = 0.0 then
				Result := a_b___0
				l_return := True
			elseif a_Q___1 = 1.0 then
				Result := a_a___5
				l_return := True
			end
			if not l_return then
				l_x := a_Q___1 * a_a___5 + ((1).to_double - a_Q___1) * a_b___0
				Result := l_x
			end
		end

end
