class
	P_PSI_STATIC

inherit
	CE_UTILITIES
	S_MATH_STATIC
	S_GCC_BUILTIN_STATIC

feature {ANY} -- public attributes

	psics_data: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					-.038057080835217922, .491415393029387130, -.056815747821244730, .008357821225914313, -.001333232857994342,
					.000220313287069308, -.000037040238178456, .000006283793654854, -.000001071263908506, .000000183128394654,
					-.000000031353509361, .000000005372808776, -.000000000921168141, .000000000157981265, -.000000000027098646,
					.000000000004648722, -.000000000000797527, .000000000000136827, -.000000000000023475, .000000000000004027,
					-.000000000000000691, .000000000000000118, -.000000000000000020
				>>)
		end

	psi_cs: CE_STATIC [CE_ARRAY [PD_CHEB_SERIES_STRUCT]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CHEB_SERIES_STRUCT]}.make_initialized (<<
					create {PD_CHEB_SERIES_STRUCT}.make_initialized ([psics_data.item, 22, (-1).to_double, (1).to_double, 17])
				>>)
		end

	apsics_data: CE_STATIC [CE_ARRAY [REAL_64]]
		once ("PROCESS")
			Result.item := create {CE_REAL_64_ARRAY}.make_initialized (<<
					-.0204749044678185, -.0101801271534859, .0000559718725387, -.0000012917176570, .0000000572858606,
					-.0000000038213539, .0000000003397434, -.0000000000374838, .0000000000048990, -.0000000000007344,
					.0000000000001233, -.0000000000000228, .0000000000000045, -.0000000000000009, .0000000000000002,
					-.0000000000000000
				>>)
		end

	apsi_cs: CE_STATIC [CE_ARRAY [PD_CHEB_SERIES_STRUCT]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_CHEB_SERIES_STRUCT]}.make_initialized (<<
					create {PD_CHEB_SERIES_STRUCT}.make_initialized ([apsics_data.item, 15, (-1).to_double, (1).to_double, 9])
				>>)
		end

feature {ANY} -- public routines

	psi_x (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		require
			not a_result.is_void
		local
			l_y: REAL_64
			l_t: REAL_64
			l_result_c: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_s: REAL_64
			l_c___1: REAL_64
			l_result_c___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_v: REAL_64
			l_t1: REAL_64
			l_t2: REAL_64
			l_t3: REAL_64
			l_tmp___12: REAL_64
			l_tmp___13: REAL_64
			l_v___0: REAL_64
			l_t1___0: REAL_64
			l_t2___0: REAL_64
			l_tmp___16: REAL_64
			l_t1___1: REAL_64
			l_v___1: REAL_64
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result_c.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result_c___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_y := (fabs (a_x))
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if a_x /= -1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if a_x /= -2.0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("domain error"), ce_string ("psi.c"), 385, 1)
								Result := 1
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if l_y >= 2.0 then
							l_t := 8.0 / (l_y * l_y) - 1.0
							apsi_cs.item.item.cheb_eval_e (l_t, l_result_c).do_nothing
							if a_x < 0.0 then
								l_s := (sin (3.14159265358979323846 * a_x))
								l_c___1 := (cos (3.14159265358979323846 * a_x))
								if (fabs (l_s)) < 2.0 * 1.4916681462400413e-154 then
									from
									until
										(l_return or l_break)
									loop
										l_break := False
										a_result.item.val := (builtin_nanf (ce_string (""))).to_double
										a_result.item.err := (builtin_nanf (ce_string (""))).to_double
										from
										until
											(l_return or l_break)
										loop
											l_break := False;
											(create {P_ERROR_STATIC}).gsl_error (ce_string ("domain error"), ce_string ("psi.c"), 395, 1)
											Result := 1
											l_return := True
											if not l_return then
												l_break := True
											end
										end
										if not l_return then
											l_break := False
											l_break := True
										end
									end
									if not l_return then
										l_break := False
									end
								else
									a_result.item.val := (((log (l_y)) - 0.5 / a_x) + l_result_c.item.val) - (3.14159265358979323846 * l_c___1) / l_s
									a_result.item.err := ((3.14159265358979323846 * (fabs (a_x))) * 2.2204460492503131e-16) / (l_s * l_s)
									a_result.item.err := a_result.item.err + (l_result_c.item.err)
									a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
									Result := 0
									l_return := True
								end
							else
								a_result.item.val := ((log (l_y)) - 0.5 / a_x) + l_result_c.item.val
								a_result.item.err := l_result_c.item.err
								a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
								Result := 0
								l_return := True
							end
						elseif a_x < -1.0 then
							l_v := a_x + 2.0
							l_t1 := 1.0 / a_x
							l_t2 := 1.0 / (a_x + 1.0)
							l_t3 := 1.0 / l_v
							psi_cs.item.item.cheb_eval_e (2.0 * l_v - 1.0, l_result_c___0).do_nothing
							a_result.item.val := -((l_t1 + l_t2) + l_t3) + l_result_c___0.item.val
							l_tmp___12 := fabs (l_t1)
							l_tmp___13 := fabs (a_x / (l_t2 * l_t2))
							a_result.item.err := 2.2204460492503131e-16 * ((l_tmp___12 + l_tmp___13) + (fabs (a_x / (l_t3 * l_t3))))
							a_result.item.err := a_result.item.err + (l_result_c___0.item.err)
							a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
							Result := 0
							l_return := True
						elseif a_x < 0.0 then
							l_v___0 := a_x + 1.0
							l_t1___0 := 1.0 / a_x
							l_t2___0 := 1.0 / l_v___0
							psi_cs.item.item.cheb_eval_e (2.0 * l_v___0 - 1.0, l_result_c___0).do_nothing
							a_result.item.val := -(l_t1___0 + l_t2___0) + l_result_c___0.item.val
							l_tmp___16 := fabs (l_t1___0)
							a_result.item.err := 2.2204460492503131e-16 * (l_tmp___16 + (fabs (a_x / (l_t2___0 * l_t2___0))))
							a_result.item.err := a_result.item.err + (l_result_c___0.item.err)
							a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
							Result := 0
							l_return := True
						elseif a_x < 1.0 then
							l_t1___1 := 1.0 / a_x
							psi_cs.item.item.cheb_eval_e (2.0 * a_x - 1.0, l_result_c___0).do_nothing
							a_result.item.val := -l_t1___1 + l_result_c___0.item.val
							a_result.item.err := 2.2204460492503131e-16 * l_t1___1
							a_result.item.err := a_result.item.err + (l_result_c___0.item.err)
							a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
							Result := 0
							l_return := True
						else
							l_v___1 := a_x - 1.0
							Result := (psi_cs.item.item.cheb_eval_e (2.0 * l_v___1 - 1.0, a_result))
							l_return := True
						end
				when 10 then -- if done | if done
					if not l_return then
						Result := 0
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	psi_n_xg0 (a_n: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ln_nf: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_hzeta: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_hz: INTEGER_32
			l_stat_nf: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_tmp___5: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_ln_nf.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_hzeta.make (<<1>>)

			if a_n = 0 then
				Result := (gsl_sf_psi_e (a_x, a_result))
			else
				l_stat_hz := (l_hzeta.item.gsl_sf_hzeta_e (a_n.to_double + 1.0, a_x))
				l_stat_nf := (l_ln_nf.item.gsl_sf_lnfact_e (a_n.to_natural_32))
				l_stat_e := (a_result.item.gsl_sf_exp_mult_err_e (l_ln_nf.item.val, l_ln_nf.item.err, l_hzeta.item.val, l_hzeta.item.err))
				if not ((a_n).bit_and (1)).to_boolean then
					a_result.item.val := -a_result.item.val
				end
				if l_stat_e /= 0 then
					l_tmp___5 := l_stat_e
				else
					if l_stat_nf /= 0 then
						l_tmp___4 := l_stat_nf
					else
						if l_stat_hz /= 0 then
							l_tmp___3 := l_stat_hz
						else
							l_tmp___3 := 0
						end
						l_tmp___4 := l_tmp___3
					end
					l_tmp___5 := l_tmp___4
				end
				Result := l_tmp___5
			end
		end

	gsl_sf_psi_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		require
			not a_result.is_void
		do
			Result := (psi_x (a_x, a_result))
		end

	gsl_sf_psi_1_e (a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_M: INTEGER_32
			l_fx: REAL_64
			l_sum: REAL_64
			l_m___4: INTEGER_32
			l_stat_psi: INTEGER_32
			l_sin_px: REAL_64
			l_d: REAL_64
			l_r___3: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_psi___0: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_r___3.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_x /= 0.0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 3 then -- else:
						if a_x /= -1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 6 then -- else:
						if a_x /= -2.0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("domain error"), ce_string ("psi.c"), 727, 1)
								Result := 1
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if a_x > 0.0 then
							Result := (psi_n_xg0 (1, a_x, a_result))
							l_return := True
						elseif a_x > -5.0 then
							l_M := (-(floor (a_x))).truncated_to_integer
							l_fx := a_x + l_M.to_double
							l_sum := 0.0
							if l_fx = 0.0 then
								from
								until
									(l_return or l_break)
								loop
									l_break := False
									a_result.item.val := (builtin_nanf (ce_string (""))).to_double
									a_result.item.err := (builtin_nanf (ce_string (""))).to_double
									from
									until
										(l_return or l_break)
									loop
										l_break := False;
										(create {P_ERROR_STATIC}).gsl_error (ce_string ("domain error"), ce_string ("psi.c"), 742, 1)
										Result := 1
										l_return := True
										if not l_return then
											l_break := True
										end
									end
									if not l_return then
										l_break := False
										l_break := True
									end
								end
								if not l_return then
									l_break := False
								end
							end
							if not l_return then
								l_m___4 := 0
								from
								until
									not (l_m___4 < l_M)
								loop
									l_sum := l_sum + (1.0 / ((a_x + l_m___4.to_double) * (a_x + l_m___4.to_double)))
									l_m___4 := l_m___4 + 1
								end
								l_stat_psi := (psi_n_xg0 (1, l_fx, a_result))
								a_result.item.val := a_result.item.val + l_sum
								a_result.item.err := a_result.item.err + ((l_M.to_double * 2.2204460492503131e-16) * l_sum)
								Result := l_stat_psi
								l_return := True
							end
						else
							l_sin_px := (sin (3.14159265358979323846 * a_x))
							l_d := (3.14159265358979323846 * 3.14159265358979323846) / (l_sin_px * l_sin_px)
							l_stat_psi___0 := (psi_n_xg0 (1, 1.0 - a_x, l_r___3))
							a_result.item.val := l_d - l_r___3.item.val
							a_result.item.err := l_r___3.item.err + (2.0 * 2.2204460492503131e-16) * l_d
							Result := l_stat_psi___0
							l_return := True
						end
				when 10 then -- if done | if done
					if not l_return then
						Result := 0
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_psi_n_e (a_n: INTEGER_32; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ln_nf: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_hzeta: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_hz: INTEGER_32
			l_stat_nf: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_ln_nf.make (<<1>>)
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_hzeta.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_n /= 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						Result := (gsl_sf_psi_e (a_x, a_result))
						l_return := True
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 3 then -- else:
						if a_n /= 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						Result := (gsl_sf_psi_1_e (a_x, a_result))
						l_return := True
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 6 then -- else:
						if not (a_n < 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						l_pos := -1 + 10 -- goto _L
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if not (a_x <= 0.0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if: | _L:
						from
						until
							(l_return or l_break)
						loop
							l_break := False
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								(l_return or l_break)
							loop
								l_break := False;
								(create {P_ERROR_STATIC}).gsl_error (ce_string ("domain error"), ce_string ("psi.c"), 781, 1)
								Result := 1
								l_return := True
								if not l_return then
									l_break := True
								end
							end
							if not l_return then
								l_break := False
								l_break := True
							end
						end
						if not l_return then
							l_break := False
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						l_stat_hz := (l_hzeta.item.gsl_sf_hzeta_e (a_n.to_double + 1.0, a_x))
						l_stat_nf := (l_ln_nf.item.gsl_sf_lnfact_e (a_n.to_natural_32))
						l_stat_e := (a_result.item.gsl_sf_exp_mult_err_e (l_ln_nf.item.val, l_ln_nf.item.err, l_hzeta.item.val, l_hzeta.item.err))
						if not ((a_n).bit_and (1)).to_boolean then
							a_result.item.val := -a_result.item.val
						end
						if l_stat_e /= 0 then
							l_tmp___8 := l_stat_e
						else
							if l_stat_nf /= 0 then
								l_tmp___7 := l_stat_nf
							else
								if l_stat_hz /= 0 then
									l_tmp___6 := l_stat_hz
								else
									l_tmp___6 := 0
								end
								l_tmp___7 := l_tmp___6
							end
							l_tmp___8 := l_tmp___7
						end
						Result := l_tmp___8
						l_return := True
				when 13 then -- if done | if done | if done
					if not l_return then
						Result := 0
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gsl_sf_psi_int (a_n: INTEGER_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_psi_int_e (a_n))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_psi_int_e(n, &result)"), ce_string ("psi.c"), 840, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_psi (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (gsl_sf_psi_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_psi_e(x, &result)"), ce_string ("psi.c"), 845, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_psi_1piy (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_psi_1piy_e (a_x))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_psi_1piy_e(x, &result)"), ce_string ("psi.c"), 850, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_psi_1_int (a_n: INTEGER_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (l_result.item.gsl_sf_psi_1_int_e (a_n))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_psi_1_int_e(n, &result)"), ce_string ("psi.c"), 855, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_psi_1 (a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (gsl_sf_psi_1_e (a_x, l_result))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_psi_1_e(x, &result)"), ce_string ("psi.c"), 860, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_psi_n (a_n: INTEGER_32; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			l_return, l_break: BOOLEAN
		do
			create {CE_CLASS_ARRAY [PD_GSL_SF_RESULT_STRUCT]} l_result.make (<<1>>)

			l_status := (gsl_sf_psi_n_e (a_n, a_x, l_result))
			if l_status /= 0 then
				from
				until
					(l_return or l_break)
				loop
					l_break := False;
					(create {P_ERROR_STATIC}).gsl_error (ce_string ("gsl_sf_psi_n_e(n, x, &result)"), ce_string ("psi.c"), 865, l_status)
					Result := (l_result.item.val)
					l_return := True
					if not l_return then
						l_break := True
					end
				end
				if not l_return then
					l_break := False
				end
			end
			if not l_return then
				Result := (l_result.item.val)
			end
		end

end
