class
	P_TAUS_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public attributes

	taus_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("taus"), {NATURAL_32} 4_294_967_295, {NATURAL_32} 0, (create {PD_TAUS_STATE_T}.make).structure_size.to_natural_32, taus_set_address, taus_get_address, taus_get_double_address])
				>>)
		end

	gsl_rng_taus: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := taus_type.item
		end

	taus2_type: CE_STATIC [CE_ARRAY [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := create {CE_CLASS_ARRAY [PD_GSL_RNG_TYPE]}.make_initialized (<<
					create {PD_GSL_RNG_TYPE}.make_initialized ([ce_string ("taus2"), {NATURAL_32} 4_294_967_295, {NATURAL_32} 0, (create {PD_TAUS_STATE_T}.make).structure_size.to_natural_32, taus2_set_address, taus_get_address, taus_get_double_address])
				>>)
		end

	gsl_rng_taus2: CE_STATIC [CE_POINTER [PD_GSL_RNG_TYPE]]
		once ("PROCESS")
			Result.item := taus2_type.item
		end

feature {ANY} -- public routines

	taus_get (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_TAUS_STATE_T]
		do
			l_state := create {CE_CLASS_POINTER [PD_TAUS_STATE_T]}.make_cast (a_vstate)
			l_state.item.s1 := (((((((l_state.item.s1).bit_and ({NATURAL_32} 4_294_967_294))).bit_shift_left (12))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (((((((((l_state.item.s1).bit_shift_left (13))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (l_state.item.s1))).bit_shift_right (19)))
			l_state.item.s2 := (((((((l_state.item.s2).bit_and ({NATURAL_32} 4_294_967_288))).bit_shift_left (4))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (((((((((l_state.item.s2).bit_shift_left (2))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (l_state.item.s2))).bit_shift_right (25)))
			l_state.item.s3 := (((((((l_state.item.s3).bit_and ({NATURAL_32} 4_294_967_280))).bit_shift_left (17))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (((((((((l_state.item.s3).bit_shift_left (3))).bit_and ({NATURAL_32} 4_294_967_295))).bit_xor (l_state.item.s3))).bit_shift_right (11)))
			Result := ((((l_state.item.s1).bit_xor (l_state.item.s2))).bit_xor (l_state.item.s3))
		end

	taus_get_double (a_vstate: CE_POINTER [ANY]): REAL_64
		do
			Result := ((taus_get (a_vstate)).to_real_64 / 4294967296.0)
		end

	taus_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_TAUS_STATE_T]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_TAUS_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.s1 := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.s2 := ({NATURAL_32} 69_069 * l_state.item.s1).bit_and ({NATURAL_32} 4_294_967_295)
			l_state.item.s3 := ({NATURAL_32} 69_069 * l_state.item.s2).bit_and ({NATURAL_32} 4_294_967_295)
			taus_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
		end

	taus2_set (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_TAUS_STATE_T]
		do
			l_s := a_s
			l_state := create {CE_CLASS_POINTER [PD_TAUS_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.s1 := ({NATURAL_32} 69_069 * l_s).bit_and ({NATURAL_32} 4_294_967_295)
			if l_state.item.s1 < {NATURAL_32} 2 then
				l_state.item.s1 := l_state.item.s1 + ({NATURAL_32} 2)
			end
			l_state.item.s2 := ({NATURAL_32} 69_069 * l_state.item.s1).bit_and ({NATURAL_32} 4_294_967_295)
			if l_state.item.s2 < {NATURAL_32} 8 then
				l_state.item.s2 := l_state.item.s2 + ({NATURAL_32} 8)
			end
			l_state.item.s3 := ({NATURAL_32} 69_069 * l_state.item.s2).bit_and ({NATURAL_32} 4_294_967_295)
			if l_state.item.s3 < {NATURAL_32} 16 then
				l_state.item.s3 := l_state.item.s3 + ({NATURAL_32} 16)
			end
			taus_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
			taus_get (create {CE_VOID_POINTER}.make_cast (l_state)).do_nothing
		end

feature {ANY} -- routine addresses

	taus_get_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent taus_get)
		end

	taus_get_double_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent taus_get_double)
		end

	taus_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent taus_set)
		end

	taus2_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent taus2_set)
		end

end
