class
	P_TYPES_STATIC

inherit
	CE_UTILITIES
	S_STDLIB_STATIC

feature {ANY} -- public attributes

	gsl_rng_generator_types: CE_STATIC [CE_ARRAY [CE_POINTER [PD_GSL_RNG_TYPE]]]
		once ("PROCESS")
			Result.item := create {CE_POINTER_ARRAY [PD_GSL_RNG_TYPE]}.make (<<100>>)
		end

feature {ANY} -- public routines

	gsl_rng_types_setup: CE_POINTER [CE_POINTER [PD_GSL_RNG_TYPE]]
		local
			l_i: INTEGER_32
		do
			l_i := 0
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_BOROSH13_STATIC}).gsl_rng_borosh13.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_CMRG_STATIC}).gsl_rng_cmrg.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_COVEYOU_STATIC}).gsl_rng_coveyou.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_FISHMAN18_STATIC}).gsl_rng_fishman18.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_FISHMAN20_STATIC}).gsl_rng_fishman20.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_FISHMAN2X_STATIC}).gsl_rng_fishman2x.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_GFSR4_STATIC}).gsl_rng_gfsr4.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_KNUTHRAN_STATIC}).gsl_rng_knuthran.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_KNUTHRAN2_STATIC}).gsl_rng_knuthran2.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_KNUTHRAN2002_STATIC}).gsl_rng_knuthran2002.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_LECUYER21_STATIC}).gsl_rng_lecuyer21.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_MINSTD_STATIC}).gsl_rng_minstd.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_MRG_STATIC}).gsl_rng_mrg.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_MT_STATIC}).gsl_rng_mt19937.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_MT_STATIC}).gsl_rng_mt19937_1999.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_MT_STATIC}).gsl_rng_mt19937_1998.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_R250_STATIC}).gsl_rng_r250.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RAN0_STATIC}).gsl_rng_ran0.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RAN1_STATIC}).gsl_rng_ran1.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RAN2_STATIC}).gsl_rng_ran2.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RAN3_STATIC}).gsl_rng_ran3.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RAND_STATIC}).gsl_rng_rand.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RAND48_STATIC}).gsl_rng_rand48.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random128_bsd.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random128_glibc2.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random128_libc5.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random256_bsd.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random256_glibc2.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random256_libc5.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random32_bsd.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random32_glibc2.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random32_libc5.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random64_bsd.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random64_glibc2.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random64_libc5.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random8_bsd.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random8_glibc2.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random8_libc5.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random_bsd.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random_glibc2.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDOM_STATIC}).gsl_rng_random_libc5.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANDU_STATIC}).gsl_rng_randu.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANF_STATIC}).gsl_rng_ranf.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANLUX_STATIC}).gsl_rng_ranlux.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANLUX_STATIC}).gsl_rng_ranlux389.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANLXD_STATIC}).gsl_rng_ranlxd1.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANLXD_STATIC}).gsl_rng_ranlxd2.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANLXS_STATIC}).gsl_rng_ranlxs0.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANLXS_STATIC}).gsl_rng_ranlxs1.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANLXS_STATIC}).gsl_rng_ranlxs2.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_RANMAR_STATIC}).gsl_rng_ranmar.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_SLATEC_STATIC}).gsl_rng_slatec.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_TAUS_STATIC}).gsl_rng_taus.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_TAUS_STATIC}).gsl_rng_taus2.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_TAUS113_STATIC}).gsl_rng_taus113.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_TRANSPUTER_STATIC}).gsl_rng_transputer.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_TT_STATIC}).gsl_rng_tt800.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_UNI_STATIC}).gsl_rng_uni.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_UNI32_STATIC}).gsl_rng_uni32.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_VAX_STATIC}).gsl_rng_vax.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_WATERMAN14_STATIC}).gsl_rng_waterman14.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := (create {P_ZUF_STATIC}).gsl_rng_zuf.item
			l_i := l_i + 1
			if l_i = 100 then
				abort
			end
			gsl_rng_generator_types.item[l_i] := create {CE_CLASS_POINTER [PD_GSL_RNG_TYPE]}.make_shared (default_pointer)
			l_i := l_i + 1
			Result := gsl_rng_generator_types.item
		end

end
