class
	PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- routine addresses

	newton_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_FDF: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x, a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_FDF.item.newton_set (a_vstate, a_x, a_f, a_J, a_dx)
				end)
		end

	newton_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x, a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_fdf.item.newton_iterate (a_vstate, a_x, a_f, a_J, a_dx)
				end)
		end

	gnewton_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_FDF: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x, a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_FDF.item.gnewton_set (a_vstate, a_x, a_f, a_J, a_dx)
				end)
		end

	gnewton_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x, a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_fdf.item.gnewton_iterate (a_vstate, a_x, a_f, a_J, a_dx)
				end)
		end

	hybridj_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x, a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_fdf.item.hybridj_set (a_vstate, a_x, a_f, a_J, a_dx)
				end)
		end

	hybridsj_set_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x, a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_fdf.item.hybridsj_set (a_vstate, a_x, a_f, a_J, a_dx)
				end)
		end

	hybridj_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x, a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_fdf.item.hybridj_iterate (a_vstate, a_x, a_f, a_J, a_dx)
				end)
		end

	hybridsj_iterate_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent (a_vstate: CE_POINTER [ANY]; a_fdf: CE_POINTER [PD_GSL_MULTIROOT_FUNCTION_FDF_STRUCT]; a_x, a_f: CE_POINTER [PD_GSL_VECTOR]; a_J: CE_POINTER [PD_GSL_MATRIX]; a_dx: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
				do
					Result := a_fdf.item.hybridsj_iterate (a_vstate, a_x, a_f, a_J, a_dx)
				end)
		end

end
